# API Reference <a name="API Reference"></a>

## Constructs <a name="Constructs"></a>

### AntiddosV1 <a name="@cdktf/provider-opentelekomcloud.AntiddosV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1 opentelekomcloud_antiddos_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.Initializer"></a>

```typescript
import { AntiddosV1 } from '@cdktf/provider-opentelekomcloud'

new AntiddosV1(scope: Construct, id: string, config: AntiddosV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AntiddosV1Config`](#@cdktf/provider-opentelekomcloud.AntiddosV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.putTimeouts"></a>

```typescript
public putTimeouts(value: AntiddosV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts`](#@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.timeouts"></a>

```typescript
public readonly timeouts: AntiddosV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference)

---

##### `appTypeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.appTypeIdInput"></a>

```typescript
public readonly appTypeIdInput: number;
```

- *Type:* `number`

---

##### `cleaningAccessPosIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.cleaningAccessPosIdInput"></a>

```typescript
public readonly cleaningAccessPosIdInput: number;
```

- *Type:* `number`

---

##### `enableL7Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.enableL7Input"></a>

```typescript
public readonly enableL7Input: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `floatingIpIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.floatingIpIdInput"></a>

```typescript
public readonly floatingIpIdInput: string;
```

- *Type:* `string`

---

##### `httpRequestPosIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.httpRequestPosIdInput"></a>

```typescript
public readonly httpRequestPosIdInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AntiddosV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts`](#@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts)

---

##### `trafficPosIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.trafficPosIdInput"></a>

```typescript
public readonly trafficPosIdInput: number;
```

- *Type:* `number`

---

##### `appTypeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.appTypeId"></a>

```typescript
public readonly appTypeId: number;
```

- *Type:* `number`

---

##### `cleaningAccessPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.cleaningAccessPosId"></a>

```typescript
public readonly cleaningAccessPosId: number;
```

- *Type:* `number`

---

##### `enableL7`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.enableL7"></a>

```typescript
public readonly enableL7: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

---

##### `httpRequestPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.httpRequestPosId"></a>

```typescript
public readonly httpRequestPosId: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `trafficPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.trafficPosId"></a>

```typescript
public readonly trafficPosId: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1.property.tfResourceType"></a>

- *Type:* `string`

---

### AsConfigurationV1 <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1 opentelekomcloud_as_configuration_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.Initializer"></a>

```typescript
import { AsConfigurationV1 } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1(scope: Construct, id: string, config: AsConfigurationV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1Config`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1Config)

---

#### Methods <a name="Methods"></a>

##### `putInstanceConfig` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.putInstanceConfig"></a>

```typescript
public putInstanceConfig(value: AsConfigurationV1InstanceConfig)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `instanceConfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.instanceConfig"></a>

```typescript
public readonly instanceConfig: AsConfigurationV1InstanceConfigOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceConfigInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.instanceConfigInput"></a>

```typescript
public readonly instanceConfigInput: AsConfigurationV1InstanceConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `scalingConfigurationNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.scalingConfigurationNameInput"></a>

```typescript
public readonly scalingConfigurationNameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `scalingConfigurationName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.scalingConfigurationName"></a>

```typescript
public readonly scalingConfigurationName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1.property.tfResourceType"></a>

- *Type:* `string`

---

### AsGroupV1 <a name="@cdktf/provider-opentelekomcloud.AsGroupV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1 opentelekomcloud_as_group_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.Initializer"></a>

```typescript
import { AsGroupV1 } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1(scope: Construct, id: string, config: AsGroupV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1Config`](#@cdktf/provider-opentelekomcloud.AsGroupV1Config)

---

#### Methods <a name="Methods"></a>

##### `putLbaasListeners` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.putLbaasListeners"></a>

```typescript
public putLbaasListeners(value: IResolvable | AsGroupV1LbaasListeners[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners)[]

---

##### `putNetworks` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.putNetworks"></a>

```typescript
public putNetworks(value: IResolvable | AsGroupV1Networks[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Networks`](#@cdktf/provider-opentelekomcloud.AsGroupV1Networks)[]

---

##### `putSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.putSecurityGroups"></a>

```typescript
public putSecurityGroups(value: AsGroupV1SecurityGroups)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups`](#@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.putTimeouts"></a>

```typescript
public putTimeouts(value: AsGroupV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts)

---

##### `resetAvailableZones` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetAvailableZones"></a>

```typescript
public resetAvailableZones()
```

##### `resetCoolDownTime` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetCoolDownTime"></a>

```typescript
public resetCoolDownTime()
```

##### `resetDeleteInstances` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetDeleteInstances"></a>

```typescript
public resetDeleteInstances()
```

##### `resetDeletePublicip` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetDeletePublicip"></a>

```typescript
public resetDeletePublicip()
```

##### `resetDesireInstanceNumber` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetDesireInstanceNumber"></a>

```typescript
public resetDesireInstanceNumber()
```

##### `resetHealthPeriodicAuditGracePeriod` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetHealthPeriodicAuditGracePeriod"></a>

```typescript
public resetHealthPeriodicAuditGracePeriod()
```

##### `resetHealthPeriodicAuditMethod` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetHealthPeriodicAuditMethod"></a>

```typescript
public resetHealthPeriodicAuditMethod()
```

##### `resetHealthPeriodicAuditTime` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetHealthPeriodicAuditTime"></a>

```typescript
public resetHealthPeriodicAuditTime()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetId"></a>

```typescript
public resetId()
```

##### `resetInstanceTerminatePolicy` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetInstanceTerminatePolicy"></a>

```typescript
public resetInstanceTerminatePolicy()
```

##### `resetLbaasListeners` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetLbaasListeners"></a>

```typescript
public resetLbaasListeners()
```

##### `resetLbListenerId` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetLbListenerId"></a>

```typescript
public resetLbListenerId()
```

##### `resetMaxInstanceNumber` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetMaxInstanceNumber"></a>

```typescript
public resetMaxInstanceNumber()
```

##### `resetMinInstanceNumber` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetMinInstanceNumber"></a>

```typescript
public resetMinInstanceNumber()
```

##### `resetNotifications` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetNotifications"></a>

```typescript
public resetNotifications()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetScalingConfigurationId` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetScalingConfigurationId"></a>

```typescript
public resetScalingConfigurationId()
```

##### `resetSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetSecurityGroups"></a>

```typescript
public resetSecurityGroups()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `currentInstanceNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.currentInstanceNumber"></a>

```typescript
public readonly currentInstanceNumber: number;
```

- *Type:* `number`

---

##### `instances`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.instances"></a>

```typescript
public readonly instances: string[];
```

- *Type:* `string`[]

---

##### `lbaasListeners`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.lbaasListeners"></a>

```typescript
public readonly lbaasListeners: AsGroupV1LbaasListenersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList)

---

##### `networks`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.networks"></a>

```typescript
public readonly networks: AsGroupV1NetworksList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList`](#@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList)

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.securityGroups"></a>

```typescript
public readonly securityGroups: AsGroupV1SecurityGroupsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference`](#@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.timeouts"></a>

```typescript
public readonly timeouts: AsGroupV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference)

---

##### `availableZonesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.availableZonesInput"></a>

```typescript
public readonly availableZonesInput: string[];
```

- *Type:* `string`[]

---

##### `coolDownTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.coolDownTimeInput"></a>

```typescript
public readonly coolDownTimeInput: number;
```

- *Type:* `number`

---

##### `deleteInstancesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.deleteInstancesInput"></a>

```typescript
public readonly deleteInstancesInput: string;
```

- *Type:* `string`

---

##### `deletePublicipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.deletePublicipInput"></a>

```typescript
public readonly deletePublicipInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `desireInstanceNumberInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.desireInstanceNumberInput"></a>

```typescript
public readonly desireInstanceNumberInput: number;
```

- *Type:* `number`

---

##### `healthPeriodicAuditGracePeriodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditGracePeriodInput"></a>

```typescript
public readonly healthPeriodicAuditGracePeriodInput: number;
```

- *Type:* `number`

---

##### `healthPeriodicAuditMethodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditMethodInput"></a>

```typescript
public readonly healthPeriodicAuditMethodInput: string;
```

- *Type:* `string`

---

##### `healthPeriodicAuditTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditTimeInput"></a>

```typescript
public readonly healthPeriodicAuditTimeInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceTerminatePolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.instanceTerminatePolicyInput"></a>

```typescript
public readonly instanceTerminatePolicyInput: string;
```

- *Type:* `string`

---

##### `lbaasListenersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.lbaasListenersInput"></a>

```typescript
public readonly lbaasListenersInput: IResolvable | AsGroupV1LbaasListeners[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners)[]

---

##### `lbListenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.lbListenerIdInput"></a>

```typescript
public readonly lbListenerIdInput: string;
```

- *Type:* `string`

---

##### `maxInstanceNumberInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.maxInstanceNumberInput"></a>

```typescript
public readonly maxInstanceNumberInput: number;
```

- *Type:* `number`

---

##### `minInstanceNumberInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.minInstanceNumberInput"></a>

```typescript
public readonly minInstanceNumberInput: number;
```

- *Type:* `number`

---

##### `networksInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.networksInput"></a>

```typescript
public readonly networksInput: IResolvable | AsGroupV1Networks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Networks`](#@cdktf/provider-opentelekomcloud.AsGroupV1Networks)[]

---

##### `notificationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.notificationsInput"></a>

```typescript
public readonly notificationsInput: string[];
```

- *Type:* `string`[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `scalingConfigurationIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.scalingConfigurationIdInput"></a>

```typescript
public readonly scalingConfigurationIdInput: string;
```

- *Type:* `string`

---

##### `scalingGroupNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.scalingGroupNameInput"></a>

```typescript
public readonly scalingGroupNameInput: string;
```

- *Type:* `string`

---

##### `securityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.securityGroupsInput"></a>

```typescript
public readonly securityGroupsInput: AsGroupV1SecurityGroups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups`](#@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AsGroupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availableZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

---

##### `coolDownTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

---

##### `deleteInstances`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.deleteInstances"></a>

```typescript
public readonly deleteInstances: string;
```

- *Type:* `string`

---

##### `deletePublicip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.deletePublicip"></a>

```typescript
public readonly deletePublicip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `desireInstanceNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.desireInstanceNumber"></a>

```typescript
public readonly desireInstanceNumber: number;
```

- *Type:* `number`

---

##### `healthPeriodicAuditGracePeriod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditGracePeriod"></a>

```typescript
public readonly healthPeriodicAuditGracePeriod: number;
```

- *Type:* `number`

---

##### `healthPeriodicAuditMethod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditMethod"></a>

```typescript
public readonly healthPeriodicAuditMethod: string;
```

- *Type:* `string`

---

##### `healthPeriodicAuditTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.healthPeriodicAuditTime"></a>

```typescript
public readonly healthPeriodicAuditTime: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceTerminatePolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.instanceTerminatePolicy"></a>

```typescript
public readonly instanceTerminatePolicy: string;
```

- *Type:* `string`

---

##### `lbListenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.lbListenerId"></a>

```typescript
public readonly lbListenerId: string;
```

- *Type:* `string`

---

##### `maxInstanceNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.maxInstanceNumber"></a>

```typescript
public readonly maxInstanceNumber: number;
```

- *Type:* `number`

---

##### `minInstanceNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.minInstanceNumber"></a>

```typescript
public readonly minInstanceNumber: number;
```

- *Type:* `number`

---

##### `notifications`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.notifications"></a>

```typescript
public readonly notifications: string[];
```

- *Type:* `string`[]

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `scalingConfigurationId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.scalingConfigurationId"></a>

```typescript
public readonly scalingConfigurationId: string;
```

- *Type:* `string`

---

##### `scalingGroupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.scalingGroupName"></a>

```typescript
public readonly scalingGroupName: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1.property.tfResourceType"></a>

- *Type:* `string`

---

### AsPolicyV1 <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1 opentelekomcloud_as_policy_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.Initializer"></a>

```typescript
import { AsPolicyV1 } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV1(scope: Construct, id: string, config: AsPolicyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1Config`](#@cdktf/provider-opentelekomcloud.AsPolicyV1Config)

---

#### Methods <a name="Methods"></a>

##### `putScalingPolicyAction` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.putScalingPolicyAction"></a>

```typescript
public putScalingPolicyAction(value: AsPolicyV1ScalingPolicyAction)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction)

---

##### `putScheduledPolicy` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.putScheduledPolicy"></a>

```typescript
public putScheduledPolicy(value: AsPolicyV1ScheduledPolicy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy)

---

##### `resetAlarmId` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetAlarmId"></a>

```typescript
public resetAlarmId()
```

##### `resetCoolDownTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetCoolDownTime"></a>

```typescript
public resetCoolDownTime()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetScalingPolicyAction` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetScalingPolicyAction"></a>

```typescript
public resetScalingPolicyAction()
```

##### `resetScheduledPolicy` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.resetScheduledPolicy"></a>

```typescript
public resetScheduledPolicy()
```


#### Properties <a name="Properties"></a>

##### `scalingPolicyAction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyAction"></a>

```typescript
public readonly scalingPolicyAction: AsPolicyV1ScalingPolicyActionOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference)

---

##### `scheduledPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scheduledPolicy"></a>

```typescript
public readonly scheduledPolicy: AsPolicyV1ScheduledPolicyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference)

---

##### `alarmIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.alarmIdInput"></a>

```typescript
public readonly alarmIdInput: string;
```

- *Type:* `string`

---

##### `coolDownTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.coolDownTimeInput"></a>

```typescript
public readonly coolDownTimeInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `scalingGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingGroupIdInput"></a>

```typescript
public readonly scalingGroupIdInput: string;
```

- *Type:* `string`

---

##### `scalingPolicyActionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyActionInput"></a>

```typescript
public readonly scalingPolicyActionInput: AsPolicyV1ScalingPolicyAction;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction)

---

##### `scalingPolicyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyNameInput"></a>

```typescript
public readonly scalingPolicyNameInput: string;
```

- *Type:* `string`

---

##### `scalingPolicyTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyTypeInput"></a>

```typescript
public readonly scalingPolicyTypeInput: string;
```

- *Type:* `string`

---

##### `scheduledPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scheduledPolicyInput"></a>

```typescript
public readonly scheduledPolicyInput: AsPolicyV1ScheduledPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy)

---

##### `alarmId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.alarmId"></a>

```typescript
public readonly alarmId: string;
```

- *Type:* `string`

---

##### `coolDownTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `scalingGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingGroupId"></a>

```typescript
public readonly scalingGroupId: string;
```

- *Type:* `string`

---

##### `scalingPolicyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyName"></a>

```typescript
public readonly scalingPolicyName: string;
```

- *Type:* `string`

---

##### `scalingPolicyType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.scalingPolicyType"></a>

```typescript
public readonly scalingPolicyType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### AsPolicyV2 <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2 opentelekomcloud_as_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.Initializer"></a>

```typescript
import { AsPolicyV2 } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2(scope: Construct, id: string, config: AsPolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV2Config`](#@cdktf/provider-opentelekomcloud.AsPolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putScalingPolicyAction` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.putScalingPolicyAction"></a>

```typescript
public putScalingPolicyAction(value: IResolvable | AsPolicyV2ScalingPolicyAction[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction)[]

---

##### `putScheduledPolicy` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.putScheduledPolicy"></a>

```typescript
public putScheduledPolicy(value: IResolvable | AsPolicyV2ScheduledPolicy[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy)[]

---

##### `resetAlarmId` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetAlarmId"></a>

```typescript
public resetAlarmId()
```

##### `resetCoolDownTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetCoolDownTime"></a>

```typescript
public resetCoolDownTime()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetScalingPolicyAction` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetScalingPolicyAction"></a>

```typescript
public resetScalingPolicyAction()
```

##### `resetScheduledPolicy` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.resetScheduledPolicy"></a>

```typescript
public resetScheduledPolicy()
```


#### Properties <a name="Properties"></a>

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.metadata"></a>

```typescript
public readonly metadata: AsPolicyV2MetadataList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList`](#@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList)

---

##### `scalingPolicyAction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyAction"></a>

```typescript
public readonly scalingPolicyAction: AsPolicyV2ScalingPolicyActionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList)

---

##### `scheduledPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scheduledPolicy"></a>

```typescript
public readonly scheduledPolicy: AsPolicyV2ScheduledPolicyList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList)

---

##### `alarmIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.alarmIdInput"></a>

```typescript
public readonly alarmIdInput: string;
```

- *Type:* `string`

---

##### `coolDownTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.coolDownTimeInput"></a>

```typescript
public readonly coolDownTimeInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `scalingPolicyActionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyActionInput"></a>

```typescript
public readonly scalingPolicyActionInput: IResolvable | AsPolicyV2ScalingPolicyAction[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction)[]

---

##### `scalingPolicyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyNameInput"></a>

```typescript
public readonly scalingPolicyNameInput: string;
```

- *Type:* `string`

---

##### `scalingPolicyTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyTypeInput"></a>

```typescript
public readonly scalingPolicyTypeInput: string;
```

- *Type:* `string`

---

##### `scalingResourceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingResourceIdInput"></a>

```typescript
public readonly scalingResourceIdInput: string;
```

- *Type:* `string`

---

##### `scalingResourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingResourceTypeInput"></a>

```typescript
public readonly scalingResourceTypeInput: string;
```

- *Type:* `string`

---

##### `scheduledPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scheduledPolicyInput"></a>

```typescript
public readonly scheduledPolicyInput: IResolvable | AsPolicyV2ScheduledPolicy[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy)[]

---

##### `alarmId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.alarmId"></a>

```typescript
public readonly alarmId: string;
```

- *Type:* `string`

---

##### `coolDownTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `scalingPolicyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyName"></a>

```typescript
public readonly scalingPolicyName: string;
```

- *Type:* `string`

---

##### `scalingPolicyType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingPolicyType"></a>

```typescript
public readonly scalingPolicyType: string;
```

- *Type:* `string`

---

##### `scalingResourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingResourceId"></a>

```typescript
public readonly scalingResourceId: string;
```

- *Type:* `string`

---

##### `scalingResourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.scalingResourceType"></a>

```typescript
public readonly scalingResourceType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### BlockstorageVolumeV2 <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2 opentelekomcloud_blockstorage_volume_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.Initializer"></a>

```typescript
import { BlockstorageVolumeV2 } from '@cdktf/provider-opentelekomcloud'

new BlockstorageVolumeV2(scope: Construct, id: string, config: BlockstorageVolumeV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.putTimeouts"></a>

```typescript
public putTimeouts(value: BlockstorageVolumeV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts)

---

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetCascade` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetCascade"></a>

```typescript
public resetCascade()
```

##### `resetConsistencyGroupId` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetConsistencyGroupId"></a>

```typescript
public resetConsistencyGroupId()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDeviceType` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetDeviceType"></a>

```typescript
public resetDeviceType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageId` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetImageId"></a>

```typescript
public resetImageId()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetMetadata"></a>

```typescript
public resetMetadata()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSnapshotId` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetSnapshotId"></a>

```typescript
public resetSnapshotId()
```

##### `resetSourceReplica` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetSourceReplica"></a>

```typescript
public resetSourceReplica()
```

##### `resetSourceVolId` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetSourceVolId"></a>

```typescript
public resetSourceVolId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVolumeType` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.resetVolumeType"></a>

```typescript
public resetVolumeType()
```


#### Properties <a name="Properties"></a>

##### `attachment`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.attachment"></a>

```typescript
public readonly attachment: BlockstorageVolumeV2AttachmentList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.timeouts"></a>

```typescript
public readonly timeouts: BlockstorageVolumeV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference)

---

##### `wwn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.wwn"></a>

```typescript
public readonly wwn: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `cascadeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.cascadeInput"></a>

```typescript
public readonly cascadeInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `consistencyGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.consistencyGroupIdInput"></a>

```typescript
public readonly consistencyGroupIdInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `deviceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.deviceTypeInput"></a>

```typescript
public readonly deviceTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* `string`

---

##### `sourceReplicaInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.sourceReplicaInput"></a>

```typescript
public readonly sourceReplicaInput: string;
```

- *Type:* `string`

---

##### `sourceVolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.sourceVolIdInput"></a>

```typescript
public readonly sourceVolIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | BlockstorageVolumeV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts)

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `cascade`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.cascade"></a>

```typescript
public readonly cascade: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `consistencyGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.consistencyGroupId"></a>

```typescript
public readonly consistencyGroupId: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `deviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.deviceType"></a>

```typescript
public readonly deviceType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `sourceReplica`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.sourceReplica"></a>

```typescript
public readonly sourceReplica: string;
```

- *Type:* `string`

---

##### `sourceVolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.sourceVolId"></a>

```typescript
public readonly sourceVolId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2.property.tfResourceType"></a>

- *Type:* `string`

---

### CbrPolicyV3 <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3 opentelekomcloud_cbr_policy_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.Initializer"></a>

```typescript
import { CbrPolicyV3 } from '@cdktf/provider-opentelekomcloud'

new CbrPolicyV3(scope: Construct, id: string, config: CbrPolicyV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3Config`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3Config)

---

#### Methods <a name="Methods"></a>

##### `putOperationDefinition` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.putOperationDefinition"></a>

```typescript
public putOperationDefinition(value: CbrPolicyV3OperationDefinition)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition)

---

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.resetId"></a>

```typescript
public resetId()
```

##### `resetOperationDefinition` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.resetOperationDefinition"></a>

```typescript
public resetOperationDefinition()
```


#### Properties <a name="Properties"></a>

##### `operationDefinition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.operationDefinition"></a>

```typescript
public readonly operationDefinition: CbrPolicyV3OperationDefinitionOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `operationDefinitionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.operationDefinitionInput"></a>

```typescript
public readonly operationDefinitionInput: CbrPolicyV3OperationDefinition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition)

---

##### `operationTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.operationTypeInput"></a>

```typescript
public readonly operationTypeInput: string;
```

- *Type:* `string`

---

##### `triggerPatternInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.triggerPatternInput"></a>

```typescript
public readonly triggerPatternInput: string[];
```

- *Type:* `string`[]

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `operationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.operationType"></a>

```typescript
public readonly operationType: string;
```

- *Type:* `string`

---

##### `triggerPattern`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.triggerPattern"></a>

```typescript
public readonly triggerPattern: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CbrVaultV3 <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3 opentelekomcloud_cbr_vault_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.Initializer"></a>

```typescript
import { CbrVaultV3 } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3(scope: Construct, id: string, config: CbrVaultV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3Config`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Config)

---

#### Methods <a name="Methods"></a>

##### `putBilling` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.putBilling"></a>

```typescript
public putBilling(value: CbrVaultV3Billing)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3Billing`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Billing)

---

##### `putBindRules` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.putBindRules"></a>

```typescript
public putBindRules(value: IResolvable | CbrVaultV3BindRules[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules)[]

---

##### `putResource` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.putResource"></a>

```typescript
public putResource(value: IResolvable | CbrVaultV3Resource[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3Resource`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Resource)[]

---

##### `resetAutoBind` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetAutoBind"></a>

```typescript
public resetAutoBind()
```

##### `resetAutoExpand` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetAutoExpand"></a>

```typescript
public resetAutoExpand()
```

##### `resetBackupPolicyId` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetBackupPolicyId"></a>

```typescript
public resetBackupPolicyId()
```

##### `resetBindRules` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetBindRules"></a>

```typescript
public resetBindRules()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEnterpriseProjectId` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetEnterpriseProjectId"></a>

```typescript
public resetEnterpriseProjectId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetId"></a>

```typescript
public resetId()
```

##### `resetResource` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetResource"></a>

```typescript
public resetResource()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.resetTags"></a>

```typescript
public resetTags()
```


#### Properties <a name="Properties"></a>

##### `billing`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.billing"></a>

```typescript
public readonly billing: CbrVaultV3BillingOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference)

---

##### `bindRules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.bindRules"></a>

```typescript
public readonly bindRules: CbrVaultV3BindRulesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList)

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `providerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

---

##### `resource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.resource"></a>

```typescript
public readonly resource: CbrVaultV3ResourceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList`](#@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList)

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `autoBindInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.autoBindInput"></a>

```typescript
public readonly autoBindInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `autoExpandInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.autoExpandInput"></a>

```typescript
public readonly autoExpandInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `backupPolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.backupPolicyIdInput"></a>

```typescript
public readonly backupPolicyIdInput: string;
```

- *Type:* `string`

---

##### `billingInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.billingInput"></a>

```typescript
public readonly billingInput: CbrVaultV3Billing;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3Billing`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Billing)

---

##### `bindRulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.bindRulesInput"></a>

```typescript
public readonly bindRulesInput: IResolvable | CbrVaultV3BindRules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules)[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `enterpriseProjectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.enterpriseProjectIdInput"></a>

```typescript
public readonly enterpriseProjectIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `resourceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.resourceInput"></a>

```typescript
public readonly resourceInput: IResolvable | CbrVaultV3Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3Resource`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Resource)[]

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `autoBind`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.autoBind"></a>

```typescript
public readonly autoBind: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `autoExpand`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.autoExpand"></a>

```typescript
public readonly autoExpand: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `backupPolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.backupPolicyId"></a>

```typescript
public readonly backupPolicyId: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `enterpriseProjectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.enterpriseProjectId"></a>

```typescript
public readonly enterpriseProjectId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CceAddonV3 <a name="@cdktf/provider-opentelekomcloud.CceAddonV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3 opentelekomcloud_cce_addon_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.Initializer"></a>

```typescript
import { CceAddonV3 } from '@cdktf/provider-opentelekomcloud'

new CceAddonV3(scope: Construct, id: string, config: CceAddonV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Config`](#@cdktf/provider-opentelekomcloud.CceAddonV3Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.putTimeouts"></a>

```typescript
public putTimeouts(value: CceAddonV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts)

---

##### `putValues` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.putValues"></a>

```typescript
public putValues(value: CceAddonV3Values)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Values`](#@cdktf/provider-opentelekomcloud.CceAddonV3Values)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.timeouts"></a>

```typescript
public readonly timeouts: CceAddonV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference)

---

##### `values`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.values"></a>

```typescript
public readonly values: CceAddonV3ValuesOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference`](#@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference)

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `templateNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.templateNameInput"></a>

```typescript
public readonly templateNameInput: string;
```

- *Type:* `string`

---

##### `templateVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.templateVersionInput"></a>

```typescript
public readonly templateVersionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CceAddonV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts)

---

##### `valuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.valuesInput"></a>

```typescript
public readonly valuesInput: CceAddonV3Values;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Values`](#@cdktf/provider-opentelekomcloud.CceAddonV3Values)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `templateName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.templateName"></a>

```typescript
public readonly templateName: string;
```

- *Type:* `string`

---

##### `templateVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.templateVersion"></a>

```typescript
public readonly templateVersion: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CceClusterV3 <a name="@cdktf/provider-opentelekomcloud.CceClusterV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3 opentelekomcloud_cce_cluster_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.Initializer"></a>

```typescript
import { CceClusterV3 } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3(scope: Construct, id: string, config: CceClusterV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3Config`](#@cdktf/provider-opentelekomcloud.CceClusterV3Config)

---

#### Methods <a name="Methods"></a>

##### `putAuthenticatingProxy` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.putAuthenticatingProxy"></a>

```typescript
public putAuthenticatingProxy(value: CceClusterV3AuthenticatingProxy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy`](#@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.putTimeouts"></a>

```typescript
public putTimeouts(value: CceClusterV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts)

---

##### `resetAnnotations` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetAnnotations"></a>

```typescript
public resetAnnotations()
```

##### `resetAuthenticatingProxy` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetAuthenticatingProxy"></a>

```typescript
public resetAuthenticatingProxy()
```

##### `resetAuthenticatingProxyCa` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetAuthenticatingProxyCa"></a>

```typescript
public resetAuthenticatingProxyCa()
```

##### `resetAuthenticationMode` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetAuthenticationMode"></a>

```typescript
public resetAuthenticationMode()
```

##### `resetBillingMode` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetBillingMode"></a>

```typescript
public resetBillingMode()
```

##### `resetClusterVersion` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetClusterVersion"></a>

```typescript
public resetClusterVersion()
```

##### `resetContainerNetworkCidr` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetContainerNetworkCidr"></a>

```typescript
public resetContainerNetworkCidr()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEip` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetEip"></a>

```typescript
public resetEip()
```

##### `resetEniSubnetCidr` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetEniSubnetCidr"></a>

```typescript
public resetEniSubnetCidr()
```

##### `resetEniSubnetId` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetEniSubnetId"></a>

```typescript
public resetEniSubnetId()
```

##### `resetExtendParam` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetExtendParam"></a>

```typescript
public resetExtendParam()
```

##### `resetHighwaySubnetId` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetHighwaySubnetId"></a>

```typescript
public resetHighwaySubnetId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetId"></a>

```typescript
public resetId()
```

##### `resetIgnoreAddons` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetIgnoreAddons"></a>

```typescript
public resetIgnoreAddons()
```

##### `resetKubernetesSvcIpRange` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetKubernetesSvcIpRange"></a>

```typescript
public resetKubernetesSvcIpRange()
```

##### `resetLabels` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetLabels"></a>

```typescript
public resetLabels()
```

##### `resetMultiAz` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetMultiAz"></a>

```typescript
public resetMultiAz()
```

##### `resetNoAddons` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetNoAddons"></a>

```typescript
public resetNoAddons()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `authenticatingProxy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticatingProxy"></a>

```typescript
public readonly authenticatingProxy: CceClusterV3AuthenticatingProxyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference`](#@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference)

---

##### `certificateClusters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.certificateClusters"></a>

```typescript
public readonly certificateClusters: CceClusterV3CertificateClustersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList`](#@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList)

---

##### `certificateUsers`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.certificateUsers"></a>

```typescript
public readonly certificateUsers: CceClusterV3CertificateUsersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList`](#@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList)

---

##### `external`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.external"></a>

```typescript
public readonly external: string;
```

- *Type:* `string`

---

##### `externalOtc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.externalOtc"></a>

```typescript
public readonly externalOtc: string;
```

- *Type:* `string`

---

##### `installedAddons`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.installedAddons"></a>

```typescript
public readonly installedAddons: string[];
```

- *Type:* `string`[]

---

##### `internal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.internal"></a>

```typescript
public readonly internal: string;
```

- *Type:* `string`

---

##### `kubeProxyMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.kubeProxyMode"></a>

```typescript
public readonly kubeProxyMode: string;
```

- *Type:* `string`

---

##### `securityGroupControl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.securityGroupControl"></a>

```typescript
public readonly securityGroupControl: string;
```

- *Type:* `string`

---

##### `securityGroupNode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.securityGroupNode"></a>

```typescript
public readonly securityGroupNode: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.timeouts"></a>

```typescript
public readonly timeouts: CceClusterV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference)

---

##### `annotationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.annotationsInput"></a>

```typescript
public readonly annotationsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `authenticatingProxyCaInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticatingProxyCaInput"></a>

```typescript
public readonly authenticatingProxyCaInput: string;
```

- *Type:* `string`

---

##### `authenticatingProxyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticatingProxyInput"></a>

```typescript
public readonly authenticatingProxyInput: CceClusterV3AuthenticatingProxy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy`](#@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy)

---

##### `authenticationModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticationModeInput"></a>

```typescript
public readonly authenticationModeInput: string;
```

- *Type:* `string`

---

##### `billingModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.billingModeInput"></a>

```typescript
public readonly billingModeInput: number;
```

- *Type:* `number`

---

##### `clusterTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.clusterTypeInput"></a>

```typescript
public readonly clusterTypeInput: string;
```

- *Type:* `string`

---

##### `clusterVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.clusterVersionInput"></a>

```typescript
public readonly clusterVersionInput: string;
```

- *Type:* `string`

---

##### `containerNetworkCidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.containerNetworkCidrInput"></a>

```typescript
public readonly containerNetworkCidrInput: string;
```

- *Type:* `string`

---

##### `containerNetworkTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.containerNetworkTypeInput"></a>

```typescript
public readonly containerNetworkTypeInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `eipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eipInput"></a>

```typescript
public readonly eipInput: string;
```

- *Type:* `string`

---

##### `eniSubnetCidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eniSubnetCidrInput"></a>

```typescript
public readonly eniSubnetCidrInput: string;
```

- *Type:* `string`

---

##### `eniSubnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eniSubnetIdInput"></a>

```typescript
public readonly eniSubnetIdInput: string;
```

- *Type:* `string`

---

##### `extendParamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.extendParamInput"></a>

```typescript
public readonly extendParamInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `highwaySubnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.highwaySubnetIdInput"></a>

```typescript
public readonly highwaySubnetIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ignoreAddonsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.ignoreAddonsInput"></a>

```typescript
public readonly ignoreAddonsInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `kubernetesSvcIpRangeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.kubernetesSvcIpRangeInput"></a>

```typescript
public readonly kubernetesSvcIpRangeInput: string;
```

- *Type:* `string`

---

##### `labelsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `multiAzInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.multiAzInput"></a>

```typescript
public readonly multiAzInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `noAddonsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.noAddonsInput"></a>

```typescript
public readonly noAddonsInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CceClusterV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `annotations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `authenticatingProxyCa`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticatingProxyCa"></a>

```typescript
public readonly authenticatingProxyCa: string;
```

- *Type:* `string`

---

##### `authenticationMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.authenticationMode"></a>

```typescript
public readonly authenticationMode: string;
```

- *Type:* `string`

---

##### `billingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

---

##### `clusterType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.clusterType"></a>

```typescript
public readonly clusterType: string;
```

- *Type:* `string`

---

##### `clusterVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.clusterVersion"></a>

```typescript
public readonly clusterVersion: string;
```

- *Type:* `string`

---

##### `containerNetworkCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.containerNetworkCidr"></a>

```typescript
public readonly containerNetworkCidr: string;
```

- *Type:* `string`

---

##### `containerNetworkType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.containerNetworkType"></a>

```typescript
public readonly containerNetworkType: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `eip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eip"></a>

```typescript
public readonly eip: string;
```

- *Type:* `string`

---

##### `eniSubnetCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eniSubnetCidr"></a>

```typescript
public readonly eniSubnetCidr: string;
```

- *Type:* `string`

---

##### `eniSubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.eniSubnetId"></a>

```typescript
public readonly eniSubnetId: string;
```

- *Type:* `string`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.extendParam"></a>

```typescript
public readonly extendParam: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `highwaySubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.highwaySubnetId"></a>

```typescript
public readonly highwaySubnetId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ignoreAddons`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.ignoreAddons"></a>

```typescript
public readonly ignoreAddons: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `kubernetesSvcIpRange`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.kubernetesSvcIpRange"></a>

```typescript
public readonly kubernetesSvcIpRange: string;
```

- *Type:* `string`

---

##### `labels`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `multiAz`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.multiAz"></a>

```typescript
public readonly multiAz: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `noAddons`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.noAddons"></a>

```typescript
public readonly noAddons: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CceNodePoolV3 <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3 opentelekomcloud_cce_node_pool_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.Initializer"></a>

```typescript
import { CceNodePoolV3 } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3(scope: Construct, id: string, config: CceNodePoolV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Config`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Config)

---

#### Methods <a name="Methods"></a>

##### `putDataVolumes` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.putDataVolumes"></a>

```typescript
public putDataVolumes(value: IResolvable | CceNodePoolV3DataVolumes[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes)[]

---

##### `putRootVolume` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.putRootVolume"></a>

```typescript
public putRootVolume(value: CceNodePoolV3RootVolume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume)

---

##### `putTaints` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.putTaints"></a>

```typescript
public putTaints(value: IResolvable | CceNodePoolV3Taints[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.putTimeouts"></a>

```typescript
public putTimeouts(value: CceNodePoolV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts)

---

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetDockerBaseSize` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetDockerBaseSize"></a>

```typescript
public resetDockerBaseSize()
```

##### `resetDockerLvmConfigOverride` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetDockerLvmConfigOverride"></a>

```typescript
public resetDockerLvmConfigOverride()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetId"></a>

```typescript
public resetId()
```

##### `resetK8STags` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetK8STags"></a>

```typescript
public resetK8STags()
```

##### `resetKeyPair` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetKeyPair"></a>

```typescript
public resetKeyPair()
```

##### `resetMaxNodeCount` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetMaxNodeCount"></a>

```typescript
public resetMaxNodeCount()
```

##### `resetMaxPods` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetMaxPods"></a>

```typescript
public resetMaxPods()
```

##### `resetMinNodeCount` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetMinNodeCount"></a>

```typescript
public resetMinNodeCount()
```

##### `resetOs` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetOs"></a>

```typescript
public resetOs()
```

##### `resetPassword` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetPassword"></a>

```typescript
public resetPassword()
```

##### `resetPostinstall` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetPostinstall"></a>

```typescript
public resetPostinstall()
```

##### `resetPreinstall` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetPreinstall"></a>

```typescript
public resetPreinstall()
```

##### `resetPriority` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetPriority"></a>

```typescript
public resetPriority()
```

##### `resetScaleDownCooldownTime` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetScaleDownCooldownTime"></a>

```typescript
public resetScaleDownCooldownTime()
```

##### `resetScaleEnable` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetScaleEnable"></a>

```typescript
public resetScaleEnable()
```

##### `resetServerGroupReference` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetServerGroupReference"></a>

```typescript
public resetServerGroupReference()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTaints` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetTaints"></a>

```typescript
public resetTaints()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetUserTags` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.resetUserTags"></a>

```typescript
public resetUserTags()
```


#### Properties <a name="Properties"></a>

##### `dataVolumes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dataVolumes"></a>

```typescript
public readonly dataVolumes: CceNodePoolV3DataVolumesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList)

---

##### `rootVolume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.rootVolume"></a>

```typescript
public readonly rootVolume: CceNodePoolV3RootVolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `taints`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.taints"></a>

```typescript
public readonly taints: CceNodePoolV3TaintsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.timeouts"></a>

```typescript
public readonly timeouts: CceNodePoolV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `dataVolumesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dataVolumesInput"></a>

```typescript
public readonly dataVolumesInput: IResolvable | CceNodePoolV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes)[]

---

##### `dockerBaseSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dockerBaseSizeInput"></a>

```typescript
public readonly dockerBaseSizeInput: number;
```

- *Type:* `number`

---

##### `dockerLvmConfigOverrideInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dockerLvmConfigOverrideInput"></a>

```typescript
public readonly dockerLvmConfigOverrideInput: string;
```

- *Type:* `string`

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.flavorInput"></a>

```typescript
public readonly flavorInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `initialNodeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.initialNodeCountInput"></a>

```typescript
public readonly initialNodeCountInput: number;
```

- *Type:* `number`

---

##### `k8STagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.k8STagsInput"></a>

```typescript
public readonly k8STagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `keyPairInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.keyPairInput"></a>

```typescript
public readonly keyPairInput: string;
```

- *Type:* `string`

---

##### `maxNodeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.maxNodeCountInput"></a>

```typescript
public readonly maxNodeCountInput: number;
```

- *Type:* `number`

---

##### `maxPodsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.maxPodsInput"></a>

```typescript
public readonly maxPodsInput: number;
```

- *Type:* `number`

---

##### `minNodeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.minNodeCountInput"></a>

```typescript
public readonly minNodeCountInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `osInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.osInput"></a>

```typescript
public readonly osInput: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `postinstallInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.postinstallInput"></a>

```typescript
public readonly postinstallInput: string;
```

- *Type:* `string`

---

##### `preinstallInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.preinstallInput"></a>

```typescript
public readonly preinstallInput: string;
```

- *Type:* `string`

---

##### `priorityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* `number`

---

##### `rootVolumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.rootVolumeInput"></a>

```typescript
public readonly rootVolumeInput: CceNodePoolV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume)

---

##### `scaleDownCooldownTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.scaleDownCooldownTimeInput"></a>

```typescript
public readonly scaleDownCooldownTimeInput: number;
```

- *Type:* `number`

---

##### `scaleEnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.scaleEnableInput"></a>

```typescript
public readonly scaleEnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `serverGroupReferenceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.serverGroupReferenceInput"></a>

```typescript
public readonly serverGroupReferenceInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `taintsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.taintsInput"></a>

```typescript
public readonly taintsInput: IResolvable | CceNodePoolV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CceNodePoolV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts)

---

##### `userTagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.userTagsInput"></a>

```typescript
public readonly userTagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `dockerBaseSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dockerBaseSize"></a>

```typescript
public readonly dockerBaseSize: number;
```

- *Type:* `number`

---

##### `dockerLvmConfigOverride`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.dockerLvmConfigOverride"></a>

```typescript
public readonly dockerLvmConfigOverride: string;
```

- *Type:* `string`

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `initialNodeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.initialNodeCount"></a>

```typescript
public readonly initialNodeCount: number;
```

- *Type:* `number`

---

##### `k8STags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.k8STags"></a>

```typescript
public readonly k8STags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

---

##### `maxNodeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.maxNodeCount"></a>

```typescript
public readonly maxNodeCount: number;
```

- *Type:* `number`

---

##### `maxPods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.maxPods"></a>

```typescript
public readonly maxPods: number;
```

- *Type:* `number`

---

##### `minNodeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.minNodeCount"></a>

```typescript
public readonly minNodeCount: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `os`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.os"></a>

```typescript
public readonly os: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `postinstall`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.postinstall"></a>

```typescript
public readonly postinstall: string;
```

- *Type:* `string`

---

##### `preinstall`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.preinstall"></a>

```typescript
public readonly preinstall: string;
```

- *Type:* `string`

---

##### `priority`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

---

##### `scaleDownCooldownTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.scaleDownCooldownTime"></a>

```typescript
public readonly scaleDownCooldownTime: number;
```

- *Type:* `number`

---

##### `scaleEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.scaleEnable"></a>

```typescript
public readonly scaleEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `serverGroupReference`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.serverGroupReference"></a>

```typescript
public readonly serverGroupReference: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `userTags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.userTags"></a>

```typescript
public readonly userTags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CceNodeV3 <a name="@cdktf/provider-opentelekomcloud.CceNodeV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3 opentelekomcloud_cce_node_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.Initializer"></a>

```typescript
import { CceNodeV3 } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3(scope: Construct, id: string, config: CceNodeV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3Config`](#@cdktf/provider-opentelekomcloud.CceNodeV3Config)

---

#### Methods <a name="Methods"></a>

##### `putDataVolumes` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.putDataVolumes"></a>

```typescript
public putDataVolumes(value: IResolvable | CceNodeV3DataVolumes[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes)[]

---

##### `putRootVolume` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.putRootVolume"></a>

```typescript
public putRootVolume(value: CceNodeV3RootVolume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume)

---

##### `putTaints` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.putTaints"></a>

```typescript
public putTaints(value: IResolvable | CceNodeV3Taints[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodeV3Taints)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.putTimeouts"></a>

```typescript
public putTimeouts(value: CceNodeV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts)

---

##### `resetAnnotations` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetAnnotations"></a>

```typescript
public resetAnnotations()
```

##### `resetBandwidthChargeMode` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetBandwidthChargeMode"></a>

```typescript
public resetBandwidthChargeMode()
```

##### `resetBandwidthSize` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetBandwidthSize"></a>

```typescript
public resetBandwidthSize()
```

##### `resetBillingMode` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetBillingMode"></a>

```typescript
public resetBillingMode()
```

##### `resetDockerBaseSize` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetDockerBaseSize"></a>

```typescript
public resetDockerBaseSize()
```

##### `resetDockerLvmConfigOverride` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetDockerLvmConfigOverride"></a>

```typescript
public resetDockerLvmConfigOverride()
```

##### `resetEcsPerformanceType` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetEcsPerformanceType"></a>

```typescript
public resetEcsPerformanceType()
```

##### `resetEipCount` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetEipCount"></a>

```typescript
public resetEipCount()
```

##### `resetEipIds` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetEipIds"></a>

```typescript
public resetEipIds()
```

##### `resetExtendParamChargingMode` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetExtendParamChargingMode"></a>

```typescript
public resetExtendParamChargingMode()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetId"></a>

```typescript
public resetId()
```

##### `resetIptype` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetIptype"></a>

```typescript
public resetIptype()
```

##### `resetK8STags` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetK8STags"></a>

```typescript
public resetK8STags()
```

##### `resetLabels` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetLabels"></a>

```typescript
public resetLabels()
```

##### `resetMaxPods` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetMaxPods"></a>

```typescript
public resetMaxPods()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetName"></a>

```typescript
public resetName()
```

##### `resetOrderId` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetOrderId"></a>

```typescript
public resetOrderId()
```

##### `resetOs` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetOs"></a>

```typescript
public resetOs()
```

##### `resetPostinstall` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetPostinstall"></a>

```typescript
public resetPostinstall()
```

##### `resetPreinstall` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetPreinstall"></a>

```typescript
public resetPreinstall()
```

##### `resetPrivateIp` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetPrivateIp"></a>

```typescript
public resetPrivateIp()
```

##### `resetProductId` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetProductId"></a>

```typescript
public resetProductId()
```

##### `resetPublicKey` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetPublicKey"></a>

```typescript
public resetPublicKey()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSharetype` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetSharetype"></a>

```typescript
public resetSharetype()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTaints` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetTaints"></a>

```typescript
public resetTaints()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `dataVolumes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dataVolumes"></a>

```typescript
public readonly dataVolumes: CceNodeV3DataVolumesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList)

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.publicIp"></a>

```typescript
public readonly publicIp: string;
```

- *Type:* `string`

---

##### `rootVolume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.rootVolume"></a>

```typescript
public readonly rootVolume: CceNodeV3RootVolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference`](#@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference)

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `taints`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.taints"></a>

```typescript
public readonly taints: CceNodeV3TaintsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList`](#@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.timeouts"></a>

```typescript
public readonly timeouts: CceNodeV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference)

---

##### `annotationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.annotationsInput"></a>

```typescript
public readonly annotationsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `bandwidthChargeModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.bandwidthChargeModeInput"></a>

```typescript
public readonly bandwidthChargeModeInput: string;
```

- *Type:* `string`

---

##### `bandwidthSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.bandwidthSizeInput"></a>

```typescript
public readonly bandwidthSizeInput: number;
```

- *Type:* `number`

---

##### `billingModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.billingModeInput"></a>

```typescript
public readonly billingModeInput: number;
```

- *Type:* `number`

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `dataVolumesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dataVolumesInput"></a>

```typescript
public readonly dataVolumesInput: IResolvable | CceNodeV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes)[]

---

##### `dockerBaseSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dockerBaseSizeInput"></a>

```typescript
public readonly dockerBaseSizeInput: number;
```

- *Type:* `number`

---

##### `dockerLvmConfigOverrideInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dockerLvmConfigOverrideInput"></a>

```typescript
public readonly dockerLvmConfigOverrideInput: string;
```

- *Type:* `string`

---

##### `ecsPerformanceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.ecsPerformanceTypeInput"></a>

```typescript
public readonly ecsPerformanceTypeInput: string;
```

- *Type:* `string`

---

##### `eipCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.eipCountInput"></a>

```typescript
public readonly eipCountInput: number;
```

- *Type:* `number`

---

##### `eipIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.eipIdsInput"></a>

```typescript
public readonly eipIdsInput: string[];
```

- *Type:* `string`[]

---

##### `extendParamChargingModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.extendParamChargingModeInput"></a>

```typescript
public readonly extendParamChargingModeInput: number;
```

- *Type:* `number`

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `iptypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.iptypeInput"></a>

```typescript
public readonly iptypeInput: string;
```

- *Type:* `string`

---

##### `k8STagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.k8STagsInput"></a>

```typescript
public readonly k8STagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `keyPairInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.keyPairInput"></a>

```typescript
public readonly keyPairInput: string;
```

- *Type:* `string`

---

##### `labelsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `maxPodsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.maxPodsInput"></a>

```typescript
public readonly maxPodsInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `orderIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.orderIdInput"></a>

```typescript
public readonly orderIdInput: string;
```

- *Type:* `string`

---

##### `osInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.osInput"></a>

```typescript
public readonly osInput: string;
```

- *Type:* `string`

---

##### `postinstallInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.postinstallInput"></a>

```typescript
public readonly postinstallInput: string;
```

- *Type:* `string`

---

##### `preinstallInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.preinstallInput"></a>

```typescript
public readonly preinstallInput: string;
```

- *Type:* `string`

---

##### `privateIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.privateIpInput"></a>

```typescript
public readonly privateIpInput: string;
```

- *Type:* `string`

---

##### `productIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.productIdInput"></a>

```typescript
public readonly productIdInput: string;
```

- *Type:* `string`

---

##### `publicKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.publicKeyInput"></a>

```typescript
public readonly publicKeyInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `rootVolumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.rootVolumeInput"></a>

```typescript
public readonly rootVolumeInput: CceNodeV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume)

---

##### `sharetypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.sharetypeInput"></a>

```typescript
public readonly sharetypeInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `taintsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.taintsInput"></a>

```typescript
public readonly taintsInput: IResolvable | CceNodeV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodeV3Taints)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CceNodeV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts)

---

##### `annotations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `bandwidthChargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.bandwidthChargeMode"></a>

```typescript
public readonly bandwidthChargeMode: string;
```

- *Type:* `string`

---

##### `bandwidthSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

---

##### `billingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `dockerBaseSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dockerBaseSize"></a>

```typescript
public readonly dockerBaseSize: number;
```

- *Type:* `number`

---

##### `dockerLvmConfigOverride`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.dockerLvmConfigOverride"></a>

```typescript
public readonly dockerLvmConfigOverride: string;
```

- *Type:* `string`

---

##### `ecsPerformanceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.ecsPerformanceType"></a>

```typescript
public readonly ecsPerformanceType: string;
```

- *Type:* `string`

---

##### `eipCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.eipCount"></a>

```typescript
public readonly eipCount: number;
```

- *Type:* `number`

---

##### `eipIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.eipIds"></a>

```typescript
public readonly eipIds: string[];
```

- *Type:* `string`[]

---

##### `extendParamChargingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.extendParamChargingMode"></a>

```typescript
public readonly extendParamChargingMode: number;
```

- *Type:* `number`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `iptype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.iptype"></a>

```typescript
public readonly iptype: string;
```

- *Type:* `string`

---

##### `k8STags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.k8STags"></a>

```typescript
public readonly k8STags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

---

##### `labels`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `maxPods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.maxPods"></a>

```typescript
public readonly maxPods: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `orderId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

---

##### `os`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.os"></a>

```typescript
public readonly os: string;
```

- *Type:* `string`

---

##### `postinstall`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.postinstall"></a>

```typescript
public readonly postinstall: string;
```

- *Type:* `string`

---

##### `preinstall`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.preinstall"></a>

```typescript
public readonly preinstall: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

---

##### `publicKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sharetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.sharetype"></a>

```typescript
public readonly sharetype: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3.property.tfResourceType"></a>

- *Type:* `string`

---

### CesAlarmrule <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule opentelekomcloud_ces_alarmrule}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.Initializer"></a>

```typescript
import { CesAlarmrule } from '@cdktf/provider-opentelekomcloud'

new CesAlarmrule(scope: Construct, id: string, config: CesAlarmruleConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleConfig`](#@cdktf/provider-opentelekomcloud.CesAlarmruleConfig)

---

#### Methods <a name="Methods"></a>

##### `putAlarmActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putAlarmActions"></a>

```typescript
public putAlarmActions(value: IResolvable | CesAlarmruleAlarmActions[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions)[]

---

##### `putCondition` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putCondition"></a>

```typescript
public putCondition(value: CesAlarmruleCondition)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleCondition`](#@cdktf/provider-opentelekomcloud.CesAlarmruleCondition)

---

##### `putInsufficientdataActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putInsufficientdataActions"></a>

```typescript
public putInsufficientdataActions(value: IResolvable | CesAlarmruleInsufficientdataActions[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions)[]

---

##### `putMetric` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putMetric"></a>

```typescript
public putMetric(value: CesAlarmruleMetric)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetric`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetric)

---

##### `putOkActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putOkActions"></a>

```typescript
public putOkActions(value: IResolvable | CesAlarmruleOkActions[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.putTimeouts"></a>

```typescript
public putTimeouts(value: CesAlarmruleTimeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts`](#@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts)

---

##### `resetAlarmActionEnabled` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetAlarmActionEnabled"></a>

```typescript
public resetAlarmActionEnabled()
```

##### `resetAlarmActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetAlarmActions"></a>

```typescript
public resetAlarmActions()
```

##### `resetAlarmDescription` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetAlarmDescription"></a>

```typescript
public resetAlarmDescription()
```

##### `resetAlarmEnabled` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetAlarmEnabled"></a>

```typescript
public resetAlarmEnabled()
```

##### `resetAlarmLevel` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetAlarmLevel"></a>

```typescript
public resetAlarmLevel()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetId"></a>

```typescript
public resetId()
```

##### `resetInsufficientdataActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetInsufficientdataActions"></a>

```typescript
public resetInsufficientdataActions()
```

##### `resetOkActions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetOkActions"></a>

```typescript
public resetOkActions()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `alarmActions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmActions"></a>

```typescript
public readonly alarmActions: CesAlarmruleAlarmActionsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList)

---

##### `alarmState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmState"></a>

```typescript
public readonly alarmState: string;
```

- *Type:* `string`

---

##### `condition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.condition"></a>

```typescript
public readonly condition: CesAlarmruleConditionOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference`](#@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference)

---

##### `insufficientdataActions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.insufficientdataActions"></a>

```typescript
public readonly insufficientdataActions: CesAlarmruleInsufficientdataActionsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList)

---

##### `metric`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.metric"></a>

```typescript
public readonly metric: CesAlarmruleMetricOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference)

---

##### `okActions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.okActions"></a>

```typescript
public readonly okActions: CesAlarmruleOkActionsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.timeouts"></a>

```typescript
public readonly timeouts: CesAlarmruleTimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference)

---

##### `updateTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.updateTime"></a>

```typescript
public readonly updateTime: number;
```

- *Type:* `number`

---

##### `alarmActionEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmActionEnabledInput"></a>

```typescript
public readonly alarmActionEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `alarmActionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmActionsInput"></a>

```typescript
public readonly alarmActionsInput: IResolvable | CesAlarmruleAlarmActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions)[]

---

##### `alarmDescriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmDescriptionInput"></a>

```typescript
public readonly alarmDescriptionInput: string;
```

- *Type:* `string`

---

##### `alarmEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmEnabledInput"></a>

```typescript
public readonly alarmEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `alarmLevelInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmLevelInput"></a>

```typescript
public readonly alarmLevelInput: number;
```

- *Type:* `number`

---

##### `alarmNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmNameInput"></a>

```typescript
public readonly alarmNameInput: string;
```

- *Type:* `string`

---

##### `conditionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.conditionInput"></a>

```typescript
public readonly conditionInput: CesAlarmruleCondition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleCondition`](#@cdktf/provider-opentelekomcloud.CesAlarmruleCondition)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `insufficientdataActionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.insufficientdataActionsInput"></a>

```typescript
public readonly insufficientdataActionsInput: IResolvable | CesAlarmruleInsufficientdataActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions)[]

---

##### `metricInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.metricInput"></a>

```typescript
public readonly metricInput: CesAlarmruleMetric;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetric`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetric)

---

##### `okActionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.okActionsInput"></a>

```typescript
public readonly okActionsInput: IResolvable | CesAlarmruleOkActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CesAlarmruleTimeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts`](#@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts)

---

##### `alarmActionEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmActionEnabled"></a>

```typescript
public readonly alarmActionEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `alarmDescription`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmDescription"></a>

```typescript
public readonly alarmDescription: string;
```

- *Type:* `string`

---

##### `alarmEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmEnabled"></a>

```typescript
public readonly alarmEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `alarmLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmLevel"></a>

```typescript
public readonly alarmLevel: number;
```

- *Type:* `number`

---

##### `alarmName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.alarmName"></a>

```typescript
public readonly alarmName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CesAlarmrule.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeBmsServerV2 <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2 opentelekomcloud_compute_bms_server_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.Initializer"></a>

```typescript
import { ComputeBmsServerV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2(scope: Construct, id: string, config: ComputeBmsServerV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config)

---

#### Methods <a name="Methods"></a>

##### `putBlockDevice` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.putBlockDevice"></a>

```typescript
public putBlockDevice(value: IResolvable | ComputeBmsServerV2BlockDevice[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice)[]

---

##### `putNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.putNetwork"></a>

```typescript
public putNetwork(value: IResolvable | ComputeBmsServerV2Network[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeBmsServerV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts)

---

##### `resetAdminPass` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetAdminPass"></a>

```typescript
public resetAdminPass()
```

##### `resetBlockDevice` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetBlockDevice"></a>

```typescript
public resetBlockDevice()
```

##### `resetFlavorId` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetFlavorId"></a>

```typescript
public resetFlavorId()
```

##### `resetFlavorName` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetFlavorName"></a>

```typescript
public resetFlavorName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageId` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetImageId"></a>

```typescript
public resetImageId()
```

##### `resetImageName` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetImageName"></a>

```typescript
public resetImageName()
```

##### `resetKeyPair` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetKeyPair"></a>

```typescript
public resetKeyPair()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetMetadata"></a>

```typescript
public resetMetadata()
```

##### `resetNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetNetwork"></a>

```typescript
public resetNetwork()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetSecurityGroups"></a>

```typescript
public resetSecurityGroups()
```

##### `resetStopBeforeDestroy` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetStopBeforeDestroy"></a>

```typescript
public resetStopBeforeDestroy()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetUserData` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.resetUserData"></a>

```typescript
public resetUserData()
```


#### Properties <a name="Properties"></a>

##### `accessIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.accessIpV4"></a>

```typescript
public readonly accessIpV4: string;
```

- *Type:* `string`

---

##### `accessIpV6`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.accessIpV6"></a>

```typescript
public readonly accessIpV6: string;
```

- *Type:* `string`

---

##### `blockDevice`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.blockDevice"></a>

```typescript
public readonly blockDevice: ComputeBmsServerV2BlockDeviceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList)

---

##### `configDrive`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.configDrive"></a>

```typescript
public readonly configDrive: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `hostId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.hostId"></a>

```typescript
public readonly hostId: string;
```

- *Type:* `string`

---

##### `hostStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.hostStatus"></a>

```typescript
public readonly hostStatus: string;
```

- *Type:* `string`

---

##### `kernelId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.kernelId"></a>

```typescript
public readonly kernelId: string;
```

- *Type:* `string`

---

##### `network`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.network"></a>

```typescript
public readonly network: ComputeBmsServerV2NetworkList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList)

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeBmsServerV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference)

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `adminPassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.adminPassInput"></a>

```typescript
public readonly adminPassInput: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `blockDeviceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.blockDeviceInput"></a>

```typescript
public readonly blockDeviceInput: IResolvable | ComputeBmsServerV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice)[]

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `flavorNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.flavorNameInput"></a>

```typescript
public readonly flavorNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `imageNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.imageNameInput"></a>

```typescript
public readonly imageNameInput: string;
```

- *Type:* `string`

---

##### `keyPairInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.keyPairInput"></a>

```typescript
public readonly keyPairInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.networkInput"></a>

```typescript
public readonly networkInput: IResolvable | ComputeBmsServerV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network)[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.securityGroupsInput"></a>

```typescript
public readonly securityGroupsInput: string[];
```

- *Type:* `string`[]

---

##### `stopBeforeDestroyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.stopBeforeDestroyInput"></a>

```typescript
public readonly stopBeforeDestroyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeBmsServerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts)

---

##### `userDataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.userDataInput"></a>

```typescript
public readonly userDataInput: string;
```

- *Type:* `string`

---

##### `adminPass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `flavorName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.flavorName"></a>

```typescript
public readonly flavorName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `imageName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.imageName"></a>

```typescript
public readonly imageName: string;
```

- *Type:* `string`

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

---

##### `stopBeforeDestroy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.stopBeforeDestroy"></a>

```typescript
public readonly stopBeforeDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `userData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeBmsTagsV2 <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2 opentelekomcloud_compute_bms_tags_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.Initializer"></a>

```typescript
import { ComputeBmsTagsV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsTagsV2(scope: Construct, id: string, config: ComputeBmsTagsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeBmsTagsV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeBmsTagsV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: string[];
```

- *Type:* `string`[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeBmsTagsV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeFloatingipAssociateV2 <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2 opentelekomcloud_compute_floatingip_associate_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.Initializer"></a>

```typescript
import { ComputeFloatingipAssociateV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeFloatingipAssociateV2(scope: Construct, id: string, config: ComputeFloatingipAssociateV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config`](#@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetFixedIp` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.resetFixedIp"></a>

```typescript
public resetFixedIp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `fixedIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.fixedIpInput"></a>

```typescript
public readonly fixedIpInput: string;
```

- *Type:* `string`

---

##### `floatingIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.floatingIpInput"></a>

```typescript
public readonly floatingIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

---

##### `floatingIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.floatingIp"></a>

```typescript
public readonly floatingIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeFloatingipV2 <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_v2 opentelekomcloud_compute_floatingip_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.Initializer"></a>

```typescript
import { ComputeFloatingipV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeFloatingipV2(scope: Construct, id: string, config?: ComputeFloatingipV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config`](#@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPool` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.resetPool"></a>

```typescript
public resetPool()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `poolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.poolInput"></a>

```typescript
public readonly poolInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `pool`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeInstanceV2 <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2 opentelekomcloud_compute_instance_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.Initializer"></a>

```typescript
import { ComputeInstanceV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2(scope: Construct, id: string, config: ComputeInstanceV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config)

---

#### Methods <a name="Methods"></a>

##### `putBlockDevice` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.putBlockDevice"></a>

```typescript
public putBlockDevice(value: IResolvable | ComputeInstanceV2BlockDevice[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice)[]

---

##### `putNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.putNetwork"></a>

```typescript
public putNetwork(value: IResolvable | ComputeInstanceV2Network[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network)[]

---

##### `putSchedulerHints` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.putSchedulerHints"></a>

```typescript
public putSchedulerHints(value: IResolvable | ComputeInstanceV2SchedulerHints[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeInstanceV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts)

---

##### `resetAccessIpV4` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetAccessIpV4"></a>

```typescript
public resetAccessIpV4()
```

##### `resetAccessIpV6` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetAccessIpV6"></a>

```typescript
public resetAccessIpV6()
```

##### `resetAdminPass` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetAdminPass"></a>

```typescript
public resetAdminPass()
```

##### `resetAutoRecovery` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetAutoRecovery"></a>

```typescript
public resetAutoRecovery()
```

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetBlockDevice` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetBlockDevice"></a>

```typescript
public resetBlockDevice()
```

##### `resetConfigDrive` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetConfigDrive"></a>

```typescript
public resetConfigDrive()
```

##### `resetFlavorId` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetFlavorId"></a>

```typescript
public resetFlavorId()
```

##### `resetFlavorName` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetFlavorName"></a>

```typescript
public resetFlavorName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageId` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetImageId"></a>

```typescript
public resetImageId()
```

##### `resetImageName` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetImageName"></a>

```typescript
public resetImageName()
```

##### `resetKeyPair` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetKeyPair"></a>

```typescript
public resetKeyPair()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetMetadata"></a>

```typescript
public resetMetadata()
```

##### `resetNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetNetwork"></a>

```typescript
public resetNetwork()
```

##### `resetPowerState` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetPowerState"></a>

```typescript
public resetPowerState()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSchedulerHints` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetSchedulerHints"></a>

```typescript
public resetSchedulerHints()
```

##### `resetSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetSecurityGroups"></a>

```typescript
public resetSecurityGroups()
```

##### `resetStopBeforeDestroy` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetStopBeforeDestroy"></a>

```typescript
public resetStopBeforeDestroy()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetUserData` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.resetUserData"></a>

```typescript
public resetUserData()
```


#### Properties <a name="Properties"></a>

##### `allMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.allMetadata"></a>

```typescript
public readonly allMetadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `blockDevice`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.blockDevice"></a>

```typescript
public readonly blockDevice: ComputeInstanceV2BlockDeviceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList)

---

##### `network`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.network"></a>

```typescript
public readonly network: ComputeInstanceV2NetworkList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList)

---

##### `schedulerHints`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.schedulerHints"></a>

```typescript
public readonly schedulerHints: ComputeInstanceV2SchedulerHintsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference)

---

##### `volumeAttached`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.volumeAttached"></a>

```typescript
public readonly volumeAttached: ComputeInstanceV2VolumeAttachedList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList)

---

##### `accessIpV4Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.accessIpV4Input"></a>

```typescript
public readonly accessIpV4Input: string;
```

- *Type:* `string`

---

##### `accessIpV6Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.accessIpV6Input"></a>

```typescript
public readonly accessIpV6Input: string;
```

- *Type:* `string`

---

##### `adminPassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.adminPassInput"></a>

```typescript
public readonly adminPassInput: string;
```

- *Type:* `string`

---

##### `autoRecoveryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.autoRecoveryInput"></a>

```typescript
public readonly autoRecoveryInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `blockDeviceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.blockDeviceInput"></a>

```typescript
public readonly blockDeviceInput: IResolvable | ComputeInstanceV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice)[]

---

##### `configDriveInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.configDriveInput"></a>

```typescript
public readonly configDriveInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `flavorNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.flavorNameInput"></a>

```typescript
public readonly flavorNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `imageNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.imageNameInput"></a>

```typescript
public readonly imageNameInput: string;
```

- *Type:* `string`

---

##### `keyPairInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.keyPairInput"></a>

```typescript
public readonly keyPairInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.networkInput"></a>

```typescript
public readonly networkInput: IResolvable | ComputeInstanceV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network)[]

---

##### `powerStateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.powerStateInput"></a>

```typescript
public readonly powerStateInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `schedulerHintsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.schedulerHintsInput"></a>

```typescript
public readonly schedulerHintsInput: IResolvable | ComputeInstanceV2SchedulerHints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints)[]

---

##### `securityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.securityGroupsInput"></a>

```typescript
public readonly securityGroupsInput: string[];
```

- *Type:* `string`[]

---

##### `stopBeforeDestroyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.stopBeforeDestroyInput"></a>

```typescript
public readonly stopBeforeDestroyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeInstanceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts)

---

##### `userDataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.userDataInput"></a>

```typescript
public readonly userDataInput: string;
```

- *Type:* `string`

---

##### `accessIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.accessIpV4"></a>

```typescript
public readonly accessIpV4: string;
```

- *Type:* `string`

---

##### `accessIpV6`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.accessIpV6"></a>

```typescript
public readonly accessIpV6: string;
```

- *Type:* `string`

---

##### `adminPass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

---

##### `autoRecovery`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.autoRecovery"></a>

```typescript
public readonly autoRecovery: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `configDrive`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.configDrive"></a>

```typescript
public readonly configDrive: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `flavorName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.flavorName"></a>

```typescript
public readonly flavorName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `imageName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.imageName"></a>

```typescript
public readonly imageName: string;
```

- *Type:* `string`

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `powerState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.powerState"></a>

```typescript
public readonly powerState: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

---

##### `stopBeforeDestroy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.stopBeforeDestroy"></a>

```typescript
public readonly stopBeforeDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `userData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeKeypairV2 <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2 opentelekomcloud_compute_keypair_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.Initializer"></a>

```typescript
import { ComputeKeypairV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeKeypairV2(scope: Construct, id: string, config: ComputeKeypairV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config`](#@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPublicKey` <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.resetPublicKey"></a>

```typescript
public resetPublicKey()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.shared"></a>

```typescript
public readonly shared: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `publicKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.publicKeyInput"></a>

```typescript
public readonly publicKeyInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `publicKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeSecgroupV2 <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2 opentelekomcloud_compute_secgroup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.Initializer"></a>

```typescript
import { ComputeSecgroupV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeSecgroupV2(scope: Construct, id: string, config: ComputeSecgroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `putRule` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.putRule"></a>

```typescript
public putRule(value: IResolvable | ComputeSecgroupV2Rule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeSecgroupV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRule` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.resetRule"></a>

```typescript
public resetRule()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `rule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.rule"></a>

```typescript
public readonly rule: ComputeSecgroupV2RuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeSecgroupV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `ruleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.ruleInput"></a>

```typescript
public readonly ruleInput: IResolvable | ComputeSecgroupV2Rule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeSecgroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeServergroupV2 <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2 opentelekomcloud_compute_servergroup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.Initializer"></a>

```typescript
import { ComputeServergroupV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeServergroupV2(scope: Construct, id: string, config: ComputeServergroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config`](#@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPolicies` <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.resetPolicies"></a>

```typescript
public resetPolicies()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `members`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `policiesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.policiesInput"></a>

```typescript
public readonly policiesInput: string[];
```

- *Type:* `string`[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `policies`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.policies"></a>

```typescript
public readonly policies: string[];
```

- *Type:* `string`[]

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ComputeVolumeAttachV2 <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2 opentelekomcloud_compute_volume_attach_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.Initializer"></a>

```typescript
import { ComputeVolumeAttachV2 } from '@cdktf/provider-opentelekomcloud'

new ComputeVolumeAttachV2(scope: Construct, id: string, config: ComputeVolumeAttachV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeVolumeAttachV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts)

---

##### `resetDevice` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.resetDevice"></a>

```typescript
public resetDevice()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeVolumeAttachV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference)

---

##### `deviceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.deviceInput"></a>

```typescript
public readonly deviceInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeVolumeAttachV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts)

---

##### `volumeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.volumeIdInput"></a>

```typescript
public readonly volumeIdInput: string;
```

- *Type:* `string`

---

##### `device`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2.property.tfResourceType"></a>

- *Type:* `string`

---

### CsbsBackupPolicyV1 <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1 opentelekomcloud_csbs_backup_policy_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1 } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1(scope: Construct, id: string, config: CsbsBackupPolicyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config)

---

#### Methods <a name="Methods"></a>

##### `putResource` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.putResource"></a>

```typescript
public putResource(value: IResolvable | CsbsBackupPolicyV1Resource[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource)[]

---

##### `putScheduledOperation` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.putScheduledOperation"></a>

```typescript
public putScheduledOperation(value: CsbsBackupPolicyV1ScheduledOperation)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation)

---

##### `putTags` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.putTags"></a>

```typescript
public putTags(value: IResolvable | CsbsBackupPolicyV1Tags[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.putTimeouts"></a>

```typescript
public putTimeouts(value: CsbsBackupPolicyV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts)

---

##### `resetCommon` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetCommon"></a>

```typescript
public resetCommon()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetProviderId` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetProviderId"></a>

```typescript
public resetProviderId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `resource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.resource"></a>

```typescript
public readonly resource: CsbsBackupPolicyV1ResourceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList)

---

##### `scheduledOperation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.scheduledOperation"></a>

```typescript
public readonly scheduledOperation: CsbsBackupPolicyV1ScheduledOperationOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.tags"></a>

```typescript
public readonly tags: CsbsBackupPolicyV1TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.timeouts"></a>

```typescript
public readonly timeouts: CsbsBackupPolicyV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference)

---

##### `commonInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.commonInput"></a>

```typescript
public readonly commonInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `providerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.providerIdInput"></a>

```typescript
public readonly providerIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `resourceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.resourceInput"></a>

```typescript
public readonly resourceInput: IResolvable | CsbsBackupPolicyV1Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource)[]

---

##### `scheduledOperationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.scheduledOperationInput"></a>

```typescript
public readonly scheduledOperationInput: CsbsBackupPolicyV1ScheduledOperation;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: IResolvable | CsbsBackupPolicyV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CsbsBackupPolicyV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts)

---

##### `common`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.common"></a>

```typescript
public readonly common: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `providerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### CsbsBackupV1 <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1 opentelekomcloud_csbs_backup_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.Initializer"></a>

```typescript
import { CsbsBackupV1 } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1(scope: Construct, id: string, config: CsbsBackupV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Config`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTags` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.putTags"></a>

```typescript
public putTags(value: IResolvable | CsbsBackupV1Tags[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.putTimeouts"></a>

```typescript
public putTimeouts(value: CsbsBackupV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts)

---

##### `resetBackupName` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetBackupName"></a>

```typescript
public resetBackupName()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetResourceType` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetResourceType"></a>

```typescript
public resetResourceType()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `backupRecordId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.backupRecordId"></a>

```typescript
public readonly backupRecordId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.tags"></a>

```typescript
public readonly tags: CsbsBackupV1TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.timeouts"></a>

```typescript
public readonly timeouts: CsbsBackupV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference)

---

##### `vmMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.vmMetadata"></a>

```typescript
public readonly vmMetadata: CsbsBackupV1VmMetadataList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList)

---

##### `volumeBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.volumeBackups"></a>

```typescript
public readonly volumeBackups: CsbsBackupV1VolumeBackupsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList)

---

##### `backupNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.backupNameInput"></a>

```typescript
public readonly backupNameInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `resourceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.resourceIdInput"></a>

```typescript
public readonly resourceIdInput: string;
```

- *Type:* `string`

---

##### `resourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.resourceTypeInput"></a>

```typescript
public readonly resourceTypeInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: IResolvable | CsbsBackupV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CsbsBackupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts)

---

##### `backupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.backupName"></a>

```typescript
public readonly backupName: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `resourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1.property.tfResourceType"></a>

- *Type:* `string`

---

### CssClusterV1 <a name="@cdktf/provider-opentelekomcloud.CssClusterV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1 opentelekomcloud_css_cluster_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.Initializer"></a>

```typescript
import { CssClusterV1 } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1(scope: Construct, id: string, config: CssClusterV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Config`](#@cdktf/provider-opentelekomcloud.CssClusterV1Config)

---

#### Methods <a name="Methods"></a>

##### `putDatastore` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.putDatastore"></a>

```typescript
public putDatastore(value: CssClusterV1Datastore)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Datastore`](#@cdktf/provider-opentelekomcloud.CssClusterV1Datastore)

---

##### `putNodeConfig` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.putNodeConfig"></a>

```typescript
public putNodeConfig(value: CssClusterV1NodeConfig)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.putTimeouts"></a>

```typescript
public putTimeouts(value: CssClusterV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts)

---

##### `resetAdminPass` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetAdminPass"></a>

```typescript
public resetAdminPass()
```

##### `resetDatastore` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetDatastore"></a>

```typescript
public resetDatastore()
```

##### `resetEnableAuthority` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetEnableAuthority"></a>

```typescript
public resetEnableAuthority()
```

##### `resetEnableHttps` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetEnableHttps"></a>

```typescript
public resetEnableHttps()
```

##### `resetExpectNodeNum` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetExpectNodeNum"></a>

```typescript
public resetExpectNodeNum()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.datastore"></a>

```typescript
public readonly datastore: CssClusterV1DatastoreOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference`](#@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference)

---

##### `endpoint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* `string`

---

##### `nodeConfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.nodeConfig"></a>

```typescript
public readonly nodeConfig: CssClusterV1NodeConfigOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference)

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.nodes"></a>

```typescript
public readonly nodes: CssClusterV1NodesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodesList`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodesList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.timeouts"></a>

```typescript
public readonly timeouts: CssClusterV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference)

---

##### `updated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.updated"></a>

```typescript
public readonly updated: string;
```

- *Type:* `string`

---

##### `adminPassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.adminPassInput"></a>

```typescript
public readonly adminPassInput: string;
```

- *Type:* `string`

---

##### `datastoreInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.datastoreInput"></a>

```typescript
public readonly datastoreInput: CssClusterV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Datastore`](#@cdktf/provider-opentelekomcloud.CssClusterV1Datastore)

---

##### `enableAuthorityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.enableAuthorityInput"></a>

```typescript
public readonly enableAuthorityInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableHttpsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.enableHttpsInput"></a>

```typescript
public readonly enableHttpsInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `expectNodeNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.expectNodeNumInput"></a>

```typescript
public readonly expectNodeNumInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nodeConfigInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.nodeConfigInput"></a>

```typescript
public readonly nodeConfigInput: CssClusterV1NodeConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CssClusterV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts)

---

##### `adminPass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

---

##### `enableAuthority`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.enableAuthority"></a>

```typescript
public readonly enableAuthority: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableHttps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.enableHttps"></a>

```typescript
public readonly enableHttps: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `expectNodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.expectNodeNum"></a>

```typescript
public readonly expectNodeNum: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1.property.tfResourceType"></a>

- *Type:* `string`

---

### CssSnapshotConfigurationV1 <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1 opentelekomcloud_css_snapshot_configuration_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1 } from '@cdktf/provider-opentelekomcloud'

new CssSnapshotConfigurationV1(scope: Construct, id: string, config: CssSnapshotConfigurationV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config)

---

#### Methods <a name="Methods"></a>

##### `putConfiguration` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.putConfiguration"></a>

```typescript
public putConfiguration(value: CssSnapshotConfigurationV1Configuration)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration)

---

##### `putCreationPolicy` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.putCreationPolicy"></a>

```typescript
public putCreationPolicy(value: CssSnapshotConfigurationV1CreationPolicy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.putTimeouts"></a>

```typescript
public putTimeouts(value: CssSnapshotConfigurationV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts)

---

##### `resetAutomatic` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.resetAutomatic"></a>

```typescript
public resetAutomatic()
```

##### `resetConfiguration` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.resetConfiguration"></a>

```typescript
public resetConfiguration()
```

##### `resetCreationPolicy` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.resetCreationPolicy"></a>

```typescript
public resetCreationPolicy()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `basePath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.basePath"></a>

```typescript
public readonly basePath: string;
```

- *Type:* `string`

---

##### `configuration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.configuration"></a>

```typescript
public readonly configuration: CssSnapshotConfigurationV1ConfigurationOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference)

---

##### `creationPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.creationPolicy"></a>

```typescript
public readonly creationPolicy: CssSnapshotConfigurationV1CreationPolicyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.timeouts"></a>

```typescript
public readonly timeouts: CssSnapshotConfigurationV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference)

---

##### `automaticInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.automaticInput"></a>

```typescript
public readonly automaticInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `configurationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.configurationInput"></a>

```typescript
public readonly configurationInput: CssSnapshotConfigurationV1Configuration;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration)

---

##### `creationPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.creationPolicyInput"></a>

```typescript
public readonly creationPolicyInput: CssSnapshotConfigurationV1CreationPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CssSnapshotConfigurationV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts)

---

##### `automatic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.automatic"></a>

```typescript
public readonly automatic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1.property.tfResourceType"></a>

- *Type:* `string`

---

### CtsTrackerV1 <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1 opentelekomcloud_cts_tracker_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.Initializer"></a>

```typescript
import { CtsTrackerV1 } from '@cdktf/provider-opentelekomcloud'

new CtsTrackerV1(scope: Construct, id: string, config: CtsTrackerV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CtsTrackerV1Config`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.putTimeouts"></a>

```typescript
public putTimeouts(value: CtsTrackerV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts)

---

##### `resetFilePrefixName` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetFilePrefixName"></a>

```typescript
public resetFilePrefixName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetId"></a>

```typescript
public resetId()
```

##### `resetIsSendAllKeyOperation` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetIsSendAllKeyOperation"></a>

```typescript
public resetIsSendAllKeyOperation()
```

##### `resetNeedNotifyUserList` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetNeedNotifyUserList"></a>

```typescript
public resetNeedNotifyUserList()
```

##### `resetOperations` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetOperations"></a>

```typescript
public resetOperations()
```

##### `resetProjectName` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetProjectName"></a>

```typescript
public resetProjectName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTopicId` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.resetTopicId"></a>

```typescript
public resetTopicId()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.timeouts"></a>

```typescript
public readonly timeouts: CtsTrackerV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference)

---

##### `trackerName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.trackerName"></a>

```typescript
public readonly trackerName: string;
```

- *Type:* `string`

---

##### `bucketNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.bucketNameInput"></a>

```typescript
public readonly bucketNameInput: string;
```

- *Type:* `string`

---

##### `filePrefixNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.filePrefixNameInput"></a>

```typescript
public readonly filePrefixNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `isSendAllKeyOperationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.isSendAllKeyOperationInput"></a>

```typescript
public readonly isSendAllKeyOperationInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isSupportSmnInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.isSupportSmnInput"></a>

```typescript
public readonly isSupportSmnInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `needNotifyUserListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.needNotifyUserListInput"></a>

```typescript
public readonly needNotifyUserListInput: string[];
```

- *Type:* `string`[]

---

##### `operationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.operationsInput"></a>

```typescript
public readonly operationsInput: string[];
```

- *Type:* `string`[]

---

##### `projectNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.projectNameInput"></a>

```typescript
public readonly projectNameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CtsTrackerV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts)

---

##### `topicIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.topicIdInput"></a>

```typescript
public readonly topicIdInput: string;
```

- *Type:* `string`

---

##### `bucketName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* `string`

---

##### `filePrefixName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.filePrefixName"></a>

```typescript
public readonly filePrefixName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `isSendAllKeyOperation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.isSendAllKeyOperation"></a>

```typescript
public readonly isSendAllKeyOperation: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isSupportSmn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.isSupportSmn"></a>

```typescript
public readonly isSupportSmn: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `needNotifyUserList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.needNotifyUserList"></a>

```typescript
public readonly needNotifyUserList: string[];
```

- *Type:* `string`[]

---

##### `operations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* `string`[]

---

##### `projectName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `topicId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.topicId"></a>

```typescript
public readonly topicId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudAntiddosV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1 opentelekomcloud_antiddos_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudAntiddosV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudAntiddosV1(scope: Construct, id: string, config?: DataOpentelekomcloudAntiddosV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetFloatingIpAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.resetFloatingIpAddress"></a>

```typescript
public resetFloatingIpAddress()
```

##### `resetFloatingIpId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.resetFloatingIpId"></a>

```typescript
public resetFloatingIpId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `bpsAttack`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.bpsAttack"></a>

```typescript
public readonly bpsAttack: number[];
```

- *Type:* `number`[]

---

##### `bpsIn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.bpsIn"></a>

```typescript
public readonly bpsIn: number[];
```

- *Type:* `number`[]

---

##### `endTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.endTime"></a>

```typescript
public readonly endTime: number[];
```

- *Type:* `number`[]

---

##### `networkType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.networkType"></a>

```typescript
public readonly networkType: string;
```

- *Type:* `string`

---

##### `periodStart`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.periodStart"></a>

```typescript
public readonly periodStart: number[];
```

- *Type:* `number`[]

---

##### `ppsAttack`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.ppsAttack"></a>

```typescript
public readonly ppsAttack: number[];
```

- *Type:* `number`[]

---

##### `ppsIn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.ppsIn"></a>

```typescript
public readonly ppsIn: number[];
```

- *Type:* `number`[]

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.startTime"></a>

```typescript
public readonly startTime: number[];
```

- *Type:* `number`[]

---

##### `totalBps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.totalBps"></a>

```typescript
public readonly totalBps: number[];
```

- *Type:* `number`[]

---

##### `totalPps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.totalPps"></a>

```typescript
public readonly totalPps: number[];
```

- *Type:* `number`[]

---

##### `trafficCleaningStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.trafficCleaningStatus"></a>

```typescript
public readonly trafficCleaningStatus: number[];
```

- *Type:* `number`[]

---

##### `triggerBps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.triggerBps"></a>

```typescript
public readonly triggerBps: number[];
```

- *Type:* `number`[]

---

##### `triggerHttpPps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.triggerHttpPps"></a>

```typescript
public readonly triggerHttpPps: number[];
```

- *Type:* `number`[]

---

##### `triggerPps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.triggerPps"></a>

```typescript
public readonly triggerPps: number[];
```

- *Type:* `number`[]

---

##### `floatingIpAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.floatingIpAddressInput"></a>

```typescript
public readonly floatingIpAddressInput: string;
```

- *Type:* `string`

---

##### `floatingIpIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.floatingIpIdInput"></a>

```typescript
public readonly floatingIpIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `floatingIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.floatingIpAddress"></a>

```typescript
public readonly floatingIpAddress: string;
```

- *Type:* `string`

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCceClusterKubeconfigV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_kubeconfig_v3 opentelekomcloud_cce_cluster_kubeconfig_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterKubeconfigV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterKubeconfigV3(scope: Construct, id: string, config: DataOpentelekomcloudCceClusterKubeconfigV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDuration` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.resetDuration"></a>

```typescript
public resetDuration()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `kubeconfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.kubeconfig"></a>

```typescript
public readonly kubeconfig: string;
```

- *Type:* `string`

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `durationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.durationInput"></a>

```typescript
public readonly durationInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `duration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.duration"></a>

```typescript
public readonly duration: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCceClusterV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3 opentelekomcloud_cce_cluster_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterV3(scope: Construct, id: string, config?: DataOpentelekomcloudCceClusterV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetClusterType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetClusterType"></a>

```typescript
public resetClusterType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `authenticationMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.authenticationMode"></a>

```typescript
public readonly authenticationMode: string;
```

- *Type:* `string`

---

##### `billingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

---

##### `certificateClusters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.certificateClusters"></a>

```typescript
public readonly certificateClusters: DataOpentelekomcloudCceClusterV3CertificateClustersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList)

---

##### `certificateUsers`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.certificateUsers"></a>

```typescript
public readonly certificateUsers: DataOpentelekomcloudCceClusterV3CertificateUsersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList)

---

##### `clusterVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.clusterVersion"></a>

```typescript
public readonly clusterVersion: string;
```

- *Type:* `string`

---

##### `containerNetworkCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.containerNetworkCidr"></a>

```typescript
public readonly containerNetworkCidr: string;
```

- *Type:* `string`

---

##### `containerNetworkType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.containerNetworkType"></a>

```typescript
public readonly containerNetworkType: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `eniSubnetCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.eniSubnetCidr"></a>

```typescript
public readonly eniSubnetCidr: string;
```

- *Type:* `string`

---

##### `eniSubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.eniSubnetId"></a>

```typescript
public readonly eniSubnetId: string;
```

- *Type:* `string`

---

##### `external`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.external"></a>

```typescript
public readonly external: string;
```

- *Type:* `string`

---

##### `externalOtc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.externalOtc"></a>

```typescript
public readonly externalOtc: string;
```

- *Type:* `string`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `highwaySubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.highwaySubnetId"></a>

```typescript
public readonly highwaySubnetId: string;
```

- *Type:* `string`

---

##### `internal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.internal"></a>

```typescript
public readonly internal: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `clusterTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.clusterTypeInput"></a>

```typescript
public readonly clusterTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `clusterType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.clusterType"></a>

```typescript
public readonly clusterType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCceNodeIdsV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_ids_v3 opentelekomcloud_cce_node_ids_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeIdsV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceNodeIdsV3(scope: Construct, id: string, config: DataOpentelekomcloudCceNodeIdsV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `ids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.ids"></a>

```typescript
public readonly ids: string[];
```

- *Type:* `string`[]

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCceNodeV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3 opentelekomcloud_cce_node_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceNodeV3(scope: Construct, id: string, config: DataOpentelekomcloudCceNodeV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.resetName"></a>

```typescript
public resetName()
```

##### `resetNodeId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.resetNodeId"></a>

```typescript
public resetNodeId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `bandwidthSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

---

##### `billingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

---

##### `chargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.chargeMode"></a>

```typescript
public readonly chargeMode: string;
```

- *Type:* `string`

---

##### `dataVolumes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.dataVolumes"></a>

```typescript
public readonly dataVolumes: DataOpentelekomcloudCceNodeV3DataVolumesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList)

---

##### `diskSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* `number`

---

##### `eipCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.eipCount"></a>

```typescript
public readonly eipCount: number;
```

- *Type:* `number`

---

##### `eipIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.eipIds"></a>

```typescript
public readonly eipIds: string[];
```

- *Type:* `string`[]

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `ipType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.publicIp"></a>

```typescript
public readonly publicIp: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nodeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.nodeIdInput"></a>

```typescript
public readonly nodeIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `nodeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.nodeId"></a>

```typescript
public readonly nodeId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeAvailabilityZonesV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_availability_zones_v2 opentelekomcloud_compute_availability_zones_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeAvailabilityZonesV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeAvailabilityZonesV2(scope: Construct, id: string, config?: DataOpentelekomcloudComputeAvailabilityZonesV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetState` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.resetState"></a>

```typescript
public resetState()
```


#### Properties <a name="Properties"></a>

##### `names`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.names"></a>

```typescript
public readonly names: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `stateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.stateInput"></a>

```typescript
public readonly stateInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `state`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.state"></a>

```typescript
public readonly state: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeBmsFlavorsV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2 opentelekomcloud_compute_bms_flavors_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsFlavorsV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsFlavorsV2(scope: Construct, id: string, config?: DataOpentelekomcloudComputeBmsFlavorsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMinDisk` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetMinDisk"></a>

```typescript
public resetMinDisk()
```

##### `resetMinRam` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetMinRam"></a>

```typescript
public resetMinRam()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSortDir` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetSortDir"></a>

```typescript
public resetSortDir()
```

##### `resetSortKey` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.resetSortKey"></a>

```typescript
public resetSortKey()
```


#### Properties <a name="Properties"></a>

##### `disk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.disk"></a>

```typescript
public readonly disk: number;
```

- *Type:* `number`

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `rxTxFactor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.rxTxFactor"></a>

```typescript
public readonly rxTxFactor: number;
```

- *Type:* `number`

---

##### `swap`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.swap"></a>

```typescript
public readonly swap: number;
```

- *Type:* `number`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `minDiskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.minDiskInput"></a>

```typescript
public readonly minDiskInput: number;
```

- *Type:* `number`

---

##### `minRamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.minRamInput"></a>

```typescript
public readonly minRamInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sortDirInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.sortDirInput"></a>

```typescript
public readonly sortDirInput: string;
```

- *Type:* `string`

---

##### `sortKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.sortKeyInput"></a>

```typescript
public readonly sortKeyInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `minDisk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

---

##### `minRam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sortDir`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.sortDir"></a>

```typescript
public readonly sortDir: string;
```

- *Type:* `string`

---

##### `sortKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.sortKey"></a>

```typescript
public readonly sortKey: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeBmsKeypairsV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_keypairs_v2 opentelekomcloud_compute_bms_keypairs_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsKeypairsV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsKeypairsV2(scope: Construct, id: string, config: DataOpentelekomcloudComputeBmsKeypairsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `fingerprint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.fingerprint"></a>

```typescript
public readonly fingerprint: string;
```

- *Type:* `string`

---

##### `publicKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeBmsNicV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_nic_v2 opentelekomcloud_compute_bms_nic_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsNicV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsNicV2(scope: Construct, id: string, config: DataOpentelekomcloudComputeBmsNicV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `fixedIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.fixedIps"></a>

```typescript
public readonly fixedIps: DataOpentelekomcloudComputeBmsNicV2FixedIpsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList)

---

##### `macAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeBmsServerV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2 opentelekomcloud_compute_bms_server_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsServerV2(scope: Construct, id: string, config?: DataOpentelekomcloudComputeBmsServerV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetFlavorId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetFlavorId"></a>

```typescript
public resetFlavorId()
```

##### `resetHostStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetHostStatus"></a>

```typescript
public resetHostStatus()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetImageId"></a>

```typescript
public resetImageId()
```

##### `resetKeyName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetKeyName"></a>

```typescript
public resetKeyName()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetUserId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.resetUserId"></a>

```typescript
public resetUserId()
```


#### Properties <a name="Properties"></a>

##### `accessIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.accessIpV4"></a>

```typescript
public readonly accessIpV4: string;
```

- *Type:* `string`

---

##### `accessIpV6`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.accessIpV6"></a>

```typescript
public readonly accessIpV6: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `configDrive`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.configDrive"></a>

```typescript
public readonly configDrive: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `hostId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.hostId"></a>

```typescript
public readonly hostId: string;
```

- *Type:* `string`

---

##### `hypervisorHostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.hypervisorHostname"></a>

```typescript
public readonly hypervisorHostname: string;
```

- *Type:* `string`

---

##### `instanceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.instanceName"></a>

```typescript
public readonly instanceName: string;
```

- *Type:* `string`

---

##### `kernelId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.kernelId"></a>

```typescript
public readonly kernelId: string;
```

- *Type:* `string`

---

##### `locked`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.locked"></a>

```typescript
public readonly locked: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `network`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.network"></a>

```typescript
public readonly network: DataOpentelekomcloudComputeBmsServerV2NetworkList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList)

---

##### `progress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.progress"></a>

```typescript
public readonly progress: number;
```

- *Type:* `number`

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.securityGroups"></a>

```typescript
public readonly securityGroups: DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `hostStatusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.hostStatusInput"></a>

```typescript
public readonly hostStatusInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `keyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.keyNameInput"></a>

```typescript
public readonly keyNameInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `hostStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.hostStatus"></a>

```typescript
public readonly hostStatus: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `keyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudComputeFlavorV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2 opentelekomcloud_compute_flavor_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeFlavorV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeFlavorV2(scope: Construct, id: string, config?: DataOpentelekomcloudComputeFlavorV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetDisk` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetDisk"></a>

```typescript
public resetDisk()
```

##### `resetFlavorId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetFlavorId"></a>

```typescript
public resetFlavorId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMinDisk` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetMinDisk"></a>

```typescript
public resetMinDisk()
```

##### `resetMinRam` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetMinRam"></a>

```typescript
public resetMinRam()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRam` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetRam"></a>

```typescript
public resetRam()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetResourceType"></a>

```typescript
public resetResourceType()
```

##### `resetRxTxFactor` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetRxTxFactor"></a>

```typescript
public resetRxTxFactor()
```

##### `resetSwap` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetSwap"></a>

```typescript
public resetSwap()
```

##### `resetVcpus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.resetVcpus"></a>

```typescript
public resetVcpus()
```


#### Properties <a name="Properties"></a>

##### `extraSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.extraSpecs"></a>

```typescript
public readonly extraSpecs: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `diskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.diskInput"></a>

```typescript
public readonly diskInput: number;
```

- *Type:* `number`

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `minDiskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.minDiskInput"></a>

```typescript
public readonly minDiskInput: number;
```

- *Type:* `number`

---

##### `minRamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.minRamInput"></a>

```typescript
public readonly minRamInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `ramInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.ramInput"></a>

```typescript
public readonly ramInput: number;
```

- *Type:* `number`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `resourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.resourceTypeInput"></a>

```typescript
public readonly resourceTypeInput: string;
```

- *Type:* `string`

---

##### `rxTxFactorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.rxTxFactorInput"></a>

```typescript
public readonly rxTxFactorInput: number;
```

- *Type:* `number`

---

##### `swapInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.swapInput"></a>

```typescript
public readonly swapInput: number;
```

- *Type:* `number`

---

##### `vcpusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.vcpusInput"></a>

```typescript
public readonly vcpusInput: number;
```

- *Type:* `number`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `disk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.disk"></a>

```typescript
public readonly disk: number;
```

- *Type:* `number`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `minDisk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

---

##### `minRam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

---

##### `rxTxFactor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.rxTxFactor"></a>

```typescript
public readonly rxTxFactor: number;
```

- *Type:* `number`

---

##### `swap`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.swap"></a>

```typescript
public readonly swap: number;
```

- *Type:* `number`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCsbsBackupPolicyV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_policy_v1 opentelekomcloud_csbs_backup_policy_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1(scope: Construct, id: string, config?: DataOpentelekomcloudCsbsBackupPolicyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `common`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.common"></a>

```typescript
public readonly common: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `providerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

---

##### `resource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.resource"></a>

```typescript
public readonly resource: DataOpentelekomcloudCsbsBackupPolicyV1ResourceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList)

---

##### `scheduledOperation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.scheduledOperation"></a>

```typescript
public readonly scheduledOperation: DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.tags"></a>

```typescript
public readonly tags: DataOpentelekomcloudCsbsBackupPolicyV1TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCsbsBackupV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1 opentelekomcloud_csbs_backup_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1(scope: Construct, id: string, config?: DataOpentelekomcloudCsbsBackupV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBackupName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetBackupName"></a>

```typescript
public resetBackupName()
```

##### `resetBackupRecordId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetBackupRecordId"></a>

```typescript
public resetBackupRecordId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPolicyId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetPolicyId"></a>

```typescript
public resetPolicyId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetResourceId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetResourceId"></a>

```typescript
public resetResourceId()
```

##### `resetResourceName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetResourceName"></a>

```typescript
public resetResourceName()
```

##### `resetResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetResourceType"></a>

```typescript
public resetResourceType()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetVmIp` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.resetVmIp"></a>

```typescript
public resetVmIp()
```


#### Properties <a name="Properties"></a>

##### `autoTrigger`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.autoTrigger"></a>

```typescript
public readonly autoTrigger: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `averageSpeed`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.averageSpeed"></a>

```typescript
public readonly averageSpeed: number;
```

- *Type:* `number`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.tags"></a>

```typescript
public readonly tags: DataOpentelekomcloudCsbsBackupV1TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList)

---

##### `vmMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.vmMetadata"></a>

```typescript
public readonly vmMetadata: DataOpentelekomcloudCsbsBackupV1VmMetadataList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList)

---

##### `volumeBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.volumeBackups"></a>

```typescript
public readonly volumeBackups: DataOpentelekomcloudCsbsBackupV1VolumeBackupsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList)

---

##### `backupNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.backupNameInput"></a>

```typescript
public readonly backupNameInput: string;
```

- *Type:* `string`

---

##### `backupRecordIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.backupRecordIdInput"></a>

```typescript
public readonly backupRecordIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `resourceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceIdInput"></a>

```typescript
public readonly resourceIdInput: string;
```

- *Type:* `string`

---

##### `resourceNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceNameInput"></a>

```typescript
public readonly resourceNameInput: string;
```

- *Type:* `string`

---

##### `resourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceTypeInput"></a>

```typescript
public readonly resourceTypeInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `vmIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.vmIpInput"></a>

```typescript
public readonly vmIpInput: string;
```

- *Type:* `string`

---

##### `backupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.backupName"></a>

```typescript
public readonly backupName: string;
```

- *Type:* `string`

---

##### `backupRecordId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.backupRecordId"></a>

```typescript
public readonly backupRecordId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `resourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

---

##### `resourceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* `string`

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `vmIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.vmIp"></a>

```typescript
public readonly vmIp: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCssFlavorV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1 opentelekomcloud_css_flavor_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudCssFlavorV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCssFlavorV1(scope: Construct, id: string, config?: DataOpentelekomcloudCssFlavorV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config)

---

#### Methods <a name="Methods"></a>

##### `putDiskRange` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.putDiskRange"></a>

```typescript
public putDiskRange(value: DataOpentelekomcloudCssFlavorV1DiskRange)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange)

---

##### `resetDiskRange` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetDiskRange"></a>

```typescript
public resetDiskRange()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetId"></a>

```typescript
public resetId()
```

##### `resetMinCpu` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetMinCpu"></a>

```typescript
public resetMinCpu()
```

##### `resetMinRam` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetMinRam"></a>

```typescript
public resetMinRam()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetName"></a>

```typescript
public resetName()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetType"></a>

```typescript
public resetType()
```

##### `resetVersion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.resetVersion"></a>

```typescript
public resetVersion()
```


#### Properties <a name="Properties"></a>

##### `cpu`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.cpu"></a>

```typescript
public readonly cpu: number;
```

- *Type:* `number`

---

##### `diskRange`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.diskRange"></a>

```typescript
public readonly diskRange: DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference)

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `diskRangeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.diskRangeInput"></a>

```typescript
public readonly diskRangeInput: DataOpentelekomcloudCssFlavorV1DiskRange;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `minCpuInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.minCpuInput"></a>

```typescript
public readonly minCpuInput: number;
```

- *Type:* `number`

---

##### `minRamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.minRamInput"></a>

```typescript
public readonly minRamInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `minCpu`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.minCpu"></a>

```typescript
public readonly minCpu: number;
```

- *Type:* `number`

---

##### `minRam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudCtsTrackerV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1 opentelekomcloud_cts_tracker_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudCtsTrackerV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCtsTrackerV1(scope: Construct, id: string, config?: DataOpentelekomcloudCtsTrackerV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBucketName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetBucketName"></a>

```typescript
public resetBucketName()
```

##### `resetFilePrefixName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetFilePrefixName"></a>

```typescript
public resetFilePrefixName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetProjectName"></a>

```typescript
public resetProjectName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTrackerName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.resetTrackerName"></a>

```typescript
public resetTrackerName()
```


#### Properties <a name="Properties"></a>

##### `isSendAllKeyOperation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.isSendAllKeyOperation"></a>

```typescript
public readonly isSendAllKeyOperation: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isSupportSmn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.isSupportSmn"></a>

```typescript
public readonly isSupportSmn: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `needNotifyUserList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.needNotifyUserList"></a>

```typescript
public readonly needNotifyUserList: string[];
```

- *Type:* `string`[]

---

##### `operations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* `string`[]

---

##### `topicId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.topicId"></a>

```typescript
public readonly topicId: string;
```

- *Type:* `string`

---

##### `bucketNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.bucketNameInput"></a>

```typescript
public readonly bucketNameInput: string;
```

- *Type:* `string`

---

##### `filePrefixNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.filePrefixNameInput"></a>

```typescript
public readonly filePrefixNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `projectNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.projectNameInput"></a>

```typescript
public readonly projectNameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `trackerNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.trackerNameInput"></a>

```typescript
public readonly trackerNameInput: string;
```

- *Type:* `string`

---

##### `bucketName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* `string`

---

##### `filePrefixName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.filePrefixName"></a>

```typescript
public readonly filePrefixName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `projectName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `trackerName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.trackerName"></a>

```typescript
public readonly trackerName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDcsAzV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1 opentelekomcloud_dcs_az_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsAzV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDcsAzV1(scope: Construct, id: string, config?: DataOpentelekomcloudDcsAzV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetCode` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.resetCode"></a>

```typescript
public resetCode()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.resetName"></a>

```typescript
public resetName()
```

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.resetPort"></a>

```typescript
public resetPort()
```


#### Properties <a name="Properties"></a>

##### `codeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.codeInput"></a>

```typescript
public readonly codeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.portInput"></a>

```typescript
public readonly portInput: string;
```

- *Type:* `string`

---

##### `code`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.code"></a>

```typescript
public readonly code: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDcsMaintainwindowV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1 opentelekomcloud_dcs_maintainwindow_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsMaintainwindowV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDcsMaintainwindowV1(scope: Construct, id: string, config?: DataOpentelekomcloudDcsMaintainwindowV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBegin` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.resetBegin"></a>

```typescript
public resetBegin()
```

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.resetDefault"></a>

```typescript
public resetDefault()
```

##### `resetEnd` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.resetEnd"></a>

```typescript
public resetEnd()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.resetId"></a>

```typescript
public resetId()
```

##### `resetSeq` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.resetSeq"></a>

```typescript
public resetSeq()
```


#### Properties <a name="Properties"></a>

##### `beginInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.beginInput"></a>

```typescript
public readonly beginInput: string;
```

- *Type:* `string`

---

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.defaultInput"></a>

```typescript
public readonly defaultInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `endInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.endInput"></a>

```typescript
public readonly endInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `seqInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.seqInput"></a>

```typescript
public readonly seqInput: number;
```

- *Type:* `number`

---

##### `begin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.begin"></a>

```typescript
public readonly begin: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.default"></a>

```typescript
public readonly default: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `end`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `seq`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.seq"></a>

```typescript
public readonly seq: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDcsProductV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1 opentelekomcloud_dcs_product_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsProductV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDcsProductV1(scope: Construct, id: string, config?: DataOpentelekomcloudDcsProductV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.resetId"></a>

```typescript
public resetId()
```

##### `resetSpecCode` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.resetSpecCode"></a>

```typescript
public resetSpecCode()
```


#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `specCodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.property.specCodeInput"></a>

```typescript
public readonly specCodeInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `specCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDdsFlavorsV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3 opentelekomcloud_dds_flavors_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsFlavorsV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsFlavorsV3(scope: Construct, id: string, config: DataOpentelekomcloudDdsFlavorsV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.resetId"></a>

```typescript
public resetId()
```

##### `resetMemory` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.resetMemory"></a>

```typescript
public resetMemory()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.resetType"></a>

```typescript
public resetType()
```

##### `resetVcpus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.resetVcpus"></a>

```typescript
public resetVcpus()
```


#### Properties <a name="Properties"></a>

##### `flavors`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.flavors"></a>

```typescript
public readonly flavors: DataOpentelekomcloudDdsFlavorsV3FlavorsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList)

---

##### `engineNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.engineNameInput"></a>

```typescript
public readonly engineNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `memoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.memoryInput"></a>

```typescript
public readonly memoryInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `vcpusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.vcpusInput"></a>

```typescript
public readonly vcpusInput: string;
```

- *Type:* `string`

---

##### `engineName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.engineName"></a>

```typescript
public readonly engineName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `memory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.memory"></a>

```typescript
public readonly memory: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.vcpus"></a>

```typescript
public readonly vcpus: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDdsInstanceV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3 opentelekomcloud_dds_instance_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3(scope: Construct, id: string, config?: DataOpentelekomcloudDdsInstanceV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDatastoreType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetDatastoreType"></a>

```typescript
public resetDatastoreType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetId"></a>

```typescript
public resetId()
```

##### `resetInstanceId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetInstanceId"></a>

```typescript
public resetInstanceId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetName"></a>

```typescript
public resetName()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `backupStrategy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: DataOpentelekomcloudDdsInstanceV3BackupStrategyList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList)

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.datastore"></a>

```typescript
public readonly datastore: DataOpentelekomcloudDdsInstanceV3DatastoreList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList)

---

##### `dbUsername`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.dbUsername"></a>

```typescript
public readonly dbUsername: string;
```

- *Type:* `string`

---

##### `diskEncryptionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

---

##### `mode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* `string`

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.nodes"></a>

```typescript
public readonly nodes: DataOpentelekomcloudDdsInstanceV3NodesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList)

---

##### `payMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.payMode"></a>

```typescript
public readonly payMode: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `ssl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.ssl"></a>

```typescript
public readonly ssl: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `datastoreTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.datastoreTypeInput"></a>

```typescript
public readonly datastoreTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `datastoreType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.datastoreType"></a>

```typescript
public readonly datastoreType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDehHostV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1 opentelekomcloud_deh_host_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehHostV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehHostV1(scope: Construct, id: string, config?: DataOpentelekomcloudDehHostV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `autoPlacement`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.autoPlacement"></a>

```typescript
public readonly autoPlacement: string;
```

- *Type:* `string`

---

##### `availableInstanceCapacities`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.availableInstanceCapacities"></a>

```typescript
public readonly availableInstanceCapacities: DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList)

---

##### `availableMemory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.availableMemory"></a>

```typescript
public readonly availableMemory: number;
```

- *Type:* `number`

---

##### `availableVcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.availableVcpus"></a>

```typescript
public readonly availableVcpus: number;
```

- *Type:* `number`

---

##### `cores`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* `number`

---

##### `hostType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.hostType"></a>

```typescript
public readonly hostType: string;
```

- *Type:* `string`

---

##### `hostTypeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.hostTypeName"></a>

```typescript
public readonly hostTypeName: string;
```

- *Type:* `string`

---

##### `instanceTotal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.instanceTotal"></a>

```typescript
public readonly instanceTotal: number;
```

- *Type:* `number`

---

##### `instanceUuids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.instanceUuids"></a>

```typescript
public readonly instanceUuids: string[];
```

- *Type:* `string`[]

---

##### `memory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* `number`

---

##### `sockets`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* `number`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDehServerV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1 opentelekomcloud_deh_server_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehServerV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehServerV1(scope: Construct, id: string, config?: DataOpentelekomcloudDehServerV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config)

---

#### Methods <a name="Methods"></a>

##### `putAddresses` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.putAddresses"></a>

```typescript
public putAddresses(value: IResolvable | DataOpentelekomcloudDehServerV1Addresses[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses)[]

---

##### `resetAddresses` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.resetAddresses"></a>

```typescript
public resetAddresses()
```

##### `resetDedicatedHostId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.resetDedicatedHostId"></a>

```typescript
public resetDedicatedHostId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetServerId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.resetServerId"></a>

```typescript
public resetServerId()
```


#### Properties <a name="Properties"></a>

##### `addresses`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.addresses"></a>

```typescript
public readonly addresses: DataOpentelekomcloudDehServerV1AddressesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList)

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.flavor"></a>

```typescript
public readonly flavor: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `addressesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.addressesInput"></a>

```typescript
public readonly addressesInput: IResolvable | DataOpentelekomcloudDehServerV1Addresses[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses)[]

---

##### `dedicatedHostIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.dedicatedHostIdInput"></a>

```typescript
public readonly dedicatedHostIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `dedicatedHostId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.dedicatedHostId"></a>

```typescript
public readonly dedicatedHostId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDmsAzV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_az_v1 opentelekomcloud_dms_az_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsAzV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDmsAzV1(scope: Construct, id: string, config?: DataOpentelekomcloudDmsAzV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetCode` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.resetCode"></a>

```typescript
public resetCode()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.resetName"></a>

```typescript
public resetName()
```

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.resetPort"></a>

```typescript
public resetPort()
```


#### Properties <a name="Properties"></a>

##### `codeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.codeInput"></a>

```typescript
public readonly codeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.portInput"></a>

```typescript
public readonly portInput: string;
```

- *Type:* `string`

---

##### `code`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.code"></a>

```typescript
public readonly code: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDmsMaintainwindowV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1 opentelekomcloud_dms_maintainwindow_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsMaintainwindowV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDmsMaintainwindowV1(scope: Construct, id: string, config?: DataOpentelekomcloudDmsMaintainwindowV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBegin` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.resetBegin"></a>

```typescript
public resetBegin()
```

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.resetDefault"></a>

```typescript
public resetDefault()
```

##### `resetEnd` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.resetEnd"></a>

```typescript
public resetEnd()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.resetId"></a>

```typescript
public resetId()
```

##### `resetSeq` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.resetSeq"></a>

```typescript
public resetSeq()
```


#### Properties <a name="Properties"></a>

##### `beginInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.beginInput"></a>

```typescript
public readonly beginInput: string;
```

- *Type:* `string`

---

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.defaultInput"></a>

```typescript
public readonly defaultInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `endInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.endInput"></a>

```typescript
public readonly endInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `seqInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.seqInput"></a>

```typescript
public readonly seqInput: number;
```

- *Type:* `number`

---

##### `begin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.begin"></a>

```typescript
public readonly begin: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.default"></a>

```typescript
public readonly default: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `end`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `seq`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.seq"></a>

```typescript
public readonly seq: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDmsProductV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1 opentelekomcloud_dms_product_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsProductV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDmsProductV1(scope: Construct, id: string, config: DataOpentelekomcloudDmsProductV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBandwidth` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetBandwidth"></a>

```typescript
public resetBandwidth()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetId"></a>

```typescript
public resetId()
```

##### `resetIoType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetIoType"></a>

```typescript
public resetIoType()
```

##### `resetNodeNum` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetNodeNum"></a>

```typescript
public resetNodeNum()
```

##### `resetPartitionNum` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetPartitionNum"></a>

```typescript
public resetPartitionNum()
```

##### `resetStorage` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetStorage"></a>

```typescript
public resetStorage()
```

##### `resetStorageSpecCode` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetStorageSpecCode"></a>

```typescript
public resetStorageSpecCode()
```

##### `resetVersion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetVersion"></a>

```typescript
public resetVersion()
```

##### `resetVmSpecification` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.resetVmSpecification"></a>

```typescript
public resetVmSpecification()
```


#### Properties <a name="Properties"></a>

##### `bandwidthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.bandwidthInput"></a>

```typescript
public readonly bandwidthInput: string;
```

- *Type:* `string`

---

##### `engineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.engineInput"></a>

```typescript
public readonly engineInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.instanceTypeInput"></a>

```typescript
public readonly instanceTypeInput: string;
```

- *Type:* `string`

---

##### `ioTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.ioTypeInput"></a>

```typescript
public readonly ioTypeInput: string;
```

- *Type:* `string`

---

##### `nodeNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.nodeNumInput"></a>

```typescript
public readonly nodeNumInput: string;
```

- *Type:* `string`

---

##### `partitionNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.partitionNumInput"></a>

```typescript
public readonly partitionNumInput: string;
```

- *Type:* `string`

---

##### `storageInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* `string`

---

##### `storageSpecCodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.storageSpecCodeInput"></a>

```typescript
public readonly storageSpecCodeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `vmSpecificationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.vmSpecificationInput"></a>

```typescript
public readonly vmSpecificationInput: string;
```

- *Type:* `string`

---

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.bandwidth"></a>

```typescript
public readonly bandwidth: string;
```

- *Type:* `string`

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.instanceType"></a>

```typescript
public readonly instanceType: string;
```

- *Type:* `string`

---

##### `ioType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.ioType"></a>

```typescript
public readonly ioType: string;
```

- *Type:* `string`

---

##### `nodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.nodeNum"></a>

```typescript
public readonly nodeNum: string;
```

- *Type:* `string`

---

##### `partitionNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.partitionNum"></a>

```typescript
public readonly partitionNum: string;
```

- *Type:* `string`

---

##### `storage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* `string`

---

##### `storageSpecCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.storageSpecCode"></a>

```typescript
public readonly storageSpecCode: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `vmSpecification`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.vmSpecification"></a>

```typescript
public readonly vmSpecification: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDnsNameserversV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2 opentelekomcloud_dns_nameservers_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsNameserversV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDnsNameserversV2(scope: Construct, id: string, config?: DataOpentelekomcloudDnsNameserversV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config)

---

#### Methods <a name="Methods"></a>

##### `putNameservers` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.putNameservers"></a>

```typescript
public putNameservers(value: IResolvable | DataOpentelekomcloudDnsNameserversV2Nameservers[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers)[]

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.resetId"></a>

```typescript
public resetId()
```

##### `resetNameservers` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.resetNameservers"></a>

```typescript
public resetNameservers()
```

##### `resetZoneId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.resetZoneId"></a>

```typescript
public resetZoneId()
```


#### Properties <a name="Properties"></a>

##### `nameservers`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.nameservers"></a>

```typescript
public readonly nameservers: DataOpentelekomcloudDnsNameserversV2NameserversList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameserversInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.nameserversInput"></a>

```typescript
public readonly nameserversInput: IResolvable | DataOpentelekomcloudDnsNameserversV2Nameservers[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers)[]

---

##### `zoneIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `zoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudDnsZoneV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2 opentelekomcloud_dns_zone_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsZoneV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDnsZoneV2(scope: Construct, id: string, config?: DataOpentelekomcloudDnsZoneV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEmail` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetEmail"></a>

```typescript
public resetEmail()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetName"></a>

```typescript
public resetName()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTtl` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetTtl"></a>

```typescript
public resetTtl()
```

##### `resetZoneType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.resetZoneType"></a>

```typescript
public resetZoneType()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `links`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.links"></a>

```typescript
public readonly links: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `masters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.masters"></a>

```typescript
public readonly masters: string[];
```

- *Type:* `string`[]

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `serial`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.serial"></a>

```typescript
public readonly serial: number;
```

- *Type:* `number`

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `emailInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.emailInput"></a>

```typescript
public readonly emailInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `ttlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* `number`

---

##### `zoneTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.zoneTypeInput"></a>

```typescript
public readonly zoneTypeInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `email`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `ttl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

---

##### `zoneType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.zoneType"></a>

```typescript
public readonly zoneType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityAgencyV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_agency_v3 opentelekomcloud_identity_agency_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAgencyV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityAgencyV3(scope: Construct, id: string, config?: DataOpentelekomcloudIdentityAgencyV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.resetName"></a>

```typescript
public resetName()
```

##### `resetTrustDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.resetTrustDomainId"></a>

```typescript
public resetTrustDomainId()
```


#### Properties <a name="Properties"></a>

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `duration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* `string`

---

##### `expireTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.expireTime"></a>

```typescript
public readonly expireTime: string;
```

- *Type:* `string`

---

##### `trustDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.trustDomainName"></a>

```typescript
public readonly trustDomainName: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `trustDomainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.trustDomainIdInput"></a>

```typescript
public readonly trustDomainIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `trustDomainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.trustDomainId"></a>

```typescript
public readonly trustDomainId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityAuthScopeV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_auth_scope_v3 opentelekomcloud_identity_auth_scope_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAuthScopeV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityAuthScopeV3(scope: Construct, id: string, config: DataOpentelekomcloudIdentityAuthScopeV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `domainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

---

##### `projectDomainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.projectDomainId"></a>

```typescript
public readonly projectDomainId: string;
```

- *Type:* `string`

---

##### `projectDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.projectDomainName"></a>

```typescript
public readonly projectDomainName: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `projectName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

---

##### `roles`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.roles"></a>

```typescript
public readonly roles: DataOpentelekomcloudIdentityAuthScopeV3RolesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList)

---

##### `userDomainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.userDomainId"></a>

```typescript
public readonly userDomainId: string;
```

- *Type:* `string`

---

##### `userDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.userDomainName"></a>

```typescript
public readonly userDomainName: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `userName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityCredentialV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_credential_v3 opentelekomcloud_identity_credential_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityCredentialV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityCredentialV3(scope: Construct, id: string, config?: DataOpentelekomcloudIdentityCredentialV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.resetId"></a>

```typescript
public resetId()
```

##### `resetUserId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.resetUserId"></a>

```typescript
public resetUserId()
```


#### Properties <a name="Properties"></a>

##### `credentials`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.credentials"></a>

```typescript
public readonly credentials: DataOpentelekomcloudIdentityCredentialV3CredentialsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityGroupV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_group_v3 opentelekomcloud_identity_group_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityGroupV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityGroupV3(scope: Construct, id: string, config: DataOpentelekomcloudIdentityGroupV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityProjectV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3 opentelekomcloud_identity_project_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityProjectV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityProjectV3(scope: Construct, id: string, config?: DataOpentelekomcloudIdentityProjectV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetId"></a>

```typescript
public resetId()
```

##### `resetIsDomain` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetIsDomain"></a>

```typescript
public resetIsDomain()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetName"></a>

```typescript
public resetName()
```

##### `resetParentId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.resetParentId"></a>

```typescript
public resetParentId()
```


#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `isDomainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.isDomainInput"></a>

```typescript
public readonly isDomainInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `parentIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.parentIdInput"></a>

```typescript
public readonly parentIdInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `isDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.isDomain"></a>

```typescript
public readonly isDomain: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `parentId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.parentId"></a>

```typescript
public readonly parentId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityRoleV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_role_v3 opentelekomcloud_identity_role_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityRoleV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityRoleV3(scope: Construct, id: string, config: DataOpentelekomcloudIdentityRoleV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudIdentityUserV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3 opentelekomcloud_identity_user_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityUserV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityUserV3(scope: Construct, id: string, config?: DataOpentelekomcloudIdentityUserV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `defaultProjectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.defaultProjectId"></a>

```typescript
public readonly defaultProjectId: string;
```

- *Type:* `string`

---

##### `passwordExpiresAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.passwordExpiresAt"></a>

```typescript
public readonly passwordExpiresAt: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudImagesImageV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2 opentelekomcloud_images_image_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudImagesImageV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudImagesImageV2(scope: Construct, id: string, config?: DataOpentelekomcloudImagesImageV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMostRecent` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetMostRecent"></a>

```typescript
public resetMostRecent()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetName"></a>

```typescript
public resetName()
```

##### `resetNameRegex` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetNameRegex"></a>

```typescript
public resetNameRegex()
```

##### `resetOwner` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetOwner"></a>

```typescript
public resetOwner()
```

##### `resetProperties` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetProperties"></a>

```typescript
public resetProperties()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSizeMax` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetSizeMax"></a>

```typescript
public resetSizeMax()
```

##### `resetSizeMin` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetSizeMin"></a>

```typescript
public resetSizeMin()
```

##### `resetSortDirection` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetSortDirection"></a>

```typescript
public resetSortDirection()
```

##### `resetSortKey` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetSortKey"></a>

```typescript
public resetSortKey()
```

##### `resetTag` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetTag"></a>

```typescript
public resetTag()
```

##### `resetVisibility` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.resetVisibility"></a>

```typescript
public resetVisibility()
```


#### Properties <a name="Properties"></a>

##### `checksum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.checksum"></a>

```typescript
public readonly checksum: string;
```

- *Type:* `string`

---

##### `containerFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.containerFormat"></a>

```typescript
public readonly containerFormat: string;
```

- *Type:* `string`

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `diskFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.diskFormat"></a>

```typescript
public readonly diskFormat: string;
```

- *Type:* `string`

---

##### `file`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.file"></a>

```typescript
public readonly file: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `minDiskGb`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.minDiskGb"></a>

```typescript
public readonly minDiskGb: number;
```

- *Type:* `number`

---

##### `minRamMb`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.minRamMb"></a>

```typescript
public readonly minRamMb: number;
```

- *Type:* `number`

---

##### `protected`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.protected"></a>

```typescript
public readonly protected: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `schema`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.schema"></a>

```typescript
public readonly schema: string;
```

- *Type:* `string`

---

##### `sizeBytes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sizeBytes"></a>

```typescript
public readonly sizeBytes: number;
```

- *Type:* `number`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `mostRecentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.mostRecentInput"></a>

```typescript
public readonly mostRecentInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nameRegexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.nameRegexInput"></a>

```typescript
public readonly nameRegexInput: string;
```

- *Type:* `string`

---

##### `ownerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.ownerInput"></a>

```typescript
public readonly ownerInput: string;
```

- *Type:* `string`

---

##### `propertiesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.propertiesInput"></a>

```typescript
public readonly propertiesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sizeMaxInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sizeMaxInput"></a>

```typescript
public readonly sizeMaxInput: number;
```

- *Type:* `number`

---

##### `sizeMinInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sizeMinInput"></a>

```typescript
public readonly sizeMinInput: number;
```

- *Type:* `number`

---

##### `sortDirectionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sortDirectionInput"></a>

```typescript
public readonly sortDirectionInput: string;
```

- *Type:* `string`

---

##### `sortKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sortKeyInput"></a>

```typescript
public readonly sortKeyInput: string;
```

- *Type:* `string`

---

##### `tagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.tagInput"></a>

```typescript
public readonly tagInput: string;
```

- *Type:* `string`

---

##### `visibilityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.visibilityInput"></a>

```typescript
public readonly visibilityInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `mostRecent`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.mostRecent"></a>

```typescript
public readonly mostRecent: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `nameRegex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.nameRegex"></a>

```typescript
public readonly nameRegex: string;
```

- *Type:* `string`

---

##### `owner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* `string`

---

##### `properties`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sizeMax`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sizeMax"></a>

```typescript
public readonly sizeMax: number;
```

- *Type:* `number`

---

##### `sizeMin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sizeMin"></a>

```typescript
public readonly sizeMin: number;
```

- *Type:* `number`

---

##### `sortDirection`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sortDirection"></a>

```typescript
public readonly sortDirection: string;
```

- *Type:* `string`

---

##### `sortKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.sortKey"></a>

```typescript
public readonly sortKey: string;
```

- *Type:* `string`

---

##### `tag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* `string`

---

##### `visibility`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudKmsDataKeyV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_data_key_v1 opentelekomcloud_kms_data_key_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudKmsDataKeyV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudKmsDataKeyV1(scope: Construct, id: string, config: DataOpentelekomcloudKmsDataKeyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetEncryptionContext` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.resetEncryptionContext"></a>

```typescript
public resetEncryptionContext()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `cipherText`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.cipherText"></a>

```typescript
public readonly cipherText: string;
```

- *Type:* `string`

---

##### `plainText`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.plainText"></a>

```typescript
public readonly plainText: string;
```

- *Type:* `string`

---

##### `datakeyLengthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.datakeyLengthInput"></a>

```typescript
public readonly datakeyLengthInput: string;
```

- *Type:* `string`

---

##### `encryptionContextInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.encryptionContextInput"></a>

```typescript
public readonly encryptionContextInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.keyIdInput"></a>

```typescript
public readonly keyIdInput: string;
```

- *Type:* `string`

---

##### `datakeyLength`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.datakeyLength"></a>

```typescript
public readonly datakeyLength: string;
```

- *Type:* `string`

---

##### `encryptionContext`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.encryptionContext"></a>

```typescript
public readonly encryptionContext: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `keyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudKmsKeyV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1 opentelekomcloud_kms_key_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudKmsKeyV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudKmsKeyV1(scope: Construct, id: string, config?: DataOpentelekomcloudKmsKeyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetDefaultKeyFlag` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetDefaultKeyFlag"></a>

```typescript
public resetDefaultKeyFlag()
```

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetKeyAlias` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetKeyAlias"></a>

```typescript
public resetKeyAlias()
```

##### `resetKeyDescription` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetKeyDescription"></a>

```typescript
public resetKeyDescription()
```

##### `resetKeyId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetKeyId"></a>

```typescript
public resetKeyId()
```

##### `resetKeyState` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetKeyState"></a>

```typescript
public resetKeyState()
```

##### `resetOrigin` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetOrigin"></a>

```typescript
public resetOrigin()
```

##### `resetRealm` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.resetRealm"></a>

```typescript
public resetRealm()
```


#### Properties <a name="Properties"></a>

##### `creationDate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.creationDate"></a>

```typescript
public readonly creationDate: string;
```

- *Type:* `string`

---

##### `expirationTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.expirationTime"></a>

```typescript
public readonly expirationTime: string;
```

- *Type:* `string`

---

##### `scheduledDeletionDate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.scheduledDeletionDate"></a>

```typescript
public readonly scheduledDeletionDate: string;
```

- *Type:* `string`

---

##### `defaultKeyFlagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.defaultKeyFlagInput"></a>

```typescript
public readonly defaultKeyFlagInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyAliasInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyAliasInput"></a>

```typescript
public readonly keyAliasInput: string;
```

- *Type:* `string`

---

##### `keyDescriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyDescriptionInput"></a>

```typescript
public readonly keyDescriptionInput: string;
```

- *Type:* `string`

---

##### `keyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyIdInput"></a>

```typescript
public readonly keyIdInput: string;
```

- *Type:* `string`

---

##### `keyStateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyStateInput"></a>

```typescript
public readonly keyStateInput: string;
```

- *Type:* `string`

---

##### `originInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.originInput"></a>

```typescript
public readonly originInput: string;
```

- *Type:* `string`

---

##### `realmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.realmInput"></a>

```typescript
public readonly realmInput: string;
```

- *Type:* `string`

---

##### `defaultKeyFlag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.defaultKeyFlag"></a>

```typescript
public readonly defaultKeyFlag: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `keyAlias`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyAlias"></a>

```typescript
public readonly keyAlias: string;
```

- *Type:* `string`

---

##### `keyDescription`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyDescription"></a>

```typescript
public readonly keyDescription: string;
```

- *Type:* `string`

---

##### `keyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

---

##### `keyState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.keyState"></a>

```typescript
public readonly keyState: string;
```

- *Type:* `string`

---

##### `origin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.origin"></a>

```typescript
public readonly origin: string;
```

- *Type:* `string`

---

##### `realm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.realm"></a>

```typescript
public readonly realm: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudLbCertificateV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_certificate_v3 opentelekomcloud_lb_certificate_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbCertificateV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbCertificateV3(scope: Construct, id: string, config?: DataOpentelekomcloudLbCertificateV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomain` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.resetDomain"></a>

```typescript
public resetDomain()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.resetName"></a>

```typescript
public resetName()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `certificate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.certificate"></a>

```typescript
public readonly certificate: string;
```

- *Type:* `string`

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `expireTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.expireTime"></a>

```typescript
public readonly expireTime: string;
```

- *Type:* `string`

---

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `domainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.domainInput"></a>

```typescript
public readonly domainInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `domain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudLbFlavorV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3 opentelekomcloud_lb_flavor_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbFlavorV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbFlavorV3(scope: Construct, id: string, config?: DataOpentelekomcloudLbFlavorV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.resetName"></a>

```typescript
public resetName()
```


#### Properties <a name="Properties"></a>

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.bandwidth"></a>

```typescript
public readonly bandwidth: number;
```

- *Type:* `number`

---

##### `cps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.cps"></a>

```typescript
public readonly cps: number;
```

- *Type:* `number`

---

##### `maxConnections`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.maxConnections"></a>

```typescript
public readonly maxConnections: number;
```

- *Type:* `number`

---

##### `qps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.qps"></a>

```typescript
public readonly qps: number;
```

- *Type:* `number`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.shared"></a>

```typescript
public readonly shared: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudLbListenerV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3 opentelekomcloud_lb_listener_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbListenerV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbListenerV3(scope: Construct, id: string, config?: DataOpentelekomcloudLbListenerV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetClientCaTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetClientCaTlsContainerRef"></a>

```typescript
public resetClientCaTlsContainerRef()
```

##### `resetClientTimeout` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetClientTimeout"></a>

```typescript
public resetClientTimeout()
```

##### `resetDefaultPoolId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetDefaultPoolId"></a>

```typescript
public resetDefaultPoolId()
```

##### `resetDefaultTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetDefaultTlsContainerRef"></a>

```typescript
public resetDefaultTlsContainerRef()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetId"></a>

```typescript
public resetId()
```

##### `resetKeepAliveTimeout` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetKeepAliveTimeout"></a>

```typescript
public resetKeepAliveTimeout()
```

##### `resetLoadbalancerId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetLoadbalancerId"></a>

```typescript
public resetLoadbalancerId()
```

##### `resetMemberAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetMemberAddress"></a>

```typescript
public resetMemberAddress()
```

##### `resetMemberDeviceId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetMemberDeviceId"></a>

```typescript
public resetMemberDeviceId()
```

##### `resetMemberTimeout` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetMemberTimeout"></a>

```typescript
public resetMemberTimeout()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetName"></a>

```typescript
public resetName()
```

##### `resetProtocol` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetProtocol"></a>

```typescript
public resetProtocol()
```

##### `resetProtocolPort` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetProtocolPort"></a>

```typescript
public resetProtocolPort()
```

##### `resetTlsCiphersPolicy` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.resetTlsCiphersPolicy"></a>

```typescript
public resetTlsCiphersPolicy()
```


#### Properties <a name="Properties"></a>

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `http2Enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.http2Enable"></a>

```typescript
public readonly http2Enable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `insertHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.insertHeaders"></a>

```typescript
public readonly insertHeaders: DataOpentelekomcloudLbListenerV3InsertHeadersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList)

---

##### `memberRetryEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberRetryEnable"></a>

```typescript
public readonly memberRetryEnable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `memoryRetryEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memoryRetryEnable"></a>

```typescript
public readonly memoryRetryEnable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `sniContainerRefs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.sniContainerRefs"></a>

```typescript
public readonly sniContainerRefs: string[];
```

- *Type:* `string`[]

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.tags"></a>

```typescript
public readonly tags: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `clientCaTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.clientCaTlsContainerRefInput"></a>

```typescript
public readonly clientCaTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `clientTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.clientTimeoutInput"></a>

```typescript
public readonly clientTimeoutInput: number;
```

- *Type:* `number`

---

##### `defaultPoolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.defaultPoolIdInput"></a>

```typescript
public readonly defaultPoolIdInput: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.defaultTlsContainerRefInput"></a>

```typescript
public readonly defaultTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keepAliveTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.keepAliveTimeoutInput"></a>

```typescript
public readonly keepAliveTimeoutInput: number;
```

- *Type:* `number`

---

##### `loadbalancerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.loadbalancerIdInput"></a>

```typescript
public readonly loadbalancerIdInput: string;
```

- *Type:* `string`

---

##### `memberAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberAddressInput"></a>

```typescript
public readonly memberAddressInput: string;
```

- *Type:* `string`

---

##### `memberDeviceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberDeviceIdInput"></a>

```typescript
public readonly memberDeviceIdInput: string;
```

- *Type:* `string`

---

##### `memberTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberTimeoutInput"></a>

```typescript
public readonly memberTimeoutInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `tlsCiphersPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.tlsCiphersPolicyInput"></a>

```typescript
public readonly tlsCiphersPolicyInput: string;
```

- *Type:* `string`

---

##### `clientCaTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

---

##### `clientTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.clientTimeout"></a>

```typescript
public readonly clientTimeout: number;
```

- *Type:* `number`

---

##### `defaultPoolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `keepAliveTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* `number`

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

---

##### `memberAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberAddress"></a>

```typescript
public readonly memberAddress: string;
```

- *Type:* `string`

---

##### `memberDeviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberDeviceId"></a>

```typescript
public readonly memberDeviceId: string;
```

- *Type:* `string`

---

##### `memberTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.memberTimeout"></a>

```typescript
public readonly memberTimeout: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `tlsCiphersPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudLbLoadbalancerV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3 opentelekomcloud_lb_loadbalancer_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbLoadbalancerV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbLoadbalancerV3(scope: Construct, id: string, config?: DataOpentelekomcloudLbLoadbalancerV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetId"></a>

```typescript
public resetId()
```

##### `resetL4Flavor` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetL4Flavor"></a>

```typescript
public resetL4Flavor()
```

##### `resetL7Flavor` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetL7Flavor"></a>

```typescript
public resetL7Flavor()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetName"></a>

```typescript
public resetName()
```

##### `resetRouterId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetRouterId"></a>

```typescript
public resetRouterId()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetVipAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetVipAddress"></a>

```typescript
public resetVipAddress()
```

##### `resetVipPortId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.resetVipPortId"></a>

```typescript
public resetVipPortId()
```


#### Properties <a name="Properties"></a>

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* `string`[]

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `ipTargetEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.ipTargetEnable"></a>

```typescript
public readonly ipTargetEnable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `networkIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.networkIds"></a>

```typescript
public readonly networkIds: string[];
```

- *Type:* `string`[]

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.publicIp"></a>

```typescript
public readonly publicIp: DataOpentelekomcloudLbLoadbalancerV3PublicIpList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.tags"></a>

```typescript
public readonly tags: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `l4FlavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.l4FlavorInput"></a>

```typescript
public readonly l4FlavorInput: string;
```

- *Type:* `string`

---

##### `l7FlavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.l7FlavorInput"></a>

```typescript
public readonly l7FlavorInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `vipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.vipAddressInput"></a>

```typescript
public readonly vipAddressInput: string;
```

- *Type:* `string`

---

##### `vipPortIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.vipPortIdInput"></a>

```typescript
public readonly vipPortIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `l4Flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.l4Flavor"></a>

```typescript
public readonly l4Flavor: string;
```

- *Type:* `string`

---

##### `l7Flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.l7Flavor"></a>

```typescript
public readonly l7Flavor: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

---

##### `vipPortId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudLbMemberIdsV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2 opentelekomcloud_lb_member_ids_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbMemberIdsV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbMemberIdsV2(scope: Construct, id: string, config: DataOpentelekomcloudLbMemberIdsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `ids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.ids"></a>

```typescript
public readonly ids: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudNetworkingNetworkV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2 opentelekomcloud_networking_network_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingNetworkV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudNetworkingNetworkV2(scope: Construct, id: string, config?: DataOpentelekomcloudNetworkingNetworkV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMatchingSubnetCidr` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetMatchingSubnetCidr"></a>

```typescript
public resetMatchingSubnetCidr()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetName"></a>

```typescript
public resetName()
```

##### `resetNetworkId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetNetworkId"></a>

```typescript
public resetNetworkId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.resetTenantId"></a>

```typescript
public resetTenantId()
```


#### Properties <a name="Properties"></a>

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: string;
```

- *Type:* `string`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.shared"></a>

```typescript
public readonly shared: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `matchingSubnetCidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.matchingSubnetCidrInput"></a>

```typescript
public readonly matchingSubnetCidrInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `matchingSubnetCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.matchingSubnetCidr"></a>

```typescript
public readonly matchingSubnetCidr: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudNetworkingPortV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2 opentelekomcloud_networking_port_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingPortV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudNetworkingPortV2(scope: Construct, id: string, config?: DataOpentelekomcloudNetworkingPortV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDeviceId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetDeviceId"></a>

```typescript
public resetDeviceId()
```

##### `resetDeviceOwner` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetDeviceOwner"></a>

```typescript
public resetDeviceOwner()
```

##### `resetFixedIp` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetFixedIp"></a>

```typescript
public resetFixedIp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMacAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetMacAddress"></a>

```typescript
public resetMacAddress()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetName"></a>

```typescript
public resetName()
```

##### `resetNetworkId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetNetworkId"></a>

```typescript
public resetNetworkId()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetPortId"></a>

```typescript
public resetPortId()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecurityGroupIds` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.resetTenantId"></a>

```typescript
public resetTenantId()
```


#### Properties <a name="Properties"></a>

##### `allFixedIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.allFixedIps"></a>

```typescript
public readonly allFixedIps: string[];
```

- *Type:* `string`[]

---

##### `allSecurityGroupIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.allSecurityGroupIds"></a>

```typescript
public readonly allSecurityGroupIds: string[];
```

- *Type:* `string`[]

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `deviceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.deviceIdInput"></a>

```typescript
public readonly deviceIdInput: string;
```

- *Type:* `string`

---

##### `deviceOwnerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.deviceOwnerInput"></a>

```typescript
public readonly deviceOwnerInput: string;
```

- *Type:* `string`

---

##### `fixedIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.fixedIpInput"></a>

```typescript
public readonly fixedIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `macAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.macAddressInput"></a>

```typescript
public readonly macAddressInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* `string`[]

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `deviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* `string`

---

##### `deviceOwner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.deviceOwner"></a>

```typescript
public readonly deviceOwner: string;
```

- *Type:* `string`

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `macAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* `string`[]

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudNetworkingSecgroupRuleIdsV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_rule_ids_v2 opentelekomcloud_networking_secgroup_rule_ids_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingSecgroupRuleIdsV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudNetworkingSecgroupRuleIdsV2(scope: Construct, id: string, config: DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `ids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.ids"></a>

```typescript
public readonly ids: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudNetworkingSecgroupV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2 opentelekomcloud_networking_secgroup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingSecgroupV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudNetworkingSecgroupV2(scope: Construct, id: string, config?: DataOpentelekomcloudNetworkingSecgroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecgroupId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.resetSecgroupId"></a>

```typescript
public resetSecgroupId()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.resetTenantId"></a>

```typescript
public resetTenantId()
```


#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `secgroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.secgroupIdInput"></a>

```typescript
public readonly secgroupIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `secgroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.secgroupId"></a>

```typescript
public readonly secgroupId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudObsBucket <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket opentelekomcloud_obs_bucket}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucket } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucket(scope: Construct, id: string, config: DataOpentelekomcloudObsBucketConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `bucketDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* `string`

---

##### `corsRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.corsRule"></a>

```typescript
public readonly corsRule: DataOpentelekomcloudObsBucketCorsRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList)

---

##### `eventNotifications`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.eventNotifications"></a>

```typescript
public readonly eventNotifications: DataOpentelekomcloudObsBucketEventNotificationsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList)

---

##### `lifecycleRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: DataOpentelekomcloudObsBucketLifecycleRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList)

---

##### `logging`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.logging"></a>

```typescript
public readonly logging: DataOpentelekomcloudObsBucketLoggingList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverSideEncryption`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: DataOpentelekomcloudObsBucketServerSideEncryptionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList)

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.tags"></a>

```typescript
public readonly tags: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `versioning`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.versioning"></a>

```typescript
public readonly versioning: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `website`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.website"></a>

```typescript
public readonly website: DataOpentelekomcloudObsBucketWebsiteList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList)

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucket.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudObsBucketObject <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket_object opentelekomcloud_obs_bucket_object}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketObject } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketObject(scope: Construct, id: string, config: DataOpentelekomcloudObsBucketObjectConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.resetId"></a>

```typescript
public resetId()
```

##### `resetVersionId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.resetVersionId"></a>

```typescript
public resetVersionId()
```


#### Properties <a name="Properties"></a>

##### `body`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.body"></a>

```typescript
public readonly body: string;
```

- *Type:* `string`

---

##### `cacheControl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.cacheControl"></a>

```typescript
public readonly cacheControl: string;
```

- *Type:* `string`

---

##### `contentDisposition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.contentDisposition"></a>

```typescript
public readonly contentDisposition: string;
```

- *Type:* `string`

---

##### `contentEncoding`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: string;
```

- *Type:* `string`

---

##### `contentLanguage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.contentLanguage"></a>

```typescript
public readonly contentLanguage: string;
```

- *Type:* `string`

---

##### `contentLength`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.contentLength"></a>

```typescript
public readonly contentLength: number;
```

- *Type:* `number`

---

##### `contentType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

---

##### `etag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

---

##### `expiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.expiration"></a>

```typescript
public readonly expiration: string;
```

- *Type:* `string`

---

##### `expires`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.expires"></a>

```typescript
public readonly expires: string;
```

- *Type:* `string`

---

##### `lastModified`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.lastModified"></a>

```typescript
public readonly lastModified: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `websiteRedirectLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.websiteRedirectLocation"></a>

```typescript
public readonly websiteRedirectLocation: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `versionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.versionIdInput"></a>

```typescript
public readonly versionIdInput: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `versionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObject.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRdsBackupV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_backup_v3 opentelekomcloud_rds_backup_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsBackupV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsBackupV3(scope: Construct, id: string, config: DataOpentelekomcloudRdsBackupV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetBackupId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.resetBackupId"></a>

```typescript
public resetBackupId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.resetId"></a>

```typescript
public resetId()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `beginTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.beginTime"></a>

```typescript
public readonly beginTime: string;
```

- *Type:* `string`

---

##### `databases`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.databases"></a>

```typescript
public readonly databases: string[];
```

- *Type:* `string`[]

---

##### `dbType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.dbType"></a>

```typescript
public readonly dbType: string;
```

- *Type:* `string`

---

##### `dbVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.dbVersion"></a>

```typescript
public readonly dbVersion: string;
```

- *Type:* `string`

---

##### `endTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.endTime"></a>

```typescript
public readonly endTime: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `backupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `backupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRdsFlavorsV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1 opentelekomcloud_rds_flavors_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsFlavorsV1(scope: Construct, id: string, config: DataOpentelekomcloudRdsFlavorsV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSpeccode` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.resetSpeccode"></a>

```typescript
public resetSpeccode()
```


#### Properties <a name="Properties"></a>

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `datastoreNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.datastoreNameInput"></a>

```typescript
public readonly datastoreNameInput: string;
```

- *Type:* `string`

---

##### `datastoreVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.datastoreVersionInput"></a>

```typescript
public readonly datastoreVersionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `speccodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.speccodeInput"></a>

```typescript
public readonly speccodeInput: string;
```

- *Type:* `string`

---

##### `datastoreName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.datastoreName"></a>

```typescript
public readonly datastoreName: string;
```

- *Type:* `string`

---

##### `datastoreVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.datastoreVersion"></a>

```typescript
public readonly datastoreVersion: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `speccode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.speccode"></a>

```typescript
public readonly speccode: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRdsFlavorsV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3 opentelekomcloud_rds_flavors_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsFlavorsV3(scope: Construct, id: string, config: DataOpentelekomcloudRdsFlavorsV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `flavors`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.flavors"></a>

```typescript
public readonly flavors: DataOpentelekomcloudRdsFlavorsV3FlavorsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList)

---

##### `dbTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.dbTypeInput"></a>

```typescript
public readonly dbTypeInput: string;
```

- *Type:* `string`

---

##### `dbVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.dbVersionInput"></a>

```typescript
public readonly dbVersionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.instanceModeInput"></a>

```typescript
public readonly instanceModeInput: string;
```

- *Type:* `string`

---

##### `dbType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.dbType"></a>

```typescript
public readonly dbType: string;
```

- *Type:* `string`

---

##### `dbVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.dbVersion"></a>

```typescript
public readonly dbVersion: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.instanceMode"></a>

```typescript
public readonly instanceMode: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRdsInstanceV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3 opentelekomcloud_rds_instance_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsInstanceV3(scope: Construct, id: string, config?: DataOpentelekomcloudRdsInstanceV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDatastoreType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetDatastoreType"></a>

```typescript
public resetDatastoreType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetName"></a>

```typescript
public resetName()
```

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetPort"></a>

```typescript
public resetPort()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetType"></a>

```typescript
public resetType()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string[];
```

- *Type:* `string`[]

---

##### `backupStrategy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: DataOpentelekomcloudRdsInstanceV3BackupStrategyList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList)

---

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `datastoreVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.datastoreVersion"></a>

```typescript
public readonly datastoreVersion: string;
```

- *Type:* `string`

---

##### `dbUsername`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.dbUsername"></a>

```typescript
public readonly dbUsername: string;
```

- *Type:* `string`

---

##### `diskEncryptionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `ha`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.ha"></a>

```typescript
public readonly ha: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.nodes"></a>

```typescript
public readonly nodes: DataOpentelekomcloudRdsInstanceV3NodesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList)

---

##### `privateIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.privateIps"></a>

```typescript
public readonly privateIps: string[];
```

- *Type:* `string`[]

---

##### `publicIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.publicIps"></a>

```typescript
public readonly publicIps: string[];
```

- *Type:* `string`[]

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.tags"></a>

```typescript
public readonly tags: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `timezone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* `string`

---

##### `updated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.updated"></a>

```typescript
public readonly updated: string;
```

- *Type:* `string`

---

##### `volumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `datastoreTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.datastoreTypeInput"></a>

```typescript
public readonly datastoreTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* `number`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `datastoreType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.datastoreType"></a>

```typescript
public readonly datastoreType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRdsVersionsV3 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_versions_v3 opentelekomcloud_rds_versions_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsVersionsV3 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsVersionsV3(scope: Construct, id: string, config: DataOpentelekomcloudRdsVersionsV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `versions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.versions"></a>

```typescript
public readonly versions: string[];
```

- *Type:* `string`[]

---

##### `databaseNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `databaseName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRtsSoftwareConfigV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_config_v1 opentelekomcloud_rts_software_config_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsSoftwareConfigV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRtsSoftwareConfigV1(scope: Construct, id: string, config?: DataOpentelekomcloudRtsSoftwareConfigV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.config"></a>

```typescript
public readonly config: string;
```

- *Type:* `string`

---

##### `group`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

---

##### `inputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.inputValues"></a>

```typescript
public readonly inputValues: StringMapList;
```

- *Type:* [`cdktf.StringMapList`](#cdktf.StringMapList)

---

##### `options`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.options"></a>

```typescript
public readonly options: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `outputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.outputValues"></a>

```typescript
public readonly outputValues: StringMapList;
```

- *Type:* [`cdktf.StringMapList`](#cdktf.StringMapList)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRtsSoftwareDeploymentV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1 opentelekomcloud_rts_software_deployment_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsSoftwareDeploymentV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRtsSoftwareDeploymentV1(scope: Construct, id: string, config?: DataOpentelekomcloudRtsSoftwareDeploymentV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetAction` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetAction"></a>

```typescript
public resetAction()
```

##### `resetConfigId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetConfigId"></a>

```typescript
public resetConfigId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetServerId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetServerId"></a>

```typescript
public resetServerId()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `inputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.inputValues"></a>

```typescript
public readonly inputValues: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `outputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.outputValues"></a>

```typescript
public readonly outputValues: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `statusReason`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.statusReason"></a>

```typescript
public readonly statusReason: string;
```

- *Type:* `string`

---

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `configIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.configIdInput"></a>

```typescript
public readonly configIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `configId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.configId"></a>

```typescript
public readonly configId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRtsStackResourceV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1 opentelekomcloud_rts_stack_resource_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsStackResourceV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRtsStackResourceV1(scope: Construct, id: string, config: DataOpentelekomcloudRtsStackResourceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPhysicalResourceId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.resetPhysicalResourceId"></a>

```typescript
public resetPhysicalResourceId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetResourceName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.resetResourceName"></a>

```typescript
public resetResourceName()
```

##### `resetResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.resetResourceType"></a>

```typescript
public resetResourceType()
```


#### Properties <a name="Properties"></a>

##### `logicalResourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.logicalResourceId"></a>

```typescript
public readonly logicalResourceId: string;
```

- *Type:* `string`

---

##### `requiredBy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.requiredBy"></a>

```typescript
public readonly requiredBy: string[];
```

- *Type:* `string`[]

---

##### `resourceStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceStatus"></a>

```typescript
public readonly resourceStatus: string;
```

- *Type:* `string`

---

##### `resourceStatusReason`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceStatusReason"></a>

```typescript
public readonly resourceStatusReason: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `physicalResourceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.physicalResourceIdInput"></a>

```typescript
public readonly physicalResourceIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `resourceNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceNameInput"></a>

```typescript
public readonly resourceNameInput: string;
```

- *Type:* `string`

---

##### `resourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceTypeInput"></a>

```typescript
public readonly resourceTypeInput: string;
```

- *Type:* `string`

---

##### `stackNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.stackNameInput"></a>

```typescript
public readonly stackNameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `physicalResourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.physicalResourceId"></a>

```typescript
public readonly physicalResourceId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `resourceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* `string`

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

---

##### `stackName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.stackName"></a>

```typescript
public readonly stackName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudRtsStackV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_v1 opentelekomcloud_rts_stack_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsStackV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRtsStackV1(scope: Construct, id: string, config: DataOpentelekomcloudRtsStackV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `capabilities`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.capabilities"></a>

```typescript
public readonly capabilities: string[];
```

- *Type:* `string`[]

---

##### `disableRollback`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.disableRollback"></a>

```typescript
public readonly disableRollback: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `notificationTopics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.notificationTopics"></a>

```typescript
public readonly notificationTopics: string[];
```

- *Type:* `string`[]

---

##### `outputs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.outputs"></a>

```typescript
public readonly outputs: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `parameters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.parameters"></a>

```typescript
public readonly parameters: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `statusReason`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.statusReason"></a>

```typescript
public readonly statusReason: string;
```

- *Type:* `string`

---

##### `templateBody`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.templateBody"></a>

```typescript
public readonly templateBody: string;
```

- *Type:* `string`

---

##### `timeoutMins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.timeoutMins"></a>

```typescript
public readonly timeoutMins: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudS3BucketObject <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object opentelekomcloud_s3_bucket_object}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.Initializer"></a>

```typescript
import { DataOpentelekomcloudS3BucketObject } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudS3BucketObject(scope: Construct, id: string, config: DataOpentelekomcloudS3BucketObjectConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.resetId"></a>

```typescript
public resetId()
```

##### `resetRange` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.resetRange"></a>

```typescript
public resetRange()
```

##### `resetVersionId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.resetVersionId"></a>

```typescript
public resetVersionId()
```


#### Properties <a name="Properties"></a>

##### `body`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.body"></a>

```typescript
public readonly body: string;
```

- *Type:* `string`

---

##### `cacheControl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.cacheControl"></a>

```typescript
public readonly cacheControl: string;
```

- *Type:* `string`

---

##### `contentDisposition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.contentDisposition"></a>

```typescript
public readonly contentDisposition: string;
```

- *Type:* `string`

---

##### `contentEncoding`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: string;
```

- *Type:* `string`

---

##### `contentLanguage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.contentLanguage"></a>

```typescript
public readonly contentLanguage: string;
```

- *Type:* `string`

---

##### `contentLength`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.contentLength"></a>

```typescript
public readonly contentLength: number;
```

- *Type:* `number`

---

##### `contentType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

---

##### `etag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

---

##### `expiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.expiration"></a>

```typescript
public readonly expiration: string;
```

- *Type:* `string`

---

##### `expires`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.expires"></a>

```typescript
public readonly expires: string;
```

- *Type:* `string`

---

##### `lastModified`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.lastModified"></a>

```typescript
public readonly lastModified: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `serverSideEncryption`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: string;
```

- *Type:* `string`

---

##### `sseKmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.sseKmsKeyId"></a>

```typescript
public readonly sseKmsKeyId: string;
```

- *Type:* `string`

---

##### `websiteRedirectLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.websiteRedirectLocation"></a>

```typescript
public readonly websiteRedirectLocation: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `rangeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.rangeInput"></a>

```typescript
public readonly rangeInput: string;
```

- *Type:* `string`

---

##### `versionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.versionIdInput"></a>

```typescript
public readonly versionIdInput: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `range`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.range"></a>

```typescript
public readonly range: string;
```

- *Type:* `string`

---

##### `versionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObject.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudSdrsDomainV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sdrs_domain_v1 opentelekomcloud_sdrs_domain_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudSdrsDomainV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudSdrsDomainV1(scope: Construct, id: string, config?: DataOpentelekomcloudSdrsDomainV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.resetName"></a>

```typescript
public resetName()
```


#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudSfsFileSystemV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_file_system_v2 opentelekomcloud_sfs_file_system_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudSfsFileSystemV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudSfsFileSystemV2(scope: Construct, id: string, config?: DataOpentelekomcloudSfsFileSystemV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `accessLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.accessLevel"></a>

```typescript
public readonly accessLevel: string;
```

- *Type:* `string`

---

##### `accessTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.accessTo"></a>

```typescript
public readonly accessTo: string;
```

- *Type:* `string`

---

##### `accessType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.accessType"></a>

```typescript
public readonly accessType: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `exportLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.exportLocation"></a>

```typescript
public readonly exportLocation: string;
```

- *Type:* `string`

---

##### `exportLocations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.exportLocations"></a>

```typescript
public readonly exportLocations: string[];
```

- *Type:* `string`[]

---

##### `host`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* `string`

---

##### `isPublic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.isPublic"></a>

```typescript
public readonly isPublic: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `mountId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.mountId"></a>

```typescript
public readonly mountId: string;
```

- *Type:* `string`

---

##### `preferred`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.preferred"></a>

```typescript
public readonly preferred: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `shareAccessId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.shareAccessId"></a>

```typescript
public readonly shareAccessId: string;
```

- *Type:* `string`

---

##### `shareInstanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.shareInstanceId"></a>

```typescript
public readonly shareInstanceId: string;
```

- *Type:* `string`

---

##### `shareProto`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `state`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.state"></a>

```typescript
public readonly state: string;
```

- *Type:* `string`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudSfsTurboShareV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1 opentelekomcloud_sfs_turbo_share_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudSfsTurboShareV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudSfsTurboShareV1(scope: Construct, id: string, config: DataOpentelekomcloudSfsTurboShareV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `availableCapacity`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.availableCapacity"></a>

```typescript
public readonly availableCapacity: string;
```

- *Type:* `string`

---

##### `cryptKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.cryptKeyId"></a>

```typescript
public readonly cryptKeyId: string;
```

- *Type:* `string`

---

##### `exportLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.exportLocation"></a>

```typescript
public readonly exportLocation: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `shareProto`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVbsBackupPolicyV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2 opentelekomcloud_vbs_backup_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupPolicyV2(scope: Construct, id: string, config?: DataOpentelekomcloudVbsBackupPolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putFilterTags` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.putFilterTags"></a>

```typescript
public putFilterTags(value: IResolvable | DataOpentelekomcloudVbsBackupPolicyV2FilterTags[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags)[]

---

##### `resetFilterTags` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetFilterTags"></a>

```typescript
public resetFilterTags()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPolicyResourceCount` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetPolicyResourceCount"></a>

```typescript
public resetPolicyResourceCount()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `filterTags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.filterTags"></a>

```typescript
public readonly filterTags: DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList)

---

##### `frequency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.frequency"></a>

```typescript
public readonly frequency: number;
```

- *Type:* `number`

---

##### `remainFirstBackup`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.remainFirstBackup"></a>

```typescript
public readonly remainFirstBackup: string;
```

- *Type:* `string`

---

##### `rententionNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.rententionNum"></a>

```typescript
public readonly rententionNum: number;
```

- *Type:* `number`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.tags"></a>

```typescript
public readonly tags: DataOpentelekomcloudVbsBackupPolicyV2TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList)

---

##### `filterTagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.filterTagsInput"></a>

```typescript
public readonly filterTagsInput: IResolvable | DataOpentelekomcloudVbsBackupPolicyV2FilterTags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `policyResourceCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.policyResourceCountInput"></a>

```typescript
public readonly policyResourceCountInput: number;
```

- *Type:* `number`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `policyResourceCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.policyResourceCount"></a>

```typescript
public readonly policyResourceCount: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVbsBackupV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2 opentelekomcloud_vbs_backup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupV2(scope: Construct, id: string, config?: DataOpentelekomcloudVbsBackupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSnapshotId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetSnapshotId"></a>

```typescript
public resetSnapshotId()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetVolumeId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.resetVolumeId"></a>

```typescript
public resetVolumeId()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `container`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.container"></a>

```typescript
public readonly container: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `serviceMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.serviceMetadata"></a>

```typescript
public readonly serviceMetadata: string;
```

- *Type:* `string`

---

##### `shareIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.shareIds"></a>

```typescript
public readonly shareIds: string[];
```

- *Type:* `string`[]

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `toProjectIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.toProjectIds"></a>

```typescript
public readonly toProjectIds: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `volumeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.volumeIdInput"></a>

```typescript
public readonly volumeIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcBandwidth <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth opentelekomcloud_vpc_bandwidth}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcBandwidth } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcBandwidth(scope: Construct, id: string, config: DataOpentelekomcloudVpcBandwidthConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig)

---

#### Methods <a name="Methods"></a>

##### `resetEnterpriseProjectId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.resetEnterpriseProjectId"></a>

```typescript
public resetEnterpriseProjectId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.resetSize"></a>

```typescript
public resetSize()
```


#### Properties <a name="Properties"></a>

##### `bandwidthType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.bandwidthType"></a>

```typescript
public readonly bandwidthType: string;
```

- *Type:* `string`

---

##### `chargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.chargeMode"></a>

```typescript
public readonly chargeMode: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `enterpriseProjectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.enterpriseProjectIdInput"></a>

```typescript
public readonly enterpriseProjectIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `enterpriseProjectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.enterpriseProjectId"></a>

```typescript
public readonly enterpriseProjectId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidth.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcBandwidthV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth_v2 opentelekomcloud_vpc_bandwidth_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcBandwidthV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcBandwidthV2(scope: Construct, id: string, config?: DataOpentelekomcloudVpcBandwidthV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.resetName"></a>

```typescript
public resetName()
```

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.resetSize"></a>

```typescript
public resetSize()
```


#### Properties <a name="Properties"></a>

##### `bandwidthType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.bandwidthType"></a>

```typescript
public readonly bandwidthType: string;
```

- *Type:* `string`

---

##### `chargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.chargeMode"></a>

```typescript
public readonly chargeMode: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcEipV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1 opentelekomcloud_vpc_eip_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcEipV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcEipV1(scope: Construct, id: string, config?: DataOpentelekomcloudVpcEipV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetBandwidthId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetBandwidthId"></a>

```typescript
public resetBandwidthId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetPortId"></a>

```typescript
public resetPortId()
```

##### `resetPrivateIpAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetPrivateIpAddress"></a>

```typescript
public resetPrivateIpAddress()
```

##### `resetPublicIpAddress` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetPublicIpAddress"></a>

```typescript
public resetPublicIpAddress()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.resetTags"></a>

```typescript
public resetTags()
```


#### Properties <a name="Properties"></a>

##### `bandwidthShareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.bandwidthShareType"></a>

```typescript
public readonly bandwidthShareType: string;
```

- *Type:* `string`

---

##### `bandwidthSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

---

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `ipVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.ipVersion"></a>

```typescript
public readonly ipVersion: number;
```

- *Type:* `number`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `bandwidthIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.bandwidthIdInput"></a>

```typescript
public readonly bandwidthIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `privateIpAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.privateIpAddressInput"></a>

```typescript
public readonly privateIpAddressInput: string;
```

- *Type:* `string`

---

##### `publicIpAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.publicIpAddressInput"></a>

```typescript
public readonly publicIpAddressInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `bandwidthId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.bandwidthId"></a>

```typescript
public readonly bandwidthId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `privateIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.privateIpAddress"></a>

```typescript
public readonly privateIpAddress: string;
```

- *Type:* `string`

---

##### `publicIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.publicIpAddress"></a>

```typescript
public readonly publicIpAddress: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcepPublicServiceV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_public_service_v1 opentelekomcloud_vpcep_public_service_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepPublicServiceV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcepPublicServiceV1(scope: Construct, id: string, config?: DataOpentelekomcloudVpcepPublicServiceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.resetName"></a>

```typescript
public resetName()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `isCharge`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.isCharge"></a>

```typescript
public readonly isCharge: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `owner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* `string`

---

##### `serviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.serviceType"></a>

```typescript
public readonly serviceType: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcepServiceV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_service_v1 opentelekomcloud_vpcep_service_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepServiceV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcepServiceV1(scope: Construct, id: string, config?: DataOpentelekomcloudVpcepServiceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.resetName"></a>

```typescript
public resetName()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.resetTags"></a>

```typescript
public resetTags()
```


#### Properties <a name="Properties"></a>

##### `approvalEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.approvalEnabled"></a>

```typescript
public readonly approvalEnabled: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `connectionCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.connectionCount"></a>

```typescript
public readonly connectionCount: number;
```

- *Type:* `number`

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.port"></a>

```typescript
public readonly port: DataOpentelekomcloudVpcepServiceV1PortList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList)

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `serverType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.serverType"></a>

```typescript
public readonly serverType: string;
```

- *Type:* `string`

---

##### `serviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.serviceType"></a>

```typescript
public readonly serviceType: string;
```

- *Type:* `string`

---

##### `tcpProxy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.tcpProxy"></a>

```typescript
public readonly tcpProxy: string;
```

- *Type:* `string`

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `vipPortId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcPeeringConnectionV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2 opentelekomcloud_vpc_peering_connection_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcPeeringConnectionV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcPeeringConnectionV2(scope: Construct, id: string, config?: DataOpentelekomcloudVpcPeeringConnectionV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPeerTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetPeerTenantId"></a>

```typescript
public resetPeerTenantId()
```

##### `resetPeerVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetPeerVpcId"></a>

```typescript
public resetPeerVpcId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `peerTenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.peerTenantIdInput"></a>

```typescript
public readonly peerTenantIdInput: string;
```

- *Type:* `string`

---

##### `peerVpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.peerVpcIdInput"></a>

```typescript
public readonly peerVpcIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `peerTenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.peerTenantId"></a>

```typescript
public readonly peerTenantId: string;
```

- *Type:* `string`

---

##### `peerVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.peerVpcId"></a>

```typescript
public readonly peerVpcId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcRouteIdsV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_ids_v2 opentelekomcloud_vpc_route_ids_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcRouteIdsV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcRouteIdsV2(scope: Construct, id: string, config: DataOpentelekomcloudVpcRouteIdsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `ids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.ids"></a>

```typescript
public readonly ids: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcRouteV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2 opentelekomcloud_vpc_route_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcRouteV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcRouteV2(scope: Construct, id: string, config?: DataOpentelekomcloudVpcRouteV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetDestination` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetDestination"></a>

```typescript
public resetDestination()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetId"></a>

```typescript
public resetId()
```

##### `resetNexthop` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetNexthop"></a>

```typescript
public resetNexthop()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetType"></a>

```typescript
public resetType()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `destinationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.destinationInput"></a>

```typescript
public readonly destinationInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nexthopInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.nexthopInput"></a>

```typescript
public readonly nexthopInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `destination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.destination"></a>

```typescript
public readonly destination: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `nexthop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.nexthop"></a>

```typescript
public readonly nexthop: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcSubnetIdsV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_ids_v1 opentelekomcloud_vpc_subnet_ids_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcSubnetIdsV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcSubnetIdsV1(scope: Construct, id: string, config: DataOpentelekomcloudVpcSubnetIdsV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `ids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.ids"></a>

```typescript
public readonly ids: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcSubnetV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1 opentelekomcloud_vpc_subnet_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcSubnetV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcSubnetV1(scope: Construct, id: string, config?: DataOpentelekomcloudVpcSubnetV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetCidr` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetCidr"></a>

```typescript
public resetCidr()
```

##### `resetGatewayIp` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetGatewayIp"></a>

```typescript
public resetGatewayIp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetName"></a>

```typescript
public resetName()
```

##### `resetPrimaryDns` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetPrimaryDns"></a>

```typescript
public resetPrimaryDns()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecondaryDns` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetSecondaryDns"></a>

```typescript
public resetSecondaryDns()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetVpcId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.resetVpcId"></a>

```typescript
public resetVpcId()
```


#### Properties <a name="Properties"></a>

##### `dhcpEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.dhcpEnable"></a>

```typescript
public readonly dhcpEnable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `dnsList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.dnsList"></a>

```typescript
public readonly dnsList: string[];
```

- *Type:* `string`[]

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `gatewayIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.gatewayIpInput"></a>

```typescript
public readonly gatewayIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `primaryDnsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.primaryDnsInput"></a>

```typescript
public readonly primaryDnsInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `secondaryDnsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.secondaryDnsInput"></a>

```typescript
public readonly secondaryDnsInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `gatewayIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `primaryDns`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.primaryDns"></a>

```typescript
public readonly primaryDns: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `secondaryDns`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.secondaryDns"></a>

```typescript
public readonly secondaryDns: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpcV1 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1 opentelekomcloud_vpc_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcV1 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcV1(scope: Construct, id: string, config?: DataOpentelekomcloudVpcV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetCidr` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetCidr"></a>

```typescript
public resetCidr()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetShared` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetShared"></a>

```typescript
public resetShared()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `routes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.routes"></a>

```typescript
public readonly routes: DataOpentelekomcloudVpcV1RoutesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList)

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sharedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.sharedInput"></a>

```typescript
public readonly sharedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DataOpentelekomcloudVpnaasServiceV2 <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2 opentelekomcloud_vpnaas_service_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpnaasServiceV2 } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpnaasServiceV2(scope: Construct, id: string, config?: DataOpentelekomcloudVpnaasServiceV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetExternalV4Ip` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetExternalV4Ip"></a>

```typescript
public resetExternalV4Ip()
```

##### `resetExternalV6Ip` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetExternalV6Ip"></a>

```typescript
public resetExternalV6Ip()
```

##### `resetFlavorId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetFlavorId"></a>

```typescript
public resetFlavorId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetName"></a>

```typescript
public resetName()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRouterId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetRouterId"></a>

```typescript
public resetRouterId()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.resetTenantId"></a>

```typescript
public resetTenantId()
```


#### Properties <a name="Properties"></a>

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `externalV4IpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.externalV4IpInput"></a>

```typescript
public readonly externalV4IpInput: string;
```

- *Type:* `string`

---

##### `externalV6IpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.externalV6IpInput"></a>

```typescript
public readonly externalV6IpInput: string;
```

- *Type:* `string`

---

##### `flavorIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.flavorIdInput"></a>

```typescript
public readonly flavorIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `externalV4Ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.externalV4Ip"></a>

```typescript
public readonly externalV4Ip: string;
```

- *Type:* `string`

---

##### `externalV6Ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.externalV6Ip"></a>

```typescript
public readonly externalV6Ip: string;
```

- *Type:* `string`

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DcsInstanceV1 <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1 opentelekomcloud_dcs_instance_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.Initializer"></a>

```typescript
import { DcsInstanceV1 } from '@cdktf/provider-opentelekomcloud'

new DcsInstanceV1(scope: Construct, id: string, config: DcsInstanceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Config`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Config)

---

#### Methods <a name="Methods"></a>

##### `putBackupPolicy` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.putBackupPolicy"></a>

```typescript
public putBackupPolicy(value: DcsInstanceV1BackupPolicy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy)

---

##### `putConfiguration` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.putConfiguration"></a>

```typescript
public putConfiguration(value: IResolvable | DcsInstanceV1Configuration[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.putTimeouts"></a>

```typescript
public putTimeouts(value: DcsInstanceV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts)

---

##### `resetAccessUser` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetAccessUser"></a>

```typescript
public resetAccessUser()
```

##### `resetBackupAt` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetBackupAt"></a>

```typescript
public resetBackupAt()
```

##### `resetBackupPolicy` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetBackupPolicy"></a>

```typescript
public resetBackupPolicy()
```

##### `resetBackupType` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetBackupType"></a>

```typescript
public resetBackupType()
```

##### `resetBeginAt` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetBeginAt"></a>

```typescript
public resetBeginAt()
```

##### `resetConfiguration` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetConfiguration"></a>

```typescript
public resetConfiguration()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetMaintainBegin` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetMaintainBegin"></a>

```typescript
public resetMaintainBegin()
```

##### `resetMaintainEnd` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetMaintainEnd"></a>

```typescript
public resetMaintainEnd()
```

##### `resetPeriodType` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetPeriodType"></a>

```typescript
public resetPeriodType()
```

##### `resetSaveDays` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetSaveDays"></a>

```typescript
public resetSaveDays()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `backupPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupPolicy"></a>

```typescript
public readonly backupPolicy: DcsInstanceV1BackupPolicyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference)

---

##### `configuration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.configuration"></a>

```typescript
public readonly configuration: DcsInstanceV1ConfigurationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList)

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `internalVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.internalVersion"></a>

```typescript
public readonly internalVersion: string;
```

- *Type:* `string`

---

##### `ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.ip"></a>

```typescript
public readonly ip: string;
```

- *Type:* `string`

---

##### `maxMemory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.maxMemory"></a>

```typescript
public readonly maxMemory: number;
```

- *Type:* `number`

---

##### `orderId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `resourceSpecCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.resourceSpecCode"></a>

```typescript
public readonly resourceSpecCode: string;
```

- *Type:* `string`

---

##### `securityGroupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.securityGroupName"></a>

```typescript
public readonly securityGroupName: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `subnetName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.subnetName"></a>

```typescript
public readonly subnetName: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.timeouts"></a>

```typescript
public readonly timeouts: DcsInstanceV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference)

---

##### `usedMemory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.usedMemory"></a>

```typescript
public readonly usedMemory: number;
```

- *Type:* `number`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `userName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

##### `vpcName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* `string`

---

##### `accessUserInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.accessUserInput"></a>

```typescript
public readonly accessUserInput: string;
```

- *Type:* `string`

---

##### `availableZonesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.availableZonesInput"></a>

```typescript
public readonly availableZonesInput: string[];
```

- *Type:* `string`[]

---

##### `backupAtInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupAtInput"></a>

```typescript
public readonly backupAtInput: number[];
```

- *Type:* `number`[]

---

##### `backupPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupPolicyInput"></a>

```typescript
public readonly backupPolicyInput: DcsInstanceV1BackupPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy)

---

##### `backupTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupTypeInput"></a>

```typescript
public readonly backupTypeInput: string;
```

- *Type:* `string`

---

##### `beginAtInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.beginAtInput"></a>

```typescript
public readonly beginAtInput: string;
```

- *Type:* `string`

---

##### `capacityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.capacityInput"></a>

```typescript
public readonly capacityInput: number;
```

- *Type:* `number`

---

##### `configurationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.configurationInput"></a>

```typescript
public readonly configurationInput: IResolvable | DcsInstanceV1Configuration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration)[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `engineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.engineInput"></a>

```typescript
public readonly engineInput: string;
```

- *Type:* `string`

---

##### `engineVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.engineVersionInput"></a>

```typescript
public readonly engineVersionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `maintainBeginInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.maintainBeginInput"></a>

```typescript
public readonly maintainBeginInput: string;
```

- *Type:* `string`

---

##### `maintainEndInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.maintainEndInput"></a>

```typescript
public readonly maintainEndInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `periodTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.periodTypeInput"></a>

```typescript
public readonly periodTypeInput: string;
```

- *Type:* `string`

---

##### `productIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.productIdInput"></a>

```typescript
public readonly productIdInput: string;
```

- *Type:* `string`

---

##### `saveDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.saveDaysInput"></a>

```typescript
public readonly saveDaysInput: number;
```

- *Type:* `number`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DcsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `accessUser`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.accessUser"></a>

```typescript
public readonly accessUser: string;
```

- *Type:* `string`

---

##### `availableZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

---

##### `backupAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupAt"></a>

```typescript
public readonly backupAt: number[];
```

- *Type:* `number`[]

---

##### `backupType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.backupType"></a>

```typescript
public readonly backupType: string;
```

- *Type:* `string`

---

##### `beginAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.beginAt"></a>

```typescript
public readonly beginAt: string;
```

- *Type:* `string`

---

##### `capacity`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.capacity"></a>

```typescript
public readonly capacity: number;
```

- *Type:* `number`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

---

##### `engineVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.engineVersion"></a>

```typescript
public readonly engineVersion: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maintainBegin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.maintainBegin"></a>

```typescript
public readonly maintainBegin: string;
```

- *Type:* `string`

---

##### `maintainEnd`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.maintainEnd"></a>

```typescript
public readonly maintainEnd: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `periodType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

---

##### `saveDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.saveDays"></a>

```typescript
public readonly saveDays: number;
```

- *Type:* `number`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DdsInstanceV3 <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3 opentelekomcloud_dds_instance_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.Initializer"></a>

```typescript
import { DdsInstanceV3 } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3(scope: Construct, id: string, config: DdsInstanceV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Config`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Config)

---

#### Methods <a name="Methods"></a>

##### `putBackupStrategy` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.putBackupStrategy"></a>

```typescript
public putBackupStrategy(value: DdsInstanceV3BackupStrategy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy)

---

##### `putDatastore` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.putDatastore"></a>

```typescript
public putDatastore(value: DdsInstanceV3Datastore)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore)

---

##### `putFlavor` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.putFlavor"></a>

```typescript
public putFlavor(value: IResolvable | DdsInstanceV3Flavor[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.putTimeouts"></a>

```typescript
public putTimeouts(value: DdsInstanceV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts)

---

##### `resetBackupStrategy` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetBackupStrategy"></a>

```typescript
public resetBackupStrategy()
```

##### `resetDiskEncryptionId` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetDiskEncryptionId"></a>

```typescript
public resetDiskEncryptionId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSsl` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetSsl"></a>

```typescript
public resetSsl()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `backupStrategy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: DdsInstanceV3BackupStrategyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference)

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.datastore"></a>

```typescript
public readonly datastore: DdsInstanceV3DatastoreOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference)

---

##### `dbUsername`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.dbUsername"></a>

```typescript
public readonly dbUsername: string;
```

- *Type:* `string`

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.flavor"></a>

```typescript
public readonly flavor: DdsInstanceV3FlavorList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList)

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.nodes"></a>

```typescript
public readonly nodes: DdsInstanceV3NodesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList)

---

##### `payMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.payMode"></a>

```typescript
public readonly payMode: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.timeouts"></a>

```typescript
public readonly timeouts: DdsInstanceV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `backupStrategyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.backupStrategyInput"></a>

```typescript
public readonly backupStrategyInput: DdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy)

---

##### `datastoreInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.datastoreInput"></a>

```typescript
public readonly datastoreInput: DdsInstanceV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore)

---

##### `diskEncryptionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.diskEncryptionIdInput"></a>

```typescript
public readonly diskEncryptionIdInput: string;
```

- *Type:* `string`

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.flavorInput"></a>

```typescript
public readonly flavorInput: IResolvable | DdsInstanceV3Flavor[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `modeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `sslInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.sslInput"></a>

```typescript
public readonly sslInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DdsInstanceV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `diskEncryptionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `mode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `ssl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.ssl"></a>

```typescript
public readonly ssl: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3.property.tfResourceType"></a>

- *Type:* `string`

---

### DehHostV1 <a name="@cdktf/provider-opentelekomcloud.DehHostV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1 opentelekomcloud_deh_host_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DehHostV1.Initializer"></a>

```typescript
import { DehHostV1 } from '@cdktf/provider-opentelekomcloud'

new DehHostV1(scope: Construct, id: string, config: DehHostV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DehHostV1Config`](#@cdktf/provider-opentelekomcloud.DehHostV1Config)

---

#### Methods <a name="Methods"></a>

##### `putAvailableInstanceCapacities` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.putAvailableInstanceCapacities"></a>

```typescript
public putAvailableInstanceCapacities(value: IResolvable | DehHostV1AvailableInstanceCapacities[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.putTimeouts"></a>

```typescript
public putTimeouts(value: DehHostV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DehHostV1Timeouts`](#@cdktf/provider-opentelekomcloud.DehHostV1Timeouts)

---

##### `resetAutoPlacement` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetAutoPlacement"></a>

```typescript
public resetAutoPlacement()
```

##### `resetAvailableInstanceCapacities` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetAvailableInstanceCapacities"></a>

```typescript
public resetAvailableInstanceCapacities()
```

##### `resetAvailableMemory` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetAvailableMemory"></a>

```typescript
public resetAvailableMemory()
```

##### `resetAvailableVcpus` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetAvailableVcpus"></a>

```typescript
public resetAvailableVcpus()
```

##### `resetCores` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetCores"></a>

```typescript
public resetCores()
```

##### `resetHostTypeName` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetHostTypeName"></a>

```typescript
public resetHostTypeName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetId"></a>

```typescript
public resetId()
```

##### `resetInstanceTotal` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetInstanceTotal"></a>

```typescript
public resetInstanceTotal()
```

##### `resetInstanceUuids` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetInstanceUuids"></a>

```typescript
public resetInstanceUuids()
```

##### `resetMemory` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetMemory"></a>

```typescript
public resetMemory()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSockets` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetSockets"></a>

```typescript
public resetSockets()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVcpus` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.resetVcpus"></a>

```typescript
public resetVcpus()
```


#### Properties <a name="Properties"></a>

##### `availableInstanceCapacities`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableInstanceCapacities"></a>

```typescript
public readonly availableInstanceCapacities: DehHostV1AvailableInstanceCapacitiesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.timeouts"></a>

```typescript
public readonly timeouts: DehHostV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference)

---

##### `autoPlacementInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.autoPlacementInput"></a>

```typescript
public readonly autoPlacementInput: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `availableInstanceCapacitiesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableInstanceCapacitiesInput"></a>

```typescript
public readonly availableInstanceCapacitiesInput: IResolvable | DehHostV1AvailableInstanceCapacities[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities)[]

---

##### `availableMemoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableMemoryInput"></a>

```typescript
public readonly availableMemoryInput: number;
```

- *Type:* `number`

---

##### `availableVcpusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableVcpusInput"></a>

```typescript
public readonly availableVcpusInput: number;
```

- *Type:* `number`

---

##### `coresInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* `number`

---

##### `hostTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.hostTypeInput"></a>

```typescript
public readonly hostTypeInput: string;
```

- *Type:* `string`

---

##### `hostTypeNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.hostTypeNameInput"></a>

```typescript
public readonly hostTypeNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `instanceTotalInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.instanceTotalInput"></a>

```typescript
public readonly instanceTotalInput: number;
```

- *Type:* `number`

---

##### `instanceUuidsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.instanceUuidsInput"></a>

```typescript
public readonly instanceUuidsInput: string[];
```

- *Type:* `string`[]

---

##### `memoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `socketsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.socketsInput"></a>

```typescript
public readonly socketsInput: number;
```

- *Type:* `number`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DehHostV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1Timeouts`](#@cdktf/provider-opentelekomcloud.DehHostV1Timeouts)

---

##### `vcpusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.vcpusInput"></a>

```typescript
public readonly vcpusInput: number;
```

- *Type:* `number`

---

##### `autoPlacement`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.autoPlacement"></a>

```typescript
public readonly autoPlacement: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `availableMemory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableMemory"></a>

```typescript
public readonly availableMemory: number;
```

- *Type:* `number`

---

##### `availableVcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.availableVcpus"></a>

```typescript
public readonly availableVcpus: number;
```

- *Type:* `number`

---

##### `cores`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* `number`

---

##### `hostType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.hostType"></a>

```typescript
public readonly hostType: string;
```

- *Type:* `string`

---

##### `hostTypeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.hostTypeName"></a>

```typescript
public readonly hostTypeName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceTotal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.instanceTotal"></a>

```typescript
public readonly instanceTotal: number;
```

- *Type:* `number`

---

##### `instanceUuids`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.instanceUuids"></a>

```typescript
public readonly instanceUuids: string[];
```

- *Type:* `string`[]

---

##### `memory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sockets`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DehHostV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DmsGroupV1 <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_group_v1 opentelekomcloud_dms_group_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.Initializer"></a>

```typescript
import { DmsGroupV1 } from '@cdktf/provider-opentelekomcloud'

new DmsGroupV1(scope: Construct, id: string, config: DmsGroupV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DmsGroupV1Config`](#@cdktf/provider-opentelekomcloud.DmsGroupV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `availableDeadletters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.availableDeadletters"></a>

```typescript
public readonly availableDeadletters: number;
```

- *Type:* `number`

---

##### `availableMessages`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.availableMessages"></a>

```typescript
public readonly availableMessages: number;
```

- *Type:* `number`

---

##### `consumedMessages`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.consumedMessages"></a>

```typescript
public readonly consumedMessages: number;
```

- *Type:* `number`

---

##### `producedDeadletters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.producedDeadletters"></a>

```typescript
public readonly producedDeadletters: number;
```

- *Type:* `number`

---

##### `producedMessages`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.producedMessages"></a>

```typescript
public readonly producedMessages: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `queueIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.queueIdInput"></a>

```typescript
public readonly queueIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `queueId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DmsInstanceV1 <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1 opentelekomcloud_dms_instance_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.Initializer"></a>

```typescript
import { DmsInstanceV1 } from '@cdktf/provider-opentelekomcloud'

new DmsInstanceV1(scope: Construct, id: string, config: DmsInstanceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DmsInstanceV1Config`](#@cdktf/provider-opentelekomcloud.DmsInstanceV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetAccessUser` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetAccessUser"></a>

```typescript
public resetAccessUser()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetMaintainBegin` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetMaintainBegin"></a>

```typescript
public resetMaintainBegin()
```

##### `resetMaintainEnd` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetMaintainEnd"></a>

```typescript
public resetMaintainEnd()
```

##### `resetPartitionNum` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetPartitionNum"></a>

```typescript
public resetPartitionNum()
```

##### `resetPassword` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetPassword"></a>

```typescript
public resetPassword()
```

##### `resetRetentionPolicy` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetRetentionPolicy"></a>

```typescript
public resetRetentionPolicy()
```

##### `resetSpecification` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.resetSpecification"></a>

```typescript
public resetSpecification()
```


#### Properties <a name="Properties"></a>

##### `connectAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.connectAddress"></a>

```typescript
public readonly connectAddress: string;
```

- *Type:* `string`

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `orderId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `resourceSpecCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.resourceSpecCode"></a>

```typescript
public readonly resourceSpecCode: string;
```

- *Type:* `string`

---

##### `securityGroupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.securityGroupName"></a>

```typescript
public readonly securityGroupName: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `subnetName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.subnetName"></a>

```typescript
public readonly subnetName: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `usedStorageSpace`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.usedStorageSpace"></a>

```typescript
public readonly usedStorageSpace: number;
```

- *Type:* `number`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `userName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

##### `vpcName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* `string`

---

##### `accessUserInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.accessUserInput"></a>

```typescript
public readonly accessUserInput: string;
```

- *Type:* `string`

---

##### `availableZonesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.availableZonesInput"></a>

```typescript
public readonly availableZonesInput: string[];
```

- *Type:* `string`[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `engineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.engineInput"></a>

```typescript
public readonly engineInput: string;
```

- *Type:* `string`

---

##### `engineVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.engineVersionInput"></a>

```typescript
public readonly engineVersionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `maintainBeginInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.maintainBeginInput"></a>

```typescript
public readonly maintainBeginInput: string;
```

- *Type:* `string`

---

##### `maintainEndInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.maintainEndInput"></a>

```typescript
public readonly maintainEndInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `partitionNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.partitionNumInput"></a>

```typescript
public readonly partitionNumInput: number;
```

- *Type:* `number`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `productIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.productIdInput"></a>

```typescript
public readonly productIdInput: string;
```

- *Type:* `string`

---

##### `retentionPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.retentionPolicyInput"></a>

```typescript
public readonly retentionPolicyInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `specificationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.specificationInput"></a>

```typescript
public readonly specificationInput: string;
```

- *Type:* `string`

---

##### `storageSpaceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.storageSpaceInput"></a>

```typescript
public readonly storageSpaceInput: number;
```

- *Type:* `number`

---

##### `storageSpecCodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.storageSpecCodeInput"></a>

```typescript
public readonly storageSpecCodeInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `accessUser`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.accessUser"></a>

```typescript
public readonly accessUser: string;
```

- *Type:* `string`

---

##### `availableZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

---

##### `engineVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.engineVersion"></a>

```typescript
public readonly engineVersion: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maintainBegin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.maintainBegin"></a>

```typescript
public readonly maintainBegin: string;
```

- *Type:* `string`

---

##### `maintainEnd`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.maintainEnd"></a>

```typescript
public readonly maintainEnd: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `partitionNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.partitionNum"></a>

```typescript
public readonly partitionNum: number;
```

- *Type:* `number`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

---

##### `retentionPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.retentionPolicy"></a>

```typescript
public readonly retentionPolicy: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `specification`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.specification"></a>

```typescript
public readonly specification: string;
```

- *Type:* `string`

---

##### `storageSpace`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.storageSpace"></a>

```typescript
public readonly storageSpace: number;
```

- *Type:* `number`

---

##### `storageSpecCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.storageSpecCode"></a>

```typescript
public readonly storageSpecCode: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DmsQueueV1 <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1 opentelekomcloud_dms_queue_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.Initializer"></a>

```typescript
import { DmsQueueV1 } from '@cdktf/provider-opentelekomcloud'

new DmsQueueV1(scope: Construct, id: string, config: DmsQueueV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DmsQueueV1Config`](#@cdktf/provider-opentelekomcloud.DmsQueueV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetId"></a>

```typescript
public resetId()
```

##### `resetMaxConsumeCount` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetMaxConsumeCount"></a>

```typescript
public resetMaxConsumeCount()
```

##### `resetQueueMode` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetQueueMode"></a>

```typescript
public resetQueueMode()
```

##### `resetRedrivePolicy` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetRedrivePolicy"></a>

```typescript
public resetRedrivePolicy()
```

##### `resetRetentionHours` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.resetRetentionHours"></a>

```typescript
public resetRetentionHours()
```


#### Properties <a name="Properties"></a>

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.created"></a>

```typescript
public readonly created: number;
```

- *Type:* `number`

---

##### `groupCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.groupCount"></a>

```typescript
public readonly groupCount: number;
```

- *Type:* `number`

---

##### `maxMsgSizeByte`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.maxMsgSizeByte"></a>

```typescript
public readonly maxMsgSizeByte: number;
```

- *Type:* `number`

---

##### `producedMessages`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.producedMessages"></a>

```typescript
public readonly producedMessages: number;
```

- *Type:* `number`

---

##### `reservation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.reservation"></a>

```typescript
public readonly reservation: number;
```

- *Type:* `number`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `maxConsumeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.maxConsumeCountInput"></a>

```typescript
public readonly maxConsumeCountInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `queueModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.queueModeInput"></a>

```typescript
public readonly queueModeInput: string;
```

- *Type:* `string`

---

##### `redrivePolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.redrivePolicyInput"></a>

```typescript
public readonly redrivePolicyInput: string;
```

- *Type:* `string`

---

##### `retentionHoursInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.retentionHoursInput"></a>

```typescript
public readonly retentionHoursInput: number;
```

- *Type:* `number`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maxConsumeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.maxConsumeCount"></a>

```typescript
public readonly maxConsumeCount: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `queueMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.queueMode"></a>

```typescript
public readonly queueMode: string;
```

- *Type:* `string`

---

##### `redrivePolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.redrivePolicy"></a>

```typescript
public readonly redrivePolicy: string;
```

- *Type:* `string`

---

##### `retentionHours`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.retentionHours"></a>

```typescript
public readonly retentionHours: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1.property.tfResourceType"></a>

- *Type:* `string`

---

### DnsPtrrecordV2 <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2 opentelekomcloud_dns_ptrrecord_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.Initializer"></a>

```typescript
import { DnsPtrrecordV2 } from '@cdktf/provider-opentelekomcloud'

new DnsPtrrecordV2(scope: Construct, id: string, config: DnsPtrrecordV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.putTimeouts"></a>

```typescript
public putTimeouts(value: DnsPtrrecordV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTtl` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.resetTtl"></a>

```typescript
public resetTtl()
```


#### Properties <a name="Properties"></a>

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.timeouts"></a>

```typescript
public readonly timeouts: DnsPtrrecordV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `floatingipIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.floatingipIdInput"></a>

```typescript
public readonly floatingipIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DnsPtrrecordV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts)

---

##### `ttlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* `number`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `floatingipId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.floatingipId"></a>

```typescript
public readonly floatingipId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `ttl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DnsRecordsetV2 <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2 opentelekomcloud_dns_recordset_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.Initializer"></a>

```typescript
import { DnsRecordsetV2 } from '@cdktf/provider-opentelekomcloud'

new DnsRecordsetV2(scope: Construct, id: string, config: DnsRecordsetV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.putTimeouts"></a>

```typescript
public putTimeouts(value: DnsRecordsetV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTtl` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetTtl"></a>

```typescript
public resetTtl()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.shared"></a>

```typescript
public readonly shared: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.timeouts"></a>

```typescript
public readonly timeouts: DnsRecordsetV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `recordsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.recordsInput"></a>

```typescript
public readonly recordsInput: string[];
```

- *Type:* `string`[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DnsRecordsetV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts)

---

##### `ttlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `zoneIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `records`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.records"></a>

```typescript
public readonly records: string[];
```

- *Type:* `string`[]

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `ttl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `zoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2.property.tfResourceType"></a>

- *Type:* `string`

---

### DnsZoneV2 <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2 opentelekomcloud_dns_zone_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.Initializer"></a>

```typescript
import { DnsZoneV2 } from '@cdktf/provider-opentelekomcloud'

new DnsZoneV2(scope: Construct, id: string, config: DnsZoneV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsZoneV2Config`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Config)

---

#### Methods <a name="Methods"></a>

##### `putRouter` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.putRouter"></a>

```typescript
public putRouter(value: IResolvable | DnsZoneV2Router[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Router`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Router)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.putTimeouts"></a>

```typescript
public putTimeouts(value: DnsZoneV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEmail` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetEmail"></a>

```typescript
public resetEmail()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRouter` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetRouter"></a>

```typescript
public resetRouter()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTtl` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetTtl"></a>

```typescript
public resetTtl()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetType"></a>

```typescript
public resetType()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `masters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.masters"></a>

```typescript
public readonly masters: string[];
```

- *Type:* `string`[]

---

##### `router`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.router"></a>

```typescript
public readonly router: DnsZoneV2RouterList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList`](#@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.timeouts"></a>

```typescript
public readonly timeouts: DnsZoneV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `emailInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.emailInput"></a>

```typescript
public readonly emailInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.routerInput"></a>

```typescript
public readonly routerInput: IResolvable | DnsZoneV2Router[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Router`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Router)[]

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DnsZoneV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts)

---

##### `ttlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `email`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `ttl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2.property.tfResourceType"></a>

- *Type:* `string`

---

### EcsInstanceV1 <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1 opentelekomcloud_ecs_instance_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.Initializer"></a>

```typescript
import { EcsInstanceV1 } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1(scope: Construct, id: string, config: EcsInstanceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Config`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Config)

---

#### Methods <a name="Methods"></a>

##### `putDataDisks` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.putDataDisks"></a>

```typescript
public putDataDisks(value: IResolvable | EcsInstanceV1DataDisks[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks)[]

---

##### `putNics` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.putNics"></a>

```typescript
public putNics(value: IResolvable | EcsInstanceV1Nics[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.putTimeouts"></a>

```typescript
public putTimeouts(value: EcsInstanceV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts)

---

##### `resetAutoRecovery` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetAutoRecovery"></a>

```typescript
public resetAutoRecovery()
```

##### `resetDataDisks` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetDataDisks"></a>

```typescript
public resetDataDisks()
```

##### `resetDeleteDisksOnTermination` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetDeleteDisksOnTermination"></a>

```typescript
public resetDeleteDisksOnTermination()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetKeyName` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetKeyName"></a>

```typescript
public resetKeyName()
```

##### `resetPassword` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetPassword"></a>

```typescript
public resetPassword()
```

##### `resetSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetSecurityGroups"></a>

```typescript
public resetSecurityGroups()
```

##### `resetSystemDiskKmsId` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetSystemDiskKmsId"></a>

```typescript
public resetSystemDiskKmsId()
```

##### `resetSystemDiskSize` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetSystemDiskSize"></a>

```typescript
public resetSystemDiskSize()
```

##### `resetSystemDiskType` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetSystemDiskType"></a>

```typescript
public resetSystemDiskType()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetUserData` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.resetUserData"></a>

```typescript
public resetUserData()
```


#### Properties <a name="Properties"></a>

##### `dataDisks`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.dataDisks"></a>

```typescript
public readonly dataDisks: EcsInstanceV1DataDisksList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList)

---

##### `nics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.nics"></a>

```typescript
public readonly nics: EcsInstanceV1NicsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.timeouts"></a>

```typescript
public readonly timeouts: EcsInstanceV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference)

---

##### `autoRecoveryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.autoRecoveryInput"></a>

```typescript
public readonly autoRecoveryInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `dataDisksInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.dataDisksInput"></a>

```typescript
public readonly dataDisksInput: IResolvable | EcsInstanceV1DataDisks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks)[]

---

##### `deleteDisksOnTerminationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.deleteDisksOnTerminationInput"></a>

```typescript
public readonly deleteDisksOnTerminationInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.flavorInput"></a>

```typescript
public readonly flavorInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `keyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.keyNameInput"></a>

```typescript
public readonly keyNameInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nicsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.nicsInput"></a>

```typescript
public readonly nicsInput: IResolvable | EcsInstanceV1Nics[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics)[]

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `securityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.securityGroupsInput"></a>

```typescript
public readonly securityGroupsInput: string[];
```

- *Type:* `string`[]

---

##### `systemDiskKmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskKmsIdInput"></a>

```typescript
public readonly systemDiskKmsIdInput: string;
```

- *Type:* `string`

---

##### `systemDiskSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskSizeInput"></a>

```typescript
public readonly systemDiskSizeInput: number;
```

- *Type:* `number`

---

##### `systemDiskTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskTypeInput"></a>

```typescript
public readonly systemDiskTypeInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | EcsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts)

---

##### `userDataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.userDataInput"></a>

```typescript
public readonly userDataInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `autoRecovery`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.autoRecovery"></a>

```typescript
public readonly autoRecovery: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `deleteDisksOnTermination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.deleteDisksOnTermination"></a>

```typescript
public readonly deleteDisksOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `keyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

---

##### `systemDiskKmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskKmsId"></a>

```typescript
public readonly systemDiskKmsId: string;
```

- *Type:* `string`

---

##### `systemDiskSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskSize"></a>

```typescript
public readonly systemDiskSize: number;
```

- *Type:* `number`

---

##### `systemDiskType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.systemDiskType"></a>

```typescript
public readonly systemDiskType: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `userData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### EvsVolumeV3 <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3 opentelekomcloud_evs_volume_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.Initializer"></a>

```typescript
import { EvsVolumeV3 } from '@cdktf/provider-opentelekomcloud'

new EvsVolumeV3(scope: Construct, id: string, config: EvsVolumeV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Config`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.putTimeouts"></a>

```typescript
public putTimeouts(value: EvsVolumeV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts)

---

##### `resetBackupId` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetBackupId"></a>

```typescript
public resetBackupId()
```

##### `resetCascade` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetCascade"></a>

```typescript
public resetCascade()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDeviceType` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetDeviceType"></a>

```typescript
public resetDeviceType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetId"></a>

```typescript
public resetId()
```

##### `resetImageId` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetImageId"></a>

```typescript
public resetImageId()
```

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetKmsId"></a>

```typescript
public resetKmsId()
```

##### `resetMultiattach` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetMultiattach"></a>

```typescript
public resetMultiattach()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetName"></a>

```typescript
public resetName()
```

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetSize"></a>

```typescript
public resetSize()
```

##### `resetSnapshotId` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetSnapshotId"></a>

```typescript
public resetSnapshotId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `attachment`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.attachment"></a>

```typescript
public readonly attachment: EvsVolumeV3AttachmentList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.timeouts"></a>

```typescript
public readonly timeouts: EvsVolumeV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference)

---

##### `wwn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.wwn"></a>

```typescript
public readonly wwn: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `backupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* `string`

---

##### `cascadeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.cascadeInput"></a>

```typescript
public readonly cascadeInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `deviceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.deviceTypeInput"></a>

```typescript
public readonly deviceTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `multiattachInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.multiattachInput"></a>

```typescript
public readonly multiattachInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | EvsVolumeV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts)

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `backupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

---

##### `cascade`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.cascade"></a>

```typescript
public readonly cascade: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `deviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.deviceType"></a>

```typescript
public readonly deviceType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `multiattach`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.multiattach"></a>

```typescript
public readonly multiattach: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3.property.tfResourceType"></a>

- *Type:* `string`

---

### FwFirewallGroupV2 <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2 opentelekomcloud_fw_firewall_group_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.Initializer"></a>

```typescript
import { FwFirewallGroupV2 } from '@cdktf/provider-opentelekomcloud'

new FwFirewallGroupV2(scope: Construct, id: string, config?: FwFirewallGroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.putTimeouts"></a>

```typescript
public putTimeouts(value: FwFirewallGroupV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEgressPolicyId` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetEgressPolicyId"></a>

```typescript
public resetEgressPolicyId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIngressPolicyId` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetIngressPolicyId"></a>

```typescript
public resetIngressPolicyId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPorts` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetPorts"></a>

```typescript
public resetPorts()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.timeouts"></a>

```typescript
public readonly timeouts: FwFirewallGroupV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `egressPolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.egressPolicyIdInput"></a>

```typescript
public readonly egressPolicyIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ingressPolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.ingressPolicyIdInput"></a>

```typescript
public readonly ingressPolicyIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.portsInput"></a>

```typescript
public readonly portsInput: string[];
```

- *Type:* `string`[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | FwFirewallGroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `egressPolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.egressPolicyId"></a>

```typescript
public readonly egressPolicyId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ingressPolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.ingressPolicyId"></a>

```typescript
public readonly ingressPolicyId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `ports`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.ports"></a>

```typescript
public readonly ports: string[];
```

- *Type:* `string`[]

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### FwPolicyV2 <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2 opentelekomcloud_fw_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.Initializer"></a>

```typescript
import { FwPolicyV2 } from '@cdktf/provider-opentelekomcloud'

new FwPolicyV2(scope: Construct, id: string, config?: FwPolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.FwPolicyV2Config`](#@cdktf/provider-opentelekomcloud.FwPolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.putTimeouts"></a>

```typescript
public putTimeouts(value: FwPolicyV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts)

---

##### `resetAudited` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetAudited"></a>

```typescript
public resetAudited()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRules` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetRules"></a>

```typescript
public resetRules()
```

##### `resetShared` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetShared"></a>

```typescript
public resetShared()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.timeouts"></a>

```typescript
public readonly timeouts: FwPolicyV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference)

---

##### `auditedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.auditedInput"></a>

```typescript
public readonly auditedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `rulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.rulesInput"></a>

```typescript
public readonly rulesInput: string[];
```

- *Type:* `string`[]

---

##### `sharedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.sharedInput"></a>

```typescript
public readonly sharedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | FwPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `audited`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.audited"></a>

```typescript
public readonly audited: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `rules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.rules"></a>

```typescript
public readonly rules: string[];
```

- *Type:* `string`[]

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### FwRuleV2 <a name="@cdktf/provider-opentelekomcloud.FwRuleV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2 opentelekomcloud_fw_rule_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.Initializer"></a>

```typescript
import { FwRuleV2 } from '@cdktf/provider-opentelekomcloud'

new FwRuleV2(scope: Construct, id: string, config: FwRuleV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.FwRuleV2Config`](#@cdktf/provider-opentelekomcloud.FwRuleV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDestinationIpAddress` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetDestinationIpAddress"></a>

```typescript
public resetDestinationIpAddress()
```

##### `resetDestinationPort` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetDestinationPort"></a>

```typescript
public resetDestinationPort()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIpVersion` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetIpVersion"></a>

```typescript
public resetIpVersion()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSourceIpAddress` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetSourceIpAddress"></a>

```typescript
public resetSourceIpAddress()
```

##### `resetSourcePort` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetSourcePort"></a>

```typescript
public resetSourcePort()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `destinationIpAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.destinationIpAddressInput"></a>

```typescript
public readonly destinationIpAddressInput: string;
```

- *Type:* `string`

---

##### `destinationPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.destinationPortInput"></a>

```typescript
public readonly destinationPortInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.ipVersionInput"></a>

```typescript
public readonly ipVersionInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sourceIpAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.sourceIpAddressInput"></a>

```typescript
public readonly sourceIpAddressInput: string;
```

- *Type:* `string`

---

##### `sourcePortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.sourcePortInput"></a>

```typescript
public readonly sourcePortInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `destinationIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.destinationIpAddress"></a>

```typescript
public readonly destinationIpAddress: string;
```

- *Type:* `string`

---

##### `destinationPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.destinationPort"></a>

```typescript
public readonly destinationPort: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.ipVersion"></a>

```typescript
public readonly ipVersion: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sourceIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.sourceIpAddress"></a>

```typescript
public readonly sourceIpAddress: string;
```

- *Type:* `string`

---

##### `sourcePort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.sourcePort"></a>

```typescript
public readonly sourcePort: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.FwRuleV2.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityAgencyV3 <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3 opentelekomcloud_identity_agency_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.Initializer"></a>

```typescript
import { IdentityAgencyV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityAgencyV3(scope: Construct, id: string, config: IdentityAgencyV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config)

---

#### Methods <a name="Methods"></a>

##### `putProjectRole` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.putProjectRole"></a>

```typescript
public putProjectRole(value: IResolvable | IdentityAgencyV3ProjectRole[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.putTimeouts"></a>

```typescript
public putTimeouts(value: IdentityAgencyV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomainRoles` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.resetDomainRoles"></a>

```typescript
public resetDomainRoles()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectRole` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.resetProjectRole"></a>

```typescript
public resetProjectRole()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `duration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* `string`

---

##### `expireTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.expireTime"></a>

```typescript
public readonly expireTime: string;
```

- *Type:* `string`

---

##### `projectRole`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.projectRole"></a>

```typescript
public readonly projectRole: IdentityAgencyV3ProjectRoleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.timeouts"></a>

```typescript
public readonly timeouts: IdentityAgencyV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference)

---

##### `delegatedDomainNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.delegatedDomainNameInput"></a>

```typescript
public readonly delegatedDomainNameInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainRolesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.domainRolesInput"></a>

```typescript
public readonly domainRolesInput: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `projectRoleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.projectRoleInput"></a>

```typescript
public readonly projectRoleInput: IResolvable | IdentityAgencyV3ProjectRole[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | IdentityAgencyV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts)

---

##### `delegatedDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.delegatedDomainName"></a>

```typescript
public readonly delegatedDomainName: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domainRoles`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.domainRoles"></a>

```typescript
public readonly domainRoles: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityCredentialV3 <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_credential_v3 opentelekomcloud_identity_credential_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.Initializer"></a>

```typescript
import { IdentityCredentialV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityCredentialV3(scope: Construct, id: string, config?: IdentityCredentialV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config`](#@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.resetId"></a>

```typescript
public resetId()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetUserId` <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.resetUserId"></a>

```typescript
public resetUserId()
```


#### Properties <a name="Properties"></a>

##### `access`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.access"></a>

```typescript
public readonly access: string;
```

- *Type:* `string`

---

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `lastUseTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.lastUseTime"></a>

```typescript
public readonly lastUseTime: string;
```

- *Type:* `string`

---

##### `secret`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.secret"></a>

```typescript
public readonly secret: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityGroupMembershipV3 <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_membership_v3 opentelekomcloud_identity_group_membership_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.Initializer"></a>

```typescript
import { IdentityGroupMembershipV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityGroupMembershipV3(scope: Construct, id: string, config: IdentityGroupMembershipV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config`](#@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `groupInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.groupInput"></a>

```typescript
public readonly groupInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `usersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.usersInput"></a>

```typescript
public readonly usersInput: string[];
```

- *Type:* `string`[]

---

##### `group`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `users`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.users"></a>

```typescript
public readonly users: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityGroupV3 <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3 opentelekomcloud_identity_group_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.Initializer"></a>

```typescript
import { IdentityGroupV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityGroupV3(scope: Construct, id: string, config: IdentityGroupV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityGroupV3Config`](#@cdktf/provider-opentelekomcloud.IdentityGroupV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityMappingV3 <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_mapping_v3 opentelekomcloud_identity_mapping_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.Initializer"></a>

```typescript
import { IdentityMappingV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityMappingV3(scope: Construct, id: string, config: IdentityMappingV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityMappingV3Config`](#@cdktf/provider-opentelekomcloud.IdentityMappingV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `links`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.links"></a>

```typescript
public readonly links: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `mappingIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.mappingIdInput"></a>

```typescript
public readonly mappingIdInput: string;
```

- *Type:* `string`

---

##### `rulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.rulesInput"></a>

```typescript
public readonly rulesInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `mappingId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.mappingId"></a>

```typescript
public readonly mappingId: string;
```

- *Type:* `string`

---

##### `rules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.rules"></a>

```typescript
public readonly rules: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityProjectV3 <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3 opentelekomcloud_identity_project_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.Initializer"></a>

```typescript
import { IdentityProjectV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityProjectV3(scope: Construct, id: string, config: IdentityProjectV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProjectV3Config`](#@cdktf/provider-opentelekomcloud.IdentityProjectV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.resetId"></a>

```typescript
public resetId()
```

##### `resetParentId` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.resetParentId"></a>

```typescript
public resetParentId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.isDomain"></a>

```typescript
public readonly isDomain: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `parentIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.parentIdInput"></a>

```typescript
public readonly parentIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `parentId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.parentId"></a>

```typescript
public readonly parentId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityProtocolV3 <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3 opentelekomcloud_identity_protocol_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.Initializer"></a>

```typescript
import { IdentityProtocolV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityProtocolV3(scope: Construct, id: string, config: IdentityProtocolV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config)

---

#### Methods <a name="Methods"></a>

##### `putMetadata` <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.putMetadata"></a>

```typescript
public putMetadata(value: IdentityProtocolV3Metadata)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.resetId"></a>

```typescript
public resetId()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.resetMetadata"></a>

```typescript
public resetMetadata()
```


#### Properties <a name="Properties"></a>

##### `links`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.links"></a>

```typescript
public readonly links: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.metadata"></a>

```typescript
public readonly metadata: IdentityProtocolV3MetadataOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `mappingIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.mappingIdInput"></a>

```typescript
public readonly mappingIdInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.metadataInput"></a>

```typescript
public readonly metadataInput: IdentityProtocolV3Metadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata)

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `providerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.providerIdInput"></a>

```typescript
public readonly providerIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `mappingId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.mappingId"></a>

```typescript
public readonly mappingId: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `providerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityProviderV3 <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_provider_v3 opentelekomcloud_identity_provider_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.Initializer"></a>

```typescript
import { IdentityProviderV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityProviderV3(scope: Construct, id: string, config: IdentityProviderV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProviderV3Config`](#@cdktf/provider-opentelekomcloud.IdentityProviderV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `links`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.links"></a>

```typescript
public readonly links: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `remoteIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.remoteIds"></a>

```typescript
public readonly remoteIds: string[];
```

- *Type:* `string`[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityRoleAssignmentV3 <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3 opentelekomcloud_identity_role_assignment_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.Initializer"></a>

```typescript
import { IdentityRoleAssignmentV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityRoleAssignmentV3(scope: Construct, id: string, config: IdentityRoleAssignmentV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config`](#@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetGroupId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.resetGroupId"></a>

```typescript
public resetGroupId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetUserId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.resetUserId"></a>

```typescript
public resetUserId()
```


#### Properties <a name="Properties"></a>

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `groupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `roleIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.roleIdInput"></a>

```typescript
public readonly roleIdInput: string;
```

- *Type:* `string`

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `groupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `roleId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.roleId"></a>

```typescript
public readonly roleId: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityRoleV3 <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3 opentelekomcloud_identity_role_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.Initializer"></a>

```typescript
import { IdentityRoleV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityRoleV3(scope: Construct, id: string, config: IdentityRoleV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Config`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Config)

---

#### Methods <a name="Methods"></a>

##### `putStatement` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.putStatement"></a>

```typescript
public putStatement(value: IResolvable | IdentityRoleV3Statement[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement)[]

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `catalog`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.catalog"></a>

```typescript
public readonly catalog: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `statement`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.statement"></a>

```typescript
public readonly statement: IdentityRoleV3StatementList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `displayLayerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.displayLayerInput"></a>

```typescript
public readonly displayLayerInput: string;
```

- *Type:* `string`

---

##### `displayNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.displayNameInput"></a>

```typescript
public readonly displayNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `statementInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.statementInput"></a>

```typescript
public readonly statementInput: IResolvable | IdentityRoleV3Statement[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement)[]

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `displayLayer`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.displayLayer"></a>

```typescript
public readonly displayLayer: string;
```

- *Type:* `string`

---

##### `displayName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.displayName"></a>

```typescript
public readonly displayName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityUserGroupMembershipV3 <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_group_membership_v3 opentelekomcloud_identity_user_group_membership_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.Initializer"></a>

```typescript
import { IdentityUserGroupMembershipV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityUserGroupMembershipV3(scope: Construct, id: string, config: IdentityUserGroupMembershipV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config`](#@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `groupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.groupsInput"></a>

```typescript
public readonly groupsInput: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `userInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.userInput"></a>

```typescript
public readonly userInput: string;
```

- *Type:* `string`

---

##### `groups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.groups"></a>

```typescript
public readonly groups: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `user`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3.property.tfResourceType"></a>

- *Type:* `string`

---

### IdentityUserV3 <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3 opentelekomcloud_identity_user_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.Initializer"></a>

```typescript
import { IdentityUserV3 } from '@cdktf/provider-opentelekomcloud'

new IdentityUserV3(scope: Construct, id: string, config?: IdentityUserV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityUserV3Config`](#@cdktf/provider-opentelekomcloud.IdentityUserV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDefaultProjectId` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetDefaultProjectId"></a>

```typescript
public resetDefaultProjectId()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetEmail` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetEmail"></a>

```typescript
public resetEmail()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetName"></a>

```typescript
public resetName()
```

##### `resetPassword` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetPassword"></a>

```typescript
public resetPassword()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSendWelcomeEmail` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.resetSendWelcomeEmail"></a>

```typescript
public resetSendWelcomeEmail()
```


#### Properties <a name="Properties"></a>

##### `defaultProjectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.defaultProjectIdInput"></a>

```typescript
public readonly defaultProjectIdInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `emailInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.emailInput"></a>

```typescript
public readonly emailInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sendWelcomeEmailInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.sendWelcomeEmailInput"></a>

```typescript
public readonly sendWelcomeEmailInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `defaultProjectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.defaultProjectId"></a>

```typescript
public readonly defaultProjectId: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `email`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sendWelcomeEmail`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.sendWelcomeEmail"></a>

```typescript
public readonly sendWelcomeEmail: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3.property.tfResourceType"></a>

- *Type:* `string`

---

### ImagesImageAccessAcceptV2 <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_accept_v2 opentelekomcloud_images_image_access_accept_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.Initializer"></a>

```typescript
import { ImagesImageAccessAcceptV2 } from '@cdktf/provider-opentelekomcloud'

new ImagesImageAccessAcceptV2(scope: Construct, id: string, config: ImagesImageAccessAcceptV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config`](#@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `schema`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.schema"></a>

```typescript
public readonly schema: string;
```

- *Type:* `string`

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `memberIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.memberIdInput"></a>

```typescript
public readonly memberIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `memberId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.memberId"></a>

```typescript
public readonly memberId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ImagesImageAccessV2 <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_v2 opentelekomcloud_images_image_access_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.Initializer"></a>

```typescript
import { ImagesImageAccessV2 } from '@cdktf/provider-opentelekomcloud'

new ImagesImageAccessV2(scope: Construct, id: string, config: ImagesImageAccessV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config`](#@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.resetId"></a>

```typescript
public resetId()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.resetStatus"></a>

```typescript
public resetStatus()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `schema`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.schema"></a>

```typescript
public readonly schema: string;
```

- *Type:* `string`

---

##### `updateAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.updateAt"></a>

```typescript
public readonly updateAt: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* `string`

---

##### `memberIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.memberIdInput"></a>

```typescript
public readonly memberIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

---

##### `memberId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.memberId"></a>

```typescript
public readonly memberId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ImagesImageV2 <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2 opentelekomcloud_images_image_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.Initializer"></a>

```typescript
import { ImagesImageV2 } from '@cdktf/provider-opentelekomcloud'

new ImagesImageV2(scope: Construct, id: string, config: ImagesImageV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageV2Config`](#@cdktf/provider-opentelekomcloud.ImagesImageV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ImagesImageV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageCachePath` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetImageCachePath"></a>

```typescript
public resetImageCachePath()
```

##### `resetImageSourceUrl` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetImageSourceUrl"></a>

```typescript
public resetImageSourceUrl()
```

##### `resetLocalFilePath` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetLocalFilePath"></a>

```typescript
public resetLocalFilePath()
```

##### `resetMinDiskGb` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetMinDiskGb"></a>

```typescript
public resetMinDiskGb()
```

##### `resetMinRamMb` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetMinRamMb"></a>

```typescript
public resetMinRamMb()
```

##### `resetProtected` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetProtected"></a>

```typescript
public resetProtected()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVisibility` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.resetVisibility"></a>

```typescript
public resetVisibility()
```


#### Properties <a name="Properties"></a>

##### `checksum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.checksum"></a>

```typescript
public readonly checksum: string;
```

- *Type:* `string`

---

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `file`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.file"></a>

```typescript
public readonly file: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `owner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* `string`

---

##### `schema`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.schema"></a>

```typescript
public readonly schema: string;
```

- *Type:* `string`

---

##### `sizeBytes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.sizeBytes"></a>

```typescript
public readonly sizeBytes: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.timeouts"></a>

```typescript
public readonly timeouts: ImagesImageV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference)

---

##### `updateAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.updateAt"></a>

```typescript
public readonly updateAt: string;
```

- *Type:* `string`

---

##### `containerFormatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.containerFormatInput"></a>

```typescript
public readonly containerFormatInput: string;
```

- *Type:* `string`

---

##### `diskFormatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.diskFormatInput"></a>

```typescript
public readonly diskFormatInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageCachePathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.imageCachePathInput"></a>

```typescript
public readonly imageCachePathInput: string;
```

- *Type:* `string`

---

##### `imageSourceUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.imageSourceUrlInput"></a>

```typescript
public readonly imageSourceUrlInput: string;
```

- *Type:* `string`

---

##### `localFilePathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.localFilePathInput"></a>

```typescript
public readonly localFilePathInput: string;
```

- *Type:* `string`

---

##### `minDiskGbInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.minDiskGbInput"></a>

```typescript
public readonly minDiskGbInput: number;
```

- *Type:* `number`

---

##### `minRamMbInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.minRamMbInput"></a>

```typescript
public readonly minRamMbInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protectedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.protectedInput"></a>

```typescript
public readonly protectedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: string[];
```

- *Type:* `string`[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ImagesImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts)

---

##### `visibilityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.visibilityInput"></a>

```typescript
public readonly visibilityInput: string;
```

- *Type:* `string`

---

##### `containerFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.containerFormat"></a>

```typescript
public readonly containerFormat: string;
```

- *Type:* `string`

---

##### `diskFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.diskFormat"></a>

```typescript
public readonly diskFormat: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageCachePath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.imageCachePath"></a>

```typescript
public readonly imageCachePath: string;
```

- *Type:* `string`

---

##### `imageSourceUrl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.imageSourceUrl"></a>

```typescript
public readonly imageSourceUrl: string;
```

- *Type:* `string`

---

##### `localFilePath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.localFilePath"></a>

```typescript
public readonly localFilePath: string;
```

- *Type:* `string`

---

##### `minDiskGb`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.minDiskGb"></a>

```typescript
public readonly minDiskGb: number;
```

- *Type:* `number`

---

##### `minRamMb`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.minRamMb"></a>

```typescript
public readonly minRamMb: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protected`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.protected"></a>

```typescript
public readonly protected: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

---

##### `visibility`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ImsDataImageV2 <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2 opentelekomcloud_ims_data_image_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.Initializer"></a>

```typescript
import { ImsDataImageV2 } from '@cdktf/provider-opentelekomcloud'

new ImsDataImageV2(scope: Construct, id: string, config: ImsDataImageV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsDataImageV2Config`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ImsDataImageV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts)

---

##### `resetCmkId` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetCmkId"></a>

```typescript
public resetCmkId()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageUrl` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetImageUrl"></a>

```typescript
public resetImageUrl()
```

##### `resetMinDisk` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetMinDisk"></a>

```typescript
public resetMinDisk()
```

##### `resetOsType` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetOsType"></a>

```typescript
public resetOsType()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVolumeId` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.resetVolumeId"></a>

```typescript
public resetVolumeId()
```


#### Properties <a name="Properties"></a>

##### `dataOrigin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.dataOrigin"></a>

```typescript
public readonly dataOrigin: string;
```

- *Type:* `string`

---

##### `diskFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.diskFormat"></a>

```typescript
public readonly diskFormat: string;
```

- *Type:* `string`

---

##### `imageSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.imageSize"></a>

```typescript
public readonly imageSize: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.timeouts"></a>

```typescript
public readonly timeouts: ImsDataImageV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference)

---

##### `visibility`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

---

##### `cmkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.cmkIdInput"></a>

```typescript
public readonly cmkIdInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.imageUrlInput"></a>

```typescript
public readonly imageUrlInput: string;
```

- *Type:* `string`

---

##### `minDiskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.minDiskInput"></a>

```typescript
public readonly minDiskInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `osTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.osTypeInput"></a>

```typescript
public readonly osTypeInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ImsDataImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts)

---

##### `volumeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.volumeIdInput"></a>

```typescript
public readonly volumeIdInput: string;
```

- *Type:* `string`

---

##### `cmkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.cmkId"></a>

```typescript
public readonly cmkId: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageUrl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.imageUrl"></a>

```typescript
public readonly imageUrl: string;
```

- *Type:* `string`

---

##### `minDisk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `osType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.osType"></a>

```typescript
public readonly osType: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ImsImageV2 <a name="@cdktf/provider-opentelekomcloud.ImsImageV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2 opentelekomcloud_ims_image_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.Initializer"></a>

```typescript
import { ImsImageV2 } from '@cdktf/provider-opentelekomcloud'

new ImsImageV2(scope: Construct, id: string, config: ImsImageV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsImageV2Config`](#@cdktf/provider-opentelekomcloud.ImsImageV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.putTimeouts"></a>

```typescript
public putTimeouts(value: ImsImageV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts)

---

##### `resetCmkId` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetCmkId"></a>

```typescript
public resetCmkId()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetId"></a>

```typescript
public resetId()
```

##### `resetImageUrl` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetImageUrl"></a>

```typescript
public resetImageUrl()
```

##### `resetInstanceId` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetInstanceId"></a>

```typescript
public resetInstanceId()
```

##### `resetIsConfig` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetIsConfig"></a>

```typescript
public resetIsConfig()
```

##### `resetMaxRam` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetMaxRam"></a>

```typescript
public resetMaxRam()
```

##### `resetMinDisk` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetMinDisk"></a>

```typescript
public resetMinDisk()
```

##### `resetMinRam` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetMinRam"></a>

```typescript
public resetMinRam()
```

##### `resetOsVersion` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetOsVersion"></a>

```typescript
public resetOsVersion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `dataOrigin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.dataOrigin"></a>

```typescript
public readonly dataOrigin: string;
```

- *Type:* `string`

---

##### `diskFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.diskFormat"></a>

```typescript
public readonly diskFormat: string;
```

- *Type:* `string`

---

##### `file`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.file"></a>

```typescript
public readonly file: string;
```

- *Type:* `string`

---

##### `imageSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.imageSize"></a>

```typescript
public readonly imageSize: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.timeouts"></a>

```typescript
public readonly timeouts: ImsImageV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference)

---

##### `visibility`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

---

##### `cmkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.cmkIdInput"></a>

```typescript
public readonly cmkIdInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `imageUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.imageUrlInput"></a>

```typescript
public readonly imageUrlInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `isConfigInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.isConfigInput"></a>

```typescript
public readonly isConfigInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `maxRamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.maxRamInput"></a>

```typescript
public readonly maxRamInput: number;
```

- *Type:* `number`

---

##### `minDiskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.minDiskInput"></a>

```typescript
public readonly minDiskInput: number;
```

- *Type:* `number`

---

##### `minRamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.minRamInput"></a>

```typescript
public readonly minRamInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `osVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.osVersionInput"></a>

```typescript
public readonly osVersionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ImsImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `cmkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.cmkId"></a>

```typescript
public readonly cmkId: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageUrl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.imageUrl"></a>

```typescript
public readonly imageUrl: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `isConfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.isConfig"></a>

```typescript
public readonly isConfig: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `maxRam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.maxRam"></a>

```typescript
public readonly maxRam: number;
```

- *Type:* `number`

---

##### `minDisk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

---

##### `minRam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `osVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.osVersion"></a>

```typescript
public readonly osVersion: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2.property.tfResourceType"></a>

- *Type:* `string`

---

### KmsGrantV1 <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1 opentelekomcloud_kms_grant_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.Initializer"></a>

```typescript
import { KmsGrantV1 } from '@cdktf/provider-opentelekomcloud'

new KmsGrantV1(scope: Construct, id: string, config: KmsGrantV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.KmsGrantV1Config`](#@cdktf/provider-opentelekomcloud.KmsGrantV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.resetName"></a>

```typescript
public resetName()
```

##### `resetOperations` <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.resetOperations"></a>

```typescript
public resetOperations()
```

##### `resetRetiringPrincipal` <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.resetRetiringPrincipal"></a>

```typescript
public resetRetiringPrincipal()
```


#### Properties <a name="Properties"></a>

##### `creationDate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.creationDate"></a>

```typescript
public readonly creationDate: string;
```

- *Type:* `string`

---

##### `issuingPrincipal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.issuingPrincipal"></a>

```typescript
public readonly issuingPrincipal: string;
```

- *Type:* `string`

---

##### `granteePrincipalInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.granteePrincipalInput"></a>

```typescript
public readonly granteePrincipalInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.keyIdInput"></a>

```typescript
public readonly keyIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `operationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.operationsInput"></a>

```typescript
public readonly operationsInput: string[];
```

- *Type:* `string`[]

---

##### `retiringPrincipalInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.retiringPrincipalInput"></a>

```typescript
public readonly retiringPrincipalInput: string;
```

- *Type:* `string`

---

##### `granteePrincipal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.granteePrincipal"></a>

```typescript
public readonly granteePrincipal: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `keyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `operations`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* `string`[]

---

##### `retiringPrincipal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.retiringPrincipal"></a>

```typescript
public readonly retiringPrincipal: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1.property.tfResourceType"></a>

- *Type:* `string`

---

### KmsKeyV1 <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1 opentelekomcloud_kms_key_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.Initializer"></a>

```typescript
import { KmsKeyV1 } from '@cdktf/provider-opentelekomcloud'

new KmsKeyV1(scope: Construct, id: string, config: KmsKeyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.KmsKeyV1Config`](#@cdktf/provider-opentelekomcloud.KmsKeyV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetIsEnabled` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetIsEnabled"></a>

```typescript
public resetIsEnabled()
```

##### `resetKeyDescription` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetKeyDescription"></a>

```typescript
public resetKeyDescription()
```

##### `resetPendingDays` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetPendingDays"></a>

```typescript
public resetPendingDays()
```

##### `resetRealm` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetRealm"></a>

```typescript
public resetRealm()
```

##### `resetRotationEnabled` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetRotationEnabled"></a>

```typescript
public resetRotationEnabled()
```

##### `resetRotationInterval` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetRotationInterval"></a>

```typescript
public resetRotationInterval()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.resetTags"></a>

```typescript
public resetTags()
```


#### Properties <a name="Properties"></a>

##### `creationDate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.creationDate"></a>

```typescript
public readonly creationDate: string;
```

- *Type:* `string`

---

##### `defaultKeyFlag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.defaultKeyFlag"></a>

```typescript
public readonly defaultKeyFlag: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `expirationTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.expirationTime"></a>

```typescript
public readonly expirationTime: string;
```

- *Type:* `string`

---

##### `origin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.origin"></a>

```typescript
public readonly origin: string;
```

- *Type:* `string`

---

##### `rotationNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.rotationNumber"></a>

```typescript
public readonly rotationNumber: number;
```

- *Type:* `number`

---

##### `scheduledDeletionDate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.scheduledDeletionDate"></a>

```typescript
public readonly scheduledDeletionDate: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `isEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.isEnabledInput"></a>

```typescript
public readonly isEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `keyAliasInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.keyAliasInput"></a>

```typescript
public readonly keyAliasInput: string;
```

- *Type:* `string`

---

##### `keyDescriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.keyDescriptionInput"></a>

```typescript
public readonly keyDescriptionInput: string;
```

- *Type:* `string`

---

##### `pendingDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.pendingDaysInput"></a>

```typescript
public readonly pendingDaysInput: string;
```

- *Type:* `string`

---

##### `realmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.realmInput"></a>

```typescript
public readonly realmInput: string;
```

- *Type:* `string`

---

##### `rotationEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.rotationEnabledInput"></a>

```typescript
public readonly rotationEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `rotationIntervalInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.rotationIntervalInput"></a>

```typescript
public readonly rotationIntervalInput: number;
```

- *Type:* `number`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `isEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.isEnabled"></a>

```typescript
public readonly isEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `keyAlias`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.keyAlias"></a>

```typescript
public readonly keyAlias: string;
```

- *Type:* `string`

---

##### `keyDescription`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.keyDescription"></a>

```typescript
public readonly keyDescription: string;
```

- *Type:* `string`

---

##### `pendingDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.pendingDays"></a>

```typescript
public readonly pendingDays: string;
```

- *Type:* `string`

---

##### `realm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.realm"></a>

```typescript
public readonly realm: string;
```

- *Type:* `string`

---

##### `rotationEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.rotationEnabled"></a>

```typescript
public readonly rotationEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `rotationInterval`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.rotationInterval"></a>

```typescript
public readonly rotationInterval: number;
```

- *Type:* `number`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### LbCertificateV2 <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2 opentelekomcloud_lb_certificate_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.Initializer"></a>

```typescript
import { LbCertificateV2 } from '@cdktf/provider-opentelekomcloud'

new LbCertificateV2(scope: Construct, id: string, config: LbCertificateV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbCertificateV2Config`](#@cdktf/provider-opentelekomcloud.LbCertificateV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbCertificateV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomain` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetDomain"></a>

```typescript
public resetDomain()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPrivateKey` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetPrivateKey"></a>

```typescript
public resetPrivateKey()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `expireTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.expireTime"></a>

```typescript
public readonly expireTime: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbCertificateV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference)

---

##### `updateTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.updateTime"></a>

```typescript
public readonly updateTime: string;
```

- *Type:* `string`

---

##### `certificateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.certificateInput"></a>

```typescript
public readonly certificateInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.domainInput"></a>

```typescript
public readonly domainInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `privateKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.privateKeyInput"></a>

```typescript
public readonly privateKeyInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbCertificateV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `certificate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.certificate"></a>

```typescript
public readonly certificate: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbCertificateV3 <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3 opentelekomcloud_lb_certificate_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.Initializer"></a>

```typescript
import { LbCertificateV3 } from '@cdktf/provider-opentelekomcloud'

new LbCertificateV3(scope: Construct, id: string, config: LbCertificateV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbCertificateV3Config`](#@cdktf/provider-opentelekomcloud.LbCertificateV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDomain` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetDomain"></a>

```typescript
public resetDomain()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetName"></a>

```typescript
public resetName()
```

##### `resetPrivateKey` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetPrivateKey"></a>

```typescript
public resetPrivateKey()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `expireTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.expireTime"></a>

```typescript
public readonly expireTime: string;
```

- *Type:* `string`

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `certificateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.certificateInput"></a>

```typescript
public readonly certificateInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.domainInput"></a>

```typescript
public readonly domainInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `privateKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.privateKeyInput"></a>

```typescript
public readonly privateKeyInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `certificate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.certificate"></a>

```typescript
public readonly certificate: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbL7PolicyV2 <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2 opentelekomcloud_lb_l7policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.Initializer"></a>

```typescript
import { LbL7PolicyV2 } from '@cdktf/provider-opentelekomcloud'

new LbL7PolicyV2(scope: Construct, id: string, config: LbL7PolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbL7PolicyV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPosition` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetPosition"></a>

```typescript
public resetPosition()
```

##### `resetRedirectListenerId` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetRedirectListenerId"></a>

```typescript
public resetRedirectListenerId()
```

##### `resetRedirectPoolId` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetRedirectPoolId"></a>

```typescript
public resetRedirectPoolId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbL7PolicyV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference)

---

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `listenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.listenerIdInput"></a>

```typescript
public readonly listenerIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `positionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* `number`

---

##### `redirectListenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.redirectListenerIdInput"></a>

```typescript
public readonly redirectListenerIdInput: string;
```

- *Type:* `string`

---

##### `redirectPoolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.redirectPoolIdInput"></a>

```typescript
public readonly redirectPoolIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbL7PolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts)

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `position`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* `number`

---

##### `redirectListenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.redirectListenerId"></a>

```typescript
public readonly redirectListenerId: string;
```

- *Type:* `string`

---

##### `redirectPoolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.redirectPoolId"></a>

```typescript
public readonly redirectPoolId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbL7RuleV2 <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2 opentelekomcloud_lb_l7rule_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.Initializer"></a>

```typescript
import { LbL7RuleV2 } from '@cdktf/provider-opentelekomcloud'

new LbL7RuleV2(scope: Construct, id: string, config: LbL7RuleV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7RuleV2Config`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbL7RuleV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetId"></a>

```typescript
public resetId()
```

##### `resetKey` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetKey"></a>

```typescript
public resetKey()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbL7RuleV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `compareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.compareTypeInput"></a>

```typescript
public readonly compareTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `l7PolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.l7PolicyIdInput"></a>

```typescript
public readonly l7PolicyIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbL7RuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `l7PolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.l7PolicyId"></a>

```typescript
public readonly l7PolicyId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbListenerV2 <a name="@cdktf/provider-opentelekomcloud.LbListenerV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2 opentelekomcloud_lb_listener_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.Initializer"></a>

```typescript
import { LbListenerV2 } from '@cdktf/provider-opentelekomcloud'

new LbListenerV2(scope: Construct, id: string, config: LbListenerV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV2Config`](#@cdktf/provider-opentelekomcloud.LbListenerV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbListenerV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetClientCaTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetClientCaTlsContainerRef"></a>

```typescript
public resetClientCaTlsContainerRef()
```

##### `resetDefaultPoolId` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetDefaultPoolId"></a>

```typescript
public resetDefaultPoolId()
```

##### `resetDefaultTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetDefaultTlsContainerRef"></a>

```typescript
public resetDefaultTlsContainerRef()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetHttp2Enable` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetHttp2Enable"></a>

```typescript
public resetHttp2Enable()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSniContainerRefs` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetSniContainerRefs"></a>

```typescript
public resetSniContainerRefs()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTlsCiphersPolicy` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetTlsCiphersPolicy"></a>

```typescript
public resetTlsCiphersPolicy()
```

##### `resetTransparentClientIpEnable` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.resetTransparentClientIpEnable"></a>

```typescript
public resetTransparentClientIpEnable()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbListenerV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clientCaTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.clientCaTlsContainerRefInput"></a>

```typescript
public readonly clientCaTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `defaultPoolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.defaultPoolIdInput"></a>

```typescript
public readonly defaultPoolIdInput: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.defaultTlsContainerRefInput"></a>

```typescript
public readonly defaultTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `http2EnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.http2EnableInput"></a>

```typescript
public readonly http2EnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `loadbalancerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.loadbalancerIdInput"></a>

```typescript
public readonly loadbalancerIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sniContainerRefsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.sniContainerRefsInput"></a>

```typescript
public readonly sniContainerRefsInput: string[];
```

- *Type:* `string`[]

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbListenerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts)

---

##### `tlsCiphersPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tlsCiphersPolicyInput"></a>

```typescript
public readonly tlsCiphersPolicyInput: string;
```

- *Type:* `string`

---

##### `transparentClientIpEnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.transparentClientIpEnableInput"></a>

```typescript
public readonly transparentClientIpEnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clientCaTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

---

##### `defaultPoolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `http2Enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.http2Enable"></a>

```typescript
public readonly http2Enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sniContainerRefs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.sniContainerRefs"></a>

```typescript
public readonly sniContainerRefs: string[];
```

- *Type:* `string`[]

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `tlsCiphersPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

---

##### `transparentClientIpEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.transparentClientIpEnable"></a>

```typescript
public readonly transparentClientIpEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbListenerV3 <a name="@cdktf/provider-opentelekomcloud.LbListenerV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3 opentelekomcloud_lb_listener_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.Initializer"></a>

```typescript
import { LbListenerV3 } from '@cdktf/provider-opentelekomcloud'

new LbListenerV3(scope: Construct, id: string, config: LbListenerV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3Config`](#@cdktf/provider-opentelekomcloud.LbListenerV3Config)

---

#### Methods <a name="Methods"></a>

##### `putInsertHeaders` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.putInsertHeaders"></a>

```typescript
public putInsertHeaders(value: LbListenerV3InsertHeaders)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders`](#@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetClientCaTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetClientCaTlsContainerRef"></a>

```typescript
public resetClientCaTlsContainerRef()
```

##### `resetClientTimeout` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetClientTimeout"></a>

```typescript
public resetClientTimeout()
```

##### `resetDefaultPoolId` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetDefaultPoolId"></a>

```typescript
public resetDefaultPoolId()
```

##### `resetDefaultTlsContainerRef` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetDefaultTlsContainerRef"></a>

```typescript
public resetDefaultTlsContainerRef()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetHttp2Enable` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetHttp2Enable"></a>

```typescript
public resetHttp2Enable()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetId"></a>

```typescript
public resetId()
```

##### `resetInsertHeaders` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetInsertHeaders"></a>

```typescript
public resetInsertHeaders()
```

##### `resetKeepAliveTimeout` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetKeepAliveTimeout"></a>

```typescript
public resetKeepAliveTimeout()
```

##### `resetMemberRetryEnable` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetMemberRetryEnable"></a>

```typescript
public resetMemberRetryEnable()
```

##### `resetMemberTimeout` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetMemberTimeout"></a>

```typescript
public resetMemberTimeout()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetName"></a>

```typescript
public resetName()
```

##### `resetSniContainerRefs` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetSniContainerRefs"></a>

```typescript
public resetSniContainerRefs()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTlsCiphersPolicy` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.resetTlsCiphersPolicy"></a>

```typescript
public resetTlsCiphersPolicy()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `insertHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.insertHeaders"></a>

```typescript
public readonly insertHeaders: LbListenerV3InsertHeadersOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference`](#@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference)

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clientCaTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.clientCaTlsContainerRefInput"></a>

```typescript
public readonly clientCaTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `clientTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.clientTimeoutInput"></a>

```typescript
public readonly clientTimeoutInput: number;
```

- *Type:* `number`

---

##### `defaultPoolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.defaultPoolIdInput"></a>

```typescript
public readonly defaultPoolIdInput: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.defaultTlsContainerRefInput"></a>

```typescript
public readonly defaultTlsContainerRefInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `http2EnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.http2EnableInput"></a>

```typescript
public readonly http2EnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `insertHeadersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.insertHeadersInput"></a>

```typescript
public readonly insertHeadersInput: LbListenerV3InsertHeaders;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders`](#@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders)

---

##### `keepAliveTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.keepAliveTimeoutInput"></a>

```typescript
public readonly keepAliveTimeoutInput: number;
```

- *Type:* `number`

---

##### `loadbalancerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.loadbalancerIdInput"></a>

```typescript
public readonly loadbalancerIdInput: string;
```

- *Type:* `string`

---

##### `memberRetryEnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.memberRetryEnableInput"></a>

```typescript
public readonly memberRetryEnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `memberTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.memberTimeoutInput"></a>

```typescript
public readonly memberTimeoutInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `sniContainerRefsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.sniContainerRefsInput"></a>

```typescript
public readonly sniContainerRefsInput: string[];
```

- *Type:* `string`[]

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tlsCiphersPolicyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.tlsCiphersPolicyInput"></a>

```typescript
public readonly tlsCiphersPolicyInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `clientCaTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

---

##### `clientTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.clientTimeout"></a>

```typescript
public readonly clientTimeout: number;
```

- *Type:* `number`

---

##### `defaultPoolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

---

##### `defaultTlsContainerRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `http2Enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.http2Enable"></a>

```typescript
public readonly http2Enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `keepAliveTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* `number`

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

---

##### `memberRetryEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.memberRetryEnable"></a>

```typescript
public readonly memberRetryEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `memberTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.memberTimeout"></a>

```typescript
public readonly memberTimeout: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `sniContainerRefs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.sniContainerRefs"></a>

```typescript
public readonly sniContainerRefs: string[];
```

- *Type:* `string`[]

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tlsCiphersPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbLoadbalancerV2 <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2 opentelekomcloud_lb_loadbalancer_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.Initializer"></a>

```typescript
import { LbLoadbalancerV2 } from '@cdktf/provider-opentelekomcloud'

new LbLoadbalancerV2(scope: Construct, id: string, config: LbLoadbalancerV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbLoadbalancerV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetId"></a>

```typescript
public resetId()
```

##### `resetLoadbalancerProvider` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetLoadbalancerProvider"></a>

```typescript
public resetLoadbalancerProvider()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVipAddress` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.resetVipAddress"></a>

```typescript
public resetVipAddress()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbLoadbalancerV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference)

---

##### `vipPortId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `loadbalancerProviderInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.loadbalancerProviderInput"></a>

```typescript
public readonly loadbalancerProviderInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbLoadbalancerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts)

---

##### `vipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.vipAddressInput"></a>

```typescript
public readonly vipAddressInput: string;
```

- *Type:* `string`

---

##### `vipSubnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.vipSubnetIdInput"></a>

```typescript
public readonly vipSubnetIdInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `loadbalancerProvider`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.loadbalancerProvider"></a>

```typescript
public readonly loadbalancerProvider: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `vipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

---

##### `vipSubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.vipSubnetId"></a>

```typescript
public readonly vipSubnetId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbLoadbalancerV3 <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3 opentelekomcloud_lb_loadbalancer_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.Initializer"></a>

```typescript
import { LbLoadbalancerV3 } from '@cdktf/provider-opentelekomcloud'

new LbLoadbalancerV3(scope: Construct, id: string, config: LbLoadbalancerV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config)

---

#### Methods <a name="Methods"></a>

##### `putPublicIp` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.putPublicIp"></a>

```typescript
public putPublicIp(value: LbLoadbalancerV3PublicIp)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetId"></a>

```typescript
public resetId()
```

##### `resetIpTargetEnable` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetIpTargetEnable"></a>

```typescript
public resetIpTargetEnable()
```

##### `resetL4Flavor` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetL4Flavor"></a>

```typescript
public resetL4Flavor()
```

##### `resetL7Flavor` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetL7Flavor"></a>

```typescript
public resetL7Flavor()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetName"></a>

```typescript
public resetName()
```

##### `resetPublicIp` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetPublicIp"></a>

```typescript
public resetPublicIp()
```

##### `resetRouterId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetRouterId"></a>

```typescript
public resetRouterId()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetTags"></a>

```typescript
public resetTags()
```

##### `resetVipAddress` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.resetVipAddress"></a>

```typescript
public resetVipAddress()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.publicIp"></a>

```typescript
public readonly publicIp: LbLoadbalancerV3PublicIpOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference)

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `vipPortId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZonesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.availabilityZonesInput"></a>

```typescript
public readonly availabilityZonesInput: string[];
```

- *Type:* `string`[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipTargetEnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.ipTargetEnableInput"></a>

```typescript
public readonly ipTargetEnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `l4FlavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.l4FlavorInput"></a>

```typescript
public readonly l4FlavorInput: string;
```

- *Type:* `string`

---

##### `l7FlavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.l7FlavorInput"></a>

```typescript
public readonly l7FlavorInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.networkIdsInput"></a>

```typescript
public readonly networkIdsInput: string[];
```

- *Type:* `string`[]

---

##### `publicIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.publicIpInput"></a>

```typescript
public readonly publicIpInput: LbLoadbalancerV3PublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp)

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.vipAddressInput"></a>

```typescript
public readonly vipAddressInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `availabilityZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* `string`[]

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipTargetEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.ipTargetEnable"></a>

```typescript
public readonly ipTargetEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `l4Flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.l4Flavor"></a>

```typescript
public readonly l4Flavor: string;
```

- *Type:* `string`

---

##### `l7Flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.l7Flavor"></a>

```typescript
public readonly l7Flavor: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.networkIds"></a>

```typescript
public readonly networkIds: string[];
```

- *Type:* `string`[]

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbMemberV2 <a name="@cdktf/provider-opentelekomcloud.LbMemberV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2 opentelekomcloud_lb_member_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.Initializer"></a>

```typescript
import { LbMemberV2 } from '@cdktf/provider-opentelekomcloud'

new LbMemberV2(scope: Construct, id: string, config: LbMemberV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMemberV2Config`](#@cdktf/provider-opentelekomcloud.LbMemberV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbMemberV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetWeight` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.resetWeight"></a>

```typescript
public resetWeight()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbMemberV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference)

---

##### `addressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* `string`

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbMemberV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts)

---

##### `weightInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* `number`

---

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `weight`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbMemberV3 <a name="@cdktf/provider-opentelekomcloud.LbMemberV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3 opentelekomcloud_lb_member_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.Initializer"></a>

```typescript
import { LbMemberV3 } from '@cdktf/provider-opentelekomcloud'

new LbMemberV3(scope: Construct, id: string, config: LbMemberV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMemberV3Config`](#@cdktf/provider-opentelekomcloud.LbMemberV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.resetName"></a>

```typescript
public resetName()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetWeight` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.resetWeight"></a>

```typescript
public resetWeight()
```


#### Properties <a name="Properties"></a>

##### `ipVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* `string`

---

##### `memberId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.memberId"></a>

```typescript
public readonly memberId: string;
```

- *Type:* `string`

---

##### `operatingStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.operatingStatus"></a>

```typescript
public readonly operatingStatus: string;
```

- *Type:* `string`

---

##### `addressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `weightInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* `number`

---

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `weight`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbMemberV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbMonitorV2 <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2 opentelekomcloud_lb_monitor_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.Initializer"></a>

```typescript
import { LbMonitorV2 } from '@cdktf/provider-opentelekomcloud'

new LbMonitorV2(scope: Construct, id: string, config: LbMonitorV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMonitorV2Config`](#@cdktf/provider-opentelekomcloud.LbMonitorV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbMonitorV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDomainName` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetDomainName"></a>

```typescript
public resetDomainName()
```

##### `resetExpectedCodes` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetExpectedCodes"></a>

```typescript
public resetExpectedCodes()
```

##### `resetHttpMethod` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetHttpMethod"></a>

```typescript
public resetHttpMethod()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMonitorPort` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetMonitorPort"></a>

```typescript
public resetMonitorPort()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetUrlPath` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.resetUrlPath"></a>

```typescript
public resetUrlPath()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbMonitorV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `delayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.delayInput"></a>

```typescript
public readonly delayInput: number;
```

- *Type:* `number`

---

##### `domainNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.domainNameInput"></a>

```typescript
public readonly domainNameInput: string;
```

- *Type:* `string`

---

##### `expectedCodesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.expectedCodesInput"></a>

```typescript
public readonly expectedCodesInput: string;
```

- *Type:* `string`

---

##### `httpMethodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.httpMethodInput"></a>

```typescript
public readonly httpMethodInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `maxRetriesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.maxRetriesInput"></a>

```typescript
public readonly maxRetriesInput: number;
```

- *Type:* `number`

---

##### `monitorPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.monitorPortInput"></a>

```typescript
public readonly monitorPortInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* `number`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbMonitorV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `urlPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.urlPathInput"></a>

```typescript
public readonly urlPathInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `delay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.delay"></a>

```typescript
public readonly delay: number;
```

- *Type:* `number`

---

##### `domainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

---

##### `expectedCodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.expectedCodes"></a>

```typescript
public readonly expectedCodes: string;
```

- *Type:* `string`

---

##### `httpMethod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.httpMethod"></a>

```typescript
public readonly httpMethod: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maxRetries`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

---

##### `monitorPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.monitorPort"></a>

```typescript
public readonly monitorPort: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `timeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `urlPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.urlPath"></a>

```typescript
public readonly urlPath: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbMonitorV3 <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3 opentelekomcloud_lb_monitor_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.Initializer"></a>

```typescript
import { LbMonitorV3 } from '@cdktf/provider-opentelekomcloud'

new LbMonitorV3(scope: Construct, id: string, config: LbMonitorV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMonitorV3Config`](#@cdktf/provider-opentelekomcloud.LbMonitorV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDomainName` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetDomainName"></a>

```typescript
public resetDomainName()
```

##### `resetExpectedCodes` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetExpectedCodes"></a>

```typescript
public resetExpectedCodes()
```

##### `resetHttpMethod` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetHttpMethod"></a>

```typescript
public resetHttpMethod()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetId"></a>

```typescript
public resetId()
```

##### `resetMaxRetriesDown` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetMaxRetriesDown"></a>

```typescript
public resetMaxRetriesDown()
```

##### `resetMonitorPort` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetMonitorPort"></a>

```typescript
public resetMonitorPort()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetName"></a>

```typescript
public resetName()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetUrlPath` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.resetUrlPath"></a>

```typescript
public resetUrlPath()
```


#### Properties <a name="Properties"></a>

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `delayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.delayInput"></a>

```typescript
public readonly delayInput: number;
```

- *Type:* `number`

---

##### `domainNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.domainNameInput"></a>

```typescript
public readonly domainNameInput: string;
```

- *Type:* `string`

---

##### `expectedCodesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.expectedCodesInput"></a>

```typescript
public readonly expectedCodesInput: string;
```

- *Type:* `string`

---

##### `httpMethodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.httpMethodInput"></a>

```typescript
public readonly httpMethodInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `maxRetriesDownInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.maxRetriesDownInput"></a>

```typescript
public readonly maxRetriesDownInput: number;
```

- *Type:* `number`

---

##### `maxRetriesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.maxRetriesInput"></a>

```typescript
public readonly maxRetriesInput: number;
```

- *Type:* `number`

---

##### `monitorPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.monitorPortInput"></a>

```typescript
public readonly monitorPortInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `timeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `urlPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.urlPathInput"></a>

```typescript
public readonly urlPathInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `delay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.delay"></a>

```typescript
public readonly delay: number;
```

- *Type:* `number`

---

##### `domainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

---

##### `expectedCodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.expectedCodes"></a>

```typescript
public readonly expectedCodes: string;
```

- *Type:* `string`

---

##### `httpMethod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.httpMethod"></a>

```typescript
public readonly httpMethod: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maxRetries`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

---

##### `maxRetriesDown`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.maxRetriesDown"></a>

```typescript
public readonly maxRetriesDown: number;
```

- *Type:* `number`

---

##### `monitorPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.monitorPort"></a>

```typescript
public readonly monitorPort: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `timeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `urlPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.urlPath"></a>

```typescript
public readonly urlPath: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbPolicyV3 <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3 opentelekomcloud_lb_policy_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.Initializer"></a>

```typescript
import { LbPolicyV3 } from '@cdktf/provider-opentelekomcloud'

new LbPolicyV3(scope: Construct, id: string, config: LbPolicyV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPolicyV3Config`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Config)

---

#### Methods <a name="Methods"></a>

##### `putRules` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.putRules"></a>

```typescript
public putRules(value: IResolvable | LbPolicyV3Rules[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPolicyV3Rules`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Rules)[]

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetName"></a>

```typescript
public resetName()
```

##### `resetPosition` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetPosition"></a>

```typescript
public resetPosition()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetRedirectListenerId` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetRedirectListenerId"></a>

```typescript
public resetRedirectListenerId()
```

##### `resetRedirectPoolId` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetRedirectPoolId"></a>

```typescript
public resetRedirectPoolId()
```

##### `resetRules` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.resetRules"></a>

```typescript
public resetRules()
```


#### Properties <a name="Properties"></a>

##### `rules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.rules"></a>

```typescript
public readonly rules: LbPolicyV3RulesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList`](#@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `listenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.listenerIdInput"></a>

```typescript
public readonly listenerIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `positionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* `number`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `redirectListenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.redirectListenerIdInput"></a>

```typescript
public readonly redirectListenerIdInput: string;
```

- *Type:* `string`

---

##### `redirectPoolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.redirectPoolIdInput"></a>

```typescript
public readonly redirectPoolIdInput: string;
```

- *Type:* `string`

---

##### `rulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.rulesInput"></a>

```typescript
public readonly rulesInput: IResolvable | LbPolicyV3Rules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPolicyV3Rules`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Rules)[]

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `position`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* `number`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `redirectListenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.redirectListenerId"></a>

```typescript
public readonly redirectListenerId: string;
```

- *Type:* `string`

---

##### `redirectPoolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.redirectPoolId"></a>

```typescript
public readonly redirectPoolId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbPoolV2 <a name="@cdktf/provider-opentelekomcloud.LbPoolV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2 opentelekomcloud_lb_pool_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.Initializer"></a>

```typescript
import { LbPoolV2 } from '@cdktf/provider-opentelekomcloud'

new LbPoolV2(scope: Construct, id: string, config: LbPoolV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV2Config`](#@cdktf/provider-opentelekomcloud.LbPoolV2Config)

---

#### Methods <a name="Methods"></a>

##### `putPersistence` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.putPersistence"></a>

```typescript
public putPersistence(value: IResolvable | LbPoolV2Persistence[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Persistence`](#@cdktf/provider-opentelekomcloud.LbPoolV2Persistence)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbPoolV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetId"></a>

```typescript
public resetId()
```

##### `resetListenerId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetListenerId"></a>

```typescript
public resetListenerId()
```

##### `resetLoadbalancerId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetLoadbalancerId"></a>

```typescript
public resetLoadbalancerId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPersistence` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetPersistence"></a>

```typescript
public resetPersistence()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `persistence`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.persistence"></a>

```typescript
public readonly persistence: LbPoolV2PersistenceList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList`](#@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbPoolV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `lbMethodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.lbMethodInput"></a>

```typescript
public readonly lbMethodInput: string;
```

- *Type:* `string`

---

##### `listenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.listenerIdInput"></a>

```typescript
public readonly listenerIdInput: string;
```

- *Type:* `string`

---

##### `loadbalancerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.loadbalancerIdInput"></a>

```typescript
public readonly loadbalancerIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `persistenceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.persistenceInput"></a>

```typescript
public readonly persistenceInput: IResolvable | LbPoolV2Persistence[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Persistence`](#@cdktf/provider-opentelekomcloud.LbPoolV2Persistence)[]

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbPoolV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts)

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `lbMethod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.lbMethod"></a>

```typescript
public readonly lbMethod: string;
```

- *Type:* `string`

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LbPoolV3 <a name="@cdktf/provider-opentelekomcloud.LbPoolV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3 opentelekomcloud_lb_pool_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.Initializer"></a>

```typescript
import { LbPoolV3 } from '@cdktf/provider-opentelekomcloud'

new LbPoolV3(scope: Construct, id: string, config: LbPoolV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3Config`](#@cdktf/provider-opentelekomcloud.LbPoolV3Config)

---

#### Methods <a name="Methods"></a>

##### `putSessionPersistence` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.putSessionPersistence"></a>

```typescript
public putSessionPersistence(value: LbPoolV3SessionPersistence)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence`](#@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetId"></a>

```typescript
public resetId()
```

##### `resetListenerId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetListenerId"></a>

```typescript
public resetListenerId()
```

##### `resetLoadbalancerId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetLoadbalancerId"></a>

```typescript
public resetLoadbalancerId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetName"></a>

```typescript
public resetName()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetProjectId"></a>

```typescript
public resetProjectId()
```

##### `resetSessionPersistence` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.resetSessionPersistence"></a>

```typescript
public resetSessionPersistence()
```


#### Properties <a name="Properties"></a>

##### `ipVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* `string`

---

##### `sessionPersistence`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.sessionPersistence"></a>

```typescript
public readonly sessionPersistence: LbPoolV3SessionPersistenceOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference`](#@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `lbAlgorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.lbAlgorithmInput"></a>

```typescript
public readonly lbAlgorithmInput: string;
```

- *Type:* `string`

---

##### `listenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.listenerIdInput"></a>

```typescript
public readonly listenerIdInput: string;
```

- *Type:* `string`

---

##### `loadbalancerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.loadbalancerIdInput"></a>

```typescript
public readonly loadbalancerIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `sessionPersistenceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.sessionPersistenceInput"></a>

```typescript
public readonly sessionPersistenceInput: LbPoolV3SessionPersistence;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence`](#@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `lbAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.lbAlgorithm"></a>

```typescript
public readonly lbAlgorithm: string;
```

- *Type:* `string`

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbRuleV3 <a name="@cdktf/provider-opentelekomcloud.LbRuleV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3 opentelekomcloud_lb_rule_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.Initializer"></a>

```typescript
import { LbRuleV3 } from '@cdktf/provider-opentelekomcloud'

new LbRuleV3(scope: Construct, id: string, config: LbRuleV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbRuleV3Config`](#@cdktf/provider-opentelekomcloud.LbRuleV3Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectId` <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.resetProjectId"></a>

```typescript
public resetProjectId()
```


#### Properties <a name="Properties"></a>

##### `ruleId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.ruleId"></a>

```typescript
public readonly ruleId: string;
```

- *Type:* `string`

---

##### `compareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.compareTypeInput"></a>

```typescript
public readonly compareTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `projectIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.projectIdInput"></a>

```typescript
public readonly projectIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbRuleV3.property.tfResourceType"></a>

- *Type:* `string`

---

### LbWhitelistV2 <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2 opentelekomcloud_lb_whitelist_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.Initializer"></a>

```typescript
import { LbWhitelistV2 } from '@cdktf/provider-opentelekomcloud'

new LbWhitelistV2(scope: Construct, id: string, config: LbWhitelistV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbWhitelistV2Config`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.putTimeouts"></a>

```typescript
public putTimeouts(value: LbWhitelistV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts)

---

##### `resetEnableWhitelist` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.resetEnableWhitelist"></a>

```typescript
public resetEnableWhitelist()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetWhitelist` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.resetWhitelist"></a>

```typescript
public resetWhitelist()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.timeouts"></a>

```typescript
public readonly timeouts: LbWhitelistV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference)

---

##### `enableWhitelistInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.enableWhitelistInput"></a>

```typescript
public readonly enableWhitelistInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `listenerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.listenerIdInput"></a>

```typescript
public readonly listenerIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbWhitelistV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts)

---

##### `whitelistInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.whitelistInput"></a>

```typescript
public readonly whitelistInput: string;
```

- *Type:* `string`

---

##### `enableWhitelist`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.enableWhitelist"></a>

```typescript
public readonly enableWhitelist: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `whitelist`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.whitelist"></a>

```typescript
public readonly whitelist: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LogtankGroupV2 <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_group_v2 opentelekomcloud_logtank_group_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.Initializer"></a>

```typescript
import { LogtankGroupV2 } from '@cdktf/provider-opentelekomcloud'

new LogtankGroupV2(scope: Construct, id: string, config: LogtankGroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LogtankGroupV2Config`](#@cdktf/provider-opentelekomcloud.LogtankGroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `ttlInDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.ttlInDays"></a>

```typescript
public readonly ttlInDays: number;
```

- *Type:* `number`

---

##### `groupNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.groupNameInput"></a>

```typescript
public readonly groupNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `groupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.groupName"></a>

```typescript
public readonly groupName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### LogtankTopicV2 <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_topic_v2 opentelekomcloud_logtank_topic_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.Initializer"></a>

```typescript
import { LogtankTopicV2 } from '@cdktf/provider-opentelekomcloud'

new LogtankTopicV2(scope: Construct, id: string, config: LogtankTopicV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.LogtankTopicV2Config`](#@cdktf/provider-opentelekomcloud.LogtankTopicV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `indexEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.indexEnabled"></a>

```typescript
public readonly indexEnabled: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `groupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `topicNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.topicNameInput"></a>

```typescript
public readonly topicNameInput: string;
```

- *Type:* `string`

---

##### `groupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `topicName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2.property.tfResourceType"></a>

- *Type:* `string`

---

### MrsClusterV1 <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1 opentelekomcloud_mrs_cluster_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.Initializer"></a>

```typescript
import { MrsClusterV1 } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1(scope: Construct, id: string, config: MrsClusterV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1Config`](#@cdktf/provider-opentelekomcloud.MrsClusterV1Config)

---

#### Methods <a name="Methods"></a>

##### `putAddJobs` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.putAddJobs"></a>

```typescript
public putAddJobs(value: IResolvable | MrsClusterV1AddJobs[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs)[]

---

##### `putBootstrapScripts` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.putBootstrapScripts"></a>

```typescript
public putBootstrapScripts(value: IResolvable | MrsClusterV1BootstrapScripts[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts)[]

---

##### `putComponentList` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.putComponentList"></a>

```typescript
public putComponentList(value: IResolvable | MrsClusterV1ComponentList[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.putTimeouts"></a>

```typescript
public putTimeouts(value: MrsClusterV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts)

---

##### `resetAddJobs` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetAddJobs"></a>

```typescript
public resetAddJobs()
```

##### `resetBootstrapScripts` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetBootstrapScripts"></a>

```typescript
public resetBootstrapScripts()
```

##### `resetClusterAdminSecret` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetClusterAdminSecret"></a>

```typescript
public resetClusterAdminSecret()
```

##### `resetClusterType` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetClusterType"></a>

```typescript
public resetClusterType()
```

##### `resetCoreDataVolumeCount` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetCoreDataVolumeCount"></a>

```typescript
public resetCoreDataVolumeCount()
```

##### `resetCoreDataVolumeSize` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetCoreDataVolumeSize"></a>

```typescript
public resetCoreDataVolumeSize()
```

##### `resetCoreDataVolumeType` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetCoreDataVolumeType"></a>

```typescript
public resetCoreDataVolumeType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetId"></a>

```typescript
public resetId()
```

##### `resetLogCollection` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetLogCollection"></a>

```typescript
public resetLogCollection()
```

##### `resetMasterDataVolumeCount` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetMasterDataVolumeCount"></a>

```typescript
public resetMasterDataVolumeCount()
```

##### `resetMasterDataVolumeSize` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetMasterDataVolumeSize"></a>

```typescript
public resetMasterDataVolumeSize()
```

##### `resetMasterDataVolumeType` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetMasterDataVolumeType"></a>

```typescript
public resetMasterDataVolumeType()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVolumeSize` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetVolumeSize"></a>

```typescript
public resetVolumeSize()
```

##### `resetVolumeType` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.resetVolumeType"></a>

```typescript
public resetVolumeType()
```


#### Properties <a name="Properties"></a>

##### `addJobs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.addJobs"></a>

```typescript
public readonly addJobs: MrsClusterV1AddJobsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList)

---

##### `availableZoneName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.availableZoneName"></a>

```typescript
public readonly availableZoneName: string;
```

- *Type:* `string`

---

##### `bootstrapScripts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.bootstrapScripts"></a>

```typescript
public readonly bootstrapScripts: MrsClusterV1BootstrapScriptsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList)

---

##### `chargingStartTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.chargingStartTime"></a>

```typescript
public readonly chargingStartTime: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `clusterState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterState"></a>

```typescript
public readonly clusterState: string;
```

- *Type:* `string`

---

##### `componentList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.componentList"></a>

```typescript
public readonly componentList: MrsClusterV1ComponentListList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList)

---

##### `coreNodeProductId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeProductId"></a>

```typescript
public readonly coreNodeProductId: string;
```

- *Type:* `string`

---

##### `coreNodeSpecId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeSpecId"></a>

```typescript
public readonly coreNodeSpecId: string;
```

- *Type:* `string`

---

##### `createAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.createAt"></a>

```typescript
public readonly createAt: string;
```

- *Type:* `string`

---

##### `deploymentId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.deploymentId"></a>

```typescript
public readonly deploymentId: string;
```

- *Type:* `string`

---

##### `duration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* `string`

---

##### `errorInfo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.errorInfo"></a>

```typescript
public readonly errorInfo: string;
```

- *Type:* `string`

---

##### `externalAlternateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.externalAlternateIp"></a>

```typescript
public readonly externalAlternateIp: string;
```

- *Type:* `string`

---

##### `externalIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.externalIp"></a>

```typescript
public readonly externalIp: string;
```

- *Type:* `string`

---

##### `fee`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.fee"></a>

```typescript
public readonly fee: string;
```

- *Type:* `string`

---

##### `hadoopVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.hadoopVersion"></a>

```typescript
public readonly hadoopVersion: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `internalIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.internalIp"></a>

```typescript
public readonly internalIp: string;
```

- *Type:* `string`

---

##### `masterNodeIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeIp"></a>

```typescript
public readonly masterNodeIp: string;
```

- *Type:* `string`

---

##### `masterNodeProductId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeProductId"></a>

```typescript
public readonly masterNodeProductId: string;
```

- *Type:* `string`

---

##### `masterNodeSpecId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeSpecId"></a>

```typescript
public readonly masterNodeSpecId: string;
```

- *Type:* `string`

---

##### `orderId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

---

##### `privateIpFirst`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.privateIpFirst"></a>

```typescript
public readonly privateIpFirst: string;
```

- *Type:* `string`

---

##### `remark`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.remark"></a>

```typescript
public readonly remark: string;
```

- *Type:* `string`

---

##### `securityGroupsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.securityGroupsId"></a>

```typescript
public readonly securityGroupsId: string;
```

- *Type:* `string`

---

##### `slaveSecurityGroupsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.slaveSecurityGroupsId"></a>

```typescript
public readonly slaveSecurityGroupsId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.timeouts"></a>

```typescript
public readonly timeouts: MrsClusterV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference)

---

##### `updateAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.updateAt"></a>

```typescript
public readonly updateAt: string;
```

- *Type:* `string`

---

##### `vnc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.vnc"></a>

```typescript
public readonly vnc: string;
```

- *Type:* `string`

---

##### `addJobsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.addJobsInput"></a>

```typescript
public readonly addJobsInput: IResolvable | MrsClusterV1AddJobs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs)[]

---

##### `availableZoneIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.availableZoneIdInput"></a>

```typescript
public readonly availableZoneIdInput: string;
```

- *Type:* `string`

---

##### `billingTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.billingTypeInput"></a>

```typescript
public readonly billingTypeInput: number;
```

- *Type:* `number`

---

##### `bootstrapScriptsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.bootstrapScriptsInput"></a>

```typescript
public readonly bootstrapScriptsInput: IResolvable | MrsClusterV1BootstrapScripts[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts)[]

---

##### `clusterAdminSecretInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterAdminSecretInput"></a>

```typescript
public readonly clusterAdminSecretInput: string;
```

- *Type:* `string`

---

##### `clusterNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterNameInput"></a>

```typescript
public readonly clusterNameInput: string;
```

- *Type:* `string`

---

##### `clusterTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterTypeInput"></a>

```typescript
public readonly clusterTypeInput: number;
```

- *Type:* `number`

---

##### `clusterVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterVersionInput"></a>

```typescript
public readonly clusterVersionInput: string;
```

- *Type:* `string`

---

##### `componentListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.componentListInput"></a>

```typescript
public readonly componentListInput: IResolvable | MrsClusterV1ComponentList[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList)[]

---

##### `coreDataVolumeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeCountInput"></a>

```typescript
public readonly coreDataVolumeCountInput: number;
```

- *Type:* `number`

---

##### `coreDataVolumeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeSizeInput"></a>

```typescript
public readonly coreDataVolumeSizeInput: number;
```

- *Type:* `number`

---

##### `coreDataVolumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeTypeInput"></a>

```typescript
public readonly coreDataVolumeTypeInput: string;
```

- *Type:* `string`

---

##### `coreNodeNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeNumInput"></a>

```typescript
public readonly coreNodeNumInput: number;
```

- *Type:* `number`

---

##### `coreNodeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeSizeInput"></a>

```typescript
public readonly coreNodeSizeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `logCollectionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.logCollectionInput"></a>

```typescript
public readonly logCollectionInput: number;
```

- *Type:* `number`

---

##### `masterDataVolumeCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeCountInput"></a>

```typescript
public readonly masterDataVolumeCountInput: number;
```

- *Type:* `number`

---

##### `masterDataVolumeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeSizeInput"></a>

```typescript
public readonly masterDataVolumeSizeInput: number;
```

- *Type:* `number`

---

##### `masterDataVolumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeTypeInput"></a>

```typescript
public readonly masterDataVolumeTypeInput: string;
```

- *Type:* `string`

---

##### `masterNodeNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeNumInput"></a>

```typescript
public readonly masterNodeNumInput: number;
```

- *Type:* `number`

---

##### `masterNodeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeSizeInput"></a>

```typescript
public readonly masterNodeSizeInput: string;
```

- *Type:* `string`

---

##### `nodePublicCertNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.nodePublicCertNameInput"></a>

```typescript
public readonly nodePublicCertNameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `safeModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.safeModeInput"></a>

```typescript
public readonly safeModeInput: number;
```

- *Type:* `number`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MrsClusterV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts)

---

##### `volumeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.volumeSizeInput"></a>

```typescript
public readonly volumeSizeInput: number;
```

- *Type:* `number`

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availableZoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.availableZoneId"></a>

```typescript
public readonly availableZoneId: string;
```

- *Type:* `string`

---

##### `billingType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.billingType"></a>

```typescript
public readonly billingType: number;
```

- *Type:* `number`

---

##### `clusterAdminSecret`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterAdminSecret"></a>

```typescript
public readonly clusterAdminSecret: string;
```

- *Type:* `string`

---

##### `clusterName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterName"></a>

```typescript
public readonly clusterName: string;
```

- *Type:* `string`

---

##### `clusterType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterType"></a>

```typescript
public readonly clusterType: number;
```

- *Type:* `number`

---

##### `clusterVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.clusterVersion"></a>

```typescript
public readonly clusterVersion: string;
```

- *Type:* `string`

---

##### `coreDataVolumeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeCount"></a>

```typescript
public readonly coreDataVolumeCount: number;
```

- *Type:* `number`

---

##### `coreDataVolumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeSize"></a>

```typescript
public readonly coreDataVolumeSize: number;
```

- *Type:* `number`

---

##### `coreDataVolumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreDataVolumeType"></a>

```typescript
public readonly coreDataVolumeType: string;
```

- *Type:* `string`

---

##### `coreNodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeNum"></a>

```typescript
public readonly coreNodeNum: number;
```

- *Type:* `number`

---

##### `coreNodeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.coreNodeSize"></a>

```typescript
public readonly coreNodeSize: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `logCollection`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.logCollection"></a>

```typescript
public readonly logCollection: number;
```

- *Type:* `number`

---

##### `masterDataVolumeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeCount"></a>

```typescript
public readonly masterDataVolumeCount: number;
```

- *Type:* `number`

---

##### `masterDataVolumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeSize"></a>

```typescript
public readonly masterDataVolumeSize: number;
```

- *Type:* `number`

---

##### `masterDataVolumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterDataVolumeType"></a>

```typescript
public readonly masterDataVolumeType: string;
```

- *Type:* `string`

---

##### `masterNodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeNum"></a>

```typescript
public readonly masterNodeNum: number;
```

- *Type:* `number`

---

##### `masterNodeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.masterNodeSize"></a>

```typescript
public readonly masterNodeSize: string;
```

- *Type:* `string`

---

##### `nodePublicCertName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.nodePublicCertName"></a>

```typescript
public readonly nodePublicCertName: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `safeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.safeMode"></a>

```typescript
public readonly safeMode: number;
```

- *Type:* `number`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `volumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1.property.tfResourceType"></a>

- *Type:* `string`

---

### MrsJobV1 <a name="@cdktf/provider-opentelekomcloud.MrsJobV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1 opentelekomcloud_mrs_job_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.Initializer"></a>

```typescript
import { MrsJobV1 } from '@cdktf/provider-opentelekomcloud'

new MrsJobV1(scope: Construct, id: string, config: MrsJobV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsJobV1Config`](#@cdktf/provider-opentelekomcloud.MrsJobV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.putTimeouts"></a>

```typescript
public putTimeouts(value: MrsJobV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts)

---

##### `resetArguments` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetArguments"></a>

```typescript
public resetArguments()
```

##### `resetHiveScriptPath` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetHiveScriptPath"></a>

```typescript
public resetHiveScriptPath()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetId"></a>

```typescript
public resetId()
```

##### `resetInput` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetInput"></a>

```typescript
public resetInput()
```

##### `resetIsProtected` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetIsProtected"></a>

```typescript
public resetIsProtected()
```

##### `resetIsPublic` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetIsPublic"></a>

```typescript
public resetIsPublic()
```

##### `resetJobLog` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetJobLog"></a>

```typescript
public resetJobLog()
```

##### `resetOutput` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetOutput"></a>

```typescript
public resetOutput()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `jobState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobState"></a>

```typescript
public readonly jobState: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.timeouts"></a>

```typescript
public readonly timeouts: MrsJobV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference)

---

##### `argumentsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.argumentsInput"></a>

```typescript
public readonly argumentsInput: string;
```

- *Type:* `string`

---

##### `clusterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* `string`

---

##### `hiveScriptPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.hiveScriptPathInput"></a>

```typescript
public readonly hiveScriptPathInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `inputInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.inputInput"></a>

```typescript
public readonly inputInput: string;
```

- *Type:* `string`

---

##### `isProtectedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.isProtectedInput"></a>

```typescript
public readonly isProtectedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isPublicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.isPublicInput"></a>

```typescript
public readonly isPublicInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `jarPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jarPathInput"></a>

```typescript
public readonly jarPathInput: string;
```

- *Type:* `string`

---

##### `jobLogInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobLogInput"></a>

```typescript
public readonly jobLogInput: string;
```

- *Type:* `string`

---

##### `jobNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobNameInput"></a>

```typescript
public readonly jobNameInput: string;
```

- *Type:* `string`

---

##### `jobTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobTypeInput"></a>

```typescript
public readonly jobTypeInput: number;
```

- *Type:* `number`

---

##### `outputInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.outputInput"></a>

```typescript
public readonly outputInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MrsJobV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts)

---

##### `arguments`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.arguments"></a>

```typescript
public readonly arguments: string;
```

- *Type:* `string`

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

---

##### `hiveScriptPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.hiveScriptPath"></a>

```typescript
public readonly hiveScriptPath: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `input`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.input"></a>

```typescript
public readonly input: string;
```

- *Type:* `string`

---

##### `isProtected`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.isProtected"></a>

```typescript
public readonly isProtected: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isPublic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `jarPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jarPath"></a>

```typescript
public readonly jarPath: string;
```

- *Type:* `string`

---

##### `jobLog`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobLog"></a>

```typescript
public readonly jobLog: string;
```

- *Type:* `string`

---

##### `jobName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* `string`

---

##### `jobType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.jobType"></a>

```typescript
public readonly jobType: number;
```

- *Type:* `number`

---

##### `output`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.output"></a>

```typescript
public readonly output: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1.property.tfResourceType"></a>

- *Type:* `string`

---

### NatDnatRuleV2 <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2 opentelekomcloud_nat_dnat_rule_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.Initializer"></a>

```typescript
import { NatDnatRuleV2 } from '@cdktf/provider-opentelekomcloud'

new NatDnatRuleV2(scope: Construct, id: string, config: NatDnatRuleV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NatDnatRuleV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.resetPortId"></a>

```typescript
public resetPortId()
```

##### `resetPrivateIp` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.resetPrivateIp"></a>

```typescript
public resetPrivateIp()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `floatingIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.floatingIpAddress"></a>

```typescript
public readonly floatingIpAddress: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.timeouts"></a>

```typescript
public readonly timeouts: NatDnatRuleV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference)

---

##### `externalServicePortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.externalServicePortInput"></a>

```typescript
public readonly externalServicePortInput: number;
```

- *Type:* `number`

---

##### `floatingIpIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.floatingIpIdInput"></a>

```typescript
public readonly floatingIpIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `internalServicePortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.internalServicePortInput"></a>

```typescript
public readonly internalServicePortInput: number;
```

- *Type:* `number`

---

##### `natGatewayIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.natGatewayIdInput"></a>

```typescript
public readonly natGatewayIdInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `privateIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.privateIpInput"></a>

```typescript
public readonly privateIpInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NatDnatRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts)

---

##### `externalServicePort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.externalServicePort"></a>

```typescript
public readonly externalServicePort: number;
```

- *Type:* `number`

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalServicePort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.internalServicePort"></a>

```typescript
public readonly internalServicePort: number;
```

- *Type:* `number`

---

##### `natGatewayId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.natGatewayId"></a>

```typescript
public readonly natGatewayId: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NatGatewayV2 <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2 opentelekomcloud_nat_gateway_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.Initializer"></a>

```typescript
import { NatGatewayV2 } from '@cdktf/provider-opentelekomcloud'

new NatGatewayV2(scope: Construct, id: string, config: NatGatewayV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatGatewayV2Config`](#@cdktf/provider-opentelekomcloud.NatGatewayV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NatGatewayV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.timeouts"></a>

```typescript
public readonly timeouts: NatGatewayV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `internalNetworkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.internalNetworkIdInput"></a>

```typescript
public readonly internalNetworkIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `specInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.specInput"></a>

```typescript
public readonly specInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NatGatewayV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalNetworkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.internalNetworkId"></a>

```typescript
public readonly internalNetworkId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `spec`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.spec"></a>

```typescript
public readonly spec: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NatSnatRuleV2 <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2 opentelekomcloud_nat_snat_rule_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.Initializer"></a>

```typescript
import { NatSnatRuleV2 } from '@cdktf/provider-opentelekomcloud'

new NatSnatRuleV2(scope: Construct, id: string, config: NatSnatRuleV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NatSnatRuleV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts)

---

##### `resetCidr` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetCidr"></a>

```typescript
public resetCidr()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetId"></a>

```typescript
public resetId()
```

##### `resetNetworkId` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetNetworkId"></a>

```typescript
public resetNetworkId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSourceType` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetSourceType"></a>

```typescript
public resetSourceType()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.timeouts"></a>

```typescript
public readonly timeouts: NatSnatRuleV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference)

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `floatingIpIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.floatingIpIdInput"></a>

```typescript
public readonly floatingIpIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `natGatewayIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.natGatewayIdInput"></a>

```typescript
public readonly natGatewayIdInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.sourceTypeInput"></a>

```typescript
public readonly sourceTypeInput: number;
```

- *Type:* `number`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NatSnatRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts)

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `natGatewayId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.natGatewayId"></a>

```typescript
public readonly natGatewayId: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `sourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.sourceType"></a>

```typescript
public readonly sourceType: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingFloatingipAssociateV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_associate_v2 opentelekomcloud_networking_floatingip_associate_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.Initializer"></a>

```typescript
import { NetworkingFloatingipAssociateV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingFloatingipAssociateV2(scope: Construct, id: string, config: NetworkingFloatingipAssociateV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `floatingIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.floatingIpInput"></a>

```typescript
public readonly floatingIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `floatingIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.floatingIp"></a>

```typescript
public readonly floatingIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingFloatingipV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2 opentelekomcloud_networking_floatingip_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.Initializer"></a>

```typescript
import { NetworkingFloatingipV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingFloatingipV2(scope: Construct, id: string, config?: NetworkingFloatingipV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingFloatingipV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts)

---

##### `resetFixedIp` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetFixedIp"></a>

```typescript
public resetFixedIp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPool` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetPool"></a>

```typescript
public resetPool()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetPortId"></a>

```typescript
public resetPortId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingFloatingipV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference)

---

##### `fixedIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.fixedIpInput"></a>

```typescript
public readonly fixedIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `poolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.poolInput"></a>

```typescript
public readonly poolInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingFloatingipV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `pool`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingNetworkV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2 opentelekomcloud_networking_network_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.Initializer"></a>

```typescript
import { NetworkingNetworkV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingNetworkV2(scope: Construct, id: string, config?: NetworkingNetworkV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config)

---

#### Methods <a name="Methods"></a>

##### `putSegments` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.putSegments"></a>

```typescript
public putSegments(value: IResolvable | NetworkingNetworkV2Segments[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingNetworkV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSegments` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetSegments"></a>

```typescript
public resetSegments()
```

##### `resetShared` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetShared"></a>

```typescript
public resetShared()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `segments`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.segments"></a>

```typescript
public readonly segments: NetworkingNetworkV2SegmentsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingNetworkV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `segmentsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.segmentsInput"></a>

```typescript
public readonly segmentsInput: IResolvable | NetworkingNetworkV2Segments[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments)[]

---

##### `sharedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.sharedInput"></a>

```typescript
public readonly sharedInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingNetworkV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.shared"></a>

```typescript
public readonly shared: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingPortV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2 opentelekomcloud_networking_port_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.Initializer"></a>

```typescript
import { NetworkingPortV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2(scope: Construct, id: string, config: NetworkingPortV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2Config)

---

#### Methods <a name="Methods"></a>

##### `putAllowedAddressPairs` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.putAllowedAddressPairs"></a>

```typescript
public putAllowedAddressPairs(value: IResolvable | NetworkingPortV2AllowedAddressPairs[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs)[]

---

##### `putFixedIp` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.putFixedIp"></a>

```typescript
public putFixedIp(value: IResolvable | NetworkingPortV2FixedIp[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingPortV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetAllowedAddressPairs` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetAllowedAddressPairs"></a>

```typescript
public resetAllowedAddressPairs()
```

##### `resetDeviceId` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetDeviceId"></a>

```typescript
public resetDeviceId()
```

##### `resetDeviceOwner` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetDeviceOwner"></a>

```typescript
public resetDeviceOwner()
```

##### `resetFixedIp` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetFixedIp"></a>

```typescript
public resetFixedIp()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetId"></a>

```typescript
public resetId()
```

##### `resetMacAddress` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetMacAddress"></a>

```typescript
public resetMacAddress()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetName"></a>

```typescript
public resetName()
```

##### `resetNoSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetNoSecurityGroups"></a>

```typescript
public resetNoSecurityGroups()
```

##### `resetPortSecurityEnabled` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetPortSecurityEnabled"></a>

```typescript
public resetPortSecurityEnabled()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecurityGroupIds` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `allFixedIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.allFixedIps"></a>

```typescript
public readonly allFixedIps: string[];
```

- *Type:* `string`[]

---

##### `allowedAddressPairs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.allowedAddressPairs"></a>

```typescript
public readonly allowedAddressPairs: NetworkingPortV2AllowedAddressPairsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList)

---

##### `fixedIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.fixedIp"></a>

```typescript
public readonly fixedIp: NetworkingPortV2FixedIpList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingPortV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `allowedAddressPairsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.allowedAddressPairsInput"></a>

```typescript
public readonly allowedAddressPairsInput: IResolvable | NetworkingPortV2AllowedAddressPairs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs)[]

---

##### `deviceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.deviceIdInput"></a>

```typescript
public readonly deviceIdInput: string;
```

- *Type:* `string`

---

##### `deviceOwnerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.deviceOwnerInput"></a>

```typescript
public readonly deviceOwnerInput: string;
```

- *Type:* `string`

---

##### `fixedIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.fixedIpInput"></a>

```typescript
public readonly fixedIpInput: IResolvable | NetworkingPortV2FixedIp[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `macAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.macAddressInput"></a>

```typescript
public readonly macAddressInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `noSecurityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.noSecurityGroupsInput"></a>

```typescript
public readonly noSecurityGroupsInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `portSecurityEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.portSecurityEnabledInput"></a>

```typescript
public readonly portSecurityEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* `string`[]

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingPortV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `deviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* `string`

---

##### `deviceOwner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.deviceOwner"></a>

```typescript
public readonly deviceOwner: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `macAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `noSecurityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.noSecurityGroups"></a>

```typescript
public readonly noSecurityGroups: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `portSecurityEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.portSecurityEnabled"></a>

```typescript
public readonly portSecurityEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* `string`[]

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingRouterInterfaceV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2 opentelekomcloud_networking_router_interface_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.Initializer"></a>

```typescript
import { NetworkingRouterInterfaceV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingRouterInterfaceV2(scope: Construct, id: string, config: NetworkingRouterInterfaceV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingRouterInterfaceV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.resetPortId"></a>

```typescript
public resetPortId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingRouterInterfaceV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingRouterInterfaceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingRouterRouteV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2 opentelekomcloud_networking_router_route_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.Initializer"></a>

```typescript
import { NetworkingRouterRouteV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingRouterRouteV2(scope: Construct, id: string, config: NetworkingRouterRouteV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.resetRegion"></a>

```typescript
public resetRegion()
```


#### Properties <a name="Properties"></a>

##### `destinationCidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.destinationCidrInput"></a>

```typescript
public readonly destinationCidrInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nextHopInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.nextHopInput"></a>

```typescript
public readonly nextHopInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `destinationCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.destinationCidr"></a>

```typescript
public readonly destinationCidr: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `nextHop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.nextHop"></a>

```typescript
public readonly nextHop: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingRouterV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2 opentelekomcloud_networking_router_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.Initializer"></a>

```typescript
import { NetworkingRouterV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingRouterV2(scope: Construct, id: string, config?: NetworkingRouterV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingRouterV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDistributed` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetDistributed"></a>

```typescript
public resetDistributed()
```

##### `resetEnableSnat` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetEnableSnat"></a>

```typescript
public resetEnableSnat()
```

##### `resetExternalGateway` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetExternalGateway"></a>

```typescript
public resetExternalGateway()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingRouterV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `distributedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.distributedInput"></a>

```typescript
public readonly distributedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableSnatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.enableSnatInput"></a>

```typescript
public readonly enableSnatInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `externalGatewayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.externalGatewayInput"></a>

```typescript
public readonly externalGatewayInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingRouterV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `distributed`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.distributed"></a>

```typescript
public readonly distributed: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableSnat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.enableSnat"></a>

```typescript
public readonly enableSnat: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `externalGateway`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.externalGateway"></a>

```typescript
public readonly externalGateway: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingSecgroupRuleV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2 opentelekomcloud_networking_secgroup_rule_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.Initializer"></a>

```typescript
import { NetworkingSecgroupRuleV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingSecgroupRuleV2(scope: Construct, id: string, config: NetworkingSecgroupRuleV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingSecgroupRuleV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPortRangeMax` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetPortRangeMax"></a>

```typescript
public resetPortRangeMax()
```

##### `resetPortRangeMin` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetPortRangeMin"></a>

```typescript
public resetPortRangeMin()
```

##### `resetProtocol` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetProtocol"></a>

```typescript
public resetProtocol()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRemoteGroupId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetRemoteGroupId"></a>

```typescript
public resetRemoteGroupId()
```

##### `resetRemoteIpPrefix` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetRemoteIpPrefix"></a>

```typescript
public resetRemoteIpPrefix()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSecgroupRuleV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `directionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.directionInput"></a>

```typescript
public readonly directionInput: string;
```

- *Type:* `string`

---

##### `ethertypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.ethertypeInput"></a>

```typescript
public readonly ethertypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portRangeMaxInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.portRangeMaxInput"></a>

```typescript
public readonly portRangeMaxInput: number;
```

- *Type:* `number`

---

##### `portRangeMinInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.portRangeMinInput"></a>

```typescript
public readonly portRangeMinInput: number;
```

- *Type:* `number`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `remoteGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.remoteGroupIdInput"></a>

```typescript
public readonly remoteGroupIdInput: string;
```

- *Type:* `string`

---

##### `remoteIpPrefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.remoteIpPrefixInput"></a>

```typescript
public readonly remoteIpPrefixInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingSecgroupRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `direction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.direction"></a>

```typescript
public readonly direction: string;
```

- *Type:* `string`

---

##### `ethertype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.ethertype"></a>

```typescript
public readonly ethertype: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portRangeMax`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.portRangeMax"></a>

```typescript
public readonly portRangeMax: number;
```

- *Type:* `number`

---

##### `portRangeMin`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.portRangeMin"></a>

```typescript
public readonly portRangeMin: number;
```

- *Type:* `number`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `remoteGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.remoteGroupId"></a>

```typescript
public readonly remoteGroupId: string;
```

- *Type:* `string`

---

##### `remoteIpPrefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.remoteIpPrefix"></a>

```typescript
public readonly remoteIpPrefix: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingSecgroupV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2 opentelekomcloud_networking_secgroup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.Initializer"></a>

```typescript
import { NetworkingSecgroupV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingSecgroupV2(scope: Construct, id: string, config: NetworkingSecgroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingSecgroupV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts)

---

##### `resetDeleteDefaultRules` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetDeleteDefaultRules"></a>

```typescript
public resetDeleteDefaultRules()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSecgroupV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference)

---

##### `deleteDefaultRulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.deleteDefaultRulesInput"></a>

```typescript
public readonly deleteDefaultRulesInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingSecgroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts)

---

##### `deleteDefaultRules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.deleteDefaultRules"></a>

```typescript
public readonly deleteDefaultRules: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingSubnetV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2 opentelekomcloud_networking_subnet_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.Initializer"></a>

```typescript
import { NetworkingSubnetV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2(scope: Construct, id: string, config: NetworkingSubnetV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config)

---

#### Methods <a name="Methods"></a>

##### `putAllocationPools` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.putAllocationPools"></a>

```typescript
public putAllocationPools(value: IResolvable | NetworkingSubnetV2AllocationPools[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools)[]

---

##### `putHostRoutes` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.putHostRoutes"></a>

```typescript
public putHostRoutes(value: IResolvable | NetworkingSubnetV2HostRoutes[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.putTimeouts"></a>

```typescript
public putTimeouts(value: NetworkingSubnetV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts)

---

##### `resetAllocationPools` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetAllocationPools"></a>

```typescript
public resetAllocationPools()
```

##### `resetDnsNameservers` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetDnsNameservers"></a>

```typescript
public resetDnsNameservers()
```

##### `resetEnableDhcp` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetEnableDhcp"></a>

```typescript
public resetEnableDhcp()
```

##### `resetGatewayIp` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetGatewayIp"></a>

```typescript
public resetGatewayIp()
```

##### `resetHostRoutes` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetHostRoutes"></a>

```typescript
public resetHostRoutes()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIpVersion` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetIpVersion"></a>

```typescript
public resetIpVersion()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetName"></a>

```typescript
public resetName()
```

##### `resetNoGateway` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetNoGateway"></a>

```typescript
public resetNoGateway()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `allocationPools`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.allocationPools"></a>

```typescript
public readonly allocationPools: NetworkingSubnetV2AllocationPoolsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList)

---

##### `hostRoutes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.hostRoutes"></a>

```typescript
public readonly hostRoutes: NetworkingSubnetV2HostRoutesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSubnetV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference)

---

##### `allocationPoolsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.allocationPoolsInput"></a>

```typescript
public readonly allocationPoolsInput: IResolvable | NetworkingSubnetV2AllocationPools[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools)[]

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `dnsNameserversInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.dnsNameserversInput"></a>

```typescript
public readonly dnsNameserversInput: string[];
```

- *Type:* `string`[]

---

##### `enableDhcpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.enableDhcpInput"></a>

```typescript
public readonly enableDhcpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `gatewayIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.gatewayIpInput"></a>

```typescript
public readonly gatewayIpInput: string;
```

- *Type:* `string`

---

##### `hostRoutesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.hostRoutesInput"></a>

```typescript
public readonly hostRoutesInput: IResolvable | NetworkingSubnetV2HostRoutes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.ipVersionInput"></a>

```typescript
public readonly ipVersionInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `noGatewayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.noGatewayInput"></a>

```typescript
public readonly noGatewayInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | NetworkingSubnetV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `dnsNameservers`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.dnsNameservers"></a>

```typescript
public readonly dnsNameservers: string[];
```

- *Type:* `string`[]

---

##### `enableDhcp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.enableDhcp"></a>

```typescript
public readonly enableDhcp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `gatewayIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.ipVersion"></a>

```typescript
public readonly ipVersion: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `noGateway`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.noGateway"></a>

```typescript
public readonly noGateway: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingVipAssociateV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_associate_v2 opentelekomcloud_networking_vip_associate_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.Initializer"></a>

```typescript
import { NetworkingVipAssociateV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingVipAssociateV2(scope: Construct, id: string, config: NetworkingVipAssociateV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `vipIpAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.vipIpAddress"></a>

```typescript
public readonly vipIpAddress: string;
```

- *Type:* `string`

---

##### `vipSubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.vipSubnetId"></a>

```typescript
public readonly vipSubnetId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.portIdsInput"></a>

```typescript
public readonly portIdsInput: string[];
```

- *Type:* `string`[]

---

##### `vipIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.vipIdInput"></a>

```typescript
public readonly vipIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.portIds"></a>

```typescript
public readonly portIds: string[];
```

- *Type:* `string`[]

---

##### `vipId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.vipId"></a>

```typescript
public readonly vipId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2.property.tfResourceType"></a>

- *Type:* `string`

---

### NetworkingVipV2 <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2 opentelekomcloud_networking_vip_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.Initializer"></a>

```typescript
import { NetworkingVipV2 } from '@cdktf/provider-opentelekomcloud'

new NetworkingVipV2(scope: Construct, id: string, config: NetworkingVipV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingVipV2Config`](#@cdktf/provider-opentelekomcloud.NetworkingVipV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIpAddress` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.resetIpAddress"></a>

```typescript
public resetIpAddress()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.resetName"></a>

```typescript
public resetName()
```


#### Properties <a name="Properties"></a>

##### `deviceOwner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.deviceOwner"></a>

```typescript
public readonly deviceOwner: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2.property.tfResourceType"></a>

- *Type:* `string`

---

### ObsBucket <a name="@cdktf/provider-opentelekomcloud.ObsBucket"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket opentelekomcloud_obs_bucket}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucket.Initializer"></a>

```typescript
import { ObsBucket } from '@cdktf/provider-opentelekomcloud'

new ObsBucket(scope: Construct, id: string, config: ObsBucketConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketConfig`](#@cdktf/provider-opentelekomcloud.ObsBucketConfig)

---

#### Methods <a name="Methods"></a>

##### `putCorsRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putCorsRule"></a>

```typescript
public putCorsRule(value: IResolvable | ObsBucketCorsRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRule)[]

---

##### `putEventNotifications` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putEventNotifications"></a>

```typescript
public putEventNotifications(value: IResolvable | ObsBucketEventNotifications[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications)[]

---

##### `putLifecycleRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putLifecycleRule"></a>

```typescript
public putLifecycleRule(value: IResolvable | ObsBucketLifecycleRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule)[]

---

##### `putLogging` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putLogging"></a>

```typescript
public putLogging(value: IResolvable | ObsBucketLogging[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLogging`](#@cdktf/provider-opentelekomcloud.ObsBucketLogging)[]

---

##### `putServerSideEncryption` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putServerSideEncryption"></a>

```typescript
public putServerSideEncryption(value: ObsBucketServerSideEncryption)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption`](#@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption)

---

##### `putWebsite` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.putWebsite"></a>

```typescript
public putWebsite(value: ObsBucketWebsite)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketWebsite`](#@cdktf/provider-opentelekomcloud.ObsBucketWebsite)

---

##### `resetAcl` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetAcl"></a>

```typescript
public resetAcl()
```

##### `resetCorsRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetCorsRule"></a>

```typescript
public resetCorsRule()
```

##### `resetEventNotifications` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetEventNotifications"></a>

```typescript
public resetEventNotifications()
```

##### `resetForceDestroy` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetForceDestroy"></a>

```typescript
public resetForceDestroy()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetId"></a>

```typescript
public resetId()
```

##### `resetLifecycleRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetLifecycleRule"></a>

```typescript
public resetLifecycleRule()
```

##### `resetLogging` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetLogging"></a>

```typescript
public resetLogging()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetServerSideEncryption` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetServerSideEncryption"></a>

```typescript
public resetServerSideEncryption()
```

##### `resetStorageClass` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetStorageClass"></a>

```typescript
public resetStorageClass()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetTags"></a>

```typescript
public resetTags()
```

##### `resetVersioning` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetVersioning"></a>

```typescript
public resetVersioning()
```

##### `resetWebsite` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.resetWebsite"></a>

```typescript
public resetWebsite()
```


#### Properties <a name="Properties"></a>

##### `bucketDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* `string`

---

##### `corsRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.corsRule"></a>

```typescript
public readonly corsRule: ObsBucketCorsRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList)

---

##### `eventNotifications`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.eventNotifications"></a>

```typescript
public readonly eventNotifications: ObsBucketEventNotificationsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList)

---

##### `lifecycleRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: ObsBucketLifecycleRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList)

---

##### `logging`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.logging"></a>

```typescript
public readonly logging: ObsBucketLoggingList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLoggingList`](#@cdktf/provider-opentelekomcloud.ObsBucketLoggingList)

---

##### `serverSideEncryption`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: ObsBucketServerSideEncryptionOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference`](#@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference)

---

##### `website`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.website"></a>

```typescript
public readonly website: ObsBucketWebsiteOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference`](#@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference)

---

##### `aclInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `corsRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.corsRuleInput"></a>

```typescript
public readonly corsRuleInput: IResolvable | ObsBucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRule)[]

---

##### `eventNotificationsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.eventNotificationsInput"></a>

```typescript
public readonly eventNotificationsInput: IResolvable | ObsBucketEventNotifications[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications)[]

---

##### `forceDestroyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.forceDestroyInput"></a>

```typescript
public readonly forceDestroyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `lifecycleRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.lifecycleRuleInput"></a>

```typescript
public readonly lifecycleRuleInput: IResolvable | ObsBucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule)[]

---

##### `loggingInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.loggingInput"></a>

```typescript
public readonly loggingInput: IResolvable | ObsBucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLogging`](#@cdktf/provider-opentelekomcloud.ObsBucketLogging)[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverSideEncryptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.serverSideEncryptionInput"></a>

```typescript
public readonly serverSideEncryptionInput: ObsBucketServerSideEncryption;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption`](#@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption)

---

##### `storageClassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `versioningInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.versioningInput"></a>

```typescript
public readonly versioningInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `websiteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.websiteInput"></a>

```typescript
public readonly websiteInput: ObsBucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketWebsite`](#@cdktf/provider-opentelekomcloud.ObsBucketWebsite)

---

##### `acl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `forceDestroy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `versioning`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.versioning"></a>

```typescript
public readonly versioning: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ObsBucket.property.tfResourceType"></a>

- *Type:* `string`

---

### ObsBucketObject <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object opentelekomcloud_obs_bucket_object}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.Initializer"></a>

```typescript
import { ObsBucketObject } from '@cdktf/provider-opentelekomcloud'

new ObsBucketObject(scope: Construct, id: string, config: ObsBucketObjectConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig`](#@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig)

---

#### Methods <a name="Methods"></a>

##### `resetAcl` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetAcl"></a>

```typescript
public resetAcl()
```

##### `resetContent` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetContent"></a>

```typescript
public resetContent()
```

##### `resetContentType` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetContentType"></a>

```typescript
public resetContentType()
```

##### `resetEncryption` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetEncryption"></a>

```typescript
public resetEncryption()
```

##### `resetEtag` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetEtag"></a>

```typescript
public resetEtag()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetId"></a>

```typescript
public resetId()
```

##### `resetKmsKeyId` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetKmsKeyId"></a>

```typescript
public resetKmsKeyId()
```

##### `resetSource` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetSource"></a>

```typescript
public resetSource()
```

##### `resetStorageClass` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.resetStorageClass"></a>

```typescript
public resetStorageClass()
```


#### Properties <a name="Properties"></a>

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `versionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

---

##### `aclInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `contentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.contentInput"></a>

```typescript
public readonly contentInput: string;
```

- *Type:* `string`

---

##### `contentTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.contentTypeInput"></a>

```typescript
public readonly contentTypeInput: string;
```

- *Type:* `string`

---

##### `encryptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.encryptionInput"></a>

```typescript
public readonly encryptionInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `etagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.etagInput"></a>

```typescript
public readonly etagInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `kmsKeyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.kmsKeyIdInput"></a>

```typescript
public readonly kmsKeyIdInput: string;
```

- *Type:* `string`

---

##### `sourceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.sourceInput"></a>

```typescript
public readonly sourceInput: string;
```

- *Type:* `string`

---

##### `storageClassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* `string`

---

##### `acl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

---

##### `contentType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

---

##### `encryption`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.encryption"></a>

```typescript
public readonly encryption: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `etag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `kmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.kmsKeyId"></a>

```typescript
public readonly kmsKeyId: string;
```

- *Type:* `string`

---

##### `source`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* `string`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ObsBucketObject.property.tfResourceType"></a>

- *Type:* `string`

---

### ObsBucketPolicy <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_policy opentelekomcloud_obs_bucket_policy}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.Initializer"></a>

```typescript
import { ObsBucketPolicy } from '@cdktf/provider-opentelekomcloud'

new ObsBucketPolicy(scope: Construct, id: string, config: ObsBucketPolicyConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig`](#@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.policyInput"></a>

```typescript
public readonly policyInput: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicy.property.tfResourceType"></a>

- *Type:* `string`

---

### OpentelekomcloudProvider <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud opentelekomcloud}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.Initializer"></a>

```typescript
import { OpentelekomcloudProvider } from '@cdktf/provider-opentelekomcloud'

new OpentelekomcloudProvider(scope: Construct, id: string, config?: OpentelekomcloudProviderConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig`](#@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig)

---

#### Methods <a name="Methods"></a>

##### `resetAccessKey` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetAccessKey"></a>

```typescript
public resetAccessKey()
```

##### `resetAgencyDomainName` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetAgencyDomainName"></a>

```typescript
public resetAgencyDomainName()
```

##### `resetAgencyName` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetAgencyName"></a>

```typescript
public resetAgencyName()
```

##### `resetAlias` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetAlias"></a>

```typescript
public resetAlias()
```

##### `resetAuthUrl` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetAuthUrl"></a>

```typescript
public resetAuthUrl()
```

##### `resetCacertFile` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetCacertFile"></a>

```typescript
public resetCacertFile()
```

##### `resetCert` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetCert"></a>

```typescript
public resetCert()
```

##### `resetCloud` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetCloud"></a>

```typescript
public resetCloud()
```

##### `resetDelegatedProject` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetDelegatedProject"></a>

```typescript
public resetDelegatedProject()
```

##### `resetDomainId` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetDomainId"></a>

```typescript
public resetDomainId()
```

##### `resetDomainName` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetDomainName"></a>

```typescript
public resetDomainName()
```

##### `resetEndpointType` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetEndpointType"></a>

```typescript
public resetEndpointType()
```

##### `resetInsecure` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetInsecure"></a>

```typescript
public resetInsecure()
```

##### `resetKey` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetKey"></a>

```typescript
public resetKey()
```

##### `resetMaxRetries` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetMaxRetries"></a>

```typescript
public resetMaxRetries()
```

##### `resetPasscode` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetPasscode"></a>

```typescript
public resetPasscode()
```

##### `resetPassword` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetPassword"></a>

```typescript
public resetPassword()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecretKey` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetSecretKey"></a>

```typescript
public resetSecretKey()
```

##### `resetSecurityToken` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetSecurityToken"></a>

```typescript
public resetSecurityToken()
```

##### `resetSwauth` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetSwauth"></a>

```typescript
public resetSwauth()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTenantName` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetTenantName"></a>

```typescript
public resetTenantName()
```

##### `resetToken` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetToken"></a>

```typescript
public resetToken()
```

##### `resetUserId` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetUserId"></a>

```typescript
public resetUserId()
```

##### `resetUserName` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.resetUserName"></a>

```typescript
public resetUserName()
```


#### Properties <a name="Properties"></a>

##### `accessKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.accessKeyInput"></a>

```typescript
public readonly accessKeyInput: string;
```

- *Type:* `string`

---

##### `agencyDomainNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.agencyDomainNameInput"></a>

```typescript
public readonly agencyDomainNameInput: string;
```

- *Type:* `string`

---

##### `agencyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.agencyNameInput"></a>

```typescript
public readonly agencyNameInput: string;
```

- *Type:* `string`

---

##### `aliasInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.aliasInput"></a>

```typescript
public readonly aliasInput: string;
```

- *Type:* `string`

---

##### `authUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.authUrlInput"></a>

```typescript
public readonly authUrlInput: string;
```

- *Type:* `string`

---

##### `cacertFileInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.cacertFileInput"></a>

```typescript
public readonly cacertFileInput: string;
```

- *Type:* `string`

---

##### `certInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.certInput"></a>

```typescript
public readonly certInput: string;
```

- *Type:* `string`

---

##### `cloudInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.cloudInput"></a>

```typescript
public readonly cloudInput: string;
```

- *Type:* `string`

---

##### `delegatedProjectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.delegatedProjectInput"></a>

```typescript
public readonly delegatedProjectInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `domainNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.domainNameInput"></a>

```typescript
public readonly domainNameInput: string;
```

- *Type:* `string`

---

##### `endpointTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.endpointTypeInput"></a>

```typescript
public readonly endpointTypeInput: string;
```

- *Type:* `string`

---

##### `insecureInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.insecureInput"></a>

```typescript
public readonly insecureInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `maxRetriesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.maxRetriesInput"></a>

```typescript
public readonly maxRetriesInput: number;
```

- *Type:* `number`

---

##### `passcodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.passcodeInput"></a>

```typescript
public readonly passcodeInput: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `secretKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.secretKeyInput"></a>

```typescript
public readonly secretKeyInput: string;
```

- *Type:* `string`

---

##### `securityTokenInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.securityTokenInput"></a>

```typescript
public readonly securityTokenInput: string;
```

- *Type:* `string`

---

##### `swauthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.swauthInput"></a>

```typescript
public readonly swauthInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `tenantNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tenantNameInput"></a>

```typescript
public readonly tenantNameInput: string;
```

- *Type:* `string`

---

##### `tokenInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tokenInput"></a>

```typescript
public readonly tokenInput: string;
```

- *Type:* `string`

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `userNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.userNameInput"></a>

```typescript
public readonly userNameInput: string;
```

- *Type:* `string`

---

##### `accessKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* `string`

---

##### `agencyDomainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.agencyDomainName"></a>

```typescript
public readonly agencyDomainName: string;
```

- *Type:* `string`

---

##### `agencyName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.agencyName"></a>

```typescript
public readonly agencyName: string;
```

- *Type:* `string`

---

##### `alias`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* `string`

---

##### `authUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.authUrl"></a>

```typescript
public readonly authUrl: string;
```

- *Type:* `string`

---

##### `cacertFile`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.cacertFile"></a>

```typescript
public readonly cacertFile: string;
```

- *Type:* `string`

---

##### `cert`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.cert"></a>

```typescript
public readonly cert: string;
```

- *Type:* `string`

---

##### `cloud`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.cloud"></a>

```typescript
public readonly cloud: string;
```

- *Type:* `string`

---

##### `delegatedProject`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.delegatedProject"></a>

```typescript
public readonly delegatedProject: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `domainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

---

##### `endpointType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.endpointType"></a>

```typescript
public readonly endpointType: string;
```

- *Type:* `string`

---

##### `insecure`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `key`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `maxRetries`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

---

##### `passcode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.passcode"></a>

```typescript
public readonly passcode: string;
```

- *Type:* `string`

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `secretKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* `string`

---

##### `securityToken`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.securityToken"></a>

```typescript
public readonly securityToken: string;
```

- *Type:* `string`

---

##### `swauth`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.swauth"></a>

```typescript
public readonly swauth: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `tenantName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tenantName"></a>

```typescript
public readonly tenantName: string;
```

- *Type:* `string`

---

##### `token`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.token"></a>

```typescript
public readonly token: string;
```

- *Type:* `string`

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `userName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProvider.property.tfResourceType"></a>

- *Type:* `string`

---

### RdsInstanceV1 <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1 opentelekomcloud_rds_instance_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.Initializer"></a>

```typescript
import { RdsInstanceV1 } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1(scope: Construct, id: string, config: RdsInstanceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Config`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Config)

---

#### Methods <a name="Methods"></a>

##### `putBackupstrategy` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putBackupstrategy"></a>

```typescript
public putBackupstrategy(value: RdsInstanceV1Backupstrategy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy)

---

##### `putDatastore` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putDatastore"></a>

```typescript
public putDatastore(value: RdsInstanceV1Datastore)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore)

---

##### `putHa` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putHa"></a>

```typescript
public putHa(value: RdsInstanceV1Ha)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha)

---

##### `putNics` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putNics"></a>

```typescript
public putNics(value: RdsInstanceV1Nics)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics)

---

##### `putSecuritygroup` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putSecuritygroup"></a>

```typescript
public putSecuritygroup(value: RdsInstanceV1Securitygroup)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putTimeouts"></a>

```typescript
public putTimeouts(value: RdsInstanceV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts)

---

##### `putVolume` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.putVolume"></a>

```typescript
public putVolume(value: RdsInstanceV1Volume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume)

---

##### `resetBackupstrategy` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetBackupstrategy"></a>

```typescript
public resetBackupstrategy()
```

##### `resetDbport` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetDbport"></a>

```typescript
public resetDbport()
```

##### `resetHa` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetHa"></a>

```typescript
public resetHa()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTag` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetTag"></a>

```typescript
public resetTag()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `backupstrategy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.backupstrategy"></a>

```typescript
public readonly backupstrategy: RdsInstanceV1BackupstrategyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference)

---

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.datastore"></a>

```typescript
public readonly datastore: RdsInstanceV1DatastoreOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference)

---

##### `ha`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.ha"></a>

```typescript
public readonly ha: RdsInstanceV1HaOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference)

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

---

##### `nics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.nics"></a>

```typescript
public readonly nics: RdsInstanceV1NicsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference)

---

##### `securitygroup`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.securitygroup"></a>

```typescript
public readonly securitygroup: RdsInstanceV1SecuritygroupOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.timeouts"></a>

```typescript
public readonly timeouts: RdsInstanceV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference)

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `updated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.updated"></a>

```typescript
public readonly updated: string;
```

- *Type:* `string`

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.volume"></a>

```typescript
public readonly volume: RdsInstanceV1VolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference)

---

##### `availabilityzoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.availabilityzoneInput"></a>

```typescript
public readonly availabilityzoneInput: string;
```

- *Type:* `string`

---

##### `backupstrategyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.backupstrategyInput"></a>

```typescript
public readonly backupstrategyInput: RdsInstanceV1Backupstrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy)

---

##### `datastoreInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.datastoreInput"></a>

```typescript
public readonly datastoreInput: RdsInstanceV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore)

---

##### `dbportInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.dbportInput"></a>

```typescript
public readonly dbportInput: string;
```

- *Type:* `string`

---

##### `dbrtpdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.dbrtpdInput"></a>

```typescript
public readonly dbrtpdInput: string;
```

- *Type:* `string`

---

##### `flavorrefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.flavorrefInput"></a>

```typescript
public readonly flavorrefInput: string;
```

- *Type:* `string`

---

##### `haInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.haInput"></a>

```typescript
public readonly haInput: RdsInstanceV1Ha;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nicsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.nicsInput"></a>

```typescript
public readonly nicsInput: RdsInstanceV1Nics;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securitygroupInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.securitygroupInput"></a>

```typescript
public readonly securitygroupInput: RdsInstanceV1Securitygroup;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup)

---

##### `tagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.tagInput"></a>

```typescript
public readonly tagInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RdsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts)

---

##### `volumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.volumeInput"></a>

```typescript
public readonly volumeInput: RdsInstanceV1Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume)

---

##### `vpcInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.vpcInput"></a>

```typescript
public readonly vpcInput: string;
```

- *Type:* `string`

---

##### `availabilityzone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.availabilityzone"></a>

```typescript
public readonly availabilityzone: string;
```

- *Type:* `string`

---

##### `dbport`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.dbport"></a>

```typescript
public readonly dbport: string;
```

- *Type:* `string`

---

##### `dbrtpd`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.dbrtpd"></a>

```typescript
public readonly dbrtpd: string;
```

- *Type:* `string`

---

##### `flavorref`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.flavorref"></a>

```typescript
public readonly flavorref: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.tag"></a>

```typescript
public readonly tag: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.vpc"></a>

```typescript
public readonly vpc: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### RdsInstanceV3 <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3 opentelekomcloud_rds_instance_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.Initializer"></a>

```typescript
import { RdsInstanceV3 } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3(scope: Construct, id: string, config: RdsInstanceV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Config`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Config)

---

#### Methods <a name="Methods"></a>

##### `putBackupStrategy` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.putBackupStrategy"></a>

```typescript
public putBackupStrategy(value: RdsInstanceV3BackupStrategy)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy)

---

##### `putDb` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.putDb"></a>

```typescript
public putDb(value: RdsInstanceV3Db)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Db`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Db)

---

##### `putRestorePoint` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.putRestorePoint"></a>

```typescript
public putRestorePoint(value: RdsInstanceV3RestorePoint)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.putTimeouts"></a>

```typescript
public putTimeouts(value: RdsInstanceV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts)

---

##### `putVolume` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.putVolume"></a>

```typescript
public putVolume(value: RdsInstanceV3Volume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume)

---

##### `resetBackupStrategy` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetBackupStrategy"></a>

```typescript
public resetBackupStrategy()
```

##### `resetHaReplicationMode` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetHaReplicationMode"></a>

```typescript
public resetHaReplicationMode()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetId"></a>

```typescript
public resetId()
```

##### `resetParameters` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetParameters"></a>

```typescript
public resetParameters()
```

##### `resetParamGroupId` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetParamGroupId"></a>

```typescript
public resetParamGroupId()
```

##### `resetPublicIps` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetPublicIps"></a>

```typescript
public resetPublicIps()
```

##### `resetRestorePoint` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetRestorePoint"></a>

```typescript
public resetRestorePoint()
```

##### `resetTag` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetTag"></a>

```typescript
public resetTag()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `backupStrategy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: RdsInstanceV3BackupStrategyOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference)

---

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `db`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.db"></a>

```typescript
public readonly db: RdsInstanceV3DbOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference)

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.nodes"></a>

```typescript
public readonly nodes: RdsInstanceV3NodesList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList)

---

##### `privateIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.privateIps"></a>

```typescript
public readonly privateIps: string[];
```

- *Type:* `string`[]

---

##### `restorePoint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.restorePoint"></a>

```typescript
public readonly restorePoint: RdsInstanceV3RestorePointOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.timeouts"></a>

```typescript
public readonly timeouts: RdsInstanceV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference)

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.volume"></a>

```typescript
public readonly volume: RdsInstanceV3VolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string[];
```

- *Type:* `string`[]

---

##### `backupStrategyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.backupStrategyInput"></a>

```typescript
public readonly backupStrategyInput: RdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy)

---

##### `dbInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.dbInput"></a>

```typescript
public readonly dbInput: RdsInstanceV3Db;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Db`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Db)

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.flavorInput"></a>

```typescript
public readonly flavorInput: string;
```

- *Type:* `string`

---

##### `haReplicationModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.haReplicationModeInput"></a>

```typescript
public readonly haReplicationModeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `parametersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.parametersInput"></a>

```typescript
public readonly parametersInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `paramGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.paramGroupIdInput"></a>

```typescript
public readonly paramGroupIdInput: string;
```

- *Type:* `string`

---

##### `publicIpsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.publicIpsInput"></a>

```typescript
public readonly publicIpsInput: string[];
```

- *Type:* `string`[]

---

##### `restorePointInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.restorePointInput"></a>

```typescript
public readonly restorePointInput: RdsInstanceV3RestorePoint;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint)

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.tagInput"></a>

```typescript
public readonly tagInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RdsInstanceV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts)

---

##### `volumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.volumeInput"></a>

```typescript
public readonly volumeInput: RdsInstanceV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string[];
```

- *Type:* `string`[]

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `haReplicationMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.haReplicationMode"></a>

```typescript
public readonly haReplicationMode: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `parameters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `paramGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.paramGroupId"></a>

```typescript
public readonly paramGroupId: string;
```

- *Type:* `string`

---

##### `publicIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.publicIps"></a>

```typescript
public readonly publicIps: string[];
```

- *Type:* `string`[]

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.tag"></a>

```typescript
public readonly tag: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3.property.tfResourceType"></a>

- *Type:* `string`

---

### RdsParametergroupV3 <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3 opentelekomcloud_rds_parametergroup_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.Initializer"></a>

```typescript
import { RdsParametergroupV3 } from '@cdktf/provider-opentelekomcloud'

new RdsParametergroupV3(scope: Construct, id: string, config: RdsParametergroupV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config)

---

#### Methods <a name="Methods"></a>

##### `putDatastore` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.putDatastore"></a>

```typescript
public putDatastore(value: RdsParametergroupV3Datastore)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.resetId"></a>

```typescript
public resetId()
```

##### `resetValues` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.resetValues"></a>

```typescript
public resetValues()
```


#### Properties <a name="Properties"></a>

##### `configurationParameters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.configurationParameters"></a>

```typescript
public readonly configurationParameters: RdsParametergroupV3ConfigurationParametersList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList)

---

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.datastore"></a>

```typescript
public readonly datastore: RdsParametergroupV3DatastoreOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference)

---

##### `updated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.updated"></a>

```typescript
public readonly updated: string;
```

- *Type:* `string`

---

##### `datastoreInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.datastoreInput"></a>

```typescript
public readonly datastoreInput: RdsParametergroupV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `valuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.valuesInput"></a>

```typescript
public readonly valuesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `values`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.values"></a>

```typescript
public readonly values: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3.property.tfResourceType"></a>

- *Type:* `string`

---

### RdsReadReplicaV3 <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3 opentelekomcloud_rds_read_replica_v3}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.Initializer"></a>

```typescript
import { RdsReadReplicaV3 } from '@cdktf/provider-opentelekomcloud'

new RdsReadReplicaV3(scope: Construct, id: string, config: RdsReadReplicaV3Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.putTimeouts"></a>

```typescript
public putTimeouts(value: RdsReadReplicaV3Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts)

---

##### `putVolume` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.putVolume"></a>

```typescript
public putVolume(value: RdsReadReplicaV3Volume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume)

---

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.resetId"></a>

```typescript
public resetId()
```

##### `resetPublicIps` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.resetPublicIps"></a>

```typescript
public resetPublicIps()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `db`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.db"></a>

```typescript
public readonly db: RdsReadReplicaV3DbList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList)

---

##### `privateIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.privateIps"></a>

```typescript
public readonly privateIps: string[];
```

- *Type:* `string`[]

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.timeouts"></a>

```typescript
public readonly timeouts: RdsReadReplicaV3TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference)

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.volume"></a>

```typescript
public readonly volume: RdsReadReplicaV3VolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference)

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `flavorRefInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.flavorRefInput"></a>

```typescript
public readonly flavorRefInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `publicIpsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.publicIpsInput"></a>

```typescript
public readonly publicIpsInput: string[];
```

- *Type:* `string`[]

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `replicaOfIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.replicaOfIdInput"></a>

```typescript
public readonly replicaOfIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RdsReadReplicaV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts)

---

##### `volumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.volumeInput"></a>

```typescript
public readonly volumeInput: RdsReadReplicaV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `flavorRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.flavorRef"></a>

```typescript
public readonly flavorRef: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `publicIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.publicIps"></a>

```typescript
public readonly publicIps: string[];
```

- *Type:* `string`[]

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `replicaOfId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.replicaOfId"></a>

```typescript
public readonly replicaOfId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3.property.tfResourceType"></a>

- *Type:* `string`

---

### RtsSoftwareConfigV1 <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1 opentelekomcloud_rts_software_config_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.Initializer"></a>

```typescript
import { RtsSoftwareConfigV1 } from '@cdktf/provider-opentelekomcloud'

new RtsSoftwareConfigV1(scope: Construct, id: string, config: RtsSoftwareConfigV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.putTimeouts"></a>

```typescript
public putTimeouts(value: RtsSoftwareConfigV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts)

---

##### `resetConfig` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetConfig"></a>

```typescript
public resetConfig()
```

##### `resetGroup` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetGroup"></a>

```typescript
public resetGroup()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetId"></a>

```typescript
public resetId()
```

##### `resetInputValues` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetInputValues"></a>

```typescript
public resetInputValues()
```

##### `resetOptions` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetOptions"></a>

```typescript
public resetOptions()
```

##### `resetOutputValues` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetOutputValues"></a>

```typescript
public resetOutputValues()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.timeouts"></a>

```typescript
public readonly timeouts: RtsSoftwareConfigV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference)

---

##### `configInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.configInput"></a>

```typescript
public readonly configInput: string;
```

- *Type:* `string`

---

##### `groupInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.groupInput"></a>

```typescript
public readonly groupInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `inputValuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.inputValuesInput"></a>

```typescript
public readonly inputValuesInput: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `optionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.optionsInput"></a>

```typescript
public readonly optionsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `outputValuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.outputValuesInput"></a>

```typescript
public readonly outputValuesInput: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RtsSoftwareConfigV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts)

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.config"></a>

```typescript
public readonly config: string;
```

- *Type:* `string`

---

##### `group`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `inputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.inputValues"></a>

```typescript
public readonly inputValues: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `options`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.options"></a>

```typescript
public readonly options: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `outputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.outputValues"></a>

```typescript
public readonly outputValues: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1.property.tfResourceType"></a>

- *Type:* `string`

---

### RtsSoftwareDeploymentV1 <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1 opentelekomcloud_rts_software_deployment_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.Initializer"></a>

```typescript
import { RtsSoftwareDeploymentV1 } from '@cdktf/provider-opentelekomcloud'

new RtsSoftwareDeploymentV1(scope: Construct, id: string, config: RtsSoftwareDeploymentV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.putTimeouts"></a>

```typescript
public putTimeouts(value: RtsSoftwareDeploymentV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts)

---

##### `resetAction` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetAction"></a>

```typescript
public resetAction()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetId"></a>

```typescript
public resetId()
```

##### `resetInputValues` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetInputValues"></a>

```typescript
public resetInputValues()
```

##### `resetOutputValues` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetOutputValues"></a>

```typescript
public resetOutputValues()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetStatusReason` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetStatusReason"></a>

```typescript
public resetStatusReason()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.timeouts"></a>

```typescript
public readonly timeouts: RtsSoftwareDeploymentV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference)

---

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `configIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.configIdInput"></a>

```typescript
public readonly configIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `inputValuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.inputValuesInput"></a>

```typescript
public readonly inputValuesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `outputValuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.outputValuesInput"></a>

```typescript
public readonly outputValuesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `statusReasonInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.statusReasonInput"></a>

```typescript
public readonly statusReasonInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RtsSoftwareDeploymentV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts)

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `configId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.configId"></a>

```typescript
public readonly configId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `inputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.inputValues"></a>

```typescript
public readonly inputValues: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `outputValues`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.outputValues"></a>

```typescript
public readonly outputValues: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `statusReason`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.statusReason"></a>

```typescript
public readonly statusReason: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1.property.tfResourceType"></a>

- *Type:* `string`

---

### RtsStackV1 <a name="@cdktf/provider-opentelekomcloud.RtsStackV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1 opentelekomcloud_rts_stack_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.Initializer"></a>

```typescript
import { RtsStackV1 } from '@cdktf/provider-opentelekomcloud'

new RtsStackV1(scope: Construct, id: string, config: RtsStackV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsStackV1Config`](#@cdktf/provider-opentelekomcloud.RtsStackV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.putTimeouts"></a>

```typescript
public putTimeouts(value: RtsStackV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts)

---

##### `resetDisableRollback` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetDisableRollback"></a>

```typescript
public resetDisableRollback()
```

##### `resetEnvironment` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetEnvironment"></a>

```typescript
public resetEnvironment()
```

##### `resetFiles` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetFiles"></a>

```typescript
public resetFiles()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetId"></a>

```typescript
public resetId()
```

##### `resetParameters` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetParameters"></a>

```typescript
public resetParameters()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTemplateBody` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetTemplateBody"></a>

```typescript
public resetTemplateBody()
```

##### `resetTemplateUrl` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetTemplateUrl"></a>

```typescript
public resetTemplateUrl()
```

##### `resetTimeoutMins` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetTimeoutMins"></a>

```typescript
public resetTimeoutMins()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `capabilities`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.capabilities"></a>

```typescript
public readonly capabilities: string[];
```

- *Type:* `string`[]

---

##### `notificationTopics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.notificationTopics"></a>

```typescript
public readonly notificationTopics: string[];
```

- *Type:* `string`[]

---

##### `outputs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.outputs"></a>

```typescript
public readonly outputs: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `statusReason`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.statusReason"></a>

```typescript
public readonly statusReason: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.timeouts"></a>

```typescript
public readonly timeouts: RtsStackV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference)

---

##### `disableRollbackInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.disableRollbackInput"></a>

```typescript
public readonly disableRollbackInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `environmentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* `string`

---

##### `filesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.filesInput"></a>

```typescript
public readonly filesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `parametersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.parametersInput"></a>

```typescript
public readonly parametersInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `templateBodyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.templateBodyInput"></a>

```typescript
public readonly templateBodyInput: string;
```

- *Type:* `string`

---

##### `templateUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.templateUrlInput"></a>

```typescript
public readonly templateUrlInput: string;
```

- *Type:* `string`

---

##### `timeoutMinsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.timeoutMinsInput"></a>

```typescript
public readonly timeoutMinsInput: number;
```

- *Type:* `number`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | RtsStackV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts)

---

##### `disableRollback`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.disableRollback"></a>

```typescript
public readonly disableRollback: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `environment`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* `string`

---

##### `files`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.files"></a>

```typescript
public readonly files: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `parameters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `templateBody`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.templateBody"></a>

```typescript
public readonly templateBody: string;
```

- *Type:* `string`

---

##### `templateUrl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.templateUrl"></a>

```typescript
public readonly templateUrl: string;
```

- *Type:* `string`

---

##### `timeoutMins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.timeoutMins"></a>

```typescript
public readonly timeoutMins: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1.property.tfResourceType"></a>

- *Type:* `string`

---

### S3Bucket <a name="@cdktf/provider-opentelekomcloud.S3Bucket"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket opentelekomcloud_s3_bucket}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3Bucket.Initializer"></a>

```typescript
import { S3Bucket } from '@cdktf/provider-opentelekomcloud'

new S3Bucket(scope: Construct, id: string, config?: S3BucketConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketConfig`](#@cdktf/provider-opentelekomcloud.S3BucketConfig)

---

#### Methods <a name="Methods"></a>

##### `putCorsRule` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.putCorsRule"></a>

```typescript
public putCorsRule(value: IResolvable | S3BucketCorsRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketCorsRule`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRule)[]

---

##### `putLifecycleRule` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.putLifecycleRule"></a>

```typescript
public putLifecycleRule(value: IResolvable | S3BucketLifecycleRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule)[]

---

##### `putLogging` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.putLogging"></a>

```typescript
public putLogging(value: IResolvable | S3BucketLogging[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLogging`](#@cdktf/provider-opentelekomcloud.S3BucketLogging)[]

---

##### `putVersioning` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.putVersioning"></a>

```typescript
public putVersioning(value: S3BucketVersioning)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketVersioning`](#@cdktf/provider-opentelekomcloud.S3BucketVersioning)

---

##### `putWebsite` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.putWebsite"></a>

```typescript
public putWebsite(value: S3BucketWebsite)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketWebsite`](#@cdktf/provider-opentelekomcloud.S3BucketWebsite)

---

##### `resetAcl` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetAcl"></a>

```typescript
public resetAcl()
```

##### `resetArn` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetArn"></a>

```typescript
public resetArn()
```

##### `resetBucket` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetBucket"></a>

```typescript
public resetBucket()
```

##### `resetBucketPrefix` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetBucketPrefix"></a>

```typescript
public resetBucketPrefix()
```

##### `resetCorsRule` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetCorsRule"></a>

```typescript
public resetCorsRule()
```

##### `resetForceDestroy` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetForceDestroy"></a>

```typescript
public resetForceDestroy()
```

##### `resetHostedZoneId` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetHostedZoneId"></a>

```typescript
public resetHostedZoneId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetId"></a>

```typescript
public resetId()
```

##### `resetLifecycleRule` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetLifecycleRule"></a>

```typescript
public resetLifecycleRule()
```

##### `resetLogging` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetLogging"></a>

```typescript
public resetLogging()
```

##### `resetPolicy` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetPolicy"></a>

```typescript
public resetPolicy()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetTags"></a>

```typescript
public resetTags()
```

##### `resetVersioning` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetVersioning"></a>

```typescript
public resetVersioning()
```

##### `resetWebsite` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetWebsite"></a>

```typescript
public resetWebsite()
```

##### `resetWebsiteDomain` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetWebsiteDomain"></a>

```typescript
public resetWebsiteDomain()
```

##### `resetWebsiteEndpoint` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.resetWebsiteEndpoint"></a>

```typescript
public resetWebsiteEndpoint()
```


#### Properties <a name="Properties"></a>

##### `bucketDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* `string`

---

##### `corsRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.corsRule"></a>

```typescript
public readonly corsRule: S3BucketCorsRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList)

---

##### `lifecycleRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: S3BucketLifecycleRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList)

---

##### `logging`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.logging"></a>

```typescript
public readonly logging: S3BucketLoggingList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketLoggingList`](#@cdktf/provider-opentelekomcloud.S3BucketLoggingList)

---

##### `versioning`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.versioning"></a>

```typescript
public readonly versioning: S3BucketVersioningOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference`](#@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference)

---

##### `website`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.website"></a>

```typescript
public readonly website: S3BucketWebsiteOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference`](#@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference)

---

##### `aclInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* `string`

---

##### `arnInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.arnInput"></a>

```typescript
public readonly arnInput: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `bucketPrefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.bucketPrefixInput"></a>

```typescript
public readonly bucketPrefixInput: string;
```

- *Type:* `string`

---

##### `corsRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.corsRuleInput"></a>

```typescript
public readonly corsRuleInput: IResolvable | S3BucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketCorsRule`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRule)[]

---

##### `forceDestroyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.forceDestroyInput"></a>

```typescript
public readonly forceDestroyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `hostedZoneIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.hostedZoneIdInput"></a>

```typescript
public readonly hostedZoneIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `lifecycleRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.lifecycleRuleInput"></a>

```typescript
public readonly lifecycleRuleInput: IResolvable | S3BucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule)[]

---

##### `loggingInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.loggingInput"></a>

```typescript
public readonly loggingInput: IResolvable | S3BucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLogging`](#@cdktf/provider-opentelekomcloud.S3BucketLogging)[]

---

##### `policyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.policyInput"></a>

```typescript
public readonly policyInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `versioningInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.versioningInput"></a>

```typescript
public readonly versioningInput: S3BucketVersioning;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketVersioning`](#@cdktf/provider-opentelekomcloud.S3BucketVersioning)

---

##### `websiteDomainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.websiteDomainInput"></a>

```typescript
public readonly websiteDomainInput: string;
```

- *Type:* `string`

---

##### `websiteEndpointInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.websiteEndpointInput"></a>

```typescript
public readonly websiteEndpointInput: string;
```

- *Type:* `string`

---

##### `websiteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.websiteInput"></a>

```typescript
public readonly websiteInput: S3BucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketWebsite`](#@cdktf/provider-opentelekomcloud.S3BucketWebsite)

---

##### `acl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

---

##### `arn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.arn"></a>

```typescript
public readonly arn: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `bucketPrefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.bucketPrefix"></a>

```typescript
public readonly bucketPrefix: string;
```

- *Type:* `string`

---

##### `forceDestroy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `hostedZoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.hostedZoneId"></a>

```typescript
public readonly hostedZoneId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `websiteDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.websiteDomain"></a>

```typescript
public readonly websiteDomain: string;
```

- *Type:* `string`

---

##### `websiteEndpoint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.websiteEndpoint"></a>

```typescript
public readonly websiteEndpoint: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.S3Bucket.property.tfResourceType"></a>

- *Type:* `string`

---

### S3BucketObject <a name="@cdktf/provider-opentelekomcloud.S3BucketObject"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object opentelekomcloud_s3_bucket_object}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.Initializer"></a>

```typescript
import { S3BucketObject } from '@cdktf/provider-opentelekomcloud'

new S3BucketObject(scope: Construct, id: string, config: S3BucketObjectConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketObjectConfig`](#@cdktf/provider-opentelekomcloud.S3BucketObjectConfig)

---

#### Methods <a name="Methods"></a>

##### `resetAcl` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetAcl"></a>

```typescript
public resetAcl()
```

##### `resetCacheControl` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetCacheControl"></a>

```typescript
public resetCacheControl()
```

##### `resetContent` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetContent"></a>

```typescript
public resetContent()
```

##### `resetContentDisposition` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetContentDisposition"></a>

```typescript
public resetContentDisposition()
```

##### `resetContentEncoding` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetContentEncoding"></a>

```typescript
public resetContentEncoding()
```

##### `resetContentLanguage` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetContentLanguage"></a>

```typescript
public resetContentLanguage()
```

##### `resetContentType` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetContentType"></a>

```typescript
public resetContentType()
```

##### `resetEtag` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetEtag"></a>

```typescript
public resetEtag()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetId"></a>

```typescript
public resetId()
```

##### `resetServerSideEncryption` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetServerSideEncryption"></a>

```typescript
public resetServerSideEncryption()
```

##### `resetSource` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetSource"></a>

```typescript
public resetSource()
```

##### `resetSseKmsKeyId` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetSseKmsKeyId"></a>

```typescript
public resetSseKmsKeyId()
```

##### `resetWebsiteRedirect` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.resetWebsiteRedirect"></a>

```typescript
public resetWebsiteRedirect()
```


#### Properties <a name="Properties"></a>

##### `versionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

---

##### `aclInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `cacheControlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.cacheControlInput"></a>

```typescript
public readonly cacheControlInput: string;
```

- *Type:* `string`

---

##### `contentDispositionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentDispositionInput"></a>

```typescript
public readonly contentDispositionInput: string;
```

- *Type:* `string`

---

##### `contentEncodingInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentEncodingInput"></a>

```typescript
public readonly contentEncodingInput: string;
```

- *Type:* `string`

---

##### `contentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentInput"></a>

```typescript
public readonly contentInput: string;
```

- *Type:* `string`

---

##### `contentLanguageInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentLanguageInput"></a>

```typescript
public readonly contentLanguageInput: string;
```

- *Type:* `string`

---

##### `contentTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentTypeInput"></a>

```typescript
public readonly contentTypeInput: string;
```

- *Type:* `string`

---

##### `etagInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.etagInput"></a>

```typescript
public readonly etagInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `serverSideEncryptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.serverSideEncryptionInput"></a>

```typescript
public readonly serverSideEncryptionInput: string;
```

- *Type:* `string`

---

##### `sourceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.sourceInput"></a>

```typescript
public readonly sourceInput: string;
```

- *Type:* `string`

---

##### `sseKmsKeyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.sseKmsKeyIdInput"></a>

```typescript
public readonly sseKmsKeyIdInput: string;
```

- *Type:* `string`

---

##### `websiteRedirectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.websiteRedirectInput"></a>

```typescript
public readonly websiteRedirectInput: string;
```

- *Type:* `string`

---

##### `acl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `cacheControl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.cacheControl"></a>

```typescript
public readonly cacheControl: string;
```

- *Type:* `string`

---

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

---

##### `contentDisposition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentDisposition"></a>

```typescript
public readonly contentDisposition: string;
```

- *Type:* `string`

---

##### `contentEncoding`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: string;
```

- *Type:* `string`

---

##### `contentLanguage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentLanguage"></a>

```typescript
public readonly contentLanguage: string;
```

- *Type:* `string`

---

##### `contentType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

---

##### `etag`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `serverSideEncryption`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: string;
```

- *Type:* `string`

---

##### `source`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* `string`

---

##### `sseKmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.sseKmsKeyId"></a>

```typescript
public readonly sseKmsKeyId: string;
```

- *Type:* `string`

---

##### `websiteRedirect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.websiteRedirect"></a>

```typescript
public readonly websiteRedirect: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.S3BucketObject.property.tfResourceType"></a>

- *Type:* `string`

---

### S3BucketPolicy <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_policy opentelekomcloud_s3_bucket_policy}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.Initializer"></a>

```typescript
import { S3BucketPolicy } from '@cdktf/provider-opentelekomcloud'

new S3BucketPolicy(scope: Construct, id: string, config: S3BucketPolicyConfig)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig`](#@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.policyInput"></a>

```typescript
public readonly policyInput: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicy.property.tfResourceType"></a>

- *Type:* `string`

---

### SdrsProtectedInstanceV1 <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1 opentelekomcloud_sdrs_protected_instance_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.Initializer"></a>

```typescript
import { SdrsProtectedInstanceV1 } from '@cdktf/provider-opentelekomcloud'

new SdrsProtectedInstanceV1(scope: Construct, id: string, config: SdrsProtectedInstanceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.putTimeouts"></a>

```typescript
public putTimeouts(value: SdrsProtectedInstanceV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts)

---

##### `resetDeleteTargetEip` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetDeleteTargetEip"></a>

```typescript
public resetDeleteTargetEip()
```

##### `resetDeleteTargetServer` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetDeleteTargetServer"></a>

```typescript
public resetDeleteTargetServer()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetIpAddress` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetIpAddress"></a>

```typescript
public resetIpAddress()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `createdAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* `string`

---

##### `priorityStation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.priorityStation"></a>

```typescript
public readonly priorityStation: string;
```

- *Type:* `string`

---

##### `targetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.targetId"></a>

```typescript
public readonly targetId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.timeouts"></a>

```typescript
public readonly timeouts: SdrsProtectedInstanceV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference)

---

##### `updatedAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* `string`

---

##### `deleteTargetEipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.deleteTargetEipInput"></a>

```typescript
public readonly deleteTargetEipInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `deleteTargetServerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.deleteTargetServerInput"></a>

```typescript
public readonly deleteTargetServerInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `groupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `serverIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.serverIdInput"></a>

```typescript
public readonly serverIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SdrsProtectedInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts)

---

##### `deleteTargetEip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.deleteTargetEip"></a>

```typescript
public readonly deleteTargetEip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `deleteTargetServer`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.deleteTargetServer"></a>

```typescript
public readonly deleteTargetServer: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `groupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### SdrsProtectiongroupV1 <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1 opentelekomcloud_sdrs_protectiongroup_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.Initializer"></a>

```typescript
import { SdrsProtectiongroupV1 } from '@cdktf/provider-opentelekomcloud'

new SdrsProtectiongroupV1(scope: Construct, id: string, config: SdrsProtectiongroupV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.putTimeouts"></a>

```typescript
public putTimeouts(value: SdrsProtectiongroupV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDrType` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.resetDrType"></a>

```typescript
public resetDrType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.timeouts"></a>

```typescript
public readonly timeouts: SdrsProtectiongroupV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `drTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.drTypeInput"></a>

```typescript
public readonly drTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `sourceAvailabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.sourceAvailabilityZoneInput"></a>

```typescript
public readonly sourceAvailabilityZoneInput: string;
```

- *Type:* `string`

---

##### `sourceVpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.sourceVpcIdInput"></a>

```typescript
public readonly sourceVpcIdInput: string;
```

- *Type:* `string`

---

##### `targetAvailabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.targetAvailabilityZoneInput"></a>

```typescript
public readonly targetAvailabilityZoneInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SdrsProtectiongroupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `drType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.drType"></a>

```typescript
public readonly drType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `sourceAvailabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.sourceAvailabilityZone"></a>

```typescript
public readonly sourceAvailabilityZone: string;
```

- *Type:* `string`

---

##### `sourceVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.sourceVpcId"></a>

```typescript
public readonly sourceVpcId: string;
```

- *Type:* `string`

---

##### `targetAvailabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.targetAvailabilityZone"></a>

```typescript
public readonly targetAvailabilityZone: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1.property.tfResourceType"></a>

- *Type:* `string`

---

### SfsFileSystemV2 <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2 opentelekomcloud_sfs_file_system_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.Initializer"></a>

```typescript
import { SfsFileSystemV2 } from '@cdktf/provider-opentelekomcloud'

new SfsFileSystemV2(scope: Construct, id: string, config: SfsFileSystemV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.putTimeouts"></a>

```typescript
public putTimeouts(value: SfsFileSystemV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts)

---

##### `resetAccessLevel` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetAccessLevel"></a>

```typescript
public resetAccessLevel()
```

##### `resetAccessTo` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetAccessTo"></a>

```typescript
public resetAccessTo()
```

##### `resetAccessType` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetAccessType"></a>

```typescript
public resetAccessType()
```

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIsPublic` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetIsPublic"></a>

```typescript
public resetIsPublic()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetMetadata"></a>

```typescript
public resetMetadata()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetShareProto` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetShareProto"></a>

```typescript
public resetShareProto()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `accessRuleStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessRuleStatus"></a>

```typescript
public readonly accessRuleStatus: string;
```

- *Type:* `string`

---

##### `exportLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.exportLocation"></a>

```typescript
public readonly exportLocation: string;
```

- *Type:* `string`

---

##### `host`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* `string`

---

##### `shareAccessId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.shareAccessId"></a>

```typescript
public readonly shareAccessId: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.timeouts"></a>

```typescript
public readonly timeouts: SfsFileSystemV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference)

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `accessLevelInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessLevelInput"></a>

```typescript
public readonly accessLevelInput: string;
```

- *Type:* `string`

---

##### `accessToInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessToInput"></a>

```typescript
public readonly accessToInput: string;
```

- *Type:* `string`

---

##### `accessTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessTypeInput"></a>

```typescript
public readonly accessTypeInput: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `isPublicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.isPublicInput"></a>

```typescript
public readonly isPublicInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `shareProtoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.shareProtoInput"></a>

```typescript
public readonly shareProtoInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SfsFileSystemV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts)

---

##### `accessLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessLevel"></a>

```typescript
public readonly accessLevel: string;
```

- *Type:* `string`

---

##### `accessTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessTo"></a>

```typescript
public readonly accessTo: string;
```

- *Type:* `string`

---

##### `accessType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.accessType"></a>

```typescript
public readonly accessType: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `isPublic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `shareProto`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SfsShareAccessRulesV2 <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2 opentelekomcloud_sfs_share_access_rules_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.Initializer"></a>

```typescript
import { SfsShareAccessRulesV2 } from '@cdktf/provider-opentelekomcloud'

new SfsShareAccessRulesV2(scope: Construct, id: string, config: SfsShareAccessRulesV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config)

---

#### Methods <a name="Methods"></a>

##### `putAccessRule` <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.putAccessRule"></a>

```typescript
public putAccessRule(value: IResolvable | SfsShareAccessRulesV2AccessRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule)[]

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `accessRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.accessRule"></a>

```typescript
public readonly accessRule: SfsShareAccessRulesV2AccessRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList)

---

##### `accessRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.accessRuleInput"></a>

```typescript
public readonly accessRuleInput: IResolvable | SfsShareAccessRulesV2AccessRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `shareIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.shareIdInput"></a>

```typescript
public readonly shareIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `shareId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.shareId"></a>

```typescript
public readonly shareId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SfsTurboShareV1 <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1 opentelekomcloud_sfs_turbo_share_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.Initializer"></a>

```typescript
import { SfsTurboShareV1 } from '@cdktf/provider-opentelekomcloud'

new SfsTurboShareV1(scope: Construct, id: string, config: SfsTurboShareV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.putTimeouts"></a>

```typescript
public putTimeouts(value: SfsTurboShareV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts)

---

##### `resetCryptKeyId` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetCryptKeyId"></a>

```typescript
public resetCryptKeyId()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetShareProto` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetShareProto"></a>

```typescript
public resetShareProto()
```

##### `resetShareType` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetShareType"></a>

```typescript
public resetShareType()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `availableCapacity`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.availableCapacity"></a>

```typescript
public readonly availableCapacity: string;
```

- *Type:* `string`

---

##### `exportLocation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.exportLocation"></a>

```typescript
public readonly exportLocation: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.timeouts"></a>

```typescript
public readonly timeouts: SfsTurboShareV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference)

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `cryptKeyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.cryptKeyIdInput"></a>

```typescript
public readonly cryptKeyIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `shareProtoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.shareProtoInput"></a>

```typescript
public readonly shareProtoInput: string;
```

- *Type:* `string`

---

##### `shareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.shareTypeInput"></a>

```typescript
public readonly shareTypeInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SfsTurboShareV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `cryptKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.cryptKeyId"></a>

```typescript
public readonly cryptKeyId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `shareProto`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1.property.tfResourceType"></a>

- *Type:* `string`

---

### SmnSubscriptionV2 <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2 opentelekomcloud_smn_subscription_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.Initializer"></a>

```typescript
import { SmnSubscriptionV2 } from '@cdktf/provider-opentelekomcloud'

new SmnSubscriptionV2(scope: Construct, id: string, config: SmnSubscriptionV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config`](#@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectName` <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.resetProjectName"></a>

```typescript
public resetProjectName()
```

##### `resetRemark` <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.resetRemark"></a>

```typescript
public resetRemark()
```


#### Properties <a name="Properties"></a>

##### `owner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.status"></a>

```typescript
public readonly status: number;
```

- *Type:* `number`

---

##### `subscriptionUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.subscriptionUrn"></a>

```typescript
public readonly subscriptionUrn: string;
```

- *Type:* `string`

---

##### `endpointInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.endpointInput"></a>

```typescript
public readonly endpointInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `projectNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.projectNameInput"></a>

```typescript
public readonly projectNameInput: string;
```

- *Type:* `string`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `remarkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.remarkInput"></a>

```typescript
public readonly remarkInput: string;
```

- *Type:* `string`

---

##### `topicUrnInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.topicUrnInput"></a>

```typescript
public readonly topicUrnInput: string;
```

- *Type:* `string`

---

##### `endpoint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `projectName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `remark`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.remark"></a>

```typescript
public readonly remark: string;
```

- *Type:* `string`

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SmnTopicAttributeV2 <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_attribute_v2 opentelekomcloud_smn_topic_attribute_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.Initializer"></a>

```typescript
import { SmnTopicAttributeV2 } from '@cdktf/provider-opentelekomcloud'

new SmnTopicAttributeV2(scope: Construct, id: string, config: SmnTopicAttributeV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config`](#@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `attributeNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.attributeNameInput"></a>

```typescript
public readonly attributeNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `topicAttributeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.topicAttributeInput"></a>

```typescript
public readonly topicAttributeInput: string;
```

- *Type:* `string`

---

##### `topicUrnInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.topicUrnInput"></a>

```typescript
public readonly topicUrnInput: string;
```

- *Type:* `string`

---

##### `attributeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.attributeName"></a>

```typescript
public readonly attributeName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `topicAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.topicAttribute"></a>

```typescript
public readonly topicAttribute: string;
```

- *Type:* `string`

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SmnTopicV2 <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_v2 opentelekomcloud_smn_topic_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.Initializer"></a>

```typescript
import { SmnTopicV2 } from '@cdktf/provider-opentelekomcloud'

new SmnTopicV2(scope: Construct, id: string, config: SmnTopicV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SmnTopicV2Config`](#@cdktf/provider-opentelekomcloud.SmnTopicV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetDisplayName` <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.resetDisplayName"></a>

```typescript
public resetDisplayName()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.resetId"></a>

```typescript
public resetId()
```

##### `resetProjectName` <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.resetProjectName"></a>

```typescript
public resetProjectName()
```


#### Properties <a name="Properties"></a>

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `pushPolicy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.pushPolicy"></a>

```typescript
public readonly pushPolicy: number;
```

- *Type:* `number`

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

---

##### `updateTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.updateTime"></a>

```typescript
public readonly updateTime: string;
```

- *Type:* `string`

---

##### `displayNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.displayNameInput"></a>

```typescript
public readonly displayNameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `projectNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.projectNameInput"></a>

```typescript
public readonly projectNameInput: string;
```

- *Type:* `string`

---

##### `displayName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.displayName"></a>

```typescript
public readonly displayName: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `projectName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SwrDomainV2 <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2 opentelekomcloud_swr_domain_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.Initializer"></a>

```typescript
import { SwrDomainV2 } from '@cdktf/provider-opentelekomcloud'

new SwrDomainV2(scope: Construct, id: string, config: SwrDomainV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrDomainV2Config`](#@cdktf/provider-opentelekomcloud.SwrDomainV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.putTimeouts"></a>

```typescript
public putTimeouts(value: SwrDomainV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `created`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.created"></a>

```typescript
public readonly created: string;
```

- *Type:* `string`

---

##### `creatorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.creatorId"></a>

```typescript
public readonly creatorId: string;
```

- *Type:* `string`

---

##### `creatorName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.creatorName"></a>

```typescript
public readonly creatorName: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.status"></a>

```typescript
public readonly status: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.timeouts"></a>

```typescript
public readonly timeouts: SwrDomainV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference)

---

##### `updated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.updated"></a>

```typescript
public readonly updated: string;
```

- *Type:* `string`

---

##### `accessDomainInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.accessDomainInput"></a>

```typescript
public readonly accessDomainInput: string;
```

- *Type:* `string`

---

##### `deadlineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.deadlineInput"></a>

```typescript
public readonly deadlineInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `organizationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.organizationInput"></a>

```typescript
public readonly organizationInput: string;
```

- *Type:* `string`

---

##### `permissionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.permissionInput"></a>

```typescript
public readonly permissionInput: string;
```

- *Type:* `string`

---

##### `repositoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.repositoryInput"></a>

```typescript
public readonly repositoryInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SwrDomainV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts)

---

##### `accessDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.accessDomain"></a>

```typescript
public readonly accessDomain: string;
```

- *Type:* `string`

---

##### `deadline`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.deadline"></a>

```typescript
public readonly deadline: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

---

##### `permission`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.permission"></a>

```typescript
public readonly permission: string;
```

- *Type:* `string`

---

##### `repository`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.repository"></a>

```typescript
public readonly repository: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SwrOrganizationPermissionsV2 <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2 opentelekomcloud_swr_organization_permissions_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.Initializer"></a>

```typescript
import { SwrOrganizationPermissionsV2 } from '@cdktf/provider-opentelekomcloud'

new SwrOrganizationPermissionsV2(scope: Construct, id: string, config: SwrOrganizationPermissionsV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.putTimeouts"></a>

```typescript
public putTimeouts(value: SwrOrganizationPermissionsV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.timeouts"></a>

```typescript
public readonly timeouts: SwrOrganizationPermissionsV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference)

---

##### `authInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.authInput"></a>

```typescript
public readonly authInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `organizationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.organizationInput"></a>

```typescript
public readonly organizationInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SwrOrganizationPermissionsV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts)

---

##### `userIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* `string`

---

##### `usernameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.usernameInput"></a>

```typescript
public readonly usernameInput: string;
```

- *Type:* `string`

---

##### `auth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.auth"></a>

```typescript
public readonly auth: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `username`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SwrOrganizationV2 <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2 opentelekomcloud_swr_organization_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.Initializer"></a>

```typescript
import { SwrOrganizationV2 } from '@cdktf/provider-opentelekomcloud'

new SwrOrganizationV2(scope: Construct, id: string, config: SwrOrganizationV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.putTimeouts"></a>

```typescript
public putTimeouts(value: SwrOrganizationV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `auth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.auth"></a>

```typescript
public readonly auth: number;
```

- *Type:* `number`

---

##### `creatorName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.creatorName"></a>

```typescript
public readonly creatorName: string;
```

- *Type:* `string`

---

##### `organizationId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.organizationId"></a>

```typescript
public readonly organizationId: number;
```

- *Type:* `number`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.timeouts"></a>

```typescript
public readonly timeouts: SwrOrganizationV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SwrOrganizationV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2.property.tfResourceType"></a>

- *Type:* `string`

---

### SwrRepositoryV2 <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2 opentelekomcloud_swr_repository_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.Initializer"></a>

```typescript
import { SwrRepositoryV2 } from '@cdktf/provider-opentelekomcloud'

new SwrRepositoryV2(scope: Construct, id: string, config: SwrRepositoryV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.putTimeouts"></a>

```typescript
public putTimeouts(value: SwrRepositoryV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts)

---

##### `resetCategory` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.resetCategory"></a>

```typescript
public resetCategory()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `internalPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.internalPath"></a>

```typescript
public readonly internalPath: string;
```

- *Type:* `string`

---

##### `numImages`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.numImages"></a>

```typescript
public readonly numImages: number;
```

- *Type:* `number`

---

##### `path`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* `string`

---

##### `repositoryId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.repositoryId"></a>

```typescript
public readonly repositoryId: number;
```

- *Type:* `number`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.timeouts"></a>

```typescript
public readonly timeouts: SwrRepositoryV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference)

---

##### `categoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.categoryInput"></a>

```typescript
public readonly categoryInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `isPublicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.isPublicInput"></a>

```typescript
public readonly isPublicInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `organizationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.organizationInput"></a>

```typescript
public readonly organizationInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | SwrRepositoryV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts)

---

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `isPublic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VbsBackupPolicyV2 <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2 opentelekomcloud_vbs_backup_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.Initializer"></a>

```typescript
import { VbsBackupPolicyV2 } from '@cdktf/provider-opentelekomcloud'

new VbsBackupPolicyV2(scope: Construct, id: string, config: VbsBackupPolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTags` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.putTags"></a>

```typescript
public putTags(value: IResolvable | VbsBackupPolicyV2Tags[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VbsBackupPolicyV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts)

---

##### `resetFrequency` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetFrequency"></a>

```typescript
public resetFrequency()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetRententionDay` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetRententionDay"></a>

```typescript
public resetRententionDay()
```

##### `resetRententionNum` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetRententionNum"></a>

```typescript
public resetRententionNum()
```

##### `resetResources` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetResources"></a>

```typescript
public resetResources()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetWeekFrequency` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.resetWeekFrequency"></a>

```typescript
public resetWeekFrequency()
```


#### Properties <a name="Properties"></a>

##### `policyResourceCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.policyResourceCount"></a>

```typescript
public readonly policyResourceCount: number;
```

- *Type:* `number`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.tags"></a>

```typescript
public readonly tags: VbsBackupPolicyV2TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupPolicyV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference)

---

##### `frequencyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.frequencyInput"></a>

```typescript
public readonly frequencyInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `rententionDayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.rententionDayInput"></a>

```typescript
public readonly rententionDayInput: number;
```

- *Type:* `number`

---

##### `rententionNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.rententionNumInput"></a>

```typescript
public readonly rententionNumInput: number;
```

- *Type:* `number`

---

##### `resourcesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: string[];
```

- *Type:* `string`[]

---

##### `retainFirstBackupInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.retainFirstBackupInput"></a>

```typescript
public readonly retainFirstBackupInput: string;
```

- *Type:* `string`

---

##### `startTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: IResolvable | VbsBackupPolicyV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VbsBackupPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts)

---

##### `weekFrequencyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.weekFrequencyInput"></a>

```typescript
public readonly weekFrequencyInput: string[];
```

- *Type:* `string`[]

---

##### `frequency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.frequency"></a>

```typescript
public readonly frequency: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `rententionDay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.rententionDay"></a>

```typescript
public readonly rententionDay: number;
```

- *Type:* `number`

---

##### `rententionNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.rententionNum"></a>

```typescript
public readonly rententionNum: number;
```

- *Type:* `number`

---

##### `resources`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* `string`[]

---

##### `retainFirstBackup`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.retainFirstBackup"></a>

```typescript
public readonly retainFirstBackup: string;
```

- *Type:* `string`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `weekFrequency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.weekFrequency"></a>

```typescript
public readonly weekFrequency: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VbsBackupShareV2 <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2 opentelekomcloud_vbs_backup_share_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.Initializer"></a>

```typescript
import { VbsBackupShareV2 } from '@cdktf/provider-opentelekomcloud'

new VbsBackupShareV2(scope: Construct, id: string, config: VbsBackupShareV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VbsBackupShareV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `backupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.backupName"></a>

```typescript
public readonly backupName: string;
```

- *Type:* `string`

---

##### `backupStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.backupStatus"></a>

```typescript
public readonly backupStatus: string;
```

- *Type:* `string`

---

##### `container`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.container"></a>

```typescript
public readonly container: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `serviceMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.serviceMetadata"></a>

```typescript
public readonly serviceMetadata: string;
```

- *Type:* `string`

---

##### `shareIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.shareIds"></a>

```typescript
public readonly shareIds: string[];
```

- *Type:* `string`[]

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupShareV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference)

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

---

##### `backupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VbsBackupShareV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts)

---

##### `toProjectIdsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.toProjectIdsInput"></a>

```typescript
public readonly toProjectIdsInput: string[];
```

- *Type:* `string`[]

---

##### `backupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `toProjectIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.toProjectIds"></a>

```typescript
public readonly toProjectIds: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VbsBackupV2 <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2 opentelekomcloud_vbs_backup_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.Initializer"></a>

```typescript
import { VbsBackupV2 } from '@cdktf/provider-opentelekomcloud'

new VbsBackupV2(scope: Construct, id: string, config: VbsBackupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupV2Config`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTags` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.putTags"></a>

```typescript
public putTags(value: IResolvable | VbsBackupV2Tags[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Tags)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VbsBackupV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSnapshotId` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetSnapshotId"></a>

```typescript
public resetSnapshotId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `container`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.container"></a>

```typescript
public readonly container: string;
```

- *Type:* `string`

---

##### `serviceMetadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.serviceMetadata"></a>

```typescript
public readonly serviceMetadata: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.tags"></a>

```typescript
public readonly tags: VbsBackupV2TagsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList`](#@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: IResolvable | VbsBackupV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Tags)[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VbsBackupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts)

---

##### `volumeIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.volumeIdInput"></a>

```typescript
public readonly volumeIdInput: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcBandwidthAssociateV2 <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2 opentelekomcloud_vpc_bandwidth_associate_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.Initializer"></a>

```typescript
import { VpcBandwidthAssociateV2 } from '@cdktf/provider-opentelekomcloud'

new VpcBandwidthAssociateV2(scope: Construct, id: string, config: VpcBandwidthAssociateV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config`](#@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetBackupChargeMode` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.resetBackupChargeMode"></a>

```typescript
public resetBackupChargeMode()
```

##### `resetBackupSize` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.resetBackupSize"></a>

```typescript
public resetBackupSize()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `backupChargeModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.backupChargeModeInput"></a>

```typescript
public readonly backupChargeModeInput: string;
```

- *Type:* `string`

---

##### `backupSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.backupSizeInput"></a>

```typescript
public readonly backupSizeInput: number;
```

- *Type:* `number`

---

##### `bandwidthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.bandwidthInput"></a>

```typescript
public readonly bandwidthInput: string;
```

- *Type:* `string`

---

##### `floatingIpsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.floatingIpsInput"></a>

```typescript
public readonly floatingIpsInput: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `backupChargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.backupChargeMode"></a>

```typescript
public readonly backupChargeMode: string;
```

- *Type:* `string`

---

##### `backupSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.backupSize"></a>

```typescript
public readonly backupSize: number;
```

- *Type:* `number`

---

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.bandwidth"></a>

```typescript
public readonly bandwidth: string;
```

- *Type:* `string`

---

##### `floatingIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.floatingIps"></a>

```typescript
public readonly floatingIps: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcBandwidthV2 <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_v2 opentelekomcloud_vpc_bandwidth_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.Initializer"></a>

```typescript
import { VpcBandwidthV2 } from '@cdktf/provider-opentelekomcloud'

new VpcBandwidthV2(scope: Construct, id: string, config: VpcBandwidthV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config`](#@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcEipV1 <a name="@cdktf/provider-opentelekomcloud.VpcEipV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1 opentelekomcloud_vpc_eip_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.Initializer"></a>

```typescript
import { VpcEipV1 } from '@cdktf/provider-opentelekomcloud'

new VpcEipV1(scope: Construct, id: string, config: VpcEipV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Config`](#@cdktf/provider-opentelekomcloud.VpcEipV1Config)

---

#### Methods <a name="Methods"></a>

##### `putBandwidth` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.putBandwidth"></a>

```typescript
public putBandwidth(value: VpcEipV1Bandwidth)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth`](#@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth)

---

##### `putPublicip` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.putPublicip"></a>

```typescript
public putPublicip(value: VpcEipV1Publicip)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Publicip`](#@cdktf/provider-opentelekomcloud.VpcEipV1Publicip)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcEipV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.bandwidth"></a>

```typescript
public readonly bandwidth: VpcEipV1BandwidthOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference`](#@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference)

---

##### `publicip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.publicip"></a>

```typescript
public readonly publicip: VpcEipV1PublicipOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference`](#@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcEipV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference)

---

##### `bandwidthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.bandwidthInput"></a>

```typescript
public readonly bandwidthInput: VpcEipV1Bandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth`](#@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `publicipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.publicipInput"></a>

```typescript
public readonly publicipInput: VpcEipV1Publicip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Publicip`](#@cdktf/provider-opentelekomcloud.VpcEipV1Publicip)

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcEipV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcepEndpointV1 <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1 opentelekomcloud_vpcep_endpoint_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.Initializer"></a>

```typescript
import { VpcepEndpointV1 } from '@cdktf/provider-opentelekomcloud'

new VpcepEndpointV1(scope: Construct, id: string, config: VpcepEndpointV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcepEndpointV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts)

---

##### `resetEnableDns` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetEnableDns"></a>

```typescript
public resetEnableDns()
```

##### `resetEnableWhitelist` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetEnableWhitelist"></a>

```typescript
public resetEnableWhitelist()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPortIp` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetPortIp"></a>

```typescript
public resetPortIp()
```

##### `resetRouteTables` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetRouteTables"></a>

```typescript
public resetRouteTables()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetWhitelist` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.resetWhitelist"></a>

```typescript
public resetWhitelist()
```


#### Properties <a name="Properties"></a>

##### `dnsNames`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.dnsNames"></a>

```typescript
public readonly dnsNames: string[];
```

- *Type:* `string`[]

---

##### `markerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.markerId"></a>

```typescript
public readonly markerId: number;
```

- *Type:* `number`

---

##### `projectId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

---

##### `serviceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* `string`

---

##### `serviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.serviceType"></a>

```typescript
public readonly serviceType: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcepEndpointV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference)

---

##### `enableDnsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.enableDnsInput"></a>

```typescript
public readonly enableDnsInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableWhitelistInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.enableWhitelistInput"></a>

```typescript
public readonly enableWhitelistInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `portIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.portIpInput"></a>

```typescript
public readonly portIpInput: string;
```

- *Type:* `string`

---

##### `routeTablesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.routeTablesInput"></a>

```typescript
public readonly routeTablesInput: string[];
```

- *Type:* `string`[]

---

##### `serviceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.serviceIdInput"></a>

```typescript
public readonly serviceIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcepEndpointV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `whitelistInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.whitelistInput"></a>

```typescript
public readonly whitelistInput: string[];
```

- *Type:* `string`[]

---

##### `enableDns`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.enableDns"></a>

```typescript
public readonly enableDns: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableWhitelist`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.enableWhitelist"></a>

```typescript
public readonly enableWhitelist: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `portIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.portIp"></a>

```typescript
public readonly portIp: string;
```

- *Type:* `string`

---

##### `routeTables`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.routeTables"></a>

```typescript
public readonly routeTables: string[];
```

- *Type:* `string`[]

---

##### `serviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.serviceId"></a>

```typescript
public readonly serviceId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `whitelist`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.whitelist"></a>

```typescript
public readonly whitelist: string[];
```

- *Type:* `string`[]

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcepServiceV1 <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1 opentelekomcloud_vpcep_service_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.Initializer"></a>

```typescript
import { VpcepServiceV1 } from '@cdktf/provider-opentelekomcloud'

new VpcepServiceV1(scope: Construct, id: string, config: VpcepServiceV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Config`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Config)

---

#### Methods <a name="Methods"></a>

##### `putPort` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.putPort"></a>

```typescript
public putPort(value: IResolvable | VpcepServiceV1Port[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Port)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcepServiceV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts)

---

##### `resetApprovalEnabled` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetApprovalEnabled"></a>

```typescript
public resetApprovalEnabled()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetName"></a>

```typescript
public resetName()
```

##### `resetPoolId` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetPoolId"></a>

```typescript
public resetPoolId()
```

##### `resetServiceType` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetServiceType"></a>

```typescript
public resetServiceType()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTcpProxy` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetTcpProxy"></a>

```typescript
public resetTcpProxy()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetVipPortId` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.resetVipPortId"></a>

```typescript
public resetVipPortId()
```


#### Properties <a name="Properties"></a>

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.port"></a>

```typescript
public readonly port: VpcepServiceV1PortList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcepServiceV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference)

---

##### `approvalEnabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.approvalEnabledInput"></a>

```typescript
public readonly approvalEnabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.portInput"></a>

```typescript
public readonly portInput: IResolvable | VpcepServiceV1Port[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Port)[]

---

##### `serverTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.serverTypeInput"></a>

```typescript
public readonly serverTypeInput: string;
```

- *Type:* `string`

---

##### `serviceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.serviceTypeInput"></a>

```typescript
public readonly serviceTypeInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tcpProxyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.tcpProxyInput"></a>

```typescript
public readonly tcpProxyInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcepServiceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts)

---

##### `vipPortIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.vipPortIdInput"></a>

```typescript
public readonly vipPortIdInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `approvalEnabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.approvalEnabled"></a>

```typescript
public readonly approvalEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `serverType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.serverType"></a>

```typescript
public readonly serverType: string;
```

- *Type:* `string`

---

##### `serviceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.serviceType"></a>

```typescript
public readonly serviceType: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tcpProxy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.tcpProxy"></a>

```typescript
public readonly tcpProxy: string;
```

- *Type:* `string`

---

##### `vipPortId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcFlowLogV1 <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1 opentelekomcloud_vpc_flow_log_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.Initializer"></a>

```typescript
import { VpcFlowLogV1 } from '@cdktf/provider-opentelekomcloud'

new VpcFlowLogV1(scope: Construct, id: string, config: VpcFlowLogV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcFlowLogV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts)

---

##### `resetAdminState` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetAdminState"></a>

```typescript
public resetAdminState()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetName"></a>

```typescript
public resetName()
```

##### `resetStatus` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetStatus"></a>

```typescript
public resetStatus()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcFlowLogV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference)

---

##### `adminStateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.adminStateInput"></a>

```typescript
public readonly adminStateInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `logGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.logGroupIdInput"></a>

```typescript
public readonly logGroupIdInput: string;
```

- *Type:* `string`

---

##### `logTopicIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.logTopicIdInput"></a>

```typescript
public readonly logTopicIdInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `resourceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.resourceIdInput"></a>

```typescript
public readonly resourceIdInput: string;
```

- *Type:* `string`

---

##### `resourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.resourceTypeInput"></a>

```typescript
public readonly resourceTypeInput: string;
```

- *Type:* `string`

---

##### `statusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcFlowLogV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts)

---

##### `trafficTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.trafficTypeInput"></a>

```typescript
public readonly trafficTypeInput: string;
```

- *Type:* `string`

---

##### `adminState`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.adminState"></a>

```typescript
public readonly adminState: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `logGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* `string`

---

##### `logTopicId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.logTopicId"></a>

```typescript
public readonly logTopicId: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `resourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `trafficType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.trafficType"></a>

```typescript
public readonly trafficType: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcPeeringConnectionAccepterV2 <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2 opentelekomcloud_vpc_peering_connection_accepter_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.Initializer"></a>

```typescript
import { VpcPeeringConnectionAccepterV2 } from '@cdktf/provider-opentelekomcloud'

new VpcPeeringConnectionAccepterV2(scope: Construct, id: string, config: VpcPeeringConnectionAccepterV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcPeeringConnectionAccepterV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts)

---

##### `resetAccept` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.resetAccept"></a>

```typescript
public resetAccept()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `peerTenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.peerTenantId"></a>

```typescript
public readonly peerTenantId: string;
```

- *Type:* `string`

---

##### `peerVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.peerVpcId"></a>

```typescript
public readonly peerVpcId: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpcPeeringConnectionAccepterV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference)

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `acceptInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.acceptInput"></a>

```typescript
public readonly acceptInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcPeeringConnectionAccepterV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts)

---

##### `vpcPeeringConnectionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.vpcPeeringConnectionIdInput"></a>

```typescript
public readonly vpcPeeringConnectionIdInput: string;
```

- *Type:* `string`

---

##### `accept`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.accept"></a>

```typescript
public readonly accept: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `vpcPeeringConnectionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.vpcPeeringConnectionId"></a>

```typescript
public readonly vpcPeeringConnectionId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcPeeringConnectionV2 <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2 opentelekomcloud_vpc_peering_connection_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.Initializer"></a>

```typescript
import { VpcPeeringConnectionV2 } from '@cdktf/provider-opentelekomcloud'

new VpcPeeringConnectionV2(scope: Construct, id: string, config: VpcPeeringConnectionV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcPeeringConnectionV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.resetId"></a>

```typescript
public resetId()
```

##### `resetPeerTenantId` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.resetPeerTenantId"></a>

```typescript
public resetPeerTenantId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpcPeeringConnectionV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `peerTenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.peerTenantIdInput"></a>

```typescript
public readonly peerTenantIdInput: string;
```

- *Type:* `string`

---

##### `peerVpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.peerVpcIdInput"></a>

```typescript
public readonly peerVpcIdInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcPeeringConnectionV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `peerTenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.peerTenantId"></a>

```typescript
public readonly peerTenantId: string;
```

- *Type:* `string`

---

##### `peerVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.peerVpcId"></a>

```typescript
public readonly peerVpcId: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcRouteV2 <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2 opentelekomcloud_vpc_route_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.Initializer"></a>

```typescript
import { VpcRouteV2 } from '@cdktf/provider-opentelekomcloud'

new VpcRouteV2(scope: Construct, id: string, config: VpcRouteV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcRouteV2Config`](#@cdktf/provider-opentelekomcloud.VpcRouteV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcRouteV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpcRouteV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference)

---

##### `destinationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.destinationInput"></a>

```typescript
public readonly destinationInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nexthopInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.nexthopInput"></a>

```typescript
public readonly nexthopInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcRouteV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `destination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.destination"></a>

```typescript
public readonly destination: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `nexthop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.nexthop"></a>

```typescript
public readonly nexthop: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcSubnetV1 <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1 opentelekomcloud_vpc_subnet_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.Initializer"></a>

```typescript
import { VpcSubnetV1 } from '@cdktf/provider-opentelekomcloud'

new VpcSubnetV1(scope: Construct, id: string, config: VpcSubnetV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcSubnetV1Config`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcSubnetV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts)

---

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDhcpEnable` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetDhcpEnable"></a>

```typescript
public resetDhcpEnable()
```

##### `resetDnsList` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetDnsList"></a>

```typescript
public resetDnsList()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetId"></a>

```typescript
public resetId()
```

##### `resetNtpAddresses` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetNtpAddresses"></a>

```typescript
public resetNtpAddresses()
```

##### `resetPrimaryDns` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetPrimaryDns"></a>

```typescript
public resetPrimaryDns()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSecondaryDns` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetSecondaryDns"></a>

```typescript
public resetSecondaryDns()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSubnetV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `dhcpEnableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.dhcpEnableInput"></a>

```typescript
public readonly dhcpEnableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `dnsListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.dnsListInput"></a>

```typescript
public readonly dnsListInput: string[];
```

- *Type:* `string`[]

---

##### `gatewayIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.gatewayIpInput"></a>

```typescript
public readonly gatewayIpInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `ntpAddressesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.ntpAddressesInput"></a>

```typescript
public readonly ntpAddressesInput: string;
```

- *Type:* `string`

---

##### `primaryDnsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.primaryDnsInput"></a>

```typescript
public readonly primaryDnsInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `secondaryDnsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.secondaryDnsInput"></a>

```typescript
public readonly secondaryDnsInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcSubnetV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts)

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `dhcpEnable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.dhcpEnable"></a>

```typescript
public readonly dhcpEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `dnsList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.dnsList"></a>

```typescript
public readonly dnsList: string[];
```

- *Type:* `string`[]

---

##### `gatewayIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `ntpAddresses`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.ntpAddresses"></a>

```typescript
public readonly ntpAddresses: string;
```

- *Type:* `string`

---

##### `primaryDns`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.primaryDns"></a>

```typescript
public readonly primaryDns: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `secondaryDns`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.secondaryDns"></a>

```typescript
public readonly secondaryDns: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpcV1 <a name="@cdktf/provider-opentelekomcloud.VpcV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1 opentelekomcloud_vpc_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcV1.Initializer"></a>

```typescript
import { VpcV1 } from '@cdktf/provider-opentelekomcloud'

new VpcV1(scope: Construct, id: string, config: VpcV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcV1Config`](#@cdktf/provider-opentelekomcloud.VpcV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcV1.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcV1Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetShared` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetShared"></a>

```typescript
public resetShared()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpcV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.timeouts"></a>

```typescript
public readonly timeouts: VpcV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference)

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `sharedInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.sharedInput"></a>

```typescript
public readonly sharedInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcV1Timeouts)

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `shared`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpcV1.property.tfResourceType"></a>

- *Type:* `string`

---

### VpnaasEndpointGroupV2 <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2 opentelekomcloud_vpnaas_endpoint_group_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.Initializer"></a>

```typescript
import { VpnaasEndpointGroupV2 } from '@cdktf/provider-opentelekomcloud'

new VpnaasEndpointGroupV2(scope: Construct, id: string, config?: VpnaasEndpointGroupV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpnaasEndpointGroupV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts)

---

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEndpoints` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetEndpoints"></a>

```typescript
public resetEndpoints()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetType"></a>

```typescript
public resetType()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasEndpointGroupV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `endpointsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.endpointsInput"></a>

```typescript
public readonly endpointsInput: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpnaasEndpointGroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts)

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `endpoints`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.endpoints"></a>

```typescript
public readonly endpoints: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpnaasIkePolicyV2 <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2 opentelekomcloud_vpnaas_ike_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.Initializer"></a>

```typescript
import { VpnaasIkePolicyV2 } from '@cdktf/provider-opentelekomcloud'

new VpnaasIkePolicyV2(scope: Construct, id: string, config?: VpnaasIkePolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putLifetime` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.putLifetime"></a>

```typescript
public putLifetime(value: IResolvable | VpnaasIkePolicyV2Lifetime[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpnaasIkePolicyV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts)

---

##### `resetAuthAlgorithm` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetAuthAlgorithm"></a>

```typescript
public resetAuthAlgorithm()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEncryptionAlgorithm` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetEncryptionAlgorithm"></a>

```typescript
public resetEncryptionAlgorithm()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetIkeVersion` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetIkeVersion"></a>

```typescript
public resetIkeVersion()
```

##### `resetLifetime` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetLifetime"></a>

```typescript
public resetLifetime()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPfs` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetPfs"></a>

```typescript
public resetPfs()
```

##### `resetPhase1NegotiationMode` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetPhase1NegotiationMode"></a>

```typescript
public resetPhase1NegotiationMode()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `lifetime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.lifetime"></a>

```typescript
public readonly lifetime: VpnaasIkePolicyV2LifetimeList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasIkePolicyV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference)

---

##### `authAlgorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.authAlgorithmInput"></a>

```typescript
public readonly authAlgorithmInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `encryptionAlgorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.encryptionAlgorithmInput"></a>

```typescript
public readonly encryptionAlgorithmInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ikeVersionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.ikeVersionInput"></a>

```typescript
public readonly ikeVersionInput: string;
```

- *Type:* `string`

---

##### `lifetimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.lifetimeInput"></a>

```typescript
public readonly lifetimeInput: IResolvable | VpnaasIkePolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime)[]

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `pfsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.pfsInput"></a>

```typescript
public readonly pfsInput: string;
```

- *Type:* `string`

---

##### `phase1NegotiationModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.phase1NegotiationModeInput"></a>

```typescript
public readonly phase1NegotiationModeInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpnaasIkePolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `authAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.authAlgorithm"></a>

```typescript
public readonly authAlgorithm: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `encryptionAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.encryptionAlgorithm"></a>

```typescript
public readonly encryptionAlgorithm: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ikeVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.ikeVersion"></a>

```typescript
public readonly ikeVersion: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `pfs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.pfs"></a>

```typescript
public readonly pfs: string;
```

- *Type:* `string`

---

##### `phase1NegotiationMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.phase1NegotiationMode"></a>

```typescript
public readonly phase1NegotiationMode: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpnaasIpsecPolicyV2 <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2 opentelekomcloud_vpnaas_ipsec_policy_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2 } from '@cdktf/provider-opentelekomcloud'

new VpnaasIpsecPolicyV2(scope: Construct, id: string, config?: VpnaasIpsecPolicyV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config)

---

#### Methods <a name="Methods"></a>

##### `putLifetime` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.putLifetime"></a>

```typescript
public putLifetime(value: IResolvable | VpnaasIpsecPolicyV2Lifetime[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpnaasIpsecPolicyV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts)

---

##### `resetAuthAlgorithm` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetAuthAlgorithm"></a>

```typescript
public resetAuthAlgorithm()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEncapsulationMode` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetEncapsulationMode"></a>

```typescript
public resetEncapsulationMode()
```

##### `resetEncryptionAlgorithm` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetEncryptionAlgorithm"></a>

```typescript
public resetEncryptionAlgorithm()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetId"></a>

```typescript
public resetId()
```

##### `resetLifetime` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetLifetime"></a>

```typescript
public resetLifetime()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPfs` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetPfs"></a>

```typescript
public resetPfs()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTransformProtocol` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetTransformProtocol"></a>

```typescript
public resetTransformProtocol()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `lifetime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.lifetime"></a>

```typescript
public readonly lifetime: VpnaasIpsecPolicyV2LifetimeList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasIpsecPolicyV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference)

---

##### `authAlgorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.authAlgorithmInput"></a>

```typescript
public readonly authAlgorithmInput: string;
```

- *Type:* `string`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `encapsulationModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.encapsulationModeInput"></a>

```typescript
public readonly encapsulationModeInput: string;
```

- *Type:* `string`

---

##### `encryptionAlgorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.encryptionAlgorithmInput"></a>

```typescript
public readonly encryptionAlgorithmInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `lifetimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.lifetimeInput"></a>

```typescript
public readonly lifetimeInput: IResolvable | VpnaasIpsecPolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime)[]

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `pfsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.pfsInput"></a>

```typescript
public readonly pfsInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpnaasIpsecPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts)

---

##### `transformProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.transformProtocolInput"></a>

```typescript
public readonly transformProtocolInput: string;
```

- *Type:* `string`

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `authAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.authAlgorithm"></a>

```typescript
public readonly authAlgorithm: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `encapsulationMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.encapsulationMode"></a>

```typescript
public readonly encapsulationMode: string;
```

- *Type:* `string`

---

##### `encryptionAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.encryptionAlgorithm"></a>

```typescript
public readonly encryptionAlgorithm: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `pfs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.pfs"></a>

```typescript
public readonly pfs: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `transformProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.transformProtocol"></a>

```typescript
public readonly transformProtocol: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpnaasServiceV2 <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2 opentelekomcloud_vpnaas_service_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.Initializer"></a>

```typescript
import { VpnaasServiceV2 } from '@cdktf/provider-opentelekomcloud'

new VpnaasServiceV2(scope: Construct, id: string, config: VpnaasServiceV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpnaasServiceV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetName"></a>

```typescript
public resetName()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetSubnetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetSubnetId"></a>

```typescript
public resetSubnetId()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `externalV4Ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.externalV4Ip"></a>

```typescript
public readonly externalV4Ip: string;
```

- *Type:* `string`

---

##### `externalV6Ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.externalV6Ip"></a>

```typescript
public readonly externalV6Ip: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasServiceV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpnaasServiceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2.property.tfResourceType"></a>

- *Type:* `string`

---

### VpnaasSiteConnectionV2 <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2 opentelekomcloud_vpnaas_site_connection_v2}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2 } from '@cdktf/provider-opentelekomcloud'

new VpnaasSiteConnectionV2(scope: Construct, id: string, config: VpnaasSiteConnectionV2Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config)

---

#### Methods <a name="Methods"></a>

##### `putDpd` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.putDpd"></a>

```typescript
public putDpd(value: IResolvable | VpnaasSiteConnectionV2Dpd[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.putTimeouts"></a>

```typescript
public putTimeouts(value: VpnaasSiteConnectionV2Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts)

---

##### `resetAdminStateUp` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetAdminStateUp"></a>

```typescript
public resetAdminStateUp()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetDpd` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetDpd"></a>

```typescript
public resetDpd()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetId"></a>

```typescript
public resetId()
```

##### `resetInitiator` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetInitiator"></a>

```typescript
public resetInitiator()
```

##### `resetLocalEpGroupId` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetLocalEpGroupId"></a>

```typescript
public resetLocalEpGroupId()
```

##### `resetLocalId` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetLocalId"></a>

```typescript
public resetLocalId()
```

##### `resetMtu` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetMtu"></a>

```typescript
public resetMtu()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetName"></a>

```typescript
public resetName()
```

##### `resetPeerCidrs` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetPeerCidrs"></a>

```typescript
public resetPeerCidrs()
```

##### `resetPeerEpGroupId` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetPeerEpGroupId"></a>

```typescript
public resetPeerEpGroupId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTags` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetTags"></a>

```typescript
public resetTags()
```

##### `resetTenantId` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetTenantId"></a>

```typescript
public resetTenantId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetValueSpecs` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.resetValueSpecs"></a>

```typescript
public resetValueSpecs()
```


#### Properties <a name="Properties"></a>

##### `dpd`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.dpd"></a>

```typescript
public readonly dpd: VpnaasSiteConnectionV2DpdList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasSiteConnectionV2TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference)

---

##### `adminStateUpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.adminStateUpInput"></a>

```typescript
public readonly adminStateUpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `dpdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.dpdInput"></a>

```typescript
public readonly dpdInput: IResolvable | VpnaasSiteConnectionV2Dpd[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ikepolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.ikepolicyIdInput"></a>

```typescript
public readonly ikepolicyIdInput: string;
```

- *Type:* `string`

---

##### `initiatorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.initiatorInput"></a>

```typescript
public readonly initiatorInput: string;
```

- *Type:* `string`

---

##### `ipsecpolicyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.ipsecpolicyIdInput"></a>

```typescript
public readonly ipsecpolicyIdInput: string;
```

- *Type:* `string`

---

##### `localEpGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.localEpGroupIdInput"></a>

```typescript
public readonly localEpGroupIdInput: string;
```

- *Type:* `string`

---

##### `localIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.localIdInput"></a>

```typescript
public readonly localIdInput: string;
```

- *Type:* `string`

---

##### `mtuInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.mtuInput"></a>

```typescript
public readonly mtuInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `peerAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerAddressInput"></a>

```typescript
public readonly peerAddressInput: string;
```

- *Type:* `string`

---

##### `peerCidrsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerCidrsInput"></a>

```typescript
public readonly peerCidrsInput: string[];
```

- *Type:* `string`[]

---

##### `peerEpGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerEpGroupIdInput"></a>

```typescript
public readonly peerEpGroupIdInput: string;
```

- *Type:* `string`

---

##### `peerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerIdInput"></a>

```typescript
public readonly peerIdInput: string;
```

- *Type:* `string`

---

##### `pskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.pskInput"></a>

```typescript
public readonly pskInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `tagsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.tagsInput"></a>

```typescript
public readonly tagsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.tenantIdInput"></a>

```typescript
public readonly tenantIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpnaasSiteConnectionV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts)

---

##### `valueSpecsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.valueSpecsInput"></a>

```typescript
public readonly valueSpecsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpnserviceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.vpnserviceIdInput"></a>

```typescript
public readonly vpnserviceIdInput: string;
```

- *Type:* `string`

---

##### `adminStateUp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ikepolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.ikepolicyId"></a>

```typescript
public readonly ikepolicyId: string;
```

- *Type:* `string`

---

##### `initiator`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.initiator"></a>

```typescript
public readonly initiator: string;
```

- *Type:* `string`

---

##### `ipsecpolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.ipsecpolicyId"></a>

```typescript
public readonly ipsecpolicyId: string;
```

- *Type:* `string`

---

##### `localEpGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.localEpGroupId"></a>

```typescript
public readonly localEpGroupId: string;
```

- *Type:* `string`

---

##### `localId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.localId"></a>

```typescript
public readonly localId: string;
```

- *Type:* `string`

---

##### `mtu`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `peerAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerAddress"></a>

```typescript
public readonly peerAddress: string;
```

- *Type:* `string`

---

##### `peerCidrs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerCidrs"></a>

```typescript
public readonly peerCidrs: string[];
```

- *Type:* `string`[]

---

##### `peerEpGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerEpGroupId"></a>

```typescript
public readonly peerEpGroupId: string;
```

- *Type:* `string`

---

##### `peerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.peerId"></a>

```typescript
public readonly peerId: string;
```

- *Type:* `string`

---

##### `psk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.psk"></a>

```typescript
public readonly psk: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `tenantId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

---

##### `valueSpecs`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `vpnserviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.vpnserviceId"></a>

```typescript
public readonly vpnserviceId: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2.property.tfResourceType"></a>

- *Type:* `string`

---

### WafAlarmNotificationV1 <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1 opentelekomcloud_waf_alarm_notification_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.Initializer"></a>

```typescript
import { WafAlarmNotificationV1 } from '@cdktf/provider-opentelekomcloud'

new WafAlarmNotificationV1(scope: Construct, id: string, config: WafAlarmNotificationV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config`](#@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config)

---

#### Methods <a name="Methods"></a>

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.resetId"></a>

```typescript
public resetId()
```

##### `resetLocale` <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.resetLocale"></a>

```typescript
public resetLocale()
```


#### Properties <a name="Properties"></a>

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `localeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.localeInput"></a>

```typescript
public readonly localeInput: string;
```

- *Type:* `string`

---

##### `sendFrequencyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.sendFrequencyInput"></a>

```typescript
public readonly sendFrequencyInput: number;
```

- *Type:* `number`

---

##### `threatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.threatInput"></a>

```typescript
public readonly threatInput: string[];
```

- *Type:* `string`[]

---

##### `timesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.timesInput"></a>

```typescript
public readonly timesInput: number;
```

- *Type:* `number`

---

##### `topicUrnInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.topicUrnInput"></a>

```typescript
public readonly topicUrnInput: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `locale`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* `string`

---

##### `sendFrequency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.sendFrequency"></a>

```typescript
public readonly sendFrequency: number;
```

- *Type:* `number`

---

##### `threat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.threat"></a>

```typescript
public readonly threat: string[];
```

- *Type:* `string`[]

---

##### `times`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.times"></a>

```typescript
public readonly times: number;
```

- *Type:* `number`

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafCcattackprotectionRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1 opentelekomcloud_waf_ccattackprotection_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.Initializer"></a>

```typescript
import { WafCcattackprotectionRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafCcattackprotectionRuleV1(scope: Construct, id: string, config: WafCcattackprotectionRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafCcattackprotectionRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts)

---

##### `resetBlockContent` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetBlockContent"></a>

```typescript
public resetBlockContent()
```

##### `resetBlockContentType` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetBlockContentType"></a>

```typescript
public resetBlockContentType()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetLockTime` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetLockTime"></a>

```typescript
public resetLockTime()
```

##### `resetTagCategory` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetTagCategory"></a>

```typescript
public resetTagCategory()
```

##### `resetTagContents` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetTagContents"></a>

```typescript
public resetTagContents()
```

##### `resetTagIndex` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetTagIndex"></a>

```typescript
public resetTagIndex()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.default"></a>

```typescript
public readonly default: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafCcattackprotectionRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference)

---

##### `actionCategoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.actionCategoryInput"></a>

```typescript
public readonly actionCategoryInput: string;
```

- *Type:* `string`

---

##### `blockContentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.blockContentInput"></a>

```typescript
public readonly blockContentInput: string;
```

- *Type:* `string`

---

##### `blockContentTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.blockContentTypeInput"></a>

```typescript
public readonly blockContentTypeInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `limitNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.limitNumInput"></a>

```typescript
public readonly limitNumInput: number;
```

- *Type:* `number`

---

##### `limitPeriodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.limitPeriodInput"></a>

```typescript
public readonly limitPeriodInput: number;
```

- *Type:* `number`

---

##### `lockTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.lockTimeInput"></a>

```typescript
public readonly lockTimeInput: number;
```

- *Type:* `number`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `tagCategoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagCategoryInput"></a>

```typescript
public readonly tagCategoryInput: string;
```

- *Type:* `string`

---

##### `tagContentsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagContentsInput"></a>

```typescript
public readonly tagContentsInput: string[];
```

- *Type:* `string`[]

---

##### `tagIndexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagIndexInput"></a>

```typescript
public readonly tagIndexInput: string;
```

- *Type:* `string`

---

##### `tagTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagTypeInput"></a>

```typescript
public readonly tagTypeInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafCcattackprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts)

---

##### `urlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.urlInput"></a>

```typescript
public readonly urlInput: string;
```

- *Type:* `string`

---

##### `actionCategory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.actionCategory"></a>

```typescript
public readonly actionCategory: string;
```

- *Type:* `string`

---

##### `blockContent`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.blockContent"></a>

```typescript
public readonly blockContent: string;
```

- *Type:* `string`

---

##### `blockContentType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.blockContentType"></a>

```typescript
public readonly blockContentType: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `limitNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.limitNum"></a>

```typescript
public readonly limitNum: number;
```

- *Type:* `number`

---

##### `limitPeriod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.limitPeriod"></a>

```typescript
public readonly limitPeriod: number;
```

- *Type:* `number`

---

##### `lockTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.lockTime"></a>

```typescript
public readonly lockTime: number;
```

- *Type:* `number`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `tagCategory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagCategory"></a>

```typescript
public readonly tagCategory: string;
```

- *Type:* `string`

---

##### `tagContents`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagContents"></a>

```typescript
public readonly tagContents: string[];
```

- *Type:* `string`[]

---

##### `tagIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagIndex"></a>

```typescript
public readonly tagIndex: string;
```

- *Type:* `string`

---

##### `tagType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tagType"></a>

```typescript
public readonly tagType: string;
```

- *Type:* `string`

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafCertificateV1 <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1 opentelekomcloud_waf_certificate_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.Initializer"></a>

```typescript
import { WafCertificateV1 } from '@cdktf/provider-opentelekomcloud'

new WafCertificateV1(scope: Construct, id: string, config: WafCertificateV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCertificateV1Config`](#@cdktf/provider-opentelekomcloud.WafCertificateV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafCertificateV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.resetId"></a>

```typescript
public resetId()
```

##### `resetRegion` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.resetRegion"></a>

```typescript
public resetRegion()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `expires`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.expires"></a>

```typescript
public readonly expires: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafCertificateV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference)

---

##### `contentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.contentInput"></a>

```typescript
public readonly contentInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `regionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafCertificateV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts)

---

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `region`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafDatamaskingRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1 opentelekomcloud_waf_datamasking_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.Initializer"></a>

```typescript
import { WafDatamaskingRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafDatamaskingRuleV1(scope: Construct, id: string, config: WafDatamaskingRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafDatamaskingRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafDatamaskingRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference)

---

##### `categoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.categoryInput"></a>

```typescript
public readonly categoryInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `indexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.indexInput"></a>

```typescript
public readonly indexInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafDatamaskingRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts)

---

##### `urlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.urlInput"></a>

```typescript
public readonly urlInput: string;
```

- *Type:* `string`

---

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafDomainV1 <a name="@cdktf/provider-opentelekomcloud.WafDomainV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1 opentelekomcloud_waf_domain_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.Initializer"></a>

```typescript
import { WafDomainV1 } from '@cdktf/provider-opentelekomcloud'

new WafDomainV1(scope: Construct, id: string, config: WafDomainV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDomainV1Config`](#@cdktf/provider-opentelekomcloud.WafDomainV1Config)

---

#### Methods <a name="Methods"></a>

##### `putServer` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.putServer"></a>

```typescript
public putServer(value: IResolvable | WafDomainV1Server[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Server`](#@cdktf/provider-opentelekomcloud.WafDomainV1Server)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafDomainV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts)

---

##### `resetCertificateId` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetCertificateId"></a>

```typescript
public resetCertificateId()
```

##### `resetCipher` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetCipher"></a>

```typescript
public resetCipher()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPolicyId` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetPolicyId"></a>

```typescript
public resetPolicyId()
```

##### `resetSipHeaderList` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetSipHeaderList"></a>

```typescript
public resetSipHeaderList()
```

##### `resetSipHeaderName` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetSipHeaderName"></a>

```typescript
public resetSipHeaderName()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetTls` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.resetTls"></a>

```typescript
public resetTls()
```


#### Properties <a name="Properties"></a>

##### `accessCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.accessCode"></a>

```typescript
public readonly accessCode: string;
```

- *Type:* `string`

---

##### `accessStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.accessStatus"></a>

```typescript
public readonly accessStatus: number;
```

- *Type:* `number`

---

##### `cname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.cname"></a>

```typescript
public readonly cname: string;
```

- *Type:* `string`

---

##### `protectStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.protectStatus"></a>

```typescript
public readonly protectStatus: number;
```

- *Type:* `number`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `server`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.server"></a>

```typescript
public readonly server: WafDomainV1ServerList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDomainV1ServerList`](#@cdktf/provider-opentelekomcloud.WafDomainV1ServerList)

---

##### `subDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.subDomain"></a>

```typescript
public readonly subDomain: string;
```

- *Type:* `string`

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafDomainV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference)

---

##### `txtCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.txtCode"></a>

```typescript
public readonly txtCode: string;
```

- *Type:* `string`

---

##### `certificateIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.certificateIdInput"></a>

```typescript
public readonly certificateIdInput: string;
```

- *Type:* `string`

---

##### `cipherInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.cipherInput"></a>

```typescript
public readonly cipherInput: string;
```

- *Type:* `string`

---

##### `hostnameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.hostnameInput"></a>

```typescript
public readonly hostnameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `proxyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.proxyInput"></a>

```typescript
public readonly proxyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `serverInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.serverInput"></a>

```typescript
public readonly serverInput: IResolvable | WafDomainV1Server[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Server`](#@cdktf/provider-opentelekomcloud.WafDomainV1Server)[]

---

##### `sipHeaderListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.sipHeaderListInput"></a>

```typescript
public readonly sipHeaderListInput: string[];
```

- *Type:* `string`[]

---

##### `sipHeaderNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.sipHeaderNameInput"></a>

```typescript
public readonly sipHeaderNameInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafDomainV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts)

---

##### `tlsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.tlsInput"></a>

```typescript
public readonly tlsInput: string;
```

- *Type:* `string`

---

##### `certificateId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.certificateId"></a>

```typescript
public readonly certificateId: string;
```

- *Type:* `string`

---

##### `cipher`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.cipher"></a>

```typescript
public readonly cipher: string;
```

- *Type:* `string`

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `proxy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.proxy"></a>

```typescript
public readonly proxy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `sipHeaderList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.sipHeaderList"></a>

```typescript
public readonly sipHeaderList: string[];
```

- *Type:* `string`[]

---

##### `sipHeaderName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.sipHeaderName"></a>

```typescript
public readonly sipHeaderName: string;
```

- *Type:* `string`

---

##### `tls`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.tls"></a>

```typescript
public readonly tls: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafFalsealarmmaskingRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1 opentelekomcloud_waf_falsealarmmasking_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.Initializer"></a>

```typescript
import { WafFalsealarmmaskingRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafFalsealarmmaskingRuleV1(scope: Construct, id: string, config: WafFalsealarmmaskingRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafFalsealarmmaskingRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafFalsealarmmaskingRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference)

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `ruleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.ruleInput"></a>

```typescript
public readonly ruleInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafFalsealarmmaskingRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts)

---

##### `urlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.urlInput"></a>

```typescript
public readonly urlInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `rule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.rule"></a>

```typescript
public readonly rule: string;
```

- *Type:* `string`

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafPolicyV1 <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1 opentelekomcloud_waf_policy_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.Initializer"></a>

```typescript
import { WafPolicyV1 } from '@cdktf/provider-opentelekomcloud'

new WafPolicyV1(scope: Construct, id: string, config: WafPolicyV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Config`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Config)

---

#### Methods <a name="Methods"></a>

##### `putAction` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.putAction"></a>

```typescript
public putAction(value: WafPolicyV1Action)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Action`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Action)

---

##### `putOptions` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.putOptions"></a>

```typescript
public putOptions(value: WafPolicyV1Options)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Options`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Options)

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafPolicyV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts)

---

##### `resetAction` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetAction"></a>

```typescript
public resetAction()
```

##### `resetFullDetection` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetFullDetection"></a>

```typescript
public resetFullDetection()
```

##### `resetHosts` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetHosts"></a>

```typescript
public resetHosts()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetId"></a>

```typescript
public resetId()
```

##### `resetLevel` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetLevel"></a>

```typescript
public resetLevel()
```

##### `resetOptions` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetOptions"></a>

```typescript
public resetOptions()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.action"></a>

```typescript
public readonly action: WafPolicyV1ActionOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference`](#@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference)

---

##### `options`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.options"></a>

```typescript
public readonly options: WafPolicyV1OptionsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference`](#@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafPolicyV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference)

---

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.actionInput"></a>

```typescript
public readonly actionInput: WafPolicyV1Action;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Action`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Action)

---

##### `fullDetectionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.fullDetectionInput"></a>

```typescript
public readonly fullDetectionInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `hostsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.hostsInput"></a>

```typescript
public readonly hostsInput: string[];
```

- *Type:* `string`[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `levelInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.levelInput"></a>

```typescript
public readonly levelInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `optionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.optionsInput"></a>

```typescript
public readonly optionsInput: WafPolicyV1Options;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Options`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Options)

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafPolicyV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts)

---

##### `fullDetection`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.fullDetection"></a>

```typescript
public readonly fullDetection: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `hosts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `level`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.level"></a>

```typescript
public readonly level: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafPreciseprotectionRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1 opentelekomcloud_waf_preciseprotection_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafPreciseprotectionRuleV1(scope: Construct, id: string, config: WafPreciseprotectionRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putConditions` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.putConditions"></a>

```typescript
public putConditions(value: IResolvable | WafPreciseprotectionRuleV1Conditions[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions)[]

---

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafPreciseprotectionRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts)

---

##### `resetEnd` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetEnd"></a>

```typescript
public resetEnd()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetPriority` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetPriority"></a>

```typescript
public resetPriority()
```

##### `resetStart` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetStart"></a>

```typescript
public resetStart()
```

##### `resetTime` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetTime"></a>

```typescript
public resetTime()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `conditions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.conditions"></a>

```typescript
public readonly conditions: WafPreciseprotectionRuleV1ConditionsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList)

---

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafPreciseprotectionRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference)

---

##### `actionCategoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.actionCategoryInput"></a>

```typescript
public readonly actionCategoryInput: string;
```

- *Type:* `string`

---

##### `conditionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.conditionsInput"></a>

```typescript
public readonly conditionsInput: IResolvable | WafPreciseprotectionRuleV1Conditions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions)[]

---

##### `endInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.endInput"></a>

```typescript
public readonly endInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `priorityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* `number`

---

##### `startInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.startInput"></a>

```typescript
public readonly startInput: string;
```

- *Type:* `string`

---

##### `timeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.timeInput"></a>

```typescript
public readonly timeInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafPreciseprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts)

---

##### `actionCategory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.actionCategory"></a>

```typescript
public readonly actionCategory: string;
```

- *Type:* `string`

---

##### `end`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `priority`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

---

##### `start`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.start"></a>

```typescript
public readonly start: string;
```

- *Type:* `string`

---

##### `time`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.time"></a>

```typescript
public readonly time: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafWebtamperprotectionRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1 opentelekomcloud_waf_webtamperprotection_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.Initializer"></a>

```typescript
import { WafWebtamperprotectionRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafWebtamperprotectionRuleV1(scope: Construct, id: string, config: WafWebtamperprotectionRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafWebtamperprotectionRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafWebtamperprotectionRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference)

---

##### `hostnameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.hostnameInput"></a>

```typescript
public readonly hostnameInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafWebtamperprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts)

---

##### `urlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.urlInput"></a>

```typescript
public readonly urlInput: string;
```

- *Type:* `string`

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

### WafWhiteblackipRuleV1 <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1"></a>

Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1 opentelekomcloud_waf_whiteblackip_rule_v1}.

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.Initializer"></a>

```typescript
import { WafWhiteblackipRuleV1 } from '@cdktf/provider-opentelekomcloud'

new WafWhiteblackipRuleV1(scope: Construct, id: string, config: WafWhiteblackipRuleV1Config)
```

##### `scope`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.parameter.scope"></a>

- *Type:* [`constructs.Construct`](#constructs.Construct)

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.parameter.id"></a>

- *Type:* `string`

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.parameter.config"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config)

---

#### Methods <a name="Methods"></a>

##### `putTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.putTimeouts"></a>

```typescript
public putTimeouts(value: WafWhiteblackipRuleV1Timeouts)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts)

---

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.resetId"></a>

```typescript
public resetId()
```

##### `resetTimeouts` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.resetTimeouts"></a>

```typescript
public resetTimeouts()
```

##### `resetWhite` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.resetWhite"></a>

```typescript
public resetWhite()
```


#### Properties <a name="Properties"></a>

##### `timeouts`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.timeouts"></a>

```typescript
public readonly timeouts: WafWhiteblackipRuleV1TimeoutsOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference)

---

##### `addrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.addrInput"></a>

```typescript
public readonly addrInput: string;
```

- *Type:* `string`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `policyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.policyIdInput"></a>

```typescript
public readonly policyIdInput: string;
```

- *Type:* `string`

---

##### `timeoutsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | WafWhiteblackipRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts)

---

##### `whiteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.whiteInput"></a>

```typescript
public readonly whiteInput: number;
```

- *Type:* `number`

---

##### `addr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.addr"></a>

```typescript
public readonly addr: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

---

##### `white`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.white"></a>

```typescript
public readonly white: number;
```

- *Type:* `number`

---

#### Constants <a name="Constants"></a>

##### `tfResourceType` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1.property.tfResourceType"></a>

- *Type:* `string`

---

## Structs <a name="Structs"></a>

### AntiddosV1Config <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AntiddosV1Config } from '@cdktf/provider-opentelekomcloud'

const antiddosV1Config: AntiddosV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `appTypeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.appTypeId"></a>

```typescript
public readonly appTypeId: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#app_type_id AntiddosV1#app_type_id}.

---

##### `cleaningAccessPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.cleaningAccessPosId"></a>

```typescript
public readonly cleaningAccessPosId: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#cleaning_access_pos_id AntiddosV1#cleaning_access_pos_id}.

---

##### `enableL7`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.enableL7"></a>

```typescript
public readonly enableL7: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#enable_l7 AntiddosV1#enable_l7}.

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#floating_ip_id AntiddosV1#floating_ip_id}.

---

##### `httpRequestPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.httpRequestPosId"></a>

```typescript
public readonly httpRequestPosId: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#http_request_pos_id AntiddosV1#http_request_pos_id}.

---

##### `trafficPosId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.trafficPosId"></a>

```typescript
public readonly trafficPosId: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#traffic_pos_id AntiddosV1#traffic_pos_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#id AntiddosV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#region AntiddosV1#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: AntiddosV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts`](#@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#timeouts AntiddosV1#timeouts}

---

### AntiddosV1Timeouts <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AntiddosV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const antiddosV1Timeouts: AntiddosV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#create AntiddosV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#delete AntiddosV1#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/antiddos_v1#update AntiddosV1#update}.

---

### AsConfigurationV1Config <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1Config } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1Config: AsConfigurationV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `instanceConfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.instanceConfig"></a>

```typescript
public readonly instanceConfig: AsConfigurationV1InstanceConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig)

instance_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#instance_config AsConfigurationV1#instance_config}

---

##### `scalingConfigurationName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.scalingConfigurationName"></a>

```typescript
public readonly scalingConfigurationName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#scaling_configuration_name AsConfigurationV1#scaling_configuration_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#id AsConfigurationV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#region AsConfigurationV1#region}.

---

### AsConfigurationV1InstanceConfig <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfig } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfig: AsConfigurationV1InstanceConfig = { ... }
```

##### `keyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#key_name AsConfigurationV1#key_name}.

---

##### `disk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.disk"></a>

```typescript
public readonly disk: IResolvable | AsConfigurationV1InstanceConfigDisk[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk)[]

disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#disk AsConfigurationV1#disk}

---

##### `flavor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#flavor AsConfigurationV1#flavor}.

---

##### `image`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#image AsConfigurationV1#image}.

---

##### `instanceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#instance_id AsConfigurationV1#instance_id}.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#metadata AsConfigurationV1#metadata}.

---

##### `personality`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.personality"></a>

```typescript
public readonly personality: IResolvable | AsConfigurationV1InstanceConfigPersonality[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality)[]

personality block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#personality AsConfigurationV1#personality}

---

##### `publicIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.publicIp"></a>

```typescript
public readonly publicIp: AsConfigurationV1InstanceConfigPublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp)

public_ip block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#public_ip AsConfigurationV1#public_ip}

---

##### `securityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#security_groups AsConfigurationV1#security_groups}.

---

##### `userData`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#user_data AsConfigurationV1#user_data}.

---

### AsConfigurationV1InstanceConfigDisk <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigDisk } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfigDisk: AsConfigurationV1InstanceConfigDisk = { ... }
```

##### `diskType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk.property.diskType"></a>

```typescript
public readonly diskType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#disk_type AsConfigurationV1#disk_type}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#size AsConfigurationV1#size}.

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#volume_type AsConfigurationV1#volume_type}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#kms_id AsConfigurationV1#kms_id}.

---

### AsConfigurationV1InstanceConfigPersonality <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPersonality } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfigPersonality: AsConfigurationV1InstanceConfigPersonality = { ... }
```

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#content AsConfigurationV1#content}.

---

##### `path`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#path AsConfigurationV1#path}.

---

### AsConfigurationV1InstanceConfigPublicIp <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIp } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfigPublicIp: AsConfigurationV1InstanceConfigPublicIp = { ... }
```

##### `eip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp.property.eip"></a>

```typescript
public readonly eip: AsConfigurationV1InstanceConfigPublicIpEip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip)

eip block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#eip AsConfigurationV1#eip}

---

### AsConfigurationV1InstanceConfigPublicIpEip <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIpEip } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfigPublicIpEip: AsConfigurationV1InstanceConfigPublicIpEip = { ... }
```

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip.property.bandwidth"></a>

```typescript
public readonly bandwidth: AsConfigurationV1InstanceConfigPublicIpEipBandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth)

bandwidth block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#bandwidth AsConfigurationV1#bandwidth}

---

##### `ipType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#ip_type AsConfigurationV1#ip_type}.

---

### AsConfigurationV1InstanceConfigPublicIpEipBandwidth <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIpEipBandwidth } from '@cdktf/provider-opentelekomcloud'

const asConfigurationV1InstanceConfigPublicIpEipBandwidth: AsConfigurationV1InstanceConfigPublicIpEipBandwidth = { ... }
```

##### `chargingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth.property.chargingMode"></a>

```typescript
public readonly chargingMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#charging_mode AsConfigurationV1#charging_mode}.

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#share_type AsConfigurationV1#share_type}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_configuration_v1#size AsConfigurationV1#size}.

---

### AsGroupV1Config <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsGroupV1Config } from '@cdktf/provider-opentelekomcloud'

const asGroupV1Config: AsGroupV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `networks`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.networks"></a>

```typescript
public readonly networks: IResolvable | AsGroupV1Networks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Networks`](#@cdktf/provider-opentelekomcloud.AsGroupV1Networks)[]

networks block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#networks AsGroupV1#networks}

---

##### `scalingGroupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.scalingGroupName"></a>

```typescript
public readonly scalingGroupName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#scaling_group_name AsGroupV1#scaling_group_name}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#vpc_id AsGroupV1#vpc_id}.

---

##### `availableZones`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#available_zones AsGroupV1#available_zones}.

---

##### `coolDownTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

The cooling duration, in seconds.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#cool_down_time AsGroupV1#cool_down_time}

---

##### `deleteInstances`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.deleteInstances"></a>

```typescript
public readonly deleteInstances: string;
```

- *Type:* `string`

Whether to delete instances when they are removed from the AS group.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#delete_instances AsGroupV1#delete_instances}

---

##### `deletePublicip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.deletePublicip"></a>

```typescript
public readonly deletePublicip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#delete_publicip AsGroupV1#delete_publicip}.

---

##### `desireInstanceNumber`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.desireInstanceNumber"></a>

```typescript
public readonly desireInstanceNumber: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#desire_instance_number AsGroupV1#desire_instance_number}.

---

##### `healthPeriodicAuditGracePeriod`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.healthPeriodicAuditGracePeriod"></a>

```typescript
public readonly healthPeriodicAuditGracePeriod: number;
```

- *Type:* `number`

The grace period for instance health check, in seconds.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#health_periodic_audit_grace_period AsGroupV1#health_periodic_audit_grace_period}

---

##### `healthPeriodicAuditMethod`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.healthPeriodicAuditMethod"></a>

```typescript
public readonly healthPeriodicAuditMethod: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#health_periodic_audit_method AsGroupV1#health_periodic_audit_method}.

---

##### `healthPeriodicAuditTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.healthPeriodicAuditTime"></a>

```typescript
public readonly healthPeriodicAuditTime: number;
```

- *Type:* `number`

The health check period for instances, in minutes.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#health_periodic_audit_time AsGroupV1#health_periodic_audit_time}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#id AsGroupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `instanceTerminatePolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.instanceTerminatePolicy"></a>

```typescript
public readonly instanceTerminatePolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#instance_terminate_policy AsGroupV1#instance_terminate_policy}.

---

##### `lbaasListeners`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.lbaasListeners"></a>

```typescript
public readonly lbaasListeners: IResolvable | AsGroupV1LbaasListeners[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners)[]

lbaas_listeners block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#lbaas_listeners AsGroupV1#lbaas_listeners}

---

##### `lbListenerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.lbListenerId"></a>

```typescript
public readonly lbListenerId: string;
```

- *Type:* `string`

The system supports the binding of up to six classic LB listeners, the IDs of which are separated using a comma.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#lb_listener_id AsGroupV1#lb_listener_id}

---

##### `maxInstanceNumber`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.maxInstanceNumber"></a>

```typescript
public readonly maxInstanceNumber: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#max_instance_number AsGroupV1#max_instance_number}.

---

##### `minInstanceNumber`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.minInstanceNumber"></a>

```typescript
public readonly minInstanceNumber: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#min_instance_number AsGroupV1#min_instance_number}.

---

##### `notifications`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.notifications"></a>

```typescript
public readonly notifications: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#notifications AsGroupV1#notifications}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#region AsGroupV1#region}.

---

##### `scalingConfigurationId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.scalingConfigurationId"></a>

```typescript
public readonly scalingConfigurationId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#scaling_configuration_id AsGroupV1#scaling_configuration_id}.

---

##### `securityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.securityGroups"></a>

```typescript
public readonly securityGroups: AsGroupV1SecurityGroups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups`](#@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups)

security_groups block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#security_groups AsGroupV1#security_groups}

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#tags AsGroupV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: AsGroupV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#timeouts AsGroupV1#timeouts}

---

### AsGroupV1LbaasListeners <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsGroupV1LbaasListeners } from '@cdktf/provider-opentelekomcloud'

const asGroupV1LbaasListeners: AsGroupV1LbaasListeners = { ... }
```

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#pool_id AsGroupV1#pool_id}.

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#protocol_port AsGroupV1#protocol_port}.

---

##### `weight`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#weight AsGroupV1#weight}.

---

### AsGroupV1Networks <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Networks"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsGroupV1Networks } from '@cdktf/provider-opentelekomcloud'

const asGroupV1Networks: AsGroupV1Networks = { ... }
```

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Networks.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#id AsGroupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### AsGroupV1SecurityGroups <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsGroupV1SecurityGroups } from '@cdktf/provider-opentelekomcloud'

const asGroupV1SecurityGroups: AsGroupV1SecurityGroups = { ... }
```

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#id AsGroupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### AsGroupV1Timeouts <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsGroupV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const asGroupV1Timeouts: AsGroupV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#create AsGroupV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_group_v1#delete AsGroupV1#delete}.

---

### AsPolicyV1Config <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV1Config } from '@cdktf/provider-opentelekomcloud'

const asPolicyV1Config: AsPolicyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `scalingGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.scalingGroupId"></a>

```typescript
public readonly scalingGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#scaling_group_id AsPolicyV1#scaling_group_id}.

---

##### `scalingPolicyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.scalingPolicyName"></a>

```typescript
public readonly scalingPolicyName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#scaling_policy_name AsPolicyV1#scaling_policy_name}.

---

##### `scalingPolicyType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.scalingPolicyType"></a>

```typescript
public readonly scalingPolicyType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#scaling_policy_type AsPolicyV1#scaling_policy_type}.

---

##### `alarmId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.alarmId"></a>

```typescript
public readonly alarmId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#alarm_id AsPolicyV1#alarm_id}.

---

##### `coolDownTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#cool_down_time AsPolicyV1#cool_down_time}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#id AsPolicyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#region AsPolicyV1#region}.

---

##### `scalingPolicyAction`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.scalingPolicyAction"></a>

```typescript
public readonly scalingPolicyAction: AsPolicyV1ScalingPolicyAction;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction)

scaling_policy_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#scaling_policy_action AsPolicyV1#scaling_policy_action}

---

##### `scheduledPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1Config.property.scheduledPolicy"></a>

```typescript
public readonly scheduledPolicy: AsPolicyV1ScheduledPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy)

scheduled_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#scheduled_policy AsPolicyV1#scheduled_policy}

---

### AsPolicyV1ScalingPolicyAction <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV1ScalingPolicyAction } from '@cdktf/provider-opentelekomcloud'

const asPolicyV1ScalingPolicyAction: AsPolicyV1ScalingPolicyAction = { ... }
```

##### `instanceNumber`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction.property.instanceNumber"></a>

```typescript
public readonly instanceNumber: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#instance_number AsPolicyV1#instance_number}.

---

##### `operation`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#operation AsPolicyV1#operation}.

---

### AsPolicyV1ScheduledPolicy <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV1ScheduledPolicy } from '@cdktf/provider-opentelekomcloud'

const asPolicyV1ScheduledPolicy: AsPolicyV1ScheduledPolicy = { ... }
```

##### `launchTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy.property.launchTime"></a>

```typescript
public readonly launchTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#launch_time AsPolicyV1#launch_time}.

---

##### `endTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy.property.endTime"></a>

```typescript
public readonly endTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#end_time AsPolicyV1#end_time}.

---

##### `recurrenceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy.property.recurrenceType"></a>

```typescript
public readonly recurrenceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#recurrence_type AsPolicyV1#recurrence_type}.

---

##### `recurrenceValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy.property.recurrenceValue"></a>

```typescript
public readonly recurrenceValue: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#recurrence_value AsPolicyV1#recurrence_value}.

---

##### `startTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v1#start_time AsPolicyV1#start_time}.

---

### AsPolicyV2Config <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const asPolicyV2Config: AsPolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `scalingPolicyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scalingPolicyName"></a>

```typescript
public readonly scalingPolicyName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scaling_policy_name AsPolicyV2#scaling_policy_name}.

---

##### `scalingPolicyType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scalingPolicyType"></a>

```typescript
public readonly scalingPolicyType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scaling_policy_type AsPolicyV2#scaling_policy_type}.

---

##### `scalingResourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scalingResourceId"></a>

```typescript
public readonly scalingResourceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scaling_resource_id AsPolicyV2#scaling_resource_id}.

---

##### `scalingResourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scalingResourceType"></a>

```typescript
public readonly scalingResourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scaling_resource_type AsPolicyV2#scaling_resource_type}.

---

##### `alarmId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.alarmId"></a>

```typescript
public readonly alarmId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#alarm_id AsPolicyV2#alarm_id}.

---

##### `coolDownTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.coolDownTime"></a>

```typescript
public readonly coolDownTime: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#cool_down_time AsPolicyV2#cool_down_time}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#id AsPolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#region AsPolicyV2#region}.

---

##### `scalingPolicyAction`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scalingPolicyAction"></a>

```typescript
public readonly scalingPolicyAction: IResolvable | AsPolicyV2ScalingPolicyAction[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction)[]

scaling_policy_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scaling_policy_action AsPolicyV2#scaling_policy_action}

---

##### `scheduledPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Config.property.scheduledPolicy"></a>

```typescript
public readonly scheduledPolicy: IResolvable | AsPolicyV2ScheduledPolicy[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy)[]

scheduled_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#scheduled_policy AsPolicyV2#scheduled_policy}

---

### AsPolicyV2Metadata <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2Metadata"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV2Metadata } from '@cdktf/provider-opentelekomcloud'

const asPolicyV2Metadata: AsPolicyV2Metadata = { ... }
```

### AsPolicyV2ScalingPolicyAction <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV2ScalingPolicyAction } from '@cdktf/provider-opentelekomcloud'

const asPolicyV2ScalingPolicyAction: AsPolicyV2ScalingPolicyAction = { ... }
```

##### `limits`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction.property.limits"></a>

```typescript
public readonly limits: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#limits AsPolicyV2#limits}.

---

##### `operation`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#operation AsPolicyV2#operation}.

---

##### `percentage`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction.property.percentage"></a>

```typescript
public readonly percentage: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#percentage AsPolicyV2#percentage}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#size AsPolicyV2#size}.

---

### AsPolicyV2ScheduledPolicy <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AsPolicyV2ScheduledPolicy } from '@cdktf/provider-opentelekomcloud'

const asPolicyV2ScheduledPolicy: AsPolicyV2ScheduledPolicy = { ... }
```

##### `launchTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy.property.launchTime"></a>

```typescript
public readonly launchTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#launch_time AsPolicyV2#launch_time}.

---

##### `endTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy.property.endTime"></a>

```typescript
public readonly endTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#end_time AsPolicyV2#end_time}.

---

##### `recurrenceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy.property.recurrenceType"></a>

```typescript
public readonly recurrenceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#recurrence_type AsPolicyV2#recurrence_type}.

---

##### `recurrenceValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy.property.recurrenceValue"></a>

```typescript
public readonly recurrenceValue: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#recurrence_value AsPolicyV2#recurrence_value}.

---

##### `startTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/as_policy_v2#start_time AsPolicyV2#start_time}.

---

### BlockstorageVolumeV2Attachment <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Attachment"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { BlockstorageVolumeV2Attachment } from '@cdktf/provider-opentelekomcloud'

const blockstorageVolumeV2Attachment: BlockstorageVolumeV2Attachment = { ... }
```

### BlockstorageVolumeV2Config <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { BlockstorageVolumeV2Config } from '@cdktf/provider-opentelekomcloud'

const blockstorageVolumeV2Config: BlockstorageVolumeV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#size BlockstorageVolumeV2#size}.

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#availability_zone BlockstorageVolumeV2#availability_zone}.

---

##### `cascade`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.cascade"></a>

```typescript
public readonly cascade: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#cascade BlockstorageVolumeV2#cascade}.

---

##### `consistencyGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.consistencyGroupId"></a>

```typescript
public readonly consistencyGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#consistency_group_id BlockstorageVolumeV2#consistency_group_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#description BlockstorageVolumeV2#description}.

---

##### `deviceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.deviceType"></a>

```typescript
public readonly deviceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#device_type BlockstorageVolumeV2#device_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#id BlockstorageVolumeV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#image_id BlockstorageVolumeV2#image_id}.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#metadata BlockstorageVolumeV2#metadata}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#name BlockstorageVolumeV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#region BlockstorageVolumeV2#region}.

---

##### `snapshotId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#snapshot_id BlockstorageVolumeV2#snapshot_id}.

---

##### `sourceReplica`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.sourceReplica"></a>

```typescript
public readonly sourceReplica: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#source_replica BlockstorageVolumeV2#source_replica}.

---

##### `sourceVolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.sourceVolId"></a>

```typescript
public readonly sourceVolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#source_vol_id BlockstorageVolumeV2#source_vol_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#tags BlockstorageVolumeV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: BlockstorageVolumeV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#timeouts BlockstorageVolumeV2#timeouts}

---

##### `volumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Config.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#volume_type BlockstorageVolumeV2#volume_type}.

---

### BlockstorageVolumeV2Timeouts <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { BlockstorageVolumeV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const blockstorageVolumeV2Timeouts: BlockstorageVolumeV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#create BlockstorageVolumeV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#delete BlockstorageVolumeV2#delete}.

---

### CbrPolicyV3Config <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrPolicyV3Config } from '@cdktf/provider-opentelekomcloud'

const cbrPolicyV3Config: CbrPolicyV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#name CbrPolicyV3#name}.

---

##### `operationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.operationType"></a>

```typescript
public readonly operationType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#operation_type CbrPolicyV3#operation_type}.

---

##### `triggerPattern`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.triggerPattern"></a>

```typescript
public readonly triggerPattern: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#trigger_pattern CbrPolicyV3#trigger_pattern}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#enabled CbrPolicyV3#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#id CbrPolicyV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `operationDefinition`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3Config.property.operationDefinition"></a>

```typescript
public readonly operationDefinition: CbrPolicyV3OperationDefinition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition)

operation_definition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#operation_definition CbrPolicyV3#operation_definition}

---

### CbrPolicyV3OperationDefinition <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrPolicyV3OperationDefinition } from '@cdktf/provider-opentelekomcloud'

const cbrPolicyV3OperationDefinition: CbrPolicyV3OperationDefinition = { ... }
```

##### `timezone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#timezone CbrPolicyV3#timezone}.

---

##### `dayBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.dayBackups"></a>

```typescript
public readonly dayBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#day_backups CbrPolicyV3#day_backups}.

---

##### `maxBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.maxBackups"></a>

```typescript
public readonly maxBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#max_backups CbrPolicyV3#max_backups}.

---

##### `monthBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.monthBackups"></a>

```typescript
public readonly monthBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#month_backups CbrPolicyV3#month_backups}.

---

##### `retentionDurationDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.retentionDurationDays"></a>

```typescript
public readonly retentionDurationDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#retention_duration_days CbrPolicyV3#retention_duration_days}.

---

##### `weekBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.weekBackups"></a>

```typescript
public readonly weekBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#week_backups CbrPolicyV3#week_backups}.

---

##### `yearBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition.property.yearBackups"></a>

```typescript
public readonly yearBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_policy_v3#year_backups CbrPolicyV3#year_backups}.

---

### CbrVaultV3Billing <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrVaultV3Billing } from '@cdktf/provider-opentelekomcloud'

const cbrVaultV3Billing: CbrVaultV3Billing = { ... }
```

##### `objectType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.objectType"></a>

```typescript
public readonly objectType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#object_type CbrVaultV3#object_type}.

---

##### `protectType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.protectType"></a>

```typescript
public readonly protectType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#protect_type CbrVaultV3#protect_type}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#size CbrVaultV3#size}.

---

##### `chargingMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.chargingMode"></a>

```typescript
public readonly chargingMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#charging_mode CbrVaultV3#charging_mode}.

---

##### `cloudType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.cloudType"></a>

```typescript
public readonly cloudType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#cloud_type CbrVaultV3#cloud_type}.

---

##### `consistentLevel`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.consistentLevel"></a>

```typescript
public readonly consistentLevel: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#consistent_level CbrVaultV3#consistent_level}.

---

##### `consoleUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.consoleUrl"></a>

```typescript
public readonly consoleUrl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#console_url CbrVaultV3#console_url}.

---

##### `extraInfo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.extraInfo"></a>

```typescript
public readonly extraInfo: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#extra_info CbrVaultV3#extra_info}.

---

##### `isAutoPay`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.isAutoPay"></a>

```typescript
public readonly isAutoPay: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#is_auto_pay CbrVaultV3#is_auto_pay}.

---

##### `isAutoRenew`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.isAutoRenew"></a>

```typescript
public readonly isAutoRenew: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#is_auto_renew CbrVaultV3#is_auto_renew}.

---

##### `periodNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.periodNum"></a>

```typescript
public readonly periodNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#period_num CbrVaultV3#period_num}.

---

##### `periodType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Billing.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#period_type CbrVaultV3#period_type}.

---

### CbrVaultV3BindRules <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrVaultV3BindRules } from '@cdktf/provider-opentelekomcloud'

const cbrVaultV3BindRules: CbrVaultV3BindRules = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#key CbrVaultV3#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#value CbrVaultV3#value}.

---

### CbrVaultV3Config <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrVaultV3Config } from '@cdktf/provider-opentelekomcloud'

const cbrVaultV3Config: CbrVaultV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `billing`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.billing"></a>

```typescript
public readonly billing: CbrVaultV3Billing;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3Billing`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Billing)

billing block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#billing CbrVaultV3#billing}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#name CbrVaultV3#name}.

---

##### `autoBind`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.autoBind"></a>

```typescript
public readonly autoBind: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#auto_bind CbrVaultV3#auto_bind}.

---

##### `autoExpand`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.autoExpand"></a>

```typescript
public readonly autoExpand: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#auto_expand CbrVaultV3#auto_expand}.

---

##### `backupPolicyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.backupPolicyId"></a>

```typescript
public readonly backupPolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#backup_policy_id CbrVaultV3#backup_policy_id}.

---

##### `bindRules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.bindRules"></a>

```typescript
public readonly bindRules: IResolvable | CbrVaultV3BindRules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules)[]

bind_rules block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#bind_rules CbrVaultV3#bind_rules}

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#description CbrVaultV3#description}.

---

##### `enterpriseProjectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.enterpriseProjectId"></a>

```typescript
public readonly enterpriseProjectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#enterprise_project_id CbrVaultV3#enterprise_project_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#id CbrVaultV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `resource`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.resource"></a>

```typescript
public readonly resource: IResolvable | CbrVaultV3Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3Resource`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Resource)[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#resource CbrVaultV3#resource}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#tags CbrVaultV3#tags}.

---

### CbrVaultV3Resource <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CbrVaultV3Resource } from '@cdktf/provider-opentelekomcloud'

const cbrVaultV3Resource: CbrVaultV3Resource = { ... }
```

##### `backupCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.backupCount"></a>

```typescript
public readonly backupCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#backup_count CbrVaultV3#backup_count}.

---

##### `backupSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.backupSize"></a>

```typescript
public readonly backupSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#backup_size CbrVaultV3#backup_size}.

---

##### `extraInfo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.extraInfo"></a>

```typescript
public readonly extraInfo: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#extra_info CbrVaultV3#extra_info}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#id CbrVaultV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#name CbrVaultV3#name}.

---

##### `protectStatus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.protectStatus"></a>

```typescript
public readonly protectStatus: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#protect_status CbrVaultV3#protect_status}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#size CbrVaultV3#size}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3Resource.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cbr_vault_v3#type CbrVaultV3#type}.

---

### CceAddonV3Config <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceAddonV3Config } from '@cdktf/provider-opentelekomcloud'

const cceAddonV3Config: CceAddonV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#cluster_id CceAddonV3#cluster_id}.

---

##### `templateName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.templateName"></a>

```typescript
public readonly templateName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#template_name CceAddonV3#template_name}.

---

##### `templateVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.templateVersion"></a>

```typescript
public readonly templateVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#template_version CceAddonV3#template_version}.

---

##### `values`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.values"></a>

```typescript
public readonly values: CceAddonV3Values;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Values`](#@cdktf/provider-opentelekomcloud.CceAddonV3Values)

values block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#values CceAddonV3#values}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#id CceAddonV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: CceAddonV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#timeouts CceAddonV3#timeouts}

---

### CceAddonV3Timeouts <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceAddonV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const cceAddonV3Timeouts: CceAddonV3Timeouts = { ... }
```

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#delete CceAddonV3#delete}.

---

### CceAddonV3Values <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Values"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceAddonV3Values } from '@cdktf/provider-opentelekomcloud'

const cceAddonV3Values: CceAddonV3Values = { ... }
```

##### `basic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Values.property.basic"></a>

```typescript
public readonly basic: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#basic CceAddonV3#basic}.

---

##### `custom`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3Values.property.custom"></a>

```typescript
public readonly custom: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_addon_v3#custom CceAddonV3#custom}.

---

### CceClusterV3AuthenticatingProxy <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceClusterV3AuthenticatingProxy } from '@cdktf/provider-opentelekomcloud'

const cceClusterV3AuthenticatingProxy: CceClusterV3AuthenticatingProxy = { ... }
```

##### `ca`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy.property.ca"></a>

```typescript
public readonly ca: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#ca CceClusterV3#ca}.

---

##### `cert`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy.property.cert"></a>

```typescript
public readonly cert: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#cert CceClusterV3#cert}.

---

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#private_key CceClusterV3#private_key}.

---

### CceClusterV3CertificateClusters <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClusters"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceClusterV3CertificateClusters } from '@cdktf/provider-opentelekomcloud'

const cceClusterV3CertificateClusters: CceClusterV3CertificateClusters = { ... }
```

### CceClusterV3CertificateUsers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsers"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceClusterV3CertificateUsers } from '@cdktf/provider-opentelekomcloud'

const cceClusterV3CertificateUsers: CceClusterV3CertificateUsers = { ... }
```

### CceClusterV3Config <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceClusterV3Config } from '@cdktf/provider-opentelekomcloud'

const cceClusterV3Config: CceClusterV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.clusterType"></a>

```typescript
public readonly clusterType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#cluster_type CceClusterV3#cluster_type}.

---

##### `containerNetworkType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.containerNetworkType"></a>

```typescript
public readonly containerNetworkType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#container_network_type CceClusterV3#container_network_type}.

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#flavor_id CceClusterV3#flavor_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#name CceClusterV3#name}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#subnet_id CceClusterV3#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#vpc_id CceClusterV3#vpc_id}.

---

##### `annotations`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#annotations CceClusterV3#annotations}.

---

##### `authenticatingProxy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.authenticatingProxy"></a>

```typescript
public readonly authenticatingProxy: CceClusterV3AuthenticatingProxy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy`](#@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy)

authenticating_proxy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#authenticating_proxy CceClusterV3#authenticating_proxy}

---

##### `authenticatingProxyCa`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.authenticatingProxyCa"></a>

```typescript
public readonly authenticatingProxyCa: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#authenticating_proxy_ca CceClusterV3#authenticating_proxy_ca}.

---

##### `authenticationMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.authenticationMode"></a>

```typescript
public readonly authenticationMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#authentication_mode CceClusterV3#authentication_mode}.

---

##### `billingMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#billing_mode CceClusterV3#billing_mode}.

---

##### `clusterVersion`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.clusterVersion"></a>

```typescript
public readonly clusterVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#cluster_version CceClusterV3#cluster_version}.

---

##### `containerNetworkCidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.containerNetworkCidr"></a>

```typescript
public readonly containerNetworkCidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#container_network_cidr CceClusterV3#container_network_cidr}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#description CceClusterV3#description}.

---

##### `eip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.eip"></a>

```typescript
public readonly eip: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#eip CceClusterV3#eip}.

---

##### `eniSubnetCidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.eniSubnetCidr"></a>

```typescript
public readonly eniSubnetCidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#eni_subnet_cidr CceClusterV3#eni_subnet_cidr}.

---

##### `eniSubnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.eniSubnetId"></a>

```typescript
public readonly eniSubnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#eni_subnet_id CceClusterV3#eni_subnet_id}.

---

##### `extendParam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.extendParam"></a>

```typescript
public readonly extendParam: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#extend_param CceClusterV3#extend_param}.

---

##### `highwaySubnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.highwaySubnetId"></a>

```typescript
public readonly highwaySubnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#highway_subnet_id CceClusterV3#highway_subnet_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#id CceClusterV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ignoreAddons`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.ignoreAddons"></a>

```typescript
public readonly ignoreAddons: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#ignore_addons CceClusterV3#ignore_addons}.

---

##### `kubernetesSvcIpRange`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.kubernetesSvcIpRange"></a>

```typescript
public readonly kubernetesSvcIpRange: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#kubernetes_svc_ip_range CceClusterV3#kubernetes_svc_ip_range}.

---

##### `labels`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#labels CceClusterV3#labels}.

---

##### `multiAz`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.multiAz"></a>

```typescript
public readonly multiAz: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#multi_az CceClusterV3#multi_az}.

---

##### `noAddons`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.noAddons"></a>

```typescript
public readonly noAddons: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#no_addons CceClusterV3#no_addons}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#region CceClusterV3#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: CceClusterV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#timeouts CceClusterV3#timeouts}

---

### CceClusterV3Timeouts <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceClusterV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const cceClusterV3Timeouts: CceClusterV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#create CceClusterV3#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_cluster_v3#delete CceClusterV3#delete}.

---

### CceNodePoolV3Config <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodePoolV3Config } from '@cdktf/provider-opentelekomcloud'

const cceNodePoolV3Config: CceNodePoolV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#cluster_id CceNodePoolV3#cluster_id}.

---

##### `dataVolumes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.dataVolumes"></a>

```typescript
public readonly dataVolumes: IResolvable | CceNodePoolV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes)[]

data_volumes block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#data_volumes CceNodePoolV3#data_volumes}

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#flavor CceNodePoolV3#flavor}.

---

##### `initialNodeCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.initialNodeCount"></a>

```typescript
public readonly initialNodeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#initial_node_count CceNodePoolV3#initial_node_count}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#name CceNodePoolV3#name}.

---

##### `rootVolume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.rootVolume"></a>

```typescript
public readonly rootVolume: CceNodePoolV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume)

root_volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#root_volume CceNodePoolV3#root_volume}

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#availability_zone CceNodePoolV3#availability_zone}.

---

##### `dockerBaseSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.dockerBaseSize"></a>

```typescript
public readonly dockerBaseSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#docker_base_size CceNodePoolV3#docker_base_size}.

---

##### `dockerLvmConfigOverride`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.dockerLvmConfigOverride"></a>

```typescript
public readonly dockerLvmConfigOverride: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#docker_lvm_config_override CceNodePoolV3#docker_lvm_config_override}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#id CceNodePoolV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `k8STags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.k8STags"></a>

```typescript
public readonly k8STags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#k8s_tags CceNodePoolV3#k8s_tags}.

---

##### `keyPair`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#key_pair CceNodePoolV3#key_pair}.

---

##### `maxNodeCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.maxNodeCount"></a>

```typescript
public readonly maxNodeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#max_node_count CceNodePoolV3#max_node_count}.

---

##### `maxPods`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.maxPods"></a>

```typescript
public readonly maxPods: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#max_pods CceNodePoolV3#max_pods}.

---

##### `minNodeCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.minNodeCount"></a>

```typescript
public readonly minNodeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#min_node_count CceNodePoolV3#min_node_count}.

---

##### `os`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.os"></a>

```typescript
public readonly os: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#os CceNodePoolV3#os}.

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#password CceNodePoolV3#password}.

---

##### `postinstall`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.postinstall"></a>

```typescript
public readonly postinstall: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#postinstall CceNodePoolV3#postinstall}.

---

##### `preinstall`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.preinstall"></a>

```typescript
public readonly preinstall: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#preinstall CceNodePoolV3#preinstall}.

---

##### `priority`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#priority CceNodePoolV3#priority}.

---

##### `scaleDownCooldownTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.scaleDownCooldownTime"></a>

```typescript
public readonly scaleDownCooldownTime: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#scale_down_cooldown_time CceNodePoolV3#scale_down_cooldown_time}.

---

##### `scaleEnable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.scaleEnable"></a>

```typescript
public readonly scaleEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#scale_enable CceNodePoolV3#scale_enable}.

---

##### `serverGroupReference`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.serverGroupReference"></a>

```typescript
public readonly serverGroupReference: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#server_group_reference CceNodePoolV3#server_group_reference}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#subnet_id CceNodePoolV3#subnet_id}.

---

##### `taints`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.taints"></a>

```typescript
public readonly taints: IResolvable | CceNodePoolV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints)[]

taints block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#taints CceNodePoolV3#taints}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: CceNodePoolV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#timeouts CceNodePoolV3#timeouts}

---

##### `userTags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Config.property.userTags"></a>

```typescript
public readonly userTags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#user_tags CceNodePoolV3#user_tags}.

---

### CceNodePoolV3DataVolumes <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodePoolV3DataVolumes } from '@cdktf/provider-opentelekomcloud'

const cceNodePoolV3DataVolumes: CceNodePoolV3DataVolumes = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#size CceNodePoolV3#size}.

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#volumetype CceNodePoolV3#volumetype}.

---

##### `extendParam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#extend_param CceNodePoolV3#extend_param}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#kms_id CceNodePoolV3#kms_id}.

---

### CceNodePoolV3RootVolume <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodePoolV3RootVolume } from '@cdktf/provider-opentelekomcloud'

const cceNodePoolV3RootVolume: CceNodePoolV3RootVolume = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#size CceNodePoolV3#size}.

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#volumetype CceNodePoolV3#volumetype}.

---

##### `extendParam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#extend_param CceNodePoolV3#extend_param}.

---

### CceNodePoolV3Taints <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodePoolV3Taints } from '@cdktf/provider-opentelekomcloud'

const cceNodePoolV3Taints: CceNodePoolV3Taints = { ... }
```

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#effect CceNodePoolV3#effect}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#key CceNodePoolV3#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#value CceNodePoolV3#value}.

---

### CceNodePoolV3Timeouts <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodePoolV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const cceNodePoolV3Timeouts: CceNodePoolV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#create CceNodePoolV3#create}.

---

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#default CceNodePoolV3#default}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#delete CceNodePoolV3#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_pool_v3#update CceNodePoolV3#update}.

---

### CceNodeV3Config <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodeV3Config } from '@cdktf/provider-opentelekomcloud'

const cceNodeV3Config: CceNodeV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#availability_zone CceNodeV3#availability_zone}.

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#cluster_id CceNodeV3#cluster_id}.

---

##### `dataVolumes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.dataVolumes"></a>

```typescript
public readonly dataVolumes: IResolvable | CceNodeV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes)[]

data_volumes block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#data_volumes CceNodeV3#data_volumes}

---

##### `flavorId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#flavor_id CceNodeV3#flavor_id}.

---

##### `keyPair`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#key_pair CceNodeV3#key_pair}.

---

##### `rootVolume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.rootVolume"></a>

```typescript
public readonly rootVolume: CceNodeV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume)

root_volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#root_volume CceNodeV3#root_volume}

---

##### `annotations`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#annotations CceNodeV3#annotations}.

---

##### `bandwidthChargeMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.bandwidthChargeMode"></a>

```typescript
public readonly bandwidthChargeMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#bandwidth_charge_mode CceNodeV3#bandwidth_charge_mode}.

---

##### `bandwidthSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#bandwidth_size CceNodeV3#bandwidth_size}.

---

##### `billingMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.billingMode"></a>

```typescript
public readonly billingMode: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#billing_mode CceNodeV3#billing_mode}.

---

##### `dockerBaseSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.dockerBaseSize"></a>

```typescript
public readonly dockerBaseSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#docker_base_size CceNodeV3#docker_base_size}.

---

##### `dockerLvmConfigOverride`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.dockerLvmConfigOverride"></a>

```typescript
public readonly dockerLvmConfigOverride: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#docker_lvm_config_override CceNodeV3#docker_lvm_config_override}.

---

##### `ecsPerformanceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.ecsPerformanceType"></a>

```typescript
public readonly ecsPerformanceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#ecs_performance_type CceNodeV3#ecs_performance_type}.

---

##### `eipCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.eipCount"></a>

```typescript
public readonly eipCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#eip_count CceNodeV3#eip_count}.

---

##### `eipIds`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.eipIds"></a>

```typescript
public readonly eipIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#eip_ids CceNodeV3#eip_ids}.

---

##### `extendParamChargingMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.extendParamChargingMode"></a>

```typescript
public readonly extendParamChargingMode: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#extend_param_charging_mode CceNodeV3#extend_param_charging_mode}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#id CceNodeV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `iptype`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.iptype"></a>

```typescript
public readonly iptype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#iptype CceNodeV3#iptype}.

---

##### `k8STags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.k8STags"></a>

```typescript
public readonly k8STags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#k8s_tags CceNodeV3#k8s_tags}.

---

##### `labels`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#labels CceNodeV3#labels}.

---

##### `maxPods`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.maxPods"></a>

```typescript
public readonly maxPods: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#max_pods CceNodeV3#max_pods}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#name CceNodeV3#name}.

---

##### `orderId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#order_id CceNodeV3#order_id}.

---

##### `os`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.os"></a>

```typescript
public readonly os: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#os CceNodeV3#os}.

---

##### `postinstall`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.postinstall"></a>

```typescript
public readonly postinstall: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#postinstall CceNodeV3#postinstall}.

---

##### `preinstall`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.preinstall"></a>

```typescript
public readonly preinstall: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#preinstall CceNodeV3#preinstall}.

---

##### `privateIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#private_ip CceNodeV3#private_ip}.

---

##### `productId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#product_id CceNodeV3#product_id}.

---

##### `publicKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#public_key CceNodeV3#public_key}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#region CceNodeV3#region}.

---

##### `sharetype`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.sharetype"></a>

```typescript
public readonly sharetype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#sharetype CceNodeV3#sharetype}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#subnet_id CceNodeV3#subnet_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#tags CceNodeV3#tags}.

---

##### `taints`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.taints"></a>

```typescript
public readonly taints: IResolvable | CceNodeV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodeV3Taints)[]

taints block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#taints CceNodeV3#taints}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: CceNodeV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#timeouts CceNodeV3#timeouts}

---

### CceNodeV3DataVolumes <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodeV3DataVolumes } from '@cdktf/provider-opentelekomcloud'

const cceNodeV3DataVolumes: CceNodeV3DataVolumes = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#size CceNodeV3#size}.

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#volumetype CceNodeV3#volumetype}.

---

##### `extendParam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#extend_param CceNodeV3#extend_param}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#kms_id CceNodeV3#kms_id}.

---

### CceNodeV3RootVolume <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodeV3RootVolume } from '@cdktf/provider-opentelekomcloud'

const cceNodeV3RootVolume: CceNodeV3RootVolume = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#size CceNodeV3#size}.

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#volumetype CceNodeV3#volumetype}.

---

##### `extendParam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#extend_param CceNodeV3#extend_param}.

---

### CceNodeV3Taints <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Taints"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodeV3Taints } from '@cdktf/provider-opentelekomcloud'

const cceNodeV3Taints: CceNodeV3Taints = { ... }
```

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Taints.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#effect CceNodeV3#effect}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Taints.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#key CceNodeV3#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Taints.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#value CceNodeV3#value}.

---

### CceNodeV3Timeouts <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CceNodeV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const cceNodeV3Timeouts: CceNodeV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#create CceNodeV3#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cce_node_v3#delete CceNodeV3#delete}.

---

### CesAlarmruleAlarmActions <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleAlarmActions } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleAlarmActions: CesAlarmruleAlarmActions = { ... }
```

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#notification_list CesAlarmrule#notification_list}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#type CesAlarmrule#type}.

---

### CesAlarmruleCondition <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleCondition } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleCondition: CesAlarmruleCondition = { ... }
```

##### `comparisonOperator`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.comparisonOperator"></a>

```typescript
public readonly comparisonOperator: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#comparison_operator CesAlarmrule#comparison_operator}.

---

##### `count`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#count CesAlarmrule#count}.

---

##### `filter`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.filter"></a>

```typescript
public readonly filter: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#filter CesAlarmrule#filter}.

---

##### `period`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.period"></a>

```typescript
public readonly period: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#period CesAlarmrule#period}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#value CesAlarmrule#value}.

---

##### `unit`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleCondition.property.unit"></a>

```typescript
public readonly unit: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#unit CesAlarmrule#unit}.

---

### CesAlarmruleConfig <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleConfig } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleConfig: CesAlarmruleConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `alarmName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmName"></a>

```typescript
public readonly alarmName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_name CesAlarmrule#alarm_name}.

---

##### `condition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.condition"></a>

```typescript
public readonly condition: CesAlarmruleCondition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleCondition`](#@cdktf/provider-opentelekomcloud.CesAlarmruleCondition)

condition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#condition CesAlarmrule#condition}

---

##### `metric`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.metric"></a>

```typescript
public readonly metric: CesAlarmruleMetric;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetric`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetric)

metric block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#metric CesAlarmrule#metric}

---

##### `alarmActionEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmActionEnabled"></a>

```typescript
public readonly alarmActionEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_action_enabled CesAlarmrule#alarm_action_enabled}.

---

##### `alarmActions`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmActions"></a>

```typescript
public readonly alarmActions: IResolvable | CesAlarmruleAlarmActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions)[]

alarm_actions block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_actions CesAlarmrule#alarm_actions}

---

##### `alarmDescription`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmDescription"></a>

```typescript
public readonly alarmDescription: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_description CesAlarmrule#alarm_description}.

---

##### `alarmEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmEnabled"></a>

```typescript
public readonly alarmEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_enabled CesAlarmrule#alarm_enabled}.

---

##### `alarmLevel`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.alarmLevel"></a>

```typescript
public readonly alarmLevel: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#alarm_level CesAlarmrule#alarm_level}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#id CesAlarmrule#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `insufficientdataActions`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.insufficientdataActions"></a>

```typescript
public readonly insufficientdataActions: IResolvable | CesAlarmruleInsufficientdataActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions)[]

insufficientdata_actions block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#insufficientdata_actions CesAlarmrule#insufficientdata_actions}

---

##### `okActions`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.okActions"></a>

```typescript
public readonly okActions: IResolvable | CesAlarmruleOkActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions)[]

ok_actions block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#ok_actions CesAlarmrule#ok_actions}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConfig.property.timeouts"></a>

```typescript
public readonly timeouts: CesAlarmruleTimeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts`](#@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#timeouts CesAlarmrule#timeouts}

---

### CesAlarmruleInsufficientdataActions <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleInsufficientdataActions } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleInsufficientdataActions: CesAlarmruleInsufficientdataActions = { ... }
```

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#notification_list CesAlarmrule#notification_list}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#type CesAlarmrule#type}.

---

### CesAlarmruleMetric <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetric"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleMetric } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleMetric: CesAlarmruleMetric = { ... }
```

##### `dimensions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetric.property.dimensions"></a>

```typescript
public readonly dimensions: IResolvable | CesAlarmruleMetricDimensions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions)[]

dimensions block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#dimensions CesAlarmrule#dimensions}

---

##### `metricName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetric.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#metric_name CesAlarmrule#metric_name}.

---

##### `namespace`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetric.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#namespace CesAlarmrule#namespace}.

---

### CesAlarmruleMetricDimensions <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleMetricDimensions } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleMetricDimensions: CesAlarmruleMetricDimensions = { ... }
```

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#name CesAlarmrule#name}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#value CesAlarmrule#value}.

---

### CesAlarmruleOkActions <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleOkActions } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleOkActions: CesAlarmruleOkActions = { ... }
```

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#notification_list CesAlarmrule#notification_list}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#type CesAlarmrule#type}.

---

### CesAlarmruleTimeouts <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CesAlarmruleTimeouts } from '@cdktf/provider-opentelekomcloud'

const cesAlarmruleTimeouts: CesAlarmruleTimeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#create CesAlarmrule#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#delete CesAlarmrule#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ces_alarmrule#update CesAlarmrule#update}.

---

### ComputeBmsServerV2BlockDevice <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsServerV2BlockDevice } from '@cdktf/provider-opentelekomcloud'

const computeBmsServerV2BlockDevice: ComputeBmsServerV2BlockDevice = { ... }
```

##### `sourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.sourceType"></a>

```typescript
public readonly sourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#source_type ComputeBmsServerV2#source_type}.

---

##### `bootIndex`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.bootIndex"></a>

```typescript
public readonly bootIndex: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#boot_index ComputeBmsServerV2#boot_index}.

---

##### `deleteOnTermination`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.deleteOnTermination"></a>

```typescript
public readonly deleteOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#delete_on_termination ComputeBmsServerV2#delete_on_termination}.

---

##### `destinationType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.destinationType"></a>

```typescript
public readonly destinationType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#destination_type ComputeBmsServerV2#destination_type}.

---

##### `deviceName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#device_name ComputeBmsServerV2#device_name}.

---

##### `guestFormat`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.guestFormat"></a>

```typescript
public readonly guestFormat: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#guest_format ComputeBmsServerV2#guest_format}.

---

##### `uuid`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#uuid ComputeBmsServerV2#uuid}.

---

##### `volumeSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#volume_size ComputeBmsServerV2#volume_size}.

---

##### `volumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#volume_type ComputeBmsServerV2#volume_type}.

---

### ComputeBmsServerV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsServerV2Config } from '@cdktf/provider-opentelekomcloud'

const computeBmsServerV2Config: ComputeBmsServerV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#availability_zone ComputeBmsServerV2#availability_zone}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#name ComputeBmsServerV2#name}.

---

##### `adminPass`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#admin_pass ComputeBmsServerV2#admin_pass}.

---

##### `blockDevice`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.blockDevice"></a>

```typescript
public readonly blockDevice: IResolvable | ComputeBmsServerV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice)[]

block_device block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#block_device ComputeBmsServerV2#block_device}

---

##### `flavorId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#flavor_id ComputeBmsServerV2#flavor_id}.

---

##### `flavorName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.flavorName"></a>

```typescript
public readonly flavorName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#flavor_name ComputeBmsServerV2#flavor_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#id ComputeBmsServerV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#image_id ComputeBmsServerV2#image_id}.

---

##### `imageName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.imageName"></a>

```typescript
public readonly imageName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#image_name ComputeBmsServerV2#image_name}.

---

##### `keyPair`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#key_pair ComputeBmsServerV2#key_pair}.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#metadata ComputeBmsServerV2#metadata}.

---

##### `network`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.network"></a>

```typescript
public readonly network: IResolvable | ComputeBmsServerV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network)[]

network block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#network ComputeBmsServerV2#network}

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#region ComputeBmsServerV2#region}.

---

##### `securityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#security_groups ComputeBmsServerV2#security_groups}.

---

##### `stopBeforeDestroy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.stopBeforeDestroy"></a>

```typescript
public readonly stopBeforeDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#stop_before_destroy ComputeBmsServerV2#stop_before_destroy}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#tags ComputeBmsServerV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeBmsServerV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#timeouts ComputeBmsServerV2#timeouts}

---

##### `userData`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Config.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#user_data ComputeBmsServerV2#user_data}.

---

### ComputeBmsServerV2Network <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsServerV2Network } from '@cdktf/provider-opentelekomcloud'

const computeBmsServerV2Network: ComputeBmsServerV2Network = { ... }
```

##### `accessNetwork`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.accessNetwork"></a>

```typescript
public readonly accessNetwork: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#access_network ComputeBmsServerV2#access_network}.

---

##### `fixedIpV4`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#fixed_ip_v4 ComputeBmsServerV2#fixed_ip_v4}.

---

##### `fixedIpV6`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.fixedIpV6"></a>

```typescript
public readonly fixedIpV6: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#fixed_ip_v6 ComputeBmsServerV2#fixed_ip_v6}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#name ComputeBmsServerV2#name}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#port ComputeBmsServerV2#port}.

---

##### `uuid`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#uuid ComputeBmsServerV2#uuid}.

---

### ComputeBmsServerV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsServerV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const computeBmsServerV2Timeouts: ComputeBmsServerV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#create ComputeBmsServerV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#delete ComputeBmsServerV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_server_v2#update ComputeBmsServerV2#update}.

---

### ComputeBmsTagsV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsTagsV2Config } from '@cdktf/provider-opentelekomcloud'

const computeBmsTagsV2Config: ComputeBmsTagsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#server_id ComputeBmsTagsV2#server_id}.

---

##### `tags`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#tags ComputeBmsTagsV2#tags}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#id ComputeBmsTagsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#region ComputeBmsTagsV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeBmsTagsV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#timeouts ComputeBmsTagsV2#timeouts}

---

### ComputeBmsTagsV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeBmsTagsV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const computeBmsTagsV2Timeouts: ComputeBmsTagsV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#create ComputeBmsTagsV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_bms_tags_v2#delete ComputeBmsTagsV2#delete}.

---

### ComputeFloatingipAssociateV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeFloatingipAssociateV2Config } from '@cdktf/provider-opentelekomcloud'

const computeFloatingipAssociateV2Config: ComputeFloatingipAssociateV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `floatingIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.floatingIp"></a>

```typescript
public readonly floatingIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2#floating_ip ComputeFloatingipAssociateV2#floating_ip}.

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2#instance_id ComputeFloatingipAssociateV2#instance_id}.

---

##### `fixedIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2#fixed_ip ComputeFloatingipAssociateV2#fixed_ip}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2#id ComputeFloatingipAssociateV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipAssociateV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_associate_v2#region ComputeFloatingipAssociateV2#region}.

---

### ComputeFloatingipV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeFloatingipV2Config } from '@cdktf/provider-opentelekomcloud'

const computeFloatingipV2Config: ComputeFloatingipV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_v2#id ComputeFloatingipV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `pool`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_v2#pool ComputeFloatingipV2#pool}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeFloatingipV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_floatingip_v2#region ComputeFloatingipV2#region}.

---

### ComputeInstanceV2BlockDevice <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2BlockDevice } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2BlockDevice: ComputeInstanceV2BlockDevice = { ... }
```

##### `sourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.sourceType"></a>

```typescript
public readonly sourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#source_type ComputeInstanceV2#source_type}.

---

##### `bootIndex`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.bootIndex"></a>

```typescript
public readonly bootIndex: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#boot_index ComputeInstanceV2#boot_index}.

---

##### `deleteOnTermination`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.deleteOnTermination"></a>

```typescript
public readonly deleteOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#delete_on_termination ComputeInstanceV2#delete_on_termination}.

---

##### `destinationType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.destinationType"></a>

```typescript
public readonly destinationType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#destination_type ComputeInstanceV2#destination_type}.

---

##### `deviceName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#device_name ComputeInstanceV2#device_name}.

---

##### `guestFormat`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.guestFormat"></a>

```typescript
public readonly guestFormat: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#guest_format ComputeInstanceV2#guest_format}.

---

##### `uuid`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#uuid ComputeInstanceV2#uuid}.

---

##### `volumeSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#volume_size ComputeInstanceV2#volume_size}.

---

##### `volumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#volume_type ComputeInstanceV2#volume_type}.

---

### ComputeInstanceV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2Config } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2Config: ComputeInstanceV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#name ComputeInstanceV2#name}.

---

##### `accessIpV4`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.accessIpV4"></a>

```typescript
public readonly accessIpV4: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#access_ip_v4 ComputeInstanceV2#access_ip_v4}.

---

##### `accessIpV6`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.accessIpV6"></a>

```typescript
public readonly accessIpV6: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#access_ip_v6 ComputeInstanceV2#access_ip_v6}.

---

##### `adminPass`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#admin_pass ComputeInstanceV2#admin_pass}.

---

##### `autoRecovery`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.autoRecovery"></a>

```typescript
public readonly autoRecovery: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#auto_recovery ComputeInstanceV2#auto_recovery}.

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#availability_zone ComputeInstanceV2#availability_zone}.

---

##### `blockDevice`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.blockDevice"></a>

```typescript
public readonly blockDevice: IResolvable | ComputeInstanceV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice)[]

block_device block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#block_device ComputeInstanceV2#block_device}

---

##### `configDrive`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.configDrive"></a>

```typescript
public readonly configDrive: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#config_drive ComputeInstanceV2#config_drive}.

---

##### `flavorId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#flavor_id ComputeInstanceV2#flavor_id}.

---

##### `flavorName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.flavorName"></a>

```typescript
public readonly flavorName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#flavor_name ComputeInstanceV2#flavor_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#id ComputeInstanceV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#image_id ComputeInstanceV2#image_id}.

---

##### `imageName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.imageName"></a>

```typescript
public readonly imageName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#image_name ComputeInstanceV2#image_name}.

---

##### `keyPair`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.keyPair"></a>

```typescript
public readonly keyPair: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#key_pair ComputeInstanceV2#key_pair}.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#metadata ComputeInstanceV2#metadata}.

---

##### `network`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.network"></a>

```typescript
public readonly network: IResolvable | ComputeInstanceV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network)[]

network block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#network ComputeInstanceV2#network}

---

##### `powerState`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.powerState"></a>

```typescript
public readonly powerState: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#power_state ComputeInstanceV2#power_state}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#region ComputeInstanceV2#region}.

---

##### `schedulerHints`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.schedulerHints"></a>

```typescript
public readonly schedulerHints: IResolvable | ComputeInstanceV2SchedulerHints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints)[]

scheduler_hints block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#scheduler_hints ComputeInstanceV2#scheduler_hints}

---

##### `securityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#security_groups ComputeInstanceV2#security_groups}.

---

##### `stopBeforeDestroy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.stopBeforeDestroy"></a>

```typescript
public readonly stopBeforeDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#stop_before_destroy ComputeInstanceV2#stop_before_destroy}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#tags ComputeInstanceV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#timeouts ComputeInstanceV2#timeouts}

---

##### `userData`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Config.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#user_data ComputeInstanceV2#user_data}.

---

### ComputeInstanceV2Network <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2Network } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2Network: ComputeInstanceV2Network = { ... }
```

##### `accessNetwork`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.accessNetwork"></a>

```typescript
public readonly accessNetwork: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#access_network ComputeInstanceV2#access_network}.

---

##### `fixedIpV4`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#fixed_ip_v4 ComputeInstanceV2#fixed_ip_v4}.

---

##### `fixedIpV6`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.fixedIpV6"></a>

```typescript
public readonly fixedIpV6: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#fixed_ip_v6 ComputeInstanceV2#fixed_ip_v6}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#name ComputeInstanceV2#name}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#port ComputeInstanceV2#port}.

---

##### `uuid`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#uuid ComputeInstanceV2#uuid}.

---

### ComputeInstanceV2SchedulerHints <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2SchedulerHints } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2SchedulerHints: ComputeInstanceV2SchedulerHints = { ... }
```

##### `buildNearHostIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.buildNearHostIp"></a>

```typescript
public readonly buildNearHostIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#build_near_host_ip ComputeInstanceV2#build_near_host_ip}.

---

##### `dehId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.dehId"></a>

```typescript
public readonly dehId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#deh_id ComputeInstanceV2#deh_id}.

---

##### `differentHost`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.differentHost"></a>

```typescript
public readonly differentHost: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#different_host ComputeInstanceV2#different_host}.

---

##### `group`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#group ComputeInstanceV2#group}.

---

##### `query`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.query"></a>

```typescript
public readonly query: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#query ComputeInstanceV2#query}.

---

##### `sameHost`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.sameHost"></a>

```typescript
public readonly sameHost: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#same_host ComputeInstanceV2#same_host}.

---

##### `targetCell`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.targetCell"></a>

```typescript
public readonly targetCell: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#target_cell ComputeInstanceV2#target_cell}.

---

##### `tenancy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints.property.tenancy"></a>

```typescript
public readonly tenancy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#tenancy ComputeInstanceV2#tenancy}.

---

### ComputeInstanceV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2Timeouts: ComputeInstanceV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#create ComputeInstanceV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#delete ComputeInstanceV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_instance_v2#update ComputeInstanceV2#update}.

---

### ComputeInstanceV2VolumeAttached <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttached"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeInstanceV2VolumeAttached } from '@cdktf/provider-opentelekomcloud'

const computeInstanceV2VolumeAttached: ComputeInstanceV2VolumeAttached = { ... }
```

### ComputeKeypairV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeKeypairV2Config } from '@cdktf/provider-opentelekomcloud'

const computeKeypairV2Config: ComputeKeypairV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2#name ComputeKeypairV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2#id ComputeKeypairV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `publicKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2#public_key ComputeKeypairV2#public_key}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2#region ComputeKeypairV2#region}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeKeypairV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_keypair_v2#value_specs ComputeKeypairV2#value_specs}.

---

### ComputeSecgroupV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeSecgroupV2Config } from '@cdktf/provider-opentelekomcloud'

const computeSecgroupV2Config: ComputeSecgroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#description ComputeSecgroupV2#description}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#name ComputeSecgroupV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#id ComputeSecgroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#region ComputeSecgroupV2#region}.

---

##### `rule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.rule"></a>

```typescript
public readonly rule: IResolvable | ComputeSecgroupV2Rule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule)[]

rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#rule ComputeSecgroupV2#rule}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeSecgroupV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#timeouts ComputeSecgroupV2#timeouts}

---

### ComputeSecgroupV2Rule <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeSecgroupV2Rule } from '@cdktf/provider-opentelekomcloud'

const computeSecgroupV2Rule: ComputeSecgroupV2Rule = { ... }
```

##### `fromPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#from_port ComputeSecgroupV2#from_port}.

---

##### `ipProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.ipProtocol"></a>

```typescript
public readonly ipProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#ip_protocol ComputeSecgroupV2#ip_protocol}.

---

##### `toPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#to_port ComputeSecgroupV2#to_port}.

---

##### `cidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#cidr ComputeSecgroupV2#cidr}.

---

##### `fromGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.fromGroupId"></a>

```typescript
public readonly fromGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#from_group_id ComputeSecgroupV2#from_group_id}.

---

##### `selfAttribute`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule.property.selfAttribute"></a>

```typescript
public readonly selfAttribute: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#self ComputeSecgroupV2#self}.

---

### ComputeSecgroupV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeSecgroupV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const computeSecgroupV2Timeouts: ComputeSecgroupV2Timeouts = { ... }
```

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_secgroup_v2#delete ComputeSecgroupV2#delete}.

---

### ComputeServergroupV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeServergroupV2Config } from '@cdktf/provider-opentelekomcloud'

const computeServergroupV2Config: ComputeServergroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2#name ComputeServergroupV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2#id ComputeServergroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `policies`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.policies"></a>

```typescript
public readonly policies: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2#policies ComputeServergroupV2#policies}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2#region ComputeServergroupV2#region}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeServergroupV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_servergroup_v2#value_specs ComputeServergroupV2#value_specs}.

---

### ComputeVolumeAttachV2Config <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeVolumeAttachV2Config } from '@cdktf/provider-opentelekomcloud'

const computeVolumeAttachV2Config: ComputeVolumeAttachV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#instance_id ComputeVolumeAttachV2#instance_id}.

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#volume_id ComputeVolumeAttachV2#volume_id}.

---

##### `device`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#device ComputeVolumeAttachV2#device}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#id ComputeVolumeAttachV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#region ComputeVolumeAttachV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeVolumeAttachV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#timeouts ComputeVolumeAttachV2#timeouts}

---

### ComputeVolumeAttachV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ComputeVolumeAttachV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const computeVolumeAttachV2Timeouts: ComputeVolumeAttachV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#create ComputeVolumeAttachV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/compute_volume_attach_v2#delete ComputeVolumeAttachV2#delete}.

---

### CsbsBackupPolicyV1Config <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupPolicyV1Config } from '@cdktf/provider-opentelekomcloud'

const csbsBackupPolicyV1Config: CsbsBackupPolicyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#name CsbsBackupPolicyV1#name}.

---

##### `resource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.resource"></a>

```typescript
public readonly resource: IResolvable | CsbsBackupPolicyV1Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource)[]

resource block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#resource CsbsBackupPolicyV1#resource}

---

##### `scheduledOperation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.scheduledOperation"></a>

```typescript
public readonly scheduledOperation: CsbsBackupPolicyV1ScheduledOperation;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation)

scheduled_operation block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#scheduled_operation CsbsBackupPolicyV1#scheduled_operation}

---

##### `common`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.common"></a>

```typescript
public readonly common: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#common CsbsBackupPolicyV1#common}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#description CsbsBackupPolicyV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#id CsbsBackupPolicyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `providerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#provider_id CsbsBackupPolicyV1#provider_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#region CsbsBackupPolicyV1#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.tags"></a>

```typescript
public readonly tags: IResolvable | CsbsBackupPolicyV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags)[]

tags block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#tags CsbsBackupPolicyV1#tags}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: CsbsBackupPolicyV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#timeouts CsbsBackupPolicyV1#timeouts}

---

### CsbsBackupPolicyV1Resource <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupPolicyV1Resource } from '@cdktf/provider-opentelekomcloud'

const csbsBackupPolicyV1Resource: CsbsBackupPolicyV1Resource = { ... }
```

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#id CsbsBackupPolicyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#name CsbsBackupPolicyV1#name}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#type CsbsBackupPolicyV1#type}.

---

### CsbsBackupPolicyV1ScheduledOperation <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupPolicyV1ScheduledOperation } from '@cdktf/provider-opentelekomcloud'

const csbsBackupPolicyV1ScheduledOperation: CsbsBackupPolicyV1ScheduledOperation = { ... }
```

##### `operationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.operationType"></a>

```typescript
public readonly operationType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#operation_type CsbsBackupPolicyV1#operation_type}.

---

##### `triggerPattern`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.triggerPattern"></a>

```typescript
public readonly triggerPattern: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#trigger_pattern CsbsBackupPolicyV1#trigger_pattern}.

---

##### `dayBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.dayBackups"></a>

```typescript
public readonly dayBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#day_backups CsbsBackupPolicyV1#day_backups}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#description CsbsBackupPolicyV1#description}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#enabled CsbsBackupPolicyV1#enabled}.

---

##### `maxBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.maxBackups"></a>

```typescript
public readonly maxBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#max_backups CsbsBackupPolicyV1#max_backups}.

---

##### `monthBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.monthBackups"></a>

```typescript
public readonly monthBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#month_backups CsbsBackupPolicyV1#month_backups}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#name CsbsBackupPolicyV1#name}.

---

##### `permanent`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.permanent"></a>

```typescript
public readonly permanent: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#permanent CsbsBackupPolicyV1#permanent}.

---

##### `retentionDurationDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.retentionDurationDays"></a>

```typescript
public readonly retentionDurationDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#retention_duration_days CsbsBackupPolicyV1#retention_duration_days}.

---

##### `timezone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#timezone CsbsBackupPolicyV1#timezone}.

---

##### `weekBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.weekBackups"></a>

```typescript
public readonly weekBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#week_backups CsbsBackupPolicyV1#week_backups}.

---

##### `yearBackups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation.property.yearBackups"></a>

```typescript
public readonly yearBackups: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#year_backups CsbsBackupPolicyV1#year_backups}.

---

### CsbsBackupPolicyV1Tags <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupPolicyV1Tags } from '@cdktf/provider-opentelekomcloud'

const csbsBackupPolicyV1Tags: CsbsBackupPolicyV1Tags = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#key CsbsBackupPolicyV1#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#value CsbsBackupPolicyV1#value}.

---

### CsbsBackupPolicyV1Timeouts <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupPolicyV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const csbsBackupPolicyV1Timeouts: CsbsBackupPolicyV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#create CsbsBackupPolicyV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_policy_v1#delete CsbsBackupPolicyV1#delete}.

---

### CsbsBackupV1Config <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupV1Config } from '@cdktf/provider-opentelekomcloud'

const csbsBackupV1Config: CsbsBackupV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `resourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#resource_id CsbsBackupV1#resource_id}.

---

##### `backupName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.backupName"></a>

```typescript
public readonly backupName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#backup_name CsbsBackupV1#backup_name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#description CsbsBackupV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#id CsbsBackupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#region CsbsBackupV1#region}.

---

##### `resourceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#resource_type CsbsBackupV1#resource_type}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.tags"></a>

```typescript
public readonly tags: IResolvable | CsbsBackupV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags)[]

tags block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#tags CsbsBackupV1#tags}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: CsbsBackupV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#timeouts CsbsBackupV1#timeouts}

---

### CsbsBackupV1Tags <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupV1Tags } from '@cdktf/provider-opentelekomcloud'

const csbsBackupV1Tags: CsbsBackupV1Tags = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#key CsbsBackupV1#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#value CsbsBackupV1#value}.

---

### CsbsBackupV1Timeouts <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const csbsBackupV1Timeouts: CsbsBackupV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#create CsbsBackupV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/csbs_backup_v1#delete CsbsBackupV1#delete}.

---

### CsbsBackupV1VmMetadata <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadata"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupV1VmMetadata } from '@cdktf/provider-opentelekomcloud'

const csbsBackupV1VmMetadata: CsbsBackupV1VmMetadata = { ... }
```

### CsbsBackupV1VolumeBackups <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackups"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CsbsBackupV1VolumeBackups } from '@cdktf/provider-opentelekomcloud'

const csbsBackupV1VolumeBackups: CsbsBackupV1VolumeBackups = { ... }
```

### CssClusterV1Config <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1Config } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1Config: CssClusterV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#name CssClusterV1#name}.

---

##### `nodeConfig`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.nodeConfig"></a>

```typescript
public readonly nodeConfig: CssClusterV1NodeConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig)

node_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#node_config CssClusterV1#node_config}

---

##### `adminPass`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.adminPass"></a>

```typescript
public readonly adminPass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#admin_pass CssClusterV1#admin_pass}.

---

##### `datastore`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.datastore"></a>

```typescript
public readonly datastore: CssClusterV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Datastore`](#@cdktf/provider-opentelekomcloud.CssClusterV1Datastore)

datastore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#datastore CssClusterV1#datastore}

---

##### `enableAuthority`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.enableAuthority"></a>

```typescript
public readonly enableAuthority: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#enable_authority CssClusterV1#enable_authority}.

---

##### `enableHttps`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.enableHttps"></a>

```typescript
public readonly enableHttps: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#enable_https CssClusterV1#enable_https}.

---

##### `expectNodeNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.expectNodeNum"></a>

```typescript
public readonly expectNodeNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#expect_node_num CssClusterV1#expect_node_num}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#id CssClusterV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#tags CssClusterV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: CssClusterV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#timeouts CssClusterV1#timeouts}

---

### CssClusterV1Datastore <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Datastore"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1Datastore } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1Datastore: CssClusterV1Datastore = { ... }
```

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Datastore.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#type CssClusterV1#type}.

---

##### `version`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Datastore.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#version CssClusterV1#version}.

---

### CssClusterV1NodeConfig <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1NodeConfig } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1NodeConfig: CssClusterV1NodeConfig = { ... }
```

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#flavor CssClusterV1#flavor}.

---

##### `networkInfo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig.property.networkInfo"></a>

```typescript
public readonly networkInfo: CssClusterV1NodeConfigNetworkInfo;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo)

network_info block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#network_info CssClusterV1#network_info}

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig.property.volume"></a>

```typescript
public readonly volume: CssClusterV1NodeConfigVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume)

volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#volume CssClusterV1#volume}

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#availability_zone CssClusterV1#availability_zone}.

---

### CssClusterV1NodeConfigNetworkInfo <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1NodeConfigNetworkInfo } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1NodeConfigNetworkInfo: CssClusterV1NodeConfigNetworkInfo = { ... }
```

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#network_id CssClusterV1#network_id}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#security_group_id CssClusterV1#security_group_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#vpc_id CssClusterV1#vpc_id}.

---

### CssClusterV1NodeConfigVolume <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1NodeConfigVolume } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1NodeConfigVolume: CssClusterV1NodeConfigVolume = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#size CssClusterV1#size}.

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#volume_type CssClusterV1#volume_type}.

---

##### `encryptionKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#encryption_key CssClusterV1#encryption_key}.

---

### CssClusterV1Nodes <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Nodes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1Nodes } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1Nodes: CssClusterV1Nodes = { ... }
```

### CssClusterV1Timeouts <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssClusterV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const cssClusterV1Timeouts: CssClusterV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#create CssClusterV1#create}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_cluster_v1#update CssClusterV1#update}.

---

### CssSnapshotConfigurationV1Config <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1Config } from '@cdktf/provider-opentelekomcloud'

const cssSnapshotConfigurationV1Config: CssSnapshotConfigurationV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#cluster_id CssSnapshotConfigurationV1#cluster_id}.

---

##### `automatic`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.automatic"></a>

```typescript
public readonly automatic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#automatic CssSnapshotConfigurationV1#automatic}.

---

##### `configuration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.configuration"></a>

```typescript
public readonly configuration: CssSnapshotConfigurationV1Configuration;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration)

configuration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#configuration CssSnapshotConfigurationV1#configuration}

---

##### `creationPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.creationPolicy"></a>

```typescript
public readonly creationPolicy: CssSnapshotConfigurationV1CreationPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy)

creation_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#creation_policy CssSnapshotConfigurationV1#creation_policy}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#id CssSnapshotConfigurationV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: CssSnapshotConfigurationV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#timeouts CssSnapshotConfigurationV1#timeouts}

---

### CssSnapshotConfigurationV1Configuration <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1Configuration } from '@cdktf/provider-opentelekomcloud'

const cssSnapshotConfigurationV1Configuration: CssSnapshotConfigurationV1Configuration = { ... }
```

##### `agency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration.property.agency"></a>

```typescript
public readonly agency: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#agency CssSnapshotConfigurationV1#agency}.

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#bucket CssSnapshotConfigurationV1#bucket}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#kms_id CssSnapshotConfigurationV1#kms_id}.

---

### CssSnapshotConfigurationV1CreationPolicy <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1CreationPolicy } from '@cdktf/provider-opentelekomcloud'

const cssSnapshotConfigurationV1CreationPolicy: CssSnapshotConfigurationV1CreationPolicy = { ... }
```

##### `enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy.property.enable"></a>

```typescript
public readonly enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#enable CssSnapshotConfigurationV1#enable}.

---

##### `keepday`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy.property.keepday"></a>

```typescript
public readonly keepday: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#keepday CssSnapshotConfigurationV1#keepday}.

---

##### `period`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy.property.period"></a>

```typescript
public readonly period: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#period CssSnapshotConfigurationV1#period}.

---

##### `prefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#prefix CssSnapshotConfigurationV1#prefix}.

---

##### `deleteAuto`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy.property.deleteAuto"></a>

```typescript
public readonly deleteAuto: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#delete_auto CssSnapshotConfigurationV1#delete_auto}.

---

### CssSnapshotConfigurationV1Timeouts <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const cssSnapshotConfigurationV1Timeouts: CssSnapshotConfigurationV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#create CssSnapshotConfigurationV1#create}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/css_snapshot_configuration_v1#update CssSnapshotConfigurationV1#update}.

---

### CtsTrackerV1Config <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CtsTrackerV1Config } from '@cdktf/provider-opentelekomcloud'

const ctsTrackerV1Config: CtsTrackerV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucketName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#bucket_name CtsTrackerV1#bucket_name}.

---

##### `isSupportSmn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.isSupportSmn"></a>

```typescript
public readonly isSupportSmn: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#is_support_smn CtsTrackerV1#is_support_smn}.

---

##### `filePrefixName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.filePrefixName"></a>

```typescript
public readonly filePrefixName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#file_prefix_name CtsTrackerV1#file_prefix_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#id CtsTrackerV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `isSendAllKeyOperation`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.isSendAllKeyOperation"></a>

```typescript
public readonly isSendAllKeyOperation: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#is_send_all_key_operation CtsTrackerV1#is_send_all_key_operation}.

---

##### `needNotifyUserList`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.needNotifyUserList"></a>

```typescript
public readonly needNotifyUserList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#need_notify_user_list CtsTrackerV1#need_notify_user_list}.

---

##### `operations`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#operations CtsTrackerV1#operations}.

---

##### `projectName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#project_name CtsTrackerV1#project_name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#region CtsTrackerV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#status CtsTrackerV1#status}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: CtsTrackerV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#timeouts CtsTrackerV1#timeouts}

---

##### `topicId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Config.property.topicId"></a>

```typescript
public readonly topicId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#topic_id CtsTrackerV1#topic_id}.

---

### CtsTrackerV1Timeouts <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CtsTrackerV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const ctsTrackerV1Timeouts: CtsTrackerV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#create CtsTrackerV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/cts_tracker_v1#delete CtsTrackerV1#delete}.

---

### DataOpentelekomcloudAntiddosV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudAntiddosV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudAntiddosV1Config: DataOpentelekomcloudAntiddosV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `floatingIpAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.floatingIpAddress"></a>

```typescript
public readonly floatingIpAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#floating_ip_address DataOpentelekomcloudAntiddosV1#floating_ip_address}.

---

##### `floatingIpId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#floating_ip_id DataOpentelekomcloudAntiddosV1#floating_ip_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#id DataOpentelekomcloudAntiddosV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#region DataOpentelekomcloudAntiddosV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudAntiddosV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/antiddos_v1#status DataOpentelekomcloudAntiddosV1#status}.

---

### DataOpentelekomcloudCceClusterKubeconfigV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterKubeconfigV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceClusterKubeconfigV3Config: DataOpentelekomcloudCceClusterKubeconfigV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_kubeconfig_v3#cluster_id DataOpentelekomcloudCceClusterKubeconfigV3#cluster_id}.

---

##### `duration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.duration"></a>

```typescript
public readonly duration: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_kubeconfig_v3#duration DataOpentelekomcloudCceClusterKubeconfigV3#duration}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterKubeconfigV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_kubeconfig_v3#id DataOpentelekomcloudCceClusterKubeconfigV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudCceClusterV3CertificateClusters <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClusters"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateClusters } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceClusterV3CertificateClusters: DataOpentelekomcloudCceClusterV3CertificateClusters = { ... }
```

### DataOpentelekomcloudCceClusterV3CertificateUsers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsers"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateUsers } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceClusterV3CertificateUsers: DataOpentelekomcloudCceClusterV3CertificateUsers = { ... }
```

### DataOpentelekomcloudCceClusterV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceClusterV3Config: DataOpentelekomcloudCceClusterV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.clusterType"></a>

```typescript
public readonly clusterType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#cluster_type DataOpentelekomcloudCceClusterV3#cluster_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#id DataOpentelekomcloudCceClusterV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#name DataOpentelekomcloudCceClusterV3#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#region DataOpentelekomcloudCceClusterV3#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#status DataOpentelekomcloudCceClusterV3#status}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_cluster_v3#vpc_id DataOpentelekomcloudCceClusterV3#vpc_id}.

---

### DataOpentelekomcloudCceNodeIdsV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeIdsV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceNodeIdsV3Config: DataOpentelekomcloudCceNodeIdsV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_ids_v3#cluster_id DataOpentelekomcloudCceNodeIdsV3#cluster_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_ids_v3#id DataOpentelekomcloudCceNodeIdsV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeIdsV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_ids_v3#region DataOpentelekomcloudCceNodeIdsV3#region}.

---

### DataOpentelekomcloudCceNodeV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceNodeV3Config: DataOpentelekomcloudCceNodeV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#cluster_id DataOpentelekomcloudCceNodeV3#cluster_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#id DataOpentelekomcloudCceNodeV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#name DataOpentelekomcloudCceNodeV3#name}.

---

##### `nodeId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.nodeId"></a>

```typescript
public readonly nodeId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#node_id DataOpentelekomcloudCceNodeV3#node_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#region DataOpentelekomcloudCceNodeV3#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cce_node_v3#status DataOpentelekomcloudCceNodeV3#status}.

---

### DataOpentelekomcloudCceNodeV3DataVolumes <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeV3DataVolumes } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCceNodeV3DataVolumes: DataOpentelekomcloudCceNodeV3DataVolumes = { ... }
```

### DataOpentelekomcloudComputeAvailabilityZonesV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeAvailabilityZonesV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeAvailabilityZonesV2Config: DataOpentelekomcloudComputeAvailabilityZonesV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_availability_zones_v2#id DataOpentelekomcloudComputeAvailabilityZonesV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_availability_zones_v2#region DataOpentelekomcloudComputeAvailabilityZonesV2#region}.

---

##### `state`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeAvailabilityZonesV2Config.property.state"></a>

```typescript
public readonly state: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_availability_zones_v2#state DataOpentelekomcloudComputeAvailabilityZonesV2#state}.

---

### DataOpentelekomcloudComputeBmsFlavorsV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsFlavorsV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsFlavorsV2Config: DataOpentelekomcloudComputeBmsFlavorsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#id DataOpentelekomcloudComputeBmsFlavorsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `minDisk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#min_disk DataOpentelekomcloudComputeBmsFlavorsV2#min_disk}.

---

##### `minRam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#min_ram DataOpentelekomcloudComputeBmsFlavorsV2#min_ram}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#name DataOpentelekomcloudComputeBmsFlavorsV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#region DataOpentelekomcloudComputeBmsFlavorsV2#region}.

---

##### `sortDir`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.sortDir"></a>

```typescript
public readonly sortDir: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#sort_dir DataOpentelekomcloudComputeBmsFlavorsV2#sort_dir}.

---

##### `sortKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsFlavorsV2Config.property.sortKey"></a>

```typescript
public readonly sortKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2#sort_key DataOpentelekomcloudComputeBmsFlavorsV2#sort_key}.

---

### DataOpentelekomcloudComputeBmsKeypairsV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsKeypairsV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsKeypairsV2Config: DataOpentelekomcloudComputeBmsKeypairsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_keypairs_v2#name DataOpentelekomcloudComputeBmsKeypairsV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_keypairs_v2#id DataOpentelekomcloudComputeBmsKeypairsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsKeypairsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_keypairs_v2#region DataOpentelekomcloudComputeBmsKeypairsV2#region}.

---

### DataOpentelekomcloudComputeBmsNicV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsNicV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsNicV2Config: DataOpentelekomcloudComputeBmsNicV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_nic_v2#server_id DataOpentelekomcloudComputeBmsNicV2#server_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_nic_v2#id DataOpentelekomcloudComputeBmsNicV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_nic_v2#region DataOpentelekomcloudComputeBmsNicV2#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_nic_v2#status DataOpentelekomcloudComputeBmsNicV2#status}.

---

### DataOpentelekomcloudComputeBmsNicV2FixedIps <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsNicV2FixedIps } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsNicV2FixedIps: DataOpentelekomcloudComputeBmsNicV2FixedIps = { ... }
```

### DataOpentelekomcloudComputeBmsServerV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsServerV2Config: DataOpentelekomcloudComputeBmsServerV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `flavorId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#flavor_id DataOpentelekomcloudComputeBmsServerV2#flavor_id}.

---

##### `hostStatus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.hostStatus"></a>

```typescript
public readonly hostStatus: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#host_status DataOpentelekomcloudComputeBmsServerV2#host_status}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#id DataOpentelekomcloudComputeBmsServerV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#image_id DataOpentelekomcloudComputeBmsServerV2#image_id}.

---

##### `keyName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#key_name DataOpentelekomcloudComputeBmsServerV2#key_name}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#name DataOpentelekomcloudComputeBmsServerV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#region DataOpentelekomcloudComputeBmsServerV2#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#status DataOpentelekomcloudComputeBmsServerV2#status}.

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Config.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_server_v2#user_id DataOpentelekomcloudComputeBmsServerV2#user_id}.

---

### DataOpentelekomcloudComputeBmsServerV2Network <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Network"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2Network } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsServerV2Network: DataOpentelekomcloudComputeBmsServerV2Network = { ... }
```

### DataOpentelekomcloudComputeBmsServerV2SecurityGroups <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroups"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2SecurityGroups } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeBmsServerV2SecurityGroups: DataOpentelekomcloudComputeBmsServerV2SecurityGroups = { ... }
```

### DataOpentelekomcloudComputeFlavorV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeFlavorV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudComputeFlavorV2Config: DataOpentelekomcloudComputeFlavorV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#availability_zone DataOpentelekomcloudComputeFlavorV2#availability_zone}.

---

##### `disk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.disk"></a>

```typescript
public readonly disk: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#disk DataOpentelekomcloudComputeFlavorV2#disk}.

---

##### `flavorId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#flavor_id DataOpentelekomcloudComputeFlavorV2#flavor_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#id DataOpentelekomcloudComputeFlavorV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `minDisk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#min_disk DataOpentelekomcloudComputeFlavorV2#min_disk}.

---

##### `minRam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#min_ram DataOpentelekomcloudComputeFlavorV2#min_ram}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#name DataOpentelekomcloudComputeFlavorV2#name}.

---

##### `ram`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#ram DataOpentelekomcloudComputeFlavorV2#ram}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#region DataOpentelekomcloudComputeFlavorV2#region}.

---

##### `resourceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#resource_type DataOpentelekomcloudComputeFlavorV2#resource_type}.

---

##### `rxTxFactor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.rxTxFactor"></a>

```typescript
public readonly rxTxFactor: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#rx_tx_factor DataOpentelekomcloudComputeFlavorV2#rx_tx_factor}.

---

##### `swap`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.swap"></a>

```typescript
public readonly swap: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#swap DataOpentelekomcloudComputeFlavorV2#swap}.

---

##### `vcpus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeFlavorV2Config.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#vcpus DataOpentelekomcloudComputeFlavorV2#vcpus}.

---

### DataOpentelekomcloudCsbsBackupPolicyV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupPolicyV1Config: DataOpentelekomcloudCsbsBackupPolicyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_policy_v1#id DataOpentelekomcloudCsbsBackupPolicyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_policy_v1#name DataOpentelekomcloudCsbsBackupPolicyV1#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_policy_v1#region DataOpentelekomcloudCsbsBackupPolicyV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_policy_v1#status DataOpentelekomcloudCsbsBackupPolicyV1#status}.

---

### DataOpentelekomcloudCsbsBackupPolicyV1Resource <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Resource"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1Resource } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupPolicyV1Resource: DataOpentelekomcloudCsbsBackupPolicyV1Resource = { ... }
```

### DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation: DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation = { ... }
```

### DataOpentelekomcloudCsbsBackupPolicyV1Tags <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1Tags } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupPolicyV1Tags: DataOpentelekomcloudCsbsBackupPolicyV1Tags = { ... }
```

### DataOpentelekomcloudCsbsBackupV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupV1Config: DataOpentelekomcloudCsbsBackupV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `backupName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.backupName"></a>

```typescript
public readonly backupName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#backup_name DataOpentelekomcloudCsbsBackupV1#backup_name}.

---

##### `backupRecordId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.backupRecordId"></a>

```typescript
public readonly backupRecordId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#backup_record_id DataOpentelekomcloudCsbsBackupV1#backup_record_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#id DataOpentelekomcloudCsbsBackupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `policyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#policy_id DataOpentelekomcloudCsbsBackupV1#policy_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#region DataOpentelekomcloudCsbsBackupV1#region}.

---

##### `resourceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#resource_id DataOpentelekomcloudCsbsBackupV1#resource_id}.

---

##### `resourceName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#resource_name DataOpentelekomcloudCsbsBackupV1#resource_name}.

---

##### `resourceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#resource_type DataOpentelekomcloudCsbsBackupV1#resource_type}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#status DataOpentelekomcloudCsbsBackupV1#status}.

---

##### `vmIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Config.property.vmIp"></a>

```typescript
public readonly vmIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/csbs_backup_v1#vm_ip DataOpentelekomcloudCsbsBackupV1#vm_ip}.

---

### DataOpentelekomcloudCsbsBackupV1Tags <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1Tags } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupV1Tags: DataOpentelekomcloudCsbsBackupV1Tags = { ... }
```

### DataOpentelekomcloudCsbsBackupV1VmMetadata <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadata"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VmMetadata } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupV1VmMetadata: DataOpentelekomcloudCsbsBackupV1VmMetadata = { ... }
```

### DataOpentelekomcloudCsbsBackupV1VolumeBackups <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackups"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VolumeBackups } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCsbsBackupV1VolumeBackups: DataOpentelekomcloudCsbsBackupV1VolumeBackups = { ... }
```

### DataOpentelekomcloudCssFlavorV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCssFlavorV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCssFlavorV1Config: DataOpentelekomcloudCssFlavorV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `diskRange`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.diskRange"></a>

```typescript
public readonly diskRange: DataOpentelekomcloudCssFlavorV1DiskRange;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange)

disk_range block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#disk_range DataOpentelekomcloudCssFlavorV1#disk_range}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#id DataOpentelekomcloudCssFlavorV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `minCpu`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.minCpu"></a>

```typescript
public readonly minCpu: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#min_cpu DataOpentelekomcloudCssFlavorV1#min_cpu}.

---

##### `minRam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#min_ram DataOpentelekomcloudCssFlavorV1#min_ram}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#name DataOpentelekomcloudCssFlavorV1#name}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#type DataOpentelekomcloudCssFlavorV1#type}.

---

##### `version`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1Config.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#version DataOpentelekomcloudCssFlavorV1#version}.

---

### DataOpentelekomcloudCssFlavorV1DiskRange <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCssFlavorV1DiskRange } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCssFlavorV1DiskRange: DataOpentelekomcloudCssFlavorV1DiskRange = { ... }
```

##### `minFrom`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange.property.minFrom"></a>

```typescript
public readonly minFrom: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#min_from DataOpentelekomcloudCssFlavorV1#min_from}.

---

##### `minTo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange.property.minTo"></a>

```typescript
public readonly minTo: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/css_flavor_v1#min_to DataOpentelekomcloudCssFlavorV1#min_to}.

---

### DataOpentelekomcloudCtsTrackerV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudCtsTrackerV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudCtsTrackerV1Config: DataOpentelekomcloudCtsTrackerV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucketName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#bucket_name DataOpentelekomcloudCtsTrackerV1#bucket_name}.

---

##### `filePrefixName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.filePrefixName"></a>

```typescript
public readonly filePrefixName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#file_prefix_name DataOpentelekomcloudCtsTrackerV1#file_prefix_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#id DataOpentelekomcloudCtsTrackerV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#project_name DataOpentelekomcloudCtsTrackerV1#project_name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#region DataOpentelekomcloudCtsTrackerV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#status DataOpentelekomcloudCtsTrackerV1#status}.

---

##### `trackerName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCtsTrackerV1Config.property.trackerName"></a>

```typescript
public readonly trackerName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/cts_tracker_v1#tracker_name DataOpentelekomcloudCtsTrackerV1#tracker_name}.

---

### DataOpentelekomcloudDcsAzV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsAzV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDcsAzV1Config: DataOpentelekomcloudDcsAzV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `code`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.code"></a>

```typescript
public readonly code: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1#code DataOpentelekomcloudDcsAzV1#code}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1#id DataOpentelekomcloudDcsAzV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1#name DataOpentelekomcloudDcsAzV1#name}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsAzV1Config.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_az_v1#port DataOpentelekomcloudDcsAzV1#port}.

---

### DataOpentelekomcloudDcsMaintainwindowV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsMaintainwindowV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDcsMaintainwindowV1Config: DataOpentelekomcloudDcsMaintainwindowV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `begin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.begin"></a>

```typescript
public readonly begin: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1#begin DataOpentelekomcloudDcsMaintainwindowV1#begin}.

---

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.default"></a>

```typescript
public readonly default: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1#default DataOpentelekomcloudDcsMaintainwindowV1#default}.

---

##### `end`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1#end DataOpentelekomcloudDcsMaintainwindowV1#end}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1#id DataOpentelekomcloudDcsMaintainwindowV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `seq`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsMaintainwindowV1Config.property.seq"></a>

```typescript
public readonly seq: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1#seq DataOpentelekomcloudDcsMaintainwindowV1#seq}.

---

### DataOpentelekomcloudDcsProductV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDcsProductV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDcsProductV1Config: DataOpentelekomcloudDcsProductV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1#id DataOpentelekomcloudDcsProductV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `specCode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDcsProductV1Config.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1#spec_code DataOpentelekomcloudDcsProductV1#spec_code}.

---

### DataOpentelekomcloudDdsFlavorsV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsFlavorsV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsFlavorsV3Config: DataOpentelekomcloudDdsFlavorsV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `engineName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.engineName"></a>

```typescript
public readonly engineName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#engine_name DataOpentelekomcloudDdsFlavorsV3#engine_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#id DataOpentelekomcloudDdsFlavorsV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `memory`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.memory"></a>

```typescript
public readonly memory: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#memory DataOpentelekomcloudDdsFlavorsV3#memory}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#region DataOpentelekomcloudDdsFlavorsV3#region}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#type DataOpentelekomcloudDdsFlavorsV3#type}.

---

##### `vcpus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Config.property.vcpus"></a>

```typescript
public readonly vcpus: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_flavors_v3#vcpus DataOpentelekomcloudDdsFlavorsV3#vcpus}.

---

### DataOpentelekomcloudDdsFlavorsV3Flavors <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Flavors"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsFlavorsV3Flavors } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsFlavorsV3Flavors: DataOpentelekomcloudDdsFlavorsV3Flavors = { ... }
```

### DataOpentelekomcloudDdsInstanceV3BackupStrategy <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3BackupStrategy } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsInstanceV3BackupStrategy: DataOpentelekomcloudDdsInstanceV3BackupStrategy = { ... }
```

### DataOpentelekomcloudDdsInstanceV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsInstanceV3Config: DataOpentelekomcloudDdsInstanceV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `datastoreType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.datastoreType"></a>

```typescript
public readonly datastoreType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#datastore_type DataOpentelekomcloudDdsInstanceV3#datastore_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#id DataOpentelekomcloudDdsInstanceV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `instanceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#instance_id DataOpentelekomcloudDdsInstanceV3#instance_id}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#name DataOpentelekomcloudDdsInstanceV3#name}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#subnet_id DataOpentelekomcloudDdsInstanceV3#subnet_id}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dds_instance_v3#vpc_id DataOpentelekomcloudDdsInstanceV3#vpc_id}.

---

### DataOpentelekomcloudDdsInstanceV3Datastore <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Datastore"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3Datastore } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsInstanceV3Datastore: DataOpentelekomcloudDdsInstanceV3Datastore = { ... }
```

### DataOpentelekomcloudDdsInstanceV3Nodes <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Nodes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3Nodes } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDdsInstanceV3Nodes: DataOpentelekomcloudDdsInstanceV3Nodes = { ... }
```

### DataOpentelekomcloudDehHostV1AvailableInstanceCapacities <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacities"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDehHostV1AvailableInstanceCapacities } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDehHostV1AvailableInstanceCapacities: DataOpentelekomcloudDehHostV1AvailableInstanceCapacities = { ... }
```

### DataOpentelekomcloudDehHostV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDehHostV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDehHostV1Config: DataOpentelekomcloudDehHostV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1#availability_zone DataOpentelekomcloudDehHostV1#availability_zone}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1#id DataOpentelekomcloudDehHostV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1#name DataOpentelekomcloudDehHostV1#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1#region DataOpentelekomcloudDehHostV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_host_v1#status DataOpentelekomcloudDehHostV1#status}.

---

### DataOpentelekomcloudDehServerV1Addresses <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDehServerV1Addresses } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDehServerV1Addresses: DataOpentelekomcloudDehServerV1Addresses = { ... }
```

##### `fixedIpV4`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#fixed_ip_v4 DataOpentelekomcloudDehServerV1#fixed_ip_v4}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#name DataOpentelekomcloudDehServerV1#name}.

---

### DataOpentelekomcloudDehServerV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDehServerV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDehServerV1Config: DataOpentelekomcloudDehServerV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `addresses`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.addresses"></a>

```typescript
public readonly addresses: IResolvable | DataOpentelekomcloudDehServerV1Addresses[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses)[]

addresses block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#addresses DataOpentelekomcloudDehServerV1#addresses}

---

##### `dedicatedHostId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.dedicatedHostId"></a>

```typescript
public readonly dedicatedHostId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#dedicated_host_id DataOpentelekomcloudDehServerV1#dedicated_host_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#id DataOpentelekomcloudDehServerV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#region DataOpentelekomcloudDehServerV1#region}.

---

##### `serverId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/deh_server_v1#server_id DataOpentelekomcloudDehServerV1#server_id}.

---

### DataOpentelekomcloudDmsAzV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsAzV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDmsAzV1Config: DataOpentelekomcloudDmsAzV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `code`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.code"></a>

```typescript
public readonly code: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_az_v1#code DataOpentelekomcloudDmsAzV1#code}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_az_v1#id DataOpentelekomcloudDmsAzV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_az_v1#name DataOpentelekomcloudDmsAzV1#name}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsAzV1Config.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_az_v1#port DataOpentelekomcloudDmsAzV1#port}.

---

### DataOpentelekomcloudDmsMaintainwindowV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsMaintainwindowV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDmsMaintainwindowV1Config: DataOpentelekomcloudDmsMaintainwindowV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `begin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.begin"></a>

```typescript
public readonly begin: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1#begin DataOpentelekomcloudDmsMaintainwindowV1#begin}.

---

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.default"></a>

```typescript
public readonly default: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1#default DataOpentelekomcloudDmsMaintainwindowV1#default}.

---

##### `end`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1#end DataOpentelekomcloudDmsMaintainwindowV1#end}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1#id DataOpentelekomcloudDmsMaintainwindowV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `seq`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsMaintainwindowV1Config.property.seq"></a>

```typescript
public readonly seq: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_maintainwindow_v1#seq DataOpentelekomcloudDmsMaintainwindowV1#seq}.

---

### DataOpentelekomcloudDmsProductV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDmsProductV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDmsProductV1Config: DataOpentelekomcloudDmsProductV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#engine DataOpentelekomcloudDmsProductV1#engine}.

---

##### `instanceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.instanceType"></a>

```typescript
public readonly instanceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#instance_type DataOpentelekomcloudDmsProductV1#instance_type}.

---

##### `bandwidth`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.bandwidth"></a>

```typescript
public readonly bandwidth: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#bandwidth DataOpentelekomcloudDmsProductV1#bandwidth}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#id DataOpentelekomcloudDmsProductV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ioType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.ioType"></a>

```typescript
public readonly ioType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#io_type DataOpentelekomcloudDmsProductV1#io_type}.

---

##### `nodeNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.nodeNum"></a>

```typescript
public readonly nodeNum: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#node_num DataOpentelekomcloudDmsProductV1#node_num}.

---

##### `partitionNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.partitionNum"></a>

```typescript
public readonly partitionNum: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#partition_num DataOpentelekomcloudDmsProductV1#partition_num}.

---

##### `storage`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#storage DataOpentelekomcloudDmsProductV1#storage}.

---

##### `storageSpecCode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.storageSpecCode"></a>

```typescript
public readonly storageSpecCode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#storage_spec_code DataOpentelekomcloudDmsProductV1#storage_spec_code}.

---

##### `version`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#version DataOpentelekomcloudDmsProductV1#version}.

---

##### `vmSpecification`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDmsProductV1Config.property.vmSpecification"></a>

```typescript
public readonly vmSpecification: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dms_product_v1#vm_specification DataOpentelekomcloudDmsProductV1#vm_specification}.

---

### DataOpentelekomcloudDnsNameserversV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsNameserversV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDnsNameserversV2Config: DataOpentelekomcloudDnsNameserversV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2#id DataOpentelekomcloudDnsNameserversV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `nameservers`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.nameservers"></a>

```typescript
public readonly nameservers: IResolvable | DataOpentelekomcloudDnsNameserversV2Nameservers[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers)[]

nameservers block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2#nameservers DataOpentelekomcloudDnsNameserversV2#nameservers}

---

##### `zoneId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Config.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2#zone_id DataOpentelekomcloudDnsNameserversV2#zone_id}.

---

### DataOpentelekomcloudDnsNameserversV2Nameservers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsNameserversV2Nameservers } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDnsNameserversV2Nameservers: DataOpentelekomcloudDnsNameserversV2Nameservers = { ... }
```

##### `hostname`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2#hostname DataOpentelekomcloudDnsNameserversV2#hostname}.

---

##### `priority`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_nameservers_v2#priority DataOpentelekomcloudDnsNameserversV2#priority}.

---

### DataOpentelekomcloudDnsZoneV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsZoneV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudDnsZoneV2Config: DataOpentelekomcloudDnsZoneV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#description DataOpentelekomcloudDnsZoneV2#description}.

---

##### `email`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#email DataOpentelekomcloudDnsZoneV2#email}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#id DataOpentelekomcloudDnsZoneV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#name DataOpentelekomcloudDnsZoneV2#name}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#status DataOpentelekomcloudDnsZoneV2#status}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#tags DataOpentelekomcloudDnsZoneV2#tags}.

---

##### `ttl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#ttl DataOpentelekomcloudDnsZoneV2#ttl}.

---

##### `zoneType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsZoneV2Config.property.zoneType"></a>

```typescript
public readonly zoneType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dns_zone_v2#zone_type DataOpentelekomcloudDnsZoneV2#zone_type}.

---

### DataOpentelekomcloudIdentityAgencyV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAgencyV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityAgencyV3Config: DataOpentelekomcloudIdentityAgencyV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_agency_v3#id DataOpentelekomcloudIdentityAgencyV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_agency_v3#name DataOpentelekomcloudIdentityAgencyV3#name}.

---

##### `trustDomainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAgencyV3Config.property.trustDomainId"></a>

```typescript
public readonly trustDomainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_agency_v3#trust_domain_id DataOpentelekomcloudIdentityAgencyV3#trust_domain_id}.

---

### DataOpentelekomcloudIdentityAuthScopeV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAuthScopeV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityAuthScopeV3Config: DataOpentelekomcloudIdentityAuthScopeV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_auth_scope_v3#name DataOpentelekomcloudIdentityAuthScopeV3#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_auth_scope_v3#id DataOpentelekomcloudIdentityAuthScopeV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_auth_scope_v3#region DataOpentelekomcloudIdentityAuthScopeV3#region}.

---

### DataOpentelekomcloudIdentityAuthScopeV3Roles <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Roles"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAuthScopeV3Roles } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityAuthScopeV3Roles: DataOpentelekomcloudIdentityAuthScopeV3Roles = { ... }
```

### DataOpentelekomcloudIdentityCredentialV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityCredentialV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityCredentialV3Config: DataOpentelekomcloudIdentityCredentialV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_credential_v3#id DataOpentelekomcloudIdentityCredentialV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Config.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_credential_v3#user_id DataOpentelekomcloudIdentityCredentialV3#user_id}.

---

### DataOpentelekomcloudIdentityCredentialV3Credentials <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Credentials"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityCredentialV3Credentials } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityCredentialV3Credentials: DataOpentelekomcloudIdentityCredentialV3Credentials = { ... }
```

### DataOpentelekomcloudIdentityGroupV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityGroupV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityGroupV3Config: DataOpentelekomcloudIdentityGroupV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_group_v3#name DataOpentelekomcloudIdentityGroupV3#name}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_group_v3#domain_id DataOpentelekomcloudIdentityGroupV3#domain_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_group_v3#id DataOpentelekomcloudIdentityGroupV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityGroupV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_group_v3#region DataOpentelekomcloudIdentityGroupV3#region}.

---

### DataOpentelekomcloudIdentityProjectV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityProjectV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityProjectV3Config: DataOpentelekomcloudIdentityProjectV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#domain_id DataOpentelekomcloudIdentityProjectV3#domain_id}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#enabled DataOpentelekomcloudIdentityProjectV3#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#id DataOpentelekomcloudIdentityProjectV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `isDomain`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.isDomain"></a>

```typescript
public readonly isDomain: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#is_domain DataOpentelekomcloudIdentityProjectV3#is_domain}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#name DataOpentelekomcloudIdentityProjectV3#name}.

---

##### `parentId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityProjectV3Config.property.parentId"></a>

```typescript
public readonly parentId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_project_v3#parent_id DataOpentelekomcloudIdentityProjectV3#parent_id}.

---

### DataOpentelekomcloudIdentityRoleV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityRoleV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityRoleV3Config: DataOpentelekomcloudIdentityRoleV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_role_v3#name DataOpentelekomcloudIdentityRoleV3#name}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_role_v3#domain_id DataOpentelekomcloudIdentityRoleV3#domain_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_role_v3#id DataOpentelekomcloudIdentityRoleV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityRoleV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_role_v3#region DataOpentelekomcloudIdentityRoleV3#region}.

---

### DataOpentelekomcloudIdentityUserV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityUserV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudIdentityUserV3Config: DataOpentelekomcloudIdentityUserV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3#domain_id DataOpentelekomcloudIdentityUserV3#domain_id}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3#enabled DataOpentelekomcloudIdentityUserV3#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3#id DataOpentelekomcloudIdentityUserV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3#name DataOpentelekomcloudIdentityUserV3#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityUserV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_user_v3#region DataOpentelekomcloudIdentityUserV3#region}.

---

### DataOpentelekomcloudImagesImageV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudImagesImageV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudImagesImageV2Config: DataOpentelekomcloudImagesImageV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#id DataOpentelekomcloudImagesImageV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `mostRecent`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.mostRecent"></a>

```typescript
public readonly mostRecent: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#most_recent DataOpentelekomcloudImagesImageV2#most_recent}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#name DataOpentelekomcloudImagesImageV2#name}.

---

##### `nameRegex`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.nameRegex"></a>

```typescript
public readonly nameRegex: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#name_regex DataOpentelekomcloudImagesImageV2#name_regex}.

---

##### `owner`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#owner DataOpentelekomcloudImagesImageV2#owner}.

---

##### `properties`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#properties DataOpentelekomcloudImagesImageV2#properties}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#region DataOpentelekomcloudImagesImageV2#region}.

---

##### `sizeMax`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.sizeMax"></a>

```typescript
public readonly sizeMax: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#size_max DataOpentelekomcloudImagesImageV2#size_max}.

---

##### `sizeMin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.sizeMin"></a>

```typescript
public readonly sizeMin: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#size_min DataOpentelekomcloudImagesImageV2#size_min}.

---

##### `sortDirection`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.sortDirection"></a>

```typescript
public readonly sortDirection: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#sort_direction DataOpentelekomcloudImagesImageV2#sort_direction}.

---

##### `sortKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.sortKey"></a>

```typescript
public readonly sortKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#sort_key DataOpentelekomcloudImagesImageV2#sort_key}.

---

##### `tag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#tag DataOpentelekomcloudImagesImageV2#tag}.

---

##### `visibility`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudImagesImageV2Config.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/images_image_v2#visibility DataOpentelekomcloudImagesImageV2#visibility}.

---

### DataOpentelekomcloudKmsDataKeyV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudKmsDataKeyV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudKmsDataKeyV1Config: DataOpentelekomcloudKmsDataKeyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `datakeyLength`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.datakeyLength"></a>

```typescript
public readonly datakeyLength: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_data_key_v1#datakey_length DataOpentelekomcloudKmsDataKeyV1#datakey_length}.

---

##### `keyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_data_key_v1#key_id DataOpentelekomcloudKmsDataKeyV1#key_id}.

---

##### `encryptionContext`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.encryptionContext"></a>

```typescript
public readonly encryptionContext: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_data_key_v1#encryption_context DataOpentelekomcloudKmsDataKeyV1#encryption_context}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsDataKeyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_data_key_v1#id DataOpentelekomcloudKmsDataKeyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudKmsKeyV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudKmsKeyV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudKmsKeyV1Config: DataOpentelekomcloudKmsKeyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `defaultKeyFlag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.defaultKeyFlag"></a>

```typescript
public readonly defaultKeyFlag: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#default_key_flag DataOpentelekomcloudKmsKeyV1#default_key_flag}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#domain_id DataOpentelekomcloudKmsKeyV1#domain_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#id DataOpentelekomcloudKmsKeyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `keyAlias`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.keyAlias"></a>

```typescript
public readonly keyAlias: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#key_alias DataOpentelekomcloudKmsKeyV1#key_alias}.

---

##### `keyDescription`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.keyDescription"></a>

```typescript
public readonly keyDescription: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#key_description DataOpentelekomcloudKmsKeyV1#key_description}.

---

##### `keyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#key_id DataOpentelekomcloudKmsKeyV1#key_id}.

---

##### `keyState`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.keyState"></a>

```typescript
public readonly keyState: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#key_state DataOpentelekomcloudKmsKeyV1#key_state}.

---

##### `origin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.origin"></a>

```typescript
public readonly origin: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#origin DataOpentelekomcloudKmsKeyV1#origin}.

---

##### `realm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudKmsKeyV1Config.property.realm"></a>

```typescript
public readonly realm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/kms_key_v1#realm DataOpentelekomcloudKmsKeyV1#realm}.

---

### DataOpentelekomcloudLbCertificateV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbCertificateV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbCertificateV3Config: DataOpentelekomcloudLbCertificateV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `domain`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_certificate_v3#domain DataOpentelekomcloudLbCertificateV3#domain}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_certificate_v3#id DataOpentelekomcloudLbCertificateV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_certificate_v3#name DataOpentelekomcloudLbCertificateV3#name}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbCertificateV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_certificate_v3#type DataOpentelekomcloudLbCertificateV3#type}.

---

### DataOpentelekomcloudLbFlavorV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbFlavorV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbFlavorV3Config: DataOpentelekomcloudLbFlavorV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3#id DataOpentelekomcloudLbFlavorV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbFlavorV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_flavor_v3#name DataOpentelekomcloudLbFlavorV3#name}.

---

### DataOpentelekomcloudLbListenerV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbListenerV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbListenerV3Config: DataOpentelekomcloudLbListenerV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clientCaTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#client_ca_tls_container_ref DataOpentelekomcloudLbListenerV3#client_ca_tls_container_ref}.

---

##### `clientTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.clientTimeout"></a>

```typescript
public readonly clientTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#client_timeout DataOpentelekomcloudLbListenerV3#client_timeout}.

---

##### `defaultPoolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#default_pool_id DataOpentelekomcloudLbListenerV3#default_pool_id}.

---

##### `defaultTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#default_tls_container_ref DataOpentelekomcloudLbListenerV3#default_tls_container_ref}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#description DataOpentelekomcloudLbListenerV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#id DataOpentelekomcloudLbListenerV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `keepAliveTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#keep_alive_timeout DataOpentelekomcloudLbListenerV3#keep_alive_timeout}.

---

##### `loadbalancerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#loadbalancer_id DataOpentelekomcloudLbListenerV3#loadbalancer_id}.

---

##### `memberAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.memberAddress"></a>

```typescript
public readonly memberAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#member_address DataOpentelekomcloudLbListenerV3#member_address}.

---

##### `memberDeviceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.memberDeviceId"></a>

```typescript
public readonly memberDeviceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#member_device_id DataOpentelekomcloudLbListenerV3#member_device_id}.

---

##### `memberTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.memberTimeout"></a>

```typescript
public readonly memberTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#member_timeout DataOpentelekomcloudLbListenerV3#member_timeout}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#name DataOpentelekomcloudLbListenerV3#name}.

---

##### `protocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#protocol DataOpentelekomcloudLbListenerV3#protocol}.

---

##### `protocolPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#protocol_port DataOpentelekomcloudLbListenerV3#protocol_port}.

---

##### `tlsCiphersPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3Config.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_listener_v3#tls_ciphers_policy DataOpentelekomcloudLbListenerV3#tls_ciphers_policy}.

---

### DataOpentelekomcloudLbListenerV3InsertHeaders <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeaders"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbListenerV3InsertHeaders } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbListenerV3InsertHeaders: DataOpentelekomcloudLbListenerV3InsertHeaders = { ... }
```

### DataOpentelekomcloudLbLoadbalancerV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbLoadbalancerV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbLoadbalancerV3Config: DataOpentelekomcloudLbLoadbalancerV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#id DataOpentelekomcloudLbLoadbalancerV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `l4Flavor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.l4Flavor"></a>

```typescript
public readonly l4Flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#l4_flavor DataOpentelekomcloudLbLoadbalancerV3#l4_flavor}.

---

##### `l7Flavor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.l7Flavor"></a>

```typescript
public readonly l7Flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#l7_flavor DataOpentelekomcloudLbLoadbalancerV3#l7_flavor}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#name DataOpentelekomcloudLbLoadbalancerV3#name}.

---

##### `routerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#router_id DataOpentelekomcloudLbLoadbalancerV3#router_id}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#subnet_id DataOpentelekomcloudLbLoadbalancerV3#subnet_id}.

---

##### `vipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#vip_address DataOpentelekomcloudLbLoadbalancerV3#vip_address}.

---

##### `vipPortId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3Config.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#vip_port_id DataOpentelekomcloudLbLoadbalancerV3#vip_port_id}.

---

### DataOpentelekomcloudLbLoadbalancerV3PublicIp <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIp"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbLoadbalancerV3PublicIp } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbLoadbalancerV3PublicIp: DataOpentelekomcloudLbLoadbalancerV3PublicIp = { ... }
```

### DataOpentelekomcloudLbMemberIdsV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudLbMemberIdsV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudLbMemberIdsV2Config: DataOpentelekomcloudLbMemberIdsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#pool_id DataOpentelekomcloudLbMemberIdsV2#pool_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#id DataOpentelekomcloudLbMemberIdsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbMemberIdsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#region DataOpentelekomcloudLbMemberIdsV2#region}.

---

### DataOpentelekomcloudNetworkingNetworkV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingNetworkV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudNetworkingNetworkV2Config: DataOpentelekomcloudNetworkingNetworkV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#id DataOpentelekomcloudNetworkingNetworkV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `matchingSubnetCidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.matchingSubnetCidr"></a>

```typescript
public readonly matchingSubnetCidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#matching_subnet_cidr DataOpentelekomcloudNetworkingNetworkV2#matching_subnet_cidr}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#name DataOpentelekomcloudNetworkingNetworkV2#name}.

---

##### `networkId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#network_id DataOpentelekomcloudNetworkingNetworkV2#network_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#region DataOpentelekomcloudNetworkingNetworkV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingNetworkV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

The ID of the Tenant (Identity v2) or Project (Identity v3) to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_network_v2#tenant_id DataOpentelekomcloudNetworkingNetworkV2#tenant_id}

---

### DataOpentelekomcloudNetworkingPortV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingPortV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudNetworkingPortV2Config: DataOpentelekomcloudNetworkingPortV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#admin_state_up DataOpentelekomcloudNetworkingPortV2#admin_state_up}.

---

##### `deviceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#device_id DataOpentelekomcloudNetworkingPortV2#device_id}.

---

##### `deviceOwner`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.deviceOwner"></a>

```typescript
public readonly deviceOwner: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#device_owner DataOpentelekomcloudNetworkingPortV2#device_owner}.

---

##### `fixedIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#fixed_ip DataOpentelekomcloudNetworkingPortV2#fixed_ip}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#id DataOpentelekomcloudNetworkingPortV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `macAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#mac_address DataOpentelekomcloudNetworkingPortV2#mac_address}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#name DataOpentelekomcloudNetworkingPortV2#name}.

---

##### `networkId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#network_id DataOpentelekomcloudNetworkingPortV2#network_id}.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#port_id DataOpentelekomcloudNetworkingPortV2#port_id}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#project_id DataOpentelekomcloudNetworkingPortV2#project_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#region DataOpentelekomcloudNetworkingPortV2#region}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#security_group_ids DataOpentelekomcloudNetworkingPortV2#security_group_ids}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#status DataOpentelekomcloudNetworkingPortV2#status}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingPortV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_port_v2#tenant_id DataOpentelekomcloudNetworkingPortV2#tenant_id}.

---

### DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config: DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_rule_ids_v2#security_group_id DataOpentelekomcloudNetworkingSecgroupRuleIdsV2#security_group_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_rule_ids_v2#id DataOpentelekomcloudNetworkingSecgroupRuleIdsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupRuleIdsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_rule_ids_v2#region DataOpentelekomcloudNetworkingSecgroupRuleIdsV2#region}.

---

### DataOpentelekomcloudNetworkingSecgroupV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudNetworkingSecgroupV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudNetworkingSecgroupV2Config: DataOpentelekomcloudNetworkingSecgroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2#id DataOpentelekomcloudNetworkingSecgroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2#name DataOpentelekomcloudNetworkingSecgroupV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2#region DataOpentelekomcloudNetworkingSecgroupV2#region}.

---

##### `secgroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.secgroupId"></a>

```typescript
public readonly secgroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2#secgroup_id DataOpentelekomcloudNetworkingSecgroupV2#secgroup_id}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudNetworkingSecgroupV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/networking_secgroup_v2#tenant_id DataOpentelekomcloudNetworkingSecgroupV2#tenant_id}.

---

### DataOpentelekomcloudObsBucketConfig <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketConfig } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketConfig: DataOpentelekomcloudObsBucketConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket#bucket DataOpentelekomcloudObsBucket#bucket}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket#id DataOpentelekomcloudObsBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudObsBucketCorsRule <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketCorsRule } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketCorsRule: DataOpentelekomcloudObsBucketCorsRule = { ... }
```

### DataOpentelekomcloudObsBucketEventNotifications <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotifications"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotifications } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketEventNotifications: DataOpentelekomcloudObsBucketEventNotifications = { ... }
```

### DataOpentelekomcloudObsBucketEventNotificationsFilterRule <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotificationsFilterRule } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketEventNotificationsFilterRule: DataOpentelekomcloudObsBucketEventNotificationsFilterRule = { ... }
```

### DataOpentelekomcloudObsBucketLifecycleRule <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRule } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLifecycleRule: DataOpentelekomcloudObsBucketLifecycleRule = { ... }
```

### DataOpentelekomcloudObsBucketLifecycleRuleExpiration <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleExpiration } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLifecycleRuleExpiration: DataOpentelekomcloudObsBucketLifecycleRuleExpiration = { ... }
```

### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration = { ... }
```

### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition = { ... }
```

### DataOpentelekomcloudObsBucketLifecycleRuleTransition <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleTransition } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLifecycleRuleTransition: DataOpentelekomcloudObsBucketLifecycleRuleTransition = { ... }
```

### DataOpentelekomcloudObsBucketLogging <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLogging"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLogging } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketLogging: DataOpentelekomcloudObsBucketLogging = { ... }
```

### DataOpentelekomcloudObsBucketObjectConfig <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketObjectConfig } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketObjectConfig: DataOpentelekomcloudObsBucketObjectConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket_object#bucket DataOpentelekomcloudObsBucketObject#bucket}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket_object#key DataOpentelekomcloudObsBucketObject#key}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket_object#id DataOpentelekomcloudObsBucketObject#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `versionId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketObjectConfig.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/obs_bucket_object#version_id DataOpentelekomcloudObsBucketObject#version_id}.

---

### DataOpentelekomcloudObsBucketServerSideEncryption <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryption"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketServerSideEncryption } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketServerSideEncryption: DataOpentelekomcloudObsBucketServerSideEncryption = { ... }
```

### DataOpentelekomcloudObsBucketWebsite <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsite"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketWebsite } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudObsBucketWebsite: DataOpentelekomcloudObsBucketWebsite = { ... }
```

### DataOpentelekomcloudRdsBackupV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsBackupV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsBackupV3Config: DataOpentelekomcloudRdsBackupV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_backup_v3#instance_id DataOpentelekomcloudRdsBackupV3#instance_id}.

---

##### `backupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_backup_v3#backup_id DataOpentelekomcloudRdsBackupV3#backup_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_backup_v3#id DataOpentelekomcloudRdsBackupV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsBackupV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_backup_v3#type DataOpentelekomcloudRdsBackupV3#type}.

---

### DataOpentelekomcloudRdsFlavorsV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsFlavorsV1Config: DataOpentelekomcloudRdsFlavorsV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `datastoreName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.datastoreName"></a>

```typescript
public readonly datastoreName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1#datastore_name DataOpentelekomcloudRdsFlavorsV1#datastore_name}.

---

##### `datastoreVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.datastoreVersion"></a>

```typescript
public readonly datastoreVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1#datastore_version DataOpentelekomcloudRdsFlavorsV1#datastore_version}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1#id DataOpentelekomcloudRdsFlavorsV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1#region DataOpentelekomcloudRdsFlavorsV1#region}.

---

##### `speccode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV1Config.property.speccode"></a>

```typescript
public readonly speccode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v1#speccode DataOpentelekomcloudRdsFlavorsV1#speccode}.

---

### DataOpentelekomcloudRdsFlavorsV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsFlavorsV3Config: DataOpentelekomcloudRdsFlavorsV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `dbType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.dbType"></a>

```typescript
public readonly dbType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#db_type DataOpentelekomcloudRdsFlavorsV3#db_type}.

---

##### `dbVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.dbVersion"></a>

```typescript
public readonly dbVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#db_version DataOpentelekomcloudRdsFlavorsV3#db_version}.

---

##### `instanceMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.instanceMode"></a>

```typescript
public readonly instanceMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#instance_mode DataOpentelekomcloudRdsFlavorsV3#instance_mode}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_flavors_v3#id DataOpentelekomcloudRdsFlavorsV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudRdsFlavorsV3Flavors <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Flavors"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV3Flavors } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsFlavorsV3Flavors: DataOpentelekomcloudRdsFlavorsV3Flavors = { ... }
```

### DataOpentelekomcloudRdsInstanceV3BackupStrategy <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3BackupStrategy } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsInstanceV3BackupStrategy: DataOpentelekomcloudRdsInstanceV3BackupStrategy = { ... }
```

### DataOpentelekomcloudRdsInstanceV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsInstanceV3Config: DataOpentelekomcloudRdsInstanceV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `datastoreType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.datastoreType"></a>

```typescript
public readonly datastoreType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#datastore_type DataOpentelekomcloudRdsInstanceV3#datastore_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#id DataOpentelekomcloudRdsInstanceV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#name DataOpentelekomcloudRdsInstanceV3#name}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#port DataOpentelekomcloudRdsInstanceV3#port}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#region DataOpentelekomcloudRdsInstanceV3#region}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#subnet_id DataOpentelekomcloudRdsInstanceV3#subnet_id}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#type DataOpentelekomcloudRdsInstanceV3#type}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_instance_v3#vpc_id DataOpentelekomcloudRdsInstanceV3#vpc_id}.

---

### DataOpentelekomcloudRdsInstanceV3Nodes <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Nodes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3Nodes } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsInstanceV3Nodes: DataOpentelekomcloudRdsInstanceV3Nodes = { ... }
```

### DataOpentelekomcloudRdsVersionsV3Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsVersionsV3Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRdsVersionsV3Config: DataOpentelekomcloudRdsVersionsV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `databaseName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_versions_v3#database_name DataOpentelekomcloudRdsVersionsV3#database_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsVersionsV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rds_versions_v3#id DataOpentelekomcloudRdsVersionsV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudRtsSoftwareConfigV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsSoftwareConfigV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRtsSoftwareConfigV1Config: DataOpentelekomcloudRtsSoftwareConfigV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_config_v1#id DataOpentelekomcloudRtsSoftwareConfigV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_config_v1#name DataOpentelekomcloudRtsSoftwareConfigV1#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareConfigV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_config_v1#region DataOpentelekomcloudRtsSoftwareConfigV1#region}.

---

### DataOpentelekomcloudRtsSoftwareDeploymentV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsSoftwareDeploymentV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRtsSoftwareDeploymentV1Config: DataOpentelekomcloudRtsSoftwareDeploymentV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `action`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#action DataOpentelekomcloudRtsSoftwareDeploymentV1#action}.

---

##### `configId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.configId"></a>

```typescript
public readonly configId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#config_id DataOpentelekomcloudRtsSoftwareDeploymentV1#config_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#id DataOpentelekomcloudRtsSoftwareDeploymentV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#region DataOpentelekomcloudRtsSoftwareDeploymentV1#region}.

---

##### `serverId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#server_id DataOpentelekomcloudRtsSoftwareDeploymentV1#server_id}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsSoftwareDeploymentV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_software_deployment_v1#status DataOpentelekomcloudRtsSoftwareDeploymentV1#status}.

---

### DataOpentelekomcloudRtsStackResourceV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsStackResourceV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRtsStackResourceV1Config: DataOpentelekomcloudRtsStackResourceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `stackName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.stackName"></a>

```typescript
public readonly stackName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#stack_name DataOpentelekomcloudRtsStackResourceV1#stack_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#id DataOpentelekomcloudRtsStackResourceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `physicalResourceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.physicalResourceId"></a>

```typescript
public readonly physicalResourceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#physical_resource_id DataOpentelekomcloudRtsStackResourceV1#physical_resource_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#region DataOpentelekomcloudRtsStackResourceV1#region}.

---

##### `resourceName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#resource_name DataOpentelekomcloudRtsStackResourceV1#resource_name}.

---

##### `resourceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackResourceV1Config.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_resource_v1#resource_type DataOpentelekomcloudRtsStackResourceV1#resource_type}.

---

### DataOpentelekomcloudRtsStackV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudRtsStackV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudRtsStackV1Config: DataOpentelekomcloudRtsStackV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_v1#name DataOpentelekomcloudRtsStackV1#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_v1#id DataOpentelekomcloudRtsStackV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRtsStackV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/rts_stack_v1#region DataOpentelekomcloudRtsStackV1#region}.

---

### DataOpentelekomcloudS3BucketObjectConfig <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudS3BucketObjectConfig } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudS3BucketObjectConfig: DataOpentelekomcloudS3BucketObjectConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object#bucket DataOpentelekomcloudS3BucketObject#bucket}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object#key DataOpentelekomcloudS3BucketObject#key}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object#id DataOpentelekomcloudS3BucketObject#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `range`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.range"></a>

```typescript
public readonly range: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object#range DataOpentelekomcloudS3BucketObject#range}.

---

##### `versionId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudS3BucketObjectConfig.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/s3_bucket_object#version_id DataOpentelekomcloudS3BucketObject#version_id}.

---

### DataOpentelekomcloudSdrsDomainV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudSdrsDomainV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudSdrsDomainV1Config: DataOpentelekomcloudSdrsDomainV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sdrs_domain_v1#id DataOpentelekomcloudSdrsDomainV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSdrsDomainV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sdrs_domain_v1#name DataOpentelekomcloudSdrsDomainV1#name}.

---

### DataOpentelekomcloudSfsFileSystemV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudSfsFileSystemV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudSfsFileSystemV2Config: DataOpentelekomcloudSfsFileSystemV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_file_system_v2#id DataOpentelekomcloudSfsFileSystemV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_file_system_v2#name DataOpentelekomcloudSfsFileSystemV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_file_system_v2#region DataOpentelekomcloudSfsFileSystemV2#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsFileSystemV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_file_system_v2#status DataOpentelekomcloudSfsFileSystemV2#status}.

---

### DataOpentelekomcloudSfsTurboShareV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudSfsTurboShareV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudSfsTurboShareV1Config: DataOpentelekomcloudSfsTurboShareV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1#name DataOpentelekomcloudSfsTurboShareV1#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudSfsTurboShareV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/sfs_turbo_share_v1#id DataOpentelekomcloudSfsTurboShareV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataOpentelekomcloudVbsBackupPolicyV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVbsBackupPolicyV2Config: DataOpentelekomcloudVbsBackupPolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `filterTags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.filterTags"></a>

```typescript
public readonly filterTags: IResolvable | DataOpentelekomcloudVbsBackupPolicyV2FilterTags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags)[]

filter_tags block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#filter_tags DataOpentelekomcloudVbsBackupPolicyV2#filter_tags}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#id DataOpentelekomcloudVbsBackupPolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#name DataOpentelekomcloudVbsBackupPolicyV2#name}.

---

##### `policyResourceCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.policyResourceCount"></a>

```typescript
public readonly policyResourceCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#policy_resource_count DataOpentelekomcloudVbsBackupPolicyV2#policy_resource_count}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#region DataOpentelekomcloudVbsBackupPolicyV2#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#status DataOpentelekomcloudVbsBackupPolicyV2#status}.

---

### DataOpentelekomcloudVbsBackupPolicyV2FilterTags <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2FilterTags } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVbsBackupPolicyV2FilterTags: DataOpentelekomcloudVbsBackupPolicyV2FilterTags = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#key DataOpentelekomcloudVbsBackupPolicyV2#key}.

---

##### `values`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_policy_v2#values DataOpentelekomcloudVbsBackupPolicyV2#values}.

---

### DataOpentelekomcloudVbsBackupPolicyV2Tags <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2Tags } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVbsBackupPolicyV2Tags: DataOpentelekomcloudVbsBackupPolicyV2Tags = { ... }
```

### DataOpentelekomcloudVbsBackupV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVbsBackupV2Config: DataOpentelekomcloudVbsBackupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#id DataOpentelekomcloudVbsBackupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#name DataOpentelekomcloudVbsBackupV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#region DataOpentelekomcloudVbsBackupV2#region}.

---

##### `snapshotId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#snapshot_id DataOpentelekomcloudVbsBackupV2#snapshot_id}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#status DataOpentelekomcloudVbsBackupV2#status}.

---

##### `volumeId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupV2Config.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vbs_backup_v2#volume_id DataOpentelekomcloudVbsBackupV2#volume_id}.

---

### DataOpentelekomcloudVpcBandwidthConfig <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcBandwidthConfig } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcBandwidthConfig: DataOpentelekomcloudVpcBandwidthConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth#name DataOpentelekomcloudVpcBandwidth#name}.

---

##### `enterpriseProjectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.enterpriseProjectId"></a>

```typescript
public readonly enterpriseProjectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth#enterprise_project_id DataOpentelekomcloudVpcBandwidth#enterprise_project_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth#id DataOpentelekomcloudVpcBandwidth#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth#region DataOpentelekomcloudVpcBandwidth#region}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthConfig.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth#size DataOpentelekomcloudVpcBandwidth#size}.

---

### DataOpentelekomcloudVpcBandwidthV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcBandwidthV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcBandwidthV2Config: DataOpentelekomcloudVpcBandwidthV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth_v2#id DataOpentelekomcloudVpcBandwidthV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth_v2#name DataOpentelekomcloudVpcBandwidthV2#name}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcBandwidthV2Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_bandwidth_v2#size DataOpentelekomcloudVpcBandwidthV2#size}.

---

### DataOpentelekomcloudVpcEipV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcEipV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcEipV1Config: DataOpentelekomcloudVpcEipV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bandwidthId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.bandwidthId"></a>

```typescript
public readonly bandwidthId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#bandwidth_id DataOpentelekomcloudVpcEipV1#bandwidth_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#id DataOpentelekomcloudVpcEipV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#port_id DataOpentelekomcloudVpcEipV1#port_id}.

---

##### `privateIpAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.privateIpAddress"></a>

```typescript
public readonly privateIpAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#private_ip_address DataOpentelekomcloudVpcEipV1#private_ip_address}.

---

##### `publicIpAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.publicIpAddress"></a>

```typescript
public readonly publicIpAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#public_ip_address DataOpentelekomcloudVpcEipV1#public_ip_address}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#region DataOpentelekomcloudVpcEipV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#status DataOpentelekomcloudVpcEipV1#status}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcEipV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_eip_v1#tags DataOpentelekomcloudVpcEipV1#tags}.

---

### DataOpentelekomcloudVpcepPublicServiceV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepPublicServiceV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcepPublicServiceV1Config: DataOpentelekomcloudVpcepPublicServiceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_public_service_v1#id DataOpentelekomcloudVpcepPublicServiceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepPublicServiceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_public_service_v1#name DataOpentelekomcloudVpcepPublicServiceV1#name}.

---

### DataOpentelekomcloudVpcepServiceV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepServiceV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcepServiceV1Config: DataOpentelekomcloudVpcepServiceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_service_v1#id DataOpentelekomcloudVpcepServiceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_service_v1#name DataOpentelekomcloudVpcepServiceV1#name}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_service_v1#status DataOpentelekomcloudVpcepServiceV1#status}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpcep_service_v1#tags DataOpentelekomcloudVpcepServiceV1#tags}.

---

### DataOpentelekomcloudVpcepServiceV1Port <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Port"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepServiceV1Port } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcepServiceV1Port: DataOpentelekomcloudVpcepServiceV1Port = { ... }
```

### DataOpentelekomcloudVpcPeeringConnectionV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcPeeringConnectionV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcPeeringConnectionV2Config: DataOpentelekomcloudVpcPeeringConnectionV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#id DataOpentelekomcloudVpcPeeringConnectionV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#name DataOpentelekomcloudVpcPeeringConnectionV2#name}.

---

##### `peerTenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.peerTenantId"></a>

```typescript
public readonly peerTenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#peer_tenant_id DataOpentelekomcloudVpcPeeringConnectionV2#peer_tenant_id}.

---

##### `peerVpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.peerVpcId"></a>

```typescript
public readonly peerVpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#peer_vpc_id DataOpentelekomcloudVpcPeeringConnectionV2#peer_vpc_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#region DataOpentelekomcloudVpcPeeringConnectionV2#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#status DataOpentelekomcloudVpcPeeringConnectionV2#status}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcPeeringConnectionV2Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_peering_connection_v2#vpc_id DataOpentelekomcloudVpcPeeringConnectionV2#vpc_id}.

---

### DataOpentelekomcloudVpcRouteIdsV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcRouteIdsV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcRouteIdsV2Config: DataOpentelekomcloudVpcRouteIdsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_ids_v2#vpc_id DataOpentelekomcloudVpcRouteIdsV2#vpc_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_ids_v2#id DataOpentelekomcloudVpcRouteIdsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteIdsV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_ids_v2#region DataOpentelekomcloudVpcRouteIdsV2#region}.

---

### DataOpentelekomcloudVpcRouteV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcRouteV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcRouteV2Config: DataOpentelekomcloudVpcRouteV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `destination`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.destination"></a>

```typescript
public readonly destination: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#destination DataOpentelekomcloudVpcRouteV2#destination}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#id DataOpentelekomcloudVpcRouteV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `nexthop`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.nexthop"></a>

```typescript
public readonly nexthop: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#nexthop DataOpentelekomcloudVpcRouteV2#nexthop}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#region DataOpentelekomcloudVpcRouteV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#tenant_id DataOpentelekomcloudVpcRouteV2#tenant_id}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#type DataOpentelekomcloudVpcRouteV2#type}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcRouteV2Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_route_v2#vpc_id DataOpentelekomcloudVpcRouteV2#vpc_id}.

---

### DataOpentelekomcloudVpcSubnetIdsV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcSubnetIdsV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcSubnetIdsV1Config: DataOpentelekomcloudVpcSubnetIdsV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_ids_v1#vpc_id DataOpentelekomcloudVpcSubnetIdsV1#vpc_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_ids_v1#id DataOpentelekomcloudVpcSubnetIdsV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetIdsV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_ids_v1#region DataOpentelekomcloudVpcSubnetIdsV1#region}.

---

### DataOpentelekomcloudVpcSubnetV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcSubnetV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcSubnetV1Config: DataOpentelekomcloudVpcSubnetV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#availability_zone DataOpentelekomcloudVpcSubnetV1#availability_zone}.

---

##### `cidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#cidr DataOpentelekomcloudVpcSubnetV1#cidr}.

---

##### `gatewayIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#gateway_ip DataOpentelekomcloudVpcSubnetV1#gateway_ip}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#id DataOpentelekomcloudVpcSubnetV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#name DataOpentelekomcloudVpcSubnetV1#name}.

---

##### `primaryDns`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.primaryDns"></a>

```typescript
public readonly primaryDns: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#primary_dns DataOpentelekomcloudVpcSubnetV1#primary_dns}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#region DataOpentelekomcloudVpcSubnetV1#region}.

---

##### `secondaryDns`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.secondaryDns"></a>

```typescript
public readonly secondaryDns: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#secondary_dns DataOpentelekomcloudVpcSubnetV1#secondary_dns}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#status DataOpentelekomcloudVpcSubnetV1#status}.

---

##### `vpcId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcSubnetV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_subnet_v1#vpc_id DataOpentelekomcloudVpcSubnetV1#vpc_id}.

---

### DataOpentelekomcloudVpcV1Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcV1Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcV1Config: DataOpentelekomcloudVpcV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `cidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#cidr DataOpentelekomcloudVpcV1#cidr}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#id DataOpentelekomcloudVpcV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#name DataOpentelekomcloudVpcV1#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#region DataOpentelekomcloudVpcV1#region}.

---

##### `shared`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#shared DataOpentelekomcloudVpcV1#shared}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpc_v1#status DataOpentelekomcloudVpcV1#status}.

---

### DataOpentelekomcloudVpcV1Routes <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Routes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcV1Routes } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpcV1Routes: DataOpentelekomcloudVpcV1Routes = { ... }
```

### DataOpentelekomcloudVpnaasServiceV2Config <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DataOpentelekomcloudVpnaasServiceV2Config } from '@cdktf/provider-opentelekomcloud'

const dataOpentelekomcloudVpnaasServiceV2Config: DataOpentelekomcloudVpnaasServiceV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#admin_state_up DataOpentelekomcloudVpnaasServiceV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#description DataOpentelekomcloudVpnaasServiceV2#description}.

---

##### `externalV4Ip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.externalV4Ip"></a>

```typescript
public readonly externalV4Ip: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#external_v4_ip DataOpentelekomcloudVpnaasServiceV2#external_v4_ip}.

---

##### `externalV6Ip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.externalV6Ip"></a>

```typescript
public readonly externalV6Ip: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#external_v6_ip DataOpentelekomcloudVpnaasServiceV2#external_v6_ip}.

---

##### `flavorId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.flavorId"></a>

```typescript
public readonly flavorId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#flavor_id DataOpentelekomcloudVpnaasServiceV2#flavor_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#id DataOpentelekomcloudVpnaasServiceV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#name DataOpentelekomcloudVpnaasServiceV2#name}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#project_id DataOpentelekomcloudVpnaasServiceV2#project_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#region DataOpentelekomcloudVpnaasServiceV2#region}.

---

##### `routerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#router_id DataOpentelekomcloudVpnaasServiceV2#router_id}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#status DataOpentelekomcloudVpnaasServiceV2#status}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#subnet_id DataOpentelekomcloudVpnaasServiceV2#subnet_id}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpnaasServiceV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/vpnaas_service_v2#tenant_id DataOpentelekomcloudVpnaasServiceV2#tenant_id}.

---

### DcsInstanceV1BackupPolicy <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DcsInstanceV1BackupPolicy } from '@cdktf/provider-opentelekomcloud'

const dcsInstanceV1BackupPolicy: DcsInstanceV1BackupPolicy = { ... }
```

##### `backupAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy.property.backupAt"></a>

```typescript
public readonly backupAt: number[];
```

- *Type:* `number`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_at DcsInstanceV1#backup_at}.

---

##### `beginAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy.property.beginAt"></a>

```typescript
public readonly beginAt: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#begin_at DcsInstanceV1#begin_at}.

---

##### `periodType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#period_type DcsInstanceV1#period_type}.

---

##### `backupType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy.property.backupType"></a>

```typescript
public readonly backupType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_type DcsInstanceV1#backup_type}.

---

##### `saveDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy.property.saveDays"></a>

```typescript
public readonly saveDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#save_days DcsInstanceV1#save_days}.

---

### DcsInstanceV1Config <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DcsInstanceV1Config } from '@cdktf/provider-opentelekomcloud'

const dcsInstanceV1Config: DcsInstanceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availableZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#available_zones DcsInstanceV1#available_zones}.

---

##### `capacity`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.capacity"></a>

```typescript
public readonly capacity: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#capacity DcsInstanceV1#capacity}.

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#engine DcsInstanceV1#engine}.

---

##### `engineVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.engineVersion"></a>

```typescript
public readonly engineVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#engine_version DcsInstanceV1#engine_version}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#name DcsInstanceV1#name}.

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#password DcsInstanceV1#password}.

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#product_id DcsInstanceV1#product_id}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#security_group_id DcsInstanceV1#security_group_id}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#subnet_id DcsInstanceV1#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#vpc_id DcsInstanceV1#vpc_id}.

---

##### `accessUser`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.accessUser"></a>

```typescript
public readonly accessUser: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#access_user DcsInstanceV1#access_user}.

---

##### `backupAt`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.backupAt"></a>

```typescript
public readonly backupAt: number[];
```

- *Type:* `number`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_at DcsInstanceV1#backup_at}.

---

##### `backupPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.backupPolicy"></a>

```typescript
public readonly backupPolicy: DcsInstanceV1BackupPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy)

backup_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_policy DcsInstanceV1#backup_policy}

---

##### `backupType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.backupType"></a>

```typescript
public readonly backupType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_type DcsInstanceV1#backup_type}.

---

##### `beginAt`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.beginAt"></a>

```typescript
public readonly beginAt: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#begin_at DcsInstanceV1#begin_at}.

---

##### `configuration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.configuration"></a>

```typescript
public readonly configuration: IResolvable | DcsInstanceV1Configuration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration)[]

configuration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#configuration DcsInstanceV1#configuration}

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#description DcsInstanceV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#id DcsInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `maintainBegin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.maintainBegin"></a>

```typescript
public readonly maintainBegin: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#maintain_begin DcsInstanceV1#maintain_begin}.

---

##### `maintainEnd`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.maintainEnd"></a>

```typescript
public readonly maintainEnd: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#maintain_end DcsInstanceV1#maintain_end}.

---

##### `periodType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#period_type DcsInstanceV1#period_type}.

---

##### `saveDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.saveDays"></a>

```typescript
public readonly saveDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#save_days DcsInstanceV1#save_days}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: DcsInstanceV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#timeouts DcsInstanceV1#timeouts}

---

### DcsInstanceV1Configuration <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DcsInstanceV1Configuration } from '@cdktf/provider-opentelekomcloud'

const dcsInstanceV1Configuration: DcsInstanceV1Configuration = { ... }
```

##### `parameterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration.property.parameterId"></a>

```typescript
public readonly parameterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_id DcsInstanceV1#parameter_id}.

---

##### `parameterName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration.property.parameterName"></a>

```typescript
public readonly parameterName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_name DcsInstanceV1#parameter_name}.

---

##### `parameterValue`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration.property.parameterValue"></a>

```typescript
public readonly parameterValue: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_value DcsInstanceV1#parameter_value}.

---

### DcsInstanceV1Timeouts <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DcsInstanceV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const dcsInstanceV1Timeouts: DcsInstanceV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#create DcsInstanceV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#delete DcsInstanceV1#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#update DcsInstanceV1#update}.

---

### DdsInstanceV3BackupStrategy <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3BackupStrategy } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3BackupStrategy: DdsInstanceV3BackupStrategy = { ... }
```

##### `keepDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#keep_days DdsInstanceV3#keep_days}.

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#start_time DdsInstanceV3#start_time}.

---

### DdsInstanceV3Config <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3Config } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3Config: DdsInstanceV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#availability_zone DdsInstanceV3#availability_zone}.

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.datastore"></a>

```typescript
public readonly datastore: DdsInstanceV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore)

datastore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#datastore DdsInstanceV3#datastore}

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.flavor"></a>

```typescript
public readonly flavor: IResolvable | DdsInstanceV3Flavor[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor)[]

flavor block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#flavor DdsInstanceV3#flavor}

---

##### `mode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#mode DdsInstanceV3#mode}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#name DdsInstanceV3#name}.

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#password DdsInstanceV3#password}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#security_group_id DdsInstanceV3#security_group_id}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#subnet_id DdsInstanceV3#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#vpc_id DdsInstanceV3#vpc_id}.

---

##### `backupStrategy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: DdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy)

backup_strategy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#backup_strategy DdsInstanceV3#backup_strategy}

---

##### `diskEncryptionId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#disk_encryption_id DdsInstanceV3#disk_encryption_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#id DdsInstanceV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#region DdsInstanceV3#region}.

---

##### `ssl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.ssl"></a>

```typescript
public readonly ssl: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#ssl DdsInstanceV3#ssl}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: DdsInstanceV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#timeouts DdsInstanceV3#timeouts}

---

### DdsInstanceV3Datastore <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3Datastore } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3Datastore: DdsInstanceV3Datastore = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#type DdsInstanceV3#type}.

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#version DdsInstanceV3#version}.

---

##### `storageEngine`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore.property.storageEngine"></a>

```typescript
public readonly storageEngine: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#storage_engine DdsInstanceV3#storage_engine}.

---

### DdsInstanceV3Flavor <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3Flavor } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3Flavor: DdsInstanceV3Flavor = { ... }
```

##### `num`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor.property.num"></a>

```typescript
public readonly num: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#num DdsInstanceV3#num}.

---

##### `specCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#spec_code DdsInstanceV3#spec_code}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#type DdsInstanceV3#type}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#size DdsInstanceV3#size}.

---

##### `storage`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#storage DdsInstanceV3#storage}.

---

### DdsInstanceV3Nodes <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Nodes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3Nodes } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3Nodes: DdsInstanceV3Nodes = { ... }
```

### DdsInstanceV3Timeouts <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DdsInstanceV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const ddsInstanceV3Timeouts: DdsInstanceV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#create DdsInstanceV3#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dds_instance_v3#delete DdsInstanceV3#delete}.

---

### DehHostV1AvailableInstanceCapacities <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DehHostV1AvailableInstanceCapacities } from '@cdktf/provider-opentelekomcloud'

const dehHostV1AvailableInstanceCapacities: DehHostV1AvailableInstanceCapacities = { ... }
```

### DehHostV1Config <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DehHostV1Config } from '@cdktf/provider-opentelekomcloud'

const dehHostV1Config: DehHostV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#availability_zone DehHostV1#availability_zone}.

---

##### `hostType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.hostType"></a>

```typescript
public readonly hostType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#host_type DehHostV1#host_type}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#name DehHostV1#name}.

---

##### `autoPlacement`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.autoPlacement"></a>

```typescript
public readonly autoPlacement: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#auto_placement DehHostV1#auto_placement}.

---

##### `availableInstanceCapacities`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.availableInstanceCapacities"></a>

```typescript
public readonly availableInstanceCapacities: IResolvable | DehHostV1AvailableInstanceCapacities[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities)[]

available_instance_capacities block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#available_instance_capacities DehHostV1#available_instance_capacities}

---

##### `availableMemory`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.availableMemory"></a>

```typescript
public readonly availableMemory: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#available_memory DehHostV1#available_memory}.

---

##### `availableVcpus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.availableVcpus"></a>

```typescript
public readonly availableVcpus: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#available_vcpus DehHostV1#available_vcpus}.

---

##### `cores`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#cores DehHostV1#cores}.

---

##### `hostTypeName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.hostTypeName"></a>

```typescript
public readonly hostTypeName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#host_type_name DehHostV1#host_type_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#id DehHostV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `instanceTotal`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.instanceTotal"></a>

```typescript
public readonly instanceTotal: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#instance_total DehHostV1#instance_total}.

---

##### `instanceUuids`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.instanceUuids"></a>

```typescript
public readonly instanceUuids: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#instance_uuids DehHostV1#instance_uuids}.

---

##### `memory`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#memory DehHostV1#memory}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#region DehHostV1#region}.

---

##### `sockets`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#sockets DehHostV1#sockets}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#status DehHostV1#status}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: DehHostV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DehHostV1Timeouts`](#@cdktf/provider-opentelekomcloud.DehHostV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#timeouts DehHostV1#timeouts}

---

##### `vcpus`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Config.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#vcpus DehHostV1#vcpus}.

---

### DehHostV1Timeouts <a name="@cdktf/provider-opentelekomcloud.DehHostV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DehHostV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const dehHostV1Timeouts: DehHostV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#create DehHostV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/deh_host_v1#delete DehHostV1#delete}.

---

### DmsGroupV1Config <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DmsGroupV1Config } from '@cdktf/provider-opentelekomcloud'

const dmsGroupV1Config: DmsGroupV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_group_v1#name DmsGroupV1#name}.

---

##### `queueId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_group_v1#queue_id DmsGroupV1#queue_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsGroupV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_group_v1#id DmsGroupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DmsInstanceV1Config <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DmsInstanceV1Config } from '@cdktf/provider-opentelekomcloud'

const dmsInstanceV1Config: DmsInstanceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availableZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.availableZones"></a>

```typescript
public readonly availableZones: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#available_zones DmsInstanceV1#available_zones}.

---

##### `engine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.engine"></a>

```typescript
public readonly engine: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#engine DmsInstanceV1#engine}.

---

##### `engineVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.engineVersion"></a>

```typescript
public readonly engineVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#engine_version DmsInstanceV1#engine_version}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#name DmsInstanceV1#name}.

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#product_id DmsInstanceV1#product_id}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#security_group_id DmsInstanceV1#security_group_id}.

---

##### `storageSpace`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.storageSpace"></a>

```typescript
public readonly storageSpace: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#storage_space DmsInstanceV1#storage_space}.

---

##### `storageSpecCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.storageSpecCode"></a>

```typescript
public readonly storageSpecCode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#storage_spec_code DmsInstanceV1#storage_spec_code}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#subnet_id DmsInstanceV1#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#vpc_id DmsInstanceV1#vpc_id}.

---

##### `accessUser`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.accessUser"></a>

```typescript
public readonly accessUser: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#access_user DmsInstanceV1#access_user}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#description DmsInstanceV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#id DmsInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `maintainBegin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.maintainBegin"></a>

```typescript
public readonly maintainBegin: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#maintain_begin DmsInstanceV1#maintain_begin}.

---

##### `maintainEnd`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.maintainEnd"></a>

```typescript
public readonly maintainEnd: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#maintain_end DmsInstanceV1#maintain_end}.

---

##### `partitionNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.partitionNum"></a>

```typescript
public readonly partitionNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#partition_num DmsInstanceV1#partition_num}.

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#password DmsInstanceV1#password}.

---

##### `retentionPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.retentionPolicy"></a>

```typescript
public readonly retentionPolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#retention_policy DmsInstanceV1#retention_policy}.

---

##### `specification`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsInstanceV1Config.property.specification"></a>

```typescript
public readonly specification: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_instance_v1#specification DmsInstanceV1#specification}.

---

### DmsQueueV1Config <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DmsQueueV1Config } from '@cdktf/provider-opentelekomcloud'

const dmsQueueV1Config: DmsQueueV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#name DmsQueueV1#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#description DmsQueueV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#id DmsQueueV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `maxConsumeCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.maxConsumeCount"></a>

```typescript
public readonly maxConsumeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#max_consume_count DmsQueueV1#max_consume_count}.

---

##### `queueMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.queueMode"></a>

```typescript
public readonly queueMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#queue_mode DmsQueueV1#queue_mode}.

---

##### `redrivePolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.redrivePolicy"></a>

```typescript
public readonly redrivePolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#redrive_policy DmsQueueV1#redrive_policy}.

---

##### `retentionHours`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DmsQueueV1Config.property.retentionHours"></a>

```typescript
public readonly retentionHours: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dms_queue_v1#retention_hours DmsQueueV1#retention_hours}.

---

### DnsPtrrecordV2Config <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsPtrrecordV2Config } from '@cdktf/provider-opentelekomcloud'

const dnsPtrrecordV2Config: DnsPtrrecordV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `floatingipId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.floatingipId"></a>

```typescript
public readonly floatingipId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#floatingip_id DnsPtrrecordV2#floatingip_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#name DnsPtrrecordV2#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#description DnsPtrrecordV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#id DnsPtrrecordV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#tags DnsPtrrecordV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: DnsPtrrecordV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#timeouts DnsPtrrecordV2#timeouts}

---

##### `ttl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Config.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#ttl DnsPtrrecordV2#ttl}.

---

### DnsPtrrecordV2Timeouts <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsPtrrecordV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const dnsPtrrecordV2Timeouts: DnsPtrrecordV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#create DnsPtrrecordV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#delete DnsPtrrecordV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_ptrrecord_v2#update DnsPtrrecordV2#update}.

---

### DnsRecordsetV2Config <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsRecordsetV2Config } from '@cdktf/provider-opentelekomcloud'

const dnsRecordsetV2Config: DnsRecordsetV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#name DnsRecordsetV2#name}.

---

##### `records`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.records"></a>

```typescript
public readonly records: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#records DnsRecordsetV2#records}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#type DnsRecordsetV2#type}.

---

##### `zoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#zone_id DnsRecordsetV2#zone_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#description DnsRecordsetV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#id DnsRecordsetV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#region DnsRecordsetV2#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#tags DnsRecordsetV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: DnsRecordsetV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#timeouts DnsRecordsetV2#timeouts}

---

##### `ttl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#ttl DnsRecordsetV2#ttl}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#value_specs DnsRecordsetV2#value_specs}.

---

### DnsRecordsetV2Timeouts <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsRecordsetV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const dnsRecordsetV2Timeouts: DnsRecordsetV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#create DnsRecordsetV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#delete DnsRecordsetV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_recordset_v2#update DnsRecordsetV2#update}.

---

### DnsZoneV2Config <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsZoneV2Config } from '@cdktf/provider-opentelekomcloud'

const dnsZoneV2Config: DnsZoneV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#name DnsZoneV2#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#description DnsZoneV2#description}.

---

##### `email`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#email DnsZoneV2#email}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#id DnsZoneV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#region DnsZoneV2#region}.

---

##### `router`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.router"></a>

```typescript
public readonly router: IResolvable | DnsZoneV2Router[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Router`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Router)[]

router block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#router DnsZoneV2#router}

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#tags DnsZoneV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: DnsZoneV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#timeouts DnsZoneV2#timeouts}

---

##### `ttl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#ttl DnsZoneV2#ttl}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#type DnsZoneV2#type}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#value_specs DnsZoneV2#value_specs}.

---

### DnsZoneV2Router <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Router"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsZoneV2Router } from '@cdktf/provider-opentelekomcloud'

const dnsZoneV2Router: DnsZoneV2Router = { ... }
```

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Router.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#router_id DnsZoneV2#router_id}.

---

##### `routerRegion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Router.property.routerRegion"></a>

```typescript
public readonly routerRegion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#router_region DnsZoneV2#router_region}.

---

### DnsZoneV2Timeouts <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { DnsZoneV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const dnsZoneV2Timeouts: DnsZoneV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#create DnsZoneV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#delete DnsZoneV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dns_zone_v2#update DnsZoneV2#update}.

---

### EcsInstanceV1Config <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EcsInstanceV1Config } from '@cdktf/provider-opentelekomcloud'

const ecsInstanceV1Config: EcsInstanceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#availability_zone EcsInstanceV1#availability_zone}.

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#flavor EcsInstanceV1#flavor}.

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#image_id EcsInstanceV1#image_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#name EcsInstanceV1#name}.

---

##### `nics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.nics"></a>

```typescript
public readonly nics: IResolvable | EcsInstanceV1Nics[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics)[]

nics block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#nics EcsInstanceV1#nics}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#vpc_id EcsInstanceV1#vpc_id}.

---

##### `autoRecovery`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.autoRecovery"></a>

```typescript
public readonly autoRecovery: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#auto_recovery EcsInstanceV1#auto_recovery}.

---

##### `dataDisks`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.dataDisks"></a>

```typescript
public readonly dataDisks: IResolvable | EcsInstanceV1DataDisks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks)[]

data_disks block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#data_disks EcsInstanceV1#data_disks}

---

##### `deleteDisksOnTermination`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.deleteDisksOnTermination"></a>

```typescript
public readonly deleteDisksOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#delete_disks_on_termination EcsInstanceV1#delete_disks_on_termination}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#id EcsInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `keyName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#key_name EcsInstanceV1#key_name}.

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#password EcsInstanceV1#password}.

---

##### `securityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#security_groups EcsInstanceV1#security_groups}.

---

##### `systemDiskKmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.systemDiskKmsId"></a>

```typescript
public readonly systemDiskKmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#system_disk_kms_id EcsInstanceV1#system_disk_kms_id}.

---

##### `systemDiskSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.systemDiskSize"></a>

```typescript
public readonly systemDiskSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#system_disk_size EcsInstanceV1#system_disk_size}.

---

##### `systemDiskType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.systemDiskType"></a>

```typescript
public readonly systemDiskType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#system_disk_type EcsInstanceV1#system_disk_type}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#tags EcsInstanceV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: EcsInstanceV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#timeouts EcsInstanceV1#timeouts}

---

##### `userData`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Config.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#user_data EcsInstanceV1#user_data}.

---

### EcsInstanceV1DataDisks <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EcsInstanceV1DataDisks } from '@cdktf/provider-opentelekomcloud'

const ecsInstanceV1DataDisks: EcsInstanceV1DataDisks = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#size EcsInstanceV1#size}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#type EcsInstanceV1#type}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#kms_id EcsInstanceV1#kms_id}.

---

##### `snapshotId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#snapshot_id EcsInstanceV1#snapshot_id}.

---

### EcsInstanceV1Nics <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EcsInstanceV1Nics } from '@cdktf/provider-opentelekomcloud'

const ecsInstanceV1Nics: EcsInstanceV1Nics = { ... }
```

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#network_id EcsInstanceV1#network_id}.

---

##### `ipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#ip_address EcsInstanceV1#ip_address}.

---

### EcsInstanceV1Timeouts <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EcsInstanceV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const ecsInstanceV1Timeouts: EcsInstanceV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#create EcsInstanceV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#delete EcsInstanceV1#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ecs_instance_v1#update EcsInstanceV1#update}.

---

### EvsVolumeV3Attachment <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Attachment"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EvsVolumeV3Attachment } from '@cdktf/provider-opentelekomcloud'

const evsVolumeV3Attachment: EvsVolumeV3Attachment = { ... }
```

### EvsVolumeV3Config <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EvsVolumeV3Config } from '@cdktf/provider-opentelekomcloud'

const evsVolumeV3Config: EvsVolumeV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#availability_zone EvsVolumeV3#availability_zone}.

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#volume_type EvsVolumeV3#volume_type}.

---

##### `backupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#backup_id EvsVolumeV3#backup_id}.

---

##### `cascade`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.cascade"></a>

```typescript
public readonly cascade: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#cascade EvsVolumeV3#cascade}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#description EvsVolumeV3#description}.

---

##### `deviceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.deviceType"></a>

```typescript
public readonly deviceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#device_type EvsVolumeV3#device_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#id EvsVolumeV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#image_id EvsVolumeV3#image_id}.

---

##### `kmsId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#kms_id EvsVolumeV3#kms_id}.

---

##### `multiattach`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.multiattach"></a>

```typescript
public readonly multiattach: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#multiattach EvsVolumeV3#multiattach}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#name EvsVolumeV3#name}.

---

##### `size`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#size EvsVolumeV3#size}.

---

##### `snapshotId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#snapshot_id EvsVolumeV3#snapshot_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#tags EvsVolumeV3#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: EvsVolumeV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#timeouts EvsVolumeV3#timeouts}

---

### EvsVolumeV3Timeouts <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { EvsVolumeV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const evsVolumeV3Timeouts: EvsVolumeV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#create EvsVolumeV3#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/evs_volume_v3#delete EvsVolumeV3#delete}.

---

### FwFirewallGroupV2Config <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { FwFirewallGroupV2Config } from '@cdktf/provider-opentelekomcloud'

const fwFirewallGroupV2Config: FwFirewallGroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#admin_state_up FwFirewallGroupV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#description FwFirewallGroupV2#description}.

---

##### `egressPolicyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.egressPolicyId"></a>

```typescript
public readonly egressPolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#egress_policy_id FwFirewallGroupV2#egress_policy_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#id FwFirewallGroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ingressPolicyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.ingressPolicyId"></a>

```typescript
public readonly ingressPolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#ingress_policy_id FwFirewallGroupV2#ingress_policy_id}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#name FwFirewallGroupV2#name}.

---

##### `ports`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.ports"></a>

```typescript
public readonly ports: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#ports FwFirewallGroupV2#ports}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#region FwFirewallGroupV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#tenant_id FwFirewallGroupV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: FwFirewallGroupV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#timeouts FwFirewallGroupV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#value_specs FwFirewallGroupV2#value_specs}.

---

### FwFirewallGroupV2Timeouts <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { FwFirewallGroupV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const fwFirewallGroupV2Timeouts: FwFirewallGroupV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#create FwFirewallGroupV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#delete FwFirewallGroupV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_firewall_group_v2#update FwFirewallGroupV2#update}.

---

### FwPolicyV2Config <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { FwPolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const fwPolicyV2Config: FwPolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `audited`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.audited"></a>

```typescript
public readonly audited: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#audited FwPolicyV2#audited}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#description FwPolicyV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#id FwPolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#name FwPolicyV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#region FwPolicyV2#region}.

---

##### `rules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.rules"></a>

```typescript
public readonly rules: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#rules FwPolicyV2#rules}.

---

##### `shared`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#shared FwPolicyV2#shared}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#tenant_id FwPolicyV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: FwPolicyV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#timeouts FwPolicyV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#value_specs FwPolicyV2#value_specs}.

---

### FwPolicyV2Timeouts <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { FwPolicyV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const fwPolicyV2Timeouts: FwPolicyV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#create FwPolicyV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_policy_v2#delete FwPolicyV2#delete}.

---

### FwRuleV2Config <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { FwRuleV2Config } from '@cdktf/provider-opentelekomcloud'

const fwRuleV2Config: FwRuleV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#action FwRuleV2#action}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#protocol FwRuleV2#protocol}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#description FwRuleV2#description}.

---

##### `destinationIpAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.destinationIpAddress"></a>

```typescript
public readonly destinationIpAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#destination_ip_address FwRuleV2#destination_ip_address}.

---

##### `destinationPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.destinationPort"></a>

```typescript
public readonly destinationPort: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#destination_port FwRuleV2#destination_port}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#enabled FwRuleV2#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#id FwRuleV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipVersion`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.ipVersion"></a>

```typescript
public readonly ipVersion: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#ip_version FwRuleV2#ip_version}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#name FwRuleV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#region FwRuleV2#region}.

---

##### `sourceIpAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.sourceIpAddress"></a>

```typescript
public readonly sourceIpAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#source_ip_address FwRuleV2#source_ip_address}.

---

##### `sourcePort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.sourcePort"></a>

```typescript
public readonly sourcePort: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#source_port FwRuleV2#source_port}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#tenant_id FwRuleV2#tenant_id}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwRuleV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/fw_rule_v2#value_specs FwRuleV2#value_specs}.

---

### IdentityAgencyV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityAgencyV3Config } from '@cdktf/provider-opentelekomcloud'

const identityAgencyV3Config: IdentityAgencyV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `delegatedDomainName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.delegatedDomainName"></a>

```typescript
public readonly delegatedDomainName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#delegated_domain_name IdentityAgencyV3#delegated_domain_name}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#name IdentityAgencyV3#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#description IdentityAgencyV3#description}.

---

##### `domainRoles`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.domainRoles"></a>

```typescript
public readonly domainRoles: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#domain_roles IdentityAgencyV3#domain_roles}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#id IdentityAgencyV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectRole`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.projectRole"></a>

```typescript
public readonly projectRole: IResolvable | IdentityAgencyV3ProjectRole[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole)[]

project_role block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#project_role IdentityAgencyV3#project_role}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: IdentityAgencyV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#timeouts IdentityAgencyV3#timeouts}

---

### IdentityAgencyV3ProjectRole <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityAgencyV3ProjectRole } from '@cdktf/provider-opentelekomcloud'

const identityAgencyV3ProjectRole: IdentityAgencyV3ProjectRole = { ... }
```

##### `project`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole.property.project"></a>

```typescript
public readonly project: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#project IdentityAgencyV3#project}.

---

##### `roles`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#roles IdentityAgencyV3#roles}.

---

### IdentityAgencyV3Timeouts <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityAgencyV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const identityAgencyV3Timeouts: IdentityAgencyV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#create IdentityAgencyV3#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#delete IdentityAgencyV3#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_agency_v3#update IdentityAgencyV3#update}.

---

### IdentityCredentialV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityCredentialV3Config } from '@cdktf/provider-opentelekomcloud'

const identityCredentialV3Config: IdentityCredentialV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_credential_v3#description IdentityCredentialV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_credential_v3#id IdentityCredentialV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_credential_v3#status IdentityCredentialV3#status}.

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityCredentialV3Config.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_credential_v3#user_id IdentityCredentialV3#user_id}.

---

### IdentityGroupMembershipV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityGroupMembershipV3Config } from '@cdktf/provider-opentelekomcloud'

const identityGroupMembershipV3Config: IdentityGroupMembershipV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `group`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_membership_v3#group IdentityGroupMembershipV3#group}.

---

##### `users`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.users"></a>

```typescript
public readonly users: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_membership_v3#users IdentityGroupMembershipV3#users}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupMembershipV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_membership_v3#id IdentityGroupMembershipV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IdentityGroupV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityGroupV3Config } from '@cdktf/provider-opentelekomcloud'

const identityGroupV3Config: IdentityGroupV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3#name IdentityGroupV3#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3#description IdentityGroupV3#description}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3#domain_id IdentityGroupV3#domain_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3#id IdentityGroupV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityGroupV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_group_v3#region IdentityGroupV3#region}.

---

### IdentityMappingV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityMappingV3Config } from '@cdktf/provider-opentelekomcloud'

const identityMappingV3Config: IdentityMappingV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `mappingId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.mappingId"></a>

```typescript
public readonly mappingId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_mapping_v3#mapping_id IdentityMappingV3#mapping_id}.

---

##### `rules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.rules"></a>

```typescript
public readonly rules: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_mapping_v3#rules IdentityMappingV3#rules}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityMappingV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_mapping_v3#id IdentityMappingV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IdentityProjectV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityProjectV3Config } from '@cdktf/provider-opentelekomcloud'

const identityProjectV3Config: IdentityProjectV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#name IdentityProjectV3#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#description IdentityProjectV3#description}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#domain_id IdentityProjectV3#domain_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#id IdentityProjectV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `parentId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.parentId"></a>

```typescript
public readonly parentId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#parent_id IdentityProjectV3#parent_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProjectV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_project_v3#region IdentityProjectV3#region}.

---

### IdentityProtocolV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityProtocolV3Config } from '@cdktf/provider-opentelekomcloud'

const identityProtocolV3Config: IdentityProtocolV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `mappingId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.mappingId"></a>

```typescript
public readonly mappingId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#mapping_id IdentityProtocolV3#mapping_id}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#protocol IdentityProtocolV3#protocol}.

---

##### `providerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#provider_id IdentityProtocolV3#provider_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#id IdentityProtocolV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Config.property.metadata"></a>

```typescript
public readonly metadata: IdentityProtocolV3Metadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata)

metadata block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#metadata IdentityProtocolV3#metadata}

---

### IdentityProtocolV3Metadata <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityProtocolV3Metadata } from '@cdktf/provider-opentelekomcloud'

const identityProtocolV3Metadata: IdentityProtocolV3Metadata = { ... }
```

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#domain_id IdentityProtocolV3#domain_id}.

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata.property.metadata"></a>

```typescript
public readonly metadata: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#metadata IdentityProtocolV3#metadata}.

---

##### `xaccountType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata.property.xaccountType"></a>

```typescript
public readonly xaccountType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_protocol_v3#xaccount_type IdentityProtocolV3#xaccount_type}.

---

### IdentityProviderV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityProviderV3Config } from '@cdktf/provider-opentelekomcloud'

const identityProviderV3Config: IdentityProviderV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_provider_v3#name IdentityProviderV3#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_provider_v3#description IdentityProviderV3#description}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_provider_v3#enabled IdentityProviderV3#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProviderV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_provider_v3#id IdentityProviderV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IdentityRoleAssignmentV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityRoleAssignmentV3Config } from '@cdktf/provider-opentelekomcloud'

const identityRoleAssignmentV3Config: IdentityRoleAssignmentV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `roleId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.roleId"></a>

```typescript
public readonly roleId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#role_id IdentityRoleAssignmentV3#role_id}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#domain_id IdentityRoleAssignmentV3#domain_id}.

---

##### `groupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#group_id IdentityRoleAssignmentV3#group_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#id IdentityRoleAssignmentV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#project_id IdentityRoleAssignmentV3#project_id}.

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleAssignmentV3Config.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_assignment_v3#user_id IdentityRoleAssignmentV3#user_id}.

---

### IdentityRoleV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityRoleV3Config } from '@cdktf/provider-opentelekomcloud'

const identityRoleV3Config: IdentityRoleV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#description IdentityRoleV3#description}.

---

##### `displayLayer`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.displayLayer"></a>

```typescript
public readonly displayLayer: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#display_layer IdentityRoleV3#display_layer}.

---

##### `displayName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.displayName"></a>

```typescript
public readonly displayName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#display_name IdentityRoleV3#display_name}.

---

##### `statement`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.statement"></a>

```typescript
public readonly statement: IResolvable | IdentityRoleV3Statement[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement)[]

statement block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#statement IdentityRoleV3#statement}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#id IdentityRoleV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IdentityRoleV3Statement <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityRoleV3Statement } from '@cdktf/provider-opentelekomcloud'

const identityRoleV3Statement: IdentityRoleV3Statement = { ... }
```

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement.property.action"></a>

```typescript
public readonly action: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#action IdentityRoleV3#action}.

---

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_role_v3#effect IdentityRoleV3#effect}.

---

### IdentityUserGroupMembershipV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityUserGroupMembershipV3Config } from '@cdktf/provider-opentelekomcloud'

const identityUserGroupMembershipV3Config: IdentityUserGroupMembershipV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `groups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.groups"></a>

```typescript
public readonly groups: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_group_membership_v3#groups IdentityUserGroupMembershipV3#groups}.

---

##### `user`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_group_membership_v3#user IdentityUserGroupMembershipV3#user}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserGroupMembershipV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_group_membership_v3#id IdentityUserGroupMembershipV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IdentityUserV3Config <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { IdentityUserV3Config } from '@cdktf/provider-opentelekomcloud'

const identityUserV3Config: IdentityUserV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `defaultProjectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.defaultProjectId"></a>

```typescript
public readonly defaultProjectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#default_project_id IdentityUserV3#default_project_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#description IdentityUserV3#description}.

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#domain_id IdentityUserV3#domain_id}.

---

##### `email`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.email"></a>

```typescript
public readonly email: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#email IdentityUserV3#email}.

---

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#enabled IdentityUserV3#enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#id IdentityUserV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#name IdentityUserV3#name}.

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#password IdentityUserV3#password}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#region IdentityUserV3#region}.

---

##### `sendWelcomeEmail`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityUserV3Config.property.sendWelcomeEmail"></a>

```typescript
public readonly sendWelcomeEmail: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/identity_user_v3#send_welcome_email IdentityUserV3#send_welcome_email}.

---

### ImagesImageAccessAcceptV2Config <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImagesImageAccessAcceptV2Config } from '@cdktf/provider-opentelekomcloud'

const imagesImageAccessAcceptV2Config: ImagesImageAccessAcceptV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_accept_v2#image_id ImagesImageAccessAcceptV2#image_id}.

---

##### `memberId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.memberId"></a>

```typescript
public readonly memberId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_accept_v2#member_id ImagesImageAccessAcceptV2#member_id}.

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_accept_v2#status ImagesImageAccessAcceptV2#status}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessAcceptV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_accept_v2#id ImagesImageAccessAcceptV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### ImagesImageAccessV2Config <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImagesImageAccessV2Config } from '@cdktf/provider-opentelekomcloud'

const imagesImageAccessV2Config: ImagesImageAccessV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `imageId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_v2#image_id ImagesImageAccessV2#image_id}.

---

##### `memberId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.memberId"></a>

```typescript
public readonly memberId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_v2#member_id ImagesImageAccessV2#member_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_v2#id ImagesImageAccessV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageAccessV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_access_v2#status ImagesImageAccessV2#status}.

---

### ImagesImageV2Config <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImagesImageV2Config } from '@cdktf/provider-opentelekomcloud'

const imagesImageV2Config: ImagesImageV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `containerFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.containerFormat"></a>

```typescript
public readonly containerFormat: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#container_format ImagesImageV2#container_format}.

---

##### `diskFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.diskFormat"></a>

```typescript
public readonly diskFormat: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#disk_format ImagesImageV2#disk_format}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#name ImagesImageV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#id ImagesImageV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageCachePath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.imageCachePath"></a>

```typescript
public readonly imageCachePath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#image_cache_path ImagesImageV2#image_cache_path}.

---

##### `imageSourceUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.imageSourceUrl"></a>

```typescript
public readonly imageSourceUrl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#image_source_url ImagesImageV2#image_source_url}.

---

##### `localFilePath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.localFilePath"></a>

```typescript
public readonly localFilePath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#local_file_path ImagesImageV2#local_file_path}.

---

##### `minDiskGb`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.minDiskGb"></a>

```typescript
public readonly minDiskGb: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#min_disk_gb ImagesImageV2#min_disk_gb}.

---

##### `minRamMb`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.minRamMb"></a>

```typescript
public readonly minRamMb: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#min_ram_mb ImagesImageV2#min_ram_mb}.

---

##### `protected`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.protected"></a>

```typescript
public readonly protected: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#protected ImagesImageV2#protected}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#region ImagesImageV2#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#tags ImagesImageV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ImagesImageV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#timeouts ImagesImageV2#timeouts}

---

##### `visibility`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Config.property.visibility"></a>

```typescript
public readonly visibility: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#visibility ImagesImageV2#visibility}.

---

### ImagesImageV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImagesImageV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const imagesImageV2Timeouts: ImagesImageV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/images_image_v2#create ImagesImageV2#create}.

---

### ImsDataImageV2Config <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImsDataImageV2Config } from '@cdktf/provider-opentelekomcloud'

const imsDataImageV2Config: ImsDataImageV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#name ImsDataImageV2#name}.

---

##### `cmkId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.cmkId"></a>

```typescript
public readonly cmkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#cmk_id ImsDataImageV2#cmk_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#description ImsDataImageV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#id ImsDataImageV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.imageUrl"></a>

```typescript
public readonly imageUrl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#image_url ImsDataImageV2#image_url}.

---

##### `minDisk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#min_disk ImsDataImageV2#min_disk}.

---

##### `osType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.osType"></a>

```typescript
public readonly osType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#os_type ImsDataImageV2#os_type}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#tags ImsDataImageV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ImsDataImageV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#timeouts ImsDataImageV2#timeouts}

---

##### `volumeId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Config.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#volume_id ImsDataImageV2#volume_id}.

---

### ImsDataImageV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImsDataImageV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const imsDataImageV2Timeouts: ImsDataImageV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#create ImsDataImageV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_data_image_v2#delete ImsDataImageV2#delete}.

---

### ImsImageV2Config <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImsImageV2Config } from '@cdktf/provider-opentelekomcloud'

const imsImageV2Config: ImsImageV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#name ImsImageV2#name}.

---

##### `cmkId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.cmkId"></a>

```typescript
public readonly cmkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#cmk_id ImsImageV2#cmk_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#description ImsImageV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#id ImsImageV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.imageUrl"></a>

```typescript
public readonly imageUrl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#image_url ImsImageV2#image_url}.

---

##### `instanceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#instance_id ImsImageV2#instance_id}.

---

##### `isConfig`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.isConfig"></a>

```typescript
public readonly isConfig: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#is_config ImsImageV2#is_config}.

---

##### `maxRam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.maxRam"></a>

```typescript
public readonly maxRam: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#max_ram ImsImageV2#max_ram}.

---

##### `minDisk`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.minDisk"></a>

```typescript
public readonly minDisk: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#min_disk ImsImageV2#min_disk}.

---

##### `minRam`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.minRam"></a>

```typescript
public readonly minRam: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#min_ram ImsImageV2#min_ram}.

---

##### `osVersion`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.osVersion"></a>

```typescript
public readonly osVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#os_version ImsImageV2#os_version}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#tags ImsImageV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: ImsImageV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#timeouts ImsImageV2#timeouts}

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#type ImsImageV2#type}.

---

### ImsImageV2Timeouts <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ImsImageV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const imsImageV2Timeouts: ImsImageV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#create ImsImageV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/ims_image_v2#delete ImsImageV2#delete}.

---

### KmsGrantV1Config <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { KmsGrantV1Config } from '@cdktf/provider-opentelekomcloud'

const kmsGrantV1Config: KmsGrantV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `granteePrincipal`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.granteePrincipal"></a>

```typescript
public readonly granteePrincipal: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#grantee_principal KmsGrantV1#grantee_principal}.

---

##### `keyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#key_id KmsGrantV1#key_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#id KmsGrantV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#name KmsGrantV1#name}.

---

##### `operations`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#operations KmsGrantV1#operations}.

---

##### `retiringPrincipal`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsGrantV1Config.property.retiringPrincipal"></a>

```typescript
public readonly retiringPrincipal: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_grant_v1#retiring_principal KmsGrantV1#retiring_principal}.

---

### KmsKeyV1Config <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { KmsKeyV1Config } from '@cdktf/provider-opentelekomcloud'

const kmsKeyV1Config: KmsKeyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `keyAlias`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.keyAlias"></a>

```typescript
public readonly keyAlias: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#key_alias KmsKeyV1#key_alias}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#id KmsKeyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `isEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.isEnabled"></a>

```typescript
public readonly isEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#is_enabled KmsKeyV1#is_enabled}.

---

##### `keyDescription`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.keyDescription"></a>

```typescript
public readonly keyDescription: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#key_description KmsKeyV1#key_description}.

---

##### `pendingDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.pendingDays"></a>

```typescript
public readonly pendingDays: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#pending_days KmsKeyV1#pending_days}.

---

##### `realm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.realm"></a>

```typescript
public readonly realm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#realm KmsKeyV1#realm}.

---

##### `rotationEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.rotationEnabled"></a>

```typescript
public readonly rotationEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#rotation_enabled KmsKeyV1#rotation_enabled}.

---

##### `rotationInterval`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.rotationInterval"></a>

```typescript
public readonly rotationInterval: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#rotation_interval KmsKeyV1#rotation_interval}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.KmsKeyV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/kms_key_v1#tags KmsKeyV1#tags}.

---

### LbCertificateV2Config <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbCertificateV2Config } from '@cdktf/provider-opentelekomcloud'

const lbCertificateV2Config: LbCertificateV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `certificate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.certificate"></a>

```typescript
public readonly certificate: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#certificate LbCertificateV2#certificate}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#description LbCertificateV2#description}.

---

##### `domain`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#domain LbCertificateV2#domain}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#id LbCertificateV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#name LbCertificateV2#name}.

---

##### `privateKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#private_key LbCertificateV2#private_key}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#region LbCertificateV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbCertificateV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#timeouts LbCertificateV2#timeouts}

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#type LbCertificateV2#type}.

---

### LbCertificateV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbCertificateV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbCertificateV2Timeouts: LbCertificateV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#create LbCertificateV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#delete LbCertificateV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v2#update LbCertificateV2#update}.

---

### LbCertificateV3Config <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbCertificateV3Config } from '@cdktf/provider-opentelekomcloud'

const lbCertificateV3Config: LbCertificateV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `certificate`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.certificate"></a>

```typescript
public readonly certificate: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#certificate LbCertificateV3#certificate}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#description LbCertificateV3#description}.

---

##### `domain`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#domain LbCertificateV3#domain}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#id LbCertificateV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#name LbCertificateV3#name}.

---

##### `privateKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#private_key LbCertificateV3#private_key}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#region LbCertificateV3#region}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_certificate_v3#type LbCertificateV3#type}.

---

### LbL7PolicyV2Config <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbL7PolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const lbL7PolicyV2Config: LbL7PolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#action LbL7PolicyV2#action}.

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#listener_id LbL7PolicyV2#listener_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#admin_state_up LbL7PolicyV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#description LbL7PolicyV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#id LbL7PolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#name LbL7PolicyV2#name}.

---

##### `position`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#position LbL7PolicyV2#position}.

---

##### `redirectListenerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.redirectListenerId"></a>

```typescript
public readonly redirectListenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#redirect_listener_id LbL7PolicyV2#redirect_listener_id}.

---

##### `redirectPoolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.redirectPoolId"></a>

```typescript
public readonly redirectPoolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#redirect_pool_id LbL7PolicyV2#redirect_pool_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#region LbL7PolicyV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#tenant_id LbL7PolicyV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbL7PolicyV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#timeouts LbL7PolicyV2#timeouts}

---

### LbL7PolicyV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbL7PolicyV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbL7PolicyV2Timeouts: LbL7PolicyV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#create LbL7PolicyV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#delete LbL7PolicyV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7policy_v2#update LbL7PolicyV2#update}.

---

### LbL7RuleV2Config <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbL7RuleV2Config } from '@cdktf/provider-opentelekomcloud'

const lbL7RuleV2Config: LbL7RuleV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#compare_type LbL7RuleV2#compare_type}.

---

##### `l7PolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.l7PolicyId"></a>

```typescript
public readonly l7PolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#l7policy_id LbL7RuleV2#l7policy_id}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#type LbL7RuleV2#type}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#value LbL7RuleV2#value}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#admin_state_up LbL7RuleV2#admin_state_up}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#id LbL7RuleV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `key`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#key LbL7RuleV2#key}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#region LbL7RuleV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#tenant_id LbL7RuleV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbL7RuleV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#timeouts LbL7RuleV2#timeouts}

---

### LbL7RuleV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbL7RuleV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbL7RuleV2Timeouts: LbL7RuleV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#create LbL7RuleV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#delete LbL7RuleV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_l7rule_v2#update LbL7RuleV2#update}.

---

### LbListenerV2Config <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbListenerV2Config } from '@cdktf/provider-opentelekomcloud'

const lbListenerV2Config: LbListenerV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#loadbalancer_id LbListenerV2#loadbalancer_id}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#protocol LbListenerV2#protocol}.

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#protocol_port LbListenerV2#protocol_port}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#admin_state_up LbListenerV2#admin_state_up}.

---

##### `clientCaTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#client_ca_tls_container_ref LbListenerV2#client_ca_tls_container_ref}.

---

##### `defaultPoolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#default_pool_id LbListenerV2#default_pool_id}.

---

##### `defaultTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#default_tls_container_ref LbListenerV2#default_tls_container_ref}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#description LbListenerV2#description}.

---

##### `http2Enable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.http2Enable"></a>

```typescript
public readonly http2Enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#http2_enable LbListenerV2#http2_enable}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#id LbListenerV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#name LbListenerV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#region LbListenerV2#region}.

---

##### `sniContainerRefs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.sniContainerRefs"></a>

```typescript
public readonly sniContainerRefs: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#sni_container_refs LbListenerV2#sni_container_refs}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#tags LbListenerV2#tags}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#tenant_id LbListenerV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbListenerV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#timeouts LbListenerV2#timeouts}

---

##### `tlsCiphersPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#tls_ciphers_policy LbListenerV2#tls_ciphers_policy}.

---

##### `transparentClientIpEnable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Config.property.transparentClientIpEnable"></a>

```typescript
public readonly transparentClientIpEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#transparent_client_ip_enable LbListenerV2#transparent_client_ip_enable}.

---

### LbListenerV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbListenerV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbListenerV2Timeouts: LbListenerV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#create LbListenerV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#delete LbListenerV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v2#update LbListenerV2#update}.

---

### LbListenerV3Config <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbListenerV3Config } from '@cdktf/provider-opentelekomcloud'

const lbListenerV3Config: LbListenerV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `loadbalancerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#loadbalancer_id LbListenerV3#loadbalancer_id}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#protocol LbListenerV3#protocol}.

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#protocol_port LbListenerV3#protocol_port}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#admin_state_up LbListenerV3#admin_state_up}.

---

##### `clientCaTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.clientCaTlsContainerRef"></a>

```typescript
public readonly clientCaTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#client_ca_tls_container_ref LbListenerV3#client_ca_tls_container_ref}.

---

##### `clientTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.clientTimeout"></a>

```typescript
public readonly clientTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#client_timeout LbListenerV3#client_timeout}.

---

##### `defaultPoolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.defaultPoolId"></a>

```typescript
public readonly defaultPoolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#default_pool_id LbListenerV3#default_pool_id}.

---

##### `defaultTlsContainerRef`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.defaultTlsContainerRef"></a>

```typescript
public readonly defaultTlsContainerRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#default_tls_container_ref LbListenerV3#default_tls_container_ref}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#description LbListenerV3#description}.

---

##### `http2Enable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.http2Enable"></a>

```typescript
public readonly http2Enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#http2_enable LbListenerV3#http2_enable}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#id LbListenerV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `insertHeaders`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.insertHeaders"></a>

```typescript
public readonly insertHeaders: LbListenerV3InsertHeaders;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders`](#@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders)

insert_headers block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#insert_headers LbListenerV3#insert_headers}

---

##### `keepAliveTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#keep_alive_timeout LbListenerV3#keep_alive_timeout}.

---

##### `memberRetryEnable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.memberRetryEnable"></a>

```typescript
public readonly memberRetryEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#member_retry_enable LbListenerV3#member_retry_enable}.

---

##### `memberTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.memberTimeout"></a>

```typescript
public readonly memberTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#member_timeout LbListenerV3#member_timeout}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#name LbListenerV3#name}.

---

##### `sniContainerRefs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.sniContainerRefs"></a>

```typescript
public readonly sniContainerRefs: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#sni_container_refs LbListenerV3#sni_container_refs}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#tags LbListenerV3#tags}.

---

##### `tlsCiphersPolicy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3Config.property.tlsCiphersPolicy"></a>

```typescript
public readonly tlsCiphersPolicy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#tls_ciphers_policy LbListenerV3#tls_ciphers_policy}.

---

### LbListenerV3InsertHeaders <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbListenerV3InsertHeaders } from '@cdktf/provider-opentelekomcloud'

const lbListenerV3InsertHeaders: LbListenerV3InsertHeaders = { ... }
```

##### `forwardedForPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders.property.forwardedForPort"></a>

```typescript
public readonly forwardedForPort: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#forwarded_for_port LbListenerV3#forwarded_for_port}.

---

##### `forwardedHost`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders.property.forwardedHost"></a>

```typescript
public readonly forwardedHost: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#forwarded_host LbListenerV3#forwarded_host}.

---

##### `forwardedPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders.property.forwardedPort"></a>

```typescript
public readonly forwardedPort: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#forwarded_port LbListenerV3#forwarded_port}.

---

##### `forwardElbIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders.property.forwardElbIp"></a>

```typescript
public readonly forwardElbIp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_listener_v3#forward_elb_ip LbListenerV3#forward_elb_ip}.

---

### LbLoadbalancerV2Config <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbLoadbalancerV2Config } from '@cdktf/provider-opentelekomcloud'

const lbLoadbalancerV2Config: LbLoadbalancerV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `vipSubnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.vipSubnetId"></a>

```typescript
public readonly vipSubnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#vip_subnet_id LbLoadbalancerV2#vip_subnet_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#admin_state_up LbLoadbalancerV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#description LbLoadbalancerV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#id LbLoadbalancerV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `loadbalancerProvider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.loadbalancerProvider"></a>

```typescript
public readonly loadbalancerProvider: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#loadbalancer_provider LbLoadbalancerV2#loadbalancer_provider}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#name LbLoadbalancerV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#region LbLoadbalancerV2#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#tags LbLoadbalancerV2#tags}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#tenant_id LbLoadbalancerV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbLoadbalancerV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#timeouts LbLoadbalancerV2#timeouts}

---

##### `vipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Config.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#vip_address LbLoadbalancerV2#vip_address}.

---

### LbLoadbalancerV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbLoadbalancerV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbLoadbalancerV2Timeouts: LbLoadbalancerV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#create LbLoadbalancerV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#delete LbLoadbalancerV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v2#update LbLoadbalancerV2#update}.

---

### LbLoadbalancerV3Config <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbLoadbalancerV3Config } from '@cdktf/provider-opentelekomcloud'

const lbLoadbalancerV3Config: LbLoadbalancerV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZones`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#availability_zones LbLoadbalancerV3#availability_zones}.

---

##### `networkIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.networkIds"></a>

```typescript
public readonly networkIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#network_ids LbLoadbalancerV3#network_ids}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#admin_state_up LbLoadbalancerV3#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#description LbLoadbalancerV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#id LbLoadbalancerV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipTargetEnable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.ipTargetEnable"></a>

```typescript
public readonly ipTargetEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#ip_target_enable LbLoadbalancerV3#ip_target_enable}.

---

##### `l4Flavor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.l4Flavor"></a>

```typescript
public readonly l4Flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#l4_flavor LbLoadbalancerV3#l4_flavor}.

---

##### `l7Flavor`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.l7Flavor"></a>

```typescript
public readonly l7Flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#l7_flavor LbLoadbalancerV3#l7_flavor}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#name LbLoadbalancerV3#name}.

---

##### `publicIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.publicIp"></a>

```typescript
public readonly publicIp: LbLoadbalancerV3PublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp)

public_ip block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#public_ip LbLoadbalancerV3#public_ip}

---

##### `routerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#router_id LbLoadbalancerV3#router_id}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#subnet_id LbLoadbalancerV3#subnet_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#tags LbLoadbalancerV3#tags}.

---

##### `vipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3Config.property.vipAddress"></a>

```typescript
public readonly vipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#vip_address LbLoadbalancerV3#vip_address}.

---

### LbLoadbalancerV3PublicIp <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbLoadbalancerV3PublicIp } from '@cdktf/provider-opentelekomcloud'

const lbLoadbalancerV3PublicIp: LbLoadbalancerV3PublicIp = { ... }
```

##### `bandwidthChargeMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.bandwidthChargeMode"></a>

```typescript
public readonly bandwidthChargeMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#bandwidth_charge_mode LbLoadbalancerV3#bandwidth_charge_mode}.

---

##### `bandwidthName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.bandwidthName"></a>

```typescript
public readonly bandwidthName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#bandwidth_name LbLoadbalancerV3#bandwidth_name}.

---

##### `bandwidthShareType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.bandwidthShareType"></a>

```typescript
public readonly bandwidthShareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#bandwidth_share_type LbLoadbalancerV3#bandwidth_share_type}.

---

##### `bandwidthSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#bandwidth_size LbLoadbalancerV3#bandwidth_size}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#id LbLoadbalancerV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_loadbalancer_v3#ip_type LbLoadbalancerV3#ip_type}.

---

### LbMemberV2Config <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMemberV2Config } from '@cdktf/provider-opentelekomcloud'

const lbMemberV2Config: LbMemberV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#address LbMemberV2#address}.

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#pool_id LbMemberV2#pool_id}.

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#protocol_port LbMemberV2#protocol_port}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#subnet_id LbMemberV2#subnet_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#admin_state_up LbMemberV2#admin_state_up}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#id LbMemberV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#name LbMemberV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#region LbMemberV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#tenant_id LbMemberV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbMemberV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#timeouts LbMemberV2#timeouts}

---

##### `weight`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Config.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#weight LbMemberV2#weight}.

---

### LbMemberV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMemberV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbMemberV2Timeouts: LbMemberV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#create LbMemberV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#delete LbMemberV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v2#update LbMemberV2#update}.

---

### LbMemberV3Config <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMemberV3Config } from '@cdktf/provider-opentelekomcloud'

const lbMemberV3Config: LbMemberV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#address LbMemberV3#address}.

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#pool_id LbMemberV3#pool_id}.

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#protocol_port LbMemberV3#protocol_port}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#id LbMemberV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#name LbMemberV3#name}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#project_id LbMemberV3#project_id}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#subnet_id LbMemberV3#subnet_id}.

---

##### `weight`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV3Config.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_member_v3#weight LbMemberV3#weight}.

---

### LbMonitorV2Config <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMonitorV2Config } from '@cdktf/provider-opentelekomcloud'

const lbMonitorV2Config: LbMonitorV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `delay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.delay"></a>

```typescript
public readonly delay: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#delay LbMonitorV2#delay}.

---

##### `maxRetries`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#max_retries LbMonitorV2#max_retries}.

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#pool_id LbMonitorV2#pool_id}.

---

##### `timeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#timeout LbMonitorV2#timeout}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#type LbMonitorV2#type}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#admin_state_up LbMonitorV2#admin_state_up}.

---

##### `domainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#domain_name LbMonitorV2#domain_name}.

---

##### `expectedCodes`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.expectedCodes"></a>

```typescript
public readonly expectedCodes: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#expected_codes LbMonitorV2#expected_codes}.

---

##### `httpMethod`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.httpMethod"></a>

```typescript
public readonly httpMethod: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#http_method LbMonitorV2#http_method}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#id LbMonitorV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `monitorPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.monitorPort"></a>

```typescript
public readonly monitorPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#monitor_port LbMonitorV2#monitor_port}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#name LbMonitorV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#region LbMonitorV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#tenant_id LbMonitorV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbMonitorV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#timeouts LbMonitorV2#timeouts}

---

##### `urlPath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Config.property.urlPath"></a>

```typescript
public readonly urlPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#url_path LbMonitorV2#url_path}.

---

### LbMonitorV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMonitorV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbMonitorV2Timeouts: LbMonitorV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#create LbMonitorV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#delete LbMonitorV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v2#update LbMonitorV2#update}.

---

### LbMonitorV3Config <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbMonitorV3Config } from '@cdktf/provider-opentelekomcloud'

const lbMonitorV3Config: LbMonitorV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `delay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.delay"></a>

```typescript
public readonly delay: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#delay LbMonitorV3#delay}.

---

##### `maxRetries`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#max_retries LbMonitorV3#max_retries}.

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#pool_id LbMonitorV3#pool_id}.

---

##### `timeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#timeout LbMonitorV3#timeout}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#type LbMonitorV3#type}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#admin_state_up LbMonitorV3#admin_state_up}.

---

##### `domainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#domain_name LbMonitorV3#domain_name}.

---

##### `expectedCodes`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.expectedCodes"></a>

```typescript
public readonly expectedCodes: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#expected_codes LbMonitorV3#expected_codes}.

---

##### `httpMethod`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.httpMethod"></a>

```typescript
public readonly httpMethod: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#http_method LbMonitorV3#http_method}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#id LbMonitorV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `maxRetriesDown`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.maxRetriesDown"></a>

```typescript
public readonly maxRetriesDown: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#max_retries_down LbMonitorV3#max_retries_down}.

---

##### `monitorPort`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.monitorPort"></a>

```typescript
public readonly monitorPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#monitor_port LbMonitorV3#monitor_port}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#name LbMonitorV3#name}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#project_id LbMonitorV3#project_id}.

---

##### `urlPath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV3Config.property.urlPath"></a>

```typescript
public readonly urlPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_monitor_v3#url_path LbMonitorV3#url_path}.

---

### LbPolicyV3Config <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPolicyV3Config } from '@cdktf/provider-opentelekomcloud'

const lbPolicyV3Config: LbPolicyV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#action LbPolicyV3#action}.

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#listener_id LbPolicyV3#listener_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#description LbPolicyV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#id LbPolicyV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#name LbPolicyV3#name}.

---

##### `position`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#position LbPolicyV3#position}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#project_id LbPolicyV3#project_id}.

---

##### `redirectListenerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.redirectListenerId"></a>

```typescript
public readonly redirectListenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#redirect_listener_id LbPolicyV3#redirect_listener_id}.

---

##### `redirectPoolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.redirectPoolId"></a>

```typescript
public readonly redirectPoolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#redirect_pool_id LbPolicyV3#redirect_pool_id}.

---

##### `rules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Config.property.rules"></a>

```typescript
public readonly rules: IResolvable | LbPolicyV3Rules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPolicyV3Rules`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Rules)[]

rules block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#rules LbPolicyV3#rules}

---

### LbPolicyV3Rules <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Rules"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPolicyV3Rules } from '@cdktf/provider-opentelekomcloud'

const lbPolicyV3Rules: LbPolicyV3Rules = { ... }
```

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Rules.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#compare_type LbPolicyV3#compare_type}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Rules.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#type LbPolicyV3#type}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3Rules.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_policy_v3#value LbPolicyV3#value}.

---

### LbPoolV2Config <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPoolV2Config } from '@cdktf/provider-opentelekomcloud'

const lbPoolV2Config: LbPoolV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `lbMethod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.lbMethod"></a>

```typescript
public readonly lbMethod: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#lb_method LbPoolV2#lb_method}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#protocol LbPoolV2#protocol}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#admin_state_up LbPoolV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#description LbPoolV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#id LbPoolV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `listenerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#listener_id LbPoolV2#listener_id}.

---

##### `loadbalancerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#loadbalancer_id LbPoolV2#loadbalancer_id}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#name LbPoolV2#name}.

---

##### `persistence`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.persistence"></a>

```typescript
public readonly persistence: IResolvable | LbPoolV2Persistence[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Persistence`](#@cdktf/provider-opentelekomcloud.LbPoolV2Persistence)[]

persistence block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#persistence LbPoolV2#persistence}

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#region LbPoolV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#tenant_id LbPoolV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbPoolV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#timeouts LbPoolV2#timeouts}

---

### LbPoolV2Persistence <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Persistence"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPoolV2Persistence } from '@cdktf/provider-opentelekomcloud'

const lbPoolV2Persistence: LbPoolV2Persistence = { ... }
```

##### `cookieName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Persistence.property.cookieName"></a>

```typescript
public readonly cookieName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#cookie_name LbPoolV2#cookie_name}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Persistence.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#type LbPoolV2#type}.

---

### LbPoolV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPoolV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbPoolV2Timeouts: LbPoolV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#create LbPoolV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#delete LbPoolV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v2#update LbPoolV2#update}.

---

### LbPoolV3Config <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPoolV3Config } from '@cdktf/provider-opentelekomcloud'

const lbPoolV3Config: LbPoolV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `lbAlgorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.lbAlgorithm"></a>

```typescript
public readonly lbAlgorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#lb_algorithm LbPoolV3#lb_algorithm}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#protocol LbPoolV3#protocol}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#description LbPoolV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#id LbPoolV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `listenerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#listener_id LbPoolV3#listener_id}.

---

##### `loadbalancerId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.loadbalancerId"></a>

```typescript
public readonly loadbalancerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#loadbalancer_id LbPoolV3#loadbalancer_id}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#name LbPoolV3#name}.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#project_id LbPoolV3#project_id}.

---

##### `sessionPersistence`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3Config.property.sessionPersistence"></a>

```typescript
public readonly sessionPersistence: LbPoolV3SessionPersistence;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence`](#@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence)

session_persistence block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#session_persistence LbPoolV3#session_persistence}

---

### LbPoolV3SessionPersistence <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbPoolV3SessionPersistence } from '@cdktf/provider-opentelekomcloud'

const lbPoolV3SessionPersistence: LbPoolV3SessionPersistence = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#type LbPoolV3#type}.

---

##### `cookieName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence.property.cookieName"></a>

```typescript
public readonly cookieName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#cookie_name LbPoolV3#cookie_name}.

---

##### `persistenceTimeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence.property.persistenceTimeout"></a>

```typescript
public readonly persistenceTimeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_pool_v3#persistence_timeout LbPoolV3#persistence_timeout}.

---

### LbRuleV3Config <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbRuleV3Config } from '@cdktf/provider-opentelekomcloud'

const lbRuleV3Config: LbRuleV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#compare_type LbRuleV3#compare_type}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#policy_id LbRuleV3#policy_id}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#type LbRuleV3#type}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#value LbRuleV3#value}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#id LbRuleV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbRuleV3Config.property.projectId"></a>

```typescript
public readonly projectId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_rule_v3#project_id LbRuleV3#project_id}.

---

### LbWhitelistV2Config <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbWhitelistV2Config } from '@cdktf/provider-opentelekomcloud'

const lbWhitelistV2Config: LbWhitelistV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `listenerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.listenerId"></a>

```typescript
public readonly listenerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#listener_id LbWhitelistV2#listener_id}.

---

##### `enableWhitelist`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.enableWhitelist"></a>

```typescript
public readonly enableWhitelist: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#enable_whitelist LbWhitelistV2#enable_whitelist}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#id LbWhitelistV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#tenant_id LbWhitelistV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: LbWhitelistV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#timeouts LbWhitelistV2#timeouts}

---

##### `whitelist`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Config.property.whitelist"></a>

```typescript
public readonly whitelist: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#whitelist LbWhitelistV2#whitelist}.

---

### LbWhitelistV2Timeouts <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LbWhitelistV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const lbWhitelistV2Timeouts: LbWhitelistV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#create LbWhitelistV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#delete LbWhitelistV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/lb_whitelist_v2#update LbWhitelistV2#update}.

---

### LogtankGroupV2Config <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LogtankGroupV2Config } from '@cdktf/provider-opentelekomcloud'

const logtankGroupV2Config: LogtankGroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `groupName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.groupName"></a>

```typescript
public readonly groupName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_group_v2#group_name LogtankGroupV2#group_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankGroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_group_v2#id LogtankGroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### LogtankTopicV2Config <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { LogtankTopicV2Config } from '@cdktf/provider-opentelekomcloud'

const logtankTopicV2Config: LogtankTopicV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `groupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_topic_v2#group_id LogtankTopicV2#group_id}.

---

##### `topicName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_topic_v2#topic_name LogtankTopicV2#topic_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LogtankTopicV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/logtank_topic_v2#id LogtankTopicV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### MrsClusterV1AddJobs <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsClusterV1AddJobs } from '@cdktf/provider-opentelekomcloud'

const mrsClusterV1AddJobs: MrsClusterV1AddJobs = { ... }
```

##### `jarPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.jarPath"></a>

```typescript
public readonly jarPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#jar_path MrsClusterV1#jar_path}.

---

##### `jobName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#job_name MrsClusterV1#job_name}.

---

##### `jobType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.jobType"></a>

```typescript
public readonly jobType: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#job_type MrsClusterV1#job_type}.

---

##### `submitJobOnceClusterRun`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.submitJobOnceClusterRun"></a>

```typescript
public readonly submitJobOnceClusterRun: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#submit_job_once_cluster_run MrsClusterV1#submit_job_once_cluster_run}.

---

##### `arguments`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.arguments"></a>

```typescript
public readonly arguments: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#arguments MrsClusterV1#arguments}.

---

##### `fileAction`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.fileAction"></a>

```typescript
public readonly fileAction: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#file_action MrsClusterV1#file_action}.

---

##### `hiveScriptPath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.hiveScriptPath"></a>

```typescript
public readonly hiveScriptPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#hive_script_path MrsClusterV1#hive_script_path}.

---

##### `hql`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.hql"></a>

```typescript
public readonly hql: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#hql MrsClusterV1#hql}.

---

##### `input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.input"></a>

```typescript
public readonly input: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#input MrsClusterV1#input}.

---

##### `jobLog`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.jobLog"></a>

```typescript
public readonly jobLog: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#job_log MrsClusterV1#job_log}.

---

##### `output`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.output"></a>

```typescript
public readonly output: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#output MrsClusterV1#output}.

---

##### `shutdownCluster`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs.property.shutdownCluster"></a>

```typescript
public readonly shutdownCluster: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#shutdown_cluster MrsClusterV1#shutdown_cluster}.

---

### MrsClusterV1BootstrapScripts <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsClusterV1BootstrapScripts } from '@cdktf/provider-opentelekomcloud'

const mrsClusterV1BootstrapScripts: MrsClusterV1BootstrapScripts = { ... }
```

##### `failAction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.failAction"></a>

```typescript
public readonly failAction: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#fail_action MrsClusterV1#fail_action}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#name MrsClusterV1#name}.

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#nodes MrsClusterV1#nodes}.

---

##### `uri`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#uri MrsClusterV1#uri}.

---

##### `activeMaster`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.activeMaster"></a>

```typescript
public readonly activeMaster: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#active_master MrsClusterV1#active_master}.

---

##### `beforeComponentStart`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.beforeComponentStart"></a>

```typescript
public readonly beforeComponentStart: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#before_component_start MrsClusterV1#before_component_start}.

---

##### `parameters`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts.property.parameters"></a>

```typescript
public readonly parameters: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#parameters MrsClusterV1#parameters}.

---

### MrsClusterV1ComponentList <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsClusterV1ComponentList } from '@cdktf/provider-opentelekomcloud'

const mrsClusterV1ComponentList: MrsClusterV1ComponentList = { ... }
```

##### `componentName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList.property.componentName"></a>

```typescript
public readonly componentName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#component_name MrsClusterV1#component_name}.

---

### MrsClusterV1Config <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsClusterV1Config } from '@cdktf/provider-opentelekomcloud'

const mrsClusterV1Config: MrsClusterV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availableZoneId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.availableZoneId"></a>

```typescript
public readonly availableZoneId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#available_zone_id MrsClusterV1#available_zone_id}.

---

##### `billingType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.billingType"></a>

```typescript
public readonly billingType: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#billing_type MrsClusterV1#billing_type}.

---

##### `clusterName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.clusterName"></a>

```typescript
public readonly clusterName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#cluster_name MrsClusterV1#cluster_name}.

---

##### `clusterVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.clusterVersion"></a>

```typescript
public readonly clusterVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#cluster_version MrsClusterV1#cluster_version}.

---

##### `componentList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.componentList"></a>

```typescript
public readonly componentList: IResolvable | MrsClusterV1ComponentList[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList)[]

component_list block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#component_list MrsClusterV1#component_list}

---

##### `coreNodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.coreNodeNum"></a>

```typescript
public readonly coreNodeNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#core_node_num MrsClusterV1#core_node_num}.

---

##### `coreNodeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.coreNodeSize"></a>

```typescript
public readonly coreNodeSize: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#core_node_size MrsClusterV1#core_node_size}.

---

##### `masterNodeNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.masterNodeNum"></a>

```typescript
public readonly masterNodeNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#master_node_num MrsClusterV1#master_node_num}.

---

##### `masterNodeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.masterNodeSize"></a>

```typescript
public readonly masterNodeSize: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#master_node_size MrsClusterV1#master_node_size}.

---

##### `nodePublicCertName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.nodePublicCertName"></a>

```typescript
public readonly nodePublicCertName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#node_public_cert_name MrsClusterV1#node_public_cert_name}.

---

##### `safeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.safeMode"></a>

```typescript
public readonly safeMode: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#safe_mode MrsClusterV1#safe_mode}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#subnet_id MrsClusterV1#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#vpc_id MrsClusterV1#vpc_id}.

---

##### `addJobs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.addJobs"></a>

```typescript
public readonly addJobs: IResolvable | MrsClusterV1AddJobs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs)[]

add_jobs block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#add_jobs MrsClusterV1#add_jobs}

---

##### `bootstrapScripts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.bootstrapScripts"></a>

```typescript
public readonly bootstrapScripts: IResolvable | MrsClusterV1BootstrapScripts[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts)[]

bootstrap_scripts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#bootstrap_scripts MrsClusterV1#bootstrap_scripts}

---

##### `clusterAdminSecret`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.clusterAdminSecret"></a>

```typescript
public readonly clusterAdminSecret: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#cluster_admin_secret MrsClusterV1#cluster_admin_secret}.

---

##### `clusterType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.clusterType"></a>

```typescript
public readonly clusterType: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#cluster_type MrsClusterV1#cluster_type}.

---

##### `coreDataVolumeCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.coreDataVolumeCount"></a>

```typescript
public readonly coreDataVolumeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#core_data_volume_count MrsClusterV1#core_data_volume_count}.

---

##### `coreDataVolumeSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.coreDataVolumeSize"></a>

```typescript
public readonly coreDataVolumeSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#core_data_volume_size MrsClusterV1#core_data_volume_size}.

---

##### `coreDataVolumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.coreDataVolumeType"></a>

```typescript
public readonly coreDataVolumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#core_data_volume_type MrsClusterV1#core_data_volume_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#id MrsClusterV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `logCollection`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.logCollection"></a>

```typescript
public readonly logCollection: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#log_collection MrsClusterV1#log_collection}.

---

##### `masterDataVolumeCount`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.masterDataVolumeCount"></a>

```typescript
public readonly masterDataVolumeCount: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#master_data_volume_count MrsClusterV1#master_data_volume_count}.

---

##### `masterDataVolumeSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.masterDataVolumeSize"></a>

```typescript
public readonly masterDataVolumeSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#master_data_volume_size MrsClusterV1#master_data_volume_size}.

---

##### `masterDataVolumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.masterDataVolumeType"></a>

```typescript
public readonly masterDataVolumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#master_data_volume_type MrsClusterV1#master_data_volume_type}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#region MrsClusterV1#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#tags MrsClusterV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: MrsClusterV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#timeouts MrsClusterV1#timeouts}

---

##### `volumeSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#volume_size MrsClusterV1#volume_size}.

---

##### `volumeType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Config.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#volume_type MrsClusterV1#volume_type}.

---

### MrsClusterV1Timeouts <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsClusterV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const mrsClusterV1Timeouts: MrsClusterV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#create MrsClusterV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_cluster_v1#delete MrsClusterV1#delete}.

---

### MrsJobV1Config <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsJobV1Config } from '@cdktf/provider-opentelekomcloud'

const mrsJobV1Config: MrsJobV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `clusterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#cluster_id MrsJobV1#cluster_id}.

---

##### `jarPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.jarPath"></a>

```typescript
public readonly jarPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#jar_path MrsJobV1#jar_path}.

---

##### `jobName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#job_name MrsJobV1#job_name}.

---

##### `jobType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.jobType"></a>

```typescript
public readonly jobType: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#job_type MrsJobV1#job_type}.

---

##### `arguments`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.arguments"></a>

```typescript
public readonly arguments: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#arguments MrsJobV1#arguments}.

---

##### `hiveScriptPath`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.hiveScriptPath"></a>

```typescript
public readonly hiveScriptPath: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#hive_script_path MrsJobV1#hive_script_path}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#id MrsJobV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.input"></a>

```typescript
public readonly input: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#input MrsJobV1#input}.

---

##### `isProtected`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.isProtected"></a>

```typescript
public readonly isProtected: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#is_protected MrsJobV1#is_protected}.

---

##### `isPublic`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#is_public MrsJobV1#is_public}.

---

##### `jobLog`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.jobLog"></a>

```typescript
public readonly jobLog: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#job_log MrsJobV1#job_log}.

---

##### `output`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.output"></a>

```typescript
public readonly output: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#output MrsJobV1#output}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#region MrsJobV1#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: MrsJobV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#timeouts MrsJobV1#timeouts}

---

### MrsJobV1Timeouts <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MrsJobV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const mrsJobV1Timeouts: MrsJobV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#create MrsJobV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#delete MrsJobV1#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/mrs_job_v1#update MrsJobV1#update}.

---

### NatDnatRuleV2Config <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatDnatRuleV2Config } from '@cdktf/provider-opentelekomcloud'

const natDnatRuleV2Config: NatDnatRuleV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `externalServicePort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.externalServicePort"></a>

```typescript
public readonly externalServicePort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#external_service_port NatDnatRuleV2#external_service_port}.

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#floating_ip_id NatDnatRuleV2#floating_ip_id}.

---

##### `internalServicePort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.internalServicePort"></a>

```typescript
public readonly internalServicePort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#internal_service_port NatDnatRuleV2#internal_service_port}.

---

##### `natGatewayId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.natGatewayId"></a>

```typescript
public readonly natGatewayId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#nat_gateway_id NatDnatRuleV2#nat_gateway_id}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#protocol NatDnatRuleV2#protocol}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#id NatDnatRuleV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#port_id NatDnatRuleV2#port_id}.

---

##### `privateIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#private_ip NatDnatRuleV2#private_ip}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NatDnatRuleV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#timeouts NatDnatRuleV2#timeouts}

---

### NatDnatRuleV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatDnatRuleV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const natDnatRuleV2Timeouts: NatDnatRuleV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#create NatDnatRuleV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_dnat_rule_v2#delete NatDnatRuleV2#delete}.

---

### NatGatewayV2Config <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatGatewayV2Config } from '@cdktf/provider-opentelekomcloud'

const natGatewayV2Config: NatGatewayV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `internalNetworkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.internalNetworkId"></a>

```typescript
public readonly internalNetworkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#internal_network_id NatGatewayV2#internal_network_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#name NatGatewayV2#name}.

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#router_id NatGatewayV2#router_id}.

---

##### `spec`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.spec"></a>

```typescript
public readonly spec: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#spec NatGatewayV2#spec}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#description NatGatewayV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#id NatGatewayV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#region NatGatewayV2#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#tags NatGatewayV2#tags}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#tenant_id NatGatewayV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NatGatewayV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#timeouts NatGatewayV2#timeouts}

---

### NatGatewayV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatGatewayV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const natGatewayV2Timeouts: NatGatewayV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#create NatGatewayV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_gateway_v2#delete NatGatewayV2#delete}.

---

### NatSnatRuleV2Config <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatSnatRuleV2Config } from '@cdktf/provider-opentelekomcloud'

const natSnatRuleV2Config: NatSnatRuleV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `floatingIpId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.floatingIpId"></a>

```typescript
public readonly floatingIpId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#floating_ip_id NatSnatRuleV2#floating_ip_id}.

---

##### `natGatewayId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.natGatewayId"></a>

```typescript
public readonly natGatewayId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#nat_gateway_id NatSnatRuleV2#nat_gateway_id}.

---

##### `cidr`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#cidr NatSnatRuleV2#cidr}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#id NatSnatRuleV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `networkId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#network_id NatSnatRuleV2#network_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#region NatSnatRuleV2#region}.

---

##### `sourceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.sourceType"></a>

```typescript
public readonly sourceType: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#source_type NatSnatRuleV2#source_type}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NatSnatRuleV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#timeouts NatSnatRuleV2#timeouts}

---

### NatSnatRuleV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NatSnatRuleV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const natSnatRuleV2Timeouts: NatSnatRuleV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#create NatSnatRuleV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/nat_snat_rule_v2#delete NatSnatRuleV2#delete}.

---

### NetworkingFloatingipAssociateV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingFloatingipAssociateV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingFloatingipAssociateV2Config: NetworkingFloatingipAssociateV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `floatingIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.floatingIp"></a>

```typescript
public readonly floatingIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_associate_v2#floating_ip NetworkingFloatingipAssociateV2#floating_ip}.

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_associate_v2#port_id NetworkingFloatingipAssociateV2#port_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_associate_v2#id NetworkingFloatingipAssociateV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipAssociateV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_associate_v2#region NetworkingFloatingipAssociateV2#region}.

---

### NetworkingFloatingipV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingFloatingipV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingFloatingipV2Config: NetworkingFloatingipV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `fixedIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.fixedIp"></a>

```typescript
public readonly fixedIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#fixed_ip NetworkingFloatingipV2#fixed_ip}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#id NetworkingFloatingipV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `pool`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#pool NetworkingFloatingipV2#pool}.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#port_id NetworkingFloatingipV2#port_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#region NetworkingFloatingipV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#tenant_id NetworkingFloatingipV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingFloatingipV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#timeouts NetworkingFloatingipV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#value_specs NetworkingFloatingipV2#value_specs}.

---

### NetworkingFloatingipV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingFloatingipV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingFloatingipV2Timeouts: NetworkingFloatingipV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#create NetworkingFloatingipV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_floatingip_v2#delete NetworkingFloatingipV2#delete}.

---

### NetworkingNetworkV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingNetworkV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingNetworkV2Config: NetworkingNetworkV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#admin_state_up NetworkingNetworkV2#admin_state_up}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#id NetworkingNetworkV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#name NetworkingNetworkV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#region NetworkingNetworkV2#region}.

---

##### `segments`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.segments"></a>

```typescript
public readonly segments: IResolvable | NetworkingNetworkV2Segments[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments)[]

segments block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#segments NetworkingNetworkV2#segments}

---

##### `shared`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.shared"></a>

```typescript
public readonly shared: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#shared NetworkingNetworkV2#shared}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#tenant_id NetworkingNetworkV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingNetworkV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#timeouts NetworkingNetworkV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#value_specs NetworkingNetworkV2#value_specs}.

---

### NetworkingNetworkV2Segments <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingNetworkV2Segments } from '@cdktf/provider-opentelekomcloud'

const networkingNetworkV2Segments: NetworkingNetworkV2Segments = { ... }
```

##### `networkType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments.property.networkType"></a>

```typescript
public readonly networkType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#network_type NetworkingNetworkV2#network_type}.

---

##### `physicalNetwork`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments.property.physicalNetwork"></a>

```typescript
public readonly physicalNetwork: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#physical_network NetworkingNetworkV2#physical_network}.

---

##### `segmentationId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments.property.segmentationId"></a>

```typescript
public readonly segmentationId: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#segmentation_id NetworkingNetworkV2#segmentation_id}.

---

### NetworkingNetworkV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingNetworkV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingNetworkV2Timeouts: NetworkingNetworkV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#create NetworkingNetworkV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2#delete NetworkingNetworkV2#delete}.

---

### NetworkingPortV2AllowedAddressPairs <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingPortV2AllowedAddressPairs } from '@cdktf/provider-opentelekomcloud'

const networkingPortV2AllowedAddressPairs: NetworkingPortV2AllowedAddressPairs = { ... }
```

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#ip_address NetworkingPortV2#ip_address}.

---

##### `macAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#mac_address NetworkingPortV2#mac_address}.

---

### NetworkingPortV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingPortV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingPortV2Config: NetworkingPortV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#network_id NetworkingPortV2#network_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#admin_state_up NetworkingPortV2#admin_state_up}.

---

##### `allowedAddressPairs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.allowedAddressPairs"></a>

```typescript
public readonly allowedAddressPairs: IResolvable | NetworkingPortV2AllowedAddressPairs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs)[]

allowed_address_pairs block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#allowed_address_pairs NetworkingPortV2#allowed_address_pairs}

---

##### `deviceId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#device_id NetworkingPortV2#device_id}.

---

##### `deviceOwner`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.deviceOwner"></a>

```typescript
public readonly deviceOwner: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#device_owner NetworkingPortV2#device_owner}.

---

##### `fixedIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.fixedIp"></a>

```typescript
public readonly fixedIp: IResolvable | NetworkingPortV2FixedIp[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp)[]

fixed_ip block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#fixed_ip NetworkingPortV2#fixed_ip}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#id NetworkingPortV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `macAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#mac_address NetworkingPortV2#mac_address}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#name NetworkingPortV2#name}.

---

##### `noSecurityGroups`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.noSecurityGroups"></a>

```typescript
public readonly noSecurityGroups: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#no_security_groups NetworkingPortV2#no_security_groups}.

---

##### `portSecurityEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.portSecurityEnabled"></a>

```typescript
public readonly portSecurityEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#port_security_enabled NetworkingPortV2#port_security_enabled}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#region NetworkingPortV2#region}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#security_group_ids NetworkingPortV2#security_group_ids}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#tenant_id NetworkingPortV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingPortV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#timeouts NetworkingPortV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#value_specs NetworkingPortV2#value_specs}.

---

### NetworkingPortV2FixedIp <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingPortV2FixedIp } from '@cdktf/provider-opentelekomcloud'

const networkingPortV2FixedIp: NetworkingPortV2FixedIp = { ... }
```

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#subnet_id NetworkingPortV2#subnet_id}.

---

##### `ipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#ip_address NetworkingPortV2#ip_address}.

---

### NetworkingPortV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingPortV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingPortV2Timeouts: NetworkingPortV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#create NetworkingPortV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_port_v2#delete NetworkingPortV2#delete}.

---

### NetworkingRouterInterfaceV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingRouterInterfaceV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingRouterInterfaceV2Config: NetworkingRouterInterfaceV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#router_id NetworkingRouterInterfaceV2#router_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#id NetworkingRouterInterfaceV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#port_id NetworkingRouterInterfaceV2#port_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#region NetworkingRouterInterfaceV2#region}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#subnet_id NetworkingRouterInterfaceV2#subnet_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingRouterInterfaceV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#timeouts NetworkingRouterInterfaceV2#timeouts}

---

### NetworkingRouterInterfaceV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingRouterInterfaceV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingRouterInterfaceV2Timeouts: NetworkingRouterInterfaceV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#create NetworkingRouterInterfaceV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_interface_v2#delete NetworkingRouterInterfaceV2#delete}.

---

### NetworkingRouterRouteV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingRouterRouteV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingRouterRouteV2Config: NetworkingRouterRouteV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `destinationCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.destinationCidr"></a>

```typescript
public readonly destinationCidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2#destination_cidr NetworkingRouterRouteV2#destination_cidr}.

---

##### `nextHop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.nextHop"></a>

```typescript
public readonly nextHop: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2#next_hop NetworkingRouterRouteV2#next_hop}.

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2#router_id NetworkingRouterRouteV2#router_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2#id NetworkingRouterRouteV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterRouteV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_route_v2#region NetworkingRouterRouteV2#region}.

---

### NetworkingRouterV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingRouterV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingRouterV2Config: NetworkingRouterV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#admin_state_up NetworkingRouterV2#admin_state_up}.

---

##### `distributed`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.distributed"></a>

```typescript
public readonly distributed: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#distributed NetworkingRouterV2#distributed}.

---

##### `enableSnat`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.enableSnat"></a>

```typescript
public readonly enableSnat: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#enable_snat NetworkingRouterV2#enable_snat}.

---

##### `externalGateway`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.externalGateway"></a>

```typescript
public readonly externalGateway: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#external_gateway NetworkingRouterV2#external_gateway}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#id NetworkingRouterV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#name NetworkingRouterV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#region NetworkingRouterV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#tenant_id NetworkingRouterV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingRouterV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#timeouts NetworkingRouterV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#value_specs NetworkingRouterV2#value_specs}.

---

### NetworkingRouterV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingRouterV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingRouterV2Timeouts: NetworkingRouterV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#create NetworkingRouterV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_router_v2#delete NetworkingRouterV2#delete}.

---

### NetworkingSecgroupRuleV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSecgroupRuleV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingSecgroupRuleV2Config: NetworkingSecgroupRuleV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `direction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.direction"></a>

```typescript
public readonly direction: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#direction NetworkingSecgroupRuleV2#direction}.

---

##### `ethertype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.ethertype"></a>

```typescript
public readonly ethertype: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#ethertype NetworkingSecgroupRuleV2#ethertype}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#security_group_id NetworkingSecgroupRuleV2#security_group_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#description NetworkingSecgroupRuleV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#id NetworkingSecgroupRuleV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `portRangeMax`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.portRangeMax"></a>

```typescript
public readonly portRangeMax: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#port_range_max NetworkingSecgroupRuleV2#port_range_max}.

---

##### `portRangeMin`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.portRangeMin"></a>

```typescript
public readonly portRangeMin: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#port_range_min NetworkingSecgroupRuleV2#port_range_min}.

---

##### `protocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#protocol NetworkingSecgroupRuleV2#protocol}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#region NetworkingSecgroupRuleV2#region}.

---

##### `remoteGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.remoteGroupId"></a>

```typescript
public readonly remoteGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#remote_group_id NetworkingSecgroupRuleV2#remote_group_id}.

---

##### `remoteIpPrefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.remoteIpPrefix"></a>

```typescript
public readonly remoteIpPrefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#remote_ip_prefix NetworkingSecgroupRuleV2#remote_ip_prefix}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#tenant_id NetworkingSecgroupRuleV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSecgroupRuleV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#timeouts NetworkingSecgroupRuleV2#timeouts}

---

### NetworkingSecgroupRuleV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSecgroupRuleV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingSecgroupRuleV2Timeouts: NetworkingSecgroupRuleV2Timeouts = { ... }
```

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_rule_v2#delete NetworkingSecgroupRuleV2#delete}.

---

### NetworkingSecgroupV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSecgroupV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingSecgroupV2Config: NetworkingSecgroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#name NetworkingSecgroupV2#name}.

---

##### `deleteDefaultRules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.deleteDefaultRules"></a>

```typescript
public readonly deleteDefaultRules: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#delete_default_rules NetworkingSecgroupV2#delete_default_rules}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#description NetworkingSecgroupV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#id NetworkingSecgroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#region NetworkingSecgroupV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#tenant_id NetworkingSecgroupV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSecgroupV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#timeouts NetworkingSecgroupV2#timeouts}

---

### NetworkingSecgroupV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSecgroupV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingSecgroupV2Timeouts: NetworkingSecgroupV2Timeouts = { ... }
```

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_secgroup_v2#delete NetworkingSecgroupV2#delete}.

---

### NetworkingSubnetV2AllocationPools <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSubnetV2AllocationPools } from '@cdktf/provider-opentelekomcloud'

const networkingSubnetV2AllocationPools: NetworkingSubnetV2AllocationPools = { ... }
```

##### `end`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#end NetworkingSubnetV2#end}.

---

##### `start`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools.property.start"></a>

```typescript
public readonly start: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#start NetworkingSubnetV2#start}.

---

### NetworkingSubnetV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSubnetV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingSubnetV2Config: NetworkingSubnetV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#cidr NetworkingSubnetV2#cidr}.

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#network_id NetworkingSubnetV2#network_id}.

---

##### `allocationPools`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.allocationPools"></a>

```typescript
public readonly allocationPools: IResolvable | NetworkingSubnetV2AllocationPools[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools)[]

allocation_pools block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#allocation_pools NetworkingSubnetV2#allocation_pools}

---

##### `dnsNameservers`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.dnsNameservers"></a>

```typescript
public readonly dnsNameservers: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#dns_nameservers NetworkingSubnetV2#dns_nameservers}.

---

##### `enableDhcp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.enableDhcp"></a>

```typescript
public readonly enableDhcp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#enable_dhcp NetworkingSubnetV2#enable_dhcp}.

---

##### `gatewayIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#gateway_ip NetworkingSubnetV2#gateway_ip}.

---

##### `hostRoutes`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.hostRoutes"></a>

```typescript
public readonly hostRoutes: IResolvable | NetworkingSubnetV2HostRoutes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes)[]

host_routes block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#host_routes NetworkingSubnetV2#host_routes}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#id NetworkingSubnetV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipVersion`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.ipVersion"></a>

```typescript
public readonly ipVersion: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#ip_version NetworkingSubnetV2#ip_version}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#name NetworkingSubnetV2#name}.

---

##### `noGateway`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.noGateway"></a>

```typescript
public readonly noGateway: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#no_gateway NetworkingSubnetV2#no_gateway}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#region NetworkingSubnetV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#tenant_id NetworkingSubnetV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: NetworkingSubnetV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#timeouts NetworkingSubnetV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#value_specs NetworkingSubnetV2#value_specs}.

---

### NetworkingSubnetV2HostRoutes <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSubnetV2HostRoutes } from '@cdktf/provider-opentelekomcloud'

const networkingSubnetV2HostRoutes: NetworkingSubnetV2HostRoutes = { ... }
```

##### `destinationCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes.property.destinationCidr"></a>

```typescript
public readonly destinationCidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#destination_cidr NetworkingSubnetV2#destination_cidr}.

---

##### `nextHop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes.property.nextHop"></a>

```typescript
public readonly nextHop: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#next_hop NetworkingSubnetV2#next_hop}.

---

### NetworkingSubnetV2Timeouts <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingSubnetV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const networkingSubnetV2Timeouts: NetworkingSubnetV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#create NetworkingSubnetV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_subnet_v2#delete NetworkingSubnetV2#delete}.

---

### NetworkingVipAssociateV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingVipAssociateV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingVipAssociateV2Config: NetworkingVipAssociateV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `portIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.portIds"></a>

```typescript
public readonly portIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_associate_v2#port_ids NetworkingVipAssociateV2#port_ids}.

---

##### `vipId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.vipId"></a>

```typescript
public readonly vipId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_associate_v2#vip_id NetworkingVipAssociateV2#vip_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipAssociateV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_associate_v2#id NetworkingVipAssociateV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### NetworkingVipV2Config <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NetworkingVipV2Config } from '@cdktf/provider-opentelekomcloud'

const networkingVipV2Config: NetworkingVipV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2#network_id NetworkingVipV2#network_id}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2#subnet_id NetworkingVipV2#subnet_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2#id NetworkingVipV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2#ip_address NetworkingVipV2#ip_address}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingVipV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_vip_v2#name NetworkingVipV2#name}.

---

### ObsBucketConfig <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketConfig } from '@cdktf/provider-opentelekomcloud'

const obsBucketConfig: ObsBucketConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#bucket ObsBucket#bucket}.

---

##### `acl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#acl ObsBucket#acl}.

---

##### `corsRule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.corsRule"></a>

```typescript
public readonly corsRule: IResolvable | ObsBucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRule)[]

cors_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#cors_rule ObsBucket#cors_rule}

---

##### `eventNotifications`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.eventNotifications"></a>

```typescript
public readonly eventNotifications: IResolvable | ObsBucketEventNotifications[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications)[]

event_notifications block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#event_notifications ObsBucket#event_notifications}

---

##### `forceDestroy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#force_destroy ObsBucket#force_destroy}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#id ObsBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `lifecycleRule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: IResolvable | ObsBucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule)[]

lifecycle_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#lifecycle_rule ObsBucket#lifecycle_rule}

---

##### `logging`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.logging"></a>

```typescript
public readonly logging: IResolvable | ObsBucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLogging`](#@cdktf/provider-opentelekomcloud.ObsBucketLogging)[]

logging block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#logging ObsBucket#logging}

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#region ObsBucket#region}.

---

##### `serverSideEncryption`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: ObsBucketServerSideEncryption;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption`](#@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption)

server_side_encryption block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#server_side_encryption ObsBucket#server_side_encryption}

---

##### `storageClass`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#storage_class ObsBucket#storage_class}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#tags ObsBucket#tags}.

---

##### `versioning`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.versioning"></a>

```typescript
public readonly versioning: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#versioning ObsBucket#versioning}.

---

##### `website`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketConfig.property.website"></a>

```typescript
public readonly website: ObsBucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketWebsite`](#@cdktf/provider-opentelekomcloud.ObsBucketWebsite)

website block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#website ObsBucket#website}

---

### ObsBucketCorsRule <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketCorsRule } from '@cdktf/provider-opentelekomcloud'

const obsBucketCorsRule: ObsBucketCorsRule = { ... }
```

##### `allowedMethods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#allowed_methods ObsBucket#allowed_methods}.

---

##### `allowedOrigins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#allowed_origins ObsBucket#allowed_origins}.

---

##### `allowedHeaders`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#allowed_headers ObsBucket#allowed_headers}.

---

##### `exposeHeaders`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#expose_headers ObsBucket#expose_headers}.

---

##### `maxAgeSeconds`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRule.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#max_age_seconds ObsBucket#max_age_seconds}.

---

### ObsBucketEventNotifications <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketEventNotifications } from '@cdktf/provider-opentelekomcloud'

const obsBucketEventNotifications: ObsBucketEventNotifications = { ... }
```

##### `events`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications.property.events"></a>

```typescript
public readonly events: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#events ObsBucket#events}.

---

##### `topic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#topic ObsBucket#topic}.

---

##### `filterRule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications.property.filterRule"></a>

```typescript
public readonly filterRule: IResolvable | ObsBucketEventNotificationsFilterRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule)[]

filter_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#filter_rule ObsBucket#filter_rule}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#id ObsBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### ObsBucketEventNotificationsFilterRule <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketEventNotificationsFilterRule } from '@cdktf/provider-opentelekomcloud'

const obsBucketEventNotificationsFilterRule: ObsBucketEventNotificationsFilterRule = { ... }
```

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#name ObsBucket#name}.

---

##### `value`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#value ObsBucket#value}.

---

### ObsBucketLifecycleRule <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLifecycleRule } from '@cdktf/provider-opentelekomcloud'

const obsBucketLifecycleRule: ObsBucketLifecycleRule = { ... }
```

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#enabled ObsBucket#enabled}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#name ObsBucket#name}.

---

##### `expiration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.expiration"></a>

```typescript
public readonly expiration: IResolvable | ObsBucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration)[]

expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#expiration ObsBucket#expiration}

---

##### `noncurrentVersionExpiration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration)[]

noncurrent_version_expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#noncurrent_version_expiration ObsBucket#noncurrent_version_expiration}

---

##### `noncurrentVersionTransition`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.noncurrentVersionTransition"></a>

```typescript
public readonly noncurrentVersionTransition: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition)[]

noncurrent_version_transition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#noncurrent_version_transition ObsBucket#noncurrent_version_transition}

---

##### `prefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#prefix ObsBucket#prefix}.

---

##### `transition`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule.property.transition"></a>

```typescript
public readonly transition: IResolvable | ObsBucketLifecycleRuleTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition)[]

transition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#transition ObsBucket#transition}

---

### ObsBucketLifecycleRuleExpiration <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleExpiration } from '@cdktf/provider-opentelekomcloud'

const obsBucketLifecycleRuleExpiration: ObsBucketLifecycleRuleExpiration = { ... }
```

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#days ObsBucket#days}.

---

### ObsBucketLifecycleRuleNoncurrentVersionExpiration <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionExpiration } from '@cdktf/provider-opentelekomcloud'

const obsBucketLifecycleRuleNoncurrentVersionExpiration: ObsBucketLifecycleRuleNoncurrentVersionExpiration = { ... }
```

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#days ObsBucket#days}.

---

### ObsBucketLifecycleRuleNoncurrentVersionTransition <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionTransition } from '@cdktf/provider-opentelekomcloud'

const obsBucketLifecycleRuleNoncurrentVersionTransition: ObsBucketLifecycleRuleNoncurrentVersionTransition = { ... }
```

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#days ObsBucket#days}.

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#storage_class ObsBucket#storage_class}.

---

### ObsBucketLifecycleRuleTransition <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleTransition } from '@cdktf/provider-opentelekomcloud'

const obsBucketLifecycleRuleTransition: ObsBucketLifecycleRuleTransition = { ... }
```

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#days ObsBucket#days}.

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#storage_class ObsBucket#storage_class}.

---

### ObsBucketLogging <a name="@cdktf/provider-opentelekomcloud.ObsBucketLogging"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketLogging } from '@cdktf/provider-opentelekomcloud'

const obsBucketLogging: ObsBucketLogging = { ... }
```

##### `targetBucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLogging.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#target_bucket ObsBucket#target_bucket}.

---

##### `targetPrefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLogging.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#target_prefix ObsBucket#target_prefix}.

---

### ObsBucketObjectConfig <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketObjectConfig } from '@cdktf/provider-opentelekomcloud'

const obsBucketObjectConfig: ObsBucketObjectConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#bucket ObsBucketObject#bucket}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#key ObsBucketObject#key}.

---

##### `acl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#acl ObsBucketObject#acl}.

---

##### `content`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#content ObsBucketObject#content}.

---

##### `contentType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#content_type ObsBucketObject#content_type}.

---

##### `encryption`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.encryption"></a>

```typescript
public readonly encryption: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#encryption ObsBucketObject#encryption}.

---

##### `etag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#etag ObsBucketObject#etag}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#id ObsBucketObject#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `kmsKeyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.kmsKeyId"></a>

```typescript
public readonly kmsKeyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#kms_key_id ObsBucketObject#kms_key_id}.

---

##### `source`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#source ObsBucketObject#source}.

---

##### `storageClass`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketObjectConfig.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_object#storage_class ObsBucketObject#storage_class}.

---

### ObsBucketPolicyConfig <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketPolicyConfig } from '@cdktf/provider-opentelekomcloud'

const obsBucketPolicyConfig: ObsBucketPolicyConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_policy#bucket ObsBucketPolicy#bucket}.

---

##### `policy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_policy#policy ObsBucketPolicy#policy}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket_policy#id ObsBucketPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### ObsBucketServerSideEncryption <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketServerSideEncryption } from '@cdktf/provider-opentelekomcloud'

const obsBucketServerSideEncryption: ObsBucketServerSideEncryption = { ... }
```

##### `algorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption.property.algorithm"></a>

```typescript
public readonly algorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#algorithm ObsBucket#algorithm}.

---

##### `kmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption.property.kmsKeyId"></a>

```typescript
public readonly kmsKeyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#kms_key_id ObsBucket#kms_key_id}.

---

### ObsBucketWebsite <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsite"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ObsBucketWebsite } from '@cdktf/provider-opentelekomcloud'

const obsBucketWebsite: ObsBucketWebsite = { ... }
```

##### `errorDocument`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsite.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#error_document ObsBucket#error_document}.

---

##### `indexDocument`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsite.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#index_document ObsBucket#index_document}.

---

##### `redirectAllRequestsTo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsite.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#redirect_all_requests_to ObsBucket#redirect_all_requests_to}.

---

##### `routingRules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsite.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/obs_bucket#routing_rules ObsBucket#routing_rules}.

---

### OpentelekomcloudProviderConfig <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { OpentelekomcloudProviderConfig } from '@cdktf/provider-opentelekomcloud'

const opentelekomcloudProviderConfig: OpentelekomcloudProviderConfig = { ... }
```

##### `accessKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* `string`

The access key for API operations. You can retrieve this from the 'My Credential' section of the console.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#access_key OpentelekomcloudProvider#access_key}

---

##### `agencyDomainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.agencyDomainName"></a>

```typescript
public readonly agencyDomainName: string;
```

- *Type:* `string`

The name of domain who created the agency (Identity v3).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#agency_domain_name OpentelekomcloudProvider#agency_domain_name}

---

##### `agencyName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.agencyName"></a>

```typescript
public readonly agencyName: string;
```

- *Type:* `string`

The name of agency.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#agency_name OpentelekomcloudProvider#agency_name}

---

##### `alias`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* `string`

Alias name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#alias OpentelekomcloudProvider#alias}

---

##### `authUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.authUrl"></a>

```typescript
public readonly authUrl: string;
```

- *Type:* `string`

The Identity authentication URL.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#auth_url OpentelekomcloudProvider#auth_url}

---

##### `cacertFile`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.cacertFile"></a>

```typescript
public readonly cacertFile: string;
```

- *Type:* `string`

A Custom CA certificate.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#cacert_file OpentelekomcloudProvider#cacert_file}

---

##### `cert`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.cert"></a>

```typescript
public readonly cert: string;
```

- *Type:* `string`

A client certificate to authenticate with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#cert OpentelekomcloudProvider#cert}

---

##### `cloud`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.cloud"></a>

```typescript
public readonly cloud: string;
```

- *Type:* `string`

An entry in a `clouds.yaml` file to use.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#cloud OpentelekomcloudProvider#cloud}

---

##### `delegatedProject`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.delegatedProject"></a>

```typescript
public readonly delegatedProject: string;
```

- *Type:* `string`

The name of delegated project (Identity v3).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#delegated_project OpentelekomcloudProvider#delegated_project}

---

##### `domainId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

The ID of the Domain to scope to (Identity v3).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#domain_id OpentelekomcloudProvider#domain_id}

---

##### `domainName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* `string`

The name of the Domain to scope to (Identity v3).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#domain_name OpentelekomcloudProvider#domain_name}

---

##### `endpointType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.endpointType"></a>

```typescript
public readonly endpointType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#endpoint_type OpentelekomcloudProvider#endpoint_type}.

---

##### `insecure`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Trust self-signed certificates.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#insecure OpentelekomcloudProvider#insecure}

---

##### `key`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

A client private key to authenticate with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#key OpentelekomcloudProvider#key}

---

##### `maxRetries`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* `number`

How many times HTTP connection should be retried until giving up.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#max_retries OpentelekomcloudProvider#max_retries}

---

##### `passcode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.passcode"></a>

```typescript
public readonly passcode: string;
```

- *Type:* `string`

One-time MFA passcode.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#passcode OpentelekomcloudProvider#passcode}

---

##### `password`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Password to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#password OpentelekomcloudProvider#password}

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

The OpenTelekomCloud region to connect to.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#region OpentelekomcloudProvider#region}

---

##### `secretKey`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* `string`

The secret key for API operations. You can retrieve this from the 'My Credential' section of the console.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#secret_key OpentelekomcloudProvider#secret_key}

---

##### `securityToken`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.securityToken"></a>

```typescript
public readonly securityToken: string;
```

- *Type:* `string`

Security token to use for OBS federated authentication.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#security_token OpentelekomcloudProvider#security_token}

---

##### `swauth`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.swauth"></a>

```typescript
public readonly swauth: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Use Swift's authentication system instead of Keystone. Only used for interaction with Swift.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#swauth OpentelekomcloudProvider#swauth}

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

The ID of the Tenant (Identity v2) or Project (Identity v3) to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#tenant_id OpentelekomcloudProvider#tenant_id}

---

##### `tenantName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.tenantName"></a>

```typescript
public readonly tenantName: string;
```

- *Type:* `string`

The name of the Tenant (Identity v2) or Project (Identity v3) to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#tenant_name OpentelekomcloudProvider#tenant_name}

---

##### `token`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.token"></a>

```typescript
public readonly token: string;
```

- *Type:* `string`

Authentication token to use as an alternative to username/password.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#token OpentelekomcloudProvider#token}

---

##### `userId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

User ID to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#user_id OpentelekomcloudProvider#user_id}

---

##### `userName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.OpentelekomcloudProviderConfig.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

Username to login with.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud#user_name OpentelekomcloudProvider#user_name}

---

### RdsInstanceV1Backupstrategy <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Backupstrategy } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Backupstrategy: RdsInstanceV1Backupstrategy = { ... }
```

##### `keepdays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy.property.keepdays"></a>

```typescript
public readonly keepdays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#keepdays RdsInstanceV1#keepdays}.

---

##### `starttime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy.property.starttime"></a>

```typescript
public readonly starttime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#starttime RdsInstanceV1#starttime}.

---

### RdsInstanceV1Config <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Config } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Config: RdsInstanceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityzone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.availabilityzone"></a>

```typescript
public readonly availabilityzone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#availabilityzone RdsInstanceV1#availabilityzone}.

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.datastore"></a>

```typescript
public readonly datastore: RdsInstanceV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore)

datastore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#datastore RdsInstanceV1#datastore}

---

##### `dbrtpd`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.dbrtpd"></a>

```typescript
public readonly dbrtpd: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#dbrtpd RdsInstanceV1#dbrtpd}.

---

##### `flavorref`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.flavorref"></a>

```typescript
public readonly flavorref: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#flavorref RdsInstanceV1#flavorref}.

---

##### `nics`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.nics"></a>

```typescript
public readonly nics: RdsInstanceV1Nics;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics)

nics block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#nics RdsInstanceV1#nics}

---

##### `securitygroup`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.securitygroup"></a>

```typescript
public readonly securitygroup: RdsInstanceV1Securitygroup;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup)

securitygroup block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#securitygroup RdsInstanceV1#securitygroup}

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.volume"></a>

```typescript
public readonly volume: RdsInstanceV1Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume)

volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#volume RdsInstanceV1#volume}

---

##### `vpc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.vpc"></a>

```typescript
public readonly vpc: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#vpc RdsInstanceV1#vpc}.

---

##### `backupstrategy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.backupstrategy"></a>

```typescript
public readonly backupstrategy: RdsInstanceV1Backupstrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy)

backupstrategy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#backupstrategy RdsInstanceV1#backupstrategy}

---

##### `dbport`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.dbport"></a>

```typescript
public readonly dbport: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#dbport RdsInstanceV1#dbport}.

---

##### `ha`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.ha"></a>

```typescript
public readonly ha: RdsInstanceV1Ha;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha)

ha block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#ha RdsInstanceV1#ha}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#id RdsInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#name RdsInstanceV1#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#region RdsInstanceV1#region}.

---

##### `tag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.tag"></a>

```typescript
public readonly tag: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#tag RdsInstanceV1#tag}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: RdsInstanceV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#timeouts RdsInstanceV1#timeouts}

---

### RdsInstanceV1Datastore <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Datastore } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Datastore: RdsInstanceV1Datastore = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#type RdsInstanceV1#type}.

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#version RdsInstanceV1#version}.

---

### RdsInstanceV1Ha <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Ha } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Ha: RdsInstanceV1Ha = { ... }
```

##### `enable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha.property.enable"></a>

```typescript
public readonly enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#enable RdsInstanceV1#enable}.

---

##### `replicationmode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha.property.replicationmode"></a>

```typescript
public readonly replicationmode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#replicationmode RdsInstanceV1#replicationmode}.

---

### RdsInstanceV1Nics <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Nics } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Nics: RdsInstanceV1Nics = { ... }
```

##### `subnetid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics.property.subnetid"></a>

```typescript
public readonly subnetid: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#subnetid RdsInstanceV1#subnetid}.

---

### RdsInstanceV1Securitygroup <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Securitygroup } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Securitygroup: RdsInstanceV1Securitygroup = { ... }
```

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#id RdsInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### RdsInstanceV1Timeouts <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Timeouts: RdsInstanceV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#create RdsInstanceV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#delete RdsInstanceV1#delete}.

---

### RdsInstanceV1Volume <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV1Volume } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV1Volume: RdsInstanceV1Volume = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#size RdsInstanceV1#size}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v1#type RdsInstanceV1#type}.

---

### RdsInstanceV3BackupStrategy <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3BackupStrategy } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3BackupStrategy: RdsInstanceV3BackupStrategy = { ... }
```

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#start_time RdsInstanceV3#start_time}.

---

##### `keepDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#keep_days RdsInstanceV3#keep_days}.

---

### RdsInstanceV3Config <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3Config } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3Config: RdsInstanceV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#availability_zone RdsInstanceV3#availability_zone}.

---

##### `db`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.db"></a>

```typescript
public readonly db: RdsInstanceV3Db;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Db`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Db)

db block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#db RdsInstanceV3#db}

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#flavor RdsInstanceV3#flavor}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#name RdsInstanceV3#name}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#security_group_id RdsInstanceV3#security_group_id}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#subnet_id RdsInstanceV3#subnet_id}.

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.volume"></a>

```typescript
public readonly volume: RdsInstanceV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume)

volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#volume RdsInstanceV3#volume}

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#vpc_id RdsInstanceV3#vpc_id}.

---

##### `backupStrategy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.backupStrategy"></a>

```typescript
public readonly backupStrategy: RdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy)

backup_strategy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#backup_strategy RdsInstanceV3#backup_strategy}

---

##### `haReplicationMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.haReplicationMode"></a>

```typescript
public readonly haReplicationMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#ha_replication_mode RdsInstanceV3#ha_replication_mode}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#id RdsInstanceV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `parameters`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#parameters RdsInstanceV3#parameters}.

---

##### `paramGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.paramGroupId"></a>

```typescript
public readonly paramGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#param_group_id RdsInstanceV3#param_group_id}.

---

##### `publicIps`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.publicIps"></a>

```typescript
public readonly publicIps: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#public_ips RdsInstanceV3#public_ips}.

---

##### `restorePoint`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.restorePoint"></a>

```typescript
public readonly restorePoint: RdsInstanceV3RestorePoint;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint)

restore_point block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#restore_point RdsInstanceV3#restore_point}

---

##### `tag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.tag"></a>

```typescript
public readonly tag: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#tag RdsInstanceV3#tag}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#tags RdsInstanceV3#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: RdsInstanceV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#timeouts RdsInstanceV3#timeouts}

---

### RdsInstanceV3Db <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Db"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3Db } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3Db: RdsInstanceV3Db = { ... }
```

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Db.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#password RdsInstanceV3#password}.

---

##### `port`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Db.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#port RdsInstanceV3#port}.

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Db.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#type RdsInstanceV3#type}.

---

##### `version`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Db.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#version RdsInstanceV3#version}.

---

### RdsInstanceV3Nodes <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Nodes"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3Nodes } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3Nodes: RdsInstanceV3Nodes = { ... }
```

### RdsInstanceV3RestorePoint <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3RestorePoint } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3RestorePoint: RdsInstanceV3RestorePoint = { ... }
```

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#instance_id RdsInstanceV3#instance_id}.

---

##### `backupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#backup_id RdsInstanceV3#backup_id}.

---

##### `restoreTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint.property.restoreTime"></a>

```typescript
public readonly restoreTime: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#restore_time RdsInstanceV3#restore_time}.

---

### RdsInstanceV3Timeouts <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3Timeouts: RdsInstanceV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#create RdsInstanceV3#create}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#update RdsInstanceV3#update}.

---

### RdsInstanceV3Volume <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsInstanceV3Volume } from '@cdktf/provider-opentelekomcloud'

const rdsInstanceV3Volume: RdsInstanceV3Volume = { ... }
```

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#size RdsInstanceV3#size}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#type RdsInstanceV3#type}.

---

##### `diskEncryptionId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_instance_v3#disk_encryption_id RdsInstanceV3#disk_encryption_id}.

---

### RdsParametergroupV3Config <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsParametergroupV3Config } from '@cdktf/provider-opentelekomcloud'

const rdsParametergroupV3Config: RdsParametergroupV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `datastore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.datastore"></a>

```typescript
public readonly datastore: RdsParametergroupV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore)

datastore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#datastore RdsParametergroupV3#datastore}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#name RdsParametergroupV3#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#description RdsParametergroupV3#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#id RdsParametergroupV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `values`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Config.property.values"></a>

```typescript
public readonly values: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#values RdsParametergroupV3#values}.

---

### RdsParametergroupV3ConfigurationParameters <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParameters"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsParametergroupV3ConfigurationParameters } from '@cdktf/provider-opentelekomcloud'

const rdsParametergroupV3ConfigurationParameters: RdsParametergroupV3ConfigurationParameters = { ... }
```

### RdsParametergroupV3Datastore <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsParametergroupV3Datastore } from '@cdktf/provider-opentelekomcloud'

const rdsParametergroupV3Datastore: RdsParametergroupV3Datastore = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#type RdsParametergroupV3#type}.

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_parametergroup_v3#version RdsParametergroupV3#version}.

---

### RdsReadReplicaV3Config <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsReadReplicaV3Config } from '@cdktf/provider-opentelekomcloud'

const rdsReadReplicaV3Config: RdsReadReplicaV3Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `flavorRef`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.flavorRef"></a>

```typescript
public readonly flavorRef: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#flavor_ref RdsReadReplicaV3#flavor_ref}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#name RdsReadReplicaV3#name}.

---

##### `replicaOfId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.replicaOfId"></a>

```typescript
public readonly replicaOfId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#replica_of_id RdsReadReplicaV3#replica_of_id}.

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.volume"></a>

```typescript
public readonly volume: RdsReadReplicaV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume)

volume block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#volume RdsReadReplicaV3#volume}

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#availability_zone RdsReadReplicaV3#availability_zone}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#id RdsReadReplicaV3#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `publicIps`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.publicIps"></a>

```typescript
public readonly publicIps: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#public_ips RdsReadReplicaV3#public_ips}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#region RdsReadReplicaV3#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Config.property.timeouts"></a>

```typescript
public readonly timeouts: RdsReadReplicaV3Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#timeouts RdsReadReplicaV3#timeouts}

---

### RdsReadReplicaV3Db <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Db"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsReadReplicaV3Db } from '@cdktf/provider-opentelekomcloud'

const rdsReadReplicaV3Db: RdsReadReplicaV3Db = { ... }
```

### RdsReadReplicaV3Timeouts <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsReadReplicaV3Timeouts } from '@cdktf/provider-opentelekomcloud'

const rdsReadReplicaV3Timeouts: RdsReadReplicaV3Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#create RdsReadReplicaV3#create}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#update RdsReadReplicaV3#update}.

---

### RdsReadReplicaV3Volume <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsReadReplicaV3Volume } from '@cdktf/provider-opentelekomcloud'

const rdsReadReplicaV3Volume: RdsReadReplicaV3Volume = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#type RdsReadReplicaV3#type}.

---

##### `diskEncryptionId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rds_read_replica_v3#disk_encryption_id RdsReadReplicaV3#disk_encryption_id}.

---

### RtsSoftwareConfigV1Config <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsSoftwareConfigV1Config } from '@cdktf/provider-opentelekomcloud'

const rtsSoftwareConfigV1Config: RtsSoftwareConfigV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#name RtsSoftwareConfigV1#name}.

---

##### `config`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.config"></a>

```typescript
public readonly config: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#config RtsSoftwareConfigV1#config}.

---

##### `group`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#group RtsSoftwareConfigV1#group}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#id RtsSoftwareConfigV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `inputValues`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.inputValues"></a>

```typescript
public readonly inputValues: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#input_values RtsSoftwareConfigV1#input_values}.

---

##### `options`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.options"></a>

```typescript
public readonly options: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#options RtsSoftwareConfigV1#options}.

---

##### `outputValues`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.outputValues"></a>

```typescript
public readonly outputValues: IResolvable | {[ key: string ]: string};
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#output_values RtsSoftwareConfigV1#output_values}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#region RtsSoftwareConfigV1#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: RtsSoftwareConfigV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#timeouts RtsSoftwareConfigV1#timeouts}

---

### RtsSoftwareConfigV1Timeouts <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsSoftwareConfigV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const rtsSoftwareConfigV1Timeouts: RtsSoftwareConfigV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#create RtsSoftwareConfigV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_config_v1#delete RtsSoftwareConfigV1#delete}.

---

### RtsSoftwareDeploymentV1Config <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsSoftwareDeploymentV1Config } from '@cdktf/provider-opentelekomcloud'

const rtsSoftwareDeploymentV1Config: RtsSoftwareDeploymentV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `configId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.configId"></a>

```typescript
public readonly configId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#config_id RtsSoftwareDeploymentV1#config_id}.

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#server_id RtsSoftwareDeploymentV1#server_id}.

---

##### `action`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#action RtsSoftwareDeploymentV1#action}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#id RtsSoftwareDeploymentV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `inputValues`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.inputValues"></a>

```typescript
public readonly inputValues: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#input_values RtsSoftwareDeploymentV1#input_values}.

---

##### `outputValues`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.outputValues"></a>

```typescript
public readonly outputValues: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#output_values RtsSoftwareDeploymentV1#output_values}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#region RtsSoftwareDeploymentV1#region}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#status RtsSoftwareDeploymentV1#status}.

---

##### `statusReason`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.statusReason"></a>

```typescript
public readonly statusReason: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#status_reason RtsSoftwareDeploymentV1#status_reason}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#tenant_id RtsSoftwareDeploymentV1#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: RtsSoftwareDeploymentV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#timeouts RtsSoftwareDeploymentV1#timeouts}

---

### RtsSoftwareDeploymentV1Timeouts <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsSoftwareDeploymentV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const rtsSoftwareDeploymentV1Timeouts: RtsSoftwareDeploymentV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#create RtsSoftwareDeploymentV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_software_deployment_v1#delete RtsSoftwareDeploymentV1#delete}.

---

### RtsStackV1Config <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsStackV1Config } from '@cdktf/provider-opentelekomcloud'

const rtsStackV1Config: RtsStackV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#name RtsStackV1#name}.

---

##### `disableRollback`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.disableRollback"></a>

```typescript
public readonly disableRollback: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#disable_rollback RtsStackV1#disable_rollback}.

---

##### `environment`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#environment RtsStackV1#environment}.

---

##### `files`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.files"></a>

```typescript
public readonly files: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#files RtsStackV1#files}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#id RtsStackV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `parameters`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#parameters RtsStackV1#parameters}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#region RtsStackV1#region}.

---

##### `templateBody`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.templateBody"></a>

```typescript
public readonly templateBody: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#template_body RtsStackV1#template_body}.

---

##### `templateUrl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.templateUrl"></a>

```typescript
public readonly templateUrl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#template_url RtsStackV1#template_url}.

---

##### `timeoutMins`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.timeoutMins"></a>

```typescript
public readonly timeoutMins: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#timeout_mins RtsStackV1#timeout_mins}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: RtsStackV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#timeouts RtsStackV1#timeouts}

---

### RtsStackV1Timeouts <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RtsStackV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const rtsStackV1Timeouts: RtsStackV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#create RtsStackV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#delete RtsStackV1#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/rts_stack_v1#update RtsStackV1#update}.

---

### S3BucketConfig <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketConfig } from '@cdktf/provider-opentelekomcloud'

const s3BucketConfig: S3BucketConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `acl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#acl S3Bucket#acl}.

---

##### `arn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.arn"></a>

```typescript
public readonly arn: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#arn S3Bucket#arn}.

---

##### `bucket`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#bucket S3Bucket#bucket}.

---

##### `bucketPrefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.bucketPrefix"></a>

```typescript
public readonly bucketPrefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#bucket_prefix S3Bucket#bucket_prefix}.

---

##### `corsRule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.corsRule"></a>

```typescript
public readonly corsRule: IResolvable | S3BucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketCorsRule`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRule)[]

cors_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#cors_rule S3Bucket#cors_rule}

---

##### `forceDestroy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#force_destroy S3Bucket#force_destroy}.

---

##### `hostedZoneId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.hostedZoneId"></a>

```typescript
public readonly hostedZoneId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#hosted_zone_id S3Bucket#hosted_zone_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#id S3Bucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `lifecycleRule`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: IResolvable | S3BucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule)[]

lifecycle_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#lifecycle_rule S3Bucket#lifecycle_rule}

---

##### `logging`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.logging"></a>

```typescript
public readonly logging: IResolvable | S3BucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLogging`](#@cdktf/provider-opentelekomcloud.S3BucketLogging)[]

logging block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#logging S3Bucket#logging}

---

##### `policy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#policy S3Bucket#policy}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#region S3Bucket#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#tags S3Bucket#tags}.

---

##### `versioning`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.versioning"></a>

```typescript
public readonly versioning: S3BucketVersioning;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketVersioning`](#@cdktf/provider-opentelekomcloud.S3BucketVersioning)

versioning block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#versioning S3Bucket#versioning}

---

##### `website`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.website"></a>

```typescript
public readonly website: S3BucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketWebsite`](#@cdktf/provider-opentelekomcloud.S3BucketWebsite)

website block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#website S3Bucket#website}

---

##### `websiteDomain`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.websiteDomain"></a>

```typescript
public readonly websiteDomain: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#website_domain S3Bucket#website_domain}.

---

##### `websiteEndpoint`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketConfig.property.websiteEndpoint"></a>

```typescript
public readonly websiteEndpoint: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#website_endpoint S3Bucket#website_endpoint}.

---

### S3BucketCorsRule <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketCorsRule } from '@cdktf/provider-opentelekomcloud'

const s3BucketCorsRule: S3BucketCorsRule = { ... }
```

##### `allowedMethods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#allowed_methods S3Bucket#allowed_methods}.

---

##### `allowedOrigins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#allowed_origins S3Bucket#allowed_origins}.

---

##### `allowedHeaders`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#allowed_headers S3Bucket#allowed_headers}.

---

##### `exposeHeaders`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#expose_headers S3Bucket#expose_headers}.

---

##### `maxAgeSeconds`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRule.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#max_age_seconds S3Bucket#max_age_seconds}.

---

### S3BucketLifecycleRule <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketLifecycleRule } from '@cdktf/provider-opentelekomcloud'

const s3BucketLifecycleRule: S3BucketLifecycleRule = { ... }
```

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#enabled S3Bucket#enabled}.

---

##### `abortIncompleteMultipartUploadDays`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.abortIncompleteMultipartUploadDays"></a>

```typescript
public readonly abortIncompleteMultipartUploadDays: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#abort_incomplete_multipart_upload_days S3Bucket#abort_incomplete_multipart_upload_days}.

---

##### `expiration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.expiration"></a>

```typescript
public readonly expiration: IResolvable | S3BucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration)[]

expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#expiration S3Bucket#expiration}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#id S3Bucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `noncurrentVersionExpiration`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: IResolvable | S3BucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration)[]

noncurrent_version_expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#noncurrent_version_expiration S3Bucket#noncurrent_version_expiration}

---

##### `prefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#prefix S3Bucket#prefix}.

---

### S3BucketLifecycleRuleExpiration <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketLifecycleRuleExpiration } from '@cdktf/provider-opentelekomcloud'

const s3BucketLifecycleRuleExpiration: S3BucketLifecycleRuleExpiration = { ... }
```

##### `date`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#date S3Bucket#date}.

---

##### `days`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#days S3Bucket#days}.

---

##### `expiredObjectDeleteMarker`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration.property.expiredObjectDeleteMarker"></a>

```typescript
public readonly expiredObjectDeleteMarker: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#expired_object_delete_marker S3Bucket#expired_object_delete_marker}.

---

### S3BucketLifecycleRuleNoncurrentVersionExpiration <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketLifecycleRuleNoncurrentVersionExpiration } from '@cdktf/provider-opentelekomcloud'

const s3BucketLifecycleRuleNoncurrentVersionExpiration: S3BucketLifecycleRuleNoncurrentVersionExpiration = { ... }
```

##### `days`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#days S3Bucket#days}.

---

### S3BucketLogging <a name="@cdktf/provider-opentelekomcloud.S3BucketLogging"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketLogging } from '@cdktf/provider-opentelekomcloud'

const s3BucketLogging: S3BucketLogging = { ... }
```

##### `targetBucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLogging.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#target_bucket S3Bucket#target_bucket}.

---

##### `targetPrefix`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLogging.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#target_prefix S3Bucket#target_prefix}.

---

### S3BucketObjectConfig <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketObjectConfig } from '@cdktf/provider-opentelekomcloud'

const s3BucketObjectConfig: S3BucketObjectConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#bucket S3BucketObject#bucket}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#key S3BucketObject#key}.

---

##### `acl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#acl S3BucketObject#acl}.

---

##### `cacheControl`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.cacheControl"></a>

```typescript
public readonly cacheControl: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#cache_control S3BucketObject#cache_control}.

---

##### `content`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#content S3BucketObject#content}.

---

##### `contentDisposition`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.contentDisposition"></a>

```typescript
public readonly contentDisposition: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#content_disposition S3BucketObject#content_disposition}.

---

##### `contentEncoding`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#content_encoding S3BucketObject#content_encoding}.

---

##### `contentLanguage`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.contentLanguage"></a>

```typescript
public readonly contentLanguage: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#content_language S3BucketObject#content_language}.

---

##### `contentType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#content_type S3BucketObject#content_type}.

---

##### `etag`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.etag"></a>

```typescript
public readonly etag: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#etag S3BucketObject#etag}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#id S3BucketObject#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `serverSideEncryption`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.serverSideEncryption"></a>

```typescript
public readonly serverSideEncryption: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#server_side_encryption S3BucketObject#server_side_encryption}.

---

##### `source`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#source S3BucketObject#source}.

---

##### `sseKmsKeyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.sseKmsKeyId"></a>

```typescript
public readonly sseKmsKeyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#sse_kms_key_id S3BucketObject#sse_kms_key_id}.

---

##### `websiteRedirect`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketObjectConfig.property.websiteRedirect"></a>

```typescript
public readonly websiteRedirect: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_object#website_redirect S3BucketObject#website_redirect}.

---

### S3BucketPolicyConfig <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketPolicyConfig } from '@cdktf/provider-opentelekomcloud'

const s3BucketPolicyConfig: S3BucketPolicyConfig = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_policy#bucket S3BucketPolicy#bucket}.

---

##### `policy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_policy#policy S3BucketPolicy#policy}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket_policy#id S3BucketPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### S3BucketVersioning <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioning"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketVersioning } from '@cdktf/provider-opentelekomcloud'

const s3BucketVersioning: S3BucketVersioning = { ... }
```

##### `enabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioning.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#enabled S3Bucket#enabled}.

---

##### `mfaDelete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioning.property.mfaDelete"></a>

```typescript
public readonly mfaDelete: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#mfa_delete S3Bucket#mfa_delete}.

---

### S3BucketWebsite <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsite"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { S3BucketWebsite } from '@cdktf/provider-opentelekomcloud'

const s3BucketWebsite: S3BucketWebsite = { ... }
```

##### `errorDocument`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsite.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#error_document S3Bucket#error_document}.

---

##### `indexDocument`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsite.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#index_document S3Bucket#index_document}.

---

##### `redirectAllRequestsTo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsite.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#redirect_all_requests_to S3Bucket#redirect_all_requests_to}.

---

##### `routingRules`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsite.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/s3_bucket#routing_rules S3Bucket#routing_rules}.

---

### SdrsProtectedInstanceV1Config <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SdrsProtectedInstanceV1Config } from '@cdktf/provider-opentelekomcloud'

const sdrsProtectedInstanceV1Config: SdrsProtectedInstanceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `groupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#group_id SdrsProtectedInstanceV1#group_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#name SdrsProtectedInstanceV1#name}.

---

##### `serverId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.serverId"></a>

```typescript
public readonly serverId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#server_id SdrsProtectedInstanceV1#server_id}.

---

##### `deleteTargetEip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.deleteTargetEip"></a>

```typescript
public readonly deleteTargetEip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#delete_target_eip SdrsProtectedInstanceV1#delete_target_eip}.

---

##### `deleteTargetServer`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.deleteTargetServer"></a>

```typescript
public readonly deleteTargetServer: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#delete_target_server SdrsProtectedInstanceV1#delete_target_server}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#description SdrsProtectedInstanceV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#id SdrsProtectedInstanceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#ip_address SdrsProtectedInstanceV1#ip_address}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#subnet_id SdrsProtectedInstanceV1#subnet_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#tags SdrsProtectedInstanceV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: SdrsProtectedInstanceV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#timeouts SdrsProtectedInstanceV1#timeouts}

---

### SdrsProtectedInstanceV1Timeouts <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SdrsProtectedInstanceV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const sdrsProtectedInstanceV1Timeouts: SdrsProtectedInstanceV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#create SdrsProtectedInstanceV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protected_instance_v1#delete SdrsProtectedInstanceV1#delete}.

---

### SdrsProtectiongroupV1Config <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SdrsProtectiongroupV1Config } from '@cdktf/provider-opentelekomcloud'

const sdrsProtectiongroupV1Config: SdrsProtectiongroupV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#domain_id SdrsProtectiongroupV1#domain_id}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#name SdrsProtectiongroupV1#name}.

---

##### `sourceAvailabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.sourceAvailabilityZone"></a>

```typescript
public readonly sourceAvailabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#source_availability_zone SdrsProtectiongroupV1#source_availability_zone}.

---

##### `sourceVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.sourceVpcId"></a>

```typescript
public readonly sourceVpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#source_vpc_id SdrsProtectiongroupV1#source_vpc_id}.

---

##### `targetAvailabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.targetAvailabilityZone"></a>

```typescript
public readonly targetAvailabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#target_availability_zone SdrsProtectiongroupV1#target_availability_zone}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#description SdrsProtectiongroupV1#description}.

---

##### `drType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.drType"></a>

```typescript
public readonly drType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#dr_type SdrsProtectiongroupV1#dr_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#id SdrsProtectiongroupV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: SdrsProtectiongroupV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#timeouts SdrsProtectiongroupV1#timeouts}

---

### SdrsProtectiongroupV1Timeouts <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SdrsProtectiongroupV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const sdrsProtectiongroupV1Timeouts: SdrsProtectiongroupV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#create SdrsProtectiongroupV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sdrs_protectiongroup_v1#delete SdrsProtectiongroupV1#delete}.

---

### SfsFileSystemV2Config <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsFileSystemV2Config } from '@cdktf/provider-opentelekomcloud'

const sfsFileSystemV2Config: SfsFileSystemV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#size SfsFileSystemV2#size}.

---

##### `accessLevel`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.accessLevel"></a>

```typescript
public readonly accessLevel: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#access_level SfsFileSystemV2#access_level}.

---

##### `accessTo`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.accessTo"></a>

```typescript
public readonly accessTo: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#access_to SfsFileSystemV2#access_to}.

---

##### `accessType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.accessType"></a>

```typescript
public readonly accessType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#access_type SfsFileSystemV2#access_type}.

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#availability_zone SfsFileSystemV2#availability_zone}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#description SfsFileSystemV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#id SfsFileSystemV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `isPublic`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#is_public SfsFileSystemV2#is_public}.

---

##### `metadata`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#metadata SfsFileSystemV2#metadata}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#name SfsFileSystemV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#region SfsFileSystemV2#region}.

---

##### `shareProto`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#share_proto SfsFileSystemV2#share_proto}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#tags SfsFileSystemV2#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: SfsFileSystemV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#timeouts SfsFileSystemV2#timeouts}

---

### SfsFileSystemV2Timeouts <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsFileSystemV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const sfsFileSystemV2Timeouts: SfsFileSystemV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#create SfsFileSystemV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_file_system_v2#delete SfsFileSystemV2#delete}.

---

### SfsShareAccessRulesV2AccessRule <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsShareAccessRulesV2AccessRule } from '@cdktf/provider-opentelekomcloud'

const sfsShareAccessRulesV2AccessRule: SfsShareAccessRulesV2AccessRule = { ... }
```

##### `accessLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule.property.accessLevel"></a>

```typescript
public readonly accessLevel: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#access_level SfsShareAccessRulesV2#access_level}.

---

##### `accessTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule.property.accessTo"></a>

```typescript
public readonly accessTo: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#access_to SfsShareAccessRulesV2#access_to}.

---

##### `accessType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule.property.accessType"></a>

```typescript
public readonly accessType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#access_type SfsShareAccessRulesV2#access_type}.

---

### SfsShareAccessRulesV2Config <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsShareAccessRulesV2Config } from '@cdktf/provider-opentelekomcloud'

const sfsShareAccessRulesV2Config: SfsShareAccessRulesV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `accessRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.accessRule"></a>

```typescript
public readonly accessRule: IResolvable | SfsShareAccessRulesV2AccessRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule)[]

access_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#access_rule SfsShareAccessRulesV2#access_rule}

---

##### `shareId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.shareId"></a>

```typescript
public readonly shareId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#share_id SfsShareAccessRulesV2#share_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_share_access_rules_v2#id SfsShareAccessRulesV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### SfsTurboShareV1Config <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsTurboShareV1Config } from '@cdktf/provider-opentelekomcloud'

const sfsTurboShareV1Config: SfsTurboShareV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#availability_zone SfsTurboShareV1#availability_zone}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#name SfsTurboShareV1#name}.

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#security_group_id SfsTurboShareV1#security_group_id}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#size SfsTurboShareV1#size}.

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#subnet_id SfsTurboShareV1#subnet_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#vpc_id SfsTurboShareV1#vpc_id}.

---

##### `cryptKeyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.cryptKeyId"></a>

```typescript
public readonly cryptKeyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#crypt_key_id SfsTurboShareV1#crypt_key_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#id SfsTurboShareV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#region SfsTurboShareV1#region}.

---

##### `shareProto`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.shareProto"></a>

```typescript
public readonly shareProto: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#share_proto SfsTurboShareV1#share_proto}.

---

##### `shareType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#share_type SfsTurboShareV1#share_type}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: SfsTurboShareV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#timeouts SfsTurboShareV1#timeouts}

---

### SfsTurboShareV1Timeouts <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SfsTurboShareV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const sfsTurboShareV1Timeouts: SfsTurboShareV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#create SfsTurboShareV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/sfs_turbo_share_v1#delete SfsTurboShareV1#delete}.

---

### SmnSubscriptionV2Config <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SmnSubscriptionV2Config } from '@cdktf/provider-opentelekomcloud'

const smnSubscriptionV2Config: SmnSubscriptionV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `endpoint`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#endpoint SmnSubscriptionV2#endpoint}.

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#protocol SmnSubscriptionV2#protocol}.

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#topic_urn SmnSubscriptionV2#topic_urn}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#id SmnSubscriptionV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#project_name SmnSubscriptionV2#project_name}.

---

##### `remark`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnSubscriptionV2Config.property.remark"></a>

```typescript
public readonly remark: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_subscription_v2#remark SmnSubscriptionV2#remark}.

---

### SmnTopicAttributeV2Config <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SmnTopicAttributeV2Config } from '@cdktf/provider-opentelekomcloud'

const smnTopicAttributeV2Config: SmnTopicAttributeV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `attributeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.attributeName"></a>

```typescript
public readonly attributeName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_attribute_v2#attribute_name SmnTopicAttributeV2#attribute_name}.

---

##### `topicAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.topicAttribute"></a>

```typescript
public readonly topicAttribute: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_attribute_v2#topic_attribute SmnTopicAttributeV2#topic_attribute}.

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_attribute_v2#topic_urn SmnTopicAttributeV2#topic_urn}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicAttributeV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_attribute_v2#id SmnTopicAttributeV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### SmnTopicV2Config <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SmnTopicV2Config } from '@cdktf/provider-opentelekomcloud'

const smnTopicV2Config: SmnTopicV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_v2#name SmnTopicV2#name}.

---

##### `displayName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.displayName"></a>

```typescript
public readonly displayName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_v2#display_name SmnTopicV2#display_name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_v2#id SmnTopicV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `projectName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SmnTopicV2Config.property.projectName"></a>

```typescript
public readonly projectName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/smn_topic_v2#project_name SmnTopicV2#project_name}.

---

### SwrDomainV2Config <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrDomainV2Config } from '@cdktf/provider-opentelekomcloud'

const swrDomainV2Config: SwrDomainV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `accessDomain`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.accessDomain"></a>

```typescript
public readonly accessDomain: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#access_domain SwrDomainV2#access_domain}.

---

##### `deadline`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.deadline"></a>

```typescript
public readonly deadline: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#deadline SwrDomainV2#deadline}.

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#organization SwrDomainV2#organization}.

---

##### `permission`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.permission"></a>

```typescript
public readonly permission: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#permission SwrDomainV2#permission}.

---

##### `repository`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.repository"></a>

```typescript
public readonly repository: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#repository SwrDomainV2#repository}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#description SwrDomainV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#id SwrDomainV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: SwrDomainV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#timeouts SwrDomainV2#timeouts}

---

### SwrDomainV2Timeouts <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrDomainV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const swrDomainV2Timeouts: SwrDomainV2Timeouts = { ... }
```

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_domain_v2#default SwrDomainV2#default}.

---

### SwrOrganizationPermissionsV2Config <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrOrganizationPermissionsV2Config } from '@cdktf/provider-opentelekomcloud'

const swrOrganizationPermissionsV2Config: SwrOrganizationPermissionsV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `auth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.auth"></a>

```typescript
public readonly auth: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#auth SwrOrganizationPermissionsV2#auth}.

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#organization SwrOrganizationPermissionsV2#organization}.

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#user_id SwrOrganizationPermissionsV2#user_id}.

---

##### `username`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#username SwrOrganizationPermissionsV2#username}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#id SwrOrganizationPermissionsV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: SwrOrganizationPermissionsV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#timeouts SwrOrganizationPermissionsV2#timeouts}

---

### SwrOrganizationPermissionsV2Timeouts <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrOrganizationPermissionsV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const swrOrganizationPermissionsV2Timeouts: SwrOrganizationPermissionsV2Timeouts = { ... }
```

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_permissions_v2#default SwrOrganizationPermissionsV2#default}.

---

### SwrOrganizationV2Config <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrOrganizationV2Config } from '@cdktf/provider-opentelekomcloud'

const swrOrganizationV2Config: SwrOrganizationV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2#name SwrOrganizationV2#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2#id SwrOrganizationV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: SwrOrganizationV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2#timeouts SwrOrganizationV2#timeouts}

---

### SwrOrganizationV2Timeouts <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrOrganizationV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const swrOrganizationV2Timeouts: SwrOrganizationV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2#create SwrOrganizationV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2#delete SwrOrganizationV2#delete}.

---

### SwrRepositoryV2Config <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrRepositoryV2Config } from '@cdktf/provider-opentelekomcloud'

const swrRepositoryV2Config: SwrRepositoryV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `isPublic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.isPublic"></a>

```typescript
public readonly isPublic: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#is_public SwrRepositoryV2#is_public}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#name SwrRepositoryV2#name}.

---

##### `organization`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.organization"></a>

```typescript
public readonly organization: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#organization SwrRepositoryV2#organization}.

---

##### `category`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#category SwrRepositoryV2#category}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#description SwrRepositoryV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#id SwrRepositoryV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: SwrRepositoryV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#timeouts SwrRepositoryV2#timeouts}

---

### SwrRepositoryV2Timeouts <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SwrRepositoryV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const swrRepositoryV2Timeouts: SwrRepositoryV2Timeouts = { ... }
```

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_repository_v2#default SwrRepositoryV2#default}.

---

### VbsBackupPolicyV2Config <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupPolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const vbsBackupPolicyV2Config: VbsBackupPolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#name VbsBackupPolicyV2#name}.

---

##### `retainFirstBackup`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.retainFirstBackup"></a>

```typescript
public readonly retainFirstBackup: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#retain_first_backup VbsBackupPolicyV2#retain_first_backup}.

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#start_time VbsBackupPolicyV2#start_time}.

---

##### `frequency`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.frequency"></a>

```typescript
public readonly frequency: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#frequency VbsBackupPolicyV2#frequency}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#id VbsBackupPolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#region VbsBackupPolicyV2#region}.

---

##### `rententionDay`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.rententionDay"></a>

```typescript
public readonly rententionDay: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#rentention_day VbsBackupPolicyV2#rentention_day}.

---

##### `rententionNum`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.rententionNum"></a>

```typescript
public readonly rententionNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#rentention_num VbsBackupPolicyV2#rentention_num}.

---

##### `resources`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#resources VbsBackupPolicyV2#resources}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#status VbsBackupPolicyV2#status}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.tags"></a>

```typescript
public readonly tags: IResolvable | VbsBackupPolicyV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags)[]

tags block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#tags VbsBackupPolicyV2#tags}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupPolicyV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#timeouts VbsBackupPolicyV2#timeouts}

---

##### `weekFrequency`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Config.property.weekFrequency"></a>

```typescript
public readonly weekFrequency: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#week_frequency VbsBackupPolicyV2#week_frequency}.

---

### VbsBackupPolicyV2Tags <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupPolicyV2Tags } from '@cdktf/provider-opentelekomcloud'

const vbsBackupPolicyV2Tags: VbsBackupPolicyV2Tags = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#key VbsBackupPolicyV2#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#value VbsBackupPolicyV2#value}.

---

### VbsBackupPolicyV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupPolicyV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vbsBackupPolicyV2Timeouts: VbsBackupPolicyV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#create VbsBackupPolicyV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_policy_v2#delete VbsBackupPolicyV2#delete}.

---

### VbsBackupShareV2Config <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupShareV2Config } from '@cdktf/provider-opentelekomcloud'

const vbsBackupShareV2Config: VbsBackupShareV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `backupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#backup_id VbsBackupShareV2#backup_id}.

---

##### `toProjectIds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.toProjectIds"></a>

```typescript
public readonly toProjectIds: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#to_project_ids VbsBackupShareV2#to_project_ids}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#id VbsBackupShareV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#region VbsBackupShareV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupShareV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#timeouts VbsBackupShareV2#timeouts}

---

### VbsBackupShareV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupShareV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vbsBackupShareV2Timeouts: VbsBackupShareV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#create VbsBackupShareV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_share_v2#delete VbsBackupShareV2#delete}.

---

### VbsBackupV2Config <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupV2Config } from '@cdktf/provider-opentelekomcloud'

const vbsBackupV2Config: VbsBackupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#name VbsBackupV2#name}.

---

##### `volumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#volume_id VbsBackupV2#volume_id}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#description VbsBackupV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#id VbsBackupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#region VbsBackupV2#region}.

---

##### `snapshotId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#snapshot_id VbsBackupV2#snapshot_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.tags"></a>

```typescript
public readonly tags: IResolvable | VbsBackupV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Tags)[]

tags block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#tags VbsBackupV2#tags}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VbsBackupV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#timeouts VbsBackupV2#timeouts}

---

### VbsBackupV2Tags <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Tags"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupV2Tags } from '@cdktf/provider-opentelekomcloud'

const vbsBackupV2Tags: VbsBackupV2Tags = { ... }
```

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Tags.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#key VbsBackupV2#key}.

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Tags.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#value VbsBackupV2#value}.

---

### VbsBackupV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VbsBackupV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vbsBackupV2Timeouts: VbsBackupV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#create VbsBackupV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vbs_backup_v2#delete VbsBackupV2#delete}.

---

### VpcBandwidthAssociateV2Config <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcBandwidthAssociateV2Config } from '@cdktf/provider-opentelekomcloud'

const vpcBandwidthAssociateV2Config: VpcBandwidthAssociateV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.bandwidth"></a>

```typescript
public readonly bandwidth: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2#bandwidth VpcBandwidthAssociateV2#bandwidth}.

---

##### `floatingIps`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.floatingIps"></a>

```typescript
public readonly floatingIps: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2#floating_ips VpcBandwidthAssociateV2#floating_ips}.

---

##### `backupChargeMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.backupChargeMode"></a>

```typescript
public readonly backupChargeMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2#backup_charge_mode VpcBandwidthAssociateV2#backup_charge_mode}.

---

##### `backupSize`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.backupSize"></a>

```typescript
public readonly backupSize: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2#backup_size VpcBandwidthAssociateV2#backup_size}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthAssociateV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_associate_v2#id VpcBandwidthAssociateV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### VpcBandwidthV2Config <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcBandwidthV2Config } from '@cdktf/provider-opentelekomcloud'

const vpcBandwidthV2Config: VpcBandwidthV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_v2#name VpcBandwidthV2#name}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_v2#size VpcBandwidthV2#size}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcBandwidthV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_bandwidth_v2#id VpcBandwidthV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### VpcEipV1Bandwidth <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcEipV1Bandwidth } from '@cdktf/provider-opentelekomcloud'

const vpcEipV1Bandwidth: VpcEipV1Bandwidth = { ... }
```

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#name VpcEipV1#name}.

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#share_type VpcEipV1#share_type}.

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#size VpcEipV1#size}.

---

##### `chargeMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth.property.chargeMode"></a>

```typescript
public readonly chargeMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#charge_mode VpcEipV1#charge_mode}.

---

### VpcEipV1Config <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcEipV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcEipV1Config: VpcEipV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.bandwidth"></a>

```typescript
public readonly bandwidth: VpcEipV1Bandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth`](#@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth)

bandwidth block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#bandwidth VpcEipV1#bandwidth}

---

##### `publicip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.publicip"></a>

```typescript
public readonly publicip: VpcEipV1Publicip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Publicip`](#@cdktf/provider-opentelekomcloud.VpcEipV1Publicip)

publicip block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#publicip VpcEipV1#publicip}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#id VpcEipV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#region VpcEipV1#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#tags VpcEipV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcEipV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#timeouts VpcEipV1#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#value_specs VpcEipV1#value_specs}.

---

### VpcEipV1Publicip <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Publicip"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcEipV1Publicip } from '@cdktf/provider-opentelekomcloud'

const vpcEipV1Publicip: VpcEipV1Publicip = { ... }
```

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Publicip.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#type VpcEipV1#type}.

---

##### `ipAddress`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Publicip.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#ip_address VpcEipV1#ip_address}.

---

##### `portId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Publicip.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#port_id VpcEipV1#port_id}.

---

### VpcEipV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcEipV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcEipV1Timeouts: VpcEipV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#create VpcEipV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_eip_v1#delete VpcEipV1#delete}.

---

### VpcepEndpointV1Config <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcepEndpointV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcepEndpointV1Config: VpcepEndpointV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `serviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.serviceId"></a>

```typescript
public readonly serviceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#service_id VpcepEndpointV1#service_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#vpc_id VpcepEndpointV1#vpc_id}.

---

##### `enableDns`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.enableDns"></a>

```typescript
public readonly enableDns: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#enable_dns VpcepEndpointV1#enable_dns}.

---

##### `enableWhitelist`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.enableWhitelist"></a>

```typescript
public readonly enableWhitelist: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#enable_whitelist VpcepEndpointV1#enable_whitelist}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#id VpcepEndpointV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `portIp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.portIp"></a>

```typescript
public readonly portIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#port_ip VpcepEndpointV1#port_ip}.

---

##### `routeTables`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.routeTables"></a>

```typescript
public readonly routeTables: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#route_tables VpcepEndpointV1#route_tables}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#subnet_id VpcepEndpointV1#subnet_id}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#tags VpcepEndpointV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcepEndpointV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#timeouts VpcepEndpointV1#timeouts}

---

##### `whitelist`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Config.property.whitelist"></a>

```typescript
public readonly whitelist: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#whitelist VpcepEndpointV1#whitelist}.

---

### VpcepEndpointV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcepEndpointV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcepEndpointV1Timeouts: VpcepEndpointV1Timeouts = { ... }
```

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_endpoint_v1#default VpcepEndpointV1#default}.

---

### VpcepServiceV1Config <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcepServiceV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcepServiceV1Config: VpcepServiceV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.port"></a>

```typescript
public readonly port: IResolvable | VpcepServiceV1Port[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Port)[]

port block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#port VpcepServiceV1#port}

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#port_id VpcepServiceV1#port_id}.

---

##### `serverType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.serverType"></a>

```typescript
public readonly serverType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#server_type VpcepServiceV1#server_type}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#vpc_id VpcepServiceV1#vpc_id}.

---

##### `approvalEnabled`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.approvalEnabled"></a>

```typescript
public readonly approvalEnabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#approval_enabled VpcepServiceV1#approval_enabled}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#id VpcepServiceV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#name VpcepServiceV1#name}.

---

##### `poolId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#pool_id VpcepServiceV1#pool_id}.

---

##### `serviceType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.serviceType"></a>

```typescript
public readonly serviceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#service_type VpcepServiceV1#service_type}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#tags VpcepServiceV1#tags}.

---

##### `tcpProxy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.tcpProxy"></a>

```typescript
public readonly tcpProxy: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#tcp_proxy VpcepServiceV1#tcp_proxy}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcepServiceV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#timeouts VpcepServiceV1#timeouts}

---

##### `vipPortId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Config.property.vipPortId"></a>

```typescript
public readonly vipPortId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#vip_port_id VpcepServiceV1#vip_port_id}.

---

### VpcepServiceV1Port <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Port"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcepServiceV1Port } from '@cdktf/provider-opentelekomcloud'

const vpcepServiceV1Port: VpcepServiceV1Port = { ... }
```

##### `clientPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Port.property.clientPort"></a>

```typescript
public readonly clientPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#client_port VpcepServiceV1#client_port}.

---

##### `serverPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Port.property.serverPort"></a>

```typescript
public readonly serverPort: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#server_port VpcepServiceV1#server_port}.

---

##### `protocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Port.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#protocol VpcepServiceV1#protocol}.

---

### VpcepServiceV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcepServiceV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcepServiceV1Timeouts: VpcepServiceV1Timeouts = { ... }
```

##### `default`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpcep_service_v1#default VpcepServiceV1#default}.

---

### VpcFlowLogV1Config <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcFlowLogV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcFlowLogV1Config: VpcFlowLogV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `logGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#log_group_id VpcFlowLogV1#log_group_id}.

---

##### `logTopicId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.logTopicId"></a>

```typescript
public readonly logTopicId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#log_topic_id VpcFlowLogV1#log_topic_id}.

---

##### `resourceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#resource_id VpcFlowLogV1#resource_id}.

---

##### `resourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#resource_type VpcFlowLogV1#resource_type}.

---

##### `trafficType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.trafficType"></a>

```typescript
public readonly trafficType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#traffic_type VpcFlowLogV1#traffic_type}.

---

##### `adminState`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.adminState"></a>

```typescript
public readonly adminState: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#admin_state VpcFlowLogV1#admin_state}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#description VpcFlowLogV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#id VpcFlowLogV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#name VpcFlowLogV1#name}.

---

##### `status`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#status VpcFlowLogV1#status}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcFlowLogV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#timeouts VpcFlowLogV1#timeouts}

---

### VpcFlowLogV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcFlowLogV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcFlowLogV1Timeouts: VpcFlowLogV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#create VpcFlowLogV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_flow_log_v1#delete VpcFlowLogV1#delete}.

---

### VpcPeeringConnectionAccepterV2Config <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcPeeringConnectionAccepterV2Config } from '@cdktf/provider-opentelekomcloud'

const vpcPeeringConnectionAccepterV2Config: VpcPeeringConnectionAccepterV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `vpcPeeringConnectionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.vpcPeeringConnectionId"></a>

```typescript
public readonly vpcPeeringConnectionId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#vpc_peering_connection_id VpcPeeringConnectionAccepterV2#vpc_peering_connection_id}.

---

##### `accept`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.accept"></a>

```typescript
public readonly accept: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#accept VpcPeeringConnectionAccepterV2#accept}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#id VpcPeeringConnectionAccepterV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#region VpcPeeringConnectionAccepterV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcPeeringConnectionAccepterV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#timeouts VpcPeeringConnectionAccepterV2#timeouts}

---

### VpcPeeringConnectionAccepterV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcPeeringConnectionAccepterV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcPeeringConnectionAccepterV2Timeouts: VpcPeeringConnectionAccepterV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#create VpcPeeringConnectionAccepterV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_accepter_v2#delete VpcPeeringConnectionAccepterV2#delete}.

---

### VpcPeeringConnectionV2Config <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcPeeringConnectionV2Config } from '@cdktf/provider-opentelekomcloud'

const vpcPeeringConnectionV2Config: VpcPeeringConnectionV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#name VpcPeeringConnectionV2#name}.

---

##### `peerVpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.peerVpcId"></a>

```typescript
public readonly peerVpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#peer_vpc_id VpcPeeringConnectionV2#peer_vpc_id}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#vpc_id VpcPeeringConnectionV2#vpc_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#id VpcPeeringConnectionV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `peerTenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.peerTenantId"></a>

```typescript
public readonly peerTenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#peer_tenant_id VpcPeeringConnectionV2#peer_tenant_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#region VpcPeeringConnectionV2#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcPeeringConnectionV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#timeouts VpcPeeringConnectionV2#timeouts}

---

### VpcPeeringConnectionV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcPeeringConnectionV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcPeeringConnectionV2Timeouts: VpcPeeringConnectionV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#create VpcPeeringConnectionV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_peering_connection_v2#delete VpcPeeringConnectionV2#delete}.

---

### VpcRouteV2Config <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcRouteV2Config } from '@cdktf/provider-opentelekomcloud'

const vpcRouteV2Config: VpcRouteV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `destination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.destination"></a>

```typescript
public readonly destination: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#destination VpcRouteV2#destination}.

---

##### `nexthop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.nexthop"></a>

```typescript
public readonly nexthop: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#nexthop VpcRouteV2#nexthop}.

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#type VpcRouteV2#type}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#vpc_id VpcRouteV2#vpc_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#id VpcRouteV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#region VpcRouteV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#tenant_id VpcRouteV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcRouteV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#timeouts VpcRouteV2#timeouts}

---

### VpcRouteV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcRouteV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcRouteV2Timeouts: VpcRouteV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#create VpcRouteV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_route_v2#delete VpcRouteV2#delete}.

---

### VpcSubnetV1Config <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcSubnetV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcSubnetV1Config: VpcSubnetV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#cidr VpcSubnetV1#cidr}.

---

##### `gatewayIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.gatewayIp"></a>

```typescript
public readonly gatewayIp: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#gateway_ip VpcSubnetV1#gateway_ip}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#name VpcSubnetV1#name}.

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#vpc_id VpcSubnetV1#vpc_id}.

---

##### `availabilityZone`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#availability_zone VpcSubnetV1#availability_zone}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#description VpcSubnetV1#description}.

---

##### `dhcpEnable`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.dhcpEnable"></a>

```typescript
public readonly dhcpEnable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#dhcp_enable VpcSubnetV1#dhcp_enable}.

---

##### `dnsList`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.dnsList"></a>

```typescript
public readonly dnsList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#dns_list VpcSubnetV1#dns_list}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#id VpcSubnetV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ntpAddresses`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.ntpAddresses"></a>

```typescript
public readonly ntpAddresses: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#ntp_addresses VpcSubnetV1#ntp_addresses}.

---

##### `primaryDns`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.primaryDns"></a>

```typescript
public readonly primaryDns: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#primary_dns VpcSubnetV1#primary_dns}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#region VpcSubnetV1#region}.

---

##### `secondaryDns`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.secondaryDns"></a>

```typescript
public readonly secondaryDns: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#secondary_dns VpcSubnetV1#secondary_dns}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#tags VpcSubnetV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSubnetV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#timeouts VpcSubnetV1#timeouts}

---

### VpcSubnetV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcSubnetV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcSubnetV1Timeouts: VpcSubnetV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#create VpcSubnetV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_subnet_v1#delete VpcSubnetV1#delete}.

---

### VpcV1Config <a name="@cdktf/provider-opentelekomcloud.VpcV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcV1Config } from '@cdktf/provider-opentelekomcloud'

const vpcV1Config: VpcV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#cidr VpcV1#cidr}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#name VpcV1#name}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#description VpcV1#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#id VpcV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#region VpcV1#region}.

---

##### `shared`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.shared"></a>

```typescript
public readonly shared: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#shared VpcV1#shared}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#tags VpcV1#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpcV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#timeouts VpcV1#timeouts}

---

### VpcV1Timeouts <a name="@cdktf/provider-opentelekomcloud.VpcV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpcV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpcV1Timeouts: VpcV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#create VpcV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpc_v1#delete VpcV1#delete}.

---

### VpnaasEndpointGroupV2Config <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasEndpointGroupV2Config } from '@cdktf/provider-opentelekomcloud'

const vpnaasEndpointGroupV2Config: VpnaasEndpointGroupV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#description VpnaasEndpointGroupV2#description}.

---

##### `endpoints`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.endpoints"></a>

```typescript
public readonly endpoints: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#endpoints VpnaasEndpointGroupV2#endpoints}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#id VpnaasEndpointGroupV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#name VpnaasEndpointGroupV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#region VpnaasEndpointGroupV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#tenant_id VpnaasEndpointGroupV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasEndpointGroupV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#timeouts VpnaasEndpointGroupV2#timeouts}

---

##### `type`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#type VpnaasEndpointGroupV2#type}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#value_specs VpnaasEndpointGroupV2#value_specs}.

---

### VpnaasEndpointGroupV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasEndpointGroupV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpnaasEndpointGroupV2Timeouts: VpnaasEndpointGroupV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#create VpnaasEndpointGroupV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#delete VpnaasEndpointGroupV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_endpoint_group_v2#update VpnaasEndpointGroupV2#update}.

---

### VpnaasIkePolicyV2Config <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIkePolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const vpnaasIkePolicyV2Config: VpnaasIkePolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `authAlgorithm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.authAlgorithm"></a>

```typescript
public readonly authAlgorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#auth_algorithm VpnaasIkePolicyV2#auth_algorithm}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#description VpnaasIkePolicyV2#description}.

---

##### `encryptionAlgorithm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.encryptionAlgorithm"></a>

```typescript
public readonly encryptionAlgorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#encryption_algorithm VpnaasIkePolicyV2#encryption_algorithm}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#id VpnaasIkePolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ikeVersion`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.ikeVersion"></a>

```typescript
public readonly ikeVersion: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#ike_version VpnaasIkePolicyV2#ike_version}.

---

##### `lifetime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.lifetime"></a>

```typescript
public readonly lifetime: IResolvable | VpnaasIkePolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime)[]

lifetime block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#lifetime VpnaasIkePolicyV2#lifetime}

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#name VpnaasIkePolicyV2#name}.

---

##### `pfs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.pfs"></a>

```typescript
public readonly pfs: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#pfs VpnaasIkePolicyV2#pfs}.

---

##### `phase1NegotiationMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.phase1NegotiationMode"></a>

```typescript
public readonly phase1NegotiationMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#phase1_negotiation_mode VpnaasIkePolicyV2#phase1_negotiation_mode}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#region VpnaasIkePolicyV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#tenant_id VpnaasIkePolicyV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasIkePolicyV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#timeouts VpnaasIkePolicyV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#value_specs VpnaasIkePolicyV2#value_specs}.

---

### VpnaasIkePolicyV2Lifetime <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIkePolicyV2Lifetime } from '@cdktf/provider-opentelekomcloud'

const vpnaasIkePolicyV2Lifetime: VpnaasIkePolicyV2Lifetime = { ... }
```

##### `units`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime.property.units"></a>

```typescript
public readonly units: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#units VpnaasIkePolicyV2#units}.

---

##### `value`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#value VpnaasIkePolicyV2#value}.

---

### VpnaasIkePolicyV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIkePolicyV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpnaasIkePolicyV2Timeouts: VpnaasIkePolicyV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2#create VpnaasIkePolicyV2#create}.

---

### VpnaasIpsecPolicyV2Config <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2Config } from '@cdktf/provider-opentelekomcloud'

const vpnaasIpsecPolicyV2Config: VpnaasIpsecPolicyV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `authAlgorithm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.authAlgorithm"></a>

```typescript
public readonly authAlgorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#auth_algorithm VpnaasIpsecPolicyV2#auth_algorithm}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#description VpnaasIpsecPolicyV2#description}.

---

##### `encapsulationMode`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.encapsulationMode"></a>

```typescript
public readonly encapsulationMode: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#encapsulation_mode VpnaasIpsecPolicyV2#encapsulation_mode}.

---

##### `encryptionAlgorithm`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.encryptionAlgorithm"></a>

```typescript
public readonly encryptionAlgorithm: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#encryption_algorithm VpnaasIpsecPolicyV2#encryption_algorithm}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#id VpnaasIpsecPolicyV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `lifetime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.lifetime"></a>

```typescript
public readonly lifetime: IResolvable | VpnaasIpsecPolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime)[]

lifetime block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#lifetime VpnaasIpsecPolicyV2#lifetime}

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#name VpnaasIpsecPolicyV2#name}.

---

##### `pfs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.pfs"></a>

```typescript
public readonly pfs: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#pfs VpnaasIpsecPolicyV2#pfs}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#region VpnaasIpsecPolicyV2#region}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#tenant_id VpnaasIpsecPolicyV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasIpsecPolicyV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#timeouts VpnaasIpsecPolicyV2#timeouts}

---

##### `transformProtocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.transformProtocol"></a>

```typescript
public readonly transformProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#transform_protocol VpnaasIpsecPolicyV2#transform_protocol}.

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#value_specs VpnaasIpsecPolicyV2#value_specs}.

---

### VpnaasIpsecPolicyV2Lifetime <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2Lifetime } from '@cdktf/provider-opentelekomcloud'

const vpnaasIpsecPolicyV2Lifetime: VpnaasIpsecPolicyV2Lifetime = { ... }
```

##### `units`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime.property.units"></a>

```typescript
public readonly units: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#units VpnaasIpsecPolicyV2#units}.

---

##### `value`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#value VpnaasIpsecPolicyV2#value}.

---

### VpnaasIpsecPolicyV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpnaasIpsecPolicyV2Timeouts: VpnaasIpsecPolicyV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ipsec_policy_v2#create VpnaasIpsecPolicyV2#create}.

---

### VpnaasServiceV2Config <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasServiceV2Config } from '@cdktf/provider-opentelekomcloud'

const vpnaasServiceV2Config: VpnaasServiceV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#router_id VpnaasServiceV2#router_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#admin_state_up VpnaasServiceV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#description VpnaasServiceV2#description}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#id VpnaasServiceV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#name VpnaasServiceV2#name}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#region VpnaasServiceV2#region}.

---

##### `subnetId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#subnet_id VpnaasServiceV2#subnet_id}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#tenant_id VpnaasServiceV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasServiceV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#timeouts VpnaasServiceV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#value_specs VpnaasServiceV2#value_specs}.

---

### VpnaasServiceV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasServiceV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpnaasServiceV2Timeouts: VpnaasServiceV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#create VpnaasServiceV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#delete VpnaasServiceV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_service_v2#update VpnaasServiceV2#update}.

---

### VpnaasSiteConnectionV2Config <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2Config } from '@cdktf/provider-opentelekomcloud'

const vpnaasSiteConnectionV2Config: VpnaasSiteConnectionV2Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `ikepolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.ikepolicyId"></a>

```typescript
public readonly ikepolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#ikepolicy_id VpnaasSiteConnectionV2#ikepolicy_id}.

---

##### `ipsecpolicyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.ipsecpolicyId"></a>

```typescript
public readonly ipsecpolicyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#ipsecpolicy_id VpnaasSiteConnectionV2#ipsecpolicy_id}.

---

##### `peerAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.peerAddress"></a>

```typescript
public readonly peerAddress: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#peer_address VpnaasSiteConnectionV2#peer_address}.

---

##### `peerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.peerId"></a>

```typescript
public readonly peerId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#peer_id VpnaasSiteConnectionV2#peer_id}.

---

##### `psk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.psk"></a>

```typescript
public readonly psk: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#psk VpnaasSiteConnectionV2#psk}.

---

##### `vpnserviceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.vpnserviceId"></a>

```typescript
public readonly vpnserviceId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#vpnservice_id VpnaasSiteConnectionV2#vpnservice_id}.

---

##### `adminStateUp`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.adminStateUp"></a>

```typescript
public readonly adminStateUp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#admin_state_up VpnaasSiteConnectionV2#admin_state_up}.

---

##### `description`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#description VpnaasSiteConnectionV2#description}.

---

##### `dpd`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.dpd"></a>

```typescript
public readonly dpd: IResolvable | VpnaasSiteConnectionV2Dpd[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd)[]

dpd block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#dpd VpnaasSiteConnectionV2#dpd}

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#id VpnaasSiteConnectionV2#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `initiator`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.initiator"></a>

```typescript
public readonly initiator: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#initiator VpnaasSiteConnectionV2#initiator}.

---

##### `localEpGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.localEpGroupId"></a>

```typescript
public readonly localEpGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#local_ep_group_id VpnaasSiteConnectionV2#local_ep_group_id}.

---

##### `localId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.localId"></a>

```typescript
public readonly localId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#local_id VpnaasSiteConnectionV2#local_id}.

---

##### `mtu`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#mtu VpnaasSiteConnectionV2#mtu}.

---

##### `name`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#name VpnaasSiteConnectionV2#name}.

---

##### `peerCidrs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.peerCidrs"></a>

```typescript
public readonly peerCidrs: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#peer_cidrs VpnaasSiteConnectionV2#peer_cidrs}.

---

##### `peerEpGroupId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.peerEpGroupId"></a>

```typescript
public readonly peerEpGroupId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#peer_ep_group_id VpnaasSiteConnectionV2#peer_ep_group_id}.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#region VpnaasSiteConnectionV2#region}.

---

##### `tags`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#tags VpnaasSiteConnectionV2#tags}.

---

##### `tenantId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.tenantId"></a>

```typescript
public readonly tenantId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#tenant_id VpnaasSiteConnectionV2#tenant_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.timeouts"></a>

```typescript
public readonly timeouts: VpnaasSiteConnectionV2Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#timeouts VpnaasSiteConnectionV2#timeouts}

---

##### `valueSpecs`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Config.property.valueSpecs"></a>

```typescript
public readonly valueSpecs: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#value_specs VpnaasSiteConnectionV2#value_specs}.

---

### VpnaasSiteConnectionV2Dpd <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2Dpd } from '@cdktf/provider-opentelekomcloud'

const vpnaasSiteConnectionV2Dpd: VpnaasSiteConnectionV2Dpd = { ... }
```

##### `action`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#action VpnaasSiteConnectionV2#action}.

---

##### `interval`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#interval VpnaasSiteConnectionV2#interval}.

---

##### `timeout`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#timeout VpnaasSiteConnectionV2#timeout}.

---

### VpnaasSiteConnectionV2Timeouts <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2Timeouts } from '@cdktf/provider-opentelekomcloud'

const vpnaasSiteConnectionV2Timeouts: VpnaasSiteConnectionV2Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#create VpnaasSiteConnectionV2#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#delete VpnaasSiteConnectionV2#delete}.

---

##### `update`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_site_connection_v2#update VpnaasSiteConnectionV2#update}.

---

### WafAlarmNotificationV1Config <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafAlarmNotificationV1Config } from '@cdktf/provider-opentelekomcloud'

const wafAlarmNotificationV1Config: WafAlarmNotificationV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#enabled WafAlarmNotificationV1#enabled}.

---

##### `sendFrequency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.sendFrequency"></a>

```typescript
public readonly sendFrequency: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#send_frequency WafAlarmNotificationV1#send_frequency}.

---

##### `threat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.threat"></a>

```typescript
public readonly threat: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#threat WafAlarmNotificationV1#threat}.

---

##### `times`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.times"></a>

```typescript
public readonly times: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#times WafAlarmNotificationV1#times}.

---

##### `topicUrn`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.topicUrn"></a>

```typescript
public readonly topicUrn: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#topic_urn WafAlarmNotificationV1#topic_urn}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#id WafAlarmNotificationV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `locale`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafAlarmNotificationV1Config.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_alarm_notification_v1#locale WafAlarmNotificationV1#locale}.

---

### WafCcattackprotectionRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafCcattackprotectionRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafCcattackprotectionRuleV1Config: WafCcattackprotectionRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `actionCategory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.actionCategory"></a>

```typescript
public readonly actionCategory: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#action_category WafCcattackprotectionRuleV1#action_category}.

---

##### `limitNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.limitNum"></a>

```typescript
public readonly limitNum: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#limit_num WafCcattackprotectionRuleV1#limit_num}.

---

##### `limitPeriod`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.limitPeriod"></a>

```typescript
public readonly limitPeriod: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#limit_period WafCcattackprotectionRuleV1#limit_period}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#policy_id WafCcattackprotectionRuleV1#policy_id}.

---

##### `tagType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.tagType"></a>

```typescript
public readonly tagType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_type WafCcattackprotectionRuleV1#tag_type}.

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#url WafCcattackprotectionRuleV1#url}.

---

##### `blockContent`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.blockContent"></a>

```typescript
public readonly blockContent: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#block_content WafCcattackprotectionRuleV1#block_content}.

---

##### `blockContentType`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.blockContentType"></a>

```typescript
public readonly blockContentType: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#block_content_type WafCcattackprotectionRuleV1#block_content_type}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#id WafCcattackprotectionRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `lockTime`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.lockTime"></a>

```typescript
public readonly lockTime: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#lock_time WafCcattackprotectionRuleV1#lock_time}.

---

##### `tagCategory`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.tagCategory"></a>

```typescript
public readonly tagCategory: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_category WafCcattackprotectionRuleV1#tag_category}.

---

##### `tagContents`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.tagContents"></a>

```typescript
public readonly tagContents: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_contents WafCcattackprotectionRuleV1#tag_contents}.

---

##### `tagIndex`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.tagIndex"></a>

```typescript
public readonly tagIndex: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#tag_index WafCcattackprotectionRuleV1#tag_index}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafCcattackprotectionRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#timeouts WafCcattackprotectionRuleV1#timeouts}

---

### WafCcattackprotectionRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafCcattackprotectionRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafCcattackprotectionRuleV1Timeouts: WafCcattackprotectionRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#create WafCcattackprotectionRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_ccattackprotection_rule_v1#delete WafCcattackprotectionRuleV1#delete}.

---

### WafCertificateV1Config <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafCertificateV1Config } from '@cdktf/provider-opentelekomcloud'

const wafCertificateV1Config: WafCertificateV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#content WafCertificateV1#content}.

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#key WafCertificateV1#key}.

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#name WafCertificateV1#name}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#id WafCertificateV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `region`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#region WafCertificateV1#region}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafCertificateV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#timeouts WafCertificateV1#timeouts}

---

### WafCertificateV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafCertificateV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafCertificateV1Timeouts: WafCertificateV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#create WafCertificateV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_certificate_v1#delete WafCertificateV1#delete}.

---

### WafDatamaskingRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafDatamaskingRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafDatamaskingRuleV1Config: WafDatamaskingRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#category WafDatamaskingRuleV1#category}.

---

##### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#index WafDatamaskingRuleV1#index}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#policy_id WafDatamaskingRuleV1#policy_id}.

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#url WafDatamaskingRuleV1#url}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#id WafDatamaskingRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafDatamaskingRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#timeouts WafDatamaskingRuleV1#timeouts}

---

### WafDatamaskingRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafDatamaskingRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafDatamaskingRuleV1Timeouts: WafDatamaskingRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#create WafDatamaskingRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_datamasking_rule_v1#delete WafDatamaskingRuleV1#delete}.

---

### WafDomainV1Config <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafDomainV1Config } from '@cdktf/provider-opentelekomcloud'

const wafDomainV1Config: WafDomainV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#hostname WafDomainV1#hostname}.

---

##### `proxy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.proxy"></a>

```typescript
public readonly proxy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#proxy WafDomainV1#proxy}.

---

##### `server`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.server"></a>

```typescript
public readonly server: IResolvable | WafDomainV1Server[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Server`](#@cdktf/provider-opentelekomcloud.WafDomainV1Server)[]

server block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#server WafDomainV1#server}

---

##### `certificateId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.certificateId"></a>

```typescript
public readonly certificateId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#certificate_id WafDomainV1#certificate_id}.

---

##### `cipher`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.cipher"></a>

```typescript
public readonly cipher: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#cipher WafDomainV1#cipher}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#id WafDomainV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `policyId`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#policy_id WafDomainV1#policy_id}.

---

##### `sipHeaderList`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.sipHeaderList"></a>

```typescript
public readonly sipHeaderList: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#sip_header_list WafDomainV1#sip_header_list}.

---

##### `sipHeaderName`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.sipHeaderName"></a>

```typescript
public readonly sipHeaderName: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#sip_header_name WafDomainV1#sip_header_name}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafDomainV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#timeouts WafDomainV1#timeouts}

---

##### `tls`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Config.property.tls"></a>

```typescript
public readonly tls: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#tls WafDomainV1#tls}.

---

### WafDomainV1Server <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafDomainV1Server } from '@cdktf/provider-opentelekomcloud'

const wafDomainV1Server: WafDomainV1Server = { ... }
```

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#address WafDomainV1#address}.

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#port WafDomainV1#port}.

---

##### `backProtocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.backProtocol"></a>

```typescript
public readonly backProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#back_protocol WafDomainV1#back_protocol}.

---

##### `clientProtocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.clientProtocol"></a>

```typescript
public readonly clientProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#client_protocol WafDomainV1#client_protocol}.

---

##### `frontProtocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.frontProtocol"></a>

```typescript
public readonly frontProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#front_protocol WafDomainV1#front_protocol}.

---

##### `serverProtocol`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Server.property.serverProtocol"></a>

```typescript
public readonly serverProtocol: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#server_protocol WafDomainV1#server_protocol}.

---

### WafDomainV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafDomainV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafDomainV1Timeouts: WafDomainV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#create WafDomainV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_domain_v1#delete WafDomainV1#delete}.

---

### WafFalsealarmmaskingRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafFalsealarmmaskingRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafFalsealarmmaskingRuleV1Config: WafFalsealarmmaskingRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#policy_id WafFalsealarmmaskingRuleV1#policy_id}.

---

##### `rule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.rule"></a>

```typescript
public readonly rule: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#rule WafFalsealarmmaskingRuleV1#rule}.

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#url WafFalsealarmmaskingRuleV1#url}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#id WafFalsealarmmaskingRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafFalsealarmmaskingRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#timeouts WafFalsealarmmaskingRuleV1#timeouts}

---

### WafFalsealarmmaskingRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafFalsealarmmaskingRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafFalsealarmmaskingRuleV1Timeouts: WafFalsealarmmaskingRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#create WafFalsealarmmaskingRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_falsealarmmasking_rule_v1#delete WafFalsealarmmaskingRuleV1#delete}.

---

### WafPolicyV1Action <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Action"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPolicyV1Action } from '@cdktf/provider-opentelekomcloud'

const wafPolicyV1Action: WafPolicyV1Action = { ... }
```

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Action.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#category WafPolicyV1#category}.

---

### WafPolicyV1Config <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPolicyV1Config } from '@cdktf/provider-opentelekomcloud'

const wafPolicyV1Config: WafPolicyV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#name WafPolicyV1#name}.

---

##### `action`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.action"></a>

```typescript
public readonly action: WafPolicyV1Action;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Action`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Action)

action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#action WafPolicyV1#action}

---

##### `fullDetection`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.fullDetection"></a>

```typescript
public readonly fullDetection: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#full_detection WafPolicyV1#full_detection}.

---

##### `hosts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#hosts WafPolicyV1#hosts}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#id WafPolicyV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `level`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.level"></a>

```typescript
public readonly level: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#level WafPolicyV1#level}.

---

##### `options`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.options"></a>

```typescript
public readonly options: WafPolicyV1Options;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Options`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Options)

options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#options WafPolicyV1#options}

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafPolicyV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#timeouts WafPolicyV1#timeouts}

---

### WafPolicyV1Options <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPolicyV1Options } from '@cdktf/provider-opentelekomcloud'

const wafPolicyV1Options: WafPolicyV1Options = { ... }
```

##### `antitamper`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.antitamper"></a>

```typescript
public readonly antitamper: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#antitamper WafPolicyV1#antitamper}.

---

##### `cc`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.cc"></a>

```typescript
public readonly cc: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#cc WafPolicyV1#cc}.

---

##### `common`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.common"></a>

```typescript
public readonly common: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#common WafPolicyV1#common}.

---

##### `crawler`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.crawler"></a>

```typescript
public readonly crawler: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#crawler WafPolicyV1#crawler}.

---

##### `crawlerEngine`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.crawlerEngine"></a>

```typescript
public readonly crawlerEngine: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#crawler_engine WafPolicyV1#crawler_engine}.

---

##### `crawlerOther`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.crawlerOther"></a>

```typescript
public readonly crawlerOther: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#crawler_other WafPolicyV1#crawler_other}.

---

##### `crawlerScanner`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.crawlerScanner"></a>

```typescript
public readonly crawlerScanner: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#crawler_scanner WafPolicyV1#crawler_scanner}.

---

##### `crawlerScript`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.crawlerScript"></a>

```typescript
public readonly crawlerScript: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#crawler_script WafPolicyV1#crawler_script}.

---

##### `custom`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.custom"></a>

```typescript
public readonly custom: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#custom WafPolicyV1#custom}.

---

##### `ignore`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.ignore"></a>

```typescript
public readonly ignore: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#ignore WafPolicyV1#ignore}.

---

##### `privacy`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.privacy"></a>

```typescript
public readonly privacy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#privacy WafPolicyV1#privacy}.

---

##### `webattack`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.webattack"></a>

```typescript
public readonly webattack: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#webattack WafPolicyV1#webattack}.

---

##### `webshell`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.webshell"></a>

```typescript
public readonly webshell: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#webshell WafPolicyV1#webshell}.

---

##### `whiteblackip`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Options.property.whiteblackip"></a>

```typescript
public readonly whiteblackip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#whiteblackip WafPolicyV1#whiteblackip}.

---

### WafPolicyV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPolicyV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafPolicyV1Timeouts: WafPolicyV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#create WafPolicyV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_policy_v1#delete WafPolicyV1#delete}.

---

### WafPreciseprotectionRuleV1Conditions <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1Conditions } from '@cdktf/provider-opentelekomcloud'

const wafPreciseprotectionRuleV1Conditions: WafPreciseprotectionRuleV1Conditions = { ... }
```

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#category WafPreciseprotectionRuleV1#category}.

---

##### `contents`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions.property.contents"></a>

```typescript
public readonly contents: string[];
```

- *Type:* `string`[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#contents WafPreciseprotectionRuleV1#contents}.

---

##### `logic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions.property.logic"></a>

```typescript
public readonly logic: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#logic WafPreciseprotectionRuleV1#logic}.

---

##### `index`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#index WafPreciseprotectionRuleV1#index}.

---

### WafPreciseprotectionRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafPreciseprotectionRuleV1Config: WafPreciseprotectionRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `actionCategory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.actionCategory"></a>

```typescript
public readonly actionCategory: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#action_category WafPreciseprotectionRuleV1#action_category}.

---

##### `conditions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.conditions"></a>

```typescript
public readonly conditions: IResolvable | WafPreciseprotectionRuleV1Conditions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions)[]

conditions block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#conditions WafPreciseprotectionRuleV1#conditions}

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#name WafPreciseprotectionRuleV1#name}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#policy_id WafPreciseprotectionRuleV1#policy_id}.

---

##### `end`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#end WafPreciseprotectionRuleV1#end}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#id WafPreciseprotectionRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `priority`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#priority WafPreciseprotectionRuleV1#priority}.

---

##### `start`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.start"></a>

```typescript
public readonly start: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#start WafPreciseprotectionRuleV1#start}.

---

##### `time`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.time"></a>

```typescript
public readonly time: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#time WafPreciseprotectionRuleV1#time}.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafPreciseprotectionRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#timeouts WafPreciseprotectionRuleV1#timeouts}

---

### WafPreciseprotectionRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafPreciseprotectionRuleV1Timeouts: WafPreciseprotectionRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#create WafPreciseprotectionRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_preciseprotection_rule_v1#delete WafPreciseprotectionRuleV1#delete}.

---

### WafWebtamperprotectionRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafWebtamperprotectionRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafWebtamperprotectionRuleV1Config: WafWebtamperprotectionRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#hostname WafWebtamperprotectionRuleV1#hostname}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#policy_id WafWebtamperprotectionRuleV1#policy_id}.

---

##### `url`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#url WafWebtamperprotectionRuleV1#url}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#id WafWebtamperprotectionRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafWebtamperprotectionRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#timeouts WafWebtamperprotectionRuleV1#timeouts}

---

### WafWebtamperprotectionRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafWebtamperprotectionRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafWebtamperprotectionRuleV1Timeouts: WafWebtamperprotectionRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#create WafWebtamperprotectionRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_webtamperprotection_rule_v1#delete WafWebtamperprotectionRuleV1#delete}.

---

### WafWhiteblackipRuleV1Config <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafWhiteblackipRuleV1Config } from '@cdktf/provider-opentelekomcloud'

const wafWhiteblackipRuleV1Config: WafWhiteblackipRuleV1Config = { ... }
```

##### `count`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `dependsOn`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* [`cdktf.ITerraformDependable`](#cdktf.ITerraformDependable)[]

---

##### `lifecycle`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* [`cdktf.TerraformResourceLifecycle`](#cdktf.TerraformResourceLifecycle)

---

##### `provider`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* [`cdktf.TerraformProvider`](#cdktf.TerraformProvider)

---

##### `addr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.addr"></a>

```typescript
public readonly addr: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#addr WafWhiteblackipRuleV1#addr}.

---

##### `policyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.policyId"></a>

```typescript
public readonly policyId: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#policy_id WafWhiteblackipRuleV1#policy_id}.

---

##### `id`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#id WafWhiteblackipRuleV1#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.timeouts"></a>

```typescript
public readonly timeouts: WafWhiteblackipRuleV1Timeouts;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts)

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#timeouts WafWhiteblackipRuleV1#timeouts}

---

##### `white`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Config.property.white"></a>

```typescript
public readonly white: number;
```

- *Type:* `number`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#white WafWhiteblackipRuleV1#white}.

---

### WafWhiteblackipRuleV1Timeouts <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { WafWhiteblackipRuleV1Timeouts } from '@cdktf/provider-opentelekomcloud'

const wafWhiteblackipRuleV1Timeouts: WafWhiteblackipRuleV1Timeouts = { ... }
```

##### `create`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#create WafWhiteblackipRuleV1#create}.

---

##### `delete`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/waf_whiteblackip_rule_v1#delete WafWhiteblackipRuleV1#delete}.

---

## Classes <a name="Classes"></a>

### AntiddosV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { AntiddosV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new AntiddosV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AntiddosV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AntiddosV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts`](#@cdktf/provider-opentelekomcloud.AntiddosV1Timeouts)

---


### AsConfigurationV1InstanceConfigDiskList <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigDiskList } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsConfigurationV1InstanceConfigDisk[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk)[]

---


### AsConfigurationV1InstanceConfigDiskOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigDiskOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.resetKmsId"></a>

```typescript
public resetKmsId()
```


#### Properties <a name="Properties"></a>

##### `diskTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.diskTypeInput"></a>

```typescript
public readonly diskTypeInput: string;
```

- *Type:* `string`

---

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `diskType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.diskType"></a>

```typescript
public readonly diskType: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsConfigurationV1InstanceConfigDisk;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk)

---


### AsConfigurationV1InstanceConfigOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `putDisk` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.putDisk"></a>

```typescript
public putDisk(value: IResolvable | AsConfigurationV1InstanceConfigDisk[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk)[]

---

##### `putPersonality` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.putPersonality"></a>

```typescript
public putPersonality(value: IResolvable | AsConfigurationV1InstanceConfigPersonality[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality)[]

---

##### `putPublicIp` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.putPublicIp"></a>

```typescript
public putPublicIp(value: AsConfigurationV1InstanceConfigPublicIp)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp)

---

##### `resetDisk` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetDisk"></a>

```typescript
public resetDisk()
```

##### `resetFlavor` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetFlavor"></a>

```typescript
public resetFlavor()
```

##### `resetImage` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetImage"></a>

```typescript
public resetImage()
```

##### `resetInstanceId` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetInstanceId"></a>

```typescript
public resetInstanceId()
```

##### `resetMetadata` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetMetadata"></a>

```typescript
public resetMetadata()
```

##### `resetPersonality` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetPersonality"></a>

```typescript
public resetPersonality()
```

##### `resetPublicIp` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetPublicIp"></a>

```typescript
public resetPublicIp()
```

##### `resetSecurityGroups` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetSecurityGroups"></a>

```typescript
public resetSecurityGroups()
```

##### `resetUserData` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.resetUserData"></a>

```typescript
public resetUserData()
```


#### Properties <a name="Properties"></a>

##### `disk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.disk"></a>

```typescript
public readonly disk: AsConfigurationV1InstanceConfigDiskList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDiskList)

---

##### `personality`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.personality"></a>

```typescript
public readonly personality: AsConfigurationV1InstanceConfigPersonalityList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList)

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.publicIp"></a>

```typescript
public readonly publicIp: AsConfigurationV1InstanceConfigPublicIpOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference)

---

##### `diskInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.diskInput"></a>

```typescript
public readonly diskInput: IResolvable | AsConfigurationV1InstanceConfigDisk[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigDisk)[]

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.flavorInput"></a>

```typescript
public readonly flavorInput: string;
```

- *Type:* `string`

---

##### `imageInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.imageInput"></a>

```typescript
public readonly imageInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `keyNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.keyNameInput"></a>

```typescript
public readonly keyNameInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `personalityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.personalityInput"></a>

```typescript
public readonly personalityInput: IResolvable | AsConfigurationV1InstanceConfigPersonality[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality)[]

---

##### `publicIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.publicIpInput"></a>

```typescript
public readonly publicIpInput: AsConfigurationV1InstanceConfigPublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp)

---

##### `securityGroupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.securityGroupsInput"></a>

```typescript
public readonly securityGroupsInput: string[];
```

- *Type:* `string`[]

---

##### `userDataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.userDataInput"></a>

```typescript
public readonly userDataInput: string;
```

- *Type:* `string`

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `image`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `keyName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `securityGroups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.securityGroups"></a>

```typescript
public readonly securityGroups: string[];
```

- *Type:* `string`[]

---

##### `userData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.userData"></a>

```typescript
public readonly userData: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsConfigurationV1InstanceConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfig)

---


### AsConfigurationV1InstanceConfigPersonalityList <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPersonalityList } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigPersonalityList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsConfigurationV1InstanceConfigPersonality[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality)[]

---


### AsConfigurationV1InstanceConfigPersonalityOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPersonalityOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigPersonalityOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `contentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.property.contentInput"></a>

```typescript
public readonly contentInput: string;
```

- *Type:* `string`

---

##### `pathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* `string`

---

##### `content`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* `string`

---

##### `path`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonalityOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsConfigurationV1InstanceConfigPersonality;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPersonality)

---


### AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `chargingModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.chargingModeInput"></a>

```typescript
public readonly chargingModeInput: string;
```

- *Type:* `string`

---

##### `shareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.shareTypeInput"></a>

```typescript
public readonly shareTypeInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `chargingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.chargingMode"></a>

```typescript
public readonly chargingMode: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsConfigurationV1InstanceConfigPublicIpEipBandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth)

---


### AsConfigurationV1InstanceConfigPublicIpEipOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIpEipOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigPublicIpEipOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `putBandwidth` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.putBandwidth"></a>

```typescript
public putBandwidth(value: AsConfigurationV1InstanceConfigPublicIpEipBandwidth)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth)

---


#### Properties <a name="Properties"></a>

##### `bandwidth`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.property.bandwidth"></a>

```typescript
public readonly bandwidth: AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidthOutputReference)

---

##### `bandwidthInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.property.bandwidthInput"></a>

```typescript
public readonly bandwidthInput: AsConfigurationV1InstanceConfigPublicIpEipBandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipBandwidth)

---

##### `ipTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.property.ipTypeInput"></a>

```typescript
public readonly ipTypeInput: string;
```

- *Type:* `string`

---

##### `ipType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsConfigurationV1InstanceConfigPublicIpEip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip)

---


### AsConfigurationV1InstanceConfigPublicIpOutputReference <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.Initializer"></a>

```typescript
import { AsConfigurationV1InstanceConfigPublicIpOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsConfigurationV1InstanceConfigPublicIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `putEip` <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.putEip"></a>

```typescript
public putEip(value: AsConfigurationV1InstanceConfigPublicIpEip)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip)

---


#### Properties <a name="Properties"></a>

##### `eip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.property.eip"></a>

```typescript
public readonly eip: AsConfigurationV1InstanceConfigPublicIpEipOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEipOutputReference)

---

##### `eipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.property.eipInput"></a>

```typescript
public readonly eipInput: AsConfigurationV1InstanceConfigPublicIpEip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpEip)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsConfigurationV1InstanceConfigPublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp`](#@cdktf/provider-opentelekomcloud.AsConfigurationV1InstanceConfigPublicIp)

---


### AsGroupV1LbaasListenersList <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.Initializer"></a>

```typescript
import { AsGroupV1LbaasListenersList } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1LbaasListenersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsGroupV1LbaasListeners[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners)[]

---


### AsGroupV1LbaasListenersOutputReference <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.Initializer"></a>

```typescript
import { AsGroupV1LbaasListenersOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1LbaasListenersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetWeight` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.resetWeight"></a>

```typescript
public resetWeight()
```


#### Properties <a name="Properties"></a>

##### `poolIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.poolIdInput"></a>

```typescript
public readonly poolIdInput: string;
```

- *Type:* `string`

---

##### `protocolPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.protocolPortInput"></a>

```typescript
public readonly protocolPortInput: number;
```

- *Type:* `number`

---

##### `weightInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* `number`

---

##### `poolId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.poolId"></a>

```typescript
public readonly poolId: string;
```

- *Type:* `string`

---

##### `protocolPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.protocolPort"></a>

```typescript
public readonly protocolPort: number;
```

- *Type:* `number`

---

##### `weight`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListenersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsGroupV1LbaasListeners;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners`](#@cdktf/provider-opentelekomcloud.AsGroupV1LbaasListeners)

---


### AsGroupV1NetworksList <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.Initializer"></a>

```typescript
import { AsGroupV1NetworksList } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1NetworksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsGroupV1Networks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Networks`](#@cdktf/provider-opentelekomcloud.AsGroupV1Networks)[]

---


### AsGroupV1NetworksOutputReference <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.Initializer"></a>

```typescript
import { AsGroupV1NetworksOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1NetworksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1NetworksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsGroupV1Networks;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Networks`](#@cdktf/provider-opentelekomcloud.AsGroupV1Networks)

---


### AsGroupV1SecurityGroupsOutputReference <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.Initializer"></a>

```typescript
import { AsGroupV1SecurityGroupsOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1SecurityGroupsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroupsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsGroupV1SecurityGroups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups`](#@cdktf/provider-opentelekomcloud.AsGroupV1SecurityGroups)

---


### AsGroupV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { AsGroupV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsGroupV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsGroupV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsGroupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.AsGroupV1Timeouts)

---


### AsPolicyV1ScalingPolicyActionOutputReference <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.Initializer"></a>

```typescript
import { AsPolicyV1ScalingPolicyActionOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV1ScalingPolicyActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetInstanceNumber` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.resetInstanceNumber"></a>

```typescript
public resetInstanceNumber()
```

##### `resetOperation` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.resetOperation"></a>

```typescript
public resetOperation()
```


#### Properties <a name="Properties"></a>

##### `instanceNumberInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.property.instanceNumberInput"></a>

```typescript
public readonly instanceNumberInput: number;
```

- *Type:* `number`

---

##### `operationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.property.operationInput"></a>

```typescript
public readonly operationInput: string;
```

- *Type:* `string`

---

##### `instanceNumber`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.property.instanceNumber"></a>

```typescript
public readonly instanceNumber: number;
```

- *Type:* `number`

---

##### `operation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsPolicyV1ScalingPolicyAction;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScalingPolicyAction)

---


### AsPolicyV1ScheduledPolicyOutputReference <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.Initializer"></a>

```typescript
import { AsPolicyV1ScheduledPolicyOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV1ScheduledPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetEndTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.resetEndTime"></a>

```typescript
public resetEndTime()
```

##### `resetRecurrenceType` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.resetRecurrenceType"></a>

```typescript
public resetRecurrenceType()
```

##### `resetRecurrenceValue` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.resetRecurrenceValue"></a>

```typescript
public resetRecurrenceValue()
```

##### `resetStartTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.resetStartTime"></a>

```typescript
public resetStartTime()
```


#### Properties <a name="Properties"></a>

##### `endTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.endTimeInput"></a>

```typescript
public readonly endTimeInput: string;
```

- *Type:* `string`

---

##### `launchTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.launchTimeInput"></a>

```typescript
public readonly launchTimeInput: string;
```

- *Type:* `string`

---

##### `recurrenceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.recurrenceTypeInput"></a>

```typescript
public readonly recurrenceTypeInput: string;
```

- *Type:* `string`

---

##### `recurrenceValueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.recurrenceValueInput"></a>

```typescript
public readonly recurrenceValueInput: string;
```

- *Type:* `string`

---

##### `startTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* `string`

---

##### `endTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.endTime"></a>

```typescript
public readonly endTime: string;
```

- *Type:* `string`

---

##### `launchTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.launchTime"></a>

```typescript
public readonly launchTime: string;
```

- *Type:* `string`

---

##### `recurrenceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.recurrenceType"></a>

```typescript
public readonly recurrenceType: string;
```

- *Type:* `string`

---

##### `recurrenceValue`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.recurrenceValue"></a>

```typescript
public readonly recurrenceValue: string;
```

- *Type:* `string`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsPolicyV1ScheduledPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV1ScheduledPolicy)

---


### AsPolicyV2MetadataList <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.Initializer"></a>

```typescript
import { AsPolicyV2MetadataList } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2MetadataList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### AsPolicyV2MetadataOutputReference <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.Initializer"></a>

```typescript
import { AsPolicyV2MetadataOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2MetadataOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `bandwidthShareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.property.bandwidthShareType"></a>

```typescript
public readonly bandwidthShareType: string;
```

- *Type:* `string`

---

##### `eipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.property.eipAddress"></a>

```typescript
public readonly eipAddress: string;
```

- *Type:* `string`

---

##### `eipId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.property.eipId"></a>

```typescript
public readonly eipId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2MetadataOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AsPolicyV2Metadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.AsPolicyV2Metadata`](#@cdktf/provider-opentelekomcloud.AsPolicyV2Metadata)

---


### AsPolicyV2ScalingPolicyActionList <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.Initializer"></a>

```typescript
import { AsPolicyV2ScalingPolicyActionList } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2ScalingPolicyActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsPolicyV2ScalingPolicyAction[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction)[]

---


### AsPolicyV2ScalingPolicyActionOutputReference <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.Initializer"></a>

```typescript
import { AsPolicyV2ScalingPolicyActionOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2ScalingPolicyActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetLimits` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.resetLimits"></a>

```typescript
public resetLimits()
```

##### `resetOperation` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.resetOperation"></a>

```typescript
public resetOperation()
```

##### `resetPercentage` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.resetPercentage"></a>

```typescript
public resetPercentage()
```

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.resetSize"></a>

```typescript
public resetSize()
```


#### Properties <a name="Properties"></a>

##### `limitsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.limitsInput"></a>

```typescript
public readonly limitsInput: number;
```

- *Type:* `number`

---

##### `operationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.operationInput"></a>

```typescript
public readonly operationInput: string;
```

- *Type:* `string`

---

##### `percentageInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.percentageInput"></a>

```typescript
public readonly percentageInput: number;
```

- *Type:* `number`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `limits`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.limits"></a>

```typescript
public readonly limits: number;
```

- *Type:* `number`

---

##### `operation`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* `string`

---

##### `percentage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.percentage"></a>

```typescript
public readonly percentage: number;
```

- *Type:* `number`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsPolicyV2ScalingPolicyAction;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScalingPolicyAction)

---


### AsPolicyV2ScheduledPolicyList <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.Initializer"></a>

```typescript
import { AsPolicyV2ScheduledPolicyList } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2ScheduledPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsPolicyV2ScheduledPolicy[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy)[]

---


### AsPolicyV2ScheduledPolicyOutputReference <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.Initializer"></a>

```typescript
import { AsPolicyV2ScheduledPolicyOutputReference } from '@cdktf/provider-opentelekomcloud'

new AsPolicyV2ScheduledPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetEndTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.resetEndTime"></a>

```typescript
public resetEndTime()
```

##### `resetRecurrenceType` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.resetRecurrenceType"></a>

```typescript
public resetRecurrenceType()
```

##### `resetRecurrenceValue` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.resetRecurrenceValue"></a>

```typescript
public resetRecurrenceValue()
```

##### `resetStartTime` <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.resetStartTime"></a>

```typescript
public resetStartTime()
```


#### Properties <a name="Properties"></a>

##### `endTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.endTimeInput"></a>

```typescript
public readonly endTimeInput: string;
```

- *Type:* `string`

---

##### `launchTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.launchTimeInput"></a>

```typescript
public readonly launchTimeInput: string;
```

- *Type:* `string`

---

##### `recurrenceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.recurrenceTypeInput"></a>

```typescript
public readonly recurrenceTypeInput: string;
```

- *Type:* `string`

---

##### `recurrenceValueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.recurrenceValueInput"></a>

```typescript
public readonly recurrenceValueInput: string;
```

- *Type:* `string`

---

##### `startTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* `string`

---

##### `endTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.endTime"></a>

```typescript
public readonly endTime: string;
```

- *Type:* `string`

---

##### `launchTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.launchTime"></a>

```typescript
public readonly launchTime: string;
```

- *Type:* `string`

---

##### `recurrenceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.recurrenceType"></a>

```typescript
public readonly recurrenceType: string;
```

- *Type:* `string`

---

##### `recurrenceValue`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.recurrenceValue"></a>

```typescript
public readonly recurrenceValue: string;
```

- *Type:* `string`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AsPolicyV2ScheduledPolicy;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy`](#@cdktf/provider-opentelekomcloud.AsPolicyV2ScheduledPolicy)

---


### BlockstorageVolumeV2AttachmentList <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.Initializer"></a>

```typescript
import { BlockstorageVolumeV2AttachmentList } from '@cdktf/provider-opentelekomcloud'

new BlockstorageVolumeV2AttachmentList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### BlockstorageVolumeV2AttachmentOutputReference <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.Initializer"></a>

```typescript
import { BlockstorageVolumeV2AttachmentOutputReference } from '@cdktf/provider-opentelekomcloud'

new BlockstorageVolumeV2AttachmentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `device`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2AttachmentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: BlockstorageVolumeV2Attachment;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Attachment`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Attachment)

---


### BlockstorageVolumeV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { BlockstorageVolumeV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new BlockstorageVolumeV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | BlockstorageVolumeV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts`](#@cdktf/provider-opentelekomcloud.BlockstorageVolumeV2Timeouts)

---


### CbrPolicyV3OperationDefinitionOutputReference <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.Initializer"></a>

```typescript
import { CbrPolicyV3OperationDefinitionOutputReference } from '@cdktf/provider-opentelekomcloud'

new CbrPolicyV3OperationDefinitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDayBackups` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetDayBackups"></a>

```typescript
public resetDayBackups()
```

##### `resetMaxBackups` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetMaxBackups"></a>

```typescript
public resetMaxBackups()
```

##### `resetMonthBackups` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetMonthBackups"></a>

```typescript
public resetMonthBackups()
```

##### `resetRetentionDurationDays` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetRetentionDurationDays"></a>

```typescript
public resetRetentionDurationDays()
```

##### `resetWeekBackups` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetWeekBackups"></a>

```typescript
public resetWeekBackups()
```

##### `resetYearBackups` <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.resetYearBackups"></a>

```typescript
public resetYearBackups()
```


#### Properties <a name="Properties"></a>

##### `dayBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.dayBackupsInput"></a>

```typescript
public readonly dayBackupsInput: number;
```

- *Type:* `number`

---

##### `maxBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.maxBackupsInput"></a>

```typescript
public readonly maxBackupsInput: number;
```

- *Type:* `number`

---

##### `monthBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.monthBackupsInput"></a>

```typescript
public readonly monthBackupsInput: number;
```

- *Type:* `number`

---

##### `retentionDurationDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.retentionDurationDaysInput"></a>

```typescript
public readonly retentionDurationDaysInput: number;
```

- *Type:* `number`

---

##### `timezoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.timezoneInput"></a>

```typescript
public readonly timezoneInput: string;
```

- *Type:* `string`

---

##### `weekBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.weekBackupsInput"></a>

```typescript
public readonly weekBackupsInput: number;
```

- *Type:* `number`

---

##### `yearBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.yearBackupsInput"></a>

```typescript
public readonly yearBackupsInput: number;
```

- *Type:* `number`

---

##### `dayBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.dayBackups"></a>

```typescript
public readonly dayBackups: number;
```

- *Type:* `number`

---

##### `maxBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.maxBackups"></a>

```typescript
public readonly maxBackups: number;
```

- *Type:* `number`

---

##### `monthBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.monthBackups"></a>

```typescript
public readonly monthBackups: number;
```

- *Type:* `number`

---

##### `retentionDurationDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.retentionDurationDays"></a>

```typescript
public readonly retentionDurationDays: number;
```

- *Type:* `number`

---

##### `timezone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* `string`

---

##### `weekBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.weekBackups"></a>

```typescript
public readonly weekBackups: number;
```

- *Type:* `number`

---

##### `yearBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.yearBackups"></a>

```typescript
public readonly yearBackups: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CbrPolicyV3OperationDefinition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition`](#@cdktf/provider-opentelekomcloud.CbrPolicyV3OperationDefinition)

---


### CbrVaultV3BillingOutputReference <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.Initializer"></a>

```typescript
import { CbrVaultV3BillingOutputReference } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3BillingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetChargingMode` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetChargingMode"></a>

```typescript
public resetChargingMode()
```

##### `resetCloudType` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetCloudType"></a>

```typescript
public resetCloudType()
```

##### `resetConsistentLevel` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetConsistentLevel"></a>

```typescript
public resetConsistentLevel()
```

##### `resetConsoleUrl` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetConsoleUrl"></a>

```typescript
public resetConsoleUrl()
```

##### `resetExtraInfo` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetExtraInfo"></a>

```typescript
public resetExtraInfo()
```

##### `resetIsAutoPay` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetIsAutoPay"></a>

```typescript
public resetIsAutoPay()
```

##### `resetIsAutoRenew` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetIsAutoRenew"></a>

```typescript
public resetIsAutoRenew()
```

##### `resetPeriodNum` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetPeriodNum"></a>

```typescript
public resetPeriodNum()
```

##### `resetPeriodType` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.resetPeriodType"></a>

```typescript
public resetPeriodType()
```


#### Properties <a name="Properties"></a>

##### `allocated`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.allocated"></a>

```typescript
public readonly allocated: number;
```

- *Type:* `number`

---

##### `frozenScene`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.frozenScene"></a>

```typescript
public readonly frozenScene: string;
```

- *Type:* `string`

---

##### `orderId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.orderId"></a>

```typescript
public readonly orderId: string;
```

- *Type:* `string`

---

##### `productId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.productId"></a>

```typescript
public readonly productId: string;
```

- *Type:* `string`

---

##### `specCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `storageUnit`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.storageUnit"></a>

```typescript
public readonly storageUnit: string;
```

- *Type:* `string`

---

##### `used`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.used"></a>

```typescript
public readonly used: number;
```

- *Type:* `number`

---

##### `chargingModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.chargingModeInput"></a>

```typescript
public readonly chargingModeInput: string;
```

- *Type:* `string`

---

##### `cloudTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.cloudTypeInput"></a>

```typescript
public readonly cloudTypeInput: string;
```

- *Type:* `string`

---

##### `consistentLevelInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.consistentLevelInput"></a>

```typescript
public readonly consistentLevelInput: string;
```

- *Type:* `string`

---

##### `consoleUrlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.consoleUrlInput"></a>

```typescript
public readonly consoleUrlInput: string;
```

- *Type:* `string`

---

##### `extraInfoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.extraInfoInput"></a>

```typescript
public readonly extraInfoInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `isAutoPayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.isAutoPayInput"></a>

```typescript
public readonly isAutoPayInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isAutoRenewInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.isAutoRenewInput"></a>

```typescript
public readonly isAutoRenewInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `objectTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.objectTypeInput"></a>

```typescript
public readonly objectTypeInput: string;
```

- *Type:* `string`

---

##### `periodNumInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.periodNumInput"></a>

```typescript
public readonly periodNumInput: number;
```

- *Type:* `number`

---

##### `periodTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.periodTypeInput"></a>

```typescript
public readonly periodTypeInput: string;
```

- *Type:* `string`

---

##### `protectTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.protectTypeInput"></a>

```typescript
public readonly protectTypeInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `chargingMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.chargingMode"></a>

```typescript
public readonly chargingMode: string;
```

- *Type:* `string`

---

##### `cloudType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.cloudType"></a>

```typescript
public readonly cloudType: string;
```

- *Type:* `string`

---

##### `consistentLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.consistentLevel"></a>

```typescript
public readonly consistentLevel: string;
```

- *Type:* `string`

---

##### `consoleUrl`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.consoleUrl"></a>

```typescript
public readonly consoleUrl: string;
```

- *Type:* `string`

---

##### `extraInfo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.extraInfo"></a>

```typescript
public readonly extraInfo: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `isAutoPay`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.isAutoPay"></a>

```typescript
public readonly isAutoPay: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `isAutoRenew`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.isAutoRenew"></a>

```typescript
public readonly isAutoRenew: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `objectType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.objectType"></a>

```typescript
public readonly objectType: string;
```

- *Type:* `string`

---

##### `periodNum`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.periodNum"></a>

```typescript
public readonly periodNum: number;
```

- *Type:* `number`

---

##### `periodType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

---

##### `protectType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.protectType"></a>

```typescript
public readonly protectType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BillingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CbrVaultV3Billing;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CbrVaultV3Billing`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Billing)

---


### CbrVaultV3BindRulesList <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.Initializer"></a>

```typescript
import { CbrVaultV3BindRulesList } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3BindRulesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CbrVaultV3BindRules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules)[]

---


### CbrVaultV3BindRulesOutputReference <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.Initializer"></a>

```typescript
import { CbrVaultV3BindRulesOutputReference } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3BindRulesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3BindRulesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CbrVaultV3BindRules;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules`](#@cdktf/provider-opentelekomcloud.CbrVaultV3BindRules)

---


### CbrVaultV3ResourceList <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.Initializer"></a>

```typescript
import { CbrVaultV3ResourceList } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3ResourceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CbrVaultV3Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3Resource`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Resource)[]

---


### CbrVaultV3ResourceOutputReference <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.Initializer"></a>

```typescript
import { CbrVaultV3ResourceOutputReference } from '@cdktf/provider-opentelekomcloud'

new CbrVaultV3ResourceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetBackupCount` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetBackupCount"></a>

```typescript
public resetBackupCount()
```

##### `resetBackupSize` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetBackupSize"></a>

```typescript
public resetBackupSize()
```

##### `resetExtraInfo` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetExtraInfo"></a>

```typescript
public resetExtraInfo()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetId"></a>

```typescript
public resetId()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetName"></a>

```typescript
public resetName()
```

##### `resetProtectStatus` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetProtectStatus"></a>

```typescript
public resetProtectStatus()
```

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetSize"></a>

```typescript
public resetSize()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `backupCountInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.backupCountInput"></a>

```typescript
public readonly backupCountInput: number;
```

- *Type:* `number`

---

##### `backupSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.backupSizeInput"></a>

```typescript
public readonly backupSizeInput: number;
```

- *Type:* `number`

---

##### `extraInfoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.extraInfoInput"></a>

```typescript
public readonly extraInfoInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `protectStatusInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.protectStatusInput"></a>

```typescript
public readonly protectStatusInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `backupCount`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.backupCount"></a>

```typescript
public readonly backupCount: number;
```

- *Type:* `number`

---

##### `backupSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.backupSize"></a>

```typescript
public readonly backupSize: number;
```

- *Type:* `number`

---

##### `extraInfo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.extraInfo"></a>

```typescript
public readonly extraInfo: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `protectStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.protectStatus"></a>

```typescript
public readonly protectStatus: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CbrVaultV3ResourceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CbrVaultV3Resource;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CbrVaultV3Resource`](#@cdktf/provider-opentelekomcloud.CbrVaultV3Resource)

---


### CceAddonV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { CceAddonV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceAddonV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceAddonV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceAddonV3Timeouts)

---


### CceAddonV3ValuesOutputReference <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.Initializer"></a>

```typescript
import { CceAddonV3ValuesOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceAddonV3ValuesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `basicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.property.basicInput"></a>

```typescript
public readonly basicInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `customInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.property.customInput"></a>

```typescript
public readonly customInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `basic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.property.basic"></a>

```typescript
public readonly basic: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `custom`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.property.custom"></a>

```typescript
public readonly custom: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: `string`}

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceAddonV3ValuesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceAddonV3Values;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceAddonV3Values`](#@cdktf/provider-opentelekomcloud.CceAddonV3Values)

---


### CceClusterV3AuthenticatingProxyOutputReference <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.Initializer"></a>

```typescript
import { CceClusterV3AuthenticatingProxyOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3AuthenticatingProxyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `caInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.caInput"></a>

```typescript
public readonly caInput: string;
```

- *Type:* `string`

---

##### `certInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.certInput"></a>

```typescript
public readonly certInput: string;
```

- *Type:* `string`

---

##### `privateKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.privateKeyInput"></a>

```typescript
public readonly privateKeyInput: string;
```

- *Type:* `string`

---

##### `ca`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.ca"></a>

```typescript
public readonly ca: string;
```

- *Type:* `string`

---

##### `cert`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.cert"></a>

```typescript
public readonly cert: string;
```

- *Type:* `string`

---

##### `privateKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceClusterV3AuthenticatingProxy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy`](#@cdktf/provider-opentelekomcloud.CceClusterV3AuthenticatingProxy)

---


### CceClusterV3CertificateClustersList <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.Initializer"></a>

```typescript
import { CceClusterV3CertificateClustersList } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3CertificateClustersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### CceClusterV3CertificateClustersOutputReference <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.Initializer"></a>

```typescript
import { CceClusterV3CertificateClustersOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3CertificateClustersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `certificateAuthorityData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.property.certificateAuthorityData"></a>

```typescript
public readonly certificateAuthorityData: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `server`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClustersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceClusterV3CertificateClusters;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClusters`](#@cdktf/provider-opentelekomcloud.CceClusterV3CertificateClusters)

---


### CceClusterV3CertificateUsersList <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.Initializer"></a>

```typescript
import { CceClusterV3CertificateUsersList } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3CertificateUsersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### CceClusterV3CertificateUsersOutputReference <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.Initializer"></a>

```typescript
import { CceClusterV3CertificateUsersOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3CertificateUsersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `clientCertificateData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.property.clientCertificateData"></a>

```typescript
public readonly clientCertificateData: string;
```

- *Type:* `string`

---

##### `clientKeyData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.property.clientKeyData"></a>

```typescript
public readonly clientKeyData: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceClusterV3CertificateUsers;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsers`](#@cdktf/provider-opentelekomcloud.CceClusterV3CertificateUsers)

---


### CceClusterV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { CceClusterV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceClusterV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceClusterV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceClusterV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceClusterV3Timeouts)

---


### CceNodePoolV3DataVolumesList <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.Initializer"></a>

```typescript
import { CceNodePoolV3DataVolumesList } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3DataVolumesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodePoolV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes)[]

---


### CceNodePoolV3DataVolumesOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.Initializer"></a>

```typescript
import { CceNodePoolV3DataVolumesOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3DataVolumesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetExtendParam` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.resetExtendParam"></a>

```typescript
public resetExtendParam()
```

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.resetKmsId"></a>

```typescript
public resetKmsId()
```


#### Properties <a name="Properties"></a>

##### `extendParamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.extendParamInput"></a>

```typescript
public readonly extendParamInput: string;
```

- *Type:* `string`

---

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumetypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.volumetypeInput"></a>

```typescript
public readonly volumetypeInput: string;
```

- *Type:* `string`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodePoolV3DataVolumes;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3DataVolumes)

---


### CceNodePoolV3RootVolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.Initializer"></a>

```typescript
import { CceNodePoolV3RootVolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3RootVolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetExtendParam` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.resetExtendParam"></a>

```typescript
public resetExtendParam()
```


#### Properties <a name="Properties"></a>

##### `extendParamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.extendParamInput"></a>

```typescript
public readonly extendParamInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumetypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.volumetypeInput"></a>

```typescript
public readonly volumetypeInput: string;
```

- *Type:* `string`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceNodePoolV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3RootVolume)

---


### CceNodePoolV3TaintsList <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.Initializer"></a>

```typescript
import { CceNodePoolV3TaintsList } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3TaintsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodePoolV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints)[]

---


### CceNodePoolV3TaintsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.Initializer"></a>

```typescript
import { CceNodePoolV3TaintsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3TaintsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `effectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.effectInput"></a>

```typescript
public readonly effectInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TaintsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodePoolV3Taints;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Taints)

---


### CceNodePoolV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { CceNodePoolV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodePoolV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodePoolV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodePoolV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodePoolV3Timeouts)

---


### CceNodeV3DataVolumesList <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.Initializer"></a>

```typescript
import { CceNodeV3DataVolumesList } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3DataVolumesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodeV3DataVolumes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes)[]

---


### CceNodeV3DataVolumesOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.Initializer"></a>

```typescript
import { CceNodeV3DataVolumesOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3DataVolumesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetExtendParam` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.resetExtendParam"></a>

```typescript
public resetExtendParam()
```

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.resetKmsId"></a>

```typescript
public resetKmsId()
```


#### Properties <a name="Properties"></a>

##### `extendParamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.extendParamInput"></a>

```typescript
public readonly extendParamInput: string;
```

- *Type:* `string`

---

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumetypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.volumetypeInput"></a>

```typescript
public readonly volumetypeInput: string;
```

- *Type:* `string`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodeV3DataVolumes;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.CceNodeV3DataVolumes)

---


### CceNodeV3RootVolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.Initializer"></a>

```typescript
import { CceNodeV3RootVolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3RootVolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetExtendParam` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.resetExtendParam"></a>

```typescript
public resetExtendParam()
```


#### Properties <a name="Properties"></a>

##### `extendParamInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.extendParamInput"></a>

```typescript
public readonly extendParamInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumetypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.volumetypeInput"></a>

```typescript
public readonly volumetypeInput: string;
```

- *Type:* `string`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumetype`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.volumetype"></a>

```typescript
public readonly volumetype: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3RootVolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CceNodeV3RootVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume`](#@cdktf/provider-opentelekomcloud.CceNodeV3RootVolume)

---


### CceNodeV3TaintsList <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.Initializer"></a>

```typescript
import { CceNodeV3TaintsList } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3TaintsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodeV3Taints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodeV3Taints)[]

---


### CceNodeV3TaintsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.Initializer"></a>

```typescript
import { CceNodeV3TaintsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3TaintsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `effectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.effectInput"></a>

```typescript
public readonly effectInput: string;
```

- *Type:* `string`

---

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TaintsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodeV3Taints;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Taints`](#@cdktf/provider-opentelekomcloud.CceNodeV3Taints)

---


### CceNodeV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { CceNodeV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CceNodeV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CceNodeV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CceNodeV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts`](#@cdktf/provider-opentelekomcloud.CceNodeV3Timeouts)

---


### CesAlarmruleAlarmActionsList <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.Initializer"></a>

```typescript
import { CesAlarmruleAlarmActionsList } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleAlarmActionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleAlarmActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions)[]

---


### CesAlarmruleAlarmActionsOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleAlarmActionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleAlarmActionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `notificationListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.property.notificationListInput"></a>

```typescript
public readonly notificationListInput: string[];
```

- *Type:* `string`[]

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleAlarmActions;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleAlarmActions)

---


### CesAlarmruleConditionOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleConditionOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleConditionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetUnit` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.resetUnit"></a>

```typescript
public resetUnit()
```


#### Properties <a name="Properties"></a>

##### `comparisonOperatorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.comparisonOperatorInput"></a>

```typescript
public readonly comparisonOperatorInput: string;
```

- *Type:* `string`

---

##### `countInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.countInput"></a>

```typescript
public readonly countInput: number;
```

- *Type:* `number`

---

##### `filterInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.filterInput"></a>

```typescript
public readonly filterInput: string;
```

- *Type:* `string`

---

##### `periodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.periodInput"></a>

```typescript
public readonly periodInput: number;
```

- *Type:* `number`

---

##### `unitInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.unitInput"></a>

```typescript
public readonly unitInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: number;
```

- *Type:* `number`

---

##### `comparisonOperator`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.comparisonOperator"></a>

```typescript
public readonly comparisonOperator: string;
```

- *Type:* `string`

---

##### `count`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* `number`

---

##### `filter`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.filter"></a>

```typescript
public readonly filter: string;
```

- *Type:* `string`

---

##### `period`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.period"></a>

```typescript
public readonly period: number;
```

- *Type:* `number`

---

##### `unit`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.unit"></a>

```typescript
public readonly unit: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleConditionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CesAlarmruleCondition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleCondition`](#@cdktf/provider-opentelekomcloud.CesAlarmruleCondition)

---


### CesAlarmruleInsufficientdataActionsList <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.Initializer"></a>

```typescript
import { CesAlarmruleInsufficientdataActionsList } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleInsufficientdataActionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleInsufficientdataActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions)[]

---


### CesAlarmruleInsufficientdataActionsOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleInsufficientdataActionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleInsufficientdataActionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `notificationListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.property.notificationListInput"></a>

```typescript
public readonly notificationListInput: string[];
```

- *Type:* `string`[]

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleInsufficientdataActions;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleInsufficientdataActions)

---


### CesAlarmruleMetricDimensionsList <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.Initializer"></a>

```typescript
import { CesAlarmruleMetricDimensionsList } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleMetricDimensionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleMetricDimensions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions)[]

---


### CesAlarmruleMetricDimensionsOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleMetricDimensionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleMetricDimensionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleMetricDimensions;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions)

---


### CesAlarmruleMetricOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleMetricOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleMetricOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `putDimensions` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.putDimensions"></a>

```typescript
public putDimensions(value: IResolvable | CesAlarmruleMetricDimensions[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions)[]

---


#### Properties <a name="Properties"></a>

##### `dimensions`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.dimensions"></a>

```typescript
public readonly dimensions: CesAlarmruleMetricDimensionsList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensionsList)

---

##### `dimensionsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.dimensionsInput"></a>

```typescript
public readonly dimensionsInput: IResolvable | CesAlarmruleMetricDimensions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetricDimensions)[]

---

##### `metricNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.metricNameInput"></a>

```typescript
public readonly metricNameInput: string;
```

- *Type:* `string`

---

##### `namespaceInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.namespaceInput"></a>

```typescript
public readonly namespaceInput: string;
```

- *Type:* `string`

---

##### `metricName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* `string`

---

##### `namespace`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleMetricOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CesAlarmruleMetric;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CesAlarmruleMetric`](#@cdktf/provider-opentelekomcloud.CesAlarmruleMetric)

---


### CesAlarmruleOkActionsList <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.Initializer"></a>

```typescript
import { CesAlarmruleOkActionsList } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleOkActionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleOkActions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions)[]

---


### CesAlarmruleOkActionsOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleOkActionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleOkActionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `notificationListInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.property.notificationListInput"></a>

```typescript
public readonly notificationListInput: string[];
```

- *Type:* `string`[]

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `notificationList`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.property.notificationList"></a>

```typescript
public readonly notificationList: string[];
```

- *Type:* `string`[]

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleOkActionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleOkActions;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions`](#@cdktf/provider-opentelekomcloud.CesAlarmruleOkActions)

---


### CesAlarmruleTimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.Initializer"></a>

```typescript
import { CesAlarmruleTimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CesAlarmruleTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CesAlarmruleTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CesAlarmruleTimeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts`](#@cdktf/provider-opentelekomcloud.CesAlarmruleTimeouts)

---


### ComputeBmsServerV2BlockDeviceList <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.Initializer"></a>

```typescript
import { ComputeBmsServerV2BlockDeviceList } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2BlockDeviceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsServerV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice)[]

---


### ComputeBmsServerV2BlockDeviceOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.Initializer"></a>

```typescript
import { ComputeBmsServerV2BlockDeviceOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2BlockDeviceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetBootIndex` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetBootIndex"></a>

```typescript
public resetBootIndex()
```

##### `resetDeleteOnTermination` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetDeleteOnTermination"></a>

```typescript
public resetDeleteOnTermination()
```

##### `resetDestinationType` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetDestinationType"></a>

```typescript
public resetDestinationType()
```

##### `resetDeviceName` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName()
```

##### `resetGuestFormat` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetGuestFormat"></a>

```typescript
public resetGuestFormat()
```

##### `resetUuid` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetUuid"></a>

```typescript
public resetUuid()
```

##### `resetVolumeSize` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetVolumeSize"></a>

```typescript
public resetVolumeSize()
```

##### `resetVolumeType` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.resetVolumeType"></a>

```typescript
public resetVolumeType()
```


#### Properties <a name="Properties"></a>

##### `bootIndexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.bootIndexInput"></a>

```typescript
public readonly bootIndexInput: number;
```

- *Type:* `number`

---

##### `deleteOnTerminationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.deleteOnTerminationInput"></a>

```typescript
public readonly deleteOnTerminationInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `destinationTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.destinationTypeInput"></a>

```typescript
public readonly destinationTypeInput: string;
```

- *Type:* `string`

---

##### `deviceNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* `string`

---

##### `guestFormatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.guestFormatInput"></a>

```typescript
public readonly guestFormatInput: string;
```

- *Type:* `string`

---

##### `sourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.sourceTypeInput"></a>

```typescript
public readonly sourceTypeInput: string;
```

- *Type:* `string`

---

##### `uuidInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.uuidInput"></a>

```typescript
public readonly uuidInput: string;
```

- *Type:* `string`

---

##### `volumeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.volumeSizeInput"></a>

```typescript
public readonly volumeSizeInput: number;
```

- *Type:* `number`

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `bootIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.bootIndex"></a>

```typescript
public readonly bootIndex: number;
```

- *Type:* `number`

---

##### `deleteOnTermination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.deleteOnTermination"></a>

```typescript
public readonly deleteOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `destinationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.destinationType"></a>

```typescript
public readonly destinationType: string;
```

- *Type:* `string`

---

##### `deviceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* `string`

---

##### `guestFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.guestFormat"></a>

```typescript
public readonly guestFormat: string;
```

- *Type:* `string`

---

##### `sourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.sourceType"></a>

```typescript
public readonly sourceType: string;
```

- *Type:* `string`

---

##### `uuid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

---

##### `volumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDeviceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsServerV2BlockDevice;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2BlockDevice)

---


### ComputeBmsServerV2NetworkList <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.Initializer"></a>

```typescript
import { ComputeBmsServerV2NetworkList } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2NetworkList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsServerV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network)[]

---


### ComputeBmsServerV2NetworkOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.Initializer"></a>

```typescript
import { ComputeBmsServerV2NetworkOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2NetworkOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAccessNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetAccessNetwork"></a>

```typescript
public resetAccessNetwork()
```

##### `resetFixedIpV4` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetFixedIpV4"></a>

```typescript
public resetFixedIpV4()
```

##### `resetFixedIpV6` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetFixedIpV6"></a>

```typescript
public resetFixedIpV6()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetName"></a>

```typescript
public resetName()
```

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetPort"></a>

```typescript
public resetPort()
```

##### `resetUuid` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.resetUuid"></a>

```typescript
public resetUuid()
```


#### Properties <a name="Properties"></a>

##### `mac`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.mac"></a>

```typescript
public readonly mac: string;
```

- *Type:* `string`

---

##### `accessNetworkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.accessNetworkInput"></a>

```typescript
public readonly accessNetworkInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `fixedIpV4Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.fixedIpV4Input"></a>

```typescript
public readonly fixedIpV4Input: string;
```

- *Type:* `string`

---

##### `fixedIpV6Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.fixedIpV6Input"></a>

```typescript
public readonly fixedIpV6Input: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.portInput"></a>

```typescript
public readonly portInput: string;
```

- *Type:* `string`

---

##### `uuidInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.uuidInput"></a>

```typescript
public readonly uuidInput: string;
```

- *Type:* `string`

---

##### `accessNetwork`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.accessNetwork"></a>

```typescript
public readonly accessNetwork: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `fixedIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

---

##### `fixedIpV6`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.fixedIpV6"></a>

```typescript
public readonly fixedIpV6: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

---

##### `uuid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2NetworkOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsServerV2Network;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Network)

---


### ComputeBmsServerV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeBmsServerV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsServerV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsServerV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsServerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsServerV2Timeouts)

---


### ComputeBmsTagsV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeBmsTagsV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeBmsTagsV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeBmsTagsV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeBmsTagsV2Timeouts)

---


### ComputeInstanceV2BlockDeviceList <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.Initializer"></a>

```typescript
import { ComputeInstanceV2BlockDeviceList } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2BlockDeviceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2BlockDevice[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice)[]

---


### ComputeInstanceV2BlockDeviceOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceV2BlockDeviceOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2BlockDeviceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetBootIndex` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetBootIndex"></a>

```typescript
public resetBootIndex()
```

##### `resetDeleteOnTermination` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetDeleteOnTermination"></a>

```typescript
public resetDeleteOnTermination()
```

##### `resetDestinationType` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetDestinationType"></a>

```typescript
public resetDestinationType()
```

##### `resetDeviceName` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName()
```

##### `resetGuestFormat` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetGuestFormat"></a>

```typescript
public resetGuestFormat()
```

##### `resetUuid` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetUuid"></a>

```typescript
public resetUuid()
```

##### `resetVolumeSize` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetVolumeSize"></a>

```typescript
public resetVolumeSize()
```

##### `resetVolumeType` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.resetVolumeType"></a>

```typescript
public resetVolumeType()
```


#### Properties <a name="Properties"></a>

##### `bootIndexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.bootIndexInput"></a>

```typescript
public readonly bootIndexInput: number;
```

- *Type:* `number`

---

##### `deleteOnTerminationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.deleteOnTerminationInput"></a>

```typescript
public readonly deleteOnTerminationInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `destinationTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.destinationTypeInput"></a>

```typescript
public readonly destinationTypeInput: string;
```

- *Type:* `string`

---

##### `deviceNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* `string`

---

##### `guestFormatInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.guestFormatInput"></a>

```typescript
public readonly guestFormatInput: string;
```

- *Type:* `string`

---

##### `sourceTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.sourceTypeInput"></a>

```typescript
public readonly sourceTypeInput: string;
```

- *Type:* `string`

---

##### `uuidInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.uuidInput"></a>

```typescript
public readonly uuidInput: string;
```

- *Type:* `string`

---

##### `volumeSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.volumeSizeInput"></a>

```typescript
public readonly volumeSizeInput: number;
```

- *Type:* `number`

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `bootIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.bootIndex"></a>

```typescript
public readonly bootIndex: number;
```

- *Type:* `number`

---

##### `deleteOnTermination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.deleteOnTermination"></a>

```typescript
public readonly deleteOnTermination: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `destinationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.destinationType"></a>

```typescript
public readonly destinationType: string;
```

- *Type:* `string`

---

##### `deviceName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* `string`

---

##### `guestFormat`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.guestFormat"></a>

```typescript
public readonly guestFormat: string;
```

- *Type:* `string`

---

##### `sourceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.sourceType"></a>

```typescript
public readonly sourceType: string;
```

- *Type:* `string`

---

##### `uuid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

---

##### `volumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.volumeSize"></a>

```typescript
public readonly volumeSize: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDeviceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2BlockDevice;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2BlockDevice)

---


### ComputeInstanceV2NetworkList <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.Initializer"></a>

```typescript
import { ComputeInstanceV2NetworkList } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2NetworkList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2Network[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network)[]

---


### ComputeInstanceV2NetworkOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceV2NetworkOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2NetworkOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAccessNetwork` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetAccessNetwork"></a>

```typescript
public resetAccessNetwork()
```

##### `resetFixedIpV4` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetFixedIpV4"></a>

```typescript
public resetFixedIpV4()
```

##### `resetFixedIpV6` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetFixedIpV6"></a>

```typescript
public resetFixedIpV6()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetName"></a>

```typescript
public resetName()
```

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetPort"></a>

```typescript
public resetPort()
```

##### `resetUuid` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.resetUuid"></a>

```typescript
public resetUuid()
```


#### Properties <a name="Properties"></a>

##### `mac`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.mac"></a>

```typescript
public readonly mac: string;
```

- *Type:* `string`

---

##### `accessNetworkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.accessNetworkInput"></a>

```typescript
public readonly accessNetworkInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `fixedIpV4Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.fixedIpV4Input"></a>

```typescript
public readonly fixedIpV4Input: string;
```

- *Type:* `string`

---

##### `fixedIpV6Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.fixedIpV6Input"></a>

```typescript
public readonly fixedIpV6Input: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.portInput"></a>

```typescript
public readonly portInput: string;
```

- *Type:* `string`

---

##### `uuidInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.uuidInput"></a>

```typescript
public readonly uuidInput: string;
```

- *Type:* `string`

---

##### `accessNetwork`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.accessNetwork"></a>

```typescript
public readonly accessNetwork: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `fixedIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

---

##### `fixedIpV6`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.fixedIpV6"></a>

```typescript
public readonly fixedIpV6: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

---

##### `uuid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.uuid"></a>

```typescript
public readonly uuid: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2NetworkOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2Network;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Network)

---


### ComputeInstanceV2SchedulerHintsList <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.Initializer"></a>

```typescript
import { ComputeInstanceV2SchedulerHintsList } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2SchedulerHintsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2SchedulerHints[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints)[]

---


### ComputeInstanceV2SchedulerHintsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceV2SchedulerHintsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2SchedulerHintsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetBuildNearHostIp` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetBuildNearHostIp"></a>

```typescript
public resetBuildNearHostIp()
```

##### `resetDehId` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetDehId"></a>

```typescript
public resetDehId()
```

##### `resetDifferentHost` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetDifferentHost"></a>

```typescript
public resetDifferentHost()
```

##### `resetGroup` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetGroup"></a>

```typescript
public resetGroup()
```

##### `resetQuery` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetQuery"></a>

```typescript
public resetQuery()
```

##### `resetSameHost` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetSameHost"></a>

```typescript
public resetSameHost()
```

##### `resetTargetCell` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetTargetCell"></a>

```typescript
public resetTargetCell()
```

##### `resetTenancy` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.resetTenancy"></a>

```typescript
public resetTenancy()
```


#### Properties <a name="Properties"></a>

##### `buildNearHostIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.buildNearHostIpInput"></a>

```typescript
public readonly buildNearHostIpInput: string;
```

- *Type:* `string`

---

##### `dehIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.dehIdInput"></a>

```typescript
public readonly dehIdInput: string;
```

- *Type:* `string`

---

##### `differentHostInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.differentHostInput"></a>

```typescript
public readonly differentHostInput: string[];
```

- *Type:* `string`[]

---

##### `groupInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.groupInput"></a>

```typescript
public readonly groupInput: string;
```

- *Type:* `string`

---

##### `queryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.queryInput"></a>

```typescript
public readonly queryInput: string[];
```

- *Type:* `string`[]

---

##### `sameHostInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.sameHostInput"></a>

```typescript
public readonly sameHostInput: string[];
```

- *Type:* `string`[]

---

##### `targetCellInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.targetCellInput"></a>

```typescript
public readonly targetCellInput: string;
```

- *Type:* `string`

---

##### `tenancyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.tenancyInput"></a>

```typescript
public readonly tenancyInput: string;
```

- *Type:* `string`

---

##### `buildNearHostIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.buildNearHostIp"></a>

```typescript
public readonly buildNearHostIp: string;
```

- *Type:* `string`

---

##### `dehId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.dehId"></a>

```typescript
public readonly dehId: string;
```

- *Type:* `string`

---

##### `differentHost`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.differentHost"></a>

```typescript
public readonly differentHost: string[];
```

- *Type:* `string`[]

---

##### `group`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* `string`

---

##### `query`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.query"></a>

```typescript
public readonly query: string[];
```

- *Type:* `string`[]

---

##### `sameHost`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.sameHost"></a>

```typescript
public readonly sameHost: string[];
```

- *Type:* `string`[]

---

##### `targetCell`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.targetCell"></a>

```typescript
public readonly targetCell: string;
```

- *Type:* `string`

---

##### `tenancy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.tenancy"></a>

```typescript
public readonly tenancy: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHintsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2SchedulerHints;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2SchedulerHints)

---


### ComputeInstanceV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2Timeouts)

---


### ComputeInstanceV2VolumeAttachedList <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.Initializer"></a>

```typescript
import { ComputeInstanceV2VolumeAttachedList } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2VolumeAttachedList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### ComputeInstanceV2VolumeAttachedOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceV2VolumeAttachedOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeInstanceV2VolumeAttachedOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttachedOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceV2VolumeAttached;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttached`](#@cdktf/provider-opentelekomcloud.ComputeInstanceV2VolumeAttached)

---


### ComputeSecgroupV2RuleList <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.Initializer"></a>

```typescript
import { ComputeSecgroupV2RuleList } from '@cdktf/provider-opentelekomcloud'

new ComputeSecgroupV2RuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeSecgroupV2Rule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule)[]

---


### ComputeSecgroupV2RuleOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.Initializer"></a>

```typescript
import { ComputeSecgroupV2RuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeSecgroupV2RuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetCidr` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.resetCidr"></a>

```typescript
public resetCidr()
```

##### `resetFromGroupId` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.resetFromGroupId"></a>

```typescript
public resetFromGroupId()
```

##### `resetSelfAttribute` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.resetSelfAttribute"></a>

```typescript
public resetSelfAttribute()
```


#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `cidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.cidrInput"></a>

```typescript
public readonly cidrInput: string;
```

- *Type:* `string`

---

##### `fromGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.fromGroupIdInput"></a>

```typescript
public readonly fromGroupIdInput: string;
```

- *Type:* `string`

---

##### `fromPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* `number`

---

##### `ipProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.ipProtocolInput"></a>

```typescript
public readonly ipProtocolInput: string;
```

- *Type:* `string`

---

##### `selfAttributeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.selfAttributeInput"></a>

```typescript
public readonly selfAttributeInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `toPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* `number`

---

##### `cidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* `string`

---

##### `fromGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.fromGroupId"></a>

```typescript
public readonly fromGroupId: string;
```

- *Type:* `string`

---

##### `fromPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* `number`

---

##### `ipProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.ipProtocol"></a>

```typescript
public readonly ipProtocol: string;
```

- *Type:* `string`

---

##### `selfAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.selfAttribute"></a>

```typescript
public readonly selfAttribute: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `toPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2RuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeSecgroupV2Rule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Rule)

---


### ComputeSecgroupV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeSecgroupV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeSecgroupV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeSecgroupV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeSecgroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeSecgroupV2Timeouts)

---


### ComputeVolumeAttachV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeVolumeAttachV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ComputeVolumeAttachV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeVolumeAttachV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts`](#@cdktf/provider-opentelekomcloud.ComputeVolumeAttachV2Timeouts)

---


### CsbsBackupPolicyV1ResourceList <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1ResourceList } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1ResourceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupPolicyV1Resource[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource)[]

---


### CsbsBackupPolicyV1ResourceOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1ResourceOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1ResourceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ResourceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupPolicyV1Resource;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Resource)

---


### CsbsBackupPolicyV1ScheduledOperationOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1ScheduledOperationOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1ScheduledOperationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDayBackups` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetDayBackups"></a>

```typescript
public resetDayBackups()
```

##### `resetDescription` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetDescription"></a>

```typescript
public resetDescription()
```

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetMaxBackups` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetMaxBackups"></a>

```typescript
public resetMaxBackups()
```

##### `resetMonthBackups` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetMonthBackups"></a>

```typescript
public resetMonthBackups()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetName"></a>

```typescript
public resetName()
```

##### `resetPermanent` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetPermanent"></a>

```typescript
public resetPermanent()
```

##### `resetRetentionDurationDays` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetRetentionDurationDays"></a>

```typescript
public resetRetentionDurationDays()
```

##### `resetTimezone` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetTimezone"></a>

```typescript
public resetTimezone()
```

##### `resetWeekBackups` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetWeekBackups"></a>

```typescript
public resetWeekBackups()
```

##### `resetYearBackups` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.resetYearBackups"></a>

```typescript
public resetYearBackups()
```


#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `triggerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerId"></a>

```typescript
public readonly triggerId: string;
```

- *Type:* `string`

---

##### `triggerName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerName"></a>

```typescript
public readonly triggerName: string;
```

- *Type:* `string`

---

##### `triggerType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerType"></a>

```typescript
public readonly triggerType: string;
```

- *Type:* `string`

---

##### `dayBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.dayBackupsInput"></a>

```typescript
public readonly dayBackupsInput: number;
```

- *Type:* `number`

---

##### `descriptionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* `string`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `maxBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.maxBackupsInput"></a>

```typescript
public readonly maxBackupsInput: number;
```

- *Type:* `number`

---

##### `monthBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.monthBackupsInput"></a>

```typescript
public readonly monthBackupsInput: number;
```

- *Type:* `number`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `operationTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.operationTypeInput"></a>

```typescript
public readonly operationTypeInput: string;
```

- *Type:* `string`

---

##### `permanentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.permanentInput"></a>

```typescript
public readonly permanentInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `retentionDurationDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.retentionDurationDaysInput"></a>

```typescript
public readonly retentionDurationDaysInput: number;
```

- *Type:* `number`

---

##### `timezoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.timezoneInput"></a>

```typescript
public readonly timezoneInput: string;
```

- *Type:* `string`

---

##### `triggerPatternInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerPatternInput"></a>

```typescript
public readonly triggerPatternInput: string;
```

- *Type:* `string`

---

##### `weekBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.weekBackupsInput"></a>

```typescript
public readonly weekBackupsInput: number;
```

- *Type:* `number`

---

##### `yearBackupsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.yearBackupsInput"></a>

```typescript
public readonly yearBackupsInput: number;
```

- *Type:* `number`

---

##### `dayBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.dayBackups"></a>

```typescript
public readonly dayBackups: number;
```

- *Type:* `number`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `maxBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.maxBackups"></a>

```typescript
public readonly maxBackups: number;
```

- *Type:* `number`

---

##### `monthBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.monthBackups"></a>

```typescript
public readonly monthBackups: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `operationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.operationType"></a>

```typescript
public readonly operationType: string;
```

- *Type:* `string`

---

##### `permanent`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.permanent"></a>

```typescript
public readonly permanent: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `retentionDurationDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.retentionDurationDays"></a>

```typescript
public readonly retentionDurationDays: number;
```

- *Type:* `number`

---

##### `timezone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* `string`

---

##### `triggerPattern`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerPattern"></a>

```typescript
public readonly triggerPattern: string;
```

- *Type:* `string`

---

##### `weekBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.weekBackups"></a>

```typescript
public readonly weekBackups: number;
```

- *Type:* `number`

---

##### `yearBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.yearBackups"></a>

```typescript
public readonly yearBackups: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CsbsBackupPolicyV1ScheduledOperation;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1ScheduledOperation)

---


### CsbsBackupPolicyV1TagsList <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1TagsList } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupPolicyV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags)[]

---


### CsbsBackupPolicyV1TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupPolicyV1Tags;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Tags)

---


### CsbsBackupPolicyV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { CsbsBackupPolicyV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupPolicyV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupPolicyV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupPolicyV1Timeouts)

---


### CsbsBackupV1TagsList <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.Initializer"></a>

```typescript
import { CsbsBackupV1TagsList } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupV1Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags)[]

---


### CsbsBackupV1TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.Initializer"></a>

```typescript
import { CsbsBackupV1TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupV1Tags;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Tags)

---


### CsbsBackupV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { CsbsBackupV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CsbsBackupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1Timeouts)

---


### CsbsBackupV1VmMetadataList <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.Initializer"></a>

```typescript
import { CsbsBackupV1VmMetadataList } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1VmMetadataList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### CsbsBackupV1VmMetadataOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.Initializer"></a>

```typescript
import { CsbsBackupV1VmMetadataOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1VmMetadataOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `cloudServiceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.cloudServiceType"></a>

```typescript
public readonly cloudServiceType: string;
```

- *Type:* `string`

---

##### `disk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.disk"></a>

```typescript
public readonly disk: number;
```

- *Type:* `number`

---

##### `eip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.eip"></a>

```typescript
public readonly eip: string;
```

- *Type:* `string`

---

##### `imageType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.imageType"></a>

```typescript
public readonly imageType: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadataOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CsbsBackupV1VmMetadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadata`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1VmMetadata)

---


### CsbsBackupV1VolumeBackupsList <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.Initializer"></a>

```typescript
import { CsbsBackupV1VolumeBackupsList } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1VolumeBackupsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### CsbsBackupV1VolumeBackupsOutputReference <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.Initializer"></a>

```typescript
import { CsbsBackupV1VolumeBackupsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CsbsBackupV1VolumeBackupsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `averageSpeed`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.averageSpeed"></a>

```typescript
public readonly averageSpeed: number;
```

- *Type:* `number`

---

##### `bootable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.bootable"></a>

```typescript
public readonly bootable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.imageType"></a>

```typescript
public readonly imageType: string;
```

- *Type:* `string`

---

##### `incremental`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.incremental"></a>

```typescript
public readonly incremental: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `sourceVolumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeId"></a>

```typescript
public readonly sourceVolumeId: string;
```

- *Type:* `string`

---

##### `sourceVolumeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeName"></a>

```typescript
public readonly sourceVolumeName: string;
```

- *Type:* `string`

---

##### `sourceVolumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeSize"></a>

```typescript
public readonly sourceVolumeSize: number;
```

- *Type:* `number`

---

##### `spaceSavingRatio`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.spaceSavingRatio"></a>

```typescript
public readonly spaceSavingRatio: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackupsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CsbsBackupV1VolumeBackups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackups`](#@cdktf/provider-opentelekomcloud.CsbsBackupV1VolumeBackups)

---


### CssClusterV1DatastoreOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.Initializer"></a>

```typescript
import { CssClusterV1DatastoreOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1DatastoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.resetType"></a>

```typescript
public resetType()
```

##### `resetVersion` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.resetVersion"></a>

```typescript
public resetVersion()
```


#### Properties <a name="Properties"></a>

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1DatastoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssClusterV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Datastore`](#@cdktf/provider-opentelekomcloud.CssClusterV1Datastore)

---


### CssClusterV1NodeConfigNetworkInfoOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.Initializer"></a>

```typescript
import { CssClusterV1NodeConfigNetworkInfoOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1NodeConfigNetworkInfoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* `string`

---

##### `vpcIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.vpcIdInput"></a>

```typescript
public readonly vpcIdInput: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `securityGroupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* `string`

---

##### `vpcId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssClusterV1NodeConfigNetworkInfo;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo)

---


### CssClusterV1NodeConfigOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.Initializer"></a>

```typescript
import { CssClusterV1NodeConfigOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1NodeConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `putNetworkInfo` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.putNetworkInfo"></a>

```typescript
public putNetworkInfo(value: CssClusterV1NodeConfigNetworkInfo)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo)

---

##### `putVolume` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.putVolume"></a>

```typescript
public putVolume(value: CssClusterV1NodeConfigVolume)
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.parameter.value"></a>

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume)

---

##### `resetAvailabilityZone` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.resetAvailabilityZone"></a>

```typescript
public resetAvailabilityZone()
```


#### Properties <a name="Properties"></a>

##### `networkInfo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.networkInfo"></a>

```typescript
public readonly networkInfo: CssClusterV1NodeConfigNetworkInfoOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfoOutputReference)

---

##### `volume`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.volume"></a>

```typescript
public readonly volume: CssClusterV1NodeConfigVolumeOutputReference;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference)

---

##### `availabilityZoneInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.availabilityZoneInput"></a>

```typescript
public readonly availabilityZoneInput: string;
```

- *Type:* `string`

---

##### `flavorInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.flavorInput"></a>

```typescript
public readonly flavorInput: string;
```

- *Type:* `string`

---

##### `networkInfoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.networkInfoInput"></a>

```typescript
public readonly networkInfoInput: CssClusterV1NodeConfigNetworkInfo;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigNetworkInfo)

---

##### `volumeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.volumeInput"></a>

```typescript
public readonly volumeInput: CssClusterV1NodeConfigVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume)

---

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssClusterV1NodeConfig;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfig)

---


### CssClusterV1NodeConfigVolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.Initializer"></a>

```typescript
import { CssClusterV1NodeConfigVolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1NodeConfigVolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetEncryptionKey` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.resetEncryptionKey"></a>

```typescript
public resetEncryptionKey()
```


#### Properties <a name="Properties"></a>

##### `encryptionKeyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.encryptionKeyInput"></a>

```typescript
public readonly encryptionKeyInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `volumeTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.volumeTypeInput"></a>

```typescript
public readonly volumeTypeInput: string;
```

- *Type:* `string`

---

##### `encryptionKey`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssClusterV1NodeConfigVolume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume`](#@cdktf/provider-opentelekomcloud.CssClusterV1NodeConfigVolume)

---


### CssClusterV1NodesList <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.Initializer"></a>

```typescript
import { CssClusterV1NodesList } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1NodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### CssClusterV1NodesOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.Initializer"></a>

```typescript
import { CssClusterV1NodesOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1NodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1NodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssClusterV1Nodes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssClusterV1Nodes`](#@cdktf/provider-opentelekomcloud.CssClusterV1Nodes)

---


### CssClusterV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { CssClusterV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssClusterV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssClusterV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CssClusterV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssClusterV1Timeouts)

---


### CssSnapshotConfigurationV1ConfigurationOutputReference <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1ConfigurationOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssSnapshotConfigurationV1ConfigurationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.resetKmsId"></a>

```typescript
public resetKmsId()
```


#### Properties <a name="Properties"></a>

##### `agencyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.agencyInput"></a>

```typescript
public readonly agencyInput: string;
```

- *Type:* `string`

---

##### `bucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* `string`

---

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `agency`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.agency"></a>

```typescript
public readonly agency: string;
```

- *Type:* `string`

---

##### `bucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1ConfigurationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssSnapshotConfigurationV1Configuration;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Configuration)

---


### CssSnapshotConfigurationV1CreationPolicyOutputReference <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1CreationPolicyOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssSnapshotConfigurationV1CreationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDeleteAuto` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.resetDeleteAuto"></a>

```typescript
public resetDeleteAuto()
```


#### Properties <a name="Properties"></a>

##### `deleteAutoInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.deleteAutoInput"></a>

```typescript
public readonly deleteAutoInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.enableInput"></a>

```typescript
public readonly enableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `keepdayInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.keepdayInput"></a>

```typescript
public readonly keepdayInput: number;
```

- *Type:* `number`

---

##### `periodInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.periodInput"></a>

```typescript
public readonly periodInput: string;
```

- *Type:* `string`

---

##### `prefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* `string`

---

##### `deleteAuto`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.deleteAuto"></a>

```typescript
public readonly deleteAuto: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.enable"></a>

```typescript
public readonly enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `keepday`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.keepday"></a>

```typescript
public readonly keepday: number;
```

- *Type:* `number`

---

##### `period`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.period"></a>

```typescript
public readonly period: string;
```

- *Type:* `string`

---

##### `prefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CssSnapshotConfigurationV1CreationPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1CreationPolicy)

---


### CssSnapshotConfigurationV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { CssSnapshotConfigurationV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CssSnapshotConfigurationV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CssSnapshotConfigurationV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts`](#@cdktf/provider-opentelekomcloud.CssSnapshotConfigurationV1Timeouts)

---


### CtsTrackerV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { CtsTrackerV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new CtsTrackerV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.CtsTrackerV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CtsTrackerV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts`](#@cdktf/provider-opentelekomcloud.CtsTrackerV1Timeouts)

---


### DataOpentelekomcloudCceClusterV3CertificateClustersList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateClustersList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterV3CertificateClustersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `certificateAuthorityData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.property.certificateAuthorityData"></a>

```typescript
public readonly certificateAuthorityData: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `server`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClustersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCceClusterV3CertificateClusters;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClusters`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateClusters)

---


### DataOpentelekomcloudCceClusterV3CertificateUsersList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateUsersList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterV3CertificateUsersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `clientCertificateData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.property.clientCertificateData"></a>

```typescript
public readonly clientCertificateData: string;
```

- *Type:* `string`

---

##### `clientKeyData`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.property.clientKeyData"></a>

```typescript
public readonly clientKeyData: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCceClusterV3CertificateUsers;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceClusterV3CertificateUsers)

---


### DataOpentelekomcloudCceNodeV3DataVolumesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeV3DataVolumesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceNodeV3DataVolumesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCceNodeV3DataVolumesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCceNodeV3DataVolumesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCceNodeV3DataVolumesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `diskSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* `number`

---

##### `extendParam`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.property.extendParam"></a>

```typescript
public readonly extendParam: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `volumeType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.property.volumeType"></a>

```typescript
public readonly volumeType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCceNodeV3DataVolumes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumes`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCceNodeV3DataVolumes)

---


### DataOpentelekomcloudComputeBmsNicV2FixedIpsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsNicV2FixedIpsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsNicV2FixedIpsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIpsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudComputeBmsNicV2FixedIps;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIps`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsNicV2FixedIps)

---


### DataOpentelekomcloudComputeBmsServerV2NetworkList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2NetworkList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsServerV2NetworkList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `ip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.ip"></a>

```typescript
public readonly ip: string;
```

- *Type:* `string`

---

##### `mac`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.mac"></a>

```typescript
public readonly mac: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.version"></a>

```typescript
public readonly version: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2NetworkOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudComputeBmsServerV2Network;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Network`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2Network)

---


### DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroupsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudComputeBmsServerV2SecurityGroups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroups`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudComputeBmsServerV2SecurityGroups)

---


### DataOpentelekomcloudCsbsBackupPolicyV1ResourceList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1ResourceList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1ResourceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ResourceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupPolicyV1Resource;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Resource`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Resource)

---


### DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `maxBackups`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.maxBackups"></a>

```typescript
public readonly maxBackups: number;
```

- *Type:* `number`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `operationType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.operationType"></a>

```typescript
public readonly operationType: string;
```

- *Type:* `string`

---

##### `permanent`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.permanent"></a>

```typescript
public readonly permanent: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `retentionDurationDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.retentionDurationDays"></a>

```typescript
public readonly retentionDurationDays: number;
```

- *Type:* `number`

---

##### `triggerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerId"></a>

```typescript
public readonly triggerId: string;
```

- *Type:* `string`

---

##### `triggerName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerName"></a>

```typescript
public readonly triggerName: string;
```

- *Type:* `string`

---

##### `triggerPattern`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerPattern"></a>

```typescript
public readonly triggerPattern: string;
```

- *Type:* `string`

---

##### `triggerType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.triggerType"></a>

```typescript
public readonly triggerType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1ScheduledOperation)

---


### DataOpentelekomcloudCsbsBackupPolicyV1TagsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1TagsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupPolicyV1Tags;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Tags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupPolicyV1Tags)

---


### DataOpentelekomcloudCsbsBackupV1TagsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1TagsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupV1TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupV1Tags;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Tags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1Tags)

---


### DataOpentelekomcloudCsbsBackupV1VmMetadataList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VmMetadataList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1VmMetadataList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `cloudServiceType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.cloudServiceType"></a>

```typescript
public readonly cloudServiceType: string;
```

- *Type:* `string`

---

##### `disk`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.disk"></a>

```typescript
public readonly disk: number;
```

- *Type:* `number`

---

##### `eip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.eip"></a>

```typescript
public readonly eip: string;
```

- *Type:* `string`

---

##### `imageType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.imageType"></a>

```typescript
public readonly imageType: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `ram`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.ram"></a>

```typescript
public readonly ram: number;
```

- *Type:* `number`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.vcpus"></a>

```typescript
public readonly vcpus: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadataOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupV1VmMetadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadata`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VmMetadata)

---


### DataOpentelekomcloudCsbsBackupV1VolumeBackupsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VolumeBackupsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1VolumeBackupsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `averageSpeed`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.averageSpeed"></a>

```typescript
public readonly averageSpeed: number;
```

- *Type:* `number`

---

##### `bootable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.bootable"></a>

```typescript
public readonly bootable: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `imageType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.imageType"></a>

```typescript
public readonly imageType: string;
```

- *Type:* `string`

---

##### `incremental`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.incremental"></a>

```typescript
public readonly incremental: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `sourceVolumeId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeId"></a>

```typescript
public readonly sourceVolumeId: string;
```

- *Type:* `string`

---

##### `sourceVolumeName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeName"></a>

```typescript
public readonly sourceVolumeName: string;
```

- *Type:* `string`

---

##### `sourceVolumeSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.sourceVolumeSize"></a>

```typescript
public readonly sourceVolumeSize: number;
```

- *Type:* `number`

---

##### `spaceSavingRatio`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.spaceSavingRatio"></a>

```typescript
public readonly spaceSavingRatio: number;
```

- *Type:* `number`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackupsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCsbsBackupV1VolumeBackups;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackups`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCsbsBackupV1VolumeBackups)

---


### DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetMinFrom` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.resetMinFrom"></a>

```typescript
public resetMinFrom()
```

##### `resetMinTo` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.resetMinTo"></a>

```typescript
public resetMinTo()
```


#### Properties <a name="Properties"></a>

##### `from`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.from"></a>

```typescript
public readonly from: number;
```

- *Type:* `number`

---

##### `to`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.to"></a>

```typescript
public readonly to: number;
```

- *Type:* `number`

---

##### `minFromInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.minFromInput"></a>

```typescript
public readonly minFromInput: number;
```

- *Type:* `number`

---

##### `minToInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.minToInput"></a>

```typescript
public readonly minToInput: number;
```

- *Type:* `number`

---

##### `minFrom`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.minFrom"></a>

```typescript
public readonly minFrom: number;
```

- *Type:* `number`

---

##### `minTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.minTo"></a>

```typescript
public readonly minTo: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRangeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudCssFlavorV1DiskRange;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudCssFlavorV1DiskRange)

---


### DataOpentelekomcloudDdsFlavorsV3FlavorsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsFlavorsV3FlavorsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsFlavorsV3FlavorsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `azStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.azStatus"></a>

```typescript
public readonly azStatus: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `memory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.memory"></a>

```typescript
public readonly memory: string;
```

- *Type:* `string`

---

##### `specCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.vcpus"></a>

```typescript
public readonly vcpus: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3FlavorsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudDdsFlavorsV3Flavors;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Flavors`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsFlavorsV3Flavors)

---


### DataOpentelekomcloudDdsInstanceV3BackupStrategyList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3BackupStrategyList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3BackupStrategyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keepDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudDdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3BackupStrategy)

---


### DataOpentelekomcloudDdsInstanceV3DatastoreList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3DatastoreList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3DatastoreList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `storageEngine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.property.storageEngine"></a>

```typescript
public readonly storageEngine: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3DatastoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudDdsInstanceV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Datastore`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Datastore)

---


### DataOpentelekomcloudDdsInstanceV3NodesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3NodesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3NodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudDdsInstanceV3NodesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDdsInstanceV3NodesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDdsInstanceV3NodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.publicIp"></a>

```typescript
public readonly publicIp: string;
```

- *Type:* `string`

---

##### `role`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3NodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudDdsInstanceV3Nodes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Nodes`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDdsInstanceV3Nodes)

---


### DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacitiesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudDehHostV1AvailableInstanceCapacities;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehHostV1AvailableInstanceCapacities)

---


### DataOpentelekomcloudDehServerV1AddressesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehServerV1AddressesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehServerV1AddressesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudDehServerV1Addresses[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses)[]

---


### DataOpentelekomcloudDehServerV1AddressesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDehServerV1AddressesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDehServerV1AddressesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetFixedIpV4` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.resetFixedIpV4"></a>

```typescript
public resetFixedIpV4()
```

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.resetName"></a>

```typescript
public resetName()
```


#### Properties <a name="Properties"></a>

##### `fixedIpV4Input`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.property.fixedIpV4Input"></a>

```typescript
public readonly fixedIpV4Input: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `fixedIpV4`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.property.fixedIpV4"></a>

```typescript
public readonly fixedIpV4: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1AddressesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudDehServerV1Addresses;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDehServerV1Addresses)

---


### DataOpentelekomcloudDnsNameserversV2NameserversList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsNameserversV2NameserversList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDnsNameserversV2NameserversList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudDnsNameserversV2Nameservers[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers)[]

---


### DataOpentelekomcloudDnsNameserversV2NameserversOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudDnsNameserversV2NameserversOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudDnsNameserversV2NameserversOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetHostname` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.resetHostname"></a>

```typescript
public resetHostname()
```

##### `resetPriority` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.resetPriority"></a>

```typescript
public resetPriority()
```


#### Properties <a name="Properties"></a>

##### `hostnameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.property.hostnameInput"></a>

```typescript
public readonly hostnameInput: string;
```

- *Type:* `string`

---

##### `priorityInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* `number`

---

##### `hostname`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* `string`

---

##### `priority`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2NameserversOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudDnsNameserversV2Nameservers;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudDnsNameserversV2Nameservers)

---


### DataOpentelekomcloudIdentityAuthScopeV3RolesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAuthScopeV3RolesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityAuthScopeV3RolesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `roleId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.property.roleId"></a>

```typescript
public readonly roleId: string;
```

- *Type:* `string`

---

##### `roleName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.property.roleName"></a>

```typescript
public readonly roleName: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3RolesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudIdentityAuthScopeV3Roles;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Roles`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityAuthScopeV3Roles)

---


### DataOpentelekomcloudIdentityCredentialV3CredentialsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityCredentialV3CredentialsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityCredentialV3CredentialsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `access`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.access"></a>

```typescript
public readonly access: string;
```

- *Type:* `string`

---

##### `createTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.createTime"></a>

```typescript
public readonly createTime: string;
```

- *Type:* `string`

---

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `userId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3CredentialsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudIdentityCredentialV3Credentials;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Credentials`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudIdentityCredentialV3Credentials)

---


### DataOpentelekomcloudLbListenerV3InsertHeadersList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbListenerV3InsertHeadersList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbListenerV3InsertHeadersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `forwardedForPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.property.forwardedForPort"></a>

```typescript
public readonly forwardedForPort: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedHost`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.property.forwardedHost"></a>

```typescript
public readonly forwardedHost: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.property.forwardedPort"></a>

```typescript
public readonly forwardedPort: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardElbIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.property.forwardElbIp"></a>

```typescript
public readonly forwardElbIp: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudLbListenerV3InsertHeaders;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeaders`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbListenerV3InsertHeaders)

---


### DataOpentelekomcloudLbLoadbalancerV3PublicIpList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbLoadbalancerV3PublicIpList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbLoadbalancerV3PublicIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `bandwidthChargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.bandwidthChargeMode"></a>

```typescript
public readonly bandwidthChargeMode: string;
```

- *Type:* `string`

---

##### `bandwidthName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.bandwidthName"></a>

```typescript
public readonly bandwidthName: string;
```

- *Type:* `string`

---

##### `bandwidthShareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.bandwidthShareType"></a>

```typescript
public readonly bandwidthShareType: string;
```

- *Type:* `string`

---

##### `bandwidthSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudLbLoadbalancerV3PublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIp`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudLbLoadbalancerV3PublicIp)

---


### DataOpentelekomcloudObsBucketCorsRuleList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketCorsRuleList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketCorsRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketCorsRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketCorsRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketCorsRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `allowedHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* `string`[]

---

##### `allowedMethods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* `string`[]

---

##### `allowedOrigins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* `string`[]

---

##### `exposeHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* `string`[]

---

##### `maxAgeSeconds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketCorsRule;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketCorsRule)

---


### DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketEventNotificationsFilterRule;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRule)

---


### DataOpentelekomcloudObsBucketEventNotificationsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotificationsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketEventNotificationsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketEventNotificationsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketEventNotificationsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketEventNotificationsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `events`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.property.events"></a>

```typescript
public readonly events: string[];
```

- *Type:* `string`[]

---

##### `filterRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.property.filterRule"></a>

```typescript
public readonly filterRule: DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsFilterRuleList)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `topic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotificationsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketEventNotifications;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketEventNotifications)

---


### DataOpentelekomcloudObsBucketLifecycleRuleExpirationList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleExpirationList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLifecycleRuleExpiration;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpiration)

---


### DataOpentelekomcloudObsBucketLifecycleRuleList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpiration)

---


### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransition)

---


### DataOpentelekomcloudObsBucketLifecycleRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `expiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.expiration"></a>

```typescript
public readonly expiration: DataOpentelekomcloudObsBucketLifecycleRuleExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleExpirationList)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `noncurrentVersionExpiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionExpirationList)

---

##### `noncurrentVersionTransition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.noncurrentVersionTransition"></a>

```typescript
public readonly noncurrentVersionTransition: DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleNoncurrentVersionTransitionList)

---

##### `prefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

---

##### `transition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.transition"></a>

```typescript
public readonly transition: DataOpentelekomcloudObsBucketLifecycleRuleTransitionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLifecycleRule;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRule)

---


### DataOpentelekomcloudObsBucketLifecycleRuleTransitionList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleTransitionList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLifecycleRuleTransition;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLifecycleRuleTransition)

---


### DataOpentelekomcloudObsBucketLoggingList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLoggingList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLoggingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketLoggingOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketLoggingOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `targetBucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* `string`

---

##### `targetPrefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketLogging;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLogging`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketLogging)

---


### DataOpentelekomcloudObsBucketServerSideEncryptionList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketServerSideEncryptionList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketServerSideEncryptionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `algorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.property.algorithm"></a>

```typescript
public readonly algorithm: string;
```

- *Type:* `string`

---

##### `kmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.property.kmsKeyId"></a>

```typescript
public readonly kmsKeyId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryptionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketServerSideEncryption;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryption`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketServerSideEncryption)

---


### DataOpentelekomcloudObsBucketWebsiteList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketWebsiteList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketWebsiteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudObsBucketWebsiteOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudObsBucketWebsiteOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudObsBucketWebsiteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `errorDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* `string`

---

##### `indexDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* `string`

---

##### `redirectAllRequestsTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* `string`

---

##### `routingRules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsiteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudObsBucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsite`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudObsBucketWebsite)

---


### DataOpentelekomcloudRdsFlavorsV3FlavorsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV3FlavorsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsFlavorsV3FlavorsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `azStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.azStatus"></a>

```typescript
public readonly azStatus: StringMap;
```

- *Type:* [`cdktf.StringMap`](#cdktf.StringMap)

---

##### `memory`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* `number`

---

##### `mode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `vcpus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.vcpus"></a>

```typescript
public readonly vcpus: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3FlavorsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudRdsFlavorsV3Flavors;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Flavors`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsFlavorsV3Flavors)

---


### DataOpentelekomcloudRdsInstanceV3BackupStrategyList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3BackupStrategyList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsInstanceV3BackupStrategyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keepDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudRdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3BackupStrategy)

---


### DataOpentelekomcloudRdsInstanceV3NodesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3NodesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsInstanceV3NodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudRdsInstanceV3NodesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudRdsInstanceV3NodesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudRdsInstanceV3NodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `role`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3NodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudRdsInstanceV3Nodes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Nodes`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudRdsInstanceV3Nodes)

---


### DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudVbsBackupPolicyV2FilterTags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags)[]

---


### DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valuesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* `string`[]

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `values`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* `string`[]

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataOpentelekomcloudVbsBackupPolicyV2FilterTags;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2FilterTags)

---


### DataOpentelekomcloudVbsBackupPolicyV2TagsList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2TagsList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupPolicyV2TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudVbsBackupPolicyV2Tags;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVbsBackupPolicyV2Tags)

---


### DataOpentelekomcloudVpcepServiceV1PortList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepServiceV1PortList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcepServiceV1PortList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudVpcepServiceV1PortOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcepServiceV1PortOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcepServiceV1PortOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `clientPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.property.clientPort"></a>

```typescript
public readonly clientPort: number;
```

- *Type:* `number`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `serverPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.property.serverPort"></a>

```typescript
public readonly serverPort: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1PortOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudVpcepServiceV1Port;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcepServiceV1Port)

---


### DataOpentelekomcloudVpcV1RoutesList <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcV1RoutesList } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcV1RoutesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DataOpentelekomcloudVpcV1RoutesOutputReference <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.Initializer"></a>

```typescript
import { DataOpentelekomcloudVpcV1RoutesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DataOpentelekomcloudVpcV1RoutesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `destination`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.property.destination"></a>

```typescript
public readonly destination: string;
```

- *Type:* `string`

---

##### `nexthop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.property.nexthop"></a>

```typescript
public readonly nexthop: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1RoutesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataOpentelekomcloudVpcV1Routes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Routes`](#@cdktf/provider-opentelekomcloud.DataOpentelekomcloudVpcV1Routes)

---


### DcsInstanceV1BackupPolicyOutputReference <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.Initializer"></a>

```typescript
import { DcsInstanceV1BackupPolicyOutputReference } from '@cdktf/provider-opentelekomcloud'

new DcsInstanceV1BackupPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetBackupType` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.resetBackupType"></a>

```typescript
public resetBackupType()
```

##### `resetSaveDays` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.resetSaveDays"></a>

```typescript
public resetSaveDays()
```


#### Properties <a name="Properties"></a>

##### `backupAtInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.backupAtInput"></a>

```typescript
public readonly backupAtInput: number[];
```

- *Type:* `number`[]

---

##### `backupTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.backupTypeInput"></a>

```typescript
public readonly backupTypeInput: string;
```

- *Type:* `string`

---

##### `beginAtInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.beginAtInput"></a>

```typescript
public readonly beginAtInput: string;
```

- *Type:* `string`

---

##### `periodTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.periodTypeInput"></a>

```typescript
public readonly periodTypeInput: string;
```

- *Type:* `string`

---

##### `saveDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.saveDaysInput"></a>

```typescript
public readonly saveDaysInput: number;
```

- *Type:* `number`

---

##### `backupAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.backupAt"></a>

```typescript
public readonly backupAt: number[];
```

- *Type:* `number`[]

---

##### `backupType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.backupType"></a>

```typescript
public readonly backupType: string;
```

- *Type:* `string`

---

##### `beginAt`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.beginAt"></a>

```typescript
public readonly beginAt: string;
```

- *Type:* `string`

---

##### `periodType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.periodType"></a>

```typescript
public readonly periodType: string;
```

- *Type:* `string`

---

##### `saveDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.saveDays"></a>

```typescript
public readonly saveDays: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DcsInstanceV1BackupPolicy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1BackupPolicy)

---


### DcsInstanceV1ConfigurationList <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.Initializer"></a>

```typescript
import { DcsInstanceV1ConfigurationList } from '@cdktf/provider-opentelekomcloud'

new DcsInstanceV1ConfigurationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DcsInstanceV1Configuration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration)[]

---


### DcsInstanceV1ConfigurationOutputReference <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.Initializer"></a>

```typescript
import { DcsInstanceV1ConfigurationOutputReference } from '@cdktf/provider-opentelekomcloud'

new DcsInstanceV1ConfigurationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `parameterIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterIdInput"></a>

```typescript
public readonly parameterIdInput: string;
```

- *Type:* `string`

---

##### `parameterNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterNameInput"></a>

```typescript
public readonly parameterNameInput: string;
```

- *Type:* `string`

---

##### `parameterValueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterValueInput"></a>

```typescript
public readonly parameterValueInput: string;
```

- *Type:* `string`

---

##### `parameterId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterId"></a>

```typescript
public readonly parameterId: string;
```

- *Type:* `string`

---

##### `parameterName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterName"></a>

```typescript
public readonly parameterName: string;
```

- *Type:* `string`

---

##### `parameterValue`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.parameterValue"></a>

```typescript
public readonly parameterValue: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1ConfigurationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DcsInstanceV1Configuration;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Configuration)

---


### DcsInstanceV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { DcsInstanceV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DcsInstanceV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DcsInstanceV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DcsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.DcsInstanceV1Timeouts)

---


### DdsInstanceV3BackupStrategyOutputReference <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.Initializer"></a>

```typescript
import { DdsInstanceV3BackupStrategyOutputReference } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3BackupStrategyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `keepDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.property.keepDaysInput"></a>

```typescript
public readonly keepDaysInput: number;
```

- *Type:* `number`

---

##### `startTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* `string`

---

##### `keepDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3BackupStrategy)

---


### DdsInstanceV3DatastoreOutputReference <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.Initializer"></a>

```typescript
import { DdsInstanceV3DatastoreOutputReference } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3DatastoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetStorageEngine` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.resetStorageEngine"></a>

```typescript
public resetStorageEngine()
```


#### Properties <a name="Properties"></a>

##### `storageEngineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.storageEngineInput"></a>

```typescript
public readonly storageEngineInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `storageEngine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.storageEngine"></a>

```typescript
public readonly storageEngine: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3DatastoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DdsInstanceV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Datastore)

---


### DdsInstanceV3FlavorList <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.Initializer"></a>

```typescript
import { DdsInstanceV3FlavorList } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3FlavorList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DdsInstanceV3Flavor[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor)[]

---


### DdsInstanceV3FlavorOutputReference <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.Initializer"></a>

```typescript
import { DdsInstanceV3FlavorOutputReference } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3FlavorOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetSize` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.resetSize"></a>

```typescript
public resetSize()
```

##### `resetStorage` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.resetStorage"></a>

```typescript
public resetStorage()
```


#### Properties <a name="Properties"></a>

##### `numInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.numInput"></a>

```typescript
public readonly numInput: number;
```

- *Type:* `number`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `specCodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.specCodeInput"></a>

```typescript
public readonly specCodeInput: string;
```

- *Type:* `string`

---

##### `storageInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `num`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.num"></a>

```typescript
public readonly num: number;
```

- *Type:* `number`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `specCode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.specCode"></a>

```typescript
public readonly specCode: string;
```

- *Type:* `string`

---

##### `storage`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3FlavorOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DdsInstanceV3Flavor;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Flavor)

---


### DdsInstanceV3NodesList <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.Initializer"></a>

```typescript
import { DdsInstanceV3NodesList } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3NodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### DdsInstanceV3NodesOutputReference <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.Initializer"></a>

```typescript
import { DdsInstanceV3NodesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3NodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `privateIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.privateIp"></a>

```typescript
public readonly privateIp: string;
```

- *Type:* `string`

---

##### `publicIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.publicIp"></a>

```typescript
public readonly publicIp: string;
```

- *Type:* `string`

---

##### `role`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3NodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DdsInstanceV3Nodes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Nodes`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Nodes)

---


### DdsInstanceV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { DdsInstanceV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DdsInstanceV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DdsInstanceV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DdsInstanceV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.DdsInstanceV3Timeouts)

---


### DehHostV1AvailableInstanceCapacitiesList <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.Initializer"></a>

```typescript
import { DehHostV1AvailableInstanceCapacitiesList } from '@cdktf/provider-opentelekomcloud'

new DehHostV1AvailableInstanceCapacitiesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DehHostV1AvailableInstanceCapacities[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities)[]

---


### DehHostV1AvailableInstanceCapacitiesOutputReference <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.Initializer"></a>

```typescript
import { DehHostV1AvailableInstanceCapacitiesOutputReference } from '@cdktf/provider-opentelekomcloud'

new DehHostV1AvailableInstanceCapacitiesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `flavor`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.property.flavor"></a>

```typescript
public readonly flavor: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacitiesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DehHostV1AvailableInstanceCapacities;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities`](#@cdktf/provider-opentelekomcloud.DehHostV1AvailableInstanceCapacities)

---


### DehHostV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { DehHostV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DehHostV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DehHostV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DehHostV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DehHostV1Timeouts`](#@cdktf/provider-opentelekomcloud.DehHostV1Timeouts)

---


### DnsPtrrecordV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { DnsPtrrecordV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DnsPtrrecordV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsPtrrecordV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsPtrrecordV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsPtrrecordV2Timeouts)

---


### DnsRecordsetV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { DnsRecordsetV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DnsRecordsetV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsRecordsetV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsRecordsetV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsRecordsetV2Timeouts)

---


### DnsZoneV2RouterList <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.Initializer"></a>

```typescript
import { DnsZoneV2RouterList } from '@cdktf/provider-opentelekomcloud'

new DnsZoneV2RouterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsZoneV2Router[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Router`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Router)[]

---


### DnsZoneV2RouterOutputReference <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.Initializer"></a>

```typescript
import { DnsZoneV2RouterOutputReference } from '@cdktf/provider-opentelekomcloud'

new DnsZoneV2RouterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `routerIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.property.routerIdInput"></a>

```typescript
public readonly routerIdInput: string;
```

- *Type:* `string`

---

##### `routerRegionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.property.routerRegionInput"></a>

```typescript
public readonly routerRegionInput: string;
```

- *Type:* `string`

---

##### `routerId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.property.routerId"></a>

```typescript
public readonly routerId: string;
```

- *Type:* `string`

---

##### `routerRegion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.property.routerRegion"></a>

```typescript
public readonly routerRegion: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2RouterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsZoneV2Router;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Router`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Router)

---


### DnsZoneV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { DnsZoneV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new DnsZoneV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.DnsZoneV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsZoneV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts`](#@cdktf/provider-opentelekomcloud.DnsZoneV2Timeouts)

---


### EcsInstanceV1DataDisksList <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.Initializer"></a>

```typescript
import { EcsInstanceV1DataDisksList } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1DataDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EcsInstanceV1DataDisks[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks)[]

---


### EcsInstanceV1DataDisksOutputReference <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.Initializer"></a>

```typescript
import { EcsInstanceV1DataDisksOutputReference } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1DataDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetKmsId` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.resetKmsId"></a>

```typescript
public resetKmsId()
```

##### `resetSnapshotId` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.resetSnapshotId"></a>

```typescript
public resetSnapshotId()
```


#### Properties <a name="Properties"></a>

##### `kmsIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.kmsIdInput"></a>

```typescript
public readonly kmsIdInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `kmsId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.kmsId"></a>

```typescript
public readonly kmsId: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `snapshotId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EcsInstanceV1DataDisks;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1DataDisks)

---


### EcsInstanceV1NicsList <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.Initializer"></a>

```typescript
import { EcsInstanceV1NicsList } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1NicsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EcsInstanceV1Nics[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics)[]

---


### EcsInstanceV1NicsOutputReference <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.Initializer"></a>

```typescript
import { EcsInstanceV1NicsOutputReference } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1NicsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetIpAddress` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.resetIpAddress"></a>

```typescript
public resetIpAddress()
```


#### Properties <a name="Properties"></a>

##### `macAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `networkIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `networkId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1NicsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EcsInstanceV1Nics;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Nics)

---


### EcsInstanceV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { EcsInstanceV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new EcsInstanceV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EcsInstanceV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EcsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.EcsInstanceV1Timeouts)

---


### EvsVolumeV3AttachmentList <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.Initializer"></a>

```typescript
import { EvsVolumeV3AttachmentList } from '@cdktf/provider-opentelekomcloud'

new EvsVolumeV3AttachmentList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### EvsVolumeV3AttachmentOutputReference <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.Initializer"></a>

```typescript
import { EvsVolumeV3AttachmentOutputReference } from '@cdktf/provider-opentelekomcloud'

new EvsVolumeV3AttachmentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `device`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3AttachmentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: EvsVolumeV3Attachment;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Attachment`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Attachment)

---


### EvsVolumeV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { EvsVolumeV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new EvsVolumeV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.EvsVolumeV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | EvsVolumeV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts`](#@cdktf/provider-opentelekomcloud.EvsVolumeV3Timeouts)

---


### FwFirewallGroupV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { FwFirewallGroupV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new FwFirewallGroupV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwFirewallGroupV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FwFirewallGroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwFirewallGroupV2Timeouts)

---


### FwPolicyV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { FwPolicyV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new FwPolicyV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.FwPolicyV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FwPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.FwPolicyV2Timeouts)

---


### IdentityAgencyV3ProjectRoleList <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.Initializer"></a>

```typescript
import { IdentityAgencyV3ProjectRoleList } from '@cdktf/provider-opentelekomcloud'

new IdentityAgencyV3ProjectRoleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IdentityAgencyV3ProjectRole[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole)[]

---


### IdentityAgencyV3ProjectRoleOutputReference <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.Initializer"></a>

```typescript
import { IdentityAgencyV3ProjectRoleOutputReference } from '@cdktf/provider-opentelekomcloud'

new IdentityAgencyV3ProjectRoleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `projectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.property.projectInput"></a>

```typescript
public readonly projectInput: string;
```

- *Type:* `string`

---

##### `rolesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.property.rolesInput"></a>

```typescript
public readonly rolesInput: string[];
```

- *Type:* `string`[]

---

##### `project`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.property.project"></a>

```typescript
public readonly project: string;
```

- *Type:* `string`

---

##### `roles`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* `string`[]

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRoleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IdentityAgencyV3ProjectRole;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3ProjectRole)

---


### IdentityAgencyV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { IdentityAgencyV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new IdentityAgencyV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityAgencyV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IdentityAgencyV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts`](#@cdktf/provider-opentelekomcloud.IdentityAgencyV3Timeouts)

---


### IdentityProtocolV3MetadataOutputReference <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.Initializer"></a>

```typescript
import { IdentityProtocolV3MetadataOutputReference } from '@cdktf/provider-opentelekomcloud'

new IdentityProtocolV3MetadataOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetXaccountType` <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.resetXaccountType"></a>

```typescript
public resetXaccountType()
```


#### Properties <a name="Properties"></a>

##### `domainIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.domainIdInput"></a>

```typescript
public readonly domainIdInput: string;
```

- *Type:* `string`

---

##### `metadataInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.metadataInput"></a>

```typescript
public readonly metadataInput: string;
```

- *Type:* `string`

---

##### `xaccountTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.xaccountTypeInput"></a>

```typescript
public readonly xaccountTypeInput: string;
```

- *Type:* `string`

---

##### `domainId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.domainId"></a>

```typescript
public readonly domainId: string;
```

- *Type:* `string`

---

##### `metadata`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.metadata"></a>

```typescript
public readonly metadata: string;
```

- *Type:* `string`

---

##### `xaccountType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.xaccountType"></a>

```typescript
public readonly xaccountType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityProtocolV3MetadataOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IdentityProtocolV3Metadata;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata`](#@cdktf/provider-opentelekomcloud.IdentityProtocolV3Metadata)

---


### IdentityRoleV3StatementList <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.Initializer"></a>

```typescript
import { IdentityRoleV3StatementList } from '@cdktf/provider-opentelekomcloud'

new IdentityRoleV3StatementList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IdentityRoleV3Statement[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement)[]

---


### IdentityRoleV3StatementOutputReference <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.Initializer"></a>

```typescript
import { IdentityRoleV3StatementOutputReference } from '@cdktf/provider-opentelekomcloud'

new IdentityRoleV3StatementOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.property.actionInput"></a>

```typescript
public readonly actionInput: string[];
```

- *Type:* `string`[]

---

##### `effectInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.property.effectInput"></a>

```typescript
public readonly effectInput: string;
```

- *Type:* `string`

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.property.action"></a>

```typescript
public readonly action: string[];
```

- *Type:* `string`[]

---

##### `effect`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.IdentityRoleV3StatementOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IdentityRoleV3Statement;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement`](#@cdktf/provider-opentelekomcloud.IdentityRoleV3Statement)

---


### ImagesImageV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ImagesImageV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ImagesImageV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImagesImageV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ImagesImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImagesImageV2Timeouts)

---


### ImsDataImageV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ImsDataImageV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ImsDataImageV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsDataImageV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ImsDataImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsDataImageV2Timeouts)

---


### ImsImageV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { ImsImageV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ImsImageV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ImsImageV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ImsImageV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts`](#@cdktf/provider-opentelekomcloud.ImsImageV2Timeouts)

---


### LbCertificateV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbCertificateV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbCertificateV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbCertificateV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbCertificateV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbCertificateV2Timeouts)

---


### LbL7PolicyV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbL7PolicyV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbL7PolicyV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7PolicyV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbL7PolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7PolicyV2Timeouts)

---


### LbL7RuleV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbL7RuleV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbL7RuleV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbL7RuleV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbL7RuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbL7RuleV2Timeouts)

---


### LbListenerV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbListenerV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbListenerV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbListenerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbListenerV2Timeouts)

---


### LbListenerV3InsertHeadersOutputReference <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.Initializer"></a>

```typescript
import { LbListenerV3InsertHeadersOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbListenerV3InsertHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetForwardedForPort` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.resetForwardedForPort"></a>

```typescript
public resetForwardedForPort()
```

##### `resetForwardedHost` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.resetForwardedHost"></a>

```typescript
public resetForwardedHost()
```

##### `resetForwardedPort` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.resetForwardedPort"></a>

```typescript
public resetForwardedPort()
```

##### `resetForwardElbIp` <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.resetForwardElbIp"></a>

```typescript
public resetForwardElbIp()
```


#### Properties <a name="Properties"></a>

##### `forwardedForPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedForPortInput"></a>

```typescript
public readonly forwardedForPortInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedHostInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedHostInput"></a>

```typescript
public readonly forwardedHostInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedPortInput"></a>

```typescript
public readonly forwardedPortInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardElbIpInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardElbIpInput"></a>

```typescript
public readonly forwardElbIpInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedForPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedForPort"></a>

```typescript
public readonly forwardedForPort: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedHost`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedHost"></a>

```typescript
public readonly forwardedHost: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardedPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardedPort"></a>

```typescript
public readonly forwardedPort: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `forwardElbIp`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.forwardElbIp"></a>

```typescript
public readonly forwardElbIp: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbListenerV3InsertHeaders;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders`](#@cdktf/provider-opentelekomcloud.LbListenerV3InsertHeaders)

---


### LbLoadbalancerV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbLoadbalancerV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbLoadbalancerV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbLoadbalancerV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV2Timeouts)

---


### LbLoadbalancerV3PublicIpOutputReference <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.Initializer"></a>

```typescript
import { LbLoadbalancerV3PublicIpOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbLoadbalancerV3PublicIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetBandwidthChargeMode` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetBandwidthChargeMode"></a>

```typescript
public resetBandwidthChargeMode()
```

##### `resetBandwidthName` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetBandwidthName"></a>

```typescript
public resetBandwidthName()
```

##### `resetBandwidthShareType` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetBandwidthShareType"></a>

```typescript
public resetBandwidthShareType()
```

##### `resetBandwidthSize` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetBandwidthSize"></a>

```typescript
public resetBandwidthSize()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetId"></a>

```typescript
public resetId()
```

##### `resetIpType` <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.resetIpType"></a>

```typescript
public resetIpType()
```


#### Properties <a name="Properties"></a>

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `managed`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.managed"></a>

```typescript
public readonly managed: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `bandwidthChargeModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthChargeModeInput"></a>

```typescript
public readonly bandwidthChargeModeInput: string;
```

- *Type:* `string`

---

##### `bandwidthNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthNameInput"></a>

```typescript
public readonly bandwidthNameInput: string;
```

- *Type:* `string`

---

##### `bandwidthShareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthShareTypeInput"></a>

```typescript
public readonly bandwidthShareTypeInput: string;
```

- *Type:* `string`

---

##### `bandwidthSizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthSizeInput"></a>

```typescript
public readonly bandwidthSizeInput: number;
```

- *Type:* `number`

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `ipTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.ipTypeInput"></a>

```typescript
public readonly ipTypeInput: string;
```

- *Type:* `string`

---

##### `bandwidthChargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthChargeMode"></a>

```typescript
public readonly bandwidthChargeMode: string;
```

- *Type:* `string`

---

##### `bandwidthName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthName"></a>

```typescript
public readonly bandwidthName: string;
```

- *Type:* `string`

---

##### `bandwidthShareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthShareType"></a>

```typescript
public readonly bandwidthShareType: string;
```

- *Type:* `string`

---

##### `bandwidthSize`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.bandwidthSize"></a>

```typescript
public readonly bandwidthSize: number;
```

- *Type:* `number`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `ipType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.ipType"></a>

```typescript
public readonly ipType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbLoadbalancerV3PublicIp;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp`](#@cdktf/provider-opentelekomcloud.LbLoadbalancerV3PublicIp)

---


### LbMemberV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbMemberV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbMemberV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMemberV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbMemberV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMemberV2Timeouts)

---


### LbMonitorV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbMonitorV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbMonitorV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbMonitorV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbMonitorV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbMonitorV2Timeouts)

---


### LbPolicyV3RulesList <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.Initializer"></a>

```typescript
import { LbPolicyV3RulesList } from '@cdktf/provider-opentelekomcloud'

new LbPolicyV3RulesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbPolicyV3Rules[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPolicyV3Rules`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Rules)[]

---


### LbPolicyV3RulesOutputReference <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.Initializer"></a>

```typescript
import { LbPolicyV3RulesOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbPolicyV3RulesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `compareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.compareTypeInput"></a>

```typescript
public readonly compareTypeInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `compareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.compareType"></a>

```typescript
public readonly compareType: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPolicyV3RulesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbPolicyV3Rules;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPolicyV3Rules`](#@cdktf/provider-opentelekomcloud.LbPolicyV3Rules)

---


### LbPoolV2PersistenceList <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.Initializer"></a>

```typescript
import { LbPoolV2PersistenceList } from '@cdktf/provider-opentelekomcloud'

new LbPoolV2PersistenceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbPoolV2Persistence[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Persistence`](#@cdktf/provider-opentelekomcloud.LbPoolV2Persistence)[]

---


### LbPoolV2PersistenceOutputReference <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.Initializer"></a>

```typescript
import { LbPoolV2PersistenceOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbPoolV2PersistenceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetCookieName` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.resetCookieName"></a>

```typescript
public resetCookieName()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.resetType"></a>

```typescript
public resetType()
```


#### Properties <a name="Properties"></a>

##### `cookieNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.property.cookieNameInput"></a>

```typescript
public readonly cookieNameInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `cookieName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.property.cookieName"></a>

```typescript
public readonly cookieName: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2PersistenceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbPoolV2Persistence;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Persistence`](#@cdktf/provider-opentelekomcloud.LbPoolV2Persistence)

---


### LbPoolV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbPoolV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbPoolV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbPoolV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbPoolV2Timeouts)

---


### LbPoolV3SessionPersistenceOutputReference <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.Initializer"></a>

```typescript
import { LbPoolV3SessionPersistenceOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbPoolV3SessionPersistenceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCookieName` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.resetCookieName"></a>

```typescript
public resetCookieName()
```

##### `resetPersistenceTimeout` <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.resetPersistenceTimeout"></a>

```typescript
public resetPersistenceTimeout()
```


#### Properties <a name="Properties"></a>

##### `cookieNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.cookieNameInput"></a>

```typescript
public readonly cookieNameInput: string;
```

- *Type:* `string`

---

##### `persistenceTimeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.persistenceTimeoutInput"></a>

```typescript
public readonly persistenceTimeoutInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `cookieName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.cookieName"></a>

```typescript
public readonly cookieName: string;
```

- *Type:* `string`

---

##### `persistenceTimeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.persistenceTimeout"></a>

```typescript
public readonly persistenceTimeout: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistenceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbPoolV3SessionPersistence;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence`](#@cdktf/provider-opentelekomcloud.LbPoolV3SessionPersistence)

---


### LbWhitelistV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { LbWhitelistV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new LbWhitelistV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.LbWhitelistV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbWhitelistV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts`](#@cdktf/provider-opentelekomcloud.LbWhitelistV2Timeouts)

---


### MrsClusterV1AddJobsList <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.Initializer"></a>

```typescript
import { MrsClusterV1AddJobsList } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1AddJobsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1AddJobs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs)[]

---


### MrsClusterV1AddJobsOutputReference <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.Initializer"></a>

```typescript
import { MrsClusterV1AddJobsOutputReference } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1AddJobsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetArguments` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetArguments"></a>

```typescript
public resetArguments()
```

##### `resetFileAction` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetFileAction"></a>

```typescript
public resetFileAction()
```

##### `resetHiveScriptPath` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetHiveScriptPath"></a>

```typescript
public resetHiveScriptPath()
```

##### `resetHql` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetHql"></a>

```typescript
public resetHql()
```

##### `resetInput` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetInput"></a>

```typescript
public resetInput()
```

##### `resetJobLog` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetJobLog"></a>

```typescript
public resetJobLog()
```

##### `resetOutput` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetOutput"></a>

```typescript
public resetOutput()
```

##### `resetShutdownCluster` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.resetShutdownCluster"></a>

```typescript
public resetShutdownCluster()
```


#### Properties <a name="Properties"></a>

##### `argumentsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.argumentsInput"></a>

```typescript
public readonly argumentsInput: string;
```

- *Type:* `string`

---

##### `fileActionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.fileActionInput"></a>

```typescript
public readonly fileActionInput: string;
```

- *Type:* `string`

---

##### `hiveScriptPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.hiveScriptPathInput"></a>

```typescript
public readonly hiveScriptPathInput: string;
```

- *Type:* `string`

---

##### `hqlInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.hqlInput"></a>

```typescript
public readonly hqlInput: string;
```

- *Type:* `string`

---

##### `inputInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.inputInput"></a>

```typescript
public readonly inputInput: string;
```

- *Type:* `string`

---

##### `jarPathInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jarPathInput"></a>

```typescript
public readonly jarPathInput: string;
```

- *Type:* `string`

---

##### `jobLogInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobLogInput"></a>

```typescript
public readonly jobLogInput: string;
```

- *Type:* `string`

---

##### `jobNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobNameInput"></a>

```typescript
public readonly jobNameInput: string;
```

- *Type:* `string`

---

##### `jobTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobTypeInput"></a>

```typescript
public readonly jobTypeInput: number;
```

- *Type:* `number`

---

##### `outputInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.outputInput"></a>

```typescript
public readonly outputInput: string;
```

- *Type:* `string`

---

##### `shutdownClusterInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.shutdownClusterInput"></a>

```typescript
public readonly shutdownClusterInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `submitJobOnceClusterRunInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.submitJobOnceClusterRunInput"></a>

```typescript
public readonly submitJobOnceClusterRunInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `arguments`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.arguments"></a>

```typescript
public readonly arguments: string;
```

- *Type:* `string`

---

##### `fileAction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.fileAction"></a>

```typescript
public readonly fileAction: string;
```

- *Type:* `string`

---

##### `hiveScriptPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.hiveScriptPath"></a>

```typescript
public readonly hiveScriptPath: string;
```

- *Type:* `string`

---

##### `hql`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.hql"></a>

```typescript
public readonly hql: string;
```

- *Type:* `string`

---

##### `input`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.input"></a>

```typescript
public readonly input: string;
```

- *Type:* `string`

---

##### `jarPath`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jarPath"></a>

```typescript
public readonly jarPath: string;
```

- *Type:* `string`

---

##### `jobLog`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobLog"></a>

```typescript
public readonly jobLog: string;
```

- *Type:* `string`

---

##### `jobName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* `string`

---

##### `jobType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.jobType"></a>

```typescript
public readonly jobType: number;
```

- *Type:* `number`

---

##### `output`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.output"></a>

```typescript
public readonly output: string;
```

- *Type:* `string`

---

##### `shutdownCluster`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.shutdownCluster"></a>

```typescript
public readonly shutdownCluster: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `submitJobOnceClusterRun`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.submitJobOnceClusterRun"></a>

```typescript
public readonly submitJobOnceClusterRun: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1AddJobs;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs`](#@cdktf/provider-opentelekomcloud.MrsClusterV1AddJobs)

---


### MrsClusterV1BootstrapScriptsList <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.Initializer"></a>

```typescript
import { MrsClusterV1BootstrapScriptsList } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1BootstrapScriptsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1BootstrapScripts[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts)[]

---


### MrsClusterV1BootstrapScriptsOutputReference <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.Initializer"></a>

```typescript
import { MrsClusterV1BootstrapScriptsOutputReference } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1BootstrapScriptsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetActiveMaster` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.resetActiveMaster"></a>

```typescript
public resetActiveMaster()
```

##### `resetBeforeComponentStart` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.resetBeforeComponentStart"></a>

```typescript
public resetBeforeComponentStart()
```

##### `resetParameters` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.resetParameters"></a>

```typescript
public resetParameters()
```


#### Properties <a name="Properties"></a>

##### `activeMasterInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.activeMasterInput"></a>

```typescript
public readonly activeMasterInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `beforeComponentStartInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.beforeComponentStartInput"></a>

```typescript
public readonly beforeComponentStartInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `failActionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.failActionInput"></a>

```typescript
public readonly failActionInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `nodesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.nodesInput"></a>

```typescript
public readonly nodesInput: string[];
```

- *Type:* `string`[]

---

##### `parametersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.parametersInput"></a>

```typescript
public readonly parametersInput: string;
```

- *Type:* `string`

---

##### `uriInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.uriInput"></a>

```typescript
public readonly uriInput: string;
```

- *Type:* `string`

---

##### `activeMaster`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.activeMaster"></a>

```typescript
public readonly activeMaster: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `beforeComponentStart`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.beforeComponentStart"></a>

```typescript
public readonly beforeComponentStart: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `failAction`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.failAction"></a>

```typescript
public readonly failAction: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `nodes`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* `string`[]

---

##### `parameters`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.parameters"></a>

```typescript
public readonly parameters: string;
```

- *Type:* `string`

---

##### `uri`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScriptsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1BootstrapScripts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1BootstrapScripts)

---


### MrsClusterV1ComponentListList <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.Initializer"></a>

```typescript
import { MrsClusterV1ComponentListList } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1ComponentListList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1ComponentList[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList)[]

---


### MrsClusterV1ComponentListOutputReference <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.Initializer"></a>

```typescript
import { MrsClusterV1ComponentListOutputReference } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1ComponentListOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `componentDesc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.componentDesc"></a>

```typescript
public readonly componentDesc: string;
```

- *Type:* `string`

---

##### `componentId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.componentId"></a>

```typescript
public readonly componentId: string;
```

- *Type:* `string`

---

##### `componentVersion`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.componentVersion"></a>

```typescript
public readonly componentVersion: string;
```

- *Type:* `string`

---

##### `componentNameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.componentNameInput"></a>

```typescript
public readonly componentNameInput: string;
```

- *Type:* `string`

---

##### `componentName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.componentName"></a>

```typescript
public readonly componentName: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentListOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1ComponentList;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList`](#@cdktf/provider-opentelekomcloud.MrsClusterV1ComponentList)

---


### MrsClusterV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { MrsClusterV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new MrsClusterV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsClusterV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsClusterV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsClusterV1Timeouts)

---


### MrsJobV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { MrsJobV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new MrsJobV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.MrsJobV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MrsJobV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts`](#@cdktf/provider-opentelekomcloud.MrsJobV1Timeouts)

---


### NatDnatRuleV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NatDnatRuleV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NatDnatRuleV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatDnatRuleV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NatDnatRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatDnatRuleV2Timeouts)

---


### NatGatewayV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NatGatewayV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NatGatewayV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatGatewayV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NatGatewayV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatGatewayV2Timeouts)

---


### NatSnatRuleV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NatSnatRuleV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NatSnatRuleV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NatSnatRuleV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NatSnatRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NatSnatRuleV2Timeouts)

---


### NetworkingFloatingipV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingFloatingipV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingFloatingipV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingFloatingipV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingFloatingipV2Timeouts)

---


### NetworkingNetworkV2SegmentsList <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.Initializer"></a>

```typescript
import { NetworkingNetworkV2SegmentsList } from '@cdktf/provider-opentelekomcloud'

new NetworkingNetworkV2SegmentsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingNetworkV2Segments[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments)[]

---


### NetworkingNetworkV2SegmentsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.Initializer"></a>

```typescript
import { NetworkingNetworkV2SegmentsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingNetworkV2SegmentsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetNetworkType` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.resetNetworkType"></a>

```typescript
public resetNetworkType()
```

##### `resetPhysicalNetwork` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.resetPhysicalNetwork"></a>

```typescript
public resetPhysicalNetwork()
```

##### `resetSegmentationId` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.resetSegmentationId"></a>

```typescript
public resetSegmentationId()
```


#### Properties <a name="Properties"></a>

##### `networkTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.networkTypeInput"></a>

```typescript
public readonly networkTypeInput: string;
```

- *Type:* `string`

---

##### `physicalNetworkInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.physicalNetworkInput"></a>

```typescript
public readonly physicalNetworkInput: string;
```

- *Type:* `string`

---

##### `segmentationIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.segmentationIdInput"></a>

```typescript
public readonly segmentationIdInput: number;
```

- *Type:* `number`

---

##### `networkType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.networkType"></a>

```typescript
public readonly networkType: string;
```

- *Type:* `string`

---

##### `physicalNetwork`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.physicalNetwork"></a>

```typescript
public readonly physicalNetwork: string;
```

- *Type:* `string`

---

##### `segmentationId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.segmentationId"></a>

```typescript
public readonly segmentationId: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2SegmentsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingNetworkV2Segments;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Segments)

---


### NetworkingNetworkV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingNetworkV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingNetworkV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingNetworkV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingNetworkV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingNetworkV2Timeouts)

---


### NetworkingPortV2AllowedAddressPairsList <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.Initializer"></a>

```typescript
import { NetworkingPortV2AllowedAddressPairsList } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2AllowedAddressPairsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingPortV2AllowedAddressPairs[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs)[]

---


### NetworkingPortV2AllowedAddressPairsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.Initializer"></a>

```typescript
import { NetworkingPortV2AllowedAddressPairsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2AllowedAddressPairsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetMacAddress` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.resetMacAddress"></a>

```typescript
public resetMacAddress()
```


#### Properties <a name="Properties"></a>

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `macAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.property.macAddressInput"></a>

```typescript
public readonly macAddressInput: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `macAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingPortV2AllowedAddressPairs;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2AllowedAddressPairs)

---


### NetworkingPortV2FixedIpList <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.Initializer"></a>

```typescript
import { NetworkingPortV2FixedIpList } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2FixedIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingPortV2FixedIp[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp)[]

---


### NetworkingPortV2FixedIpOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.Initializer"></a>

```typescript
import { NetworkingPortV2FixedIpOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2FixedIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetIpAddress` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.resetIpAddress"></a>

```typescript
public resetIpAddress()
```


#### Properties <a name="Properties"></a>

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `subnetIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `subnetId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingPortV2FixedIp;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2FixedIp)

---


### NetworkingPortV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingPortV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingPortV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingPortV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingPortV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingPortV2Timeouts)

---


### NetworkingRouterInterfaceV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingRouterInterfaceV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingRouterInterfaceV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingRouterInterfaceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterInterfaceV2Timeouts)

---


### NetworkingRouterV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingRouterV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingRouterV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingRouterV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingRouterV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingRouterV2Timeouts)

---


### NetworkingSecgroupRuleV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingSecgroupRuleV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingSecgroupRuleV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSecgroupRuleV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupRuleV2Timeouts)

---


### NetworkingSecgroupV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingSecgroupV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingSecgroupV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSecgroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSecgroupV2Timeouts)

---


### NetworkingSubnetV2AllocationPoolsList <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.Initializer"></a>

```typescript
import { NetworkingSubnetV2AllocationPoolsList } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2AllocationPoolsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSubnetV2AllocationPools[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools)[]

---


### NetworkingSubnetV2AllocationPoolsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.Initializer"></a>

```typescript
import { NetworkingSubnetV2AllocationPoolsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2AllocationPoolsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `endInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.property.endInput"></a>

```typescript
public readonly endInput: string;
```

- *Type:* `string`

---

##### `startInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.property.startInput"></a>

```typescript
public readonly startInput: string;
```

- *Type:* `string`

---

##### `end`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* `string`

---

##### `start`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.property.start"></a>

```typescript
public readonly start: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPoolsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSubnetV2AllocationPools;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2AllocationPools)

---


### NetworkingSubnetV2HostRoutesList <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.Initializer"></a>

```typescript
import { NetworkingSubnetV2HostRoutesList } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2HostRoutesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSubnetV2HostRoutes[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes)[]

---


### NetworkingSubnetV2HostRoutesOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.Initializer"></a>

```typescript
import { NetworkingSubnetV2HostRoutesOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2HostRoutesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `destinationCidrInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.property.destinationCidrInput"></a>

```typescript
public readonly destinationCidrInput: string;
```

- *Type:* `string`

---

##### `nextHopInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.property.nextHopInput"></a>

```typescript
public readonly nextHopInput: string;
```

- *Type:* `string`

---

##### `destinationCidr`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.property.destinationCidr"></a>

```typescript
public readonly destinationCidr: string;
```

- *Type:* `string`

---

##### `nextHop`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.property.nextHop"></a>

```typescript
public readonly nextHop: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSubnetV2HostRoutes;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2HostRoutes)

---


### NetworkingSubnetV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { NetworkingSubnetV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new NetworkingSubnetV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.NetworkingSubnetV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | NetworkingSubnetV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts`](#@cdktf/provider-opentelekomcloud.NetworkingSubnetV2Timeouts)

---


### ObsBucketCorsRuleList <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.Initializer"></a>

```typescript
import { ObsBucketCorsRuleList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketCorsRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRule)[]

---


### ObsBucketCorsRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.Initializer"></a>

```typescript
import { ObsBucketCorsRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketCorsRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAllowedHeaders` <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.resetAllowedHeaders"></a>

```typescript
public resetAllowedHeaders()
```

##### `resetExposeHeaders` <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.resetExposeHeaders"></a>

```typescript
public resetExposeHeaders()
```

##### `resetMaxAgeSeconds` <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.resetMaxAgeSeconds"></a>

```typescript
public resetMaxAgeSeconds()
```


#### Properties <a name="Properties"></a>

##### `allowedHeadersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedHeadersInput"></a>

```typescript
public readonly allowedHeadersInput: string[];
```

- *Type:* `string`[]

---

##### `allowedMethodsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedMethodsInput"></a>

```typescript
public readonly allowedMethodsInput: string[];
```

- *Type:* `string`[]

---

##### `allowedOriginsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedOriginsInput"></a>

```typescript
public readonly allowedOriginsInput: string[];
```

- *Type:* `string`[]

---

##### `exposeHeadersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.exposeHeadersInput"></a>

```typescript
public readonly exposeHeadersInput: string[];
```

- *Type:* `string`[]

---

##### `maxAgeSecondsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.maxAgeSecondsInput"></a>

```typescript
public readonly maxAgeSecondsInput: number;
```

- *Type:* `number`

---

##### `allowedHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* `string`[]

---

##### `allowedMethods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* `string`[]

---

##### `allowedOrigins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* `string`[]

---

##### `exposeHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* `string`[]

---

##### `maxAgeSeconds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketCorsRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketCorsRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketCorsRule`](#@cdktf/provider-opentelekomcloud.ObsBucketCorsRule)

---


### ObsBucketEventNotificationsFilterRuleList <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.Initializer"></a>

```typescript
import { ObsBucketEventNotificationsFilterRuleList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketEventNotificationsFilterRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketEventNotificationsFilterRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule)[]

---


### ObsBucketEventNotificationsFilterRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.Initializer"></a>

```typescript
import { ObsBucketEventNotificationsFilterRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketEventNotificationsFilterRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetName` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.resetName"></a>

```typescript
public resetName()
```

##### `resetValue` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.resetValue"></a>

```typescript
public resetValue()
```


#### Properties <a name="Properties"></a>

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketEventNotificationsFilterRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule)

---


### ObsBucketEventNotificationsList <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.Initializer"></a>

```typescript
import { ObsBucketEventNotificationsList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketEventNotificationsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketEventNotifications[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications)[]

---


### ObsBucketEventNotificationsOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.Initializer"></a>

```typescript
import { ObsBucketEventNotificationsOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketEventNotificationsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `putFilterRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.putFilterRule"></a>

```typescript
public putFilterRule(value: IResolvable | ObsBucketEventNotificationsFilterRule[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule)[]

---

##### `resetFilterRule` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.resetFilterRule"></a>

```typescript
public resetFilterRule()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.resetId"></a>

```typescript
public resetId()
```


#### Properties <a name="Properties"></a>

##### `filterRule`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.filterRule"></a>

```typescript
public readonly filterRule: ObsBucketEventNotificationsFilterRuleList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRuleList)

---

##### `eventsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.eventsInput"></a>

```typescript
public readonly eventsInput: string[];
```

- *Type:* `string`[]

---

##### `filterRuleInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.filterRuleInput"></a>

```typescript
public readonly filterRuleInput: IResolvable | ObsBucketEventNotificationsFilterRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsFilterRule)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `topicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.topicInput"></a>

```typescript
public readonly topicInput: string;
```

- *Type:* `string`

---

##### `events`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.events"></a>

```typescript
public readonly events: string[];
```

- *Type:* `string`[]

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `topic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketEventNotificationsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketEventNotifications;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications`](#@cdktf/provider-opentelekomcloud.ObsBucketEventNotifications)

---


### ObsBucketLifecycleRuleExpirationList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleExpirationList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration)[]

---


### ObsBucketLifecycleRuleExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleExpiration;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration)

---


### ObsBucketLifecycleRuleList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule)[]

---


### ObsBucketLifecycleRuleNoncurrentVersionExpirationList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionExpirationList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleNoncurrentVersionExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration)[]

---


### ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration)

---


### ObsBucketLifecycleRuleNoncurrentVersionTransitionList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionTransitionList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleNoncurrentVersionTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition)[]

---


### ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `storageClassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* `string`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionTransition;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition)

---


### ObsBucketLifecycleRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `putExpiration` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.putExpiration"></a>

```typescript
public putExpiration(value: IResolvable | ObsBucketLifecycleRuleExpiration[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration)[]

---

##### `putNoncurrentVersionExpiration` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.putNoncurrentVersionExpiration"></a>

```typescript
public putNoncurrentVersionExpiration(value: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionExpiration[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration)[]

---

##### `putNoncurrentVersionTransition` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.putNoncurrentVersionTransition"></a>

```typescript
public putNoncurrentVersionTransition(value: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionTransition[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition)[]

---

##### `putTransition` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.putTransition"></a>

```typescript
public putTransition(value: IResolvable | ObsBucketLifecycleRuleTransition[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition)[]

---

##### `resetExpiration` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.resetExpiration"></a>

```typescript
public resetExpiration()
```

##### `resetNoncurrentVersionExpiration` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.resetNoncurrentVersionExpiration"></a>

```typescript
public resetNoncurrentVersionExpiration()
```

##### `resetNoncurrentVersionTransition` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.resetNoncurrentVersionTransition"></a>

```typescript
public resetNoncurrentVersionTransition()
```

##### `resetPrefix` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.resetPrefix"></a>

```typescript
public resetPrefix()
```

##### `resetTransition` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.resetTransition"></a>

```typescript
public resetTransition()
```


#### Properties <a name="Properties"></a>

##### `expiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.expiration"></a>

```typescript
public readonly expiration: ObsBucketLifecycleRuleExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpirationList)

---

##### `noncurrentVersionExpiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: ObsBucketLifecycleRuleNoncurrentVersionExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpirationList)

---

##### `noncurrentVersionTransition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.noncurrentVersionTransition"></a>

```typescript
public readonly noncurrentVersionTransition: ObsBucketLifecycleRuleNoncurrentVersionTransitionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransitionList)

---

##### `transition`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.transition"></a>

```typescript
public readonly transition: ObsBucketLifecycleRuleTransitionList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList)

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `expirationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.expirationInput"></a>

```typescript
public readonly expirationInput: IResolvable | ObsBucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleExpiration)[]

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `noncurrentVersionExpirationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.noncurrentVersionExpirationInput"></a>

```typescript
public readonly noncurrentVersionExpirationInput: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionExpiration)[]

---

##### `noncurrentVersionTransitionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.noncurrentVersionTransitionInput"></a>

```typescript
public readonly noncurrentVersionTransitionInput: IResolvable | ObsBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleNoncurrentVersionTransition)[]

---

##### `prefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* `string`

---

##### `transitionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.transitionInput"></a>

```typescript
public readonly transitionInput: IResolvable | ObsBucketLifecycleRuleTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition)[]

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `prefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRule)

---


### ObsBucketLifecycleRuleTransitionList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleTransitionList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleTransition[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition)[]

---


### ObsBucketLifecycleRuleTransitionOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.Initializer"></a>

```typescript
import { ObsBucketLifecycleRuleTransitionOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLifecycleRuleTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `storageClassInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* `string`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `storageClass`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLifecycleRuleTransition;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition`](#@cdktf/provider-opentelekomcloud.ObsBucketLifecycleRuleTransition)

---


### ObsBucketLoggingList <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.Initializer"></a>

```typescript
import { ObsBucketLoggingList } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLoggingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLogging`](#@cdktf/provider-opentelekomcloud.ObsBucketLogging)[]

---


### ObsBucketLoggingOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.Initializer"></a>

```typescript
import { ObsBucketLoggingOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetTargetPrefix` <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.resetTargetPrefix"></a>

```typescript
public resetTargetPrefix()
```


#### Properties <a name="Properties"></a>

##### `targetBucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.property.targetBucketInput"></a>

```typescript
public readonly targetBucketInput: string;
```

- *Type:* `string`

---

##### `targetPrefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.property.targetPrefixInput"></a>

```typescript
public readonly targetPrefixInput: string;
```

- *Type:* `string`

---

##### `targetBucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* `string`

---

##### `targetPrefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ObsBucketLogging;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.ObsBucketLogging`](#@cdktf/provider-opentelekomcloud.ObsBucketLogging)

---


### ObsBucketServerSideEncryptionOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.Initializer"></a>

```typescript
import { ObsBucketServerSideEncryptionOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketServerSideEncryptionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `algorithmInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.property.algorithmInput"></a>

```typescript
public readonly algorithmInput: string;
```

- *Type:* `string`

---

##### `kmsKeyIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.property.kmsKeyIdInput"></a>

```typescript
public readonly kmsKeyIdInput: string;
```

- *Type:* `string`

---

##### `algorithm`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.property.algorithm"></a>

```typescript
public readonly algorithm: string;
```

- *Type:* `string`

---

##### `kmsKeyId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.property.kmsKeyId"></a>

```typescript
public readonly kmsKeyId: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryptionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ObsBucketServerSideEncryption;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption`](#@cdktf/provider-opentelekomcloud.ObsBucketServerSideEncryption)

---


### ObsBucketWebsiteOutputReference <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.Initializer"></a>

```typescript
import { ObsBucketWebsiteOutputReference } from '@cdktf/provider-opentelekomcloud'

new ObsBucketWebsiteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetErrorDocument` <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.resetErrorDocument"></a>

```typescript
public resetErrorDocument()
```

##### `resetIndexDocument` <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.resetIndexDocument"></a>

```typescript
public resetIndexDocument()
```

##### `resetRedirectAllRequestsTo` <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.resetRedirectAllRequestsTo"></a>

```typescript
public resetRedirectAllRequestsTo()
```

##### `resetRoutingRules` <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.resetRoutingRules"></a>

```typescript
public resetRoutingRules()
```


#### Properties <a name="Properties"></a>

##### `errorDocumentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.errorDocumentInput"></a>

```typescript
public readonly errorDocumentInput: string;
```

- *Type:* `string`

---

##### `indexDocumentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.indexDocumentInput"></a>

```typescript
public readonly indexDocumentInput: string;
```

- *Type:* `string`

---

##### `redirectAllRequestsToInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.redirectAllRequestsToInput"></a>

```typescript
public readonly redirectAllRequestsToInput: string;
```

- *Type:* `string`

---

##### `routingRulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.routingRulesInput"></a>

```typescript
public readonly routingRulesInput: string;
```

- *Type:* `string`

---

##### `errorDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* `string`

---

##### `indexDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* `string`

---

##### `redirectAllRequestsTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* `string`

---

##### `routingRules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.ObsBucketWebsiteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ObsBucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.ObsBucketWebsite`](#@cdktf/provider-opentelekomcloud.ObsBucketWebsite)

---


### RdsInstanceV1BackupstrategyOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1BackupstrategyOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1BackupstrategyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetKeepdays` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.resetKeepdays"></a>

```typescript
public resetKeepdays()
```

##### `resetStarttime` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.resetStarttime"></a>

```typescript
public resetStarttime()
```


#### Properties <a name="Properties"></a>

##### `keepdaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.property.keepdaysInput"></a>

```typescript
public readonly keepdaysInput: number;
```

- *Type:* `number`

---

##### `starttimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.property.starttimeInput"></a>

```typescript
public readonly starttimeInput: string;
```

- *Type:* `string`

---

##### `keepdays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.property.keepdays"></a>

```typescript
public readonly keepdays: number;
```

- *Type:* `number`

---

##### `starttime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.property.starttime"></a>

```typescript
public readonly starttime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1BackupstrategyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Backupstrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Backupstrategy)

---


### RdsInstanceV1DatastoreOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1DatastoreOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1DatastoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1DatastoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Datastore)

---


### RdsInstanceV1HaOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1HaOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1HaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetEnable` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.resetEnable"></a>

```typescript
public resetEnable()
```

##### `resetReplicationmode` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.resetReplicationmode"></a>

```typescript
public resetReplicationmode()
```


#### Properties <a name="Properties"></a>

##### `enableInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.property.enableInput"></a>

```typescript
public readonly enableInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `replicationmodeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.property.replicationmodeInput"></a>

```typescript
public readonly replicationmodeInput: string;
```

- *Type:* `string`

---

##### `enable`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.property.enable"></a>

```typescript
public readonly enable: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `replicationmode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.property.replicationmode"></a>

```typescript
public readonly replicationmode: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1HaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Ha;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Ha)

---


### RdsInstanceV1NicsOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1NicsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1NicsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `subnetidInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.property.subnetidInput"></a>

```typescript
public readonly subnetidInput: string;
```

- *Type:* `string`

---

##### `subnetid`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.property.subnetid"></a>

```typescript
public readonly subnetid: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1NicsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Nics;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Nics)

---


### RdsInstanceV1SecuritygroupOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1SecuritygroupOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1SecuritygroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1SecuritygroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Securitygroup;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Securitygroup)

---


### RdsInstanceV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RdsInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Timeouts)

---


### RdsInstanceV1VolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV1VolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV1VolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV1VolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV1Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV1Volume)

---


### RdsInstanceV3BackupStrategyOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3BackupStrategyOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3BackupStrategyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetKeepDays` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.resetKeepDays"></a>

```typescript
public resetKeepDays()
```


#### Properties <a name="Properties"></a>

##### `keepDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.property.keepDaysInput"></a>

```typescript
public readonly keepDaysInput: number;
```

- *Type:* `number`

---

##### `startTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* `string`

---

##### `keepDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.property.keepDays"></a>

```typescript
public readonly keepDays: number;
```

- *Type:* `number`

---

##### `startTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV3BackupStrategy;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3BackupStrategy)

---


### RdsInstanceV3DbOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3DbOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3DbOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetPort` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.resetPort"></a>

```typescript
public resetPort()
```

##### `resetType` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.resetType"></a>

```typescript
public resetType()
```

##### `resetVersion` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.resetVersion"></a>

```typescript
public resetVersion()
```


#### Properties <a name="Properties"></a>

##### `userName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

##### `passwordInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `password`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3DbOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV3Db;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Db`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Db)

---


### RdsInstanceV3NodesList <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.Initializer"></a>

```typescript
import { RdsInstanceV3NodesList } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3NodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### RdsInstanceV3NodesOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3NodesOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3NodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `availabilityZone`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.availabilityZone"></a>

```typescript
public readonly availabilityZone: string;
```

- *Type:* `string`

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `role`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* `string`

---

##### `status`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3NodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV3Nodes;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Nodes`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Nodes)

---


### RdsInstanceV3RestorePointOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3RestorePointOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3RestorePointOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetBackupId` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.resetBackupId"></a>

```typescript
public resetBackupId()
```

##### `resetRestoreTime` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.resetRestoreTime"></a>

```typescript
public resetRestoreTime()
```


#### Properties <a name="Properties"></a>

##### `backupIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* `string`

---

##### `instanceIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* `string`

---

##### `restoreTimeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.restoreTimeInput"></a>

```typescript
public readonly restoreTimeInput: number;
```

- *Type:* `number`

---

##### `backupId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* `string`

---

##### `instanceId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* `string`

---

##### `restoreTime`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.restoreTime"></a>

```typescript
public readonly restoreTime: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePointOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV3RestorePoint;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3RestorePoint)

---


### RdsInstanceV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RdsInstanceV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Timeouts)

---


### RdsInstanceV3VolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.Initializer"></a>

```typescript
import { RdsInstanceV3VolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsInstanceV3VolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDiskEncryptionId` <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.resetDiskEncryptionId"></a>

```typescript
public resetDiskEncryptionId()
```


#### Properties <a name="Properties"></a>

##### `diskEncryptionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.diskEncryptionIdInput"></a>

```typescript
public readonly diskEncryptionIdInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `diskEncryptionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsInstanceV3VolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsInstanceV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume`](#@cdktf/provider-opentelekomcloud.RdsInstanceV3Volume)

---


### RdsParametergroupV3ConfigurationParametersList <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.Initializer"></a>

```typescript
import { RdsParametergroupV3ConfigurationParametersList } from '@cdktf/provider-opentelekomcloud'

new RdsParametergroupV3ConfigurationParametersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### RdsParametergroupV3ConfigurationParametersOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.Initializer"></a>

```typescript
import { RdsParametergroupV3ConfigurationParametersOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsParametergroupV3ConfigurationParametersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `description`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `readonly`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.readonly"></a>

```typescript
public readonly readonly: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `restartRequired`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.restartRequired"></a>

```typescript
public readonly restartRequired: IResolvable;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `valueRange`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.valueRange"></a>

```typescript
public readonly valueRange: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParametersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsParametergroupV3ConfigurationParameters;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParameters`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3ConfigurationParameters)

---


### RdsParametergroupV3DatastoreOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.Initializer"></a>

```typescript
import { RdsParametergroupV3DatastoreOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsParametergroupV3DatastoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `versionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsParametergroupV3DatastoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsParametergroupV3Datastore;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore`](#@cdktf/provider-opentelekomcloud.RdsParametergroupV3Datastore)

---


### RdsReadReplicaV3DbList <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.Initializer"></a>

```typescript
import { RdsReadReplicaV3DbList } from '@cdktf/provider-opentelekomcloud'

new RdsReadReplicaV3DbList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---




### RdsReadReplicaV3DbOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.Initializer"></a>

```typescript
import { RdsReadReplicaV3DbOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsReadReplicaV3DbOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* `number`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `userName`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* `string`

---

##### `version`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3DbOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsReadReplicaV3Db;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Db`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Db)

---


### RdsReadReplicaV3TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.Initializer"></a>

```typescript
import { RdsReadReplicaV3TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsReadReplicaV3TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RdsReadReplicaV3Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Timeouts)

---


### RdsReadReplicaV3VolumeOutputReference <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.Initializer"></a>

```typescript
import { RdsReadReplicaV3VolumeOutputReference } from '@cdktf/provider-opentelekomcloud'

new RdsReadReplicaV3VolumeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDiskEncryptionId` <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.resetDiskEncryptionId"></a>

```typescript
public resetDiskEncryptionId()
```


#### Properties <a name="Properties"></a>

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `diskEncryptionIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.diskEncryptionIdInput"></a>

```typescript
public readonly diskEncryptionIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `diskEncryptionId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.diskEncryptionId"></a>

```typescript
public readonly diskEncryptionId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RdsReadReplicaV3VolumeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: RdsReadReplicaV3Volume;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume`](#@cdktf/provider-opentelekomcloud.RdsReadReplicaV3Volume)

---


### RtsSoftwareConfigV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { RtsSoftwareConfigV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RtsSoftwareConfigV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RtsSoftwareConfigV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareConfigV1Timeouts)

---


### RtsSoftwareDeploymentV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { RtsSoftwareDeploymentV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RtsSoftwareDeploymentV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RtsSoftwareDeploymentV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsSoftwareDeploymentV1Timeouts)

---


### RtsStackV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { RtsStackV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new RtsStackV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.RtsStackV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | RtsStackV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts`](#@cdktf/provider-opentelekomcloud.RtsStackV1Timeouts)

---


### S3BucketCorsRuleList <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.Initializer"></a>

```typescript
import { S3BucketCorsRuleList } from '@cdktf/provider-opentelekomcloud'

new S3BucketCorsRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketCorsRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketCorsRule`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRule)[]

---


### S3BucketCorsRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.Initializer"></a>

```typescript
import { S3BucketCorsRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketCorsRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAllowedHeaders` <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.resetAllowedHeaders"></a>

```typescript
public resetAllowedHeaders()
```

##### `resetExposeHeaders` <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.resetExposeHeaders"></a>

```typescript
public resetExposeHeaders()
```

##### `resetMaxAgeSeconds` <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.resetMaxAgeSeconds"></a>

```typescript
public resetMaxAgeSeconds()
```


#### Properties <a name="Properties"></a>

##### `allowedHeadersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedHeadersInput"></a>

```typescript
public readonly allowedHeadersInput: string[];
```

- *Type:* `string`[]

---

##### `allowedMethodsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedMethodsInput"></a>

```typescript
public readonly allowedMethodsInput: string[];
```

- *Type:* `string`[]

---

##### `allowedOriginsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedOriginsInput"></a>

```typescript
public readonly allowedOriginsInput: string[];
```

- *Type:* `string`[]

---

##### `exposeHeadersInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.exposeHeadersInput"></a>

```typescript
public readonly exposeHeadersInput: string[];
```

- *Type:* `string`[]

---

##### `maxAgeSecondsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.maxAgeSecondsInput"></a>

```typescript
public readonly maxAgeSecondsInput: number;
```

- *Type:* `number`

---

##### `allowedHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* `string`[]

---

##### `allowedMethods`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* `string`[]

---

##### `allowedOrigins`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* `string`[]

---

##### `exposeHeaders`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* `string`[]

---

##### `maxAgeSeconds`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketCorsRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketCorsRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketCorsRule`](#@cdktf/provider-opentelekomcloud.S3BucketCorsRule)

---


### S3BucketLifecycleRuleExpirationList <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleExpirationList } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration)[]

---


### S3BucketLifecycleRuleExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetDate` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.resetDate"></a>

```typescript
public resetDate()
```

##### `resetDays` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.resetDays"></a>

```typescript
public resetDays()
```

##### `resetExpiredObjectDeleteMarker` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.resetExpiredObjectDeleteMarker"></a>

```typescript
public resetExpiredObjectDeleteMarker()
```


#### Properties <a name="Properties"></a>

##### `dateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.dateInput"></a>

```typescript
public readonly dateInput: string;
```

- *Type:* `string`

---

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `expiredObjectDeleteMarkerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarkerInput"></a>

```typescript
public readonly expiredObjectDeleteMarkerInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `date`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* `string`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `expiredObjectDeleteMarker`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarker"></a>

```typescript
public readonly expiredObjectDeleteMarker: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRuleExpiration;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration)

---


### S3BucketLifecycleRuleList <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleList } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule)[]

---


### S3BucketLifecycleRuleNoncurrentVersionExpirationList <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleNoncurrentVersionExpirationList } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleNoncurrentVersionExpirationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration)[]

---


### S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetDays` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resetDays"></a>

```typescript
public resetDays()
```


#### Properties <a name="Properties"></a>

##### `daysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* `number`

---

##### `days`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration)

---


### S3BucketLifecycleRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.Initializer"></a>

```typescript
import { S3BucketLifecycleRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketLifecycleRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `putExpiration` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.putExpiration"></a>

```typescript
public putExpiration(value: IResolvable | S3BucketLifecycleRuleExpiration[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration)[]

---

##### `putNoncurrentVersionExpiration` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.putNoncurrentVersionExpiration"></a>

```typescript
public putNoncurrentVersionExpiration(value: IResolvable | S3BucketLifecycleRuleNoncurrentVersionExpiration[])
```

###### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.parameter.value"></a>

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration)[]

---

##### `resetAbortIncompleteMultipartUploadDays` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.resetAbortIncompleteMultipartUploadDays"></a>

```typescript
public resetAbortIncompleteMultipartUploadDays()
```

##### `resetExpiration` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.resetExpiration"></a>

```typescript
public resetExpiration()
```

##### `resetId` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.resetId"></a>

```typescript
public resetId()
```

##### `resetNoncurrentVersionExpiration` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.resetNoncurrentVersionExpiration"></a>

```typescript
public resetNoncurrentVersionExpiration()
```

##### `resetPrefix` <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.resetPrefix"></a>

```typescript
public resetPrefix()
```


#### Properties <a name="Properties"></a>

##### `expiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.expiration"></a>

```typescript
public readonly expiration: S3BucketLifecycleRuleExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpirationList)

---

##### `noncurrentVersionExpiration`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: S3BucketLifecycleRuleNoncurrentVersionExpirationList;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpirationList)

---

##### `abortIncompleteMultipartUploadDaysInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDaysInput"></a>

```typescript
public readonly abortIncompleteMultipartUploadDaysInput: number;
```

- *Type:* `number`

---

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `expirationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.expirationInput"></a>

```typescript
public readonly expirationInput: IResolvable | S3BucketLifecycleRuleExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleExpiration)[]

---

##### `idInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* `string`

---

##### `noncurrentVersionExpirationInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.noncurrentVersionExpirationInput"></a>

```typescript
public readonly noncurrentVersionExpirationInput: IResolvable | S3BucketLifecycleRuleNoncurrentVersionExpiration[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleNoncurrentVersionExpiration)[]

---

##### `prefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* `string`

---

##### `abortIncompleteMultipartUploadDays`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDays"></a>

```typescript
public readonly abortIncompleteMultipartUploadDays: number;
```

- *Type:* `number`

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `id`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* `string`

---

##### `prefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLifecycleRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLifecycleRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule`](#@cdktf/provider-opentelekomcloud.S3BucketLifecycleRule)

---


### S3BucketLoggingList <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.Initializer"></a>

```typescript
import { S3BucketLoggingList } from '@cdktf/provider-opentelekomcloud'

new S3BucketLoggingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLogging[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLogging`](#@cdktf/provider-opentelekomcloud.S3BucketLogging)[]

---


### S3BucketLoggingOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.Initializer"></a>

```typescript
import { S3BucketLoggingOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetTargetPrefix` <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.resetTargetPrefix"></a>

```typescript
public resetTargetPrefix()
```


#### Properties <a name="Properties"></a>

##### `targetBucketInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.property.targetBucketInput"></a>

```typescript
public readonly targetBucketInput: string;
```

- *Type:* `string`

---

##### `targetPrefixInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.property.targetPrefixInput"></a>

```typescript
public readonly targetPrefixInput: string;
```

- *Type:* `string`

---

##### `targetBucket`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* `string`

---

##### `targetPrefix`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | S3BucketLogging;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.S3BucketLogging`](#@cdktf/provider-opentelekomcloud.S3BucketLogging)

---


### S3BucketVersioningOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.Initializer"></a>

```typescript
import { S3BucketVersioningOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketVersioningOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetEnabled` <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.resetEnabled"></a>

```typescript
public resetEnabled()
```

##### `resetMfaDelete` <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.resetMfaDelete"></a>

```typescript
public resetMfaDelete()
```


#### Properties <a name="Properties"></a>

##### `enabledInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `mfaDeleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.property.mfaDeleteInput"></a>

```typescript
public readonly mfaDeleteInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `enabled`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `mfaDelete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.property.mfaDelete"></a>

```typescript
public readonly mfaDelete: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketVersioningOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: S3BucketVersioning;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketVersioning`](#@cdktf/provider-opentelekomcloud.S3BucketVersioning)

---


### S3BucketWebsiteOutputReference <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.Initializer"></a>

```typescript
import { S3BucketWebsiteOutputReference } from '@cdktf/provider-opentelekomcloud'

new S3BucketWebsiteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetErrorDocument` <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.resetErrorDocument"></a>

```typescript
public resetErrorDocument()
```

##### `resetIndexDocument` <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.resetIndexDocument"></a>

```typescript
public resetIndexDocument()
```

##### `resetRedirectAllRequestsTo` <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.resetRedirectAllRequestsTo"></a>

```typescript
public resetRedirectAllRequestsTo()
```

##### `resetRoutingRules` <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.resetRoutingRules"></a>

```typescript
public resetRoutingRules()
```


#### Properties <a name="Properties"></a>

##### `errorDocumentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.errorDocumentInput"></a>

```typescript
public readonly errorDocumentInput: string;
```

- *Type:* `string`

---

##### `indexDocumentInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.indexDocumentInput"></a>

```typescript
public readonly indexDocumentInput: string;
```

- *Type:* `string`

---

##### `redirectAllRequestsToInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.redirectAllRequestsToInput"></a>

```typescript
public readonly redirectAllRequestsToInput: string;
```

- *Type:* `string`

---

##### `routingRulesInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.routingRulesInput"></a>

```typescript
public readonly routingRulesInput: string;
```

- *Type:* `string`

---

##### `errorDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* `string`

---

##### `indexDocument`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* `string`

---

##### `redirectAllRequestsTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* `string`

---

##### `routingRules`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.S3BucketWebsiteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: S3BucketWebsite;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.S3BucketWebsite`](#@cdktf/provider-opentelekomcloud.S3BucketWebsite)

---


### SdrsProtectedInstanceV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { SdrsProtectedInstanceV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SdrsProtectedInstanceV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SdrsProtectedInstanceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectedInstanceV1Timeouts)

---


### SdrsProtectiongroupV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { SdrsProtectiongroupV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SdrsProtectiongroupV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SdrsProtectiongroupV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts`](#@cdktf/provider-opentelekomcloud.SdrsProtectiongroupV1Timeouts)

---


### SfsFileSystemV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { SfsFileSystemV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SfsFileSystemV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsFileSystemV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SfsFileSystemV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts`](#@cdktf/provider-opentelekomcloud.SfsFileSystemV2Timeouts)

---


### SfsShareAccessRulesV2AccessRuleList <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.Initializer"></a>

```typescript
import { SfsShareAccessRulesV2AccessRuleList } from '@cdktf/provider-opentelekomcloud'

new SfsShareAccessRulesV2AccessRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SfsShareAccessRulesV2AccessRule[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule)[]

---


### SfsShareAccessRulesV2AccessRuleOutputReference <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.Initializer"></a>

```typescript
import { SfsShareAccessRulesV2AccessRuleOutputReference } from '@cdktf/provider-opentelekomcloud'

new SfsShareAccessRulesV2AccessRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAccessType` <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.resetAccessType"></a>

```typescript
public resetAccessType()
```


#### Properties <a name="Properties"></a>

##### `accessRuleStatus`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessRuleStatus"></a>

```typescript
public readonly accessRuleStatus: string;
```

- *Type:* `string`

---

##### `shareAccessId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.shareAccessId"></a>

```typescript
public readonly shareAccessId: string;
```

- *Type:* `string`

---

##### `accessLevelInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessLevelInput"></a>

```typescript
public readonly accessLevelInput: string;
```

- *Type:* `string`

---

##### `accessToInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessToInput"></a>

```typescript
public readonly accessToInput: string;
```

- *Type:* `string`

---

##### `accessTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessTypeInput"></a>

```typescript
public readonly accessTypeInput: string;
```

- *Type:* `string`

---

##### `accessLevel`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessLevel"></a>

```typescript
public readonly accessLevel: string;
```

- *Type:* `string`

---

##### `accessTo`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessTo"></a>

```typescript
public readonly accessTo: string;
```

- *Type:* `string`

---

##### `accessType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.accessType"></a>

```typescript
public readonly accessType: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SfsShareAccessRulesV2AccessRule;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule`](#@cdktf/provider-opentelekomcloud.SfsShareAccessRulesV2AccessRule)

---


### SfsTurboShareV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { SfsTurboShareV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SfsTurboShareV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SfsTurboShareV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SfsTurboShareV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts`](#@cdktf/provider-opentelekomcloud.SfsTurboShareV1Timeouts)

---


### SwrDomainV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { SwrDomainV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SwrDomainV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```


#### Properties <a name="Properties"></a>

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrDomainV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SwrDomainV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrDomainV2Timeouts)

---


### SwrOrganizationPermissionsV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { SwrOrganizationPermissionsV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SwrOrganizationPermissionsV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```


#### Properties <a name="Properties"></a>

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SwrOrganizationPermissionsV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationPermissionsV2Timeouts)

---


### SwrOrganizationV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { SwrOrganizationV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SwrOrganizationV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrOrganizationV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SwrOrganizationV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrOrganizationV2Timeouts)

---


### SwrRepositoryV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { SwrRepositoryV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new SwrRepositoryV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```


#### Properties <a name="Properties"></a>

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.SwrRepositoryV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | SwrRepositoryV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts`](#@cdktf/provider-opentelekomcloud.SwrRepositoryV2Timeouts)

---


### VbsBackupPolicyV2TagsList <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.Initializer"></a>

```typescript
import { VbsBackupPolicyV2TagsList } from '@cdktf/provider-opentelekomcloud'

new VbsBackupPolicyV2TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupPolicyV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags)[]

---


### VbsBackupPolicyV2TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.Initializer"></a>

```typescript
import { VbsBackupPolicyV2TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VbsBackupPolicyV2TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupPolicyV2Tags;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Tags)

---


### VbsBackupPolicyV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VbsBackupPolicyV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VbsBackupPolicyV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupPolicyV2Timeouts)

---


### VbsBackupShareV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VbsBackupShareV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VbsBackupShareV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupShareV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupShareV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupShareV2Timeouts)

---


### VbsBackupV2TagsList <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.Initializer"></a>

```typescript
import { VbsBackupV2TagsList } from '@cdktf/provider-opentelekomcloud'

new VbsBackupV2TagsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupV2Tags[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Tags)[]

---


### VbsBackupV2TagsOutputReference <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.Initializer"></a>

```typescript
import { VbsBackupV2TagsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VbsBackupV2TagsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---



#### Properties <a name="Properties"></a>

##### `keyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: string;
```

- *Type:* `string`

---

##### `key`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TagsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupV2Tags;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Tags`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Tags)

---


### VbsBackupV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VbsBackupV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VbsBackupV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VbsBackupV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VbsBackupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VbsBackupV2Timeouts)

---


### VpcEipV1BandwidthOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.Initializer"></a>

```typescript
import { VpcEipV1BandwidthOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcEipV1BandwidthOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetChargeMode` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.resetChargeMode"></a>

```typescript
public resetChargeMode()
```


#### Properties <a name="Properties"></a>

##### `chargeModeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.chargeModeInput"></a>

```typescript
public readonly chargeModeInput: string;
```

- *Type:* `string`

---

##### `nameInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* `string`

---

##### `shareTypeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.shareTypeInput"></a>

```typescript
public readonly shareTypeInput: string;
```

- *Type:* `string`

---

##### `sizeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* `number`

---

##### `chargeMode`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.chargeMode"></a>

```typescript
public readonly chargeMode: string;
```

- *Type:* `string`

---

##### `name`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* `string`

---

##### `shareType`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.shareType"></a>

```typescript
public readonly shareType: string;
```

- *Type:* `string`

---

##### `size`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1BandwidthOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VpcEipV1Bandwidth;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth`](#@cdktf/provider-opentelekomcloud.VpcEipV1Bandwidth)

---


### VpcEipV1PublicipOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.Initializer"></a>

```typescript
import { VpcEipV1PublicipOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcEipV1PublicipOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetIpAddress` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.resetIpAddress"></a>

```typescript
public resetIpAddress()
```

##### `resetPortId` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.resetPortId"></a>

```typescript
public resetPortId()
```


#### Properties <a name="Properties"></a>

##### `ipAddressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* `string`

---

##### `portIdInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.portIdInput"></a>

```typescript
public readonly portIdInput: string;
```

- *Type:* `string`

---

##### `typeInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* `string`

---

##### `ipAddress`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* `string`

---

##### `portId`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.portId"></a>

```typescript
public readonly portId: string;
```

- *Type:* `string`

---

##### `type`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1PublicipOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VpcEipV1Publicip;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.VpcEipV1Publicip`](#@cdktf/provider-opentelekomcloud.VpcEipV1Publicip)

---


### VpcEipV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcEipV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcEipV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcEipV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcEipV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcEipV1Timeouts)

---


### VpcepEndpointV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcepEndpointV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcepEndpointV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```


#### Properties <a name="Properties"></a>

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepEndpointV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcepEndpointV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepEndpointV1Timeouts)

---


### VpcepServiceV1PortList <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.Initializer"></a>

```typescript
import { VpcepServiceV1PortList } from '@cdktf/provider-opentelekomcloud'

new VpcepServiceV1PortList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcepServiceV1Port[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Port)[]

---


### VpcepServiceV1PortOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.Initializer"></a>

```typescript
import { VpcepServiceV1PortOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcepServiceV1PortOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetProtocol` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.resetProtocol"></a>

```typescript
public resetProtocol()
```


#### Properties <a name="Properties"></a>

##### `clientPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.clientPortInput"></a>

```typescript
public readonly clientPortInput: number;
```

- *Type:* `number`

---

##### `protocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* `string`

---

##### `serverPortInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.serverPortInput"></a>

```typescript
public readonly serverPortInput: number;
```

- *Type:* `number`

---

##### `clientPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.clientPort"></a>

```typescript
public readonly clientPort: number;
```

- *Type:* `number`

---

##### `protocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* `string`

---

##### `serverPort`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.serverPort"></a>

```typescript
public readonly serverPort: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1PortOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcepServiceV1Port;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Port`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Port)

---


### VpcepServiceV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcepServiceV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcepServiceV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetDefault` <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault()
```


#### Properties <a name="Properties"></a>

##### `defaultInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* `string`

---

##### `default`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcepServiceV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcepServiceV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcepServiceV1Timeouts)

---


### VpcFlowLogV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcFlowLogV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcFlowLogV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcFlowLogV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcFlowLogV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcFlowLogV1Timeouts)

---


### VpcPeeringConnectionAccepterV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcPeeringConnectionAccepterV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcPeeringConnectionAccepterV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcPeeringConnectionAccepterV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionAccepterV2Timeouts)

---


### VpcPeeringConnectionV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcPeeringConnectionV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcPeeringConnectionV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcPeeringConnectionV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcPeeringConnectionV2Timeouts)

---


### VpcRouteV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcRouteV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcRouteV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcRouteV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcRouteV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpcRouteV2Timeouts)

---


### VpcSubnetV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcSubnetV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcSubnetV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcSubnetV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSubnetV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcSubnetV1Timeouts)

---


### VpcV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpcV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpcV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpcV1Timeouts`](#@cdktf/provider-opentelekomcloud.VpcV1Timeouts)

---


### VpnaasEndpointGroupV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpnaasEndpointGroupV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasEndpointGroupV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasEndpointGroupV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasEndpointGroupV2Timeouts)

---


### VpnaasIkePolicyV2LifetimeList <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.Initializer"></a>

```typescript
import { VpnaasIkePolicyV2LifetimeList } from '@cdktf/provider-opentelekomcloud'

new VpnaasIkePolicyV2LifetimeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIkePolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime)[]

---


### VpnaasIkePolicyV2LifetimeOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.Initializer"></a>

```typescript
import { VpnaasIkePolicyV2LifetimeOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasIkePolicyV2LifetimeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetUnits` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.resetUnits"></a>

```typescript
public resetUnits()
```

##### `resetValue` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.resetValue"></a>

```typescript
public resetValue()
```


#### Properties <a name="Properties"></a>

##### `unitsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.property.unitsInput"></a>

```typescript
public readonly unitsInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: number;
```

- *Type:* `number`

---

##### `units`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.property.units"></a>

```typescript
public readonly units: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2LifetimeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIkePolicyV2Lifetime;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Lifetime)

---


### VpnaasIkePolicyV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpnaasIkePolicyV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasIkePolicyV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIkePolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIkePolicyV2Timeouts)

---


### VpnaasIpsecPolicyV2LifetimeList <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2LifetimeList } from '@cdktf/provider-opentelekomcloud'

new VpnaasIpsecPolicyV2LifetimeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIpsecPolicyV2Lifetime[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime)[]

---


### VpnaasIpsecPolicyV2LifetimeOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2LifetimeOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasIpsecPolicyV2LifetimeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetUnits` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.resetUnits"></a>

```typescript
public resetUnits()
```

##### `resetValue` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.resetValue"></a>

```typescript
public resetValue()
```


#### Properties <a name="Properties"></a>

##### `unitsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.property.unitsInput"></a>

```typescript
public readonly unitsInput: string;
```

- *Type:* `string`

---

##### `valueInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.property.valueInput"></a>

```typescript
public readonly valueInput: number;
```

- *Type:* `number`

---

##### `units`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.property.units"></a>

```typescript
public readonly units: string;
```

- *Type:* `string`

---

##### `value`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2LifetimeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIpsecPolicyV2Lifetime;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Lifetime)

---


### VpnaasIpsecPolicyV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpnaasIpsecPolicyV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasIpsecPolicyV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasIpsecPolicyV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasIpsecPolicyV2Timeouts)

---


### VpnaasServiceV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpnaasServiceV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasServiceV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasServiceV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasServiceV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasServiceV2Timeouts)

---


### VpnaasSiteConnectionV2DpdList <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2DpdList } from '@cdktf/provider-opentelekomcloud'

new VpnaasSiteConnectionV2DpdList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasSiteConnectionV2Dpd[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd)[]

---


### VpnaasSiteConnectionV2DpdOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2DpdOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasSiteConnectionV2DpdOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetAction` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.resetAction"></a>

```typescript
public resetAction()
```

##### `resetInterval` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.resetInterval"></a>

```typescript
public resetInterval()
```

##### `resetTimeout` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.resetTimeout"></a>

```typescript
public resetTimeout()
```


#### Properties <a name="Properties"></a>

##### `actionInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.actionInput"></a>

```typescript
public readonly actionInput: string;
```

- *Type:* `string`

---

##### `intervalInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: number;
```

- *Type:* `number`

---

##### `timeoutInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* `number`

---

##### `action`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* `string`

---

##### `interval`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* `number`

---

##### `timeout`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* `number`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2DpdOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasSiteConnectionV2Dpd;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Dpd)

---


### VpnaasSiteConnectionV2TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.Initializer"></a>

```typescript
import { VpnaasSiteConnectionV2TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new VpnaasSiteConnectionV2TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```

##### `resetUpdate` <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `updateInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `update`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpnaasSiteConnectionV2Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts`](#@cdktf/provider-opentelekomcloud.VpnaasSiteConnectionV2Timeouts)

---


### WafCcattackprotectionRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafCcattackprotectionRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafCcattackprotectionRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafCcattackprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCcattackprotectionRuleV1Timeouts)

---


### WafCertificateV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafCertificateV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafCertificateV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafCertificateV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafCertificateV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafCertificateV1Timeouts)

---


### WafDatamaskingRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafDatamaskingRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafDatamaskingRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafDatamaskingRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDatamaskingRuleV1Timeouts)

---


### WafDomainV1ServerList <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.Initializer"></a>

```typescript
import { WafDomainV1ServerList } from '@cdktf/provider-opentelekomcloud'

new WafDomainV1ServerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafDomainV1Server[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Server`](#@cdktf/provider-opentelekomcloud.WafDomainV1Server)[]

---


### WafDomainV1ServerOutputReference <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.Initializer"></a>

```typescript
import { WafDomainV1ServerOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafDomainV1ServerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetBackProtocol` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.resetBackProtocol"></a>

```typescript
public resetBackProtocol()
```

##### `resetClientProtocol` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.resetClientProtocol"></a>

```typescript
public resetClientProtocol()
```

##### `resetFrontProtocol` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.resetFrontProtocol"></a>

```typescript
public resetFrontProtocol()
```

##### `resetServerProtocol` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.resetServerProtocol"></a>

```typescript
public resetServerProtocol()
```


#### Properties <a name="Properties"></a>

##### `addressInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* `string`

---

##### `backProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.backProtocolInput"></a>

```typescript
public readonly backProtocolInput: string;
```

- *Type:* `string`

---

##### `clientProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.clientProtocolInput"></a>

```typescript
public readonly clientProtocolInput: string;
```

- *Type:* `string`

---

##### `frontProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.frontProtocolInput"></a>

```typescript
public readonly frontProtocolInput: string;
```

- *Type:* `string`

---

##### `portInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.portInput"></a>

```typescript
public readonly portInput: string;
```

- *Type:* `string`

---

##### `serverProtocolInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.serverProtocolInput"></a>

```typescript
public readonly serverProtocolInput: string;
```

- *Type:* `string`

---

##### `address`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* `string`

---

##### `backProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.backProtocol"></a>

```typescript
public readonly backProtocol: string;
```

- *Type:* `string`

---

##### `clientProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.clientProtocol"></a>

```typescript
public readonly clientProtocol: string;
```

- *Type:* `string`

---

##### `frontProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.frontProtocol"></a>

```typescript
public readonly frontProtocol: string;
```

- *Type:* `string`

---

##### `port`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.port"></a>

```typescript
public readonly port: string;
```

- *Type:* `string`

---

##### `serverProtocol`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.serverProtocol"></a>

```typescript
public readonly serverProtocol: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1ServerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafDomainV1Server;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Server`](#@cdktf/provider-opentelekomcloud.WafDomainV1Server)

---


### WafDomainV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafDomainV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafDomainV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafDomainV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafDomainV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafDomainV1Timeouts)

---


### WafFalsealarmmaskingRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafFalsealarmmaskingRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafFalsealarmmaskingRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafFalsealarmmaskingRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafFalsealarmmaskingRuleV1Timeouts)

---


### WafPolicyV1ActionOutputReference <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.Initializer"></a>

```typescript
import { WafPolicyV1ActionOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafPolicyV1ActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---



#### Properties <a name="Properties"></a>

##### `categoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.property.categoryInput"></a>

```typescript
public readonly categoryInput: string;
```

- *Type:* `string`

---

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1ActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: WafPolicyV1Action;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Action`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Action)

---


### WafPolicyV1OptionsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.Initializer"></a>

```typescript
import { WafPolicyV1OptionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafPolicyV1OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetAntitamper` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetAntitamper"></a>

```typescript
public resetAntitamper()
```

##### `resetCc` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCc"></a>

```typescript
public resetCc()
```

##### `resetCommon` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCommon"></a>

```typescript
public resetCommon()
```

##### `resetCrawler` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCrawler"></a>

```typescript
public resetCrawler()
```

##### `resetCrawlerEngine` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCrawlerEngine"></a>

```typescript
public resetCrawlerEngine()
```

##### `resetCrawlerOther` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCrawlerOther"></a>

```typescript
public resetCrawlerOther()
```

##### `resetCrawlerScanner` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCrawlerScanner"></a>

```typescript
public resetCrawlerScanner()
```

##### `resetCrawlerScript` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCrawlerScript"></a>

```typescript
public resetCrawlerScript()
```

##### `resetCustom` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetCustom"></a>

```typescript
public resetCustom()
```

##### `resetIgnore` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetIgnore"></a>

```typescript
public resetIgnore()
```

##### `resetPrivacy` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetPrivacy"></a>

```typescript
public resetPrivacy()
```

##### `resetWebattack` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetWebattack"></a>

```typescript
public resetWebattack()
```

##### `resetWebshell` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetWebshell"></a>

```typescript
public resetWebshell()
```

##### `resetWhiteblackip` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.resetWhiteblackip"></a>

```typescript
public resetWhiteblackip()
```


#### Properties <a name="Properties"></a>

##### `antitamperInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.antitamperInput"></a>

```typescript
public readonly antitamperInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `ccInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.ccInput"></a>

```typescript
public readonly ccInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `commonInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.commonInput"></a>

```typescript
public readonly commonInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerEngineInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerEngineInput"></a>

```typescript
public readonly crawlerEngineInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerInput"></a>

```typescript
public readonly crawlerInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerOtherInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerOtherInput"></a>

```typescript
public readonly crawlerOtherInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerScannerInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerScannerInput"></a>

```typescript
public readonly crawlerScannerInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerScriptInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerScriptInput"></a>

```typescript
public readonly crawlerScriptInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `customInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.customInput"></a>

```typescript
public readonly customInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `ignoreInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.ignoreInput"></a>

```typescript
public readonly ignoreInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `privacyInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.privacyInput"></a>

```typescript
public readonly privacyInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `webattackInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.webattackInput"></a>

```typescript
public readonly webattackInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `webshellInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.webshellInput"></a>

```typescript
public readonly webshellInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `whiteblackipInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.whiteblackipInput"></a>

```typescript
public readonly whiteblackipInput: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `antitamper`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.antitamper"></a>

```typescript
public readonly antitamper: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `cc`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.cc"></a>

```typescript
public readonly cc: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `common`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.common"></a>

```typescript
public readonly common: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawler`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawler"></a>

```typescript
public readonly crawler: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerEngine`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerEngine"></a>

```typescript
public readonly crawlerEngine: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerOther`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerOther"></a>

```typescript
public readonly crawlerOther: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerScanner`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerScanner"></a>

```typescript
public readonly crawlerScanner: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `crawlerScript`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.crawlerScript"></a>

```typescript
public readonly crawlerScript: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `custom`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.custom"></a>

```typescript
public readonly custom: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `ignore`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.ignore"></a>

```typescript
public readonly ignore: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `privacy`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.privacy"></a>

```typescript
public readonly privacy: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `webattack`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.webattack"></a>

```typescript
public readonly webattack: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `webshell`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.webshell"></a>

```typescript
public readonly webshell: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `whiteblackip`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.whiteblackip"></a>

```typescript
public readonly whiteblackip: boolean | IResolvable;
```

- *Type:* `boolean` | [`cdktf.IResolvable`](#cdktf.IResolvable)

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: WafPolicyV1Options;
```

- *Type:* [`@cdktf/provider-opentelekomcloud.WafPolicyV1Options`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Options)

---


### WafPolicyV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafPolicyV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafPolicyV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPolicyV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafPolicyV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPolicyV1Timeouts)

---


### WafPreciseprotectionRuleV1ConditionsList <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1ConditionsList } from '@cdktf/provider-opentelekomcloud'

new WafPreciseprotectionRuleV1ConditionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.parameter.wrapsSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `get` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.get"></a>

```typescript
public get(index: number)
```

###### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.parameter.index"></a>

- *Type:* `number`

the index of the item to return.

---


#### Properties <a name="Properties"></a>

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafPreciseprotectionRuleV1Conditions[];
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions)[]

---


### WafPreciseprotectionRuleV1ConditionsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1ConditionsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafPreciseprotectionRuleV1ConditionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.parameter.complexObjectIndex"></a>

- *Type:* `number`

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.parameter.complexObjectIsFromSet"></a>

- *Type:* `boolean`

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods"></a>

##### `resetIndex` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.resetIndex"></a>

```typescript
public resetIndex()
```


#### Properties <a name="Properties"></a>

##### `categoryInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.categoryInput"></a>

```typescript
public readonly categoryInput: string;
```

- *Type:* `string`

---

##### `contentsInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.contentsInput"></a>

```typescript
public readonly contentsInput: string[];
```

- *Type:* `string`[]

---

##### `indexInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.indexInput"></a>

```typescript
public readonly indexInput: string;
```

- *Type:* `string`

---

##### `logicInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.logicInput"></a>

```typescript
public readonly logicInput: string;
```

- *Type:* `string`

---

##### `category`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.category"></a>

```typescript
public readonly category: string;
```

- *Type:* `string`

---

##### `contents`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.contents"></a>

```typescript
public readonly contents: string[];
```

- *Type:* `string`[]

---

##### `index`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* `string`

---

##### `logic`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.logic"></a>

```typescript
public readonly logic: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1ConditionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafPreciseprotectionRuleV1Conditions;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Conditions)

---


### WafPreciseprotectionRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafPreciseprotectionRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafPreciseprotectionRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafPreciseprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafPreciseprotectionRuleV1Timeouts)

---


### WafWebtamperprotectionRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafWebtamperprotectionRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafWebtamperprotectionRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafWebtamperprotectionRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWebtamperprotectionRuleV1Timeouts)

---


### WafWhiteblackipRuleV1TimeoutsOutputReference <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference"></a>

#### Initializers <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.Initializer"></a>

```typescript
import { WafWhiteblackipRuleV1TimeoutsOutputReference } from '@cdktf/provider-opentelekomcloud'

new WafWhiteblackipRuleV1TimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

##### `terraformResource`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.parameter.terraformResource"></a>

- *Type:* [`cdktf.IInterpolatingParent`](#cdktf.IInterpolatingParent)

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.parameter.terraformAttribute"></a>

- *Type:* `string`

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods"></a>

##### `resetCreate` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate()
```

##### `resetDelete` <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete()
```


#### Properties <a name="Properties"></a>

##### `createInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* `string`

---

##### `deleteInput`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* `string`

---

##### `create`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* `string`

---

##### `delete`<sup>Required</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* `string`

---

##### `internalValue`<sup>Optional</sup> <a name="@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1TimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | WafWhiteblackipRuleV1Timeouts;
```

- *Type:* [`cdktf.IResolvable`](#cdktf.IResolvable) | [`@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts`](#@cdktf/provider-opentelekomcloud.WafWhiteblackipRuleV1Timeouts)

---



